#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 100005;
int n, m;
vector<pair<int, char>> v[MAX_N];
bool used[MAX_N];
bool p[MAX_N];
vector<int> kos[MAX_N];
int cntkos[MAX_N];
queue<int> q;

int main()
{
	//freopen(".in", "r", stdin);
	//freopen(",out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	string s;
	cin >> s;
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		v[i].resize(k);
		for (int j = 0; j < k; j++)
		{
			cin >> v[i][j].first >> v[i][j].second;
			v[i][j].first--;
			if (s[v[i][j].first] != v[i][j].second)
			{
				cntkos[i]++;
				kos[v[i][j].first].push_back(i);
			}
		}
		if (cntkos[i] == 0)
		{
			q.push(i);
		}
	}

	vector<int> ans;
	while (!q.empty())
	{
		int cur = q.front();
		q.pop();
		used[cur] = 1;
		ans.push_back(cur + 1);
		for (int j = 0; j < v[cur].size(); j++)
		{
			if (!p[v[cur][j].first])
			{
				p[v[cur][j].first] = 1;
				for (int x : kos[v[cur][j].first])
				{
					cntkos[x]--;
					if (cntkos[x] == 0)
					{
						q.push(x);
					}
				}
			}
		}
	}

	bool badp = 0;
	for (int i = 0; i < m; i++)
	{
		if (!p[i])
		{
			badp = 1;
			break;
		}
	}

	if (ans.size() < n || badp)
	{
		cout << -1;
	}
	else
	{
		for (int i = 0; i < n; i++)
		{
			cout << ans[i] << " ";
		}
	}

	return 0;
}