#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <bitset>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <cassert>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()
//#define int ll

bool check(const set<int>& need, bitset<100'000> & tek) {
	for (const int& i : need)
		if (!tek[i])
			return 0;
	return 1;
}

//bool cmp(const pair<unordered_set<int>, int>& a, const pair<unordered_set<int>, int>& b) {
//	if (a.first.size() == b.first.size())
//		return a.second < b.second;
//	return a.first.size() < b.first.size();
//}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector<unordered_set<int>> del(n);
	vector<pair<unordered_set<int>, int>> need(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		int in;
		char ch;
		for (int j = 0; j < k; ++j) {
			cin >> in >> ch;
			--in;
			if (s[in] == ch) {
				del[i].emplace(in);
			}
			else {
				need[i].first.emplace(in);
			}
		}
		need[i].second = i;
	}
	bitset<100'000> tek;
	vector<bool> u(n);
	vector<int> ans;
	set<int> ord;
	for (int i = 0; i < n; ++i)
		ord.emplace(i);
	for (int i = 0; i < n; ++i) {
		int de = -1;
		for (const int& j : ord) {
			if (need[j].first.empty()) {
				for (const int& i : del[j]) {
					if (!tek[i]) {
						for (const int& j1 : ord) {
							need[j1].first.erase(i);
							if (j != j1)
								del[j1].erase(i);
						}
						tek[i] = 1;
					}
				}
				de = j;
				ans.emplace_back(j + 1);
				u[j] = 1;
				break;
			}
		}
		if (de == -1) {
			cout << -1;
			return 0;
		}
		else
			ord.erase(de);
	}
	for (int i = 0; i < m; ++i)
		if (!tek[i]) {
			cout << -1;
			return 0;
		}
	for (int& i : ans)
		cout << i << " ";
	return 0;
}