#include <bits/stdc++.h>

#define ll long long
#define ld double
#define ft first
#define sd second
#define pb push_back

using namespace std;

ll k, n;
bool a[26][26];
ll dp[5000][5000];
string s;
bool get(ll l, ll r) {
    if (l > r) return 0;
    if (l == r) return 1;
    if (dp[l][r] != -1) return dp[l][r];
    dp[l][r] = 0;
    for (ll i = l + 1; i <= r; ++i) {
        if (a[s[l] - 'a'][s[i] - 'a'] && get(l, i - 1) && get(i, r)) {
            dp[l][r] = 1;
            break;
        }
    }
    return dp[l][r];
}

string tup() {
    for (ll i = 0; i < n; ++i) {
        fill(dp[i], dp[i] + n, -1);
    }
    string ans;
    for (ll msk = 0; msk < (1<<n); ++msk) {
        ll lst = 0;
        bool g = 1;
        string cur;
        cur += s[0];
        for (ll i = 1; i < n; ++i) {
            if (msk&(1<<i)) {
                cur += s[i];
                if (!get(lst, i - 1)) {
                    g = 0;
                    break;
                }
                lst = i;
            }
        }
        if (!get(lst, n - 1))
            g = 0;
        if (g && (ans.empty() || ans > cur)) {
            ans = cur;
        }
    }
    return ans;
}

string umn() {
    string cur[n][n + 1];
    for (ll i = 0; i < n; ++i) {
        fill(dp[i], dp[i] + n, -1);
    }
    cur[0][1] += s[0];
    for (ll i = 1; i < n; ++i) {
        for (ll j = 0; j < i; ++j) {
            if (!get(j, i - 1)) continue;
            for (ll len = 2; len <= i + 1; ++len) {
                if (!cur[j][len - 1].empty() && (cur[i][len].empty() || cur[i][len] > cur[j][len - 1] + s[i])) {
                    cur[i][len] = cur[j][len - 1] + s[i];
                }
            }
        }
    }
    string ans;

    for (ll i = 0; i < n; ++i) {
        for (ll len = 0; len < n; ++len) {
            if (!cur[i][len].empty() && get(i, n - 1) && (ans.empty() || ans > cur[i][len]))
                ans = cur[i][len];
        }
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef FREOPEN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> k >> n;
    for (ll i = 0; i < k; ++i) {
        for (ll j = 0; j < k; ++j) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
        }
    }
    cin >> s;
    cout << umn();
    return 0;
}
