#include <iostream>
#include <vector>

using namespace std;

void paint(int i, int j, int n, vector<vector<bool>>& x) {
    for (int u = i; u < n; ++u) 
    for (int v = j; v < n; ++v) x[u][v] = true;
}

void code() {
    int n, k, m; cin >> n >> k >> m;
    string s; cin >> s;
    s += s;

    vector<int> codes;
    for (int i = 0; i < m; i += 4) {
        int x = 0;
        x += s[i+0] == '1' ? 1 : 0;
        x += s[i+1] == '1' ? 2 : 0;
        x += s[i+2] == '1' ? 4 : 0;
        x += s[i+3] == '1' ? 8 : 0;
        codes.push_back(x);
    }

    int writed = 0, fmv = 1;
    while (writed < codes.size()) {
        int i = n-1, j = n-1;
        int mv = fmv;

        vector v(n, vector<bool>(n));
        while (!v[0][0]) {
            if (mv) {
                if (codes.size() != writed) {
                    while (v[i][j] || (i+j)%16 != codes[writed]) {
                        if (!i && !j) break;
                        j--;
                        if (j < 0) j = n - 1, --i;
                    }
                    if (i == 1) j = 0;
                    if (i == 0 && j > 0) j = 1;
                } else {
                    if (i >= 1) {
                        i = 1;
                        j = 0;
                    } else {
                        i = 0;
                        j = 1;
                        if (v[i][j]) j = 0;
                    }
                }
                cout << i+1 << " " << j+1 << endl;
                if (i > 1) writed++;
                paint(i, j,  n, v);
                if (i == 1) i--;
            } else {
                int i, j; cin >> i >> j;
                paint(i-1, j-1, n, v);
            }
            mv ^= 1;
        }
        fmv ^= 1;
    }
    cerr << "writed " << writed << endl;
    cout << 0 << endl;
}

void decode() {
    int n, k, m, w=0; cin >> n >> k >> m;
    string s(m, '0');
    int g, fmv=1; cin >> g;
    cerr << "decode" << endl;
    for (int i = 0; i < g; ++i) {
        int mv = fmv;
        while (true) {
            int i, j; cin >> i >> j;
            if (i==1 && j==1) break;
            if (mv) {
                i--, j--;
                if (i > 1) {
                    for (int u = 0; u < 4; ++u) {
                        if (w < m) s[w++] = '0' + (i+j >> u)%2;
                    }
                }
            }
            mv ^= 1;
        }
        fmv ^= 1;
    }
    cout << s << endl;
}

int main() {
    //freopen("/tmp/game.in", "r", stdin); 
    //freopen("/tmp/game.out", "w", stdout);
    ios::sync_with_stdio(0); cin.tie(0);
    int t; cin >> t;
    if (t == 1) {
        code();
    } else {
        decode();
    }
}