#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define fs first
#define sc second
#define sz(x) (int)x.size()
#define pb push_back
#define MP make_pair

#ifdef FlameDragon
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#else
mt19937 rng(6236);
#endif

const int INF = 1e9;
signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef FlameDragon
#endif
    int type;
    cin >> type;
    int n, m, k;
    cin >> n >> k >> m;
    vector<vector<int>> used(n, vector<int>(n)), pref(n, vector<int>(n));

    auto mark = [&](int x, int y) {
        for (int i = 0; i <= x; i++) {
            for (int j = 0; j <= y; j++) {
                used[i][j] = true;
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                pref[i][j] = used[i][j];
                if (j) {
                    pref[i][j] += pref[i][j - 1];
                }
            }
        }
        for (int i = 1; i < n; i++) {
            for (int j = 0; j < m; j++) {
                pref[i][j] += pref[i - 1][j];
            }
        }
    };
    auto transpose = [&](int &x, int &y) {
        x = n - x;
        y = n - y;
    };
    auto cntFree = [&](int x, int y) {
        return (x + 1) * (y + 1) - pref[x][y];
    };
    auto freeLeft = [&](int x, int y) {
        int d = 0;
        while (x >= 0 && !used[x][y]) {
            x -= 1;
            d += 1;
        }
        return d;
    };
    auto freeDown = [&](int x, int y) {
        int d = 0;
        while (y >= 0 && !used[x][y]) {
            y -= 1;
            d += 1;
        }
        return d;
    };
    auto print = [&]() {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                cout << used[i][j];
            }
            cout << endl;
        }
        cout << endl;
    };
    auto clear = [&]() {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                used[i][j] = 0;
                pref[i][j] = 0;
            }
        }
    };
    if (type == 1) {
        string s;
        cin >> s;
        for (int i = 0; i < m; i++) {
            if (i % 2 == 0) {
                if (s[i] == '0') {
                    cout << "2 1" << endl;
                } else {
                    cout << "1 2" << endl;
                }
                int x, y;
                cin >> x >> y;
                assert(x != 1 || y != 1);
                if (s[i] == '1') {
                    cout << "2 1" << endl;
                } else {
                    cout << "1 2" << endl;
                }
                cin >> x >> y;
            } else {
                int x, y;
                cin >> x >> y;
                if (s[i] == '0') {
                    cout << "2 1" << endl;
                } else {
                    cout << "1 2" << endl;
                }
                cin >> x >> y;
                assert(x != 1 || y != 1);
                if (s[i] == '1') {
                    cout << "2 1" << endl;
                } else {
                    cout << "1 2" << endl;
                }
                cin >> x >> y;
            }
        }
        cout << "0" << endl;
    } else {
        int len;
        cin >> len;
        string ans;
        for (int it = 0; it < len; it++) {
            if (it % 2) {
                int x, y;
                cin >> x >> y;
                x--; y--;
            }

            while (true) {
                int x, y;
                cin >> x >> y;
                if (x == 1 && y == 1) {
                    break;
                }
                x--; y--;
//                assert(freeDown(x, y) != freeLeft(x, y));
                ans += '0';
                cin >> x >> y;
                if (x == 1 && y == 1) {
                    break;
                }
                x--; y--;
            }
        }
        while (sz(ans) > m){};
        cout << ans << endl;
    }
}
