#include <bits/stdc++.h>
using namespace std;
 
#define size(a) (int)(a.size())
#define chkmax(a, b) a = max(a, b)
#define chkmin(a, b) a = min(a, b)

#pragma O3
#pragma fast-math

const int max_n = 2e5 + 3;
 
int n;
int gr[26][26];
string s;
int f[max_n];
string dp[max_n];
set<int> b;
 
bool chk(int l, int r) {
    vector<int> a;
    for(int i = r;i >= l;i--) {
        while(size(a) && gr[s[i] - 'a'][a.back()]) a.pop_back();
        a.emplace_back(s[i] - 'a');
    }
    return size(a) == 1;
}
 
void build_f() {
    /*f[n] = n;
    for(int i = n - 1;i >= 0;i--) {
        int mx = i + 1;
        for(int j = i + 1;j < i + 2;j++) {
            if (!gr[s[i] - 'a'][s[j] - 'a']) break;
            chkmax(mx, f[j]);
        }
        for(;mx < n;mx++)
            if (!gr[s[i] - 'a'][s[mx] - 'a']) break;
        f[i] = mx;
    }*/
    for(int i = n - 1;i >= 0;i--) {
    	f[i] = i + 1;
    	int j = i;
    	while(j < n - 1) {
    		j = f[j] - 1;
    		if (!gr[s[i] - 'a'][s[j + 1] - 'a']) break;
    		++j;
    	}
    	f[i] = j + 1;
    	//cout << i << ' ' << f[i] << endl;
    }
    /*int r = n - 1;
    for(int i = 0;i < n;i++) {
        for(;r >= i;r--) {
            if (chk(i, r)) {
            	f[i] = r + 1;
            	break;
            }
        }
    }*/
}
 
void solve() {
    int k;
    cin >> k >> n;
    for(int i = 0;i < k;i++) {
        string s;
        cin >> s;
        for(int j = 0;j < k;j++)
            gr[i][j] = s[j] - '0';
    }
    cin >> s;
  
    build_f();
    /*for(int i = 0;i < n;i++)
        cout << f[i] << " ";
    cout << endl;*/
  
    b.emplace(n);
    for(int i = n - 1;i >= 0;i--) {
        int k = *(--b.upper_bound(f[i]));
        dp[i] = s[i] + dp[k];
        while (size(dp[i]) > 20000) dp[i].pop_back();
        while(true) {
            int v = *b.begin();
            if (v == n || s[v] < s[i]) break;
            if (s[v] == s[i] && dp[v] < dp[i]) break;
            b.erase(b.begin());
        }
        b.emplace(i);
    }
     
    cout << dp[0];
   /* string t;
    int id = 0;
    while(id < n)
        t += s[id], id = dp[id];
    cout << t << endl;*/
}
 
 
signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
    #ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
 
    solve();
}