#include <bits/stdc++.h>
#define cpair pair <int, char>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    string s; cin >> s;

    vector <pair <vector <cpair>, int> > lines(n);
    vector <int> stat(n, 1e9);
    vector <int> cnt(m, n);
    for (int i = 0; i < n; i++)
    {
        lines[i].second = i;
        int k; cin >> k;
        for (int j = 0; j < k; j++)
        {
            char ch; int p;
            cin >> p >> ch;
            lines[i].first.push_back({p - 1, ch});
            cnt[p - 1]--;
        }
    }

    vector <int> ans;
    vector <bool> used(m, false);
    vector <bool> temp(n, false);

    for (int i = 0; i < n; i++)
    {
        int cur = -1;
        for (int j = 0; j < n; j++)
        {
            if (temp[j])
                continue;
            bool good = true;
            for (auto p : lines[j].first)
                if (!used[p.first] && p.second != s[p.first])
                {
                    good = false;
                    break;
                }

            if (good)
            {
                cur = j;
                for (auto p : lines[j].first)
                    used[p.first] = true;
                temp[j] = true;
                ans.push_back(lines[j].second + 1);
                break;
            }
        }
    }

    if (count(used.begin(), used.end(), true) == used.size())
    {
        copy(ans.begin(), ans.end(), ostream_iterator <int> (cout, " "));
        cout << "\n";
    } else
        cout << "-1\n";
}
