#include <iostream>
#include <vector>
#include <string>
#include <set>

using namespace std;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0;
	cin >> n >> m;

	string s;
	cin >> s;

	set<pair<int, int>> st;
	vector<vector<int>> mtch(m);
	vector<int> cnt(n);
	vector<vector<pair<int, char>>> ln(n);
	set<int> pos;

	int k = 0, a = 0;
	char c = 'a';
	for (int i = 0; i < n; ++i)
	{
		cin >> k;
		for (int j = 0; j < k; ++j)
		{
			cin >> a >> c;
			pos.insert(a);
			ln[i].emplace_back(a - 1, c);
			if (s[a - 1] != c)
			{
				++cnt[i];
				mtch[a - 1].push_back(i);
			}
		}
	}

	if (pos.size() != m)
	{
		cout << -1 << "\n";
		return 0;
	}

	for (int i = 0; i < n; ++i)
		st.emplace(cnt[i], i);

	vector<int> ans;
	while (!st.empty())
	{
		auto [cc, i] = *st.begin();
		if (cc)
		{
			cout << -1 << "\n";
			return 0;
		}
		st.erase(st.begin());
		ans.push_back(i + 1);

		for (auto [a1, c1] : ln[i])
		{
			for (auto x : mtch[a1])
			{
				st.erase({ cnt[x], x });
				--cnt[x];
				st.emplace(cnt[x], x);
			}
			mtch[a1].clear();
		}
	}

	for (auto x : ans)
		cout << x << " ";
	cout << "\n";

	return 0;
}