#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100, INF = 1e18;

int n, m;
string s;
vector<pair<int, char>> v[N];
bool ok[N], used[N];
vector<int> ans;

void solve() {
    cin >> m >> n >> s;
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        v[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> v[i][j].first >> v[i][j].second;
            v[i][j].first--;
        }
    }
    for (int t = 0; t < m; t++) {
        for (int i = 0; i < m; i++) {
            if (used[i]) continue;
            bool fl = true;
            for (auto x : v[i]) {
                if (s[x.first] != x.second && !ok[x.first]) {
                    fl = false;
                    break;
                }
            }
            if (fl) {
                ans.push_back(i);
                used[i] = true;
                for (auto x : v[i]) {
                    ok[x.first] = true;
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!ok[i]) {
            cout << -1;
            return;
        }
    }
    for (int x : ans) {
        cout << x + 1 << " ";
    }
}
