#include <iostream>
#include <string>
#include <vector>
#include <set>
using namespace std;

const int N = 100100;
const int A = 26;
int cnt[N];
vector<int> v[N];
vector<int> l[N];

bool placed[N];
int ans[N];

int main() {
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		for (int j = 0; j < k; j++) {
			int pos;
			char c;
			cin >> pos >> c;
			pos--;
			if (s[pos] == c) {
				l[i].push_back(pos);
			}
			else {
				cnt[i]++;
				v[pos].push_back(i);
			}
		}
	}
	for (auto& i : placed) i = false;
	set<pair<int, int>> q;
	for (int i = 0; i < n; i++) {
		q.insert(make_pair(cnt[i], i));
	}

	for (int i = 0; i < n; i++) {
		if (q.begin()->first) {
			cout << "-1\n";
			return 0;
		}
		int cur = q.begin()->second;
		ans[i] = cur;
		q.erase(q.begin());
		for (auto j : l[cur]) {
			if (placed[j]) continue;
			placed[j] = true;
			for (auto k : v[j]) {
				q.erase(make_pair(cnt[k], k));
				cnt[k]--;
				q.insert(make_pair(cnt[k], k));
			}
		}
	}

	for (int i = 0; i < m; i++) {
		if (!placed[i]) {
			cout << "-1\n";
			return 0;
		}
	}

	for (int i = 0; i < n; i++) {
		cout << ans[i] + 1 << ' ';
	}
	cout << '\n';
	return 0;
}