#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define int ll
#define f first
#define s second
#define vi vector<int>
#define pii pair<int, int>
#define pb push_back
using namespace std;

const int maxn = 2e5 + 50;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, char>> a[n];
    map<int, char> mp[n];
    string s;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int p;
            char c;
            cin >> p >> c;
            p--;
            mp[i][p] = c;
            a[i].pb({p, c});
        }
    }
    int cnt[n];
    int used[n];
    int used2[m];
    vector<int> org[m];
    memset(cnt, 0, sizeof(cnt));
    memset(used, 0, sizeof(used));
    memset(used2, 0, sizeof(used2));
    queue<int> q;
    for (int i = 0; i < n; ++i) {
        for (auto &[p, c] : a[i]) {
            if (s[p] == c) {
                cnt[i]++;
            }
            org[p].pb(i);
        }
        cnt[i] -= a[i].size();
        if (cnt[i] == 0) {
            used[i] = 1;
            q.push(i);
        }
    }
    //auto g = get();
    vi top;
    while (q.size()) {
        int v = q.front();
        q.pop();
        used[v] = 1;
        top.pb(v);
        for (auto &[p, c] : a[v]) {
            if (!used2[p]) {
                if (s[p] != c) {
                    cout << -1 << '\n';
                    exit(0);
                }
                for (auto &j : org[p]) {
                    if (used[j])
                        continue;
                    cnt[j]++;
                    if (mp[j][p] == c)
                        cnt[j]--;
                    if (cnt[j] == 0) {
                        used[j] = 1;
                        q.push(j);
                    }
                }
                used2[p] = 1;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            top.pb(i);
        }
    }
    assert(top.size() <= n);

    set<int> st;
    for (int i = 0; i < m; ++i)
        st.insert(i);
    for (int i = 0; i < n; ++i) {
        for (auto &[p, c] : a[top[i]]) {
            if (st.count(p)) {
                if (c == s[p]) {
                    st.erase(p);
                } else {
                    cout << -1 << '\n';
                    exit(0);
                }
            }
        }
    }
    if (st.size()) {
         cout << -1 << '\n';
        exit(0);
    }
    for (auto &i : top) {
        if (i < n)
            cout << i + 1 << ' ';
    }
    cout << '\n';
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while (t--)
        solve();
    return 0;
}
