#include <iostream>
#include <set>
#include <bitset>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long
#define hash(i) ((200000 - i) * 309 + (long long)(s[i] - 'a') * 47)

vector<vector<bool>> A(26, vector<bool>(26));

string ans = "";

void rec(string s)
{
	if (s == "") return;

	for (int i = 1; i < s.length(); i++)
	{
		if (A[s[i - 1] - 'a'][s[i] - 'a'])
		{
			rec(s.substr(0, i) + s.substr(i + 1, s.length() - i - 1));
		}
	}

	if (ans == "") ans = s;
	else ans = min(ans, s);
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int k, n;
	cin >> k >> n;

	for (int i = 0; i < k; i++)
	{
		string s;
		cin >> s;
		for (int j = 0; j < k; j++)
		{
			if (s[j] == '1')
				A[i][j] = 1;
			else
				A[i][j] = 0;
		}
	}

	vector<char> s(n);
	for (int i = 0; i < n; i++)
		cin >> s[i];

	if (k == 1)
	{
		set<char> st;
		for (int i = 0; i < n; i++)
			st.insert(s[i]);
		char a = *st.begin();
		if (A[a - 'a'][a - 'a'])
			cout << s[0];
		else
		{
			for (int i = 0; i < n; i++)
				cout << s[i];
		}
	}
	if (k == 2)
	{
		char a, b;
		set<char> st;
		for (int i = 0; i < n; i++)
			st.insert(s[i]);
		a = *st.begin();
		b = *st.rbegin();
		if (A[b - 'a'][b - 'a'])
		{
			int i = 1;
			while (i < s.size())
			{
				if (s[i - 1] == b && s[i] == b)
					s.erase(s.begin() + i);
				else i++;
			}
		}
		if (A[a - 'a'][b - 'a'])
		{
			int i = 1;
			while (i < s.size())
			{
				if (s[i - 1] == a && s[i] == b)
					s.erase(s.begin() + i);
				else i++;
			}
		}

		for (int i = 0; i < s.size(); i++)
			cout << s[i];
	}
	else
	{
		rec(s);
		cout << ans;
	}
}