#include <iostream>
#include <vector>

using namespace std;

struct kek{
    int id;
    char val;
    kek(){
        id = -1;
        val = '0';
    }
    kek(int a, char b){
        id = a;
        val = b;
    }
};

int main() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector <vector<kek>> a(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            char y;
            cin >> x >> y;
            a[i].push_back({x - 1, y});
        }
    }
    vector <int> ans;
    vector <bool> visited(n);
    for (int i = 0; i < n; ++i) {
        if (ans.size() != i) {
            cout << -1;
            return 0;
        }
        for (int j = 0; j < n; ++j) {
            if (visited[j])
                continue;
            bool check = true;
            for (auto ii : a[j]){
                if (!(s[ii.id] == '0' || s[ii.id] == ii.val)){
                    check = false;
                    //cout << i << " " << s[ii.id] << " " << ii.id << " " << ii.val << endl;
                    break;
                }
            }
            if (check) {
                ans.push_back(j + 1);
                for (auto ii : a[j]) {
                    s[ii.id] = '0';
                }
                visited[j] = true;
                break;
            }
        }
    }
    for (auto i : ans) {
        cout << i << " ";
    }
}
