#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define int long long
#define all(a) a.begin(), a.end()
#define vi vector<int>
using namespace std;
const int N = 100, K = 26;

char a[K][K];
int n, k;
string s;
int dp[N][N];

bool cmp(string s, string t) {
	while (s.size() < t.size())
		s.push_back('a' - 1);
	while (t.size() < s.size())
		t.push_back('a' - 1);
	for (int i = 0; i < s.size(); ++i)
		if (s[i] != t[i])
			return s[i] < t[i];
	return false;
}

int f(int l, int r) {
	if (l == r)
		return 1;
	if (dp[l][r] != -1)
		return dp[l][r];
	for (int i = l; i < r; ++i)
		if (a[s[l] - 'a'][s[i + 1] - 'a'] == '1' && f(l, i) && f(i + 1, r))
			return dp[l][r] = 1;
	return dp[l][r] = 0;
}

string dp2[N];

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cin >> k >> n;
	for (int i = 0; i < k; ++i)
		for (int j = 0; j < k; ++j)
			cin >> a[i][j];
	cin >> s;
	memset(dp, -1, sizeof(dp));
	dp2[n - 1].push_back(s[n - 1]);
	dp2[n] = "";
	for (int i = n - 2; i > -1; --i) {
		for (int j = i + 1; j <= n && f(i, j - 1); ++j)
			if (cmp(dp2[j], dp2[i]) || dp2[i] == "")
				dp2[i] = dp2[j];
		dp2[i] = s[i] + dp2[i];
	}
	cout << dp2[0];
}