#include <iostream>

#include <algorithm>

#include <vector>
#include <string>

#include <random>

using namespace std;

int main() {
	int n, m; cin >> n >> m;
	string s; cin >> s;
	vector<pair<int, vector<int>>> a(n, { 0, vector<int>(m, 0) });
	vector<vector<int>> b(n, vector<int>(m, 0));

	for (int i = 0; i < n; i++) {
		a[i].first = i;
		int k; cin >> k;
		for (int j = 0; j < k; j++) {
			int pos; cin >> pos;
			pos--;
			char c; cin >> c;
			b[i][pos] = c;
			if (c != s[pos])
				a[i].second[pos] = 2;
			else
				a[i].second[pos] = 1;
		}
	}

	for (int q = 0; q < 1000; q++) {
		for (int pos = 0; pos < m; pos++) {
			for (int i = 0; i < n - 1; i++) {
				if (a[i].second[pos] == 1)
					break;
				if (a[i].second[pos] == 2) {
					int good = i;
					vector<int> tmp;
					for (int j = n - 1; j >= i + 1; j--) {
						if (a[j].second[pos] == 1) {
							tmp.push_back(j);
						}
					}

					if (tmp.size() > 0) {
						int tmp_i = rand() % tmp.size();
						good = tmp[tmp_i];
					}

					for (int k = good; k > i; k--) {
						swap(a[k], a[k - 1]);
					}
				}
			}
		}

		bool flag = true;
		vector<bool> used(m);
		for (int j = 0; j < n; j++) {
			int pos = a[j].first;
			for (int i = 0; i < m; i++) {
				if (b[pos][i] == 0)
					continue;
				if (b[pos][i] == s[i])
					used[i] = true;
				if (b[pos][i] != s[i] && !used[i]) {
					flag = false;
				}
			}
		}


		for (auto c : used) {
			if (!c) {
				flag = false;
			}
		}

		if (flag) {
			for (auto c : a) {
				cout << c.first + 1 << ' ';
			}
			return 0;
		}
	}

	cout << -1;

	return 0;
}