#include <iostream>

#include <algorithm>

#include <vector>
#include <string>
#include <unordered_map>
#include <queue>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int k, n; cin >> k >> n;
	vector<vector<char>> can(k, vector<char>(k));
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			cin >> can[i][j];
		}
	}
	string s; cin >> s;
	unordered_map<string, bool> used;
	queue<string> q;
	q.push(s);
	used[s] = true;

	while (!q.empty()) {
		string v = q.front();
		q.pop();

		for (int i = 1; i < v.size(); i++) {
			if (can[v[i - 1] - 'a'][v[i] - 'a'] == '1') {
				string new_v = v;
				new_v.erase(new_v.begin() + i);

				if (!used[new_v] && q.size() < 1e4) {
					used[new_v] = true;
					q.push(new_v);
				}
			}
		}
	}

	string ans = s;
	for (auto c : used) {
		if (c.second) {
			ans = min(ans, c.first);
		}
	}

	cout << ans;
	return 0;
}