﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

string f(int i, const string& cur, int n, string& s, vector<int>& dp) {
	if (i == -1) {
		return cur;
	}

	if (dp[i] == -1) {
		return f(i - 1, char(s[i] + 'a') + cur, n, s, dp);
	}
	return min(f(i - 1, char(s[i] + 'a') + cur, n, s, dp), f(dp[i], cur, n, s, dp));
}

int main() {
	int k, n, x;
	cin >> k >> n;
	vector<vector<char>> g(k, vector<char>(k));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> g[i][j];
			g[i][j] -= '0';
		}
	}
	string s;
	cin >> s;
	for (char& i : s) {
		i -= 'a';
	}

	vector<int> dp(n, n);
	dp[0] = -1;
	for (int i = 1; i < n; ++i) {
		x = n;
		for (int j = i - 1; j >= 0 && x > -1; --j) {
			if (g[s[j]][s[i]] && x >= j) {
				dp[i] = j;
				break;
			}
			x = min(x, dp[j]);
		}
		if (dp[i] == n) {
			dp[i] = -1;
		}
	}

	cout << f(n - 1, "", n, s, dp);

	return 0;
}
