#include <bits/stdc++.h>
using namespace std;

const int N = 1e5 + 1;
vector<int> bad[N];
int cnt[N];
vector<pair<int, char>> arr[N];
bool used[N];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    for(int i = 0; i < n; i++) {
        int k;
        cin >> k;
        arr[i].resize(k);
        for(int j = 0; j < k; j++) {
            cin >> arr[i][j].first >> arr[i][j].second;
            arr[i][j].first--;
            if (s[arr[i][j].first] != arr[i][j].second) {
                bad[arr[i][j].first].push_back(i);
                cnt[i]++;
            }
        }
    }
    set<pair<int, int>> q;
    for(int i = 0; i < n; i++) {
        q.insert({cnt[i], i});
    }
    vector<int> ans;
    while (!q.empty()) {
        auto v = *q.begin();
        q.erase(v);
        int x = v.second;
        ans.push_back(x);
        if (cnt[x]) {
            cout << -1;
            exit(0);
        }
        for(auto j : arr[x]) {
            int i = j.first;
            char c = j.second;
            if (used[i]) continue;
            used[i] = 1;
            for(int b : bad[i]) {
                q.erase({cnt[b], b});
                cnt[b]--;
                q.insert({cnt[b], b});
            }
        }
    }
    for(int x : ans) cout << x + 1 << ' ';
}

