#include <bits/stdc++.h>

using namespace std;

signed main() {
	int n, m;
	cin >> n >> m;

	string s;
	cin >> s;

	vector< vector<int> > bad(n);
	vector< vector< pair<int, char> > > strings(n);

	for(int i = 0; i < n; i++) {
		int k;
		cin >> k;

		for(int j = 0; j < k; j++) {
			int a;
			char c;
			cin >> a >> c;
			a--;
			if(c != s[i]) {
				bad[i].push_back(a);
			}
			strings[i].emplace_back(a, c);
		}
	}

	vector<int> order(n);
	iota(order.begin(), order.end(), 0);
	sort(order.begin(), order.end(), [&](int i, int j) {
		return bad[i] < bad[j];
	});

	string t(m, '.');
	for(int i: order) {
		for(auto [a, c]: strings[i]) {
			t[a] = c;
		}
	}

	if(t == s) {
		reverse(order.begin(), order.end());
		for(int i: order) {
			cout << i + 1 << " ";
		}
		cout << endl;
	} else {
		cout << -1 << endl;
	}

	return 0;
}