#include <iostream>
#include <vector>
#include <set>

bool deletable(std::string str, int32_t k, bool** allow) {
    std::vector<int32_t> candidates = {0};
    for(int32_t i = 1; i < str.size(); i++) {
        bool ok = false;
        for(int32_t j = candidates.size() - 1; j >= 0; j--)
            if( allow[str[candidates[j]] - 'a'][str[i] - 'a']) {
                ok = true;
                for(int32_t p = candidates.size() - 1; p > j; p--)
                    candidates.pop_back();
                break;
            }
        if(!ok)
            return false;
        candidates.push_back(i);
    }
    return true;
}

std::string solve(std::string str, int32_t k, bool** allow) {
    if(str.size() == 1)
        return str;

    std::string ans = str;
    for(int32_t i = 0; i < str.size() - 1; i++) {
        if(allow[str[i] - 'a'][str[i + 1] - 'a'])
            ans = std::min(ans, solve(
                    str.substr(0, i + 1) + (i == str.size() - 1 ? "" : str.substr(i + 2)),
                    k, allow));
    }
    return ans;
}

int main() {
    int32_t k, n;
    std::cin >> k >> n;

    //for(int32_t z = 0; z< 1000; z++) {
    //    int a = 0;
    //    if(z == 446)
     //       a++;
        bool **allow = new bool *[k];
        for (int32_t i = 0; i < k; i++) {
            allow[i] = new bool[k];
            std::string str;
            std::cin >> str;

            for (int32_t j = 0; j < k; j++) {
                allow[i][j] = /*rand() % 2 == 0;*/str[j] == '1';
            }
        }

        std::string str;
        std::cin >> str;
        //for (int32_t i = 0; i < n; i++)
        //    str.push_back('a' + rand() % k);

        std::cout << solve(str, k, allow) << "\n";

        /*std::pair<std::string, std::string> *dp = new std::pair<std::string, std::string>[n + 1];
        dp[1].first.push_back(str[0]);
        dp[1].second.push_back(str[0]);
        for (int32_t i = 2; i <= n; i++) {
            //the symbol is not deleted
            dp[i].first = std::string(1, (char) ('z' + 1));
            for (int32_t suf = 1; suf <= i; suf++)
                dp[i].first = std::min(dp[i].first, dp[i - suf].second + str.substr(i - suf, suf));

            //the symbol IS deleted
            dp[i].second = std::string(1, (char) ('z' + 1));
            for (int32_t j = i - 1; j >= 1; j--) {
                if (deletable(str.substr(j - 1, i - j + 1), k, allow))
                    dp[i].second = std::min(dp[i].second, dp[j].first);
            }
        }
        std::cout << std::min(dp[n].first, dp[n].second) << "\n\n";

        if(solve(str, k, allow) != std::min(dp[n].first, dp[n].second))
            a++;*/
    //}
    return 0;
}
