#include <bits/stdc++.h>
using namespace std;
#define ll long long
const int N = 1e5 + 113;
int n;
int type[N];
vector<int> edges[N];
vector<int> projects[N];
vector<int> leafs, nleafs;
vector<int> have[N];
vector<int> ans_order[N];
bool can[N];
int lel = 1000, cnt = 0;
void solve(int v)
{
    can[v] = 1;
    if(edges[v].empty())
        return;
    have[v].clear();
    ans_order[v].clear();
    vector<pair<int, int>> order;
    for(auto i : edges[v])
        solve(i), order.push_back({have[i][0], i});
    sort(order.begin(), order.end());
    for(auto i : order)
    {
        ans_order[v].push_back(i.second);
        for(auto j : have[i.second])
            have[v].push_back(j);
    }
    for(int i = 1; i < have[v].size(); i++)
    {
        if(have[v][i] < have[v][i - 1])
            can[v] = 0;
    }
}
void generate(int index)
{
    if(cnt > lel)
        return;
    if(index == leafs.size())
    {
        cnt++;
        solve(1);
        if(can[1])
        {
            cout<<"Yes"<<endl;
            for(int i = 1; i <= n; i++)
            {
                if(edges[i].empty())
                {
                    cout<<have[i][0]<<endl;
                    continue;
                }
                for(auto j : ans_order[i])
                    cout<<j<<" ";
                cout<<endl;
            }
            exit(0);
        }
        return;
    }
    for(auto j : projects[leafs[index]])
    {
        have[leafs[index]].push_back(j);
        generate(index + 1);
        have[leafs[index]].pop_back();
    }
}
const int M = 2001;
int dp[M][M];
void dfs(int v)
{
    for(int i = 0; i < M; i++)
        dp[v][i] = M;
    if(edges[v].empty())
    {
        for(auto i : projects[v])
            dp[v][i] = i;
    }
    else
    {
        for(auto i : edges[v])
            dfs(i);
        if(edges[v].size() == 1)
        {
            for(int i = 1; i < M; i++)
                dp[v][i] = dp[edges[v][0]][i];
        }
        else
        {
            int a = edges[v][0], b = edges[v][1];
            for(int i = 1; i < M; i++)
            {
                if(dp[a][i] + 1 < M)
                    dp[v][i] = min(dp[v][i], dp[b][dp[a][i] + 1]);
                if(dp[b][i] + 1 < M)
                    dp[v][i] = min(dp[v][i], dp[a][dp[b][i] + 1]);
            }
        }
    }
    for(int i = M - 2; i > 0; i--)
        dp[v][i] = min(dp[v][i], dp[v][i + 1]);
}
signed main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    cin>>n;
    for(int i = 1; i <= n; i++)
    {
        cin>>type[i];
        if(type[i] == 1)
        {
            nleafs.push_back(i);
            int k;
            cin>>k;
            for(int j = 0; j < k; j++)
            {
                int a;
                cin>>a;
                edges[i].push_back(a);
            }
        }
        else
        {
            leafs.push_back(i);
            int m;
            cin>>m;
            for(int j = 0; j < m; j++)
            {
                int a;
                cin>>a;
                projects[i].push_back(a);
            }
        }
    }
    lel = 2e6;
    generate(0);
    dfs(1);
    for(int i = 1; i < M; i++)
    {
        if(dp[1][i] < M)
        {
            cout<<"Yes"<<endl;
            return 0;
        }
    }
    cout<<"No"<<endl;
}