#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array


typedef long long ll;
using namespace std;

const int md = 1e9 + 7;

inline int mul(const int &a, const int &b) {
    return (1ll * a * b) % md;
}

inline int sub(const int &a, const int &b) {
    return a - b < 0 ? a - b + md : a - b;
}

inline int add(const int &a, const int &b) {
    return a + b >= md ? a + b - md : a + b;
}

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int P = -1;
const int maxN = 5e5 + 100;
int stP[maxN];
const int G = 19;
void init() {
    while(P < 1000) {
        P = rng() % md;
    }
    stP[0] = 1;
    for(int i = 1; i < maxN; ++i) stP[i] = mul(stP[i - 1], P);
}

int hup[maxN][G];
int mup[maxN][G];
int pos[maxN];
char s[maxN];
bool a[27][27];
vector<int> stk;
int nxt[maxN];

bool check(int u, int w) {
    if (w == u) return false;
    int i = pos[u];
    int j = pos[w];
    for(int k = G - 1; k >= 0; --k) {
        if (i - (1 << k) < -1 || j - (1 << k) < -1) continue;
        if (hup[stk[i]][k] == hup[stk[j]][k]) {
            i -= (1 << k);
            j -= (1 << k);
        }
    }
    if (i == -1) return true;
    if (j == -1) return false;
    return hup[stk[i]][0] < hup[stk[j]][0];
}

void solve() {
    init();
    int k, n; cin >> k >> n;
    range(i, k) {
        range(j, k) {
            char x; cin >> x;
            if (x == '1') a[i][j] = 1;
        }
    }
    range(i, n) cin >> s[i];
    vector<vector<int>> delb(n);
    for(int i = n - 1; i >= 0; --i) {
        while(!stk.empty() && a[s[i]-'a'][s[stk.back()]-'a']) {
            delb[i].push_back(stk.back());
            stk.pop_back();
        }
        if (stk.empty()) {
            nxt[i] = n;
        } else {
            nxt[i] = stk.back();
        }
        stk.push_back(i);
    }
    stk.clear();

    for(int i = n - 1; i >= 0; --i) {
        int e = stk.size();
        int r = nxt[i];
        if (!stk.empty() && stk[0] >= r) {
            int mn = -1;
            for(auto &j : delb[i]) {
                int p = pos[j];
                assert(stk[p] == j);
                if (mn == -1 || check(p, mn)) {
                    mn = p;
                }
            }
            if (mn != -1) {
                while (stk.back() != mn) {
                    stk.pop_back();
                }
            }
        } else {
            stk.clear();
        }
        e = stk.size();
        pos[i] = e;
        stk.push_back(i);
        hup[i][0] = s[i];
        for(int j = 1; j < G; ++j) {
            if (e - (int)(1 << j) < -1) break;
            hup[i][j] = add(mul(hup[stk[e - (int)(1 << (j-1))]][j - 1], stP[1<<(j-1)]), hup[i][j - 1]);
        }
    }
    reverse(all(stk));
    for(auto &i : stk) cout << s[i];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    range(_, tests) {
        solve();
    }
    return 0;
}