#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

ll n, m;
string s;
vector<vector<pair<ll, string>>> a;

vector<ll> bad_cnt;
set<ll> good;
vector<vector<ll>> bad_inds;

void solve() {
    cin >> n >> m;
    cin >> s;
    a.resize(n);
    for(ll i = 0; i < n; i++) {
        ll cnt;
        cin >> cnt;
        for(ll j = 0; j < cnt; j++) {
            ll pos;
            string let;
            cin >> pos >> let;
            pos--;
            a[i].pb({pos, let});
        }
    }

    bad_inds.resize(m);
    bad_cnt.assign(n, 0);
    for(ll i = 0; i < n; i++) {
        for(ll j = 0; j < a[i].size(); j++) {
            if(s[a[i][j].first] != a[i][j].second[0]) {
                bad_cnt[i]++;
                bad_inds[a[i][j].first].pb(i);
            }
        }
        if(bad_cnt[i] == 0) {
            good.insert(i);
        }
    }

    vector<ll> ps(m, -1);
    vector<ll> ans;
    vector<ll> used(n, 0);

    ll ost = m;

    while(ost > 0) {
        if(good.size() == 0) {
            cout << "-1\n";
            return;
        }
        ll cur = *good.begin();
        good.erase(good.begin());

        used[cur] = true;
        ans.pb(cur);
        for(ll j = 0; j < a[cur].size(); j++) {
            if(ps[a[cur][j].first] != -1) continue;

            for(auto el : bad_inds[a[cur][j].first]) {
                bad_cnt[el]--;
                if(bad_cnt[el] == 0) {
                    good.insert(el);
                }
            }
            ost--;
            ps[a[cur][j].first] = cur;
        }
    }

    for(ll i = 0; i < n; i++) {
        if(used[i]) continue;

        ans.pb(i);
    }

    for(auto el : ans) {
        cout << el+1 << " ";
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
