 #include <iostream>
#include <vector>
#include <bitset>

#define int long long
#define f first
#define s second

using namespace std;

void ext()
{
    cout << "-1\n";
    exit(0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    int n,m;
    cin >> n >> m;
    const int maxm = 100000;
    string s;
    cin >> s;
    bitset <maxm> ri, cur;
    for(int i = 0; i < m; ++i)ri[i] = 1;
    vector <bitset<maxm> > w(n);
    vector <bitset<maxm> > e(n);
    for(int i = 0; i < n; ++i){
        int k;
        cin >> k;
        w[i] = ri;
        for(int j = 0; j < k; ++j){
            int pos;
            char c;
            cin >> pos >> c;
            pos--;
            e[i][pos] = 1;
            if(s[pos] != c)w[i][pos] = 0;
        }
    }
    vector <int> ans;
    vector <bool> used(n, false);
    while(cur != ri){
        int ind = -1;
        for(int i = 0; i < n; ++i){
            if(used[i])continue;
            if((w[i]|cur) == ri ){
                ind = i;
                break;
            }
        }
        if(ind == -1)ext();
        cur = (cur|e[ind]);
        ans.push_back(ind);
        used[ind] = true;
    }
    for(auto x:ans)cout << x+1 << ' ';
    for(int i = 0; i < n; ++i){
        if(!used[i])cout << i+1 << ' ';
    }
    cout << endl;
    return 0;
}
