#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(v) v.begin(), v.end()
#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

const int N = 32;
int a[N][N];
int pref[N + 1][N + 1];

void FIL()
{
    for(int i = 0; i < N; ++i)
    {
        for(int j = 0; j < N; ++j)
            a[i][j] = 1;
    }
    for(int i = N - 1; i >= 0; --i)
    {
        for(int j = N - 1; j >= 0; --j)
        {
            pref[i][j] = pref[i + 1][j] + pref[i][j + 1] - pref[i + 1][j + 1] + a[i][j];
        }
    }
}

void recalc()
{
    for(int i = N - 1; i >= 0; --i)
    {
        for(int j = N - 1; j >= 0; --j)
        {
            pref[i][j] = pref[i + 1][j] + pref[i][j + 1] - pref[i + 1][j + 1] + a[i][j];
        }
    }
}

int update(int x, int y)
{
    int s = 0;
    for(int i = x; i < N; ++i)
    {
        for(int j = y; j < N; ++j)
        {
            if(a[i][j])
                ++s;
            a[i][j] = 0;
        }
    }
    recalc();
    return s;
}

signed main()
{
    ///ios;
    int n, k, m;
    cin >> n >> k >> m;
    int t;
    cin >> t;
    if(t == 2)
    {
        string s = "";
        bool first = 0;
        int G;
        cin >> G;
        while(G--)
        {
            FIL();
            first ^= 1;
            ///1 - me, 0 - jury
            int x, y;
            bool cur = first ^ 1;
            while(1)
            {
                cur ^= 1;
                cin >> x >> y;
                --x;
                --y;
                if(x == 0 && y == 0)
                    break;
                int w = update(x, y);
                if(cur)
                {
                    if(w == 1)
                        s.push_back('0');
                    else
                        s.push_back('1');
                }
                else
                {
                    ;
                }
            }
        }
        cout << s << endl;
    }
    else
    {
        string s;
        cin >> s;
        int i = 0;
        bool first = 0;
        bool cur = 0;
        while(i < m)
        {
            FIL();
            first ^= 1;
            cur = first ^ 1;
            while(i < m)
            {
                cur ^= 1;
                if(cur)
                {
                    if(pref[0][0] == 1)
                    {
                        cout << "1 1" << endl;
                        break;
                    }
                    if(s[i] == '0')
                    {
                        int p = n * n - 1;
                        while(p >= 0)
                        {
                            int i = p / n;
                            int j = p % n;
                            if(pref[i][j] == 1)
                                break;
                        }
                        if(p == -1)
                        {
                            cout << "1 1" << endl;
                            break;
                        }
                        else
                        {
                            update(p / n, p % n);
                            cout << p / n + 1 << ' ' << p % n + 1 << endl;
                        }
                    }
                    else
                    {
                        int p = n * n - 1;
                        while(p >= 0)
                        {
                            int i = p / n;
                            int j = p % n;
                            if(pref[i][j] > 1)
                                break;
                        }
                        if(p / n == 0 && p % n == 0 || p < 0)
                        {
                            cout << "1 1" << endl;
                            break;
                        }
                        update(p / n, p % n);
                    }
                }
                else
                {
                    int x, y;
                    cin >> x >> y;
                    if(x == 1 && y == 1)
                    {
                        break;
                    }
                    --x;
                    --y;
                    update(x, y);
                }
            }
        }
    }
    return 0;
}
