#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 32;
int a[maxn][maxn];
int n;

void make(int x, int y) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i <= x && j >= y)a[i][j] = 1;
        }
    }
}

void ask(int x, int y) {
    if (x != -1) {
        cout << y + 1 << " " << (n - x - 1) + 1 << endl;
        make(x, y);
    }
    cin >> y;
    cin >> x;
    x--;
    y--;
    x = (n - x - 1);
    make(x, y);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    int type;
    cin >> type;
    int k, m;
    cin >> n >> k >> m;

    if (type == 1) {
        string s;
        cin >> s;
        int l = 0;
        bool first = true;
        while (l < m) {
            if (!first)ask(-1, -1);
            int cnt = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (a[i][j] == 0) {
                        cnt++;
                    }
                }
            }
            if (cnt == 0) {
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < n; ++j) {
                        a[i][j] = 0;
                    }
                }
                first = !first;
                continue;
            }
            int bits = 0;
            while (cnt != 0) {
                bits++;
                cnt /= 2;
            }
            bits--;
            int to = min(l + bits - 1, (int) m - 1);
            int num = 0;
            for (int i = l; i <= to; ++i) {
                num += (s[i] - '0') * (1 << (i - l));
            }
            bool found = false;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (found)continue;
                    if (a[i][j] == 0) {
                        if (num == 0) {
                            found = true;
                            ask(i, j);
                        } else num--;
                    }
                }
            }
            first = !first;
            l = to + 1;
        }
    } else {
        int G;
        cin >> G;
        vector<pair<int, int>> d;
        vector<char> s(m);

        while (true) {
            int aa, bb;
            cin >> bb >> aa;
            if (aa == 1 && bb == 1)G--;
            aa--;
            bb--;
            aa = (n - aa - 1);
            d.push_back({aa, bb});
            if (G == 0) {
                break;
            }
        }
        int l = 0;
        bool first = true;
        int it = 0;
        while (l < m) {
            if (!first) {
                make(d[it].first, d[it].second);
                it++;
                first = !first;
                continue;
            }
            int cnt = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (a[i][j] == 0) {
                        cnt++;
                    }
                }
            }
            if (cnt == 0) {
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < n; ++j) {
                        a[i][j] = 0;
                    }
                }
                first = !first;
                it++;
                continue;
            }
            int bits = 0;
            while (cnt != 0) {
                bits++;
                cnt /= 2;
            }
            int num = 0;
            bool ff = false;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if(ff)continue;
                    if (d[it].first == i && d[it].second == j){
                        ff = true;
                        break;
                    }
                    if (a[i][j] == 0)num++;
                }
            }
            while (num != 0) {
                s[l] = num % 2 + '0';
                num /= 2;
                l++;
            }
            first = !first;
            make(d[it].first, d[it].second);
            it++;
        }
        for (int i = 0; i < s.size(); ++i) {
            cout << s[i];
        }
    }
}