#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <stdio.h>
#include <stack>

using namespace std;

#define endl '\n'

vector<vector<int>> v;
int k, n;
string str;
vector<vector<bool>> segdes;

bool cmp(string str1, string str2)
{
	int pos = 0;
	while (pos < str1.size() && pos < str2.size() && str1[pos] == str2[pos])
	{
		pos++;
	}

	if (str1.size() == pos)
	{
		return true;
	}
	else if (str2.size() == pos)
	{
		return false;
	}
	else
	{
		if (str1[pos] < str2[pos])
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}

bool candestroy(int l, int r)
{
	stack<char> st;

	for (int i = r; i >= l; i--)
	{
		while (!st.empty() && v[str[i] - 'a'][st.top() - 'a'] == 1)
		{
			st.pop();
		}
		st.push(str[i]);
	}

	if (st.size() == 1)
	{
		return true;
	}
	else
	{
		return false;
	}
}

string ans;

void rec(int pos, string cur)
{
	cur.push_back(str[pos]);

	if (pos == n)
	{
		if (cmp(cur, ans))
		{
			ans = cur;
		}
	}
	else
	{
		for (int i = pos; i < n; i++)
		{
			if (segdes[pos][i])
			{
				rec(i + 1, cur);
			}
		}
	}
}

void task()
{
	cin >> k >> n;

	v.resize(k, vector<int>(k, 0));

	for (int i = 0; i < k; i++)
	{
		for (int j = 0; j < k; j++)
		{
			char x;
			cin >> x;

			v[i][j] = x - '0';
		}
	}

	cin >> str;

	segdes.resize(n, vector<bool>(n, false));

	for (int i = 0; i < n; i++)
	{
		for (int j = i; j < n; j++)
		{
			segdes[i][j] = candestroy(i, j);
		}
	}

	ans = str;

	rec(0, "");

	cout << ans;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	task();

	return 0;
}