#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>
#include <math.h>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>
#define pii pair<int, int>

signed main() {
    
	int n, m; cin >> n >> m;
	string s; cin >> s;
	
	vector<map<int, char>> p(n);
	vector<set<int>> bad(n);
	vector<vi> del(m);
	vi ok(m, 0);
	for (int i = 0; i < n; ++i) {
		int k; cin >> k;
		for (int j = 0; j < k; ++j) {
			int t;
			char c;
			cin >> t >> c;
			p[i][--t] = c;
			del[t].push_back(i);
			if (c != s[t]) {
				bad[i].insert(t);
			}
		}
	}

	queue<int> q;
	vi was(n, 0);
	for (int i = 0; i < n; ++i) {
		if (bad[i].size() == 0) q.push(i), was[i] = 1;
	}
	vi ans;
	while (q.size()) {
		int v = q.front();
		ans.push_back(v);
		q.pop();
		for (auto el : p[v]) {
			if (ok[el.first]) continue;

			ok[el.first] = 1;
			for (auto str : del[el.first]) {
				if (!was[str]) {

					p[str].erase(el.first);
					bad[str].erase(el.first);

					if (bad[str].size() == 0) {
						was[str] = 1;
						q.push(str);
					}
				}
			}


		}
	}
	
	for (int i = 0; i < m; ++i) {
		if (!ok[i]) {
			cout << "-1\n";
			exit(0);
		}
	}
	for (auto a : ans) cout << a + 1 << ' ';
	cout << '\n';
}
/*

3 4 
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f


*/