#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
// define int long long


// #pragma GCC target('sse,sse2,sse3,ssse3,sse4,avx,avx2,popcnt,tune=native')
// #pragma optimaze('O3')

bool dfs(int v, vector<vector<int>> & g, vector<int> & val, vector<int> & lft, vector<int> & rght, vector<vector<int>> & pos) {
    if (g[v].size() == 0) {
        lft[v] = val[v];
        rght[v] = val[v];
        return true;
    }
    vector<pair<pair<int, int>, int>> seg;
    for (auto to : g[v]) {
        if (!dfs(to, g, val, lft, rght, pos)) {
            return false;
        }
        seg.emplace_back(make_pair(lft[to], rght[to]), to);
    }
    sort(seg.begin(), seg.end());
    for (int i = 1; i < seg.size(); i++) {
        if (seg[i].first.first < seg[i - 1].first.second) return false;
    }
    for (int i = 0; i < seg.size(); i++) {
        pos[v].push_back(seg[i].second);
    }
    lft[v] = seg[0].first.first;
    rght[v] = seg.back().first.second;
    return true;

}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n; cin >> n;
    vector<vector<int>> g(n);
    vector<pair<int, int>> all;
    int maxm = 1e5 + 5;
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        if (x == 1) {
            int k; cin >> k;
            while (k--) {
                int j; cin >> j; j--;
                g[i].push_back(j);
            }
        } else {
            int m; cin >> m;
            while (m--) {
                int a; cin >> a;
                all.emplace_back(a, i);
            }
        }
    }
    int mm = all.size();
    for (int mask = 0; mask < (1 << mm); mask++) {
        vector<int> ind(n, -1), val(n, -1);
        bool ok = true;
        for (int i = 0; i < mm; i++) {
            if (mask & (1 << i)) {
                if (ind[all[i].second] != -1) {
                    ok = false;
                    break;
                }
                val[all[i].second] = all[i].first;
            }
        }
        for (int i = 0; i < n; i++) {
            if (g[i].size()) continue;
            if (val[i] == -1) ok = false;
        }
        if (!ok) continue;
        vector<int> lft(n), rght(n);
        vector<vector<int>> pos(n);
        if (dfs(0, g, val, lft, rght, pos)) {
            cout << "Yes" << endl;
            for (int i = 0; i < n; i++) {
                if (g[i].size()) {
                    for (auto el : pos[i]) cout << el + 1 << " ";
                    cout << endl;
                } else {
                    cout << val[i] << endl;
                }
            }
            return 0;
        }
    }
    cout << "No" << endl;

    return 0;
}
