#include <iostream>
#include <vector>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

int can[26][26];
vector<int> a;

bool can_del(int l, int r) {
	vector<int> now;
	for (int i = r; i >= l; --i) {
		while (now.size()) {
			if (can[a[i]][now.back()])
				now.pop_back();
			else
				break;
		}
		if (i != l)
			now.push_back(a[i]);
	}
	return now.size() == 0;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < k; ++j) {
			can[i][j] = (s[j] - '0');
		}
	}
	vector<int> last(k);
	string res;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		char c;
		cin >> c;
		a[i] = (c - 'a');
		last[a[i]] = i;
	}
	int pos = 0;
	string ans;
	ans += (char) (a[0] + 'a');
	while (pos < n) {
		for (int j = -1; j < k; ++j) {
			vector<int> now;
			for (int i = n - 1; i >= pos; --i) {
				while (now.size()) {
					if (now.back() != j && can[a[i]][now.back()])
						now.pop_back();
					else
						break;
				}
				if (i != pos)
					now.push_back(a[i]);
			}
			if (!now.size()) {
				cout << ans << '\n';
				return 0;
			}

			if (now.back() == j) {
				// cout << j << ' ' << pos << '\n';
				ans += ('a' + j);
				int z = pos;
				for (++pos; pos < n; ++pos) {
					if (a[pos] == j && (!can_del(z, pos) || pos == last[j])) {
						break;
					}
				}
				break;
			}
		}
	}
	// cout << ans << '\n';
	return 1;
}