#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <random>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

#define ff first
#define ss second
#define vec vector
#define all(a) a.begin(), a.end()
#define pb push_back
#define rall(a) a.rbegin(), a.rend()

void run() {
	ll n, m;
	string s;
	cin >> n >> m >> s;
	vec<vec<pair<ll, char>>> tb(n);
	vec<set<ll>> s1(n), s2(m);
	pair<ll, char> tmp;
	for (ll i = 0; i < n; ++i) {
		ll k;
		cin >> k;
		for (ll j = 0; j < k; ++j) {
			cin >> tmp.ff >> tmp.ss;
			tmp.ff--;
			tb[i].pb(tmp);
			if (s[tmp.ff] != tmp.ss) {
				s1[i].insert(tmp.ff);
				s2[tmp.ff].insert(i);
			}
		}
	}
	queue<ll> q;
	for (ll i = 0; i < n; ++i) {
		if (s1[i].empty()) {
			q.push(i);
		}
	}
	vi ans;
	vi used(m, 0);
	while (!q.empty()) {
		ll v = q.front();
		q.pop();
		ans.pb(v);
		for (auto u : tb[v]) {
			if (!used[u.ff]) {
				used[u.ff] = 1;
				for (auto w : s2[u.ff]) {
					s1[w].erase(u.ff);
					if (s1[w].empty())
						q.push(w);
				}
			}
		}
	}
	ll fl = 1;
	for (ll i = 0; i < m; ++i)
		fl = fl && used[i];
	if (fl && ans.size() == n) {
		for (auto v : ans)
			cout << v + 1 << ' ';
	}
	else {
		cout << -1;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll tkk = 1, kk = 0;
	while (kk++ < tkk) {
		run();
		cout << '\n';
	}
	return 0;
}

/*
1 1
a
1 1 a

3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f
*/