#include <bits/stdc++.h>

using namespace std;

#define pii pair <int, int>
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
#define ss second
#define ff first

typedef long long ll;
typedef long double ld;
#define int ll

const int inf = 1e9 + 100;
const ll inf64 = 1ll * inf * inf;

int n, k, m;

pii find0(vector <vector <int>> &a){
    int clear_cnt = 0;
    for(int i = n - 1; i >= 0; --i){
        for(int j = n - 1; j >= 0; --j){
            if((i + j) % 2 == 0 && a[i][j] == 0){
                return mp(i, j);
            }
        }
    }
    return mp(0, 0);
}

pii find1(vector <vector <int>> &a){
    int clear_cnt = 0;
    for(int i = n - 1; i >= 0; --i){
        for(int j = n - 1; j >= 0; --j){
            if((i + j) % 2 == 1 && a[i][j] == 0){
                return mp(i, j);
            }
        }
    }
    return mp(0, 0);
}

void color(vector <vector <int>> &a, int ti, int tj){
    for(int i = n - 1; i >= ti; --i){
        for(int j = n - 1; j >= tj; --j){
            a[i][j] = 1;
        }
    }
}

void play(){
    cin >> n >> k >> m;
    string s;
    cin >> s;
    int t = 0;
    vector <vector <int>> a(n, vector <int>(n));
    bool move = 0;
    bool first_move = 1;
    while(t < sz(s)){
        move = !move;
        if(move){
            if(s[t] == '0'){
                pii t = find0(a);
                if(t == mp(0ll, 0ll)){
                    cout << 1 << ' ' << 1 << endl;
                    first_move = !first_move;
                    if(first_move)
                        move = 0;
                    else
                        move = 1;
                    a.assign(n, vector <int>(n, 0));
                    continue;
                }
                else{
                    cout << t.ff + 1 << ' ' << t.ss + 1 << endl;
                }
                color(a, t.ff, t.ss);
            }
            else{
                pii t = find1(a);
                if(t == mp(0ll, 0ll)){
                    cout << 1 << ' ' << 1 << endl;
                    first_move = !first_move;
                    if(first_move)
                        move = 0;
                    else
                        move = 1;
                    a.assign(n, vector <int>(n, 0));
                    continue;
                }
                else{
                    cout << t.ff + 1 << ' ' << t.ss + 1 << endl;
                }
                color(a, t.ff, t.ss);
            }
            ++t;
        }
        else{
            int ti, tj;
            cin >> ti >> tj;
            --ti;
            --tj;
            if(mp(ti, tj) == mp(0ll, 0ll)){
                first_move = !first_move;
                if(first_move)
                    move = 0;
                else
                    move = 1;
                a.assign(n, vector <int>(n, 0));
            }
            color(a, ti, tj);
        }
    }
    cout << 1 << ' ' << 1 << endl;
    int ti, tj;
    cin >> ti >> tj;
    cout << 0 << endl;
}

void gans(){
    vector <pii> moves;
    cin >> n >> k >> m;
    int cg;
    cin >> cg;
    bool move = 0;
    bool first_move = 1;
    for(int i = 0; i < cg;){
        move = !move;
        int ti, tj;
        cin >> ti >> tj;
        --ti;
        --tj;
        if(mp(ti, tj) == mp(0ll, 0ll)){
            first_move = !first_move;
            if(first_move)
                move = 0;
            else
                move = 1;
            ++i;
            continue;
        }
        if(move){
            moves.pb(mp(ti, tj));
        }
    }
    string ans;
    for(auto i : moves){
        ans.pb((i.ff + i.ss) % 2 + '0');
    }
    cout << ans << endl;
}

void run(){
    int game;
    cin >> game;
    if(game == 1){
        play();
    }
    else{
        gans();
    }
}

signed main(){
    //freopen("/tmp/game.in", "r", stdin); 
    //freopen("/tmp/game.out", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(0);
    run();
}