//#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

int k, n;
vector<vector<int>> can;

bool cmp2(vector<int> a1, vector<int> a2) {
    for (int i = 0; i < (int) a1.size() && i < (int) a2.size(); i++) {
        if (a1[i] < a2[i])
            return true;
        if (a1[i] > a2[i])
            return false;
    }
    return a1.size() > a2.size();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> k >> n;
    can.resize(k + 1, vector<int> (k + 1));
    for (int i = 1; i <= k; i++) {
        for (int j = 1; j <= k; j++) {
            char c;
            cin >> c;
            if (c == '1') {
                can[i][j] = 1;
            }
        }
    }
    for (int i = 0; i <= k; i++) {
        can[i][0] = 1;
    }
    vector<int> arr;
    for (int i = 0; i < n; i++) {
        char c;
        cin >> c;
        arr.push_back(c - 'a' + 1);
    }
    vector<vector<int>> dp2(n + 1);
    vector<int> right(n + 1);
    right[n] = n;
    vector<vector<int>> near(n + 1, vector<int> (27, n + 1));
    for (int i = n - 1; i >= 0; i--) {
        dp2[i] = {33};
        vector<int> cur = {i};
        right[i] = i + 1;
        int bad = n;
        for (int j = 0; j < 27; j++) {
            if (!can[arr[i]][j]) {
                bad = min(bad, near[i + 1][j]);
            }
        }
        right[i] = bad;
        near[i] = near[right[i]];
        near[i][arr[i]] = i;
        for (int j = i + 1; j <= right[i]; j++) {
            vector<int> arr2 = dp2[j];
            arr2.insert(arr2.begin(), arr[i]);
            dp2[i] = min(dp2[i], arr2);
        }

    }
    for (int el : dp2[0]) {
        cout << (char) (el + 'a' - 1);
    }
    cout << endl;
}
