#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

const int MEM = 2e8;
char *mem[MEM];
int cur = 0;

void *operator new(size_t sz) {
    void *ans = mem + cur;
    cur += sz;
    return ans;
}

void operator delete(void *) {}
void operator delete(void *, size_t) {}

#define set adsjfkljdasfljdasfjkl
#define right adsfjfa

typedef long long ll;
typedef long double ldb;
typedef unsigned int uint;

mt19937 rd(228);

int randint(int l, int r) {
    int ans = rd() % (r - l + 1);
    assert(ans >= 0);
    return ans + l;
}

//const int MOD = 1e9 + 7;
const int p = 517;

int ppow[500000 + 228];

inline uint add(uint a, uint b) {
    return a + b;
}

inline uint mul(uint a, uint b) {
    return a * b;
}

void init() {
    ppow[0] = 1;
    for (int i = 1; i < 500000 + 228; i++) {
        ppow[i] = mul(ppow[i - 1], p);
    }
}

struct Hash {
    int hsh, len;

    Hash(int hsh, int len) : hsh(hsh), len(len) {}
    Hash() {}
};

inline bool operator==(const Hash &a, const Hash &b) {
    return tie(a.hsh, a.len) == tie(b.hsh, b.len);
}

inline Hash merge(Hash a, Hash b) {
    return Hash(add(mul(a.hsh, ppow[b.len]), b.hsh), a.len + b.len);
}

struct node {
    node *l, *r;
    int x;
    Hash hsh;
    int sz;
    node(int x) : x(x) {
        l = r = NULL;
        hsh = Hash(x, 1);
        sz = 1;
    }
};

Hash gethsh(node *n) {
    if (n == NULL)
        return Hash(0, 0);
    return n->hsh;
}

int getsz(node *n) {
    if (n == NULL)
        return 0;
    return n->sz;
}

inline void pull(node *n) {
    n->hsh = merge(gethsh(n->l), merge(Hash(n->x, 1), gethsh(n->r)));
    n->sz = 1 + getsz(n->l) + getsz(n->r);
}

node *make_tree(int x, node *l, node *r) {
    node *n = new node(x);
    n->l = l;
    n->r = r;
    pull(n);
    return n;
}

node *merge(node *a, node *b) {
    if (a == NULL)
        return b;
    if (b == NULL)
        return a;
    if (randint(0, getsz(a) + getsz(b) - 1) < getsz(a)) {
        return make_tree(a->x, a->l, merge(a->r, b));
    }
    return make_tree(b->x, merge(a, b->l), b->r);
}

Hash getHash(node *a, int k) {
     if (k <= 0) {
         return Hash(0, 0);
     }
     if (a == NULL)
         return Hash(0, 0);
     if (k >= getsz(a)) {
         return a->hsh;
     }
     if (k <= getsz(a->l)) {
         return getHash(a->l, k);
     }
     return merge(getHash(a->l, k), merge(Hash(a->x, 1), getHash(a->r, k - 1 - getsz(a->l))));
}

int getk(node *a, int k) {
    if (k == getsz(a->l)) {
        return a->x;
    }
    if (k < getsz(a->l))
        return getk(a->l, k);
    return getk(a->r, k - 1 - getsz(a->l));
}

bool cmp(node *a, node *b) {
    int l = 0;
    int r = min(getsz(a), getsz(b));
    if (getHash(a, r) == getHash(b, r)) {
        if (getsz(a) < getsz(b)) {
            return true;
        }
        return false;
    }
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (getHash(a, m) == getHash(b, m)) {
            l = m;
        } else {
            r = m;
        }
    }
    int aa = getk(a, l);
    int bb = getk(b, l);
    return aa < bb;
/*    auto pp11 = split(a, l);
    auto pp111 = split(pp11.second, 1);
    auto pp22 = split(b, l);
    auto pp222 = split(pp22.second, 1);
    return pp111.first->x < pp222.first->x;*/
}

int k, n;
int can[27][27];
node *n33;


void print(node *n) {
    if (n == NULL)
        return;
    print(n->l);
    cout << (char) (n->x + 'a' - 1);
    print(n->r);
}

int arr[500000 + 228];
int right[500000 + 228];
int near[500000 + 228][27];

pair<int, node *> st[500000 + 228];;

signed main() {
    n33 = new node(33);
    init();
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> k >> n;
    for (int i = 1; i <= k; i++) {
        for (int j = 1; j <= k; j++) {
            char c;
            cin >> c;
            if (c == '1') {
                can[i][j] = 1;
            }
        }
    }
    for (int i = 0; i <= k; i++) {
        can[i][0] = 1;
    }
    for (int i = 0; i < n; i++) {
        char c;
        cin >> c;
        arr[i] = c - 'a' + 1;
    }
    right[n] = n;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= k; j++) {
            near[i][j] = n + 1;
        }
    }
    int top = 0;
    st[top++] = {n, NULL};
    for (int i = n - 1; i >= 0; i--) {
        right[i] = i + 1;
        int bad = n;
        for (int j = 0; j <= k; j++) {
            if (!can[arr[i]][j]) {
                bad = min(bad, near[i + 1][j]);
            }
        }
        right[i] = bad;
        for (int j = 0; j <= k; j++) {
            near[i][j] = near[right[i]][j];
        }
        near[i][arr[i]] = i;
        node *mn;
        if (right[i] == n) {
            mn = st[0].second;
        } else {
            int l = 0;
            int r = top;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (st[m].first > right[i]) {
                    l = m;
                } else {
                    r = m;
                }
            }
            mn = st[r].second;
        }
        mn = merge(new node(arr[i]), mn);
        while (cmp(mn, st[top - 1].second)) {
            top--;
        }
        st[top++] = {i, mn};
    }
    print(st[top - 1].second);
    cout << endl;
}
