#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

const int MAXN = 32;

int first[MAXN];

void reset() {
    fill(first, first + MAXN, MAXN);
}

void makeMove(int x, int y) {
    for (int i = x; i < MAXN; i++) {
        first[i] = min(first[i], y);
    }
}

void readMove() {
    int x, y;
    cin >> x >> y;
    x--;
    y--;
    makeMove(x, y);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    int n, m, k;
    cin >> n >> k >> m;
    assert(n == 32);
    assert(k == 8);
    if (t == 1) {
        string s;
        cin >> s;
        int cur_bit = 0;
        int cur_player = 0;
        while (cur_bit < m) {
            reset(); 
            if (cur_player == 1) {
                readMove();
            }
            while (first[0] != 0) {
                if (first[0] == 1 && first[1] == 0) {
                    cout << "1 1" << endl;
                    break;
                }
                int x1, y1, x2, y2;
                for (int i = MAXN - 1; i >= 0; i--) {
                    if (first[i] != 0) {
                        x1 = i;
                        y1 = first[i] - 1;
                        if (first[i] != 1) {
                            x2 = i;
                            y2 = y1 - 1;
                        } else {
                            x2 = i - 1;
                            y2 = first[i - 1] + 1;
                        }
                        break;
                    }
                }
                bool bad = false;
                if (cur_bit == m || s[cur_bit] == '0') {
                    cout << x1 + 1 << ' ' << y1 + 1 << endl;
                    if (x1 == 0 && y1 == 0)
                        bad = 1;
                    makeMove(x1, y1);
                } else {
                    cout << x2 + 1 << ' ' << y2 + 1 << endl;
                    if (x2 == 0 && y2 == 0)
                        bad = 1;
                    makeMove(x2, y2);
                }
                cur_bit++;
                if (bad)
                    break;
                readMove();
            }
            cur_player ^= 1;
        }
    } else {
        int cur_bit = 0;
        int cur_player = 0;
        string ans;
        int cnt_games;
        cin >> cnt_games;
        while (cnt_games--) {
            reset();
            if (cur_player == 1) {
                readMove();
            }
            while (first[0] != 0) {
                if (first[0] == 1 && first[1] == 0) {
                    int a, b;
                    cin >> a >> b;
                    assert(a == 1 && b == 1);
                    break;
                }
                int x1, y1, x2, y2;
                for (int i = MAXN - 1; i >= 0; i--) {
                    if (first[i] != 0) {
                        x1 = i;
                        y1 = first[i] - 1;
                        if (first[i] != 1) {
                            x2 = i;
                            y2 = y1 - 1;
                        } else {
                            x2 = i - 1;
                            y2 = first[i - 1] + 1;
                        }
                        break;
                    }
                }
                int a, b;
                cin >> a >> b;
                a--;
                b--;
                if (cur_bit < m) {
                    if (a == x1 && b == y1) {
                        ans.push_back('0'); 
                    } else {
                        ans.push_back('1');
                    }
                }
                makeMove(a, b);
                if (a == 0 && b == 0) {
                    break;
                }
                readMove();
            }
            cur_player ^= 1;
        }
        cout << ans << endl;
    }
}
