#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

vector<vector<int>> ch;

vector<vector<int>> imp;

vector<int> p;
vector<int> sz;

void dfs(int v) {
    if (ch[v].empty()) {
        sz[v] = 1;
    } else {
        for (int u : ch[v]) {
            p[u] = v;
            dfs(u);
            sz[v] += sz[u];
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    ch.resize(n);
    imp.resize(n);
    sz.resize(n);
    p.resize(n, -1);
    vector<int> times;
    vector<int> who;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        int k;
        cin >> k;
        if (t == 1) {
            ch[i].resize(k);
            for (auto &el : ch[i]) {
                cin >> el;
                el--;
            }
        } else {
            if (k == 0) {
                cout << "No" << endl;
                return 0;
            }
            imp[i].resize(k);
            for (auto &el : imp[i]) {
                cin >> el;
                times.push_back(el);
                who.push_back(i);
            }
        }
    }
    dfs(0);
    for (int mask = 0; mask < (1 << (int) times.size()); mask++) {
        vector<int> cnt(n);
        vector<pair<int, int>> arr;
        for (int i = 0; i < (int) times.size(); i++) {
            if (mask & (1 << i)) {
                cnt[who[i]]++;
                arr.push_back({times[i], who[i]});
            }
        }
        bool good = 1;
        for (int i = 0; i < n; i++) {
            if (ch[i].empty()) {
                if (cnt[i] != 1) {
                    good = 0;
                    break;
                }
            }
        }
        if (!good)
            continue;
        vector<int> fst(n, n), last(n, 0);
        sort(arr.begin(), arr.end());
        for (int i = 0; i < (int) arr.size(); i++) {
            int cur = p[arr[i].second];
            while (cur != -1) {
                fst[cur] = min(fst[cur], i);
                last[cur] = max(last[cur], i);
                cur = p[cur];
            }
        }
        for (int i = 0; i < n; i++) {
            if (!ch[i].empty()) {
                if (sz[i] != last[i] - fst[i] + 1) {
                    good = 0;
                    break;
                }
            }
        }
        if (!good)
            continue;
        cout << "Yes" << endl;
        return 0;
    }
    cout << "No" << endl;
}
