#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <iomanip>
#include <cstring>
#include <bitset>
#include <queue>
#include <deque>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <random>

//#pragma GCC target("avx2")

//#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int maxN = 2e3 + 123;
int g[maxN][maxN];

void solve() {
    int c, n;
    cin >> c >> n;

    /*string s1 = "aaaa";
    string s2 = "aa";
    cout << (s1 < s2) << '\n';*/


    vector<string> matrix(c);
    for (int i = 0; i < c; ++i) {
        cin >> matrix[i];
    }
    string s;
    cin >> s;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        v[i] = s[i] - 'a';
    }

    vector<int> go_right(n, 0);
    go_right[n - 1] = n;
    for (int i = n - 2; i >= 0; --i) {
        go_right[i] = i + 1;
        while (go_right[i] < n && matrix[v[i]][v[go_right[i]]] == '1') {
            go_right[i] = go_right[go_right[i]];
        }
    }

    vector<string> d(n + 1, {"{"});
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j <= go_right[i]; ++j) {
            g[i][j] = 1;
        }
    }
    d[0] = s[0];
    for (int i = 0; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            if (!g[i][j]) break;
            if (j < n) {
                d[j] = min(d[j], d[i] + s[j]);
            } else {
                d[j] = min(d[j], d[i]);
            }
        }
    }
    cout << d[n];
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}