// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <string>
using namespace std;

long long n, m;
string s;
vector <vector<char>> p;
vector<bool> used;
vector<pair<bool, long long>> close;
vector <long long> ans;

bool f(long long ind)
{
	for (long long i = 0; i < s.size(); i++)
	{
		if (p[ind][i] != s[i] && !(close[i].first) && p[ind][i] != '.')
			return false;
	}
	for (long long i = 0; i < s.size(); i++)
	{
		if (p[ind][i] == s[i] && !(close[i].first))
		{
			close[i] = make_pair(true, ind);
		}
	}
	return true;
}

bool f1(long long ind)
{
	for (long long i = 0; i < s.size(); i++)
	{
		if (p[ind][i] != s[i] && !(close[i].first))
			return false;
	}
	return true;
}

void unclose(long long ind)
{
	for (long long i = 0; i < n; i++)
	{
		if (p[ind][i] == s[i] && close[i].second == ind)
		{
			close[i] = make_pair(false, -1);
		}
	}
	return;
}

bool gen(long long ind, long long dept)
{
	used[ind] = true;
	ans.push_back(ind + 1);
	bool fl = true;
	for (long long i = 0; i < n; i++)
	{
		if (!(used[i]))
		{
			fl = false;
			if (f(i))
			{
				if (gen(i, dept + 1))
					return true;
			}
		}
	}
	if (fl && f1(ind))
	{
		return true;
	}
	used[ind] = false;
	ans.pop_back();
	unclose(ind);
	return false;
}

int main()
{
	cin >> n >> m >> s;
	p.resize(n);
	for (long long i = 0; i < n; i++)
	{
		long long k;
		cin >> k;
		vector <pair<long long, char>> elem(k);
		char cr; long long intt;
		for (long long j = 0; j < k; j++)
		{
			cin >> intt >> cr;
			elem[j] = make_pair(intt, cr);
		}
		long long index = 0;
		for (long long j = 0; j < elem.size(); j++)
		{
			while (index != (elem[j].first - 1))
			{
				p[i].push_back('.');
				index++;
			}
			p[i].push_back(elem[j].second);
			index++;
		}
		if (p[i].size() < s.size())
			for (long long el = 0; el < s.size() - p[i].size(); el++)
				p[i].push_back('.');
	}
	used.resize(n, false);
	close.resize(s.size(), make_pair(false, -1));
	bool flag = true;
	for (long long i = 0; i < n; i++)
	{
		if (f(i))
		{
			if (gen(i, 0))
			{
				for (auto j : ans)
					cout << j << ' ';
				cout << endl;
				flag = false;
				break;
			}
			close.resize(s.size(), make_pair(false, -1));
		}
	}
	if (flag)
	{
		cout << -1 << endl;
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
