#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2e5 + 10;
int used[MAXN];
int ost[MAXN];

vector<vector<int>> graph;
vector<int> ans;
bitset<MAXN> kek;
int tout[MAXN];
int tt = 0;
void dfs0(int v) {
  if (kek[v])
    return;
  kek[v] = true;
  for (int u : graph[v])
    dfs0(u);
  tout[v] = tt++;
}

void dfs(int v) {
  ost[v]--;
  if (ost[v] > 0)
    return;
  if (used[v] == 1) {
//    cout << -1;
//    exit(0);
    return;
  }
  if (used[v] == 2)
    return;
  used[v] = 1;
  for (int u : graph[v]) {
    dfs(u);
  }
  ans.push_back(v);
  used[v] = 2;
}

bool cmp(int a, int b) {
  return tout[a] < tout[b];
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, m;
  cin >> n >> m;
  string s;
  cin >> s;
  vector<vector<pair<int, char>>> arr(n);
//  vector<vector<int>> can(m), uncan(m);
  graph.resize(n + m + 1);
  int rt = n + m;
  for (int i = 0; i < n; ++i) {
    int k;
    cin >> k;
    auto &el = arr[i];
    el.resize(k);
    bool ok = true;
    for (auto &p : el) {
      cin >> p.first >> p.second;
      p.first--;
      if (p.second == s[p.first]) {
        graph[i].push_back(p.first + n);
//        can[p.first].push_back(i);
      }
      else {
        ok = false;
        graph[p.first + n].push_back(i);
//        ost[i]++;
//        uncan[p.first].push_back(i);
      }
    }
    if (ok)
      graph[rt].push_back(i);
  }
  for (int i = 0; i < graph.size(); ++i) {
    sort(graph[i].begin(), graph[i].end());
    graph[i].resize(unique(graph[i].begin(), graph[i].end()) - graph[i].begin());
  }
  dfs0(rt);
  for (int i = 0; i < graph.size(); ++i) {
    sort(graph[i].begin(), graph[i].end(), cmp);
    for (int j : graph[i]) {
      if (j < n)
        ost[j]++;
    }
  }

  dfs(rt);
  reverse(ans.begin(), ans.end());
  vector<int> res;
  for (int i : ans) {
    if (i < n) {
      res.push_back(i);
    }
  }
  for (int i = 0; i < n; ++i) {
    if (used[i] == 0) {
      res.push_back(i);
    }
  }
  string t(m, '#');
  for (int i : res) {
    for (auto[a, c] : arr[i]) {
      if (t[a] == '#')
        t[a] = c;
    }
  }
  if (t != s)
    cout << -1;
  else {
    for (int i : res)
      cout << i + 1 << ' ';
  }
}