#include <bits/stdc++.h>

using namespace std;

int n, k, m;
vector<string> arr;
bool fin;
int last;
int A, B;


int paint(int x, int y) {
  int res = 0;
  for (int i = x; i < n; ++i) {
    if (arr[i][y] == '1')
      break;
    for (int j = y; j < n; ++j) {
      if (arr[i][j] == '1')
        break;
      res += arr[i][j] == '0';
      arr[i][j] = '1';
    }
  }
  return res;
}

int get() {
  if (A == -1) {
    fin = true;
    return -1;
  }
  int a = 0, b = 0;
  if (!(cin >> a)) {
    a = 0, b = 0;
  } else
    cin >> b;
  a--, b--;
  A = a, B = b;
  if (a < 0) {
    fin = true;
    return -1;
  }
  int res = paint(a, b);
  fin = (a == 0) && (b == 0);
  last = a ^ b;
  return res;
}


int getarea(int x, int y) {
  int res = 0;
  for (int i = x; i < n; ++i) {
    if (arr[i][y] == '1')
      break;
    for (int j = y; j < n; ++j) {
      if (arr[i][x] == '1')
        break;
      res += arr[i][j] == '0';
    }
  }
  return res;
}

bool fset(int a) {
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      if (i == 0 && j == 0)
        continue;
      if (arr[i][j] == '1')
        continue;
      if (getarea(i, j) == a) {
        cout << i + 1 << ' ' << j + 1 << endl;
        paint(i, j);
        return true;
      }
    }
  }
  return false;
}

void startgame() {
  arr.clear();
  arr.resize(n, string(n, '0'));
  fin = false;
  A = 0, B = 0;
  last = 0;
}

void solve1() {
  string s;
  cin >> s;
  int game = 1;
  int p = 0;
  fin = true;
  while (p < m) {
    game ^= 1;
    startgame();
    if (game) {
      get();
    }
    while (!fin && p < m) {
      bool ok;
      if (s[p] == '1') {
        ok = fset(1);
      } else {
        ok = fset(2);
      }
      if (ok) {
        p++;
        get();
        continue;
      }
      cout << "1 1" << endl;
      fin = true;
    }
    if (p == m && !fin) {
      cout << "1 1" << endl;
      fin = true;
      break;
    }
  }
  cout << 0 << endl;
}

void solve2() {
  int games;
  cin >> games;
  string s;
  for (int g = 0; g < games && A != -1; ++g) {
    startgame();
    bool fst = g & 1;
    if (fst)
      get();
    while (!fin) {
      int a = get();
      if (!fin) {
        s.push_back('0' + a % 2);
        get();
      }
    }
  }
  cout << s << endl;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t;
  cin >> t;
  cin >> n >> k >> m;
  if (t == 1)
    solve1();
  else
    solve2();
}

