#include <bits/stdc++.h>
#define int long long
using namespace std;
int INF = 1e9;
int n, k;
vector <vector <int> > get_del(vector <int> a, vector <vector <int> > gr) {
    vector <vector <int> > dp(n, vector <int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (gr[a[i]][a[j]]) {
                if (dp[i - 1][j + 1]) {
                    for (int k = 0; k <= j; k++) dp[i][k] = dp[j][k];
                    dp[i][j + 1] = 1;
                    break;
                }
            }
        }
        for (int j = i + 1; j < n; j++) dp[i][j] = 1;
        // for (int j = 0; j < n; j++) cout << dp[i][j] << " ";
        // cout << endl;
    }
    return dp;
}

string min(string a, string b, int t) {
    if (a.size() > b.size()) swap(a, b);
    for (int i = 0; i < a.size(); i++) {
        if (a[i] != b[i]) return (a[i] < b[i] ? a : b);
    }
    return (t == 0 ? a : b);
}

string stupid(vector <int> a, vector <vector <int> > gr) {
    vector <set <string> > dp(n);
    dp[0].insert(string(1, a[0] + 'a'));
    auto del = get_del(a, gr);
    for (int i = 1; i < n; i++) {
        for (int z = 0; z <= i; z++) {
            if (del[i - 1][z]) {
                for (auto s : dp[z - 1]) {
                    dp[i].insert(s + string(1, a[i] + 'a'));
                }
            }
            if (del[i][z]) {
                for (auto s : dp[z - 1]) {
                    dp[i].insert(s);
                }
            }
        }
    }
    return *dp[n - 1].begin();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();
    cin >> k >> n;
    vector <vector <int> > gr(k, vector <int> (k));
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char x;
            cin >> x;
            if (x == '1') gr[j][i] = 1;
        }
    }
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        char c;
        cin >> c;
        a[i] = c - 'a';
    }
    cout << stupid(a, gr);
    return 0;
    /*
    for (int i = 0; i < k; i++) {
        cout << i << " ";
        for (int j = 0; j < k; j++) if (gr[i][j]) cout << j << " ";
        cout << endl;
    }*/
    string big(1, 'z' + 1);
    vector <vector <string> > dp(n, vector <string> (2, big));
    auto del = get_del(a, gr);

    dp[0][0] = dp[0][1] = string(1, a[0] + 'a');
    for (int i = 1; i < n; i++) {
        for (int z = 0; z <= i; z++) {
            if (del[i - 1][z]) {
                for (int t = 0; t < 2; t++) {
                    dp[i][t] = min(dp[i][t], dp[z - 1][t] + string(1, a[i] + 'a'), t);
                }
            }
            if (del[i][z]) {
                for (int t = 0; t < 2; t++) dp[i][t] = min(dp[i][t], dp[z - 1][t], t);
            }
        }
        for (int t = 0; t < 2; t++) dp[i][t] = min(dp[i][t], dp[i][t ^ 1], t);
        // cout << dp[i][0] << " " << dp[i][1] << endl;
    }
    string ans = big;
    for (int c = 0; c < 2; c++) ans = min(ans, dp[n - 1][0]);
    cout << ans;
}
/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
*/
