#include <bits/stdc++.h>

using namespace std;

#define pb emplace_back
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define ll long long
#define ld long double
#define pii pair<int, int>

const int INF = 1e9 + 1;

struct Sparse_Table {
    vector<vector<int>> st;
    vector<int> logs;

    Sparse_Table(vector<int> a) {
        int n = a.size();
        logs.resize(n + 1);
        logs[1] = 0;
        for (int i = 2; i <= n; i++) logs[i] = logs[i / 2] + 1;
        st.assign(n, vector<int>(logs[n] + 1));
        for (int i = 0; i < n; i++) st[i][0] = a[i];
        for (int j = 1; j <= logs[n]; j++) {
            for (int i = 0; i + (1 << j) <= n; i++) {
                st[i][j] = min(st[i][j - 1], st[i + (1 << (j - 1))][j - 1]);
            }
        }
    }

    int get(int l, int r) {
        if (l >= r) return INF;
        return min(st[l][logs[r - l]], st[r - (1 << logs[r - l])][logs[r - l]]);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<string> a(k);
    for (auto &c : a) cin >> c;
    string s;
    cin >> s;
    vector<vector<int>> dp(n, vector<int>(n));
    for (int i = 0; i < n; i++) dp[i][i] = 1;
    vector<vector<int>> gist(k);
    vector<int> p(n, -1);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k; j++) {
            if (gist[j].size() && a[j][s[i] - 'a'] == '1') p[i] = max(p[i], gist[j].back());
        }
        gist[s[i] - 'a'].pb(i);
    }
    Sparse_Table st(p);
    for (int l = 0; l < n; l++) {
        for (int r = l + 1; r < n; r++) {
            if (p[r] < l || st.get(p[r] + 1, r) < p[r]) break;
            dp[l][r] = 1;
            //cout << l << " " << r << endl;
        }
    }
    vector<string> dp1(n + 1);
    for (int i = n - 1; i >= 0; i--) {
        dp1[i] = 'z' + 1;
        for (int r = i; r < n; r++) {
            if (dp[i][r]) {
                dp1[i] = min(dp1[i], s[i] + dp1[r + 1]);
            }
        }
    }
    cout << dp1[0];
    return 0;
}
/*
3 5
010
001
100
bcacb
*/
