#include <bits/stdc++.h>

using namespace std;

#define pb emplace_back
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define ll long long
#define ld long double
#define pii pair<int, int>

const int MAXN = 1e5 + 10;

vector<vector<int>> g;
vector<pii> a;
vector<vector<int>> order;

void dfs(int v, bool &ok) {
    if (!ok) return;
    if ((int)g[v].size() == 0) return;
    for (auto &to : g[v]) {
        dfs(to, ok);
        if (!ok) return;
    }
    vector<pair<pii, int>> seg;
    for (auto &to : g[v]) {
        seg.pb(a[to], to);
    }
    sort(all(seg));
    for (int i = 0; i + 1 < (int)seg.size(); i++) {
        if (seg[i].fi.se >= seg[i + 1].fi.fi) {
            ok = 0;
            break;
        }
    }
    a[v].fi = seg[0].fi.fi;
    a[v].se = seg.back().fi.se;
    for (auto &c : seg) order[v].pb(c.se);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<pii> l;
    vector<int> leaf(n);
    g.resize(n);
    int M = 0;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            while (k--) {
                int j;
                cin >> j; j--;
                g[i].pb(j);
            }
        } else {
            int m;
            cin >> m;
            M += m;
            while (m--) {
                int x;
                cin >> x;
                l.pb(x, i);
            }
            leaf[i] = 1;
        }
    }
    sort(all(l));
    for (int mask = 0; mask < (1 << M); mask++) {
        vector<int> cnt(n);
        for (int i = 0; i < M; i++) {
            if (mask & (1 << i)) cnt[l[i].se]++;
        }
        bool ok = 1;
        for (int i = 0; i < n; i++) {
            if (leaf[i]) {
                if (cnt[i] != 1) ok = 0;
            }
        }
        if (!ok) continue;
        a.clear();
        a.resize(n);
        order.clear();
        order.resize(n);
        for (int i = 0; i < M; i++) {
            if (mask & (1 << i)) {
                a[l[i].se].fi = a[l[i].se].se = i;
            }
        }
        dfs(0, ok);
        if (!ok) continue;
        cout << "Yes\n";
        for (int i = 0; i < n; i++) {
            if (leaf[i]) {
                cout << l[a[i].fi].fi << "\n";
            } else {
                for (auto &to : order[i]) cout << to + 1 << " ";
                cout << "\n";
            }
        }
        return 0;
    }
    cout << "No";
    return 0;
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92
*/
/*
3
1 2 2 3
2 1 1
2 1 2
*/
