#include <bits/stdc++.h>

using namespace std;

#define pb emplace_back
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define ll long long
#define ld long double
#define pii pair<int, int>

const int MAXN = 1e5 + 10;
const int INF = 1e9 + 1;

vector<vector<int>> g;
vector<vector<int>> dp;
vector<vector<int>> order;

int M = 0;

void dfs(int v) {
    if ((int)g[v].size() == 0) return;
    for (auto &to : g[v]) dfs(to);
    if ((int)g[v].size() == 1) {
        dp[v] = dp[g[v][0]];
        return;
    }
    for (int l = 0; l < M; l++) {
        if (dp[g[v][1]][l] != INF && dp[v][l] > dp[g[v][0]][dp[g[v][1]][l]]) {
            dp[v][l] = dp[g[v][0]][dp[g[v][1]][l]];
            order[v][l] = 1;
        }
        if (dp[g[v][0]][l] != INF && dp[v][l] > dp[g[v][1]][dp[g[v][0]][l]]) {
            dp[v][l] = dp[g[v][1]][dp[g[v][0]][l]];
            order[v][l] = 0;
        }
    }
}

void dfs1(int v, int l, vector<int> &a) {
    if ((int)g[v].size() == 0) {
        a[v] = dp[v][l];
        return;
    }
    a[v] = l;
    if ((int)g[v].size() == 1) {
        dfs1(g[v][0], l, a);
        return;
    }
    if (order[v][l] == 0) {
        dfs1(g[v][0], l, a);
        dfs1(g[v][1], dp[g[v][0]][l], a);
    } else {
        dfs1(g[v][1], l, a);
        dfs1(g[v][0], dp[g[v][1]][l], a);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<pii> l;
    vector<int> leaf(n);
    g.resize(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            while (k--) {
                int j;
                cin >> j; j--;
                g[i].pb(j);
            }
        } else {
            int m;
            cin >> m;
            M += m;
            while (m--) {
                int x;
                cin >> x;
                l.pb(x, i);
            }
            leaf[i] = 1;
        }
    }
    sort(all(l));
    dp.assign(n, vector<int>(M, INF));
    for (int i = 0; i < M; i++) {
        for (int j = i; j >= 0; j--) {
            dp[l[i].se][j] = min(dp[l[i].se][j], i);
        }
    }
    order.assign(n, vector<int>(n, -1));
    dfs(0);
    for (int le = 0; le < M; le++) {
        if (dp[0][le] != INF) {
            cout << "Yes\n";
            vector<int> a(n);
            dfs1(0, le, a);
            for (int i = 0; i < n; i++) {
                if (leaf[i]) {
                    cout << l[a[i]].fi << "\n";
                } else {
                    if ((int)g[i].size() == 1) {
                        cout << g[i][0] + 1 << "\n";
                    } else {
                        if (order[i][a[i]] == 0) {
                            cout << g[i][0] + 1 << " " << g[i][1] + 1 << "\n";
                        } else {
                            cout << g[i][1] + 1 << " " << g[i][0] + 1 << "\n";
                        }
                    }
                }
            }
            return 0;
        }
    }
    cout << "No";
    return 0;
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92
*/
/*
3
1 2 2 3
2 1 1
2 1 2
*/
