#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second

const int MAXN = 131072 * 4;

string dodo[MAXN << 1];

string gg(string a, string b) {
    if (a == "-1")
        return b;
    if (b == "-1")
        return a;
    return min(a, b);
}

string get(int le, int re, int v = 1, int lb = 0, int rb = MAXN) {
    if (le <= lb && rb <= re)
        return dodo[v];
    if (re <= lb || rb <= le)
        return "-1";
    return gg(get(le, re, v + v, lb, (lb + rb) >> 1), get(le, re, v + v + 1, (lb + rb) >> 1, rb));
}


void solve() {
    for (int i = 0; i < MAXN + MAXN; ++i)
        dodo[i] = "";
    int k, n;
    cin >> k >> n;
    vector<vector<int>> may(k, vector<int> (k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char x;
            cin >> x;
            may[i][j] = x - '0';
        }
    }
    string s;
    cin >> s;
    vector<pair<int, char>> v;
    vector<int> jump(n);

    for (int i = n - 1; i >= 0; --i) {
        while (v.size() && may[s[i] - 'a'][v.back().y - 'a'])
            v.pop_back();
        if (v.size()) {
            jump[i] = v.back().x;
        } else {
            jump[i] = MAXN;
        }
        v.push_back({i, s[i]});
    }
    for (int i = n - 1; i >= 0; --i) {
        string my = s[i] + get(i + 1, jump[i] + 1);
        dodo[i + MAXN] = my;
        int pos = i + MAXN;
        while (pos > 1) {
            pos /= 2;
            dodo[pos] = gg(dodo[pos + pos], dodo[pos + pos + 1]);

        }
    }
    cout << dodo[MAXN] << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}
