#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>

#define IO
#define endl '\n'
#define int long long
#define float long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

int n;

vector<vector<int>> g, ms;
vector<int> mms;

int ans = 0;

bool operator<(const vector<int> &a, const vector<int> &b) {
	return a.front() < b.front();
}

vector<int> dfs(int i) {
	if (g[i].empty()) {
		return vector<int>(1, mms[i]);
	}
	vector<vector<int>> v;
	for (const int &j : g[i]) {
		v.push_back(dfs(j));
	}
	sort(all(v));
	vector<int> z;
	for (int i = 0; i < v.size(); ++i) {
		for (int j = 0; j < v[i].size(); ++j) {
			z.push_back(v[i][j]);
		}
	}
	return z;
}

void f(int i) {
	for (; i < n && ms[i].empty(); ++i) {}
	if (i == n) {
		vector<int> v = dfs(0);
		if (is_sorted(all(v))) {
			ans = 1;
		}
		return;
	}
	for (int j = 0; j < ms[i].size(); ++j) {
		mms[i] = ms[i][j];
		f(i + 1);
	}
}

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
#ifdef IO
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	cin >> n;
	g.resize(n);
	ms.resize(n);
	mms.assign(n, -1);
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int a;
				cin >> a;
				--a;
				g[i].push_back(a);
			}
		} else {
			int m;
			cin >> m;
			for (int j = 0; j < m; ++j) {
				int a;
				cin >> a;
				ms[i].push_back(a);
			}
		}
	}
	f(0);
	if (ans) {
		cout << "Yes" << endl;
	} else {
		cout << "No" << endl;
	}
	return 0;
}