#include <bits/stdc++.h>

#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())

typedef long long ll;
typedef long double ld;

const char nl = '\n';

const ll inf = 1e9;
const ll inf2 = 1e18;
const ld eps = 1e-9;
const ll mod = 1e9+7;

const ll maxn = 1e4 + 5, maxm = 1e6;

using namespace std;

vector<int> c[maxn][26];

int main() {
	FAST;
	
	int k, n;
	cin >> k >> n;
	
	vector<vector<bool>> g(k, vector<bool>(k));
	for (int i = 0; i < k; i++) {
		string ts;
		cin >> ts;
		for (int j = 0; j < k; j++) {
			g[i][j] = (ts[j] == '1');
		}
	}
	
	string s;
	cin >> s;
	
	vector<int> dp(n, 0); // store the furthest reachable index
	dp[n - 1] = n - 1;
	for (int i = n - 2; i >= 0; i--) {
		dp[i] = i;
		vector<int> ma(k, -1);
			
		for (int j = i + 1; j < n; j++) {
			if (g[s[i] - 'a'][s[j] - 'a'] || dp[i] >= j) {
				dp[i] = max(dp[i], dp[j]);
			} else {
				break;
			}
		}
	}
	
	vector<int> d(n, k);
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < min(n, dp[i] + 2); j++) {
			c[i][s[j] - 'a'].push_back(j);
			d[i] = min(d[i], s[j] - 'a');
		}
	}

	string ans;
	ans += s[0];
	vector<int> v = {0};
	while(true) {
		int bk = k;
		
		for (auto x: v) {
			if (dp[x] == n - 1) {
				bk = -1;
				break;
			}
			bk = min(bk, d[x]);
		}
		
		if (bk < 0) {
			cout << ans << nl;
			return 0;
		}
		vector<bool> good(n, false);
		ans += (char)(bk + 'a');
		for (auto x: v) {
			for (int i: c[x][bk]) {
				good[i] = true;
			}
		}
		v.clear();
		for (int i = 0; i < n; i++) {
			if (good[i]) v.push_back(i);
		}
	}
}
