#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define int long long
#define double long double

using namespace std;
using namespace __gnu_pbds;

typedef pair<int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

const int NMAX = 200010, MMAX = 200010, KMAX = 200010;

string s;

set<int> bad[NMAX];

vector<int> good[NMAX];
vector<int> col[NMAX];

int ans[NMAX];

deque<int> g;

vector<int> used;

void solve_solve_solve() {
    int n, m;
    cin >> n >> m >> s;

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;

        for (int j = 0; j < k; j++) {

            int x;
            char y;
            cin >> x >> y;

            x--;

            //cout << "OK " << x << " " << y << " " << s[x] << "\n\n";

            if (y == s[x]) {
                good[i].pub(x);
            } else {
                bad[i].insert(x);
                col[x].pub(i);
            }
        }
    }

    /*

    cout << "bad = \n";
    for (int i = 0; i < n; i++) {
        for (int j : bad[i]) {
            cout << j << "" ;
        }
        cout << "\n";
    }
    cout << "END\n";

    */

    g.clear();
    for (int i = 0; i < n; i++) {
        if (bad[i].empty()) {
            g.pub(i);
        }
    }

    /*

    cout << "GPPD = \n";
    for (int i : g) {
        cout << i << " ";
    }
    cout << "\n";

    */

    memset(ans, -1, sizeof(ans));

    int ind_ans = 0;
    while (!g.empty()) {
        int ind = g.front();
        g.pof();

        ans[ind_ans++] = ind;

        for (int i : good[ind]) {
            for (int j : col[i]) {
                bad[j].erase(i);
                if (bad[j].empty()) {
                    g.pub(j);
                }
            }
            col[i].clear();
        }
    }

    if (ind_ans != n) {
        cout << "-1\n";
        exit(0);
    }
    /*
    for (int i = 0; i < n; i++) {
        if (ans[i] == -1) {
            cout << 100 / 0 << "\n";
            exit(9);
        }
    }
    */

    used.assign(n, 0);

    for (int i = 0; i < n; i++) {
        for (int j : good[i]) {
            //cout << "OK " << i << " " << j << " " << n << "\n";
            used[j] = 1;
        }
    }
   /*
    for (int i : used) {
        if (!i) {
            cout << "-1\n";
            exit(0);
        }
    }    */

    for (int i = 0; i < n; i++) {
        cout << ans[i] + 1 << " ";
    }
    cout << "\n";
}


signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(0), cout.tie(0);

    int Q = 1;
    //cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
