#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    string s;
    vector <pair <string, int>> words(n, {string(m, ' '), -1});
    cin >> s;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        words[i].second = i;
        for (int j = 0; j < k; ++j) {
            int a;
            char c;
            cin >> a >> c;
            (words[i].first)[a - 1] = c;
        }
    }
    vector <int> res(n, -1);
    int end = 1;
    for (int i = 2; i <= n; ++i) {
        end *= i;
    }
    for (int count = 0; count < end; ++count) {
        bool good = true;
        for (int j = 0; j < m && good; ++j) {
            for (int i = 0; i < n; ++i) {
                if ((words[i].first)[j] == s[j]) {
                    break;
                }
                if ((words[i].first)[j] != s[j] and (words[i].first)[j] != ' ') {
                    good = false;
                    break;
                }
            }
        }
        if (good) {
            for (int i = 0; i < n; ++i) {
                res[i] = words[i].second;
            }
        }
        next_permutation(words.begin(), words.end());
    }
    if (res[0] == -1) {
        cout << -1;
    }
    else {
        for (int p: res) {
            cout << p + 1 << ' ';
        }
    }
}
