#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    string s;
    vector <pair <string, int>> words1(n, {string(m, '0'), -1});
    vector <string> words(n, string(m, ' '));
    cin >> s;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        words1[i].second = i;
        for (int j = 0; j < k; ++j) {
            int a;
            char c;
            cin >> a >> c;
            if (c == s[a - 1] || c == ' ') {
                (words1[i].first)[a - 1] = '0';
            }
            else {
                (words1[i].first)[a - 1] = '1';
            }
            words[i][a - 1] = c;
        }
    }
    sort(words1.begin(), words1.end());
    bool good = true;
    for (int j = 0; j < m && good; ++j) {
        bool found = false;
        for (int i = 0; i < n; ++i) {
            int p = words1[i].second;
            if (words[p][j] == s[j]) {
                found = true;
                break;
            }
            if (words[p][j] != s[j] and words[p][j] != ' ') {
                good = false;
                break;
            }
        }
        if (!found) good = false;
    }
    if (good) {
        for (int i = 0; i < n; ++i) {
            cout << words1[i].second + 1 << ' ';
        }
    }
    else cout << -1;
}
