_alf = 'abcdefghijklmnopqrstuvwxyz'

k, n = map(int, input().split())
A = [list(map(int, input())) for _ in range(k)]
s = list(map(_alf.index, input()))

dp_lexn = [None] * n
dp_sec = [None] * n

dp_sec[-1] = {None}

def mkey(a):
    res = ''
    while a is not None:
        res += _alf[s[a]]
        a = dp_lexn[a]
    return res

def mmin(a, b):
    rs = [a, b]
    while True:
        if a is None:
            return rs[0]
        if b is None:
            return rs[1]
        if s[a] > s[b]:
            return rs[1]
        if s[a] < s[b]:
            return rs[0]
        a, b = dp_lexn[a], dp_lexn[b]

def mm(x, *args):
    for arg in args:
        x = mmin(x, arg)
    return x

def update_lexn(ind):
    dp_lexn[ind] = mm(*dp_sec[ind])

def update_sec(ind):
    dp_sec[ind] = set()
    queue = [ind + 1]
    while queue:
        el = queue.pop(0)
        if el not in dp_sec[ind]:
            dp_sec[ind].add(el)
            if el is not None:
                if A[s[ind]][s[el]]:
                    queue.extend(list(dp_sec[el]))


for i in reversed(range(n - 1)):
    update_sec(i)
    update_lexn(i)
print(mkey(0))
