#include <iostream>
#include <string>
#include <unordered_map>
#include <algorithm>
#include <utility>

#define maxN 100000

long long n, m, k, a, perfocards[maxN];
char c;
bool check[maxN];
std::string s;
std::unordered_map<long long, std::unordered_map<long long, long long>> dict;

bool comp(long long a, long long b) {
	long long s1 = 0, s2 = 0;
	for (long long i = 0; i < m; i++) {
		if (dict.find(a) == dict.end() || dict[a].find(i) == dict[a].end()) {
			s1 = 0;
		}
		else if (dict[a][i] == s[i] - 'a' + 1) {
			s1 = 1;
		}
		else {
			s1 = 2;
		}
		if (dict.find(b) == dict.end() || dict[b].find(i) == dict[b].end()) {
			s2 = 0;
		}
		else if (dict[b][i] == s[i] - 'a' + 1) {
			s2 = 1;
		}
		else {
			s2 = 2;
		}
		if (s1 < s2) {
			return true;
		}
		else if (s1 > s2) {
			return false;
		}
	}
	return true;
}

int main() {
	std::cin >> n >> m >> s;
	for (long long i = 0; i < n; i++) {
		std::cin >> k;
		perfocards[i] = i;
		for (long long j = 0; j < k; j++) {
			std::cin >> a >> c;
			dict[i][a - 1] = c - 'a' + 1;
		}
	}
	std::sort(perfocards, perfocards + n, comp);
	for (long long i = 0; i < n; i++) {
		for (std::pair<long long, long long> ans : dict[perfocards[i]]) {
			if (!check[ans.first] && ans.second != s[ans.first] - 'a' + 1) {
				std::cout << -1 << std::endl;
				return 0;
			}
			if (ans.second == s[ans.first] - 'a' + 1) {
				check[ans.first] = true;
			}
		}
	}
	for (long long i = 0; i < n; i++) {
		std::cout << perfocards[i] + 1 << " ";
	}
	std::cout << std::endl;
	return 0;
}