#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define print(x) {for (auto xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}

void ask(int i, int j) {
    if (i == -1) {
        cout << "0" << endl;
        exit(0);
    }
    cout << i + 1 << ' ' << j + 1 << endl;
}

bool check(int x, int y, char c) {
    return ((c == '0' && x < y) || (c == '1' && x > y));
}

mt19937 rng(1337);

void solve() {
    int type; cin >> type;
    int n, k, m; cin >> n >> k >> m;
    int id = 0;
    if (type == 1) {
        string s; cin >> s;
        bool st = true;
        while (true) {
            bool cur = st;
            vector < vector <int> > a(n, vector <int> (n, 0));
            bool fst = true;
            while (true) {
                int x, y;
                if (cur) {
                    if (id >= m && fst) {
                        ask(-1, -1);
                    }
                    fst = false;
                    bool br = false;
                    int X, Y;
                    vector <int> p(n);
                    for (int i = 0; i < n; i ++) {
                        p[i] = i;
                    }
                    reverse(all(p));
                    for (int sum = 2*n - 2; sum >= 0 && !br; sum--) {
                        //shuffle(all(p), rng);
                        for (auto x : p) {
                            y = sum - x;
                            if (y < 0 || y >= n)
                                continue;
                            if (a[x][y] == 0 && (id >= m || check(x, y, s[id]))) {
                                ask(x, y);
                                X = x;
                                Y = y;
                                br = true;
                                id++;
                            }
                        }
                    }
                    x = X, y = Y;
                    if (!br) {
                        bool ff = false;
                        for (int i = n - 1; i >= 0; i--) {
                            if (a[i][i] == 0) {
                                ask(i, i);
                                x = y = i;
                                ff = (i == 0);
                                break;
                            }
                        }
                        if (ff)
                            break;
                    }
                } else {
                    cin >> x >> y;
                    x--, y--;
                    if (x == 0 && y == 0) {
                        break;
                    }
                }
                for (int i = x; i < n; i++) {
                    for (int j = y; j < n; j++) {
                        a[i][j] = 1;
                    }
                }
                cur ^= 1;
            }
            st ^= 1;
        }
    } else {
        int g; cin >> g;
        int x, y;
        string ans;
        bool st = true;
        while (g > 0) {
            bool cur = st;
            g--;
            while (true) {
                int x, y; cin >> x >> y;
                if (x == 1 && y == 1)
                    break;
                if (cur && (x != y)) {
                    ans += '0' + (x > y);
                }
                cur ^= 1;
            }
            st ^= 1;
        }
        cout << ans.substr(0, m) << endl;
    }
}

signed main() {
    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}