#include <bits/stdc++.h>

#define eb emplace_back
#define x first
#define y second

using namespace std;

void chmin(string& a, const string& b) {
    int n = min(a.size(), b.size());
    for (int i = 0; i < n; i++){
        if (a[i] > b[i]) {
            a = b;
            return;
        }
        if (a[i] < b[i]) return;
    }
    if (a.size() > b.size()){
        a = b;
    }
}


const int MAXN = 500100;

int k, n;
int a[26][26];
string s;

void read(){
    cin >> k >> n;
    for (int i = 0; i < k; i++){
        string s2;
        cin >> s2;
        for (int j = 0; j < k; j++){
            if (s2[j] == '1') a[i][j] = 1;
        }
    }
    cin >> s;
}

int ci(char c){
    return (int)(c - 'a');
}

int used[MAXN];
int p[MAXN];
int last[MAXN];

void solve() {
    read();

    vector<pair<int, char>> st;
    for (int i = n - 1; i > -1; i--){
        last[i] = n;
        while (!st.empty() && a[ci(s[i])][ci(st.back().y)]){
            //cerr << i << ' ' << s[i] << ' ' << st.back().y << ' ' << a[ci(s[i])][ci(st.back().y)] << '\n';
            used[st.back().x] = 1;
            st.pop_back();
            //continue;
        }
        if (!st.empty()){
            last[i] = st.back().x;
        }
        st.eb(i, s[i]);
    }

    for (int i = 0; i < n; i++){
        if (!used[i]) p[i]++;
        if (i > 0) p[i] += p[i-1];
    }

    //for (int i = 0; i < n; i++){
    //    cerr << last[i] << ' ';
    //}
    //cerr << '\n';

    string ans = "";
    int curi = -1;
    for (int i = 0; i < n; i++){
        if (curi > -1 && last[curi] == n) break;
        for (int j = 0; j < k; j++){
            int cool = -1;
            for (int w = curi + 1; w < n; w++){
                if (ci(s[w]) == j){
                    cool = w;
                    break;
                }
            }
            if (cool == -1) continue;
            if (curi == -1 && j != ci(s[0])) continue;
            if (curi != -1 && last[curi] < cool) continue;
            curi = cool;
            ans += (char)(j + 'a');
            break;
        }
        //cerr << curi << '\n';
    }

    cout << ans << '\n';
}

string dp[MAXN];
void solve2() {
    read();

    string ans = s;
    dp[n] = "";
    for (int i = n-1; i > -1; i--){
        dp[i] = s[i] + dp[i+1];
    }
    for (int i = n - 1; i > -1; i--){
        for (int w = n; w > i; w--) {

            vector<pair<int, char>> st;
            for (int j = w - 1; j >= i; j--) {
                while (!st.empty() && a[ci(s[j])][ci(st.back().y)]) {
                    st.pop_back();
                }
                st.eb(j, s[j]);
            }

            if (st.size() > 1) continue;

            string cur = s[i] + dp[w];
            chmin(dp[i], cur);
        }
        //cerr << i << ' '<< dp[i] << '\n';
    }


    cout << dp[0] << '\n';
}

void solve3() {
    read();

    string ans = s;
    for (int msk = 0; msk < (1 << n); msk++){
        int ok = 1;
        for (int j = 0; j < n; j++){
            if ((msk >> j) & 1){
                if (j == 0 || !a[ci(s[j-1])][ci(s[j])]) ok = 0;
            }
        }
        if (!ok) continue;
        string cur = "";
        for (int j = 0; j < n; j++){
            if ((msk >> j) & 1){
                continue;
            }
            cur += s[j];
        }
        chmin(ans, cur);
    }

    cout << ans << '\n';
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve2();

    return 0;
}

/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
 */
