#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
#include <string>
using namespace std;
#pragma GCC optimize("O3")
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double

const int mod = 1e9 + 7;
int n;
vector <vector <int>> dp;
string ans = "", s;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	int k; cin >> k >> n;
	vector <string> a(k);
	for (auto& x : a) cin >> x;
	cin >> s;
	dp.resize(n, vector <int>(n));
	for (int len = 0; len < n; ++len) {
		for (int l = 1; l < n - len; ++l) {
			int r = l + len;
			dp[l][r] = 0;
			if (!len) {
				if (a[s[l - 1] - 'a'][s[l] - 'a'] == '1')
					dp[l][l] = 1;
			}
			else {
				for (int j = r - 1; j >= l - 1; --j) {
					if (a[s[j] - 'a'][s[r] - 'a'] != '1') continue;
					if ((j + 1 > r - 1 or dp[j + 1][r - 1]) and (l > j or dp[l][j]))
						dp[l][r] = true;
				}
			}
		}
	}
	
	vector <string> dp2(n, string(n, 'z'));
	dp2.back() = s.back();
	for (int i = n - 2; i >= 0; --i) {
		if (dp[i + 1][n - 1]) dp2[i] = s[i];
		else {
			vector <int> ok = {};
			for (int j = i + 1; j < n; ++j) {
				if (dp[i + 1][j - 1] or i + 1 > j - 1) {
					if (ok.empty()) ok.push_back(j);
					else {
						if (s[ok[0]] > s[j]) ok = { j };
						else if (s[ok[0]] == s[j]) ok.push_back(j);
					}
				}
			}
			for (auto& x : ok)
				dp2[i] = min(dp2[i], s[i] + dp2[x]);
		}
	}
	cout << dp2[0] << '\n';
}
/*
3 5
010
001
100
bcacb

3 7
010
001
100
abacaba
*/
