#include <bits/stdc++.h>
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()

using namespace std;

void solve1(), solve2();

signed main() {
    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);
    int type;
    cin >> type;
    if (type == 1)
        solve1();
    else
        solve2();
    return 0;
}

bitset <33> used[33];

bool check(int x, int y) {
    if (x <= 32 && y <= 32)
        return true;
    return false;
}

int dx[2] = {0, 1};
int dy[2] = {1, 0};

void dfs(int x, int y) {
    used[x][y] = 1;
    for (int i = 0; i < 2; ++i) {
        int xx = x + dx[i], yy = y + dy[i];
        if (check(xx, yy) && !used[xx][yy])
            dfs(xx, yy);
    }
}

string s;

void solve1() {
    int n, k, m;
    cin >> n >> k >> m;
    cin >> s;
    bool f;
    int x, y;
    bool p = true;
    for (int z = 0; z < sz(s); ++z) {
        if (s[z] == '1') {
            f = false;
            for (int i = 32; i >= 1; --i) {
                for (int j = i - 1; j >= 1; --j) {
                    if (!used[i][j]) {
                        cout << i << " " << j << endl;
                        dfs(i, j);
                        f = true;
                        break;
                    }
                }
                if (f)
                    break;
            }
            if (!f) {
                cout << "1 1" << endl;
                for (int i = 1; i <= 32; ++i)
                    used[i] = 0;
                if (p) {
                    cin >> x >> y;
                    dfs(x, y);
                }
                p ^= 1;
            } else {
                cin >> x >> y;
                if (x == 1 && y == 1) {
                    for (int i = 1; i <= 32; ++i)
                        used[i] = 0;
                    if (p) {
                        cin >> x >> y;
                        dfs(x, y);
                        p ^= 1;
                    } else {
                        p ^= 1;
                        continue;
                    }
                } else {
                    dfs(x, y);
                }
            }
        } else {
            f = false;
            for (int i = 32; i >= 1; --i) {
                for (int j = 32; j >= i + 1; --j) {
                    if (!used[i][j]) {
                        cout << i << " " << j << endl;
                        dfs(i, j);
                        f = true;
                        break;
                    }
                }
                if (f)
                    break;
            }
            if (!f) {
                cout << "1 1" << endl;
                for (int i = 1; i <= 32; ++i)
                    used[i] = 0;
                if (p) {
                    cin >> x >> y;
                    dfs(x, y);
                }
                p ^= 1;
            } else {
                cin >> x >> y;
                if (x == 1 && y == 1) {
                    for (int i = 1; i <= 32; ++i)
                        used[i] = 0;
                    if (p) {
                        cin >> x >> y;
                        dfs(x, y);
                        p ^= 1;
                    } else {
                        p ^= 1;
                        continue;
                    }
                } else {
                    dfs(x, y);
                }
            }
        }
    }
    cout << 1 << " " << 1 << endl;
    if (p) {
        cin >> x >> y;
        cout << 0 << endl;
    } else {
        cout << 0 << endl;
    }
}

void solve2() {
    int n, k, m, t, x, y;
    cin >> n >> k >> m;
    cin >> t;
    bool p = true, f = true;
    while (cin >> x >> y) {
        if (f) {
            if (y < x)
                s.pb('1');
            else if (y > x)
                s.pb('0');
        }
        if (x == 1 && y == 1) {
            if (p)
                f = false;
            else
                f = true;
            p ^= 1;
        }
        f ^= 1;
        if (sz(s) == m)
            break;
    }
    cout << s << endl;
}
/*/
31 32
1 1
31 32
32 31
1 1
31 32
1 1
31 32
30 32
1 1
32 31
1 1
31 32
1 1
0
/*/
