#include<bits/stdc++.h>
using namespace std;

const int MAXN = 110;
char inp[MAXN][MAXN];
bool used[MAXN];
bool fil[MAXN];

void solve() {
    int n, m;
    string s;
    cin >> n >> m >> s;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            inp[i][j] = ' ';
        }
    }
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            char t;
            cin >> x >> t;
            inp[i][x - 1] = t;
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        int ok = -1;
        for (int j = 0; j < n; ++j) {
            if (!used[j]) {
                bool fl = true;
                for (int k = 0; k < m; ++k) {
                    if (!fil[k] && inp[j][k] != ' ') {
                        fl &= inp[j][k] == s[k];
                    }
                    if (!fl) break;
                }
                if (fl) {
                    ok = j;
                    break;
                }
            }
        }
        if (ok == -1) {
            cout << "-1\n";
            return;
        }
        ans.push_back(ok);
        used[ok] = true;
        for (int k = 0; k < m; ++k) {
            if (!fil[k] && inp[ok][k] != ' ') fil[k] = true;
        }
    }
    for (int i = 0; i < m; ++i) {
        if (!fil[i]) {
            cout << "-1\n";
            return;
        }
    }
    for (auto it : ans) {
        cout << it + 1 << " ";
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            cout << i + 1 << " ";
        }
    }
    cout << "\n";
}

/*
3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f


2 2
aa
2 1 a 2 b
2 1 b 2 a
*/

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
