#include <iostream>
#include <vector>
#include <set>
#include <cassert>
#include <string>
#include <algorithm>


using namespace std;


#pragma warning(disable:4996)
#define x first
#define y second


bool mat[26][26];
bool can[2001][2001];
bool dp1[2001];
bool dp2[2001];


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	assert(freopen("input.txt", "r", stdin));
#endif
	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			char el;
			cin >> el;
			if (el == '1')
				mat[i][j] = 1;
		}
	}
	string s;
	cin >> s;
	for (int i = 0; i < n; i++)
		can[i][i] = 1;
	for (int ln = 2; ln <= n; ln++) {
		for (int i = 0; i < n - ln + 1; i++) {
			int j = i + ln - 1;
			if (can[i][j - 1] && mat[s[i] - 'a'][s[j] - 'a']) {
				can[i][j] = 1;
				continue;
			}
			for (int k = i + 1; k < j; k++)
				if (can[i][k] && can[k][j]) {
					can[i][j] = 1;
					break;
				}
		}
	}
	if (can[0][n - 1]) {
		cout << s[0] << endl;
		return 0;
	}
	string ans = "";
	ans += s[0];
	dp1[0] = 1;
	while (1) {
		for (char x = 0; x < k; x++) {
			bool f = 0;
			for (int i = 0; i < n; i++) {
				if (dp1[i] == 1) {
					for (int j = i + 1; j < n; j++) {
						if (can[i][j - 1] && s[j] - 'a' == x) {
							f = 1;
							break;
						}
					}
				}
				if (f == 1)
					break;
			}
			if (f == 1) {
				ans += 'a' + x;
				for (int i = 0; i < n; i++) {
					if (dp1[i] == 1) {
						for (int j = i + 1; j < n; j++) {
							if (can[i][j - 1] && s[j] - 'a' == x) {
								dp2[j] = 1;
								if (can[j][n - 1]) {
									cout << ans;
									return 0;
								}
							}
						}
					}
				}
				for (int i = 0; i < n; i++) {
					dp1[i] = dp2[i];
					dp2[i] = 0;
				}
				break;
			}
		}
	}
	cout << ans;
	return 0;
}