#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#pragma GCC target("avx2")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unrol-loops")

typedef long long ll;
typedef long double ld;
/*
typedef tree <
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
*/

#define pb push_back
#define _ << " " <<
#define ff first
#define ss second

#ifdef LOCAL
    #define err cerr
#else
    #define err if (0) cerr
#endif // LOCAL

const int N = 1e5 + 10;

vector<int> g[N];
vector<int> gt[N];

int ind = 0;
vector<int> ans(N);
vector<int> used(N);

void dfs(int v) {
    err << "!" _ v << endl;

    used[v] = 1;
    for (auto to : gt[v]) {
        if (used[to] == 1) {
            used[v] = 0;
            return;
        }

        if (used[to] == 0) {
            dfs(to);
            if (used[to] != 2) {
                cout << -1;
                exit(0);
            }
        }
    }
    err << "^^^" _ v << endl;
    used[v] = 2;
    ans[ind] = v + 1;
    ++ind;
    for (auto to : g[v]) {
        if (used[to] == 0) {
            dfs(to);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    string s;
    cin >> s;

    int k, c;
    char a;
    vector<vector<int> > v(m, vector<int>());
    vector<vector<pair<int, char> > > arr(n, vector<pair<int, char> >());
    for (int i = 0; i < n; ++i) {
        cin >> k;
        for (int j = 0; j < k; ++j) {
            cin >> c >> a;
            arr[i].pb({c - 1, a});

            if (s[c - 1] == a) {
                v[c - 1].pb(i);
            }
        }
    }

    for (auto to : v) {
        if (to.size() == 0) {
            cout << -1;
            return;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (auto p : arr[i]) {
            if (s[p.ff] != p.ss) {
                for (auto to : v[p.ff]) {
                    g[to].pb(i);
                    gt[i].pb(to);
                }
            }
        }
    }

    dfs(0);

    vector<int> ret(n);
    for (int i = 0; i < n; ++i) {
        if (ans[i] == 0) {
            cout << -1;
            return;
        }
        ret[i] = ans[i];
    }

    for (auto to : ret) {
        cout << to << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    //freopen("output.txt", "w", stdout);
    //freopen("input.txt", "r", stdin);
#endif // LOCAL

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}




