#include <bits/stdc++.h>

using namespace std;

const int N = 107;

vector<int> g[N];

vector<int> projects[N];
vector<int> cur_project(N);
vector<int> order[N];

int n;

pair<int, int> dfs(int v) {
    order[v].clear();
    if (!projects[v].empty()) {
        return {cur_project[v], cur_project[v]};
    } else {
        vector<pair<pair<int, int>, int>> reports;
        for (auto u : g[v]) {
            pair<int, int> cur_report = dfs(u);
            if (cur_report.first == -1) {
                return {-1, -1};
            }

            reports.emplace_back(cur_report, u);
        }

        sort(reports.begin(), reports.end());

        for (int i = 0; i < reports.size() - 1; ++i) {
            if (reports[i].first.second > reports[i + 1].first.first) {
                return {-1, -1};
            }
        }
        for (auto &report : reports) {
            order[v].push_back(report.second);
        }

        return {reports[0].first.first, reports[reports.size() - 1].first.second};
    }
}

void solve(int cur_bur) {
    if (cur_bur < n) {
        if (projects[cur_bur].empty()) {
            solve(cur_bur + 1);
        } else {
            for (int i = 0; i < projects[cur_bur].size(); ++i) {
                cur_project[cur_bur] = projects[cur_bur][i];
                solve(cur_bur + 1);
            }
        }
    } else {
        pair<int, int> res = dfs(0);
        if (res.first != -1) {
            cout << "Yes\n";
            for (int v = 0; v < n; ++v) {
                if (projects[v].empty()) {
                    for (auto u : order[v]) {
                        cout << u + 1 << ' ';
                    }
                } else {
                    cout << cur_project[v] + 1;
                }
                cout << '\n';
            }
            exit(0);
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    cin >> n;

    for (int i = 0; i < n; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int v;
                cin >> v;
                v--;
                g[i].push_back(v);
            }
        } else {
            int m;
            cin >> m;
            for (int j = 0; j < m; ++j) {
                int x;
                cin >> x;
                x--;
                projects[i].push_back(x);
            }
        }
    }

    solve(0);
    cout << "No";
}