#include <bits/stdc++.h>

using namespace std;

int n, m;

int check(vector<vector<int>> &al) {
    for (int j = 0; j < m; j++) {
        int i = 0;
        while (i < n && al[i][j] == 0) {
            i++;
        }
        if (i == n || al[i][j] == -1) {
            return 0;
        }
    }
    return 1;
}

int main() {
    cin >> n >> m;
    vector<int> s(m);
    vector<vector<int>> al(n, vector<int> (m, 0));
    for (int i = 0; i < m; i++) {
        char t;
        cin >> t;
        s[i] = t - 'a';
    }
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int pos;
            char sym;
            cin >> pos >> sym;
            pos--;
            int ch = sym - 'a';
            if (ch == s[pos]) {
                al[i][pos] = 1;
            } else if (ch != s[pos]) {
                al[i][pos] = -1;
            }
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        ans[i] = i;
    }
    if (check(al)) {
        for (auto t: ans) {
            cout << t + 1 << " ";
        }
        exit(0);
    }
    while (next_permutation(ans.begin(), ans.end())) {
        vector<vector<int>> tmp(n);
        for (int i = 0; i < n; i++) {
            tmp[i] = al[ans[i]];
        }
        if (check(tmp)) {
            for (auto t: ans) {
                cout << t + 1 << " ";
            }
            exit(0);
        }
    }
    cout << -1;
}
