//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>
using namespace std;

#define ioBoost ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr)
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
typedef long long ll;

void solve() {
    vector<vector<bool>> mat;

    int n, k;
    cin >> k >> n;

    mat.resize(k, vector<bool>(k));

    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char now;
            cin >> now;

            mat[i][j] = (now - '0');
        }
    }

    string s;
    cin >> s;

    char inf = (char) ('z' + 5);
    string ins;
    ins += inf;
    vector<string> dp1(n, ins), dp2(n, ins);
    vector<int> p(n, -1);
    dp1[0] = s[0];

    for (int i = 1; i < n; ++i) {
        dp1[i] = min(dp2[i - 1] + s[i], dp1[i - 1] + s[i]);

        for (int j = i - 1; j >= 0; j = p[j]) {
            if (mat[s[j] - 'a'][s[i] - 'a'] == 1) {
                dp2[i] = min(dp2[i], dp1[j]);
                p[i] = j;
                break;
            }
            if (dp2[j] == ins) break;
        }
    }

    cout << min(dp1[n - 1], dp2[n - 1]);
}

signed main() {
    ioBoost;

    solve();

    return 0;
}