#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define em emplace
#define eb emplace_back
#define pb pop_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int randint(int L, int R) {
    return L + rnd() % (R - L + 1);
}

const int N = 35;

bool used[N][N];

int n, k, m;

void do_move(int x, int y) {
    cout << x << " " << y << endl;
    for (int i = 1; i <= x; ++i) {
        for (int j = y; j <= n; ++j) {
            used[i][j] = 1;
        }
    }
}

bool read_move() {
    int x, y;
    cin >> x >> y;
    for (int i = 1; i <= x; ++i) {
        for (int j = y; j <= n; ++j) {
            used[i][j] = 1;
        }
    }
    return x == 1 && y == 1;
}

void clearused() {
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j<= n; ++j) {
            used[i][j] = 0;
        }
    }
}

void end_game() {
    cout << 0 << endl;
}

int32_t main() {
    int type;
    cin >> type;
    if (type == 1) {
        string s;
        cin >> n >> k >> m >> s;
        int pos = -1, i = 0;
        while (pos < m - 1) {
            clearused();
            if (i == 1) read_move();
            bool startmove = i != 1;
            bool ended = false;
            while (pos < m - 1) {
                int x = 0, y = 0;
                for (int i = pos + 1; i < min(m, pos + 6); ++i) {
                    if (s[i] == '1') {
                        x += (1 << (i - pos - 1));
                    }
                }
                pos += 5;
                for (int i = pos + 1; i < min(m, pos + 6); ++i) {
                    if (s[i] == '1') {
                        y += (1 << (i - pos - 1));
                    }
                }
                pos += 5;
                if (!used[x + 1][y + 1]) {
                    do_move(x + 1, y + 1);
                    if (x == 0 && y == 0) {
                        if (!startmove) pos -= 10;
                        ended = true;
                        break;
                    }
                    if (read_move()) {
                        ended = true;
                        break;
                    }
                } else {
                    do_move(1, 1);
                    pos -= 10;
                    ended = true;
                    break;
                }
                startmove = false;
            }
            if (!ended) {
                if (!read_move()) {
                    do_move(1, 1);
                }
            }
            i ^= 1;
        }
        if (i == 1) read_move();
        end_game();
    } else {
        int n, k, m;
        cin >> n >> k >> m;
        int games;
        cin >> games;
        int i = 0;
        string ans;
        while (games--) {
            int moves = 0;
            while (true) {
                int x, y;
                cin >> x >> y;
                if (x == 1 && y == 1) {
                    if (i == 0 && !moves) {
                        for (int p = 0; p < 10; ++p) ans += '0';
                    }
                    break;
                } else {
                    if (i == 0) {
                        --x, --y;
                        for (int p = 0; p < 5; ++p) ans += '0' + (((1 << p) & x) != 0);
                        for (int p = 0; p < 5; ++p) ans += '0' + (((1 << p) & y) != 0);
                    }
                }
                ++moves;
                i ^= 1;
            }
        }
        while (sz(ans) > m) ans.pb();
        cout << ans << endl;
    }
    return 0;
}
