#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define em emplace
#define eb emplace_back
#define pb pop_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int randint(int L, int R) {
    return L + rnd() % (R - L + 1);
}

const int N = 505, M = 505;

int n;
vector<int> g[N];
vector<int> a[N];
bool dp[N][M][M];
int mxdp[N][M], mndp[N][M];
int m;
bool dp1[M][M], newdp[M][M];
pii per[N][M][M];

void dfs(int v) {
    if (g[v].empty()) {
        for (int j = 0; j < sz(a[v]); ++j) {
            dp[v][a[v][j]][a[v][j]] = 1;
            per[v][a[v][j]][a[v][j]] = {a[v][j], -1};
        }
        for (int R = 0; R < m; ++R) {
            mxdp[v][R] = m - 1;
            while (mxdp[v][R] > -1 && !dp[v][mxdp[v][R]][R]) {
                --mxdp[v][R];
            }
        }
        for (int L = 0; L < m; ++L) {
            while (mndp[v][L] < m && !dp[v][L][mndp[v][L]]) {
                ++mndp[v][L];
            }
        }
        return;
    }
    for (int u : g[v]) {
        dfs(u);
    }
    if (sz(g[v]) == 1) {
        for (int L = 0; L < m; ++L) {
            for (int R = L; R < m; ++R) {
                dp[v][L][R] = dp[g[v][0]][L][R];
                per[v][L][R] = {0, -1};
            }
        }
    } else {
        int u1 = g[v][0], u2 = g[v][1];
        for (int L = 0; L < m; ++L) {
            for (int R = L; R < m; ++R) {
                if (mndp[u1][L] < mxdp[u2][R]) {
                    dp[v][L][R] = 1;
                    per[v][L][R] = {0, 1};
                }
                if (mndp[u2][L] < mxdp[u1][R]) {
                    dp[v][L][R] = 1;
                    per[v][L][R] = {1, 0};
                }
            }
        }
    }
    for (int R = 0; R < m; ++R) {
        mxdp[v][R] = m - 1;
        while (mxdp[v][R] > -1 && !dp[v][mxdp[v][R]][R]) {
            --mxdp[v][R];
        }
    }
    for (int L = 0; L < m; ++L) {
        while (mndp[v][L] < m && !dp[v][L][mndp[v][L]]) {
            ++mndp[v][L];
        }
    }
}

bool dp2[10][M];

vector<int> ans[N];

vector<int> diff;

void calc_ans(int v, int nL, int nR) {
    //cerr << v << " " << diff[L] << " " << diff[R] << "\n";
    if (g[v].empty()) {
        ans[v] = {diff[per[v][nL][nR].fi]};
        return;
    }
    vector<int> order = {per[v][nL][nR].fi, per[v][nL][nR].se};
    while (order.back() == -1) order.pb();
    for (int x : order) ans[v].eb(g[v][x]);
    for (int k = 0; k < 10; ++k) {
        for (int R = 0; R < m; ++R) {
            dp2[k][R] = 0;
        }
    }
    int s = g[v][order[0]];
    for (int R = 0; R < m; ++R) {
        dp2[0][R] = dp[s][nL][R];
    }
    for (int i = 1; i < sz(order); ++i) {
        int u = g[v][order[i]];
        for (int R = nL; R < m; ++R) {
            if (!dp2[i - 1][R]) continue;
            for (int R1 = R + 1; R1 < m; ++R1) {
                dp2[i][R1] |= (mxdp[u][R1] > R);
            }
        }
    }
    assert(dp2[sz(order) - 1][nR]);
    int L = nL, R = nR;
    vector<vector<int>> go;
    for (int i = sz(order) - 1; i > 0; --i) {
        int u = g[v][order[i]];
        bool ok = true;
        for (int pR = L; pR < R; ++pR) {
            if (dp2[i - 1][pR] && mxdp[u][R] > pR) {
                go.push_back({u, mxdp[u][R], R});
                ok = false;
                R = pR;
                break;
            }
        }
    }
    go.push_back({s, L, R});
    for (auto x : go) calc_ans(x[0], x[1], x[2]);
}

int32_t main() {
#ifdef WINNER
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // WINNER
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            while (k--) {
                int v;
                cin >> v;
                g[i].eb(v);
            }
        } else {
            int k;
            cin >> k;
            a[i].resize(k);
            for (int j = 0; j < k; ++j) {
                cin >> a[i][j];
                diff.eb(a[i][j]);
            }
        }
    }
    sort(all(diff));
    diff.resize(unique(all(diff)) - diff.begin());
    m = sz(diff);
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < sz(a[i]); ++j) {
            a[i][j] = lower_bound(all(diff), a[i][j]) - diff.begin();
        }
    }
    dfs(1);
    for (int L =0; L < m; ++L) {
        for (int R = L; R < m; ++R) {
            if (dp[1][L][R]) {
                calc_ans(1, L, R);
                cout << "Yes\n";
                for (int i = 1; i <= n; ++i) {
                    for (int x : ans[i]) cout << x << " ";
                    cout << "\n";
                }
                return 0;
            }
        }
    }
    cout << "No\n";
    return 0;
}
