#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using namespace  std;

#define int long long
const int INF = 1e9;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> mat(k, vector<bool>(k, false));
    for (int i =0; i < k; i++){
        for (int j =0 ; j < k; j++){
            char x;
            cin >> x;
            if (x == '1'){
                mat[i][j] = true;
            }
        }
    }
    string s;
    cin >> s;
    vector<int> dp(n, INF), pos(n, -1);
    for (int i =0; i < n; i++){
        //dp[i] = s[i] - 'a';
        pos[i] = -1;
        stack<int> cur;
        cur.push(s[i] - 'a');
        for (int j = i + 1; j < n; j++) {
            while (!cur.empty() && mat[cur.top()][s[j] - 'a'] == 0) {
                cur.pop();
            }
            if (dp[i] > s[j] - 'a') {
                pos[i] = j;
                dp[i] = s[j] - 'a';
            }
            if (cur.empty()) {
                break;
            }
            cur.push(s[j] - 'a');
        }
        if (!cur.empty()){
            pos[i] = n + 1;
        }
    }
    string ans="";
    ans += s[0];
    int cur = pos[0];
    while (cur != n + 1){

        ans += s[cur];
        cur = pos[cur];
    }
    cout << ans;
    return 0;
}
