#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

#pragma GCC optimize("Ofast,unroll-loops")
struct e {
    int l, r;
    string s;
};
vector<vector<bool>> mat;
string s;
void solv2() {
    string cur = s;

    if (mat[1][1]){
        string dop = "";
        dop += s[0];
        for (int i = 1; i < cur.size(); i++){
            if (dop.back() == 'b' && cur[i] == 'b'){
                continue;
            }
            dop += s[i];
        }
        swap(dop, cur);
    }

    if (mat[0][1]){
        string dop = "";
        dop += cur[0];
        for (int i = 1; i < cur.size(); i++){
            if (dop.back() == 'a' && cur[i] == 'b'){
                continue;
            }
            dop.push_back(cur[i]);
        }
        swap(dop, cur);
    }

    if (mat[0][0]) {
        while (cur.size() >= 2 && cur[cur.size() - 1] == 'a' && cur[cur.size() - 2] == 'a') {
            cur.pop_back();
        }
    }
    if (mat[1][0]){
        int pos = cur.size();
        for (int i = cur.size() - 1; i >= 0; i--){
            if (cur[i] == 'b'){
                pos = i + 1;
                break;
            }
        }
        string dop = "";
        for (int  i= 0; i < pos; i++){
            dop += cur[i];
        }
        swap(cur, dop);
    }

    cout << cur;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int k, n;
    cin >> k >> n;
    mat.assign(k, vector<bool>(k, false));
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char x;
            cin >> x;
            if (x == '1') {
                mat[i][j] = true;
            }
        }
    }
    cin >> s;
    s += ' ';
    if (k == 1) {
        if (mat[0][0]) {
            cout << "a";
        } else {
            cout << s;
        }
        return 0;
    }
    if (k == 2) {
        solv2();
        return 0;
    }
    vector<string> dp(n + 1, "");
    dp[n - 1] = "";
    dp[n - 1] += s[n - 1];
    stack<e> cur;
    cur.push({n - 1, n - 1, dp[n - 1]});
    for (int i = n - 2; i >= 0; i--) {
        int l = i, r = i;
        string ss = dp[i + 1];
        while (!cur.empty() && mat[s[l] - 'a'][s[cur.top().l] - 'a']) {
            r = cur.top().r;
            ss = min(ss, cur.top().s);
            cur.pop();
        }
        cur.push({l, r, ss});
        dp[i] += s[i];
        if (cur.size() == 1) ss = "";
        dp[i].append(ss);
    }
    cout << dp[0];
    return 0;
}