#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

#pragma GCC optimize("Ofast,unroll-loops")
#define int long long

vector<vector<int>> lst;
vector<vector<int>> dp;
vector<pair<int, int>> ul;
vector<int> cost;
vector<vector<int>> res;

vector<int> dfs(int st){
    vector<int> cur;
    vector<pair<int, vector<int>>> dop;
    if (lst[st].size() == 0){
        return {cost[st]};
    }
    int cnt= 0;
    for (int to : lst[st]){
        dop.push_back({cnt++, dfs(to)});
    }
    sort(dop.begin(), dop.end(), [&](const pair<int, vector<int>> &a, const pair<int, vector<int>> &b){
        return a.second[0] < b.second[0];
    });
    res[st].clear();
    for (int i =0; i < dop.size(); i++){
        for (int j : dop[i].second){
            cur.push_back(j);
        }
        res[st].push_back(dop[i].first);
    }
    return cur;
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    lst.assign(n, {});
    dp.assign(n, {});
    res.assign(n, {});
    vector<int>p(n, -1);
    for (int i =0; i < n; i++){
        int x;
        cin >> x;
        if (x == 1){
            int k;
            cin >> k;
            for (int j =0; j < k; j++){
                int v;
                cin >> v;
                v--;
                lst[i].push_back(v);
                p[v] = i;
            }
        }
        else{
            int k;
            cin >> k;
            for (int j =0; j < k; j++){
                int xx;
                cin >> xx;
                ul.push_back({xx, i});
            }
        }
    }
    for (int i =0; i < (1 << ul.size()); i++){
        cost.assign(n, -1);
        int bl = 1;
        for (int j =0; j < ul.size(); j++){
            if ((i >> j) & 1){
                if (cost[ul[j].second]!= -1){
                    bl =0;
                    break;
                }
                cost[ul[j].second] = ul[j].first;
            }
        }
        if (!bl) continue;
        for (int j =0; j < n; j++){
            if (lst[j].size() == 0 && cost[j] == -1){
                bl = 0;
                break;
            }
        }
        vector<int> cur = dfs(0);
        for (int j = 1; j < cur.size(); j++){
            if (cur[j] < cur[j - 1]){
                bl = 0;
                break;
            }
        }
        if (!bl) continue;
        cout << "Yes\n";
        for (int j = 0; j < n; j++){
            if (lst[j].size() == 0){
                cout << cost[j] << '\n';
            }
            else{
                for (int kk : res[j]){
                    cout << kk + 1<< " ";
                }
                cout << '\n';
            }
        }
        return 0;
    }
    cout << "No";
    return 0;
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80
20
2 2 40 70
1 2 3 2
2 4 30 90 91 92
*/