#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <numeric>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const int N = 1.1e5;

void Play() {
	int a, b, c;
	string s;
	cin >> a >> b >> c >> s;

	for (int i = 0; i < s.size(); i++) {
		if (s[i] == '0') {
			cout << "1 2" << endl;
			cout << "2 1" << endl;
		}
		else {
			cout << "2 1" << endl;
			cout << "1 2" << endl;
		}
	}
	cout << 0 << endl;
}

void Guess() {
	int a, b, c, n;
	cin >> a >> b >> c >> n;
	string s;
	while (n--) {
		while (1) {
			int a, b;
			cin >> a >> b;
			bool was = false;
			if (!was && a == 2 && b == 1) {
				s += '1';
			}
			else if (!was && a == 1 && b == 2) {
				s += '0';
			}
			if (a == 1 && b == 1) break;
		}
	}
	cout << s;
}

void Solve() {
	int n;
	cin >> n;
	if (n == 1) {
		Play();
	}
	else {
		Guess();
	}
}


int main() {
//#ifdef _DEBUG
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
//#endif
//	freopen("\\\\.\\pipe\\game.in", "r", stdin);
	//freopen("\\\\.\\pipe\\game.out", "w", stdout);
	ios_base::sync_with_stdio(false);
	Solve();
}