#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include "bits/stdc++.h"
#define ll long long
#define vi vector<ll>
#define mp make_pair
#define pii pair<ll, ll>
#define pb push_back

using namespace std;

const ll MAXN = 1e5 + 10;

vi bad_graph[MAXN];
vector<pair<int, char>> str_graph[MAXN];
int cnt[MAXN];
int used[MAXN];
int pos_fill[MAXN];

void solve() {
    int n, m; cin >> n >> m;
    string s; cin >> s;
    set<pii> q;
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        for (int j = 0; j < k; ++j) {
            int pos; cin >> pos; --pos;
            char c; cin >> c;
            if (c != s[pos]) bad_graph[pos].pb(i), cnt[i]++;
            str_graph[i].pb(mp(pos, c));
        }
        q.insert(make_pair(cnt[i], i));
    }
    vi ans;
    while (q.size()) {
        auto x = *q.begin();
        q.erase(q.begin());
        if (used[x.second]) continue;
        used[x.second] = 1;
        if (x.first != 0) {
            cout << -1;
            return;
        }
        ans.push_back(x.second);
        for (int i = 0; i < str_graph[x.second].size(); ++i) {
            if (pos_fill[str_graph[x.second][i].first]) continue;
            pos_fill[str_graph[x.second][i].first] = 1;
            for (int j : bad_graph[str_graph[x.second][i].first]) {
                --cnt[j];
                q.insert(mp(cnt[j], j));
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        if (pos_fill[i] == 0) {
            cout << -1;
            return;
        }
    }
    for (int i : ans) cout << i + 1 << " ";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    cout.precision(30);
    solve();

    return 0;
}
