#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include "bits/stdc++.h"
#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define mp make_pair
#define pii pair<ll, ll>
#define pb push_back
#define all(x) x.begin(), x.end()
#define mn(a, b) a = min(a, b)
const ll MAXN = 5e5 + 10;

using namespace std;

bool can_delete[27][27];
int sz[MAXN];
int p[MAXN];
int ind[MAXN];
int n, k;

bool lst(int i) {
    return i + sz[i] == n - 1;
}

string s;
string dp[MAXN];

void upd(string &x, string y) {
    for (int i = 0; i < min(x.size(), y.size()); ++i) {
        if (x[i] < y[i]) return;
        if (x[i] > y[i]) {
            x = y;
            return;
        }
    }
    if (x.size() > y.size()) y = x;
}

void solve() {
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c; cin >> c;
            can_delete[i][j] = c - '0';
        }
    }
    cin >> s;
    for (int i = n - 1; i > -1; --i) {
        if (i == n - 1) continue;
        while (i + sz[i] + 1 < n && can_delete[s[i] - 'a'][s[i + sz[i] + 1] - 'a']) {
            sz[i] += sz[i + sz[i] + 1] + 1;
        }
    }
    for (int i = 0; i < n; ++i) dp[i] = (char)123;
    dp[0] = s[0];
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j <= min(n - 1, i + sz[i] + 1); ++j) {
            upd(dp[j], dp[i] + s[j]);
        }
    }
    string best_ans = dp[n - 1];
    for (int i = 0; i < n - 1; ++i) if (lst(i)) upd(best_ans, dp[i]);
    cout << best_ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    cout.precision(30);
    solve();

    return 0;
}
