#include <bits/stdc++.h>
using namespace std;

//#define int long long
#define F first
#define S second
#define mp make_pair
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), x.end()
#ifdef MY
    #define endl '\n'
#endif // MY

typedef long long ll;
typedef pair <int, int> pii;
typedef pair < pii, pii > ppp;

const int N = 1e5 + 5;
vector < pii > lst[N];
int clr[N];
int cnt[N];
int pnt[N];
int ind[N];
set < pair < pii, pii > > cur;

ppp f(int i) {
    if (pnt[i] == sz(lst[i])) {
        return {{-1, -1}, {-1, -1}};
    }
    pii p = lst[i][pnt[i]];
    return mp(mp(p.F, clr[i]), mp(p.S, i));
}

void upd(int i, int c) {
    cnt[clr[i]]--;
    clr[i] = c;
    cnt[c]++;
}

void add(int i) {
    ppp p = f(i);
    if (p.F.F == -1) {
        return;
    }
    cur.insert(p);
    pnt[i]++;
}

void solve(vector < pii >& ord, int cc, bool& fl) {
    int zero = cc + (cnt[cc] - sz(ord));
    int one = zero;
    for (pii p : ord) {
        if (p.F == 0) {
            upd(p.S, zero);
            one++;
        } else {
            upd(p.S, one);
        }
        add(p.S);
    }
    if (one == zero && fl == 1) {
        cout << -1;
        exit(0);
    }
    fl = 0;
}

void solve(int i) {
    vector < ppp > pos;
    while (sz(cur) && (*(cur.begin())).F.F == i) {
        pos.pb(*(cur.begin()));
        cur.erase(cur.begin());
    }
    if (sz(pos) == 0) {
        cout << -1;
        exit(0);
    }
    vector < pii > ord;
    int cc = 0;
    bool fl = 1;
    for (int j = 0; j < sz(pos); j++) {
        ord.pb(pos[j].S);
        cc = pos[j].F.S;
        if (j + 1 == sz(pos) || pos[j].F.S != pos[j + 1].F.S) {
            solve(ord, cc, fl);
            ord.clear();
        }
    }
}

bool cmp(int i, int j) {
    return clr[i] < clr[j];
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
//    freopen("f.out", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    cnt[0] = n;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int t;
            char c;
            cin >> t >> c;
            t--;
            lst[i].pb({t, bool(s[t] != c)});
        }
        if (k) {
            upd(i, 1);
            add(i);
        }
    }
    for (int i = 0; i < m; i++) {
        solve(i);
    }
    for (int i = 0; i < n; i++) {
        ind[i] = i;
    }
    sort(ind, ind + n, cmp);
    for (int i = 0; i < n; i++) {
        cout << ind[i] + 1 << ' ';
    }
    return 0;
}
