#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
using namespace std;

vector<pair<int,char>> qw[100000];
char used[100000];
vector<int> bad[100000];
int nwc[100000];

void solve(){
    int n,m;
    cin >> n >> m;
    string s;
    cin >> s;
    for(int i = 0; i < n; ++i){
        int q;
        cin >> q;
        for(int j = 0; j < q; ++j){
            int ind;
            char bu;
            cin >> ind >> bu;
            --ind;
            qw[i].emplace_back(ind,bu);
        }
    }
    vector<int> ans;
    set<pair<int,int>> se;

    for(int i = 0; i < n; ++i){
        int cc = 0;
        for(auto j : qw[i]){
            if(s[j.first] != j.second){
                bad[j.first].push_back(i);
                ++cc;
            }
        }
        se.insert({cc,i});
        nwc[i] = cc;
    }

    for(int i = 0; i < n; ++i){
        pair<int,int> nw = *se.begin();
        if(nw.first != 0){
            break;
        }
        se.erase(se.begin());
        ans.push_back(nw.second + 1);
        for(auto j : qw[nw.second]){
            if(!used[j.first]){
                used[j.first] = 1;
                for(auto u : bad[j.first]){
                    se.erase({nwc[u],u});
                    nwc[u]--;
                    se.insert({nwc[u],u});
                }
            }
        }
    }


    bool ok = true;
    for(int i = 0; i < m; ++i){
        if(!used[i]) ok = false;
    }
    if(ans.size() != n || !ok){
        cout << -1;
        return;
    }
    for(auto i : ans){
        cout << i << ' ';
    }
}


signed main() {
#ifdef Debugg
    freopen("ain.txt","r",stdin);
    freopen("aout.txt","w",stdout);
#endif
    solve();
}
