#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <array>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <functional>
#include <random>
#include <chrono>
#include <time.h>
#include <limits>
#include <cmath>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

template<typename T1, typename T2> ostream& operator<< (ostream& out, const pair<T1, T2>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

// #define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif	

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

#pragma GCC optimize("Ofast,O2")

const int A = 26;
const int N = 510;
// const long long INF = 1e18;

int k, n;
int g[A][A];
// int can[N];
string s;
// string dp[N];
// int from[N], d[N];
// int used[N];

string compressb(string have) {
	string ans;
	for (auto c : have) {
		if (!ans.empty() && ans.back() == 'b' && c == 'b') continue;
		ans.pb(c);
	}
	return ans;
}

string compressab(string have) {
	string ans;
	for (auto c : have) {
		if (!ans.empty() && ans.back() == 'a' && c == 'b') continue;
		ans.pb(c);
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			char c;
			cin >> c;
			g[i][j] = c - '0';
		}
	}
	cin >> s;
	int v1 = g[0][0], v2 = g[0][1], v3 = g[1][0], v4 = g[1][1];
	if (v1 == 0 && v2 == 0 && v3 == 0 && v4 == 0) {
		cout << s << "\n";
	} else if (v1 == 0 && v2 == 0 && v3 == 0 && v4 == 1) {
		s = compressb(s);
		cout << s << "\n";
	} else if (v1 == 0 && v2 == 0 && v3 == 1 && v4 == 0) {
		string ans = s;
		while (!ans.empty() && ans.back() == 'a') ans.pop_back();
		if (ans.empty()) ans = s;
		cout << ans << "\n";
	} else if (v1 == 0 && v2 == 0 && v3 == 1 && v4 == 1) {
		s = compressb(s);
		string ans = s;
		while (!ans.empty() && ans.back() == 'a') ans.pop_back();
		if (ans.empty()) ans = s;
		cout << ans << "\n";
	} else if (v1 == 0 && v2 == 1 && v3 == 0 && v4 == 0) {
		s = compressab(s);
		cout << s << "\n";
	} else if (v1 == 0 && v2 == 1 && v3 == 0 && v4 == 1) {
		s = compressb(s);
		s = compressab(s);
		cout << s << "\n";
	} else if (v1 == 0 && v2 == 1 && v3 == 1 && v4 == 0) {
		cout << s[0];
		for (int i = 1; i < n; i++) {
			if (s[i] == s[i - 1]) cout << s[i];
			else break;
		}
		cout << "\n";
	} else if (v1 == 0 && v2 == 1 && v3 == 1 && v4 == 1) {
		s = compressb(s);
		cout << s[0];
		for (int i = 1; i < n; i++) {
			if (s[i] == s[i - 1]) cout << s[i];
			else break;
		}
		cout << "\n";
	} else if (v1 == 1 && v2 == 0 && v3 == 0 && v4 == 0) {
		string ans = s;
		while (!ans.empty() && ans.back() == 'a') ans.pop_back();
		ans.pb('a');
		cout << ans << "\n";
	} else if (v1 == 1 && v2 == 0 && v3 == 0 && v4 == 1) {
		s = compressb(s);
		string ans = s;
		while (!ans.empty() && ans.back() == 'a') ans.pop_back();
		ans.pb('a');
		cout << ans << "\n";
	} else if (v1 == 1 && v2 == 0 && v3 == 1 && v4 == 0) {
		string ans = s;
		while (!ans.empty() && ans.back() == 'a') ans.pop_back();
		if (ans.empty()) ans = s;
		cout << ans << "\n";
	} else if (v1 == 1 && v2 == 0 && v3 == 1 && v4 == 1) {
		s = compressb(s);
		string ans = s;
		while (!ans.empty() && ans.back() == 'a') ans.pop_back();
		ans.pb('a');
		cout << ans << "\n";
	} else if (v1 == 1 && v2 == 1 && v3 == 0 && v4 == 0) {
		s = compressab(s);
		string ans = s;
		while (!ans.empty() && ans.back() == 'a') ans.pop_back();
		ans.pb('a');
		cout << ans << "\n";
	} else if (v1 == 1 && v2 == 1 && v3 == 0 && v4 == 1) {
		s = compressb(s);
		s = compressab(s);
		string ans = s;
		while (!ans.empty() && ans.back() == 'a') ans.pop_back();
		ans.pb('a');
		cout << ans << "\n";
	} else if (v1 == 1 && v2 == 1 && v3 == 1 && v4 == 0) {
		string ans;
		ans.pb(s[0]);
		for (int i = 1; i < n; i++) {
			if (s[i] == s[i - 1]) ans.pb(s[i]);
			else break;
		}
		if (ans[0] == 'a') cout << "a\n";
		else cout << ans << "\n";
	} else {
		cout << s[0] << "\n";
	}
}
/*
3 7
010
001
100
abacaba
-> aac

3 5
010
001
100
bcacb
-> bacb

4 4 
0000
0000
1000
0110
dcab

*/