#include <iostream>
#include <string>
#include <vector>
#include <set>
using namespace std;

const int MAXN = 5e5 + 123;
const int MAXK = 27;
short f[MAXK][MAXK];

bool is_ok(int i, int j, vector<int>& a){
	return f[a[i]][a[j]];
}

int get_rt(vector<int>& rt, int i){
	if(i < 0 || i >= rt.size() || rt[i] == i)
		return i;
	return rt[i] = get_rt(rt, rt[i]);
}

int find_lst(vector<int>& a){
	int n = a.size();
	if(n == 1)
		return 0;
	vector<int> pv(n);
	vector<int> nt(n);
	for(int i = 0; i < n; ++i)
		pv[i] = nt[i] = i;
	set<int> st;
	for(int i = 1; i < n; ++i){
		if(f[a[i - 1]][a[i]])
			st.insert(i);
	}
	if(st.empty())
		return n - 1;
	while(st.size()){
		int i = *st.rbegin();
		st.erase(prev(st.end()));
		nt[i] = i + 1;
		pv[i] = i - 1;
		int pvi = get_rt(pv, i);
		int nti = get_rt(nt, i);
		if(pvi != -1 && nti != n){
			if(f[a[pvi]][a[nti]])
				st.insert(nti);
		}
	}
	return get_rt(pv, n - 1);
}


signed main(){
	int k, n;
	cin >> k >> n;
	vector<int> a(n);
	for(int i = 0; i < k; ++i){
		for(int j = 0; j < k; ++j){
			char c;
			cin >> c;
			if(c == '1')
				f[i][j] = 1;
		}
	}
	for(int i = 0; i < n; ++i){
		char c;
		cin >> c;
		a[i] = (c - 'a');
	}
	int lp = find_lst(a);
	string ans = "";
	ans.push_back('a' + a[0]);
	for(int i = 0; i + 1 < n;){
		vector<int> lps = {i};
		int lmch = i + 1;
		for(int j = i + 1; j <= n; ++j){
			if(j == n){
				lmch = n;
				break;
			}
			if(a[j] <= a[lmch])
				lmch = j;
			while(lps.size()){
				if(is_ok(lps.back(), j, a)){
					lps.push_back(j);
					break;
				} else lps.pop_back();
			}
			if(lps.empty())
				break;
		}
		if(lmch > lp)
			break;
		ans.push_back('a' + a[lmch]);	
		i = lmch;
	}
	cout << ans;
}
