#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
using namespace std;

int n = 32, m = 100000, k = 8;

void code()
{
	cin >> n >> k >> m;
	string s; cin >> s;
	int h = 0;
	for (int tt = 0; tt < 1000; ++tt)
	{
		int x, y;
		if (h)
			cin >> x >> y;
		for (int t = 0; t < 25; ++t)
		{
			int need = 0;
			if (s[tt * 100 + t * 25] == '1') need += 1;
			if (s[tt * 100 + t * 25 + 1] == '1') need += 2;
			if (s[tt * 100 + t * 25 + 2] == '1') need += 4;
			if (s[tt * 100 + t * 25 + 3] == '1') need += 8;
			x = need + 1;
			y = n - t;
			cout << x << ' ' << y << endl;
		}
		cout << "1 1" << endl;
		h ^= 1;
	}
	cout << 0 << endl;
}

void decode()
{
	cin >> n >> k >> m;
	string s(100000, '0');
	int d; cin >> d;
	int h = 0;
	for (int tt = 0; tt < d; ++tt)
	{
		int x, y;
		if (h)
			cin >> x >> y;
		for (int t = 0; t < 25; ++t)
		{
			cin >> x >> y;
			x -= 1;
			if (x & 1) ++s[tt * 100 + t * 25 + 0];
			if (x & 2) ++s[tt * 100 + t * 25 + 1];
			if (x & 4) ++s[tt * 100 + t * 25 + 2];
			if (x & 8) ++s[tt * 100 + t * 25 + 3];
		}
		cin >> x >> y;
		h ^= 1;
	}
	cout << s << endl;
}

int main()
{
	int h; cin >> h;
	if (h == 1)
		code();
	if (h == 2)
		decode();

	return 0;
}