#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector < vector < char > > a;

int k, n;
string s;

string res = "{";

void f(string s) {
	res = min(res, s);
	for (int i = 1; i < s.size(); i++) {
		if (a[s[i - 1] - 'a'][s[i] - 'a'] == '1') {
			string ns;
			for (int w = 0; w < i; w++) ns.push_back(s[w]);
			for (int w = i + 1; w < s.size(); w++) ns.push_back(s[w]);
			f(ns);
		}
	}
	return;
}

void solve10() {
	f(s);
	cout << res << "\n";
}

void solve50() {
	s += "#";
	vector < vector < int > > nearestpos(n, vector < int >(k, -1));
	vector < int > todel(n, -1);
	for (int i = 1; i < n; i++) {
		nearestpos[i] = nearestpos[i - 1];
		if (a[s[i - 1] - 'a'][s[i] - 'a'] == '1')
			nearestpos[i][s[i - 1] - 'a'] = i - 1;
		for (int j = 0; j < k; j++) {
			if (nearestpos[i][j] == -1) continue;
			if (nearestpos[i][j] < todel[i]) continue;
			if (a[j][s[i] - 'a'] == '0') continue;
			bool ok = true;
			for (int w = nearestpos[i][j] + 1; w < i; w++) {
				if (todel[w] < nearestpos[i][j])
					ok = false;
			}
			if(ok)
				todel[i] = max(todel[i], nearestpos[i][j]);
		}
	}

	int start = 0;
	int id = 1;
	string ans;
	ans.push_back(s[0]);
	while (id < n) {
		int takepos = id;
		while (id < n && todel[id] >= start) {
			id++;
			if (s[id] < s[takepos]) takepos = id;
		}
		ans.push_back(s[takepos]);
		start = takepos;
		id = takepos + 1;
	}
	if (ans.back() == '#') ans.pop_back();
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> k >> n;
	a.assign(k, vector < char >(k, 0));
	for (int i = 0; i < k; i++)
		for (int j = 0; j < k; j++) cin >> a[i][j];

	cin >> s;

	solve10();
}