#pragma GCC optimze("Ofast")
#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << '\n';
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::

const int K = 30, N = 5e5 + 5;

char a[K][K];

void solve() {
    int k, n;
    cin >> k >> n;

    for (int i = 1; i <= k; ++i) {
        for (int j = 1; j <= k; ++j) {
            cin >> a[i][j];
            a[i][j] -= '0';
        }
    }
    string s;
    cin >> s;
    for (auto& c : s)
        c -= 'a' - 1;
    s += char(0);
    ++n;

    int pos = 1;
    string res;
    res += s[0];
    while (pos < n) {
//        err(res.size());
        for (int c = 0; c <= k; ++c) {
            int ind = -1;
            vector<int> st;
            st.push_back(res.back());
            for (int i = pos; i < n; ++i) {
                if (s[i] == c) {
                    ind = i;
                    break;
                }

                while (!st.empty() && !a[st.back()][s[i]])
                    st.pop_back();
                if (st.empty()) break;
                st.push_back(s[i]);
            }
//            err(ind);
            if (ind != -1) {
                res += c;
                pos = ind + 1;
                break;
            }
        }
    }
    res.pop_back();
    for (auto& c : res)
        c += 'a' - 1;
    cout << res << '\n';
}

/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
*/

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();

    return 0;
}

