#pragma GCC optimze("Ofast")
#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << '\n';
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::

const int N = 32;

int was[N][N];

void solve() {
    int type;
    cin >> type;

    int n, k, m;
    cin >> n >> k >> m;


    auto reset = [&]() {
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < n; ++j)
                was[i][j] = 0;
    };

    auto find = [&](int b) {
        if (b == 0) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (i == 0 && j == 0) continue;
                    if (!was[i][j] && (i + 1 >= n || was[i + 1][j]) && (j + 1 >= n || was[i][j + 1])) {
                        return make_pair(i, j);
                    }
                }
            }
            return make_pair(-1, -1);
        }
        else {
            for (int i = n - 1; i >= 0; --i) {
                for (int j = n - 1; j >= 0; --j) {
                    if (i == 0 && j == 0) continue;
                    if (!was[i][j] && (i + 1 >= n || was[i + 1][j]) && (j + 1 >= n || was[i][j + 1])) {
                        if (i - 1 >= 0 && (j + 1 >= n || was[i - 1][j + 1])) {
                            return make_pair(i - 1, j);
                        }
                        if (j - 1 >= 0 && (i + 1 >= n || was[i + 1][j - 1])) {
                            return make_pair(i, j - 1);
                        }
                    }
                }
            }
            return make_pair(-1, -1);
        }
    };

    if (type == 1) {
        string s;
        cin >> s;

        int pos = 0;
        for (char& c : s)
            c -= '0';

        auto out = [](int x, int y) {
            cout << x + 1 << ' ' << y + 1 << endl;
        };

        auto paint = [&](int x, int y) {
            for (int i = x; i < n; ++i) {
                for (int j = y; j < n; ++j) {
                    was[i][j] = 1;
                }
            }
        };

        reset();
        int me = 1, st = 1;
        while (pos < s.size()) {
            int b = s[pos];

            if (me) {
                auto [x, y] = find(s[pos]);
                if (x == -1) {
                    out(0, 0);
                    st ^= 1;
                    me = st;
                    reset();
                    continue;
                }
                else {
                    out(x, y);
                    paint(x, y);
                    me ^= 1;
                }
            }
            else {
                int sx, sy;
                cin >> sx >> sy;
                --sx; --sy;

                if (sx == 0 && sy == 0) {
                    st ^= 1;
                    me = st;
                    reset();
                    continue;
                }
                paint(sx, sy);
                me ^= 1;
                continue;
            }
            ++pos;
        }
        if (me) {
            out(0, 0);
        }
        else {
            int sx, sy;
            cin >> sx >> sy;
            --sx; --sy;
            if (sx == 0 && sy == 0) {

            }
            else {
                out(0, 0);
            }
        }
        cout << 0 << endl;
    }
    else {
        int k;
        cin >> k;

        int me = 1, st = 1;
        string res;
        int x, y;
        while (true) {
            cin >> x >> y;

            --x; --y;
            if (x == 0 && y == 0) {
                st ^= 1;
                me = st;
                reset();
                k--;
                if (k)
                    continue;
                else
                    break;
            }
            if (me) {
                auto [sx, sy] = find(0);
                if  (sx == x && sy == y)
                    res += '0';
                else
                    res += '1';
            }
            me ^= 1;
        }
        res.resize(m);

        cout << res << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();

    return 0;
}


