#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<int> cnt(n), view(n);
    vector<bool> used(n);
    vector<pair<int, int>> id[m];
    vector<int> c[n], crack(m);
    queue<int> q;
    for (int i = 0; i < n; i++) {
        cin >> view[i];
        c[i].resize(view[i]);
        for (int j = 0; j < view[i]; j++) {
            char ch;
            cin >> c[i][j] >> ch;
            if (s[--c[i][j]] == ch) {
                id[c[i][j]].emplace_back(i, 1);
                cnt[i]++;
            } else {
                id[c[i][j]].emplace_back(i, 0);
            }
        }
        if (view[i] == cnt[i]) {
            q.emplace(i);
            used[i] = true;
        }
    }
    vector<int> ans;
    while (!q.empty()) {
        int k = q.front();
        ans.emplace_back(k + 1);
        q.pop();
        for (auto &ind : c[k]) {
            if (!crack[ind]) {
                crack[ind] = true;
                for (auto &[i, delta] : id[ind]) {
                    view[i]--;
                    cnt[i] -= delta;
                    if (!used[i] && cnt[i] >= view[i]) {
                        q.emplace(i);
                        used[i] = true;
                    }
                }
            }
        }
    }
    if (ans.size() != n) {
        cout << -1 << '\n';
        return 0;
    }
    for (auto &c : ans) {
        cout << c << ' ';
    }
    cout << '\n';
    return 0;
}
