#include <bits/stdc++.h>

#define next my_next

using namespace std;

const int MAXN = 2000, MAXK = 8;

bool possible[MAXN][MAXN];
int ans[MAXN][MAXN][MAXK], cnt[MAXN], n;
vector<int> m[MAXN];

vector<int> g[MAXN];

void dfs(int v = 0) {
    if (g[v].empty()) {
        cnt[v] = 1;
        for (auto &i : m[v]) {
            possible[v][i] = true;
        }
        return;
    }
    sort(g[v].begin(), g[v].end());
    for (auto &u : g[v]) {
        dfs(u);
        cnt[v] += cnt[u];
    }
    for (int i = 0; i <= n - cnt[i]; i++) {
        sort(g[v].begin(), g[v].end());
        do {
            int cur = i;
            possible[v][i] = true;
            for (auto &u : g[v]) {
                if (!possible[u][cur]) {
                    possible[v][i] = false;
                    break;
                }
                cur += cnt[u];
            }
            if (possible[v][i]) {
                for (int j = 0; j < g[v].size(); j++) {
                    ans[v][i][j] = g[v][j];
                }
                break;
            }
        } while (next_permutation(g[v].begin(), g[v].end()));
    }
}

int start[MAXN];

void mark(int v = 0, int cur = 0) {
    start[v] = cur;
    for (int i = 0; i < g[v].size(); i++) {
        mark(ans[v][start[v]][i], cur);
        cur += cnt[ans[v][start[v]][i]];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    memset(ans, 255, sizeof(ans));
    cin >> n;
    vector<int> val;
    for (int v = 0; v < n; v++) {
        int type;
        cin >> type;
        if (type == 1) {
            int m;
            cin >> m;
            g[v].resize(m);
            for (auto &u : g[v]) {
                cin >> u;
                u--;
            }
        } else {
            int sz;
            cin >> sz;
            m[v].resize(sz);
            for (auto &u : m[v]) {
                cin >> u;
                val.emplace_back(u);
            }
        }
    }
    sort(val.begin(), val.end());
    val.erase(unique(val.begin(), val.end()), val.end());
    for (int v = 0; v < n; v++) {
        for (auto &x : m[v]) {
            x = lower_bound(val.begin(), val.end(), x) - val.begin();
        }
    }
    dfs();
    if (possible[0][0]) {
        cout << "Yes\n";
//        mark();
//        for (int v = 0; v < n; v++) {
//            if (g[v].empty()) {
//                cout << val[start[v]] << '\n';
//            } else {
//                for (int i = 0; i < g[v].size(); i++) {
//                    cout << ans[v][start[v]][i] + 1 << ' ';
//                }
//                cout << '\n';
//            }
//        }
    } else {
        cout << "No\n";
    }
    return 0;
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92

3
1 2 2 3
2 1 1
2 1 2

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
 */