#pragma GCC optimize("Ofast")
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++) 
#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

typedef vector< int> vi;
typedef  pair<int, int> pii;
typedef vector<pii> vpii;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	map<int, vi> pr;
	vector<vector<pair<int, char>>> ac(n);
	vector<set<int>> same(n);
	set<pair<int, int>> best;
	rep(i, n) {
		int k;
		cin >> k;
		rep(j, k) {
			int a;
			char c;
			cin >> a >> c;
			a--;
			pr[a].pb(i);
			ac[i].pb({ a,c });
			if (s[a] != c) {
				same[i].insert(a);
			}
		}
	}

	rep(i, n) {
		best.insert({ same[i].size(), i });
	}

	vector<int>ans;
	vector<bool>used(n);
	while (best.size()) {
		int ind = best.begin()->second;
		int r = best.begin()->ff;
		if (r != 0) {
			break;
		}
		best.erase(best.begin());
		used[ind] = true;
		ans.pb(ind);
		int k = ac[ind].size();
		rep(i, k) {
			int p = ac[ind][i].ff;
			s[p] = '#';
			for (int q : pr[p]) {
				if (!used[q]) {
					best.erase({ same[q].size(), q });
					same[q].erase(p);
					best.insert({ same[q].size(), q });
				}
			}
			pr[p].clear();
		}
	}
	rep(i, m) {
		if (s[i] != '#') {
			cout << -1;
			return 0;
		}
	}
	rep(i, n) {
		if (!used[i]) {
			ans.pb(i);
		}
	}
	rep(i, n) {
		cout << ans[i] + 1 << " ";
	}

	return 0;
}