#pragma GCC optimize("Ofast")
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++) 
#define per(i, n) for (int i = n - 1; i >= 0; i--) 

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

typedef vector< int> vi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
const int H = 19;
const int N = 500500;
int up_to[N];
char s[N];
bool can[300][300];
int dp[N];
int bin_up[N][H];
int bin_clas[N][H];
int k, n;

map<pii, int> clas;

bool compare_dp(int i1, int i2) {
	per(lvl, H) {
		if (bin_clas[i1][lvl] == bin_clas[i2][lvl]) {
			i1 = bin_up[i1][lvl];
			i2 = bin_up[i2][lvl];
		}
	}
	return (i1 == n && i2 != n) || s[i1] < s[i2];
}

int cur = 30;

int get_clas(int a, int b) {
	if (b == -1) return a;
	if (clas.count({ a,b })) {
		return clas[{a, b}];
	}
	return clas[{a, b}] = cur++;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> k >> n;
	rep(i, k) {
		string tmp;
		cin >> tmp;
		rep(j, k) {
			if (tmp[j] == '1') {
				can[i + 'a'][j + 'a'] = true;
			}
		}
	}
	cin >> s;
	per(i, n) {
		int ind = i + 1;
		while (ind < n && can[s[i]][s[ind]]) {
			ind = up_to[ind];
		}
		up_to[i] = ind;
	}
	rep(i, H) {
		bin_up[n][i] = n;
		bin_clas[n][i] = -1;
	}
	per(i, n) {
		int best = i + 1;
		for (int j = i + 1; j <= up_to[i]; j++) {
			if (compare_dp(j, best)) {
				best = j;
			}
		}
		dp[i] = best;
		bin_clas[i][0] = get_clas(s[i] - 'a', bin_clas[best][0]);
		bin_up[i][0] = dp[i];
		rep(lvl, H - 1) {
			int x = bin_up[i][lvl];
			bin_up[i][lvl + 1] = bin_up[x][lvl];
			bin_clas[i][lvl + 1] = get_clas(bin_clas[i][lvl], bin_clas[x][lvl]);
		}
	}

	int i = 0;
	while (i < n) {
		cout << s[i];
		i = dp[i];
	}

	return 0;
}