#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("Ofast")
#include <iostream>
#include <string>
#include <vector>
#include <assert.h>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++) 
#define per(i, n) for (int i = n - 1; i >= 0; i--) 

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define pb push_back
#define ff first
#define ss second

typedef vector< int> vi;
typedef  pair<int, int> pii;
typedef vector<pii> vpii;


vi g[100100];

vi can_choose[100100];

vi cons;

pii r[100100];
vi order[100100];

bool dfs(int v) {
	if (can_choose[v].size()) {
		return true;
	}
	for (int u : g[v]) {
		if (!dfs(u)) {
			return false;
		}
	}
	vector<pair<pii, int>> segs;
	for (int u : g[v]) {
		segs.pb({ r[u], u });
	}
	sort(all(segs));
	for (int i = 0; i + 1 < sz(segs); i++) {
		if (segs[i].ff.ss > segs[i + 1].ff.ff) {
			return false;
		}
	}
	for (int i = 0; i < sz(segs); i++) {
		order[v].pb(segs[i].ss);
	}
	r[v] = { segs[0].ff.ff, segs.back().ff.ss };
	return true;
}

int n;


void brute(int i) {
	if (i == cons.size()) {
		for (int v = 1; v <= n; v++) {
			order[v].clear();
		}
		if (dfs(1)) {
			cout << "Yes\n";
			for (int v = 1; v <= n; v++) {
				if (can_choose[v].size()) {
					cout << r[v].ff << "\n";
				}
				else {
					for (int u : order[v]) {
						cout << u << " ";
					}
					cout << "\n";
				}
			}
			exit(0);
		}
		return;
	}
	for (int x: can_choose[cons[i]]) {
		r[cons[i]] = { x, x };
		brute(i + 1);
		r[cons[i]] = { -1, -1 };
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	
	rep(i, n) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			while (k--) {
				int v;
				cin >> v;
				g[i + 1].pb(v);
			}
		}
		else {
			int k;
			cin >> k;
			while (k--) {
				int x;
				cin >> x;
				can_choose[i + 1].pb(x);
			}
			cons.pb(i + 1);
		}
	}

	brute(0);

	cout << "No";
	return 0;
}