import java.io.*;
import java.util.*;

public class task4 {
    static ArrayList<Integer[]>[] lines;
    static int[] ans;
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        ans = new int[n - 1];
        for (int i = 0; i < n - 1; i++) {
            ans[i] = 2000000009;
        }
        lines = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            lines[i] = new ArrayList<>();
        }
        int m = nextInt();
        for (int i = 0; i < m; i++) {
            int v = nextInt() - 1;
            int u = nextInt() - 1;
            int x = nextInt();
            lines[v].add(new Integer[]{u, x});
            lines[u].add(new Integer[]{v, x});
        }
        dfs(0, -1, 1000000007, -1);
        for (int i = 0; i < n - 1; i++) {
            out.println(ans[i]);
        }
        out.close();
    }

    public static void dfs(int v, int prev, int min, int max) {
        for (Integer[] i : lines[v]) {
            if (i[0] == prev) {
                continue;
            }
            int u = i[0];
            int x = i[1];
            int min1 = Math.min(min, x);
            int max1 = Math.max(max, x);
            ans[u - 1] = Math.min(ans[u - 1], min1 + max1);
            dfs(u, v, min1, max1);
        }
    }


    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");

    public static String nextToken() throws IOException{
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}