#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <map>
#include <string>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()
//#define int ll

vector<ll> cost(27);

void solve() {
	string s;
	cin >> s;
	ll ccost = 0;
	int max = 0;
	for (int i = s.size() - 1; i >= 0; --i) {
		if (s[i] - 'A' < max) {
			ccost -= cost[s[i] - 'A'];
		}
		else {
			ccost += cost[s[i] - 'A'];
			max = std::max(max, s[i] - 'A');
		}
	}
	cout << ccost << '\n' << s;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif 
	cost[0] = 1;
	for (int i = 1; i < 26; i += 2) {
		cost[i] = cost[i - 1] * 5;
		cost[i + 1] = cost[i] * 2;
	}
	cost.pop_back();
	int t;
	cin >> t;
	while (t-- > 0) {
		solve();
		cout << '\n';
	}
	return 0;
}