#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <map>
#include <set>
#include <string>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()
//#define int ll

const ll INF = 2e9;

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif 
	int n, m, a, b, c;
	cin >> n >> m;
	vector<vector<pair<int, int>>> g(n);
	for (int i = 0; i < m; ++i) {
		cin >> a >> b >> c;
		--a, --b;
		g[a].emplace_back(b, c);
		g[b].emplace_back(a, c);
	}
	vector<int> d(n, INF);
	d[0] = 0;
	set<pair<int, int>> s;
	s.emplace(d[0], 0);
	while (!s.empty()) {
		int v = s.begin()->second, cost = s.begin()->first;
		s.erase(s.begin());
		for (auto& u : g[v]) {
			if (d[u.first] > max(cost, u.second)) {
				s.erase({ d[u.first], u.first });
				d[u.first] = max(cost, u.second);
				s.emplace(d[u.first], u.first);
			}
		}
	}
	for (int i = 1; i < n; ++i)
		cout << d[i] << '\n';
	return 0;
}