#include <bits/stdc++.h>

#define ll long long
#define ld double
#define pb push_back
#define ft first
#define sd second

using namespace std;

const ll inf = (ll)1e18;
vector <pair<ll, ll>> g[300000];
vector <ll> e;
ll ans[300000];
bool u[300000];

void dfs(ll v, ll mx = -inf, ll mn = inf) {
    ans[v] = min(mx + mn, ans[v]);
    for (auto &to: g[v]) {
        if (!u[to.sd]) {
            u[to.sd] = 1;
            dfs(to.ft, max(mx, e[to.sd]), min(mn, e[to.sd]));
            u[to.sd] = 0;
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef FREOPEN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll n, m;
    cin >> n >> m;
    fill(ans, ans + n, inf);
    bool gg = 1;
    for (ll i = 0; i < m; ++i) {
        ll x, y, t;
        cin >> x >> y >> t;
        if (abs(x - y) > 1) {
            gg = 0;
        }
        --x;
        --y;
        e.pb(t);
        g[x].pb({y, i});
        g[y].pb({x, i});
    }
    if (gg) {
        ll mx = 0;
        ll mn = inf;
        for (ll i = 1; i < n; ++i) {
            ll ed = inf;
            for (auto &to: g[i]) {
                if (to.ft == i - 1)
                    ed = min(ed, e[to.sd]);
            }
            mx = max(mx, ed);
            mn = min(mn, ed);
            ans[i] = mx + mn;
        }
    }
    else {
        dfs(0);
    }
    for (ll i = 1; i < n; ++i) {
        cout << ans[i] <<  '\n';
    }
    return 0;
}