#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <random>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#include <chrono>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

using namespace std;
using ll = long long;
constexpr int MAXN = (int)6e5;
constexpr int INF = (int)2e9;
vector<pair<int, int>> g[MAXN];
int dist[MAXN];
int n, m;

void add_edge(int v, int to, int t) {
	g[v].emplace_back(to, 0);
	g[n + v].emplace_back(n + to, 0);
	g[v].emplace_back(n + to, t);
}

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		add_edge(--u, --v, t);
		add_edge(v, u, t);
	}

	fill(dist, dist + 2 * n, INF);
	dist[0] = 0;
	set<pair<int, int>> q;
	q.emplace(0, 0);
	while (!q.empty()) {
		int v = q.begin()->second;
		q.erase(q.begin());

		for (const auto &[to, t] : g[v]) {
			if (dist[to] > dist[v] + t) {
				q.erase(make_pair(dist[to], to));
				dist[to] = dist[v] + t;
				q.emplace(dist[to], to);
			}
		}
	}

	for (int i = 1; i < n; ++i)
		cout << dist[n + i] + int(1e9) << '\n';

	return 0;
}