#include <bits/stdc++.h>

using namespace std;
#define MAXN 300000
vector<int> g[MAXN];
vector<int> gg[MAXN];
int d[MAXN];
bool used[MAXN];
int pre[MAXN];
bool down[MAXN];
bool up[MAXN];
int n;

void dfs1(int v, int p, int dep) {
    d[v] = dep;
    pre[v] = p;
    for (int u:g[v]) {
        if (d[u] != -1) {
            continue;
        }
        gg[v].push_back(u);
        dfs1(u, v, dep + 1);
    }
}

vector<vector<int>> ans;

int dfs2(int v) {
    vector<int> pos, neg;
    for (int u:gg[v]) {
        int x = dfs2(u);
        if (x == -1) {
            neg.push_back(u);
        } else if (x == 1) {
            pos.push_back(u);
        }
    }
    while (pos.size() > 0 && neg.size() > 0) {
        ans.push_back({pos.back(), v, v, neg.back()});
        pos.pop_back();
        neg.pop_back();
    }
    bool need_up = 0;
    bool need_down = 0;
    if (up[v]) {
        if (pos.size() > 0) {
            ans.push_back({pos.back(), v, v, pre[v]});
            pos.pop_back();
        } else {
            need_up = 1;
        }
    }
    if (down[v]) {
        if (neg.size() > 0) {
            ans.push_back({pre[v], v, v, neg.back()});
            neg.pop_back();
        } else {
            need_down = 1;
        }
    }
    if (pos.size() > 0 || neg.size() > 0) {
        cout << "No";
        exit(0);
    }
    if (need_down && need_up) {
        ans.push_back({pre[v], v, v, pre[v]});
    }
    return -need_down + need_up;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int m;
    cin >> n >> m;
    vector<pair<int, int>> vp;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
        vp.push_back({u, v});
    }
    memset(d, 255, sizeof(d));
    for (int i = 0; i < n; ++i) {
        if (d[i] == -1) {
            dfs1(i, i, 0);
        }
    }
    memset(down, 0, sizeof(down));
    memset(up, 0, sizeof(up));
    for (auto e:vp) {
        if (d[e.second] > d[e.first]) {
            down[e.second] = 1;
        } else {
            up[e.first] = 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (d[i] == 0) {
            dfs2(i);
        }
    }
    cout << "Yes\n";
    if (ans.size() != m / 2) {
        cout << 1 / 0;
    }
    for (auto x:ans) {
        for (auto y:x) {
            cout << y + 1 << " ";
        }
        cout << "\n";
    }
}
