#include <bits/stdc++.h>

using namespace std;

struct tree {
    int x, h;

    tree(int x = 0, int h = 0) : x(x), h(h) {}
};

#define left left228
#define right right228
#define MAXN 5000
tree trees[MAXN];
int left[MAXN];
int right[MAXN];
vector<int> need_r[MAXN];
int n;

int arr[MAXN];

void reset() {
    for (int i = 0; i < n; ++i) {
        arr[i] = 1;
    }
}

void upd(int pos) {
    arr[pos] = 0;
}

int sum(int l, int r) {
    int res = 0;
    for (int i = l; i < r; ++i) {
        res += arr[i];
    }
    return res;
}

int solve(int l, int r) {
    reset();
    while (true) {
        int pos = -1;
        for (int i = l; i < r; ++i) {
            if (sum(i, i + 1) == 0) {
                continue;
            }
            bool canl = trees[i].x - trees[i].h >= trees[0].x;
            canl &= sum(left[i], i) == 0;
            bool canr = trees[i].x + trees[i].h <= trees[n - 1].x;
            canr &= sum(i + 1, right[i]) == 0;
            if (canl || canr) {
                pos = i;
                break;
            }
        }
        if (pos == -1) {
            break;
        }
        upd(pos);
    }
    return n - sum(0, n);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        int x, h;
        cin >> x >> h;
        trees[i] = {x, h};
    }
    for (int i = 0; i < n; ++i) {
        left[i] = i;
        for (int j = i - 1; j >= 0; --j) {
            if (trees[i].x - trees[i].h < trees[j].x) {
                left[i] = j;
            } else {
                break;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        right[i] = i + 1;
        for (int j = i + 1; j < n; ++j) {
            if (trees[i].x + trees[i].h > trees[j].x) {
                right[i] = j + 1;
            } else {
                break;
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        cout << solve(l, r) << "\n";
    }
    return 0;

}