#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INFLL = 2e18;

ll value(int c)
{
    ll x = 1;
    int t = 0;
    for (int i = 0; i < c; i++)
    {
        if (t == 0) x *= 5;
        else x *= 2;
        t ^= 1;
    }
    return x;
}

void solve()
{
    string s;
    cin >> s;
    vector<ll> a(s.size());
    for (int i = 0; i < a.size(); i++) a[i] = s[i] - 'A';
    vector<vector<ll> > dp(a.size(), vector<ll>(26, -INFLL));
    if (a[a.size() - 1] == -2)
    {
        for (int i = 0; i < 26; i++) dp[a.size() - 1][i] = value(i);
    }
    else
    {
        dp[a.size() - 1][a.back()] = value(a.back());
    }

    for (int pos = (int)a.size() - 2; pos >= 0; pos--)
    {
        for (int mx = 0; mx < 26; mx++)
        {
            for (int place = 0; place < 26; place++)
            {
                if (a[pos] == -2 || a[pos] == place)
                {
                    if (mx <= place) dp[pos][place] = max(dp[pos][place], dp[pos + 1][mx] + value(place));
                    else dp[pos][mx] = max(dp[pos][mx], dp[pos + 1][mx] - value(place));
                }
            }
        }
    }

    ll ans = -INFLL;
    for (int i = 0; i < 26; i++) ans = max(ans, dp[0][i]);
    cout << ans << "\n";
    cout << s << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cerr << (int)('?' - 'A') << endl;

    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }
}

/*
4
BBBC
????
A?B?C?D
YYYYY?
*/
