#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1e9;
const ll INFLL = 1e18;

void dfs(int v, int p, vector<ll> &mn, vector<ll> &mx, vector<vector<pair<ll, ll> > > &g)
{
    for (auto e : g[v]) if (e.first != p)
    {
        int u = e.first;
        mn[u] = min(mn[v], e.second);
        mx[u] = max(mx[v], e.second);
        dfs(u, v, mn, mx, g);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<pair<ll, ll> > > g(n);
    for (int i = 0; i < m; i++)
    {
        ll ft, to, tm;
        cin >> ft >> to >> tm;
        ft--, to--;
        g[ft].push_back({to, tm});
        g[to].push_back({ft, tm});
    }
    vector<ll> mn(n, INF), mx(n, 0);
    dfs(0, 0, mn, mx, g);
    for (int i = 1; i < n; i++)
        cout << mn[i] + mx[i] << " ";
}
