#include <bits/stdc++.h>
#define ll long long
#define ipair pair <int, int>
#define dpair pair <int, pair <int, int> >
using namespace std;

const int inf = pow(10, 9);

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector <ipair> edges;
    for (int i = 0; i < m; i++)
    {
        int from, to;
        cin >> from >> to;
        edges.push_back({from - 1, to - 1});
    }

    vector <int> paired(m, -1);

    function <void(int)> dfs = [&](int sz)
    {
        if (sz < m)
        {
            for (int i = 0; i < m; i++)
                if (paired[i] == -1) {
                    for (int j = i + 1; j < m; j++)
                    {
                         ipair lhs = edges[i];
                        ipair rhs = edges[j];
                        if (i != j && paired[j] == -1 && (lhs.second == rhs.first || lhs.first == rhs.second))
                        {
                            paired[i] = j;
                            paired[j] = i;
                            dfs(sz + 2);
                            paired[i] = -1;
                            paired[j] = -1;
                        }
                    }
                    break;
                }
        } else
        {
            bool good = true;
            for (int i = 0; i < m && good; i++)
            {
                ipair lhs = edges[i];
                ipair rhs = edges[paired[i]];
                if (!(lhs.second == rhs.first || lhs.first == rhs.second))
                    good = false;
            }
            if (good)
            {
                cout << "Yes\n";
                for (int i = 0; i < m; i++)
                    if (paired[i] > i)
                        cout << edges[i].first + 1 << " " << edges[i].second + 1 << " " << edges[paired[i]].first + 1 << " " << edges[paired[i]].second + 1 << '\n';
                exit(0);
            }
        }

    };


        dfs(0);
        cout << "No";
}

