#include <bits/stdc++.h>
#define ll long long
#define ipair pair <int, int>
#define dpair pair <int, pair <int, int> >
using namespace std;

vector <ipair> trees;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;
    trees.resize(n);
    for (auto& v : trees)
        cin >> v.first >> v.second;

    while (q--)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;

        vector <int> nxtLeft(n, -1), nxtRight(n, -1);
        for (int i = l; i <= r; i++)
        {
            nxtRight[i] = i + 1;
            if (i == n - 1)
                nxtRight[i] = -1;
            nxtLeft[i] = i - 1;
            if (i == 0)
                nxtLeft[i] = -1;
        }
        vector <bool> av(n, true);

        int ans = 0;
        for (int k = 0; k < r - l + 1; k++)
        for (int t = l; t <= r; t++)
        {
            if (!av[t])
                continue;
            int pos = t;

            int left = nxtLeft[pos];
            int right = nxtRight[pos];

            if (!(left != -1 && trees[pos].first - trees[pos].second >= trees[left].first ||
                  right != -1 && trees[pos].first + trees[pos].second <= trees[right].first) &&
                !(left == -1 && trees[pos].first - trees[pos].second >= trees[0].first ||
                  right == -1 && trees[pos].first + trees[pos].second <= trees.back().first))
            {
                continue;
            } else
            {
                ans++;
                av[t] = false;
                if (left != -1)
                    nxtRight[nxtLeft[pos]] = right;
                if (right != -1)
                    nxtLeft[nxtRight[pos]] = left;
            }
        }
        cout << ans << "\n";
    }
}

