#include <algorithm>
#include <iostream>
#include <vector>
#include <string>

using namespace std;
using ll = long long;

ll vals[26];
const ll INF = 1e18;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	ll num = 1;
	for (int i = 0; i < 13; ++i)
	{
		vals[i * 2] = num;
		vals[i * 2 + 1] = num * 5;
		num *= 10;
	}

	int t = 0;
	cin >> t;

	string s;
	while (t--)
	{
		cin >> s;
		int n = s.size();

		vector<ll> dp[26];
		vector<int> par[26];
		vector<int> cur[26];
		for (int i = 0; i < 26; ++i)
		{
			dp[i].resize(n + 1, -INF);
			par[i].resize(n, -1);
			cur[i].resize(n, -1);
			dp[i][n] = 0;
		}

		for (int i = n - 1; i >= 0; --i)
		{
			for (int c = 0; c < 26; ++c)
			{
				if (s[i] == '?')
				{
					for (int curC = 0; curC < 26; ++curC)
					{
						if (curC < c)
						{
							if (dp[c][i + 1] - vals[curC] > dp[c][i])
								dp[c][i] = dp[c][i + 1] - vals[curC], par[c][i] = c, cur[c][i] = curC;
						}
						else
						{
							if (dp[c][i + 1] + vals[curC] > dp[curC][i])
								dp[curC][i] = dp[c][i + 1] + vals[curC], par[curC][i] = c, cur[curC][i] = curC;
						}
					}
				}
				else
				{
					int curC = s[i] - 'A';
					if (curC < c)
					{
						if (dp[c][i + 1] - vals[curC] > dp[c][i])
							dp[c][i] = dp[c][i + 1] - vals[curC], par[c][i] = c, cur[c][i] = curC;
					}
					else
					{
						if (dp[c][i + 1] + vals[curC] > dp[curC][i])
							dp[curC][i] = dp[c][i + 1] + vals[curC], par[curC][i] = c, cur[curC][i] = curC;
					}
				}
			}
		}

		int bestC = 0;
		for (int i = 0; i < 26; ++i)
			if (dp[i][0] > dp[bestC][0])
				bestC = i;

		cout << dp[bestC][0] << "\n";

		string ans(n, 'A');
		for (int i = 0; i < n; ++i)
		{
			int curC = cur[bestC][i];
			ans[i] = 'A' + curC;
			bestC = par[bestC][i];
		}

		cout << ans << "\n";
	}



	return 0;
}