#include <bits/stdc++.h>

const int inf = 0x3f3f3f3f;
using ll = long long;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
using pii = std::pair<int, int>;

const int MAXN = 5e5;
std::vector<pii> g[MAXN];

int main() {
    int n, m;
    std::cin >> n >> m;

    std::map<pii, int> cntEdges;
    for (int i = 0; i < m; i++) {
        int a, b, t;
        std::cin >> a >> b >> t;
        a--, b--;
        g[a].emplace_back(b, t);
        g[b].emplace_back(a, t);
    }

    std::priority_queue<pii> q;
    int dist[n];
    bool used[n];
    memset(dist, inf, sizeof(dist));
    memset(used, 0, sizeof(used));
    dist[0] = inf;

    q.push(std::make_pair(inf, 0));
    while(!q.empty()) {
        auto [shit, v] = q.top();
        q.pop();
        if(used[v]) continue;
        used[v] = true;

        for(auto &[to, cost] : g[v]) {
            if(used[to]) continue;
            if(std::min(dist[v], cost) < dist[to]) {
                dist[to] = std::min(dist[v], cost);
                q.push(std::make_pair(-dist[to], to));
            }
        }
    }

    for (int i = 1; i < n; i++) {
        std::cout << 1'000'000'000 + dist[i] << ' ';
    }
}
