#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <ctime>


using namespace std;


#define int long long
#define ll long long
#define all(a) a.begin(), a.end()


const int k = 26;
int n;
string s;
ll lrs;
string res;
vector<vector<ll>> dp;
vector<ll> vals;


void cnt_vals() {
	vals.resize(k);
	vals[0] = 1;
	vals[1] = 5;
	for (int i = 2; i < k; i += 1) {
		vals[i] = (vals[i - 2] * 10);
	}
}


ll get_val(char c) {
	return vals[c - 'A'];
}


void rec_res() {
	ll rs = lrs;
	int mx = k - 1;
	res = s;
	for (int i = 0; i < n - 1; ++i) {
		if (s[i] == '?') {
			for (int x = 0; x <= mx; ++x) {
				if (dp[i][x] == rs) {
					for (int y = 0; y <= mx; ++y) {
						bool ok = false;
						if (x < y) {
							if (rs == dp[i + 1][y] - vals[x]) {
								ok = true;
							}
						}
						else {
							if (rs == dp[i + 1][y] + vals[x]) {
								ok = true;
							}
						}
						if (ok) {
							mx = y;
							rs = dp[i + 1][y];
							break;
						}
					}
					res[i] = x + 'A';
					break;
				}
			}
		}
		else {
			int x = s[i] - 'A';
			for (int y = 0; y <= mx; ++y) {
				bool ok = false;
				if (x < y) {
					if (rs == dp[i + 1][y] - vals[x]) {
						ok = true;
					}
				}
				else {
					if (rs == dp[i + 1][y] + vals[x]) {
						ok = true;
					}
				}
				if (ok) {
					mx = y;
					rs = dp[i + 1][y];
					break;
				}
			}
		}
	}
	if (s[n - 1] == '?') {
		for (int x = 0; x <= mx; ++x) {
			if (dp[n - 1][x] == rs) {
				res[n - 1] = x + 'A';
				break;
			}
		}
	}
}


ll inf = 1e15;


void get_res() {
	n = s.size();
	dp.assign(n, vector<ll>(k, -inf));
	if (s[n - 1] == '?') {
		for (int i = 0; i < k; ++i) {
			dp[n - 1][i] = vals[i];
		}
	}
	else {
		int x = s[n - 1] - 'A';
		for (int i = 0; i < k; ++i) {
			if (i < x) {
				dp[n - 1][i] = -inf;
			}
			else {
				dp[n - 1][i] = vals[x];
			}
		}
	}
	for (int i = n - 2; i >= 0; --i) {
		if (s[i] == '?') {
			for (int x = 0; x < k; ++x) {
				for (int y = 0; y < k; ++y) {
					if (x < y) {
						dp[i][y] = max(dp[i][y], dp[i + 1][y] - vals[x]);
					}
					else {
						dp[i][x] = max(dp[i][y], dp[i + 1][y] + vals[x]);
					}
				}
			}
		}
		else {
			int x = s[i] - 'A';
			for (int y = 0; y < k; ++y) {
				if (x < y) {
					dp[i][y] = max(dp[i][y], dp[i + 1][y] - vals[x]);
				}
				else {
					dp[i][x] = max(dp[i][y], dp[i + 1][y] + vals[x]);
				}
			}
		}
	}
	lrs = -inf;
	for (int i = 0; i < k; ++i) {
		lrs = max(lrs, dp[0][i]);
	}
	rec_res();
}


int32_t main() {
	cnt_vals();
	int t;
	cin >> t;
	while (t--) {
		cin >> s;
		get_res();
		cout << lrs << "\n";
		cout << res << "\n";
	}
	return 0;
}

/*
4
BBBC
????
A?B?C?D
YYYYY?
*/