#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define pii pair<int, int>

using namespace std;

const int inf = 1e18;

int cost[100];

string s;
int n;
vector<vector<int>> dp;
vector<vector<char>> p;
vector<vector<int>> go;

void solve() {
	cin >> s;
	n = s.size();
	dp.assign(n + 1, vector<int>(26, -inf));
	p.assign(n + 1, vector<char>(26, '?'));
	go.assign(n + 1, vector<int>(26, -1));
	for (int j = 0; j < 26; j++) {
		dp[n][j] = 0;
	}
	for (int i = n - 1; i >= 0; i--) {
		if (s[i] == '?') {
			// add any
			int dp_max = dp[i + 1][0];
			int dp_ch = 0;
			for (int j = 0; j < 26; j++) {
				if (dp[i + 1][j] > dp_max) {
					dp_max = dp[i + 1][j];
					dp_ch = j;
				}
				dp[i][j] = cost[(j + 'A')] + dp_max;
				p[i][j] = j;
				go[i][j] = dp_ch;
			}
		} else {
			// add only this
			int dp_max = -inf;
			char dp_ch = 'A';
			for (int j = 0; j <= s[i] - 'A'; j++) {
				if (dp[i + 1][j] > dp_max) {
					dp_max = dp[i + 1][j];
					dp_ch = j;
				}
			}
			dp[i][s[i] - 'A'] = cost[s[i]] + dp_max;
			p[i][s[i] - 'A'] = s[i] - 'A';
			go[i][s[i] - 'A'] = dp_ch;
			for (int j = s[i] - 'A' + 1; j < 26; j++) {
				dp[i][j] = -cost[s[i]] + dp[i + 1][j];
				p[i][j] = s[i] - 'A';
				go[i][j] = j;
			}
		}
		// cout << i << " : " << endl;
		// for (int j = 0; j < 26; j++) {
		// 	cout << j << " : " << dp[i][j] << "\n";
		// }

		// cout << endl;
	}
	int mx = -inf;
	int mx_i = -1;
	for (int i = 0; i < 26; i++) {
		if (mx < dp[0][i]) {
			mx = dp[0][i];
			mx_i = i;
		}
	}
	int t = 0;
	char c = mx_i;
	while (t < n) {
		if (s[t] != '?') {
			c = go[t][c];
		} else {
			s[t] = p[t][c] + 'A';
			c = go[t][c];
		}
		t++;
	}
	cout << mx << "\n" << s << "\n";
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int mul = 5;
	int tek = 1;
	for (int i = 'A'; i <= 'Z'; i++) {
		cost[i] = tek;
		tek *= mul;
		mul = 10 / mul;
		// cout << (char) i << " : " << cost[i] << endl;
	}

	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}
