#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<string>
#include<random>
#include<vector>
#include<cmath>
#include<iomanip>
#include<queue>
#include<cassert>
#include<set>
#include <algorithm>
using namespace std;
//#define int long long
vector<vector<pair<int, int>>> g;
vector<int> cost, ans, used;
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int n, m;
	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; ++i) {
		int q, w, c;
		cin >> q >> w >> c;
		--q, --w;
		g[q].push_back({ w, i });
		g[w].push_back({ q,i });
		cost.push_back(c);
	}
	vector<int> dma(n, 0);
	set<pair<int, int>> se;
	se.insert({ dma[0],0 });
	while (!se.empty()) {
		int v = se.begin()->second;
		se.erase({ dma[v],v });
		for (auto& x : g[v]) {
			if (dma[x.first] < max(dma[v], cost[x.second])) {
				se.erase({ dma[x.first], x.first });
				dma[x.first] = max(dma[v], cost[x.second]);
				se.insert({ dma[x.first], x.first });
			}
		}
	}
	vector<int> dmi(n, 2e9);
	se.insert({ dmi[0],0 });
	while (!se.empty()) {
		int v = se.begin()->second;
		se.erase({ dmi[v],v });
		for (auto& x : g[v]) {
			if (dmi[x.first] > min(dmi[v], cost[x.second])) {
				se.erase({ dmi[x.first], x.first });
				dmi[x.first] = min(dmi[v], cost[x.second]);
				se.insert({ dmi[x.first], x.first });
			}
		}
	}
	for (int i = 1; i < n; ++i) cout << dmi[i] + dma[i] << '\n';
	return 0;
}