#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>
#define ti tuple<int,int,int>

typedef long long ll;


const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;

const int MAXN = 25;

int g[MAXN][MAXN];
int ans[MAXN];

void Solve() {
    memset(ans, 127, sizeof(ans));
    int n, m;
    cin >> n >> m;
    vector <ti> edges;
    forn(i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        if (a > b) {
            swap(a, b);
        }
        edges.eb(a, b, c);
    }
    vi order(m);
    iota(all(order), 0);
    do{
        int mn = INF, mx = nINF;
        int v = 1;
        if (get<0>(edges[order[0]]) != 1) {continue;}
        for (auto u : order) {
            auto [a, b, c] = edges[u];
            if (v != a && v != b) {break;}
            mn = min(mn, c);
            mx = max(mx, c);
            v = a + b - v;
            ans[v] = min(ans[v], mn + mx);
        }
    } while (next_permutation(all(order)));
    for (int i = 2; i <= n; ++i) {
        cout << ans[i] << '\n';
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}

