#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int inf = 1e9;

int n;
vector<vector<pair<int, int>>> a;
vector<pair<int, int>> t;

void dfs(int v, int p) {
	for (auto i : a[v]) {
		if (i.x == p) continue;
		t[i.x] = t[v];
		if (i.y > t[i.x].x) t[i.x].x = i.y;
		if (i.y < t[i.x].y) t[i.x].y = i.y;
		dfs(i.x, v);
	}
}

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int m;
	cin >> n >> m;
	a.resize(n);
	t.resize(n, { -inf, inf });
	int x, y, w;
	for (int i{}; i < m; ++i) {
		cin >> x >> y >> w;
		x--;
		y--;
		a[x].push_back({ y, w });
		a[y].push_back({ x, w });
	}
	
	dfs(0, 0);
	for (int i{ 1 }; i < n; ++i) {
		cout << t[i].x + t[i].y << '\n';
	}
	return 0;
}