#include <bits/stdc++.h>
using namespace std;

#define s second
#define f first

vector <pair <int,int> > rlist;
vector <vector <int> > g;
int n;
vector <int> dp;
vector <pair <int,int> > bad;
vector <int> used;
map <pair <int,int>, int> t;
vector <int> h;
vector <int> par;

void build(int v, int p)
{
    used[v]=1;
    par[v]=p;
    h[v]=h[p]+1;
    for (int u:g[v]){
        if (used[u])continue;
        build(u,v);
    }
}

vector <vector <int> > ans;

void dfs(int v)
{
    used[v]=1;
    for (int u:g[v]){
        if (used[u])continue;
        dfs(u);
    }
    vector <pair <int,int> > down;
    vector <pair <int,int> > up;

    for (int u:g[v]){
        if (u==par[v])continue;
        if (dp[u]==1){
            int t0=t[{v,u}];
            if (t0==1){
                down.push_back({v,u});
            }
            if (t0==2){
                up.push_back({u,v});
            }
            if (t0==3){
                ans.push_back({v,u,u,v});
            }
            continue;
        }
        int t1=0;
        if (h[bad[u].f]<h[bad[u].s])t1=1;
        else t1=2;
        int t0=t[{v,u}];

        if (t0+t1==3){
            cout << "No";
            exit(0);
        }
        if (t0==1){
            ans.push_back({v,u,bad[u].f,bad[u].s});
            continue;
        }
        if (t0==2){
            ans.push_back({u,v,bad[u].f,bad[u].s});
            continue;
        }

        ///t0==3
        if (t1==1){
            ans.push_back({v,u,bad[u].f,bad[u].s});
            up.push_back({u,v});
        }
        if (t1==2){
            ans.push_back({u,v,bad[u].f,bad[u].s});
            down.push_back({v,u});
        }
    }

    if (abs((int)down.size()-(int)up.size())>=2){
        cout << "No";
        exit(0);
    }

    while (down.size()>0 && up.size()>0){
        ans.push_back({up.back().f,up.back().s,down.back().f,down.back().s});
        down.pop_back();
        up.pop_back();
    }
    if (down.size()>0)bad[v]=down[0];
    if (up.size()>0)bad[v]=up[0];

    if (bad[v].f==-1)dp[v]=1;
    else dp[v]=0;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int m;
    cin >> n >> m;
    rlist.resize(m);
    g.resize(n);
    par.resize(n,-1);
    map <pair <int,int>, int> was;
    for (int i=0; i<m; i++){
        int v,u;
        cin >> v >> u;
        v--;
        u--;
        rlist[i]={v,u};
        if (was[{v,u}]==0){
            g[v].push_back(u);
            g[u].push_back(v);
        }
        was[{v,u}]=1;
        was[{u,v}]=1;
    }

    dp.assign(n,0);
    bad.assign(n,{-1,-1});
    used.assign(n,0);
    h.assign(n,-1);
    for (int i=0; i<n; i++){
        if (used[i])continue;
        build(i,i);
    }
    for (int i=0; i<m; i++){
        int v=rlist[i].f;
        int u=rlist[i].s;
        if (h[v]<h[u]){
            t[{v,u}]+=1;
            t[{u,v}]+=1;
        }
        else {
            t[{v,u}]+=2;
            t[{u,v}]+=2;
        }
    }
    used.assign(n,0);
    for (int i=0; i<n; i++){
        if (used[i])continue;
        dfs(i);
        if (dp[i]==0){
            cout << "No";
            return 0;
        }
    }
    cout << "Yes" << '\n';
    for (auto i:ans){
        for (int j:i){
            cout << j+1 << " ";
        }
        cout << endl;
    }
    /*for (int i:dp)cout << i << " " ;
    cout << endl;
    for (int i=0; i<n; i++){
        cout << bad[i].f << " " << bad[i].s << endl;
    }*/
    return 0;
}
/**
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/

