#include <bits/stdc++.h>
using namespace std;

#define int long long
#define s second
#define f first

vector <int> parl;
int n;

int getl(int v)
{
    if (v==-1)return -1;
    if (v==n+2)return v;
    if (parl[v]==v)return v;
    parl[v]=getl(parl[v]);
    return parl[v];
}

void updatel(int v, int u)
{
    v=getl(v);
    u=getl(u);
    if (v==-1)return;
    if (v==n+2)return;
    if (v==u)return;
    parl[v]=u;
}

vector <int> parr;

int getr(int v)
{
    if (v==-1)return -1;
    if (v==n+2)return v;
    if (parr[v]==v)return v;
    parr[v]=getr(parr[v]);
    return parr[v];
}

void updater(int v, int u)
{
    v=getr(v);
    u=getr(u);
    if (v==-1)return;
    if (v==n+2)return;
    if (v==u)return;
    parr[v]=u;
}


signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int q;
    cin >> n >> q;
    vector <int> h(n+2);
    vector <int> x(n+2);
    for (int i=1; i<=n; i++){
        cin >> x[i] >> h[i];
    }
    x[0]=x[1];
    h[0]=10000000000;
    x[n+1]=x[n];
    h[n+1]=10000000000;
    parr.resize(n+2);
    parl.resize(n+2);

    while (q--){
        int l,r;
        cin >> l >> r;
        for (int i=0; i<n+2; i++){
            parr[i]=i;
            parl[i]=i;
        }

        queue <int> p;
        vector <int> used(n+2,0);
        for (int i=l; i<=r; i++){
            int u=getl(i-1);
            if (u!=-1 && x[i]-x[u]>=h[i]){
                p.push(i);
                used[i]=1;
                continue;
            }
            u=getr(i+1);
            if (u!=n+2 && x[u]-x[i]>=h[i]){
                p.push(i);
                used[i]=1;
                continue;
            }
        }

        int cnt=0;
        while (!p.empty()){
            int v=p.front();
            p.pop();
            if (v<l || r<v){
                continue;
            }
            updatel(v,v-1);
            updater(v,v+1);
            cnt++;
            int i=getr(v+1);
            if (i<=r && !used[i]){
                int u=getl(i-1);
                if (u!=-1 && x[i]-x[u]>=h[i]){
                    p.push(i);
                    used[i]=1;
                    continue;
                }
                u=getr(i+1);
                if (u!=n+2 && x[u]-x[i]>=h[i]){
                    p.push(i);
                    used[i]=1;
                    continue;
                }
            }
            i=getl(v-1);
            if (i>=l && !used[i]){
                int u=getl(i-1);
                if (u!=-1 && x[i]-x[u]>=h[i]){
                    p.push(i);
                    used[i]=1;
                    continue;
                }
                u=getr(i+1);
                if (u!=n+2 && x[u]-x[i]>=h[i]){
                    p.push(i);
                    used[i]=1;
                    continue;
                }
            }

        }
        cout << cnt << endl;
    }
}
/**
5 3
1 5
3 1
4 2
5 3
6 1

1 5
5 5
1 1
///
3 3
1 3
3 1
4 2

1 1
2 3
1 3

*/
