#include <bits/stdc++.h>

using namespace std;

#ifndef SEVA
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#endif
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,mmx,abm,fma,popcnt,tune=native")

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef vector<int> vi;
typedef pair<int, int> pi;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define sz(a) int((a).size())

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

#define int ll

struct Edge {
    int u, v, c;

    int to(int from) const {
        return u ^ v ^ from;
    }
};

const int N = 21;

vector<pi> g[N];

bool dp[1 << N][N];
int mn[1 << N];
int mx[1 << N];
int ans[N];

void Solve() {
    int n, m;
    cin >> n >> m;
    vector<Edge> edges;
    forn(i, m) {
        int u, v, t;
        cin >> u >> v >> t;
        u--, v--;
        edges.push_back({u, v, t});
        g[u].emplace_back(v, t);
        g[v].emplace_back(u, t);
    }
    fill(ans, ans + N, INT_MAX);
    for (int mask = 1; mask < (1 << m); mask++) {
        mn[mask] = INT_MAX;
        mx[mask] = INT_MIN;
        if (__builtin_popcount(mask) == 1) {
            for (int i = 0; i < m; i++) {
                if (!(mask >> i & 1))
                    continue;
                auto &e = edges[i];
                mn[mask] = mx[mask] = e.c;
                mn[mask] = mx[mask] = e.c;
                dp[mask][e.v] = e.u == 0;
                dp[mask][e.u] = e.v == 0;
                if (dp[mask][e.v])
                    minq(ans[e.v], mn[mask] + mx[mask]);
                if (dp[mask][e.u])
                    minq(ans[e.u], mn[mask] + mx[mask]);
            }
        } else {
            for (int i = 0; i < m; i++) {
                if (!(mask >> i & 1))
                    continue;
                int subMask = mask ^ (1 << i);
                auto &e = edges[i];
                minq(mn[mask], min(mn[subMask], e.c));
                maxq(mx[mask], max(mx[subMask], e.c));
                dp[mask][e.v] = dp[subMask][e.u];
                dp[mask][e.u] = dp[subMask][e.v];
                if (dp[mask][e.v])
                    minq(ans[e.v], mn[mask] + mx[mask]);
                if (dp[mask][e.u])
                    minq(ans[e.u], mn[mask] + mx[mask]);
            }
        }
    }
    for (int i = 1; i < n; i++) {
        cout << ans[i] << nl;
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    forn(i, t) {
        Solve();
    }
}
