#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vii = vector<int>;

void optimize() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}

const int N = 3e5 + 5;

ll values[27];
ll INF = 1e18;

ll binpow(ll a, ll b) {
    if (b == 0) return 1;
    ll res = binpow(a, b / 2);
    if (b % 2) {
        return res * res * a;
    }
    return res * res;
}

ll dp[26][N];
bool number[26][N];
void solve() {
    string s; cin >> s;
    int n = s.size();
    for (int i = n - 1; i >= 0; --i) {
        for (int k = 0; k < 26; ++k) {
            if (i == n - 1) {
                if (s[i] == '?') {
                    dp[k][i] = values[k], number[k][i] = k;
                }
                else {
                    int num = s[i] - 'A';
                    if (num > k) dp[k][i] = -INF;
                    else dp[k][i] = values[num], number[k][i] = num;
                }
                continue;
            }
            if (s[i] == '?') {
                if (values[k] + dp[k][i + 1] > dp[k][i + 1] - values[k]) number[k][i] = k, dp[k][i] = values[k] + dp[k][i + 1];
                else number[k][i] = k, dp[k][i] = dp[k][i + 1] - values[k];
            }
            else {
                int num = s[i] - 'A';
                if (num > k || dp[k][i + 1] == -INF) dp[k][i] = -INF;
                else if (dp[num][i + 1] + values[num] > dp[k][i + 1] - values[num]) number[k][i] = num, dp[k][i] = dp[num][i + 1] + values[num];
                else number[k][i] = num, dp[k][i] = dp[k][i + 1] - values[num];
            }
        }
    }
    string res = "";
    int k = 25;
    for (int i = 0; i < n; ++i) {
        if (s[i] != '?') {
            res += s[i];
            if (i != n - 1) {
                int num = s[i] - 'A';
                if (dp[num][i + 1] + values[num] > dp[k][i + 1] - values[num]) k = num;
            }
            continue;
        }
        res += 'A' + k;
    }
    cout << dp[25][0] << '\n';
    cout << res << '\n';
}

int main() {
    optimize();
    for (int i = 0; i < 26; ++i) {
        values[i] = binpow(2, i / 2) * binpow(5, (i + 1) / 2);
    }
    int t; cin >> t;
    for (int i = 0; i < t; ++i) solve();

    return 0;
}
