#include <bits/stdc++.h>
using namespace std;

const int MAXN = 3e5 + 100, INF = 1e9;
vector<int> g[MAXN];
int w[MAXN];
int n, m;

int d[MAXN];

array<int, 2> ed[MAXN];

int ans[MAXN];

int used[MAXN];

void dfs(int v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}

main() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        ed[i] = {u, v};
        cin >> w[i];
    }
    fill(ans, ans + n, 2 * INF);
    for (int mask = 1; mask < (1 << m); ++mask) {
        fill(d, d + n, 0);
        fill(used, used + n, 0);
        for (int i = 0; i < n; ++i) {
            g[i].clear();
        }
        int mn = INF, mx = -1;
        for (int i = 0; i < m; ++i) {
            if (mask & (1 << i)) {
                d[ed[i][0]]++;
                d[ed[i][1]]++;
                mn = min(mn, w[i]);
                mx = max(mx, w[i]);
                g[ed[i][0]].push_back(ed[i][1]);
                g[ed[i][1]].push_back(ed[i][0]);
            }
        }
        if (d[0] % 2 == 0) {
            continue;
        }
        int k = -1;
        for (int i = 1; i < n; ++i) {
            if (d[i] % 2 == 1) {
                if (k != -1) {
                    k = -2;
                    break;
                }
                k = i;
            }
        }
        if (k == -2) {
            continue;
        }
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            if (d[i] > 0 && !used[i]) {
                cnt++;
                dfs(i);
            }
        }
        if (cnt > 1) {
            continue;
        }
        ans[k] = min(ans[k], mn + mx);
    }
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << endl;
    }
    return 0;
}
