#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define int long long

map<char, int> value;

struct biba
{
	int Sum;
	string S;
	vector<pair<int, int>> v;

	void Init()
	{
		v.resize(26);
		for (int i = 0; i < 26; i++)
			v[i] = { 0, 0 };
		Sum = 0;
		S = "";
	}
	
	int neg(int x)
	{
		if (x > 0) return -x;
		else return x;
	}

	void Add(char c)
	{
		Sum = 0;
		S += c;
		v[c - 'A'].first++;
		for (char x = 'A'; x <= 'Z'; x++)
		{
			if (x < c)
			{
				v[x - 'A'].second += v[x - 'A'].first;
				v[x - 'A'].first = 0;
			}
			Sum += value[x] * (v[x - 'A'].first - v[x - 'A'].second);
		}
	}

	void Copy(biba& a)
	{
		Sum = a.Sum;
		S = a.S;
		for (int i = 0; i < 26; i++)
			v[i] = a.v[i];
	}
};

int32_t main()
{
	int k = 1;
	for (char c = 'A'; c <= 'Z'; c += 2)
	{
		value[c] = k;
		value[c + 1] = k * 5;
		k *= 10;
	}

	int q;
	cin >> q;
	while (q--)
	{
		string s;
		cin >> s;
		int n = s.length();
		vector<pair<biba, biba>> dp(2);
		dp[0].first.Init();
		dp[0].second.Init();

		if (s[0] == '?')
		{
			dp[0].first.Add('A');
			dp[0].second.Add('Z');
		}
		else
		{
			dp[0].first.Add(s[0]);
			dp[0].second.Add(s[0]);
		}

		for (int i = 1; i < n; i++)
		{
			dp[1].first.Init();
			dp[1].second.Init();

			if (s[i] == '?')
			{
				biba t;
				t.Init();
				biba mn, mx;
				mn.Init(); mx.Init();
				mn.Sum = 1e18; mx.Sum = -1e18;
				for (char x = 'A'; x <= 'Z'; x++)
				{
					t.Copy(dp[0].first);
					t.Add(x);
					if (t.Sum < mn.Sum)
						mn.Copy(t);
					if (t.Sum > mx.Sum)
						mx.Copy(t);
					t.Copy(dp[0].second);
					t.Add(x);
					if (t.Sum < mn.Sum)
						mn.Copy(t);
					if (t.Sum > mx.Sum)
						mx.Copy(t);
				}

				dp[1].first.Copy(mn);
				dp[1].second.Copy(mx);
			}
			else
			{
				dp[1].first.Copy(dp[0].first);
				dp[1].first.Add(s[i]);
				dp[1].second.Copy(dp[0].second);
				dp[1].second.Add(s[i]);
			}

			if (dp[1].first.Sum > dp[1].second.Sum)
				swap(dp[1].first, dp[1].second);
			swap(dp[0], dp[1]);
		}

		cout << dp[0].second.Sum << endl << dp[0].second.S << endl;
	}
	

}