﻿#include<iostream>
#include<string>
#include<vector>
#include<algorithm>
#include<unordered_set>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
using namespace std;

#define veci vector<int>
#define ll long long
#define nint signed
#define FORN(i, a, b) for (int i = a; i < b; ++i)
#define PAI pair<int, int>
#define fastio ios::sync_with_stdio(); cin.tie(0); cout.tie(0);
#define all(v) v.begin(), v.end()
#define MAXN 150000
#define MOD (int)(1e9 + 7)

veci g[MAXN];
int dp[MAXN][3], numedg[MAXN] = { 0 };

ll has(PAI x) {
	return (x.first * MAXN + x.second) % MOD;
}

PAI inout[MAXN];
unordered_set<int> now;

int fl = 1;
veci g_comp[MAXN];

void dfs_dp(int v, int p, veci& used) {
	if (!fl) return;
	used[v] = 1;
	for (int u : g_comp[v]) {
		if (u == p) {
			continue;
		}
		dfs_dp(u, v, used);
		if (!fl) return;
	}
	if (g_comp[v].size() == 1 && g_comp[v][0] == p) {
		dp[v][0] = 1;
		dp[v][1] = 0;
		dp[v][2] = 0; return;
	}
	int could = 1;
	int in = 0, out = 0;
	for (int u : g_comp[v]) {
		if (u == p) continue;
		if (dp[u][0] == 1) {
			in += (now.find(has({u, v})) != now.end());
			out += (now.find(has({v, u})) != now.end());
			continue;
		}
		else if (dp[u][1]) {
			could = (now.find(has({ v, u })) != now.end());
			in += (now.find(has({u, v})) != now.end());
		}
		else {
			could = (now.find(has({u, v})) != now.end());
			out += (now.find(has({v, u})) != now.end());
		}
		if (!could) break;
	}
	if (!could) {
		fl = 0; return;
	}
	if (in == out) {
		dp[v][0] = 1; return;
	}
	else if (in - 1 == out) {
		dp[v][2] = 1; return;
	}
	else if (in == out - 1) {
		dp[v][1] = 1; return;
	}
	else {
		fl = 0; return;
	}
}

unordered_map<int, int> ANS;
int ost[MAXN];

void get_ans(int v, int p) {
	for (int u : g_comp[v]) {
		if (u == p) {
			continue;
		}
		get_ans(u, v);
	}
	priority_queue<int> IN, OUT;
	for (int u : g[v]) {
		if (u == p) continue;
		if (dp[u][1]) {
			ANS[ost[u]] = has({v, u});
			ANS[has({v, u})] = ost[u];
			if (now.find(has({u, v})) != now.end()) {
				IN.push(has({u, v}));
			}
		}
		if (dp[u][2]) {
			ANS[ost[u]] = has({u, v});
			ANS[has({u, v})] = ost[u];
			if (now.find(has({v, u})) != now.end()) {
				OUT.push(has({v, u}));
			}
		}
		if (dp[u][0]) {
			if (now.find(has({v, u})) != now.end()) {
				OUT.push(has({v, u}));
			}
			if (now.find(has({u, v})) != now.end()) {
				IN.push(has({u, v}));
			}
		}
	}
	if (dp[v][1]) {
		ost[v] = OUT.top();
		OUT.pop();
		while (!IN.empty()) {
			int Y = OUT.top();
			int X = IN.top();
			ANS[X] = Y;
			ANS[Y] = X;
			OUT.pop();
			IN.pop();
		}
	}
	if (dp[v][2]) {
		ost[v] = IN.top();
		IN.pop();
		while (!IN.empty()) {
			int Y = OUT.top();
			int X = IN.top();
			ANS[X] = Y;
			ANS[Y] = X;
			OUT.pop();
			IN.pop();
		}
	}
	if (dp[v][0]) {
		while (!IN.empty()) {
			int Y = OUT.top();
			int X = IN.top();
			ANS[X] = Y;
			ANS[Y] = X;
			OUT.pop();
			IN.pop();
		}
	}
}

nint main() {
	fastio;
	int n, m; cin >> n >> m;
	map<int, PAI> obr;
	FORN(i, 0, m) {
		int u, v; cin >> u >> v; --u, --v; 
		obr[has({ u, v })] = { u, v };
		obr[has({ v, u })] = { v, u };
		inout[u].second++;
		inout[v].first++;
		if (now.find(has({u, v})) == now.end() && now.find((has({v, u}))) == now.end()) {
			g_comp[u].push_back(v);
			g_comp[v].push_back(u);
			g[u].push_back(v); g[v].push_back(u);
		}
		now.insert(has({u, v}));
	}
	veci used(n, 0);
	veci starts;
	FORN(v, 0, n) {
		if (!fl) break;
		if (used[v] == 0) {
			dfs_dp(v, -1, used);
			if (dp[v][0] == 0) fl = 0;
			starts.push_back(v);
		}
	}
	if (!fl) {
		cout << "No\n"; return 0;
	}
	cout << "Yes\n";
	for (int v : starts) {
		get_ans(v, -1);
	}
	map<int, int> USED;
	
	for (int X : now) {
		USED[X] = 0;
	}
	for (int X : now) {
		if (USED[X]) continue;
		cout << obr[X].first + 1 << ' ' << obr[X].second + 1 << ' ';
		int Y = ANS[X];
		cout << obr[Y].first + 1 << ' ' << obr[Y].second + 1 << ' ';
		USED[X] = 1;
		USED[Y] = 1;
		cout << '\n';
	}
	return 0;
}