#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y)
{
    return y < x ? (x = y, true) : false;
}
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y)
{
    return y > x ? (x = y, true) : false;
}
void debug_out()
{
    cerr << endl;
}
template<typename T1, typename... T2> void debug_out(T1 A, T2... B)
{
    cerr << ' ' << A;
    debug_out(B...);
}
template<typename T> void mdebug_out(T* a, int n)
{
    for (int i = 0; i < n; ++i)
        cerr << a[i] << ' ';
    cerr << endl;
}
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T>& a)
{
    for (auto x : a)
        stream << x << ' ';
    return stream;
}
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2>& p)
{
    return stream << p.first << ' ' << p.second;
}

const int maxN = 500005;
const int quadN = 10004;
int n, Q;
int X[maxN], H[maxN];

int V;
const int maxV = 2 * quadN;
int banv[2 * maxN];
bitset<maxV> G[maxV];
int indeg[maxV], indeg1[maxV];
void addEdgeG(int a, int b)
{
    //debug(a, b);
    G[a][b] = 1;
    ++indeg[b];
}
bool taken[maxV];

struct Query
{
    int l, r;
} qr[maxN];

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> Q;
    for (int i = 0; i < n; ++i)
        cin >> X[i] >> H[i];
    for_each(qr, qr + Q, [&](Query& q)
    {
        cin >> q.l >> q.r;
        --q.l;
        --q.r;
    });
    for (int i = 0; i < n; ++i)
    {
        if (X[i] - H[i] >= X[0])
        {
            for (int j = i - 1; j >= 0; --j)
            {
                if (X[j] <= X[i] - H[i]) break;
                addEdgeG(2 * j, 2 * i);
                addEdgeG(2 * j + 1, 2 * i);
            }
        }
        else banv[2 * i] = 1;
        if (X[i] + H[i] <= X[n - 1])
        {
            for (int j = i + 1; j < n; ++j)
            {
                if (X[j] >= X[i] + H[i]) break;
                addEdgeG(2 * j, 2 * i + 1);
                addEdgeG(2 * j + 1, 2 * i + 1);
            }
        }
        else banv[2 * i + 1] = 1;
    }
    V = 2 * n;
    for_each(qr, qr + Q, [&](Query& q)
    {
        for (int v = 0; v < V; ++v)
        {
            indeg1[v] = indeg[v];
        }
        for (int i = 0; i < n; ++i)
        {
            taken[i] = false;
        }
        vector<int> z;
        for (int v = 2 * q.l; v <= 2 * q.r + 1; ++v)
        {
            if (!indeg1[v] && !banv[v])
                z.push_back(v);
        }
        int ans = 0;
        for (; !z.empty(); )
        {
            int v = z.back();
            z.pop_back();
            int i = v / 2;
            if (taken[i] || banv[v]) continue;
            taken[i] = true;
            ++ans;
            for (int u = 0; u < V; ++u)
            {
                if (G[v][u])
                    --indeg1[u];
                if (G[v ^ 1][u])
                    --indeg1[u];
                if (indeg1[u] == 0 && 2 * q.l <= u && u <= 2 * q.r + 1 && !banv[u])
                    z.push_back(u);
            }
        }
        cout << ans << '\n';
    });

    return 0;
}