#include <iostream>

#include <algorithm>

#include <vector>

using namespace std;

typedef long long ll;

vector<vector<pair<int, int>>> g;

vector<int> ans;

vector<vector<bool>> used_e;

void dfs(int v, int a, int b) {
	ans[v] = min(ans[v], a + b);

	random_shuffle(g[v].begin(), g[v].end());
	int to = g[v][0].first, c = g[v][0].second;

	if (!used_e[v][to]) {
		used_e[to][v] = used_e[v][to] = true;
		dfs(to, min(a, c), max(b, c));
	}
}
int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int n, m; cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int v, u, c; cin >> v >> u >> c;
		v--; u--;

		g[v].push_back({ u, c });
		g[u].push_back({ v, c });
	}

	ans.assign(n, 2e9);

	for (int q = 0; q < 100000; q++) {
		used_e.assign(n, vector<bool>(n, false));
		dfs(0, 1e9, 0);
	}

	for (int i = 1; i < n; i++) {
		cout << ans[i] << '\n';
	}
	return 0;
}