#include <bits/stdc++.h>
using namespace std;

using ll = long long;

vector<ll> lazy_calc(30, -1);
ll calc(int pos) {
    if (lazy_calc[pos] == -1) {
        lazy_calc[pos] = pos == 0 ? 1 : calc(pos - 1);
        if (pos % 2 == 1) {
            lazy_calc[pos] *= 5;
        } else if (pos != 0) {
            lazy_calc[pos] *= 2;
        }
    }

    return lazy_calc[pos];
}

void solve() {
    string s;
    cin >> s;

    int n = s.size();
    vector<int> right(n);
    right[n - 1] = n - 1;

    stack<int> p;
    p.push(n - 1);
    for (int i = n - 2; i >= 0; i--) {
        if (s[p.top()] > s[i]) {
            right[i] = p.top();
        } else {
            right[i] = i;
            p.push(i);
        }
    }

    ll ans = 0;
    for (int i = 0; i < n; i++) {
        if (right[i] == i) {
            ans += calc(s[i] - 'A');
        } else {
            ans -= calc(s[i] - 'A');
        }
    }

    cout << ans << "\n";
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}
