#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
void initial()
{
#ifdef PC
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}
#define all(x) (x).begin(), (x).end()
#define sz(x) ((long long)(x).size())
#define pb push_back
typedef long long ll;
const ll maxn = 3e5 + 10;
vector <pair <ll, ll> > g[maxn];
ll mx[maxn];
bool used[maxn];
int main() {
    initial();
    ll n, m;
    cin >> n >> m;
    memset(mx, -1, sizeof(mx));
    for (int i = 0; i < m; i++)
    {
        ll f, t, c;
        cin >> f >> t >> c;
        g[f].pb({t, c});
        g[t].pb({f, c});
    }
    priority_queue <pair <ll, ll> > q;
    memset(mx, -1, sizeof(mx));
    q.push({0, 1});
    while (!q.empty())
    {
        auto[v, d] = q.top();
        q.pop();
        if (used[v]) continue;
        used[v] = true;
        for (auto [t, c] : g[v])
        {
            if (mx[t] == -1 || mx[t] > max(c, d))
            {
                mx[t] = max(c, d);
                q.push({-mx[t], t});
            }
        }
    }
    for (int i = 2; i <= n; i++)
        cout << mx[t] << '\n';
    return 0;
}
