#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int maxn = 3e5, INF = 1e9 + 7;
int ans[maxn];


struct Edge {
    int u, v, t, ind;
    bool used;
    Edge(){};
    Edge(int uu, int vv, int tt, int indd) {
        u = uu;
        v = vv;
        t = tt;
        ind = indd;
        used = false;
    }
};

vector<Edge> adj[maxn];


void dfs_tree(int u, int minn = INF, int maxx = -INF) {
    ans[u] = minn + maxx;
    for (auto edge : adj[u]) {
        if (!edge.used) {
            edge.used = true;
            adj[edge.v][edge.ind].used = true;
            dfs_tree(edge.v, min(minn, edge.t), max(maxx, edge.t));
        }
    }
}


signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u; --v;
        adj[u].emplace_back(u, v, t, adj[v].size());
        adj[v].emplace_back(v, u, t, (int)adj[u].size() - 1);
    }
    if (n - 1 == m) {
        dfs_tree(0);
        for (int i = 1; i < n; ++i) {
            cout << ans[i] << " ";
        }
    }
}