﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

vector<long long> val(26);

long long Int(string& s) {
	long long res = 0;
	int n = s.size();
	vector<char> m(n, 'A');
	char M = 'A';
	for (int i = n - 1; i >= 0; --i) {
		if (s[i] != '?') {
			M = max(s[i], M);
		}
		m[i] = M;
	}
	vector<int> cnt(26, 0);
	long long curres;
	int cntdel;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '?') {
			curres = res + val[0];
			cntdel = 0;
			for (int j = 1; j <= 25; ++j) {
				curres = curres - val[j - 1] + val[j] - 2 * cnt[j - 1] * val[j - 1];
				if (curres > res) {
					cntdel = j;
					res = curres;
				}
			}
			for (int j = 0; j < cntdel; ++j) {
				cnt[j] = 0;
			}
			s[i] = cntdel + 'A';
		}
		else {
			if (m[i] <= s[i]) {
				++cnt[s[i] - 'A'];
			}
			else {
				res -= val[s[i] - 'A'];
			}
		}
	}
	for (int i = 0; i < 26; ++i) {
		res += cnt[i] * val[i];
	}
	return res;
}

void sol() {
	string s;
	cin >> s;
	long long res = Int(s);
	cout << res << '\n' << s << '\n';
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	val[0] = 1;
	for (int i = 1; i < 26; ++i) {
		if (i & 1) {
			val[i] = val[i - 1] * 5;
		}
		else {
			val[i] = val[i - 1] * 2;
		}
	}

	int t;
	cin >> t;
	for (; t; --t) {
		sol();
	}

	return 0;
}
