#include <bits/stdc++.h>
using namespace std;
typedef long long lint;
int n, m;
vector<vector<int>> graph;
vector<int> c;
vector<vector<int>> edges;
void dfs(int v, int p, int fl){
    c[v] = fl;
    for (auto h: graph[v]){
        if (h == p) continue;
        dfs(h, v, fl ^ 1);
    }
}
vector<vector<int>> gr;
vector<int> used;
vector<int> px;
vector<int> py;
map<vector<int>, int> d;
int sz1, sz2;
int dfspar(int v){
    used[v] = 1;
    for (auto h: gr[v]){
        if ((py[h] == -1) or (!used[py[h]] and dfspar(py[h]))){
            py[h] = v;
            px[v] = h;
            return 1;
        }
    }
    return 0;
}
int kun(){
    int cnt = 0;
    for (int i = 0; i < sz1; i++){
        for (auto h: gr[i]){
            if (py[h] == -1){
                cnt++;
                px[i] = h;
                py[h] = i;
                break;
            }
        }
    }
    for (int i = 0; i < sz1; i++){
        if (px[i] == -1){
            used.assign(sz1, 0);
            cnt += dfspar(i);
        }
    }
    return cnt;
}
void print(vector<vector<int>> a){
    sort(a.begin(), a.end());
    auto last = unique(a.begin(), a.end());
    a.erase(last, a.end());
    for (auto h: a){
        for (auto u: h) cout << u << " ";
        cout << endl;
    }
}
void solve(){
    vector<int> e1;
    vector<int> e2;
    vector<vector<int>> e;
    vector<vector<int>> ans;
    for (int i = 0; i < m; i++){
        int a, b; a = edges[i][0] + 1;
        b = edges[i][1] + 1;
        if (d[{a, b}] == 1 and d[{b, a}] == 1){
            if (a < b) ans.push_back({a, b, b, a});
        }
        else e.push_back({a, b});
    }
    if (e.size() == 0){
        print(ans);
        return;
    }
    e1 = e[0];
    e2 = e[1];
    /*cout << e1[0] << " " << e1[1] << endl;
    cout << e2[0] << " " << e2[1] << endl;*/
    if (e1[0] == e2[1] or e1[1] == e2[0]){
        cout << "Yes\n";
        if (e1[0] == e2[1]) cout << e2[0] << " " << e2[1] << " " << e1[0] << " " << e1[1] << endl;
        else cout << e1[0] << " " << e1[1] << " " << e2[0] << " " << e2[1] << endl;
        print(ans);
    }
    else{
        cout << "No\n";
    }
}
int main(){
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> m;
    graph.assign(n, vector<int>());
    c.assign(n, -1);
    for (int i = 0; i < m; i++){
        int a, b; cin >> a >> b;
        d[{a, b}] = 1;
        edges.push_back({a - 1, b - 1});
        graph[a - 1].push_back(b - 1);
        graph[b - 1].push_back(a - 1);
    }
    if (m == 2 * n - 4){
        solve();
        return 0;
    }
    for (int i = 0; i < n; i++){
        if (c[i] == -1) dfs(i, i, 0);
    }
    //for (auto h: c) cout << h << " ";
    //cout << endl;
    vector<vector<int>> sl;
    vector<vector<int>> sr;
    for (int i = 0; i < m; i++){
        int a = edges[i][0]; int b = edges[i][1];
        if (c[a] == 0 and c[b] == 1) sl.push_back({a, b});
        else sr.push_back({a, b});
    }
    /*for (auto h: sl) cout << h[0] << " " << h[1] << endl;
    cout << endl;
    for (auto h: sr) cout << h[0] << " " << h[1] << endl;
    cout << endl;*/
    sz1 = sl.size();
    sz2 = sr.size();
    if (sz1 != sz2){
        cout << "No";
        return 0;
    }
    gr.assign(sz1, vector<int>());
    for (int i = 0; i < sz1; i++){
        for (int j = 0; j < sz2; j++){
            if (sl[i][0] == sr[j][1] or sl[i][1] == sr[j][0]){
                gr[i].push_back(j);
            }
        }
    }
    /*for (auto h: gr){
        for (auto u: h) cout << u << " ";
        cout << endl;
    }*/
    px.assign(sz1, -1);
    py.assign(sz2, -1);
    used.assign(sz1, 0);
    int cnt = kun();
    /*cout << cnt << endl;*/
     if (sz1 != cnt){
        cout << "No";
        return 0;
     }
     cout << "Yes\n";
    for (int i = 0; i < sz1; i++){
        if (sl[i][1] == sr[px[i]][0]){
            cout << sl[i][0] + 1 << " " << sl[i][1] + 1 << " ";
            cout << sr[px[i]][0] + 1 << " " << sr[px[i]][1] + 1 << " ";
        }
        else{
            cout << sr[px[i]][0] + 1 << " " << sr[px[i]][1] + 1 << " ";
            cout << sl[i][0] + 1 << " " << sl[i][1] + 1 << " ";
        }
        cout << endl;
    }
}
