#include <bits/stdc++.h>

using namespace std;

const int INF = 1000000001;

vector< vector< pair<int, int> > > adj;

vector<int> ans;

void dfs(int u, int p, int cmax, int cmin) {
	ans[u] = cmax + cmin;
	for(auto [v, t]: adj[u]) {
		if(v == p) {
			continue;
		}
		dfs(v, u, max(cmax, t), min(cmin, t));
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;
	assert(m == n - 1);

	adj.resize(n);
	for(int i = 0; i < m; i++) {
		int u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		adj[u].emplace_back(v, t);
		adj[v].emplace_back(u, t);
	}

	ans.resize(n);
	dfs(0, -1, -INF, INF);

	for(int i = 1; i < n; i++) {
		cout << ans[i] << " ";
	}
	cout << endl;

	return 0;
}