import java.io.*;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class A {
    public static int kun(int v) {
        if (used[v] == time) {
            return 0;
        }
        used[v] = time;
        for (int to : g[v]) {
            if (take[to] == -1 || kun(take[to]) == 1) {
                take[to] = v;
                return 1;
            }
        }
        return 0;
    }

    public static void dfs(int v, int c) {
        used[v] = 1;
        col[v] = c;
        if (c == 0) {
            ++bal;
        } else {
            --bal;
        }
        c = (c + 1) % 2;
        for (int to : g[v]) {
            if (used[to] == 0) {
                dfs(to, c);
            }
        }
    }
    public static int time = 1;
    public static int[] used;
    public static int[] take;
    public static int[] col;
    public static int bal = 0;
    public static ArrayList<Integer>[] g;

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter writer = new PrintWriter(System.out);
        StringTokenizer st = new StringTokenizer(reader.readLine());
        int n = Integer.parseInt(st.nextToken());
        int m = Integer.parseInt(st.nextToken());
        int[][] edges = new int[m][2];
        g = new ArrayList[m];
        for (int i = 0; i < m; ++i) {
            g[i] = new ArrayList<>();
        }
        LinkedList<Integer>[] start = new LinkedList[n];
        LinkedList<Integer>[] end = new LinkedList[n];
        for (int i = 0; i < n; ++i) {
            start[i] = new LinkedList<>();
            end[i] = new LinkedList<>();
        }
        for (int i = 0; i < m; ++i) {
            st = new StringTokenizer(reader.readLine());
            int a = Integer.parseInt(st.nextToken()) - 1;
            int b = Integer.parseInt(st.nextToken()) - 1;
            edges[i][0] = a + 1;
            edges[i][1] = b + 1;
            start[a].add(i);
            end[b].add(i);
        }
        for (int i = 0; i < n; ++i) {
            for (int from : start[i]) {
                for (int to : end[i]) {
                    g[from].add(to);
                    g[to].add(from);
                }
            }
        }
        used = new int[m];
        take = new int[m];
        col = new int[m];
        for (int i = 0; i < m; ++i) {
            if (used[i] == 0) {
                dfs(i, 0);
            }
        }
        if (bal != 0) {
            System.out.println("No");
            return;
        }
        for (int i = 0; i < m; ++i) {
            if(col[i] == 1){
                continue;
            }
            ++time;
            if (kun(i) == 0) {
                System.out.println("No");
                return;
            }
        }
        writer.println("Yes");
        for (int i = 0; i < m; ++i) {
            if (take[i] != -1) {
                int j = take[i];
                writer.println(edges[i][0] + " " + edges[i][1] + " " + edges[j][0] + " " + edges[j][1]);
            }
        }
        writer.close();
    }
}