#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 2000000001;

using namespace std;

vector<vector<p>> d;
vector<int> dist;
vector<bool> was;
vector<vector<int>> d1;

int DFS(int vertex){
    was[vertex] = true;
    int ans = d1[vertex].size();
    for (int q: d1[vertex]){
        if (!was[q]){
            ans += DFS(q);
        }
    }
    return ans;
}

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    d.assign(n, {});
    map<p, int> edge_map;
    vector<pair<p, int>> edge;
    for (int q = 0; q < m; q++){
        int x, y, z;
        cin >> x >> y >> z;
        x--, y--;
        edge_map[{x, y}]++, edge_map[{y, x}]++;
        d[x].push_back({y, z});
        d[y].push_back({x, z});
        edge.push_back({{x, y}, z});
    }
    dist.assign(n, INF);
    for (int q = 0; q < (1 << m); q++){
        int min1 = INF, max1 = -INF, num = 0;
        d1.assign(n, {}), was.assign(n, false);
        for (int q1 = 0; q1 < m; q1++){
            if ((q >> q1) & 1){
                min1 = min(min1, edge[q1].second), max1 = max(max1, edge[q1].second);
                d1[edge[q1].first.first].push_back(edge[q1].first.second);
                d1[edge[q1].first.second].push_back(edge[q1].first.first);
                num++;
            }
        }
        int num_now = DFS(0)/2, ind = -1;
        if (num_now == num && d1[0].size() % 2 == 1){
            for (int q1 = 1; q1 < n; q1++){
                if (d1[q1].size() % 2 == 1 && ind == -1){
                    ind = q1;
                }else if (d1[q1].size() % 2 == 1){
                    ind = -1;
                    break;
                }
            }
            if (ind != -1){
                dist[ind] = min(dist[ind], min1+max1);
            }
        }
    }
    for (int q = 1; q < n; q++){
        cout << dist[q] << endl;
    }
    return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1

7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9

4 4
1 2 2
3 2 0
2 4 3
4 3 1

*/
