#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

using namespace std;

typedef int ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(4e3) + 123;
const ll maxn = ll(1e4) + 5;

ll n, q;
vector<ll> a, hs;

ll can_fall[maxn]; /// (immediately)

vector<ll> good;
ll ps[maxn], used[maxn], pre[maxn], nx[maxn];

void check(ll ind, ll l, ll r) {
    ll pos = ps[ind];

    if(used[ind]) return;

    if(pre[ind] == -1) {
        if(l == 0) {
            if(a[0] <= a[pos] - hs[pos]) {
                if(!used[ind]) {
                    good.pb(ind);
                    used[ind] = 1;
                }
            }
        } else {
            if(a[l - 1] <= a[pos] - hs[pos]) {
                if(!used[ind]) {
                    good.pb(ind);
                    used[ind] = 1;
                }
            }
        }
    } else {
        ll prev = ps[pre[ind]];
        if(a[prev] <= a[pos] - hs[pos]) {
            if(!used[ind]) {
                good.pb(ind);
                used[ind] = 1;
            }
        }
    }

    if(nx[ind] == -1) {
        if(r == n - 1) {
            if(a[pos] + hs[pos] <= a[n - 1]) {
                if(!used[ind]) {
                    good.pb(ind);
                    used[ind] = 1;
                }
            }
        } else {
            if(a[pos] + hs[pos] <= a[r + 1]) {
                if(!used[ind]) {
                    good.pb(ind);
                    used[ind] = 1;
                }
            }
        }
    } else {
        ll nxt = ps[nx[ind]];
        if(a[pos] + hs[pos] <= a[nxt]) {
            if(!used[ind]) {
                good.pb(ind);
                used[ind] = 1;
            }
        }
    }
}

void solve() {
    cin >> n >> q;
    for(ll i = 0; i < n; i++) {
        ll x, h;
        cin >> x >> h;
        a.pb(x);
        hs.pb(h);
    }

    for(ll i = 0; i < n; i++) {
        bool cur = false;

        if(i > 0 && a[i - 1] <= a[i] - hs[i]) {
            cur = true;
        }
        if(i < n - 1 && a[i] + hs[i] <= a[i + 1]) {
            cur = true;
        }

        can_fall[i] = cur;
    }

    for(ll tt = 0; tt < q; tt++) {
        ll l, r;
        cin >> l >> r;
        l--;
        r--;

        for(ll i = l; i <= r; i++) {
            ps[i - l] = i;
            used[i - l] = 0;

            if(i == l) {
                pre[i - l] = -1;
            } else pre[i - l] = i - l - 1;

            if(i == r) {
                nx[i - l] = -1;
            } else nx[i - l] = i - l + 1;
        }

        ll ans = 0;

        good.clear();

        for(ll i = l; i <= r; i++) {
            check(i - l, l, r);
        }

        for(ll s = 0; s < (r - l + 1); s++) {
            if(good.size() == 0) {
                break;
            }

            ll cur = good.back();

            if(pre[cur] != -1) {
                nx[pre[cur]] = nx[cur];
            }
            if(nx[cur] != -1) {
                pre[nx[cur]] = pre[cur];
            }
            ps[cur] = -1;
            good.pop_back();

            if(nx[cur] != -1) {
                check(nx[cur], l, r);
            }
            if(pre[cur] != -1) {
                check(pre[cur], l, r);
            }
            ans++;
        }

        cout << ans << "\n";
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
