#include <iostream>
#include <map>
#include <cmath>
#include <vector>

#define int long long
using namespace std;

int count(string s) {
    int maxn = 0, cnt = 0;
    for (int i = (int)s.size() - 1; i >= 0; --i) {
        if ((int)s[i] - 65 >= maxn) {
            maxn = (int)s[i] - 65;
            if (((int)s[i] - 65) % 2 == 0) {
                if ((int)s[i] - 65 == 0) {
                    cnt++;
                } else {
                    cnt+= pow(10, ((int)s[i] - 65) / 2);
                }
            } else {
                cnt += (int)(5 * pow(10, (((int)s[i] - 65) / 2)));
            }
        } else {
            if (((int)s[i] - 65) % 2 == 0) {
                if ((int)s[i] - 65 == 0) {
                    cnt--;
                } else {
                    cnt-= (int)(pow(10, (((int)s[i] - 65) / 2)));
                }
            } else {
                cnt -= (int)(5 * pow(10, (((int)s[i] - 65) / 2)));
            }
        }
    }
    return cnt;
}
pair<int, string> binsearch(string &s, const vector<int>& a) {
    int r = 0, l = 26;
    int best = -1e18;
    string bests = s;
    while (l - r > 1) {
        int m = (l + r) / 2;
        for (auto i : a) {
            s[i] = (char)(m + 65);
        }
        int cur = count(s);
        if (cur > best) {
            best = cur;
            bests = s;
            r = m;
        } else {
            l = m;
        }
    }
    return {best, bests};
}
int32_t main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        vector<int> a;
        for (int j = 0; j < s.size(); ++j) {
            if (s[j] == '?') {
                a.push_back(j);
            }
        }
        if (a.empty()) {
            cout << s << "\n" << count(s) << "\n";
        } else {
            auto[best_ans, bests] = binsearch(s, a);
            cout << best_ans << "\n";
            cout << bests << "\n";
        }

    }
}
