#include <bits/stdc++.h>
using namespace std;

#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(v) v.begin(), v.end()

inline int h(char c)
{
    return c - 'A';
}

vector<ll> val(26, 1);

ll check(string s, vector<bool> &g, int n, int last)
{
    for(int i = 0; i < s.size(); ++i)
    {
        if(g[i])
        {
            s[i] = max(s[i], char('A' + last));
        }
    }
    set<char> q;
    ll ans = 0;
    while(s.size() > 0)
    {
        char c = s[s.size() - 1];
        if(q.upper_bound(c) == q.end())
            ans += val[h(c)];
        else
            ans -= val[h(c)];
        q.insert(c);
        s.pop_back();
    }
    return ans;
}

signed main()
{
    ios;
    int t;
    cin >> t;
    for(int i = 1; i < 26; ++i)
    {
        if(i % 2 == 1)
        {
            val[i] = 5 * val[i - 1];
        }
        else
        {
            val[i] = 2 * val[i - 1];
        }
    }
    while(t--)
    {
        string s;
        cin >> s;
        string w = "";
        ll ans = 0;
        set<char> q;
        while(s.size() > 0 && s[s.size() - 1] != '?')
        {
            char c = s[s.size() - 1];
            if(q.upper_bound(c) == q.end())
                ans += val[h(c)];
            else
                ans -= val[h(c)];
            q.insert(c);
            w.push_back(c);
            s.pop_back();
        }
        reverse(all(w));
        int n = s.size();
        if(n == 0)
        {
            cout << ans << '\n' << w << '\n';
            continue;
        }
        vector<bool> g(n, 0);
        for(int i = 0; i < n; ++i)
        {
            if(s[i] == '?')
                g[i] = 1;
        }
        for(int i = 0; i < n; ++i)
        {
            if(g[i])
            {
                pair<ll, int> best = {-1, -1};
                for(int k = 0; k < 26; ++k)
                {
                    s[i] = 'A' + k;
                    best = max(best, make_pair(check(s, g, i + 1, k), k));
                }
                s[i] = 'A' + best.second;
            }
        }
        cout << check(s, g, n, s[n - 1]) + ans << '\n' << s + w << '\n';
    }
    return 0;
}

/**
4
BBBC
????
A?B?C?D
YYYYY?
**/
