#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::pair;
using std::string;

using ll = long long;
using ld = long double;

#define int ll

const int INF = 1e9 + 1e6;


signed main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, q;
	cin >> n >> q;

	vector<int> x(n + 2), h(n + 2);
	for (int i = 1; i < n + 1; ++i) {
		cin >> x[i] >> h[i];
		x[i] += i;
	}
	x[0] = x[1] - 1;
	h[0] = INF;
	x[n + 1] = x[n] + 1;
	h[n + 1] = INF;

	vector<vector<int>> right(n + 2), left(n + 2);
	vector<int> cntr(n + 2), cntl(n + 2);

	while (q--) {
		int l, r;
		cin >> l >> r;
		--l;
		++l, ++r;

		vector<int> st = {l - 1};

		for (int i = l; i < r; ++i) {
			left[i].clear();
			cntl[i] = 0;
			bool f = true;
			for (int j = i; j >= l - 1 && x[j] + h[j] >= x[i]; --j) {
				++cntl[i];
				left[j].push_back(i);
			}
		}

		st = {r};

		for (int i = r - 1; i >= l; --i) {
			right[i].clear();
			cntr[i] = 0;
			for (int j = i; j < r + 1 && x[j] - h[j] <= x[i]; ++j) {
				++cntr[i];
				right[j].push_back(i);
			}
		}

		vector<int> good;
		for (int i = l; i < r; ++i) {
			if (cntl[i] == 0 || cntr[i] == 0)
				good.push_back(i);
		}

		for (int ind = 0; ind < good.size(); ++ind) {
			int i = good[ind];
			for (int j : left[i]) {
				assert(cntl[j] != 0);
				--cntl[j];
				if (cntl[j] == 0 && cntr[j] != 0)
					good.push_back(j);
			}

			for (int j : right[i]) {
				assert(cntr[j] != 0);
				--cntr[j];
				if (cntr[j] == 0 && cntl[j] != 0)
					good.push_back(j);
			}
		}
		cout << good.size() << '\n';
	}

	return 0;
}