#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#define int long long
using namespace std;

const int maxn = 3e5 + 228;
vector<pair<int, int> > g[maxn];
int ans[maxn];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<int, pair<int, int> > >  edges;
    for(int i=0; i<m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        edges.push_back(make_pair(a, make_pair(b, c)));
    }
    sort(edges.begin(), edges.end());
    for(int &i:ans)
        i = 2e9;
    for(int i=0; i<m; i++) {
        g[edges[i].first].push_back(make_pair(edges[i].second.first, edges[i].second.second));
        g[edges[i].second.first].push_back(make_pair(edges[i].first, edges[i].second.second));
        vector<int> cur(n, 2e9);
        priority_queue<pair<int, int>> q;
        cur[0] = 0;
        q.push(make_pair(0, 0));
        while(!q.empty()){
            int v = q.top().second;
            q.pop();
            for(pair<int, int> i:g[v]){
                if(cur[i.first] > max(i.second, cur[v])){
                    cur[i.first] = max(i.second, cur[v]);
                    q.push(make_pair(-cur[i.first], i.first));
                }
            }
        }
        for(int j=0; j<n; j++){
            ans[j] = min(ans[j], edges[i].second.second + cur[j]);
        }
    }
    for(int i=1; i<n; i++){
        cout << ans[i] << endl;
    }
    return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1
==========

 */