#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 3e5;
const int inf = 1e15;
vector<pair<int, pair<int, int>>> g[maxn];
int ans[maxn];
bool used[maxn];

void dfs2(int v, int mn, int mx, int p) {
    ans[v] = min(ans[v], mn + mx);
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first;
        if (to == p)continue;
        int t = g[v][i].second.first;
        dfs2(to, min(mn, t), max(mx, t), v);
    }
}

int k = -1;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    for (int i = 0; i < maxn; ++i) {
        ans[i] = inf;
    }
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        int t;
        cin >> t;
        g[a].push_back({b, {t, i}});
        g[b].push_back({a, {t, i}});
    }
    if (n - 1 == m) {
        dfs2(0, inf, -inf, -1);
        for (int i = 1; i < n; ++i) {
            cout << ans[i] << "\n";
        }
    } else {
        int need[n];
        int secneed[n];
        for (int i = 0; i < n; ++i) {
            need[i] = inf;
            vector<int> tt;
            for (int j = 0; j < g[i].size(); ++j) {
                if (g[i][j].first != i + 1)continue;
                int to = g[i][j].second.first;
                tt.push_back(to);
                need[i] = min(need[i], to);
            }
            sort(tt.begin(), tt.end());
            if (tt.size() <= 1) {
                secneed[i] = inf;
                continue;
            }
            secneed[i] = tt[1];
        }
        int mx = -inf;
        int mn = inf;
        for (int i = 0; i < n - 1; ++i) {
            mx = max(need[i], mx);
            mn = min(need[i], mn);
            int mx2 = -inf;
            int mn2 = inf;
            for (int j = i; j >= 0; --j) {
                mx2 = max(secneed[j], mx2);
                mn2 = min(secneed[j], mn2);
                ans[j] = min(ans[j], max(mx2, mx) + min(mn2, mn));
            }
        }
        for (int i = 0; i < n - 1; ++i) {
            cout << ans[i] << "\n";
        }
    }
}
