#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 3e5;
const int inf = 1e15;
vector<pair<int, pair<int, int>>> g[maxn];
int ans[maxn];
bool used[maxn];
void dfs(int v, int mn, int mx) {
    ans[v] = min(ans[v], mn + mx);
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first;
        int t = g[v][i].second.first;
        if (used[g[v][i].second.second])continue;
        used[g[v][i].second.second] = true;
        dfs(to, min(mn, t), max(mx, t));
        used[g[v][i].second.second] = false;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    for (int i = 0; i < maxn; ++i) {
        ans[i] = inf;
    }
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        int t;
        cin >> t;
        g[a].push_back({b, {t, i}});
        g[b].push_back({a, {t, i}});
    }
    dfs(0, inf, -inf);
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }
}
