#include <iostream>
#include <vector>
#include <unordered_set>
#include <cmath>
using namespace std;
vector<vector<int> > a;
vector<unordered_set<int> > dct, rev;
vector<int> vis;
vector<int> d;
vector<pair<pair<int, int>, pair<int, int> > > anses;
bool dfs(int v, int p) {
	int curstat = 0;
	vis[v] = 1;
	vector<int> is1, ism1;
	for (auto h : a[v]) {
		if (!vis[h]) {
			if (!dfs(h, v))
				return false;
			
			curstat += d[h];
			if (d[h] == 1) {
				is1.push_back(h);
			}
			if (d[h] == -1) {
				ism1.push_back(h);
			}
		}
	}
	while (is1.size() > 0 && ism1.size() > 0) {
		anses.push_back({ {is1.back(),v},{v,ism1.back()} });
		is1.pop_back();
		ism1.pop_back();
	}
	if (abs(curstat) > 1) {
		return false;
	}
	if (p == -1 && curstat != 0) {
		return false;
	}
	if (p != -1) {
		bool isup = dct[v].find(p) != dct[v].end();
		bool isdown = dct[p].find(v) != dct[p].end();
		if (curstat == 0) {
			if (isdown) {
				d[v] = -1;
			}
			if (isup) {
				d[v] += 1;
			}
			if (isup && isdown) {
				anses.push_back({ {p,v},{v,p} });
			}
		}
		if (curstat == -1) {
			if (!isdown) {
				return false;
			}
			anses.push_back({ {p,v},{v,ism1[0]} });
			d[v] = 0;
			if (isup) {
				d[v] = 1;
			}
		}
		if (curstat == 1) {
			if (!isup) {
				return false;
			}
			anses.push_back({ {is1[0],v},{v,p} });
			d[v] = 0;
			if (isdown) {
				d[v] = -1;
			}
		}
	}
	return true;
}
int main() {
	int n,m;
	cin >> n>>m;
	a.resize(n);
	dct.resize(n);
	d.resize(n);
	rev.resize(n);
	for (int i = 0; i < m; i++) {
		int t1, t2;
		cin >> t1 >> t2;
		t1--;
		t2--;
		a[t1].push_back(t2);
		a[t2].push_back(t1);
		dct[t1].insert(t2);
		
	}
	vis.resize(n);
	bool OK = true;
	for (int i= 0; i < n; i++) {
		if (vis[i] == 0) {
			OK=OK&dfs(i, -1);
		}
	}
	if (!OK) {
		cout << "No";
		return 0;
	}
	cout << "Yes\n";
	for (auto h : anses) {
		cout << h.first.first+1 << ' ' << h.first.second+1 << ' ' << h.second.first+1 << ' ' << h.second.second+1 << '\n';

	}
	return 0;
}