#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <fstream>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

const int N = 500010;

struct edge {
	int v, to;
	int num;
	bool fake;
};

vector < edge > g[N];

set < pair < int, int > > s;

int cnt[N];

int used[N];

int dp[N][2][2];

int has_down[N], has_up[N];

bool ok = true;

void dfs(int v, int p) {
	used[v] = true;
	if (has_down[v])
		cnt[v]--;
	for (edge e : g[v]) {
		int to = e.to;
		if (to == p) {
			if (!e.fake)
				has_up[v] = true;
			continue;
		}
		has_down[to] = e.fake;
		dfs(to, v);
	}
	int up_l = 0, up_r = 0;
	int down_l = 0, down_r = 0;
	for (edge e : g[v]) {
		int to = e.to;
		if (to == p)
			continue;
		if (has_up[to]) {//     
			//if (!dp[to][has_down[to]][has_up[to]] && !dp[to][has_down[to]][!has_up[to]])
			//	dp[v][0][0] = false;
			if (dp[to][has_down[to]][!has_up[to]]) {
				++up_r;
			}
			if (!dp[to][has_down[to]][has_up[to]]) {
				++up_l;
			}
		}
		else {
			if (has_down[to]) {
				if (dp[to][has_down[to]][has_up[to]])

			}
			else {
				if (!dp[to][0][0])
					dp[v][0][0] = false;
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif
	
	int n, m;

	cin >> n >> m;

	for (int i = 1; i <= m; ++i) {
		int v, to;
		cin >> v >> to;
		g[v].push_back({ v, to, i, false });
		s.insert({ v, to });
		cnt[to]++;
	}

	for (auto t : s) {
		if (s.find({ t.second, t.first }) == s.end())
			g[t.first].push_back({ t.second, t.first, -1, true });
	}

	for (int i = 1; i <= n; ++i) {
		if (!used[i])
			dfs(i, i);
	}

	if (!ok) {
		cout << "No";
		return 0;
	}

}
