#include <bits/stdc++.h>
using namespace std;

//#define int long long

#define sz(x) static_cast<int>(x.size())
const int N = 6e3 + 10;
const int K = 26;

int n, m;
pair <int, int> e[N];

vector <int> r[N], g[N], t[N];

int used[N];
int color[N];

bool flag = true;

void dfs_color(int u) {
    used[u] = 1;

    for (int v : g[u]) {
        if (!used[v]) {
            color[v] = color[u] ^ 1;
            dfs_color(v);
        } else if (color[v] == color[u]) {
            flag = false;
        }
    }
}

int timer;
int mt[N];

bool dfs(int u) {
    if (used[u] == timer) return false;
    used[u] = timer;

    for (int v : t[u]) {
        if (mt[v] == -1 || dfs(mt[v])) {
            mt[v] = u;
            return true;
        }
    }
    return false;
}

char al[N];

signed main() {
#ifdef CHOPPAWONTMISS
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        auto& [u, v] = e[i];
        cin >> u >> v;
        r[u].push_back(i);
    }

    for (int i = 0; i < m; i++) {
        auto [u, v] = e[i];
        for (int j : r[v]) {
            g[i].push_back(j);
            g[j].push_back(i);
        }
    }

    for (int i = 0; i < m; i++) {
        if (!used[i]) {
            dfs_color(i);
        }
    }

    for (int i = 0; i < m; i++) {
        if (color[i]) continue;
        for (int j : g[i]) {
            t[i].push_back(j);
        }
    }

    memset(used, 0, sizeof used);
    memset(mt, -1, sizeof mt);
    int cnt = 0;

    for (int i = 0; i < m; i++) {
        for (int j : t[i]) {
            if (mt[j] == -1) {
                mt[j] = i;
                al[i] = 1;
                break;
            }
        }
    }

    for (int i = 0; i < m; i++) {
        if (color[i]) continue;

        if (al[i]) {
            cnt++;
        } else {
            timer++;
            cnt += dfs(i);
        }
    }

    if (cnt != m / 2) {
        return cout << "No\n", 0;
    }

    cout << "Yes\n";

    for (int i = 0; i < m; i++) {
        if (color[i] == 0) continue;

        int j = mt[i];
        auto [u, v] = e[i];
        auto [x, y] = e[j];

        cout << u << " " << v << " " << x << " " << y << "\n";
    }

    return 0;
}
