#include <bits/stdc++.h>

using namespace std;
struct edge {
    int x, y, w;
};
const int INF = 1e9;
vector <vector <int>> g;
vector <int> tin, fup, comp, st;
vector <bool> used;
int cur = 0, cha = 0;

void dfs(int v, int p) {
    st.push_back(v);
    tin[v] = fup[v] = cur;
    used[v] = true;
    ++cur;
    int kol = 0;
    for (auto i : g[v]) {
        if (!used[i]) {
            int len = st.size();
            dfs(i, v);
            fup[v] = min(fup[v], fup[i]);
            if (fup[i] > tin[v]) {
                while (st.size() > len) {
                    comp[st.back()] = cha;
                    st.pop_back();
                }
                ++cha;
            }
        } else if (i == p) {
            ++kol;
            if (kol == 2) fup[v] = min(fup[v], tin[i]);
        } else fup[v] = min(fup[v], tin[i]);
    }
}
bool cmp(edge one, edge two) {
    return one.w < two.w;
}

vector <int> ans;
vector <int> gl;
vector <vector <int>> gg;

void dfs1(int v, int p) {
    for (int i : gg[v]) {
        if (i != p) {
            gl[i] = gl[v] + 1;
            dfs1(i, v);
        }
    }
}

void make_ans(int v, int x) {
    used[v] = true;
    ans[v] = x;
    for (int i : gg[v]) {
        if (!used[i] && gl[i] > gl[v]) {
            make_ans(i, x);
        }
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector <int> res(n, 2 * INF);
    g.resize(n);
    vector <edge> all;
    for (int i = 0; i < m; ++i) {
        int x, y, w;
        cin >> x >> y >> w; --x; --y;
        g[x].emplace_back(y);
        g[y].emplace_back(x);
        all.push_back({x, y, w});
    }
    sort(all.begin(), all.end(), cmp);
    for (int maxx = 0; maxx < m; ++maxx) {
        g.assign(n, {});
        for (auto i : all) {
            if (i.w <= all[maxx].w) {
                g[i.x].push_back(i.y);
                g[i.y].push_back(i.x);
            }
        }
        cur = 0;
        cha = 0;
        tin.assign(n, 0);
        fup.assign(n, 0);
        used.assign(n, false);
        comp.assign(n, -1);
        dfs(0, -1);
        while (!st.empty()) {
            comp[st.back()] = cha;
            st.pop_back();
        }
        ++cha;
        gg.assign(cha, {});
        for (int i = 0; i < n; ++i) {
            for (int j : g[i]) {
                if (comp[i] != comp[j]) {
                    gg[comp[i]].push_back(comp[j]);
                    gg[comp[j]].push_back(comp[i]);
                }
            }
        }
        for (int i = 0; i < cha; ++i) {
            sort(gg[i].begin(), gg[i].end());
            gg[i].resize(unique(gg[i].begin(), gg[i].end()) - gg[i].begin());
        }
        used.assign(cha, false);
        ans.assign(cha, 0);
        gl.assign(cha, 0);
        dfs1(comp[0], -1);
        for (auto i : all) {
            int one = comp[i.x], two = comp[i.y];
            if (one == -1 || two == -1 || i.w > all[maxx].w) continue;
            if (gl[one] < gl[two]) swap(one, two);
            if (!used[one]) make_ans(one, i.w);
        }
        for (int i = 1; i < n; ++i) {
            if (comp[i] != -1) res[i] = min(res[i], ans[comp[i]] + all[maxx].w);
        }
    }
    for (int i = 1; i < n; ++i) cout << res[i] << "\n";
}

/*
 7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9
 */