#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;


map<char, long long>cnt;
long long dp[300001][26];
int prevs[300001][26];
void solve() {
	string s;
	cin >> s;
	int n = s.size();
	vector<char>mx(n);
	mx[n - 1] = s[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		if (s[i] == '?') {
			mx[i] = mx[i + 1];
			continue;
		}
		if (mx[i + 1] == '?') {
			mx[i] = s[i];
			continue;
		}
		mx[i] = max(s[i], mx[i + 1]);
	}
	char good = '-';
	long long best = 0;
	long long res = 0;
	long long cur = 0;
	int last = -1;
	vector<bool>bad(n, 0);
	int pos = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] != '?') {
			if (i < n - 1 && (mx[i + 1] != '?' && mx[i + 1] > s[i])) {
				res -= cnt[s[i]];
				bad[i] = 1;
			}
		}
		else {
			long long mm = -1000000000000000000;
			int pr = -1;
			for (int z = 25; z >= 0; z--) {
				char now = 'A' + z;
				if (pos > 0) {
					if (mm < dp[pos - 1][z]) {
						mm = dp[pos - 1][z];
						pr = z;
					}
				}
				else
					mm = 0;
				long long ct = cnt[now];
				for (int y = i - 1; y > last; y--) {
					if (bad[y])
						continue;
					if (now > s[y])
						ct -= cnt[s[y]];
					else
						ct += cnt[s[y]];
				}
				dp[pos][z] = mm + ct;
				prevs[pos][z] = pr;
			}
			last = i;
			pos++;
		}
	}
	for (int i = last + 1; i < n; i++) {
		if (bad[i])
			continue;
		res += cnt[s[i]];
	}
	if (pos > 0) {
		for (int i = 0; i <= 25; i++) {
			best = max(best, dp[pos - 1][i]);
		}
	}
	cout << res+best << '\n';
	vector<char>ans(n);
	int nd = -1;
	for (int i = n - 1; i >= 0; i--) {
		if (s[i] != '?') {
			ans[i] = s[i];
			continue;
		}
		if (nd == -1) {
			long long v = -1000000000000000000;
			int fr = 0;
			for (int y = 0; y < 26; y++) {
				if (dp[pos - 1][y] > v) {
					v = dp[pos - 1][y];
					fr = y;
				}
			}
			char now = 'A' + fr;
			ans[i] = now;
			nd = prevs[pos - 1][fr];
			pos--;
		}
		else {
			char now = 'A' + nd;
			ans[i] = now;
			nd = prevs[pos - 1][nd];
		}
	}
	for (auto c : ans)
		cout << c;
	cout << '\n';
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	cnt['A'] = 1;
	cnt['B'] = 5;
	cnt['C'] = 10;
	cnt['D'] = 50;
	cnt['E'] = 100;
	cnt['F'] = 500;
	cnt['G'] = 1000;
	cnt['H'] = 5000;
	cnt['I'] = 10000;
	cnt['J'] = 50000;
	cnt['K'] = 100000;
	cnt['L'] = 500000;
	cnt['M'] = 1000000;
	cnt['N'] = 5000000;
	cnt['O'] = 10000000;
	cnt['P'] = 50000000;
	cnt['Q'] = 100000000;
	cnt['R'] = 500000000;
	cnt['S'] = 1000000000;
	cnt['T'] = 5000000000;
	cnt['U'] = 10000000000;
	cnt['V'] = 50000000000;
	cnt['W'] = 100000000000;
	cnt['X'] = 500000000000;
	cnt['Y'] = 1000000000000;
	cnt['Z'] = 5000000000000;
	int t;
	cin >> t;
	while (t) {

		t--;
		solve();
	}
}