#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>;
using namespace std;

const int M = 2000;

int pos[300001];
pair<int, int> ans[300001];
int get(int v) {
	if (pos[v] == v)
		return v;
	return pos[v] = get(pos[v]);
}

bool unite(int v, int u) {
	v = get(v);
	u = get(u);
	if (v == u)
		return 0;
	pos[v] = u;
	return 1;
}
vector<pair<int, int>>all[300001];
void dfs(int v, int p) {
	for (auto c : all[v]) {
		if (c.first == p)
			continue;
		ans[c.first].first = max(c.second, ans[v].first);
		ans[c.first].second = min(c.second, ans[v].second);
		dfs(c.first, v);
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector < pair<int, pair<int, int>>>w;
	bool tp = 0;
	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		a--;
		b--;
		w.push_back({ c,{a,b} });
		if (c == 1000000000&&min(a,b)==0)
			tp = 1;
	}
	sort(begin(w), end(w));
	if (tp==false) {
		for (int i = 0; i < n; i++)
			pos[i] = i;
		bool k = 0;
		for (int i = 0; i < m; i++) {
			int v = w[i].second.first;
			int u = w[i].second.second;
			if (unite(v, u)) {
				all[v].push_back({ u,w[i].first });
				all[u].push_back({ v,w[i].first });
				if (u == 0 || v == 0) {
					if (w[i].first == 1000000000)
						k = 1;
				}
			}
		}

		if (k) {
			ans[0].second = 1000000000;
			ans[0].first = ans[0].second;
		}
		dfs(0, -1);
		for (int i = 1; i < n; i++)
			cout << ans[i].first + ans[i].second << '\n';
	}
	else {
		int k = 1000000000;
		for (auto c : w)
			k = min(k, c.first);
		for (int i = 1; i < n; i++)
			cout << k + 1000000000 << '\n';
	}
}


int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 

	int t;
	//cin >> t;
	t = 1;
	while (t) {

		t--;
		solve();
	}
}