#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>
#define vvi vector<vi>

const int N = 3e5 + 5;
const ll INF = 1e18;

int give(int t) {
	int id = t;
	int cnt = id / 2;
	int ans = 1;
	if (id % 2) ans = 5;
	for (int i = 0; i < cnt; ++i) {
		ans *= 10;
	}
	return ans;
}

void solve() {
	string s; cin >> s;
	int n = s.size();
	vvi dp(n + 1, vi(26, 0));
	vector<vector< pair<int, int> >> get(n + 1, vector < pair<int, int>>(26));
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j < 26; ++j) {
			dp[i][j] = -INF;
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int c = 0; c < 26; ++c) {
			if (s[i] == '?') {
				
				for (int c2 = 0; c2 <= c; ++c2) {

					if (c2 == c) {
						if (dp[i][c] + give(c2) > dp[i + 1][c]) {
							dp[i + 1][c] = max(dp[i + 1][c], dp[i][c] + give(c2));
							get[i + 1][c] = { c, c2 };
						}
					}
					else {
						if (dp[i][c] - give(c2) > dp[i + 1][c]) {
							dp[i + 1][c] = max(dp[i + 1][c], dp[i][c] + give(c2));
							get[i + 1][c] = { c, c2 };
						}
					}

				}

			}
			else {
				if (c > s[i] - 'A') {

					if (dp[i][c] - give(s[i] - 'A') > dp[i + 1][c]) {
						dp[i + 1][c] = max(dp[i + 1][c], dp[i][c] - give(s[i] - 'A'));
						get[i + 1][c] = { c, s[i] - 'A' };
					}
					if (dp[i][c] + give(s[i] - 'A') > dp[i + 1][s[i] - 'A']) {
						dp[i + 1][s[i] - 'A'] = max(dp[i + 1][s[i] - 'A'], dp[i][c] + give(s[i] - 'A'));
						get[i + 1][s[i] - 'A'] = { c, s[i] - 'A' };
					}
				}
				if (c == s[i] - 'A') {
					if (dp[i][c] + give(s[i] - 'A') > dp[i + 1][c]) {
						dp[i + 1][c] = max(dp[i + 1][c], dp[i][c] + give(s[i] - 'A'));
						get[i + 1][c] = { c, s[i] - 'A' };
					}
				}
			}

		}
	}
	pair<int, int> ans = { -INF, -INF };
	for (int i = 0; i < 26; ++i) {
		ans = max(ans, {dp[n][i], i});
	}
	cout << ans.first << '\n';
	string st = "";
	int i = n, j = ans.second;
	while (i > 0) {
		st += char('A' + get[i][j].second);
		j = get[i][j].first;
		--i;
	}
	reverse(st.begin(), st.end());
	cout << st << '\n';
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}