#include <bits/stdc++.h>

#define int long long

#define all(x) (x).begin(), (x).end()

using namespace std;


void solve() {
    vector<int> price = {1};
    for (int i = 1; i < 26; i++) {
        if (i % 2 == 1) {
            price.push_back(price.back() * 5);
        } else {
            price.push_back(price.back() * 2);
        }
    }

    string s;
    cin >> s;
    int n = s.size();

    vector <vector <int>> dp(n + 1, vector <int> (26, 0));
    vector <vector <int>> host(n + 1, vector <int> (26, 0));

    for (int i = n - 1; i > -1; i--) {
        if (s[i] != '?') {
            int mx_pref_ind = 0;

            for (int j = 0; j < 26; j++) {
                if (dp[i + 1][j] > dp[i + 1][mx_pref_ind])
                    mx_pref_ind = j;

                if (s[i] - 'A' > j) {
                    dp[i][j] = LLONG_MIN / 2;
                } else if (s[i] - 'A' == j) {
                    dp[i][j] = dp[i + 1][mx_pref_ind] + price[j];
                    host[i][j] = mx_pref_ind;
                } else {
                    dp[i][j] = dp[i + 1][j] - price[s[i] - 'A'];
                }
            }
        } else {
            int mx_pref_ind = 0;
            for (int j = 0; j < 26; j++) {
                if (dp[i + 1][j] > dp[i + 1][mx_pref_ind])
                    mx_pref_ind = j;

                if (dp[i + 1][mx_pref_ind] != LLONG_MIN / 2) {
                    dp[i][j] = dp[i + 1][mx_pref_ind] + price[j];
                    host[i][j] = mx_pref_ind;
                } else {
                    dp[i][j] = LLONG_MIN / 2;
                }
            }
        }
    }

    int mx_pos = 0;
    for (int i = 0; i < 26; i++) {
        if (dp[0][i] > dp[0][mx_pos])
            mx_pos = i;
    }
    cout << dp[0][mx_pos] << endl;

    string ans;

    for (int i = 0; i < n; i++) {
        if (s[i] != '?') {
            ans.push_back(s[i]);

            if (s[i] - 'A' == mx_pos) {
                mx_pos = host[i][mx_pos];
            }
        } else {
            ans.push_back((char) (mx_pos + 'A'));
            mx_pos = host[i][mx_pos];
        }
    }
    cout << ans << endl;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;
    while (q--)
        solve();
    return 0;
}
