#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()

using namespace std;

const int N = 3e5 + 100;
vector <int> g[N];

bool connected[N];
int ans[N];

void connect(int v) {
    connected[v] = true;

    for (int i : g[v]) {
        if (!connected[i]) {
            connect(i);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector <array <int, 3>> edges;

    for (int i = 0; i < m; i++) {
        int a, b, t;
        cin >> a >> b >> t;
        a--, b--;
        edges.push_back({t, a, b});
    }
    sort(all(edges));

    connected[0] = true;
    for (auto [t, a, b] : edges) {
        if (connected[a] == connected[b]) {
        } else if (connected[a] && !connected[b]) {
            connect(b);
        } else if (!connected[a] && connected[b]) {
            connect(a);
        }
        g[a].push_back(b);
        g[b].push_back(a);
    }

    for (int i = 1; i < n; i++)
        cout << ans[i] << "\n";
    return 0;
}
