#include <iostream>
#include <vector>
#include <algorithm>
#include <array>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N = 21;
const int INF = 1e9 + 228;

vector<array<int, 3>> G[N];

pair<int, int> dp[(1 << N)][N];
int used[(1 << N)][N];
int ans[N];

pair<int, int> bad = {-1, INF};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b, t;
		cin >> a >> b >> t;
		G[a - 1].push_back({b - 1, t, i});
		G[b - 1].push_back({a - 1, t, i});
	}

	for (int i = 0; i < (1 << m); ++i) {
		fill(dp[i], dp[i] + n, bad);
	}
	fill(ans, ans + N, 2 * INF);
	dp[0][0] = {0, INF};

	for (int mask = 0; mask < (1 << m); ++mask) {
		for (int i = 0; i < n; ++i) {
			if (dp[mask][i] == bad)
				continue;
			ans[i] = min(ans[i], dp[mask][i].first + dp[mask][i].second);
			for (auto j : G[i]) {
				if ((mask & (1 << j[2])) == 0) {
					dp[mask + (1 << j[2])][j[0]].first = 
					max(dp[mask + (1 << j[2])][j[0]].first, max(dp[mask][i].first, j[1]));

					dp[mask + (1 << j[2])][j[0]].second = 
					min(dp[mask + (1 << j[2])][j[0]].second, min(dp[mask][i].second, j[1]));
				}
			}
		}
	}
	for (int i = 1; i < n; ++i)
		cout << ans[i] << '\n';
}