#include <bits/stdc++.h>
using namespace std;

#define right right1
#define left left1

typedef long long ll;
typedef long double ldb;

int n;
vector<pair<int, int>> arr;

vector<int> left, right;

namespace Tree1 {
    
    const int MAXN = 5e5;

    vector<int> tree1[MAXN];

    void set(int i, int x, int y) {
        tree1[i] = {x, y};
    }

    int get(int l, int r, int x) {
        int ans = 1e9;
        for (int i = l; i < r; i++) {
            if (tree1[i][0] > x) {
                ans = min(ans, tree1[i][1]);
            }
        }
        return ans;
    }
};


void calcLeft() {
    left.resize(n, -1);
    Tree1::set(n - 1, arr[n - 1].first + arr[n - 1].second, -1);
    for (int i = 1; i < n; i++) {
        if (arr[i].first - arr[i].second < arr[0].first) {
        } else {
            int x = arr[i].first - arr[i].second;
            int l = 0;
            int r = i;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (arr[m].first <= x) {
                    l = m;
                } else {
                    r = m;
                }
            }
            left[i] = min(r, Tree1::get(r, i, arr[i].first));
        }
        Tree1::set(i, arr[i].first + arr[i].second, left[i]);
    }
}

void calcRight() {
    right.resize(n, n);
    for (int i = n - 2; i >= 0; i--) {
        if (arr[i].first + arr[i].second > arr[n - 1].first) {
            continue;
        } else {
            int x = arr[i].first + arr[i].second;
            int l = i;
            int r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (arr[m].first >= x) {
                    r = m;
                } else {
                    l = m;
                }
            }
            right[i] = l;
            for (int j = l; j > i; j--) {
                if (arr[j].first - arr[j].second < arr[i].first) {
                    right[i] = max(right[i], right[j]);
                }
            }
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> n >> q;
    arr.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first >> arr[i].second;
    }
    calcLeft();
    calcRight();

    while (q--) {
        int l, r;
        cin >> l >> r;
        l--;
        int ans = 0;
        for (int i = l; i < r; i++) {
            if (left[i] >= l || right[i] < r) {
                ans++;
            }
        }
        cout << ans << endl;
    }
}
