#include <iostream>
#include <string>
#include <map>
#include <vector>
using namespace std;

string summ_v_s(vector <string> v)
{
	string ans = "";
	for (auto el : v)
	{
		ans += el;
	}
	return ans;
}

long long summ_v_n(vector <long long> v)
{
	long long ans = 0;
	for (auto el : v)
	{
		ans += el;
	}
	return ans;
}

map <char, long long> d;
string al = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
vector <char> maxi;

long long summ(string s)
{
	char maxi = '.';
	long long ans = 0;
	for (int i = s.size() - 1; i >= 0; i--)
	{
		if (s[i] >= maxi)
		{
			ans += d[s[i]];
			maxi = s[i];
		}
		else
			ans -= d[s[i]];
	}
	return ans;
}

int main()
{
	long long t; cin >> t;
	d[al[0]] = 1;
	long long x = 5;
	for (int i = 1; i < 27; i += 2)
	{
		d[al[i]] = x; x *= 10;
	}
	x = 10;
	for (int i = 2; i < 27; i += 2)
	{
		d[al[i]] = x; x *= 10;
	}

	for (int iii = 0; iii < t; iii++)
	{
		string s; cin >> s;
		vector <string> ans_s;
		vector <long long> ans_n;
		string g = "";
		long long ans;
		long long count = -1;
		for (int i = 0; i < s.size(); i++)
		{
			if (s[i] == '?')
			{
				count++;
				bool flag = false;
				for (auto chr : al)
				{
					long long elem = summ(g + chr);
					if (!(flag) || (flag && elem > ans))
					{
						flag = true;
						if (ans_s.size() > count)
						{
							ans_s.pop_back();
							ans_n.pop_back();
						}
						ans = elem;
						ans_s.push_back(g + chr);
						ans_n.push_back(ans);
					}
				}
				g = "";
			}
			else
			{
				g += s[i];
			}
		}
		if (g.size())
		{
			ans_s.push_back(g);
			ans_n.push_back(summ(g));
		}
		cout << summ_v_n(ans_n) << endl << summ_v_s(ans_s) << endl;
	}
	return 0;
}