#include <bits/stdc++.h>

using namespace std;

const int MAXN = 5e5 + 25;

int a[MAXN];
int x[MAXN];
int L[MAXN];
int R[MAXN];

int cnt1[MAXN];
int cnt2[MAXN];

vector<vector<int>> g1(MAXN);
vector<vector<int>> g2(MAXN);

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; ++i)
    {
        cin >> x[i] >> a[i];
        L[i] = x[i] - a[i];
        R[i] = x[i] + a[i];
    }
    x[0] = x[1];
    x[n + 1] = x[n];
    for (int i = 1; i <= n; ++i)
    {
        for (int j = 0; j < i; ++j)
        {
            if (L[i] < x[j])
            {
                g1[j].push_back(i);
                ++cnt1[i];
            }
        }
        for (int j = i + 1; j < n + 2; ++j)
        {
            if (R[i] > x[j])
            {
                g2[j].push_back(i);
                ++cnt2[i];
            }
        }
    }
    for (int _ = 0; _ < q; ++_)
    {
        int l, r;
        cin >> l >> r;
        vector<int> used(n + 2);
        int ans = 0;
        vector<int> Q;
        for (int i = l; i <= r; ++i)
        {
            if (cnt1[i] == 0 || cnt2[i] == 0)
            {
                Q.push_back(i);
                used[i] = true;
            }
        }
        while (!Q.empty())
        {
            int u = Q.back();
            Q.pop_back();
            ++ans;
            for (auto v : g1[u])
            {
                --cnt1[v];
                if (!used[v] && cnt1[v] == 0 && v >= l && v <= r)
                {
                    used[v] = true;
                    Q.push_back(v);
                }
            }
            for (auto v : g2[u])
            {
                --cnt2[v];
                if (!used[v] && cnt2[v] == 0 && v >= l && v <= r)
                {
                    used[v] = true;
                    Q.push_back(v);
                }
            }
        }
        cout << ans << endl;
    }
    return 0;
}
