#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second

typedef long long ll;

const long long INF64 = 1e18;

#define int ll

void Solve(){
	int n, m;
	cin >> n >> m;

	vector<set<int>> g(n + 1);
	vector<set<int>> rg(n + 1);
	vector<int> cntin(n + 1);
	vector<int> cntout(n + 1);
	vector<pair<pair<int, int>, pair<int, int>>> ans;
	set<pair<int, int>> st;

	for(int i = 1; i <= m; i++){
		int v, u;
		cin >> v >> u;
		g[v].insert(u);
		rg[u].insert(v);
		cntin[u]++;
		cntout[v]++;
	}

	for(int v = 1; v <= n; v++)
		st.insert({min(cntout[v], cntin[v]), v});

	while(st.size()){
		auto p = *st.begin();
		int v = p.se;

		if(max(cntout[v], cntin[v]) == 0){
			st.erase(p);
			continue;
		}

		if(max(cntout[v], cntin[v]) == 2){
			cout << "No\n";
			return;
		}

		vector<pair<pair<int, int>, pair<int, int>>> locans;

		vector<int> dell;

		for(int u : g[v]){
			vector<int> del;

			for(int w : g[u]){
				locans.push_back({{v, u}, {u, w}});

				st.erase({min(cntout[v], cntin[v]), v});
				st.erase({min(cntout[u], cntin[u]), u});
				st.erase({min(cntout[w], cntin[w]), w});

				cntout[v]--;
				cntout[u]--;
				cntin[u]--;
				cntin[w]--;
				del.push_back(w);

				st.insert({min(cntout[v], cntin[v]), v});
				st.insert({min(cntout[u], cntin[u]), u});
				st.insert({min(cntout[w], cntin[w]), w});

				dell.push_back(u);
				break;
			}

			for(int w : del){
				g[u].erase(w);
				rg[w].erase(u);
			}
		}

		for(int u : dell){
			g[v].erase(u);
			rg[u].erase(v);
		}

		dell = {};

		for(int u : rg[v]){
			vector<int> del;

			for(int w : rg[u]){
				locans.push_back({{u, v}, {w, u}});

				st.erase({min(cntout[v], cntin[v]), v});
				st.erase({min(cntout[u], cntin[u]), u});
				st.erase({min(cntout[w], cntin[w]), w});

				cntout[u]--;
				cntin[v]--;
				cntin[u]--;
				cntout[w]--;
				del.push_back(w);

				st.insert({min(cntout[v], cntin[v]), v});
				st.insert({min(cntout[u], cntin[u]), u});
				st.insert({min(cntout[w], cntin[w]), w});

				dell.push_back(u);
				break;
			}

			for(int w : del){
				g[w].erase(u);
				rg[u].erase(w);
			}
		}

		for(int u : dell){
			rg[v].erase(u);
			g[u].erase(v);
		}

		for(auto p : locans)
			ans.push_back(p);
	}

	if(ans.size() == m / 2){
		cout << "Yes\n";

		for(auto p : ans)
			cout << p.fi.fi << ' ' << p.fi.se << ' ' << p.se.fi << ' ' << p.se.se << '\n';
	}else{
		cout << "No\n";
	}
}

signed main(){
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);

	// freopen("input.txt", "r", stdin);

	int test = 1;
	// cin >> test;

	for(int i = 1; i <= test; i++)
		Solve();
}