#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second

typedef long long ll;

const long long INF64 = 1e18;
const int SZ = 2e5;

#define int ll

void Solve(){
	int n, q;
	cin >> n >> q;
	vector<int> x(n + 1);
	vector<int> h(n + 1);

	for(int i = 1; i <= n; i++){
		cin >> x[i] >> h[i];
	}

	while(q--){
		int l, r;
		cin >> l >> r;

		stack<int> st;

		int ans = 0;

		for(int j = l; j <= r; j++){
			st.push(j);

			while(st.size()){
				int dl, dr;
				int i = st.top();

				if(st.size() > 1){
					st.pop();
					dl = st.top();
					st.push(i);
				}else{
					dl = max(l - 1, 1ll);
				}

				dr = min(j + 1, n);

				if(x[i] - h[i] >= x[dl] || x[i] + h[i] <= x[dr]){
					ans++;
					st.pop();
				}else{
					break;
				}
			}
		}

		cout << ans << '\n';
	}
}

signed main(){
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);

	// freopen("input.txt", "r", stdin);

	int test = 1;
	// cin >> test;

	for(int i = 1; i <= test; i++)
		Solve();
}