#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el : a) out << el << " ";
    return out;
}
int INF = 1e18;

vector <int> cost(26);
void solve() {
    string s;
    cin >> s;
    int n = s.size();
    int C = 26;
    vector <vector <int> > dp(n, vector <int> (C, -INF));
    vector <vector <int> > par(n, vector <int> (C, -1));

    if (s.back() == '?') for (int i = 0; i < C; i++) dp[n - 1][i] = cost[i];
    else dp[n - 1][s.back() - 'A'] = cost[s.back() - 'A'];

    for (int i = n - 2; i >= 0; i--) {
        for (int j = 0; j < C; j++) {
            if (s[i] == '?') {
                for (int c = 0; c <= j; c++) {
                    if (dp[i + 1][c] != -INF && dp[i + 1][c] + cost[j] > dp[i][j]) {
                        dp[i][j] = dp[i + 1][c] + cost[j];
                        par[i][j] = c;
                    }
                }
            } else {
                for (int c = 0; c <= j; c++) {
                    if (dp[i + 1][c] != -INF && dp[i][j] < cost[s[i] - 'A'] * (s[i] - 'A' >= c ? 1 : -1) + dp[i + 1][c]) {
                        dp[i][j] = cost[s[i] - 'A'] * (s[i] - 'A' >= c ? 1 : -1) + dp[i + 1][c];
                        par[i][j] = c;
                    }
                }
            }
        }
    }
    int ans = -INF, ind = 0, c = 0;
    for (int i = 0; i < 26; i++) {
        if (dp[0][i] > ans) c = i;
        ans = max(ans, dp[0][i]);
    }
    cout << ans << endl;
    string res;
    while (ind != n) {
        if (s[ind] == '?') res += c + 'A';
        else res += s[ind];
        c = par[ind][c];
        ind++;
    }
    cout << res << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int now = 1;
    for (int c = 'A', i = 0; c <= 'Z'; c++, i++) {
        cost[i] = now;
        if (i % 2) now *= 2;
        else now *= 5;
    }

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
/*
4
BBBC
????
A?B?C?D
YYYYY?
*/
