#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el : a) out << el << " ";
    return out;
}
int INF = 1e18;
vector <vector <pair <int, int> > > gr;
vector <int> ans;

void dfs(int v, int p, int big, int small) {
    ans[v] = small + big;
    for (auto u : gr[v]) {
        if (u.first == p) continue;
        dfs(u.first, v, max(big, u.second), min(small, u.second));
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    if (m != n - 1) return 0;
    ans.resize(n);
    gr.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;b--;
        gr[a].push_back({b, c});
        gr[b].push_back({a, c});
    }
    dfs(0, -1, 0, INF);
    for (int i = 1; i < n; i++) cout << ans[i] << endl;
}
/*
3 3
1 2 2
1 3 1
2 3 1

7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9

4 4
1 2 2
3 2 0
2 4 3
4 3 1
*/
