#include <bits/stdc++.h>

using namespace std;

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, q;
  cin >> n >> q;
  vector<int> x(n);
  vector<int> h(n);
  for (int i = 0; i < n; i++) {
    cin >> x[i] >> h[i];
  }
  while (q-- > 0) {

    if (n == 1) {
      cout << 0 << '\n';
      continue;
    }

    int l, r;
    cin >> l >> r;
    l--;
    vector<int> used(n, 1);
    for (int i = l; i < r; i++)
      used[i] = 0;

    int cnt = 0;
    int prev_cnt = cnt;
    while (true) {
      prev_cnt = cnt;

      for (int cur = l; cur < r; cur++) {
        if (used[cur])
          continue;

        int left_on = max(0, l - 1);
        for (int i = cur - 1; i >= 0; i--) {
          if (!used[i]) {
            left_on = i;
            break;
          }
        }
        if (x[cur] - h[cur] >= x[left_on]) {
          used[cur] = 1;
          cnt++;
          continue;
        }

        int right_on = min(n - 1, r);
        for (int i = cur + 1; i < n; i++) {
          if (!used[i]) {
            right_on = i;
            break;
          }
        }
        if (x[cur] + h[cur] <= x[right_on]) {
          used[cur] = 1;
          cnt++;
          continue;
        }
      }

      if (cnt == prev_cnt)
        break;

    }
    cout << cnt << '\n';
  }
  return 0;
}
/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

 0
 2
 3

 5 3
 1 5
 3 1
 4 2
 5 3
 6 1
 1 5
 5 5
 1 1

 5
 1
 0

 1 1
 100 100
 1 1

 0
 */