#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
// #define int ll
#define rep(i, n) for (int i = 0; i < int(n); ++i)
#define all(a) (a).begin(), (a).end()

ll d[26] = {
	1,
	5,
	10,
	50,
	100,
	500,
	(ll)1e3,
	(ll)5e3,
	(ll)1e4,
	(ll)5e4,
	(ll)1e5,
	(ll)5e5,
	(ll)1e6,
	(ll)5e6,
	(ll)1e7,
	(ll)5e7,
	(ll)1e8,
	(ll)5e8,
	(ll)1e9,
	(ll)5e9,
	(ll)1e10,
	(ll)5e10,
	(ll)1e11,
	(ll)5e11,
	(ll)1e12,
	(ll)5e12
};

ll calc(string s) {
	reverse(all(s));
	ll mx = -1;
	ll ans = 0;
	for (char c_ : s) {
		ll c = d[c_ - 'A'];
		if (mx > c) {
			ans -= c;
		} else {
			ans += c;
		}
		mx = max(mx, c);
	}
	return ans;
}

void solve() {
	string s;
	cin >> s;
	int n = s.size();
	pair<ll, string> ans{LLONG_MIN, ""};
	rep(i, 26) {
		string t = s;
		rep(j, n) {
			if (t[j] == '?') {
				t[j] = 'A' + i;
			}
		}
		ans = max(ans, make_pair(calc(t), t));
	}
	cout << ans.first << '\n' << ans.second << '\n';
}

signed main() {
	rep(i, 26) {
		cerr << char('A' + i) << ' ' << d[i] << endl;
	}
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}