#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define fi first
#define se second
#define pb emplace_back
#define all(x) (x).begin(), (x).end()
#define pii pair<int, int>
#define mp make_pair

const int INF = 1e9;
const ll INFLL = 1e18 + 1;

set<pii> edges;
vector<vector<int>> g;
vector<int> usd;
vector<pair<pii, pii>> ans;

void dfs(int v, int p) {
    usd[v] = 1;
    vector<int> both, to, from;
    for (auto &e : g[v]) {
        if (usd[e]) continue;
        dfs(e, v);
        if (edges.find({v, e}) != edges.end()) {
            if (edges.find({e, v}) != edges.end()) {
                both.pb(e);
            } else {
                to.pb(e);
            }
        } else if (edges.find({e, v}) != edges.end()) {
            from.pb(e);
        }
    }
    for (auto &c : both) {
        ans.pb(mp(v, c), mp(c, v));
    }
    if (abs((int)to.size() - (int)from.size()) > 1) {
        cout << "No";
        exit(0);
    }
    int i = 0;
    while (i < min(to.size(), from.size())) {
        ans.pb(mp(from[i], v), mp(v, to[v]));
        i++;
    }
    if (i < (int)to.size()) {
        if (edges.find({p, v}) == edges.end()) {
            cout << "No";
            exit(0);
        }
        edges.erase({p, v});
        ans.pb(mp(p, v), mp(v, to.back()));
    }
    if (i < (int)from.size()) {
        if (edges.find({v, p}) == edges.end()) {
            cout << "No";
            exit(0);
        }
        edges.erase({v, p});
        ans.pb(mp(v, p), mp(from.back(), v));
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].pb(b);
        g[b].pb(a);
        edges.insert({a, b});
    }
    usd.resize(n);
    for (int v = 0; v < n; v++) {
        if (usd[v]) continue;
        dfs(v, -1);
    }
    cout << "Yes\n";
    for (auto &c : ans) {
        cout << c.fi.fi + 1 << " " << c.fi.se + 1 << " " << c.se.fi + 1 << " " << c.se.se + 1 << "\n";
    }
    return 0;
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/
