#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;

ll INF = 2e18;
ll k = 26;
ll Q = -1;


lvec val;

lvec v;
ll ans;
lvec sym;

void precalc() {
    ll cur = 1;
    for (ll i = 0; i < k; i += 2) {
        val.push_back(cur);
        val.push_back(5 * cur);
        cur *= 10;
    }
}

char getch(ll x) {
    return (char) ('A' + x);
}

void print() {
    for (auto &el : sym)
        cout << getch(el);
    cout << "\n";
}

ll read(char x) {
    if (x == '?') return Q;
    return x - 'A';
}

struct pos {
    ll maxc, cur;

    pos(ll maxc, ll cur) : maxc(maxc), cur(cur) {}
};

void solve() {
    ll n = v.size();
    vector<lvec> dp(n + 1, lvec(k, -INF));
    vector<vector<pos> > p(n, vector<pos>(k, pos( -1, -1)));
    sym = v;
    dp[n][0] = 0;
    for (ll i = n - 1; i > -1; i--) {
        ll c = v[i];
        if (c == Q) {
            for (c = 0; c < k; c++) {
                for (ll maxc = 0; maxc <= c; maxc++) {
                    ll opt = dp[i + 1][maxc] + val[c];
                    if (dp[i][c] < opt) {
                        dp[i][c] = opt;
                        p[i][c] = pos(maxc, c);
                    }
                }
                for (ll maxc = c + 1; maxc < k; maxc++) {
                    ll opt = dp[i + 1][maxc] - val[c];
                    if (dp[i][c] < opt) {
                        dp[i][maxc] = opt;
                        p[i][maxc] = pos(maxc, c);
                    }
                }
            }
        } else {
            for (ll maxc = 0; maxc <= c; maxc++) {
               ll opt =  dp[i + 1][maxc] + val[c];
                if (dp[i][c] < opt) {
                    dp[i][c] = opt;
                    p[i][c] = pos(maxc, c);
                }
            }
            for (ll maxc = c + 1; maxc < k; maxc++) {
                ll opt = dp[i + 1][maxc] - val[c];
                if (dp[i][c] < opt) {
                    dp[i][maxc] = opt;
                    p[i][maxc] = pos(maxc, c);
                }
            }
        }
    }
    ll ans_c;
    for (ll maxc = 0; maxc < k; maxc++) {
        ll opt = dp[0][maxc];
        if(ans < opt) {
            ans = opt;
            ans_c = maxc;
        }
    }
    ll maxc = ans_c;
    for (ll i = 0; i < n; i ++) {
        auto pr = p[i][maxc];
        maxc = pr.maxc;
        if (sym[i] == Q) sym[i] = pr.cur;
    }
}

int main() {
  //  freopen("A.in", "r", stdin);
    precalc();
    ll t;
    string s;
    cin >> t;
    while (t--) {
        ans = -INF;
        cin >> s;
        sym.assign(s.size(), -2);
        v.assign(s.size(), -2);
        for (ll i = 0; i < s.size(); i++)
            v[i] = read(s[i]);
        solve();
        cout << ans << "\n";
        print();
    }
    return 0;
}
