#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (auto x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
	#define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
	#define dbg(...)
#endif



int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int n, q;
	cin >> n >> q;
	vec<int> x(n), h(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> h[i];
	}
	vec<int> prev(n), nxt(n);
	int timer = 1;
	vec<int> used(n);
	while (q--) {
		timer++;
		int l, r;
		cin >> l >> r;
		l--;
		vec<int> que;
		auto my_insert = [&](int i) {
			if (used[i] == timer) {
				return;
			}
			int left = (prev[i] == -1 ? x[max(l - 1, 0)] : x[prev[i]]);
			int right = (nxt[i] == -1 ? x[min(r, n - 1)] : x[nxt[i]]);
			if (right - x[i] >= h[i] || x[i] - left >= h[i]) {
				used[i] = timer;
				que.push_back(i);
			}
		};
		for (int i = l; i < r; i++) {
			prev[i] = (i == l ? -1 : i - 1);
			nxt[i] = (i == r - 1 ? -1 : i + 1);
			my_insert(i);
		}
		for (int st = 0; st < len(que); st++) {
			int i = que[st];
			if (nxt[i] != -1) {
				prev[nxt[i]] = prev[i];
				my_insert(nxt[i]);
			}
			if (prev[i] != -1) {
				nxt[prev[i]] = nxt[i];
				my_insert(prev[i]);
			}
		}
		cout << len(que) << '\n';
	}
}
