MAP = {
    "A": 1, "B": 5, "C": 10, "D": 50, "E": 100, "F": 500, "G": 1000, "H": 5000,
    "I": 10000, "J": 50000, "K": 10 ** 5, "L": 5 * 10 ** 5, "M": 10 ** 6, "N": 5 * 10 ** 6,
    "O": 10 ** 7, "P": 5 * 10 ** 7, "Q": 10 ** 8, "R": 5 * 10 ** 8, "S": 10 ** 9, "T": 5 * 10 ** 9,
    "U": 10 ** 10, "V": 5 * 10 ** 10, "W": 10 ** 11, "X": 5 * 10 ** 11, "Y": 10 ** 12, "Z": 5 * 10 ** 12,
    "?": -1
}

for _ in range(int(input())):
    s = input()
    n = len(s)
    arr = [MAP[i] for i in s]
    codes_arr = [ord(i) - 63 for i in s]

    cnt = [0] * 28
    for i in s:
        cnt[ord(i) - 63] += 1

    cur_max = 2
    for i in range(n - 1, -1, -1):
        if s[i] == "?":
            start = cur_max
            delta = MAP[chr(start + 63)] * cnt[0]
            max_delta, res = delta, start
            for code in range(start + 1, 28):
                delta += MAP[chr(code + 63)] * cnt[0] - MAP[chr(code - 1 + 63)] * cnt[0]
                delta -= MAP[chr(code - 1 + 63)] * cnt[code - 1] * 2
                if delta > max_delta:
                    max_delta = delta
                    res = code
            # print(f"code: {res}")
            codes_arr[i] = res
            cur_max = max(cur_max, res)
            cnt[0] -= 1
        else:
            now = ord(s[i]) - 63
            cur_max = max(cur_max, now)
            cnt[now] -= 1

    s = ''.join(chr(i + 63) for i in codes_arr)
    arr = [MAP[i] for i in s]

    stack = []
    ans = 0
    for i in arr:
        while len(stack) > 0 and i > stack[-1]:
            ans -= stack.pop()
        stack.append(i)

    ans += sum(stack)
    print(ans)
    print(s)
