#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define int long long
#define double long double


using namespace std;
using namespace __gnu_pbds;

typedef pair<int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int INF = (int)2e16 + 109;
const int NMAX = 300010;

string s;

string ans;

int dp[NMAX][26];
int p[NMAX][26];
char c[NMAX][26];

int w[26];

void solve_solve_solve() {
    cin >> s;
    int n = sz(s);

    for (int i = 0; i < n; i++) {
        fill(dp[i], dp[i] + 26, -INF);
        fill(p[i], p[i] + 26, -1);
    }

    if (s[n - 1] == '?') {
        for (int k = 0; k < 26; k++) {
            dp[n - 1][k] = w[k];
            c[n - 1][k] = char('A' + k);
        }
    } else {
        int k = s[n - 1] - 'A';
        for (int i = k; i < 26; i++) {
            dp[n - 1][i] = w[k];
            c[n - 1][i] = char('A' + k);
        }
    }

    for (int i = n - 2; i >= 0; i--) {
        if (s[i] == '?') {
            for (int k = 0; k < 26; k++) {
                for (int j = 0; j <= k; j++) {
                    int t = dp[i + 1][j] + w[k];

                    if (t > dp[i][k]) {
                        dp[i][k] = t;
                        p[i][k] = j;
                        c[i][k] = char('A' + k);
                    }
                }
                for (int j = s[i] - 'A' + 1; j < 26; j++) {
                    int t = dp[i + 1][j] - w[k];

                    if (t > dp[i][j]) {
                        dp[i][j] = t;
                        p[i][j] = j;
                        c[i][j] = char('A' + k);
                    }
                }
            }
        } else {
            int k = s[i] - 'A';

            for (int j = 0; j <= k; j++) {
                int t = dp[i + 1][j] + w[k];

                if (t > dp[i][k]) {
                    dp[i][k] = t;
                    p[i][k] = j;
                    c[i][k] = char('A' + k);
                }
            }
            for (int j = s[i] - 'A' + 1; j < 26; j++) {
                int t = dp[i + 1][j] - w[k];

                if (t > dp[i][j]) {
                    dp[i][j] = t;
                    p[i][j] = j;
                    c[i][j] = char('A' + k);
                }
            }
        }
    }
    /*
    cout << "dp = \n";
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 5; j++) {
            cout << dp[i][j] << " ";
        }
        cout << "\n";
    }
    cout << "END\n\n";

    */
             /*
    cout << "c = \n";
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 5; j++) {
            cout << c[i][j] << " ";
        }
        cout << "\n";
    }
    cout << "END\n\n";
                     */

    int M = -INF, ind;
    for (int i = 0; i < 26; i++) {
        if (dp[0][i] > M) {
            M = dp[0][i], ind = i;
        }
    }


    ans = "";
    int x = 0, y = ind;
    while (true) {
        //cout << "OK " << x << " " << y << " " << dp[x][y] << " " << p[x][y] << " " << c[x][y] << "\n";

        ans += c[x][y];
        y = p[x][y];
        x++;

        if (x == n) {
            break;
        }
    }


    cout << M << "\n" << ans << "\n";
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    w[0] = 1, w[1] = 5;
    for (int i = 1; i < 13; i++) {
        w[2 * i] = w[2 * (i - 1)] * 10;
        w[2 * i + 1] = w[2 * (i - 1) + 1] * 10;
    }

    int Q = 1;
    cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
