#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

#define all(x) (x).begin(), (x).end()
#define print(x) {for (auto xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}

const ll inf = 2e18;

int n, q;
vector < vector <int> > g[2];
vector <int> x, h, ed[2];
vector <int> was;
vector <bool> can;

vector <int> L, R;

void dfs(int v) {
    was[v] = 1;
    for (int t = 0; t < 2 && !can[v]; t++) {
        if (ed[t][v] < x[0] || ed[t][v] > x[n - 1]) {
            continue;
        }
        bool cur = true;
        for (auto to : g[t][v]) {
            if (was[to] == 0) {
                dfs(to);
            }
            if (!can[to]) {
                cur = false;
            }
        }
        if (cur) {
            can[v] = true;
        }
    }
    was[v] = 2;
}

void count(int l, int r) {
    r++;
    was.assign(n, 2);
    can.assign(n, false);
    for (int i = l; i < r; i++) {
        was[i] = 0;
    }
    for (int i = l; i < r; i++) {
        if (!was[i]) {
            dfs(i);
        }
    }
}

void solve() {
    cin >> n >> q;
    x.resize(n);
    h.resize(n);
    ed[0].resize(n);
    ed[1].resize(n);
    g[0].resize(n);
    g[1].resize(n);
    L.resize(n);
    R.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> h[i];
        ed[0][i] = x[i] - h[i];
        ed[1][i] = x[i] + h[i];
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j)
                continue;

            if (x[i] - h[i] < x[j] && x[j] < x[i]) {
                g[0][i].push_back(j);
            }
            if (x[i] < x[j] && x[j] < x[i] + h[i]) {
                g[1][i].push_back(j);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        L[i] = -1, R[i] = -1;
        int l = 0, r = i;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            count(mid, i);
            if (can[i]) {
                l = mid;
            } else {
                r = mid;
            }
        }
        for (int j = r; j >= l; j--) {
            count(j, i);
            if (can[i]) {
                L[i] = j;
                break;
            }
        }

        l = i, r = n - 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            count(i, mid);
            if (can[i]) {
                r = mid;
            } else {
                l = mid;
            }
        }
        for (int j = l; j <= r; j++) {
            count(i, j);
            if (can[i]) {
                R[i] = j;
                break;
            }
        }

        //cout << L[i] << ' ' << R[i] << '\n';
    }

    while (q --> 0) {
        int l, r; cin >> l >> r; l--;
        int ans = 0;
        for (int i = l; i < r; i++) {
            ans += ((L[i] != -1 && l <= L[i]) || (R[i] != -1 && R[i] < r));
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);

    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}