#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;
#define int long long

int n, q;

int a[500010];
int h[500010];

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> q;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i] >> h[i];
	}

	a[0] = a[1];
	a[n + 1] = a[n];

	while (q--)
	{
		int l, r;
		cin >> l >> r;

		int le = a[l - 1];
		int ri = a[r + 1];

		int ans = 0;

		set <int> all;

		for (int i = l; i <= r; ++i)
		{
			all.insert(i);
		}

		bool found;
		do
		{
			found = false;

			auto it = all.begin();

			while (it != all.end())
			{
				int leftb;
				if (it == all.begin()) leftb = le;
				else leftb = a[*prev(it)];

				int rightb;
				if (next(it) == all.end()) rightb = ri;
				else rightb = a[*next(it)];

				int coord = a[*it];
				int he = h[*it];
				if (coord - he >= leftb || coord + he <= rightb)
				{
					found = true;
					++ans;
					all.erase(it);
					break;
				}
				++it;
			}
		} while (found);

		cout << ans << '\n';
	}
	return 0;
}