#include <bits/stdc++.h>

using namespace std;

#define int long long

const int N = 3e5 + 5;
const int INF = 1.6e18;

int dp[26][N];
int parent[26][N];
int conv[26];

int32_t main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    conv[0] = 1;
    for (int i = 1; i < 26; ++i)
        conv[i] = conv[i - 1] * ((i & 1) ? 5 : 2);
    int t;
    cin >> t;
    for (int i = 0; i < 26; ++i)
        fill(dp[i], dp[i] + N, -INF);
    for (int _ = 0; _ < t; ++_)
    {
        string s;
        cin >> s;
        int n = s.size();
        if (s.back() == '?')
            for (int i = 0; i < 26; ++i)
                dp[i][0] = conv[i];
        else
            dp[s.back() - 'A'][0] =  conv[s.back() - 'A'];
        for (int i = 1; i < n; ++i)
        {
            if (s[n - i - 1] == '?')
            {
                int ma = 0;
                for (int j = 0; j < 26; ++j)
                {
                    if (dp[j][i - 1] > dp[ma][i - 1])
                        ma = j;
                    dp[j][i] = dp[ma][i - 1] + conv[j];
                    parent[j][i] = ma;
                }
            }
            else
            {
                int ma = 0;
                for (int j = 0; j < 26; ++j)
                {
                    if (dp[j][i - 1] > dp[ma][i - 1])
                        ma = j;
                    if (j == (s[n - i - 1] - 'A'))
                    {
                        dp[j][i] = dp[ma][i - 1] + conv[s[n - i - 1] - 'A'];
                        parent[j][i] = ma;
                    }
                    else if (j > (s[n - i - 1] - 'A'))
                    {
                        dp[j][i] = dp[ma][i - 1] - conv[s[n - i - 1] - 'A'];
                        parent[j][i] = ma;
                    }
                }
            }
        }
        int ma = 0;
        for (int i = 0; i < 26; ++i)
        {
            if (dp[i][n - 1] > dp[ma][n - 1])
                ma = i;
        }
        cout << dp[ma][n - 1] << '\n';
        for (int i = 0; i < n; ++i)
        {
            if (s[i] == '?')
                s[i] = 'A' + ma;
            ma = parent[ma][n - i - 1];
        }
        cout << s << '\n';
        for (int i = 0; i < 26; ++i)
        {
            fill(dp[i], dp[i] + n, -INF);
            fill(parent[i], parent[i] + n, -INF);
        }
    }
    return 0;
}