#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>

#define INF 1000000000000000000

using namespace std;

long long get_tally(string s) {
    int max_code = -1;

    long long tally = 0;
    for (int j = s.length() - 1; j >= 0; --j) {
        int code = s[j] - 'A';

        long long num = 1;

        if (code % 2 == 1) {
            num = 5;
        }

        for (int k = 0; k < code / 2; ++k) {
            num *= 10;
        }

        if (code < max_code) {
            tally -= num;
        }
        else {
            tally += num;
        }

        if (code > max_code) {
            max_code = code;
        }
    }

    return tally;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    for (int i = 0; i < t; ++i) {
        string s;
        cin >> s;

        int max_code = -1;

        queue <string> to_test;
        queue <int> checked_to;

        to_test.push(s);
        checked_to.push(0);

        vector <string> var;

        while (!to_test.empty()) {
            string cs = to_test.front();
            to_test.pop();

            int starting_i = checked_to.front();
            checked_to.pop();

            bool fl = true;

            for (int j = starting_i; j < cs.length(); ++j) {
                if (max_code < cs[j] - 'A') {
                    max_code = cs[j] - 'A';
                }

                if (cs[j] == '?') {
                    if (j != 0) {
                        to_test.push(cs.substr(0, j) + cs[j - 1] + cs.substr(j + 1));
                        checked_to.push(j + 1);
                    }

                    to_test.push(cs.substr(0, j) + 'Z' + cs.substr(j + 1));
                    checked_to.push(j + 1);

                    fl = false;
                    break;
                }
            }

            if (fl) {
                var.push_back(cs);
            }
        }

        string max_num = "";
        long long max_tally = -INF;

        for (int j = 0; j < var.size(); ++j) {
            string n_num = var[j];
            long long n_tally = get_tally(n_num);

            if (n_tally > max_tally) {
                max_tally = n_tally;
                max_num = n_num;
            }
        }

        cout << max_tally << '\n' << max_num << '\n';
    }

    return 0;
}
