#include <bits/stdc++.h>

#define eb emplace_back
#define x first
#define y second

using namespace std;

typedef long long ll;

const int MAXN = 150103;
int n, m;
set<int> g[MAXN];
vector<int> gg[MAXN];
int used[MAXN];
typedef pair<int, int> pt;
vector<pt> ans;

void read(){
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].insert(b);
        g[b].insert(a);
        gg[a].eb(b);
        //gg[b].eb(a);
    }
}

int dp[MAXN][2];
int t[MAXN];
int pr[MAXN];

int ok = 1;
void dfs(int v, int p){
    used[v] = 1;
    pr[v] = p;
    for (int i : gg[v]){
        if (i == p){
            t[v] = 1;
            continue;
        }
        //dfs(i, v);
    }
    for (int i : g[v]){
        if (used[i]) continue;
        dfs(i, v);
    }

    int up = 0, db = 0, d = 0;
    for (int i : g[v]){
        if (i == p) continue;
        if (t[i] == 1){
            up++;
        }
    }
    for (int i : gg[v]){
        if (i == p) continue;
        if (dp[i][0] && dp[i][1]) db++;
        else if (dp[i][0]) d++;
    }

    //cerr << v << ' ' << up << ' ' << d << ' ' << db << '\n';

    auto mrg = [](int& a, int& b){
        int d = min(a, b);
        a -= d;
        b -= d;
    };

    mrg(up, d);
    mrg(up, db);

    if (d > 1 || up > 0) ok = 0;
    if (d > 0 || db > 0) {
        dp[v][1] = 1;
    }
    if (d == 0) dp[v][0] = 1;
}

int used2[MAXN];
void dfs2(int v, int p, int ch){
    //cerr << v << ' ' << p << ' ' << ch<< '\n';
    used2[v] = 1;
    if (ch == 2){
        ans.eb(pr[p], p);
        ans.eb(p, v);
        ch = 0;
    }
    vector<int> up, db, d;

    for (int i : g[v]){
        if (i == p || used2[i]) continue;
        if (t[i] == 1){
            up.eb(i);
        }
    }
    for (int i : gg[v]){
        if (i == p) continue;
        if (dp[i][0] && dp[i][1]) db.eb(i);
        else if (dp[i][0]) d.eb(i);
        else dfs2(i, v, ch + 1);
    }

    auto mrg = [&](vector<int>& a, vector<int>& b){
        while (!a.empty() && !b.empty()){
            ans.eb(a.back(), v);
            ans.eb(v, b.back());
            //dfs2(a.back(), v, 0);
            dfs2(b.back(), v, 0);
            a.pop_back();
            b.pop_back();
        }
    };

    mrg(up, d);
    mrg(up, db);

    while (!d.empty()){
        dfs2(d.back(), v, ch + 1);
        d.pop_back();
        ch = 0;
    }

    while (!db.empty()){
        dfs2(db.back(), v, ch + 1);
        db.pop_back();
        ch = 0;
    }

    for (int i : g[v]){
        if (used2[i]) continue;
        dfs2(i, v, 0);
    }
}

void solve(){
    read();
    for (int i = 0; i < n; i++){
        //cerr << i << '\n';
        if (used[i]) continue;
        dfs(i, -1);
        if (!dp[i][0]) ok = 0;
        dfs2(i, -1, 0);
    }

    if (ok){
        cout << "Yes\n";
        int N = ans.size();
        for (int i = 0; i < N; i += 2){
            cout << ans[i].x + 1 << ' ' << ans[i].y + 1 << ' ' << ans[i + 1].x + 1 << ' ' << ans[i + 1].y + 1 << '\n';
        }
    }else {
        cout << "No\n";
    }
    //cout << ok << '\n';
}

signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}

/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/

//
// Created by roi on 09.04.2021.
//

