#include <bits/stdc++.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define vi vector<int>
#define forn(i, n) for (int i = 0; i < n; i++)
#define sz(a) ((int)a.size())
#define pb push_back

typedef long long ll;

void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
}

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

const int INF = 1e9 + 7;
const ll INFL = 4e18;
const int MAXN = 3e5 + 10;

// #define int ll

vi x, h;
unordered_map<int, int> prv, nxt;

int GetMax(int ind) {
    return max(x[nxt[ind]] - x[ind], x[ind] - x[prv[ind]]);
}

void Solve() {
    int n, q;
    cin >> n >> q;
    x.resize(n + 2);
    h.resize(n + 2);
    for (int i = 1; i <= n; i++) {
        cin >> x[i] >> h[i];
    }
    x[0] = x[1];
    h[0] = h[1];
    x[n + 1] = x[n];
    h[n + 1] = h[n];
    int L = x[0], R = x.back();
    vi xR = x, hR = h;
    while (q--) {
        x = xR;
        h = hR;
        int l, r;
        cin >> l >> r;
        set<pair<int, int>> deltas;
        for (int i = l; i <= r; i++) {
            prv[i] = i - 1;
            nxt[i] = i + 1;
            deltas.insert({h[i] - GetMax(i), i});
        }
        int ans = 0;
        while (sz(deltas) && deltas.begin()->first <= 0) {
            ans++;
            auto[del, ind] = *deltas.begin();
            deltas.erase(deltas.begin());
            if (prv[ind] >= l) {
                deltas.erase({h[prv[ind]] - GetMax(prv[ind]), prv[ind]});
                nxt[prv[ind]] = nxt[ind];
                deltas.insert({h[prv[ind]] - GetMax(prv[ind]), prv[ind]});
            }
            if (nxt[ind] <= r) {
                deltas.erase({h[nxt[ind]] - GetMax(nxt[ind]), nxt[ind]});
                prv[nxt[ind]] = prv[ind];
                deltas.insert({h[nxt[ind]] - GetMax(nxt[ind]), nxt[ind]});
            }
        }
        cout << ans << nl;
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while (t--) {
        Solve();
    }
}