#include "bits/stdc++.h"

#define int long long
#define endl '\n'
#define foriab(i, a, b) for(int i=(a);i<(b);++i)
#define fori(i, n) foriab(i, 0, n)
#define foris(i, s) fori(i, s.sz())
#define sz size
#define pb push_back
#define pp pop_back
#define VI vector<int>
#define INF 1000000000000000000LL
#define x first
#define y second
#define SI set<int>
#define ins insert
#define era erase
#define VVI vector<VI>
#define BEDA {cout<<"No"<<endl;exit(0);}

using namespace std;

SI merge(SI a, SI b){
	SI ans;
	for(auto x:a){
		ans.ins(x);
	}
	for(auto x:b){
		ans.ins(x);
	}
	return ans;
}
SI inter(SI a, SI b){
	SI ans;
	for(auto x:a){
		if(b.count(x)){
			ans.ins(x);
		}
	}
	return ans;
}


struct Node{
	SI kuda;
	SI otkuda;
	VI ktokomne;
	VI ktootmenya;
};

vector<Node> v;
SI listiki;
SI sosedi(int i){
	return merge(v[i].kuda, v[i].otkuda);
}
bool checklist(int i){
	if(listiki.count(i)){
		return true;
	}
	if(sosedi(i).sz()<2){
		listiki.ins(i);
		return true;
	}
	return false;
}
bool checknelist(int i){
	listiki.era(i);
	return checklist(i);
}
void checkalllist(){
	foris(i, v){
		checklist(i);
	}
}
//0-zero, 1-visim, 2-zepl, 3-full, 4-trash
int gettype(int i){
	if(!(listiki.count(i))){
		return 4;
	}
	int type=0;
	if(v[i].kuda.sz()){
		type+=2;
	}
	if(v[i].otkuda.sz()){
		type+=1;
	}
	return type;
}
void addrebro(int a, int b){
	v[a].kuda.ins(b);
	v[b].otkuda.ins(a);
	checknelist(a);
	checknelist(b);
}
void delrebro(int a, int b){
	v[a].kuda.era(b);
	v[b].kuda.era(a);
	checklist(a);
	checklist(b);
}
void del(int i){
	for(auto ku:v[i].kuda){
		delrebro(i, ku);
	}
	for(auto ot:v[i].otkuda){
		delrebro(ot, i);
	}
	listiki.era(i);
}
void cut(int a, int b){
	v[a].kuda.era(b);
	v[a].ktootmenya.pb(b);
	v[b].ktokomne.pb(a);
}
void cutcut(int a, int b){
	if(v[a].kuda.count(b)){
		cut(a, b);
	}
	swap(a, b);
	if(v[a].kuda.count(b)){
		cut(a, b);
	}
}
VVI result;
bool close(int i){
	while(v[i].ktokomne.sz()&&v[i].ktootmenya.sz()){
		result.pb({v[i].ktokomne.back(), i, i, v[i].ktootmenya.back()});
		v[i].ktokomne.pp();
		v[i].ktootmenya.pp();
	}
	return(v[i].ktokomne.sz()||v[i].ktootmenya.sz());
}
void processlist(int i){
	close(i);
	int type=gettype(i);
	if(type==0){
		if(close(i)){
			BEDA;
		}else{
			del(i);
			return;
		}
	}
	int par=*(sosedi(i).begin());
	if(type==1){
		if(v[i].ktokomne.sz()){
			BEDA;
		}
		if(v[i].ktootmenya.sz()){
			result.pb({par, i, i, v[i].ktootmenya.back()});
			delrebro(par, i);
			v[i].ktootmenya.pp();
			return;
		}
		cut(par, i);
		del(i);
		return;
	}
	if(type==2){
		if(v[i].ktootmenya.sz()){
			BEDA;
		}
		if(v[i].ktokomne.sz()){
			result.pb({v[i].ktokomne.back(), i, i, par});
			delrebro(par, i);
			v[i].ktokomne.pp();
			return;
		}
		cut(i, par);
		del(i);
		return;
	}
	if(type==3){
		if(v[i].ktootmenya.sz()){
			result.pb({par, i, i, v[i].ktootmenya.back()});
			delrebro(par, i);
			v[i].ktootmenya.pp();
			return;
		}
		if(v[i].ktokomne.sz()){
			result.pb({par, i, i, v[i].ktokomne.back()});
			delrebro(par, i);
			v[i].ktokomne.pp();
			return;
		}
		cutcut(par, i);
		del(i);
		return;

	}

}
signed main(){
	//stringstream cin("5 6 1 2  2 1 1 5 2 3 2 4 4 2");
	int n, m;
	cin>>n>>m;
	v.resize(n);
	fori(i, m){
		int x, y;
		cin>>x>>y;
		--x;--y;
		v[x].kuda.ins(y);
		v[y].otkuda.ins(x);
	}
	checkalllist();
	while(listiki.sz()){
		processlist(*(listiki.begin()));
	}
	if(result.sz()!=m/2){
		if(result.sz()>m/4){
			while(true){}
		}
		cout<<"No"<<endl;
		return 1;
	}
	cout<<"Yes"<<endl;
	foris(i, result){
		cout<<(1+result[i][0])<<' ';
		cout<<(1+result[i][1])<<' ';
		cout<<(1+result[i][2])<<' ';
		cout<<(1+result[i][3])<<endl;
	}
	return 0;
}
