#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <iomanip>

using namespace std;
#define int long long
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double
map <char, int> mp;
vector <int> ids;
string s, ans = "";
int res;
char last;
void gen(int sz) {
	if (sz == ids.size()) {
		int n = s.size(), get = mp[s.back()];
		char mx = s.back();
		for (int i = n - 2; i >= 0; --i) {
			if (mx > s[i]) get -= mp[s[i]];
			else get += mp[s[i]];
			mx = max(mx, s[i]);
		}
		if (get > res) {
			ans = s, res = get;
		}
		return;
	}
	for (auto x = 'A'; x <= 'Z'; ++x) {
		last = x;
		s[ids[sz]] = x;
		gen(sz + 1);
	}
}
/*
4
BBBC
????
A?B?C?D
YYYYY?
*/
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	mp['A'] = 1;
	int cur = 5;
	for (auto x = 'B'; x <= 'Z'; x++) {
		mp[x] = mp[x - 1] * cur;
		cur = 7 - cur;
	}
	int testcases;
	cin >> testcases;
	while (testcases-- > 0) {
		last = 'A';
		cin >> s;
		ids = {};
		res = -1e18;
		int n = s.size();
		for (int i = 0; i < n; ++i) {
			if (s[i] == '?')
				ids.push_back(i);
		}
		gen(0);
		cout << res << '\n' << ans << '\n';
	}
}