#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
using namespace std;
#define int long long
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	int n, q; cin >> n >> q;
	vector <vector <int>> a(n, vector <int>(2));
	for (auto& x : a) cin >> x[0] >> x[1];
	while (q-- > 0) {
		int l, r; cin >> l >> r;
		l--, r--;
		set <pair <int, int>> cur;
		for (int i = l; i <= r; ++i)
			cur.insert({ a[i][0], a[i][1] });
		if (l) cur.insert({ a[l - 1][0], a[l - 1][1] });
		if (r != n - 1) cur.insert({ a[r + 1][0], a[r + 1][1] });
		while (true) {
			bool was = false;
			for (auto x : cur) {
				if (l and x.first == a[l - 1][0]) continue;
				if (r != n - 1 and x.first == a[r + 1][0]) continue;
				if (x.first - x.second >= a[0][0]) {
					auto it = cur.find(x);
					bool ok = false;
					if (it == cur.begin()) ok = true;
					else {
						it--;
						if (x.first - x.second >= it->first)
							ok = true;
					}
					if (ok) {
						cur.erase(x);
						was = true;
						break;
					}
				}
				if (x.first + x.second <= a.back()[0]) {
					auto it = cur.find(x);
					bool ok = false;
					it++;
					if (it == cur.end()) ok = true;
					else {
						if (x.first + x.second <= it->first)
							ok = true;
					}
					if (ok) {
						cur.erase(x);
						was = true;
						break;
					}
				}
			}
			if (!was) break;
		}
		cout << (r - l + 1 + bool(l) + bool(r != n - 1)) - cur.size() << '\n';
	}
}