#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
using namespace std;
#define int long long
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double
vector <vector <pair <int, int>>> g;
vector <int> ans;
void dfs(int v, int mn, int mx, int p) {
	ans[v] = mn + mx;
	for (auto u : g[v]) {
		if (u.first == p) continue;
		dfs(u.first, min(mn, u.second), max(mx, u.second), v);
	}
}
const int mod = 1e9 + 7;
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	int n, m; cin >> n >> m;
	g.resize(n + 1);
	ans.resize(n + 1, mod);
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		g[u].push_back({v, w});
		g[v].push_back({ u, w });
	}
	ans[1] = mod;
	set <pair <int, int>> heap;
	for (int i = 2; i <= n; ++i)
		heap.insert({ mod, i });
	heap.insert({ 0, 1 });
	vector <bool> used(n + 1);
	while (!heap.empty()) {
		auto it = heap.begin();
		used[it->second] = true;
		for (auto u : g[it->second]) {
			if (used[u.first]) continue;
			if (ans[u.first] > min(ans[it->second], u.second)) {
				heap.erase({ ans[u.first], u.first });
				heap.insert({ min(u.second, ans[it->second]), u.first });
				ans[u.first] = min(ans[it->second], u.second);
			}
		}
		heap.erase(it);
	}
	for (int i = 2; i <= n; ++i)
		cout << ans[i] + (int)(1e9) << '\n';

}