#include<bits\stdc++.h>
using namespace std;

const int MAXN = 3e5 + 1;
const int INF = 1e9 + 1;
vector<pair<int, int>> g[MAXN];
int ans[MAXN];

void dfs(int u, int tmn, int tmx, int gl) {
    if (gl == 11) return;
    //cout << tmn << " " << tmx << "\n";
    ans[u] = tmn + tmx;
    for (auto it : g[u]) {
        int v = it.first, w = it.second;
        int mx = max(tmx, w);
        int mn = min(tmn, w);
        dfs(v, mn, mx, gl + 1);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u - 1].push_back({v - 1, w});
        g[v - 1].push_back({u - 1, w});
    }
    dfs(0, INF, -INF, 0);
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}

