#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
#define pb push_back
#define all(x) (x).begin(), (x).end()
#pragma GCC optimize("O3");
const int maxN = 1.5e5 + 9;
vector<int> tour;
vector<int> g[maxN];
bool vis[maxN];
void dfs(int v) {
    tour.pb(v);
    vis[v] = true;
    for(auto &i: g[v]) {
        if(!vis[i]) {
            dfs(i);
            tour.pb(v);
        }
    }
}
struct thing {
    int a, b, c;
};
int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int n, m; cin >> n >> m;
    set<pii> e;
    vector<pii> ee;
    for(int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        e.insert({u, v});
        ee.pb({u, v});
        g[u].pb(v);
    }
    for(auto &i: ee) {
        if(!e.count({i.second, i.first})) {
            g[i.second].pb(i.first);
        }
    }
    vector<thing> ans;
    for(int i = 1; i <= n; ++i) {
        if(!g[i].empty()) {
            tour.clear();
            dfs(i);
            tour.pop_back();
            int pos = -1;
            for(int j = 0; j < tour.size(); ++j) {
                int a = tour[j];
                int b = tour[(j + 1) % tour.size()];
                if(!e.count({a, b})) {
                    pos = (j + 1) % tour.size();
                }
            }
            if(pos == -1) tour.pb(tour[0]);
            else {
                vector<int> newtour;
                newtour.pb(tour[pos]);
                for(int j = (pos + 1) % tour.size(); j != pos; j = (j + 1) % tour.size()) {
                    newtour.pb(tour[j]);
                }
                tour = newtour;
            }
            int j = 0;
            while(j + 1 < tour.size()) {
                vector<int> z;
                z.pb(tour[j]);
                while(j + 1 < tour.size()) {
                    int u = tour[j];
                    int v = tour[(j + 1) % tour.size()];
                    if(!e.count({u, v})) {
                        ++j;
                        break;
                    }
                    z.pb(tour[(j + 1) % tour.size()]);
                    ++j;
                }
                if((int(z.size()) - 1) % 2) {
                    cout << "No\n";
                    return 0;
                }
                for(int q = 0; q + 2 < z.size(); q += 2) {
                    int a, b, c;
                    tie(a, b, c) = {z[q], z[q + 1], z[q + 2]};
                    if(e.count({a, b}) && e.count({b, c})) {
                        ans.pb({a, b, c});
                    }
                    else {
                        ans.pb({c, b, a});
                        assert(e.count({c, b}) && e.count({b, a}));
                    }
                }
            }
        }
    }
    cout << "Yes\n";
    for(auto &i: ans) {
        cout << i.a << ' ' << i.b << ' ' << i.b << ' ' << i.c << '\n';
    }
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3

 */