#include <bits/stdc++.h>
using ll = long long;
using namespace std;
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()

int n, m;
const int MAXN = 1.5e5 + 7;
vector<int> g[MAXN];
bool used[MAXN];

vector<pair<int,int>> euler;
set<pair<int ,int>> have;
void dfs(int v, int p = -1){
    used[v] = true;
    for (int u : g[v]){
        if (u == p)
            continue;
        euler.emplace_back(v + 1, u + 1);
        dfs(u, v);
    }
    if (p != -1)
        euler.emplace_back(v + 1, p + 1);
}

bool check(const pair<int, int>& a, const pair<int, int>& b){
    return a.first == b.second || a.second == b.first;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        int v, u;
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
        have.insert({v + 1, u + 1});
    }
    for (int i = 0; i < n; i++)
        if (!used[i])
            dfs(i);
    vector<pair<int, int>> euler1;
    for (auto x : euler)
        if (have.count(x))
            euler1.push_back(x);
    for (int i = 0; i < SZ(euler1); i += 2){
        if (!check(euler1[i], euler1[i + 1])){
            cout << "No\n";
            return 0;
        }
    }
    cout << "Yes\n";
    for (int i = 0; i < SZ(euler1); i += 2){
        auto [a, b] = euler1[i];
        auto [c, d] = euler1[i + 1];
        cout << a << ' ' << b << ' ' << c << " " << d << '\n';
    }
    return 0;
}
