#include <bits/stdc++.h>

#define endl '\n'
#define X first
#define Y second

using namespace std;

const int INF = 2e9 + 1;
const int N = 20;


vector<pair<int, int*>> g[N + 1];
vector<int> ans(N + 1, INF);

void dfs(int u, int l, int h){
    ans[u] = min(ans[u], l + h);

    for (auto & v : g[u]){
        if (*v.Y < 0)
            continue;

        *v.Y = -*v.Y;

        if (l == -1)
            dfs(v.X, -*v.Y, -*v.Y);
        else
            dfs(v.X, min(l, -*v.Y), max(h, -*v.Y));
        *v.Y = -*v.Y;
    }
}

void solve(){
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i){
        int u, v, t;
        cin >> u >> v >> t;

        ++t;
        int* k = new int;
        *k = t;
        g[u].push_back({v, k});
        g[v].push_back({u, k});
    }

    dfs(1, -1, -1);

    for (int i = 2; i <= n; ++i)
        cout << ans[i] - 2 << endl;
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    solve();
    return 0;
}