#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    for (int c = 0; c < t; ++c) solve();
}

using edge = tuple<int, int, int>;
int n;

struct dsu {
    vector<int> p;
    vector<int> sz;

    explicit dsu(int n) : p(n, -1), sz(n, 1) { iota(p.begin(), p.end(), 0); }

    int find(int x) { return p[x] = (p[x] == x ? x : find(p[x])); }

    void unite(int x, int y) {
        x = find(x);
        y = find(y);
        if (x == y) return;
        if (sz[x] < sz[y]) {
            p[x] = y;
            sz[y] += sz[x];
        } else {
            p[y] = x;
            sz[x] += sz[y];
        }
    }

    bool connected(int x, int y) { return find(x) == find(y); }
};

dsu without(vector<edge> edges, int f) {
    dsu test(n);
    for (int i = 0; i < edges.size(); ++i) {
        if (i == f) continue;
        auto[u, v, t]=edges[i];
        test.unite(u, v);
    }
    return test;

}

void solve() {
    int m;
    cin >> n >> m;
    vector<edge> edges;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u, --v;
        edges.emplace_back(u, v, t);
    }
    vector<vector<tuple<int, int, int>>> tree(n);
    int xxx = 0;
    for (auto[u, v, t] : edges) {
        tree[u].emplace_back(v, t, xxx);
        tree[v].emplace_back(u, t, xxx++);
    }
    vector<int> ans(n, 2e9);
    function<void(int, int, int, int)> dfs = [&](int cur, int mask, int max, int min) {
        ans[cur] = ::min(ans[cur], min + max);
        for (auto [next, time, i] : tree[cur]){
            if (mask & (1 << i)) continue;
            dfs(next, mask | (1 << i), ::max(max, time), ::min(min, time));
        }
    };
    dfs(0, 0, 0, 2e9);
    for (int i = 1; i < n; ++i) cout << ans[i] << '\n';
}
