#include "bits/stdc++.h"

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define all(x) x.begin(), x.end()

//#define GLIBCXX_DEBUG

namespace {
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {return in >> p.first >> p.second;}
    template<typename T>
    istream& operator>>(istream& in, vector<T>& v) {
        for (auto & e : v)
            in >> e;
        return in;
    }
}

void solve();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("gen.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
//    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
//    int t;
//    cin >> t;
//    while(t--)
    solve();
}

void dfs(int u, vector<vector<pii>>& graph, vector<pii>& answers, pii parent = pii{1e9, -1e9}, int prev = -1) {
    for (auto [e, t] : graph[u]) {
        if (prev == e)
            continue;
        pair<ll, ll> mm{min(t, parent.first), max(t, parent.second)};
        answers[e] = mm;
        dfs(e, graph, answers, mm, u);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pii>> graph(n);
    for (int i = 0; i < m; i++) {
        int a, b, t;
        cin >> a >> b >> t;
        graph[a - 1].emplace_back(b - 1, t);
        graph[b - 1].emplace_back(a - 1, t);
    }

    vector<pii> answers(n);
    dfs(0, graph, answers);

    for (int u = 1; u < n; u++) {
        cout << answers[u].first + answers[u].second << '\n';
    }
}