#include <bits/stdc++.h>

using namespace std;

const int N = 100000;

vector<pair<int, int>> g[N];

vector<bool> used(N, false);

vector<int> res(N, -1);

void dfs(int v, int mn, int mx) {
    if (used[v]) {
        return;
    }
    used[v] = true;
    res[v] = mn + mx;

    for (auto e : g[v]) {
        int mnn = min(mn, e.second);
        int mxx = max(mx, e.second);

        dfs(e.first, mnn, mxx);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }

    dfs(0, INT32_MAX / 2, -1);
    for (int i = 1; i < n; ++i) {
        cout << res[i] << '\n';
    }

}
