#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define IO ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define ff first
#define ss second
#define print(a) {for(auto iiii: a) cout << iiii << ' '; cout << '\n';}
#define printp(a) {for(auto iiii: a) cout << "{" << iiii.ff << ", " << iiii.ss << "} "; cout << '\n';}
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
mt19937_64 rng(1488);
int random(int l, int r) { return uniform_int_distribution<int> (l, r) ( rng);}

vector<vector<int>> graf;
vector<set<int>> in, out;
vector<bool> use;

struct st{
    int a, b, c, d;
};

vector<st> ans;

void dfs(int v, int last){
    use[v] = true;
    for(auto i: graf[v]){
        if(use[i]) continue;
        dfs(i, v);
    }
    bool fout = false;
    if(out[v].count(last)){
        out[v].erase(last);
        in[last].erase(v);
        fout = true;
    }
    bool fin = false;
    if(in[v].count(last)){
        in[v].erase(last);
        out[last].erase(v);
        fin = true;
    }
    while(in[v].size() != 0 && out[v].size() != 0){
        int x = *in[v].begin();
        int y = *out[v].begin();
        //cout << "KEK\n";
        ans.pb({x+1, v+1, v+1, y+1});
        in[v].erase(x);
        out[x].erase(v);
        in[y].erase(v);
        out[v].erase(y);
    }
    if(in[v].size() > 0 && fout){
        int x = *in[v].begin();
        ans.pb({x+1, v+1, v+1, last+1});
        in[v].erase(x);
        out[x].erase(v);
        fout = false;
    }
    if(out[v].size() > 0 && fin){
        int x = *out[v].begin();
        ans.pb({last+1, v+1, v+1, x+1});
        out[v].erase(x);
        in[x].erase(v);
        fin = false;
    }
    if(fout){
        out[v].insert(last);
        in[last].insert(v);
    }
    if(fin){
        in[v].insert(last);
        out[last].insert(v);
    }
}

void solve(){
    int n, m;
    cin >> n >> m;
    graf.resize(n);
    use.resize(n);
    in.resize(n);
    out.resize(n);
    for(int i=0;i<m;i++){
        int x, y;
        cin >> x >> y;
        x--, y--;
        graf[x].pb(y);
        graf[y].pb(x);
        in[y].insert(x);
        out[x].insert(y);
    }
    for(int i=0;i<n;i++){
        if(!use[i]) dfs(i, -1);
    }
    //for(auto i: ans) cout << i.a << ' ' << i.b << ' ' << i.c << ' ' << i.d << '\n';
    if(ans.size() != m/2) cout << "No\n";
    else{
        cout << "Yes\n";
        for(auto i: ans) cout << i.a << ' ' << i.b << ' ' << i.c << ' ' << i.d << '\n';
    }
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/
signed main(){
    IO
    int test = 1;
    //cin >> test;
    while(test--){
        solve();
    }
}
