#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define IO ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define ff first
#define ss second
#define print(a) {for(auto iiii: a) cout << iiii << ' '; cout << '\n';}
#define printp(a) {for(auto iiii: a) cout << "{" << iiii.ff << ", " << iiii.ss << "} "; cout << '\n';}
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
mt19937_64 rng(1488);
int random(int l, int r) { return uniform_int_distribution<int> (l, r) ( rng);}

struct st{
    int l, h, r;
};

struct node{
    vector<st> a;
    int back;
    node(){}
    node(st i){
        a.pb(i);
        back = i.l;
    }
};

class SegmentTree{
public:
    vector<node> t;
    SegmentTree(int n){
        t.resize(4*n);
    }
    node merge(node a, node b){
        if(b.a.empty()) return a;
        node c = a;
        if(a.a.empty()) b.a.front().l = a.back;
        else b.a.front().l = a.a.back().r;
        /*cout << "_______\n";
        for(auto i: a.a) cout << i.l << ' ' << i.h << ' ' << i.r << '\n';
        cout << '\n';
        for(auto i: b.a) cout << i.l << ' ' << i.h << ' ' << i.r << '\n';
        cout << '\n';
        for(auto i: c.a) cout << i.l << ' ' << i.h << ' ' << i.r << '\n';
        cout << "_______\n";*/
        for(auto i: b.a){
            c.a.pb(i);
            while(!c.a.empty() && (c.a.back().h <= c.a.back().l || c.a.back().h <= c.a.back().r)){
                if(c.a.size() > 1) c.a[c.a.size()-2].r += c.a.back().r;
                else c.back += c.a.back().r;
                c.a.pop_back();
            }
        }
        return c;
    }
    void build(int v, int tl, int tr, vector<st> &a){
        if(tl == tr){
            t[v] = node(a[tl]);
        }
        else{
            int tm = (tl+tr)/2;
            build(v*2, tl, tm, a);
            build(v*2+1, tm+1, tr, a);
            t[v] = merge(t[v*2], t[v*2+1]);
            //cout << tl << ' ' << tr << '\n';
            //cout << '\n';
        }
    }
    node query(int v, int tl, int tr, int l, int r){
        if(l > tr || tl > r) return node();
        if(l <= tl && tr <= r) return t[v];
        int tm = (tl+tr)/2;
        return merge(query(v*2, tl, tm, l, r), query(v*2+1, tm+1, tr, l, r));
    }
};

void solve(){
    int n, q;
    cin >> n >> q;
    vector<pii> a(n);
    for(auto &i: a) cin >> i.ff >> i.ss;
    vector<st> tmp;
    a.pb(a.back());
    tmp.pb({0, a[0].ss, a[1].ff - a[0].ff});
    for(int i=1;i<n;i++) tmp.pb({tmp[i-1].r, a[i].ss, a[i+1].ff - a[i].ff});
    SegmentTree tree(n);
    tree.build(1, 0, n-1, tmp);
    //return;
    while(q--){
        int l, r;
        cin >> l >> r;
        l--, r--;
        //for(auto i: tree.query(1, 0, n-1, l, r).a)cout << i.l << ' ' << i.h << ' ' << i.r << '\n';
        cout << (r - l + 1) - (int)tree.query(1, 0, n-1, l, r).a.size() << '\n';
    }
    /*while(q--){
        int l, r;
        cin >> l >> r;
        l--, r--;
        int tans = 0;
        int back = 0;
        if(l != 0) back = a[l].ff - a[l-1].ff;
        vector<st> tmp;
        for(int i=l;i<=r;i++){
            if(tmp.empty()) tmp.pb({back, a[i].ss, a[i+1].ff - a[i].ff});
            else tmp.pb({tmp.back().r, a[i].ss, a[i+1].ff - a[i].ff});
            //cout << i << '\n';
            //for(auto i: tmp) cout << i.l << ' ' << i.h << ' ' << i.r << '\n';
            while(!tmp.empty() && (tmp.back().h <= tmp.back().l || tmp.back().h <= tmp.back().r)){
                if(tmp.size() > 1) tmp[tmp.size()-2].r += tmp.back().r;
                else back += tmp.back().r;
                tans++;
                tmp.pop_back();
            }
            //for(auto i: tmp) cout << i.l << ' ' << i.h << ' ' << i.r << '\n';
            //cout << "\n";
        }
        cout << tans << '\n';
    }*/
}
/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

1 1
100 100
1 1

5 3
1 5
3 1
4 2
5 3
6 1
1 5
5 5
1 1
*/
signed main(){
    IO
    int test = 1;
    //cin >> test;
    while(test--){
        solve();
    }
}
