#include <iostream>
#include <vector>

using namespace std;

vector <pair <int, int> > g[301000];
int ans[300100];

void dfs(int v, int p, int mi = 1000000001, int ma = -1)
{
    ans[v] = mi + ma;
    for (int i = 0; i < g[v].size(); i++){
        if (g[v][i].first != p)
            dfs(g[v][i].first, v, min(mi, g[v][i].second), max(ma, g[v][i].second));
    }
}
int main()
{
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        int u, v, t;
        cin >> u >> v >> t;
        g[u].push_back(make_pair(v, t));
        g[v].push_back(make_pair(u, t));
    }
    dfs(1, -1);
    for (int i = 2; i <= n; i++)
        cout << ans[i] << '\n';
    return 0;
}
