#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

int x[500009];
int h[500009];

const int inf = 1e9 + 7;
bool ers[500009];

pii lefseg[500009];
pii rigseg[500009];

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        freopen("input.txt", "r", stdin);
    #endif // localfile

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; i++) {
        cin >> x[i] >> h[i];
    }

    x[0] = x[1];
    x[n + 1] = x[n];

    for (int i = 1; i <= n; i++) {
        int l = 0, r = i + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (x[m] <= x[i] - h[i]) {
                l = m;
            }

            else {
                r = m;
            }
        }

        lefseg[i] = {r, i - 1};
        if (x[i] - h[i] < x[1]) lefseg[i] = {0, i - 1};

        l = i, r = n + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (x[m] >= x[i] + h[i]) {
                r = m;
            }

            else {
                l = m;
            }
        }

        rigseg[i] = {i + 1, l};
        if (x[i] + h[i] > x[n]) rigseg[i] = {i  +1, n + 1};

        //cout << i << ' ' << lefseg[i].x << ' ' << lefseg[i].y << endl;
        //cout << i << ' ' << rigseg[i].x << ' ' << rigseg[i].y << endl;
    }

    for (int qqq = 0; qqq < q; qqq++) {
        int l, r;
        cin >> l >> r;

        int answ = 0;
        for (int i = l; i <= r; i++) ers[i] = 0;

        bool run = 1;
        while (run) {
            run = 0;
            for (int i = l; i <= r; i++) {
                if (ers[i]) continue;
                int suml = 0, sumr = 0;
                for (int t = lefseg[i].x; t <= lefseg[i].y; t++) suml += !ers[t];
                for (int t = rigseg[i].x; t <= rigseg[i].y; t++) sumr += !ers[t];
                if (lefseg[i].x >= l && suml == 0 || rigseg[i].y <= r && sumr == 0) {
                    answ++;
                    ers[i] = 1;
                    run = 1;
                }
            }
        }

        cout << answ << "\n";
    }

    return 0;
}


