#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

int x[500009];
int h[500009];

const int inf = 1e9 + 7;
bool dp[10009][10009];

pii lefseg[500009];
pii rigseg[500009];

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        freopen("input.txt", "r", stdin);
    #endif // localfile

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; i++) {
        cin >> x[i] >> h[i];
    }

    x[0] = x[1];
    x[n + 1] = x[n];

    for (int i = 1; i <= n; i++) {
        auto ret = lower_bound(x, x + n + 1, x[i] - h[i] + 1) - x;
        lefseg[i] = {ret, i - 1};
        ret = upper_bound(x, x + n + 1, x[i] + h[i] - 1) - x - 1;
        rigseg[i] = {i + 1, ret};

        //cout << i << ' ' << rigseg[i].x << ' ' << rigseg[i].y << ' '<< x[i] + h[i] - 1 << ' '<< ret << endl;
    }

    for (int len = 1; len <= n; len++) {
        for (int i = 1; i + len - 1 <= n; i++) {
            int j = i + len - 1;
            if (i == j && (lefseg[i].x > lefseg[i].y || rigseg[i].x < rigseg[i].y)) {
                dp[i][j] = 1;
            }

            else if (i != j) {
                dp[i][j] = 1;
                for (int m = i; m <= j; m++) {
                    if (lefseg[m].x >= i && dp[lefseg[m].x][m] || rigseg[m].y <= j && dp[m][rigseg[m].y]) ;
                    else dp[i][j] = 0;
                }
            }
        }
    }

    for (int qqq = 0; qqq < q; qqq++) {
        int l, r;
        cin >> l >> r;

        int answ = 0;
        for (int i = l; i <= r; i++) {
            if (lefseg[i].x >= l && dp[lefseg[i].x][i] || rigseg[i].y <= r && dp[i][rigseg[i].y]) {
                answ++;
            }
        }

        cout << answ << "\n";
    }

    return 0;
}


