#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

ll K = 26;

vector<ll> P(13, 1);

inline ll val(char c) {
    if (c == '?') return 0;
    else return (((c - 'A') % 2) ? 5 : 1) * P[(c - 'A') / 2];
}

inline ll val(ll c) {
    return val(char('A' + c));
}

const ll INF = 3e18;

string dr;
ll dc = -INF;

void f(const string &s, string &r, ll c, ll m, ll i) {
    if (i == s.length()) {
        if (c > dc) {
            dc = c;
            dr = r;
        }
        return;
    }
    if (s[i] == '?') {
        for (ll k = 0; k < K; k++) {
            ll d = c + val(k) * (m > k ? -1 : 1);
            r.push_back('A' + k);
            f(s, r, d, max(m, k), i + 1);
            r.pop_back();
        }
    } else {
        ll d = c + val(s[i]) * (m > (s[i] - 'A') ? -1 : 1);
        r.push_back(s[i]);
        f(s, r, d, max(m, ll(s[i] - 'A')), i + 1);
        r.pop_back();
    }
}

pair<string, ll> dumb(string s) {
    dc = -INF;
    reverse(s.begin(), s.end());
    string r = "";
    r.reserve(s.length());
    f(s, r, 0, 0, 0);
    reverse(dr.begin(), dr.end());
    return {dr, dc};
}

pair<string, ll> solve(string s) {
    ll n = s.length();
    reverse(s.begin(), s.end());
    vector<vector<ll>> d(n + 1, vector<ll>(K, -INF));
    vector<vector<pair<ll, char>>> a(n + 1, vector<pair<ll, char>>(K));
    for (ll k = 0; k < K; k++) d[0][k] = 0;
    for (ll i = 0; i < n; i++) {
        if (ll v = val(s[i])) {
            for (ll k = 0; k < K; k++) {
                ll m = max(k, ll(s[i] - 'A'));
                ll c = d[i][k] + v * (k > (s[i] - 'A') ? -1 : 1);
                if (c > d[i + 1][m]) d[i + 1][m] = c, a[i + 1][m] = {k, s[i]};
            }
        } else {
            for (ll k = 0; k < K; k++) {
                for (ll j = 0; j < K; j++) {
                    ll m = max(k, j);
                    ll c = d[i][j] + val(k) * (j > k ? -1 : 1);
                    if (c > d[i + 1][m]) d[i + 1][m] = c, a[i + 1][m] = {j, 'A' + k};
                }
            }
        }
    }
    ll k1 = 0;
    for (ll k = 0; k < K; k++) if (d[n][k] > d[n][k1]) k1 = k;
    string r;
    r.reserve(s.size());
    ll i = n, k = k1;
    while (i != 0) {
        r.push_back(a[i][k].second);
        k = a[i--][k].first;
    }
    return {r, d[n][k1]};
}

int main() {
    for (ll i = 0; i < P.size() - 1; i++) P[i + 1] = P[i] * 10ll;
    ll t;
    cin >> t;
    while (t--) {
        string s;
        cin >> s;
        auto[r, c] = solve(s);
        cout << c << '\n';
        cout << r << '\n';
    }
}


string A = "ABCDEFGHIJKLMNOPQRSTUVWXYZ?";

int main1() {
    for (ll i = 0; i < P.size() - 1; i++) P[i + 1] = P[i] * 10ll;
    ll n = 5;
    for (ll q = 0;; q++) {
        string s;
        s.reserve(5);
        while (s.length() < n) s.push_back(A[rand() % A.length()]);
        auto[r1, c1] = solve(s);
        auto[r2, c2] = dumb(s);
        if (c1 != c2) {
            cout << s << '\n';
            cout << r1 << ' ' << c1 << '\n';
            cout << r2 << ' ' << c2 << '\n';
            return 0;
        }
        cout << q << " OK\n";
    }
}