#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct R {
    ll r[3]{0};
};

struct T {
    ll a, b, c;

    T(ll a, ll b, ll c) : a(a), b(b), c(c) {}

    T() : a(), b(), c() {}
};

struct M {
    vector<T> m;
    vector<pair<ll, ll>> s;
    ll u;
};

vector<vector<M>> a;

bool match(set<ll> i, set<ll> o, const set<ll> &x, const set<ll> &y, ll v, ll k) {
    ll d = 0;
    if (k == 1) {
        if (o.empty()) return 0;
        d = 1;
    }
    if (k == 2) {
        if (i.empty()) return 0;
        d = -1;
    }
    if (ll(i.size()) + d > ll(o.size())) {
        for (ll u : x) {
            if (ll(i.size()) + d == ll(o.size())) break;
            a[v][k].m.push_back({a[u][2].u, u, v});
            a[v][k].s.push_back({u, 2});
            i.erase(u);
        }
    } else {
        for (ll u : y) {
            if (ll(i.size()) + d == ll(o.size())) break;
            a[v][k].m.push_back({v, u, a[u][1].u});
            a[v][k].s.push_back({u, 1});
            o.erase(u);
        }
    }
    if (ll(i.size()) + d != ll(o.size())) return 0;
    vector<ll> s1, s2;
    s1.reserve(i.size());
    s2.reserve(o.size());
    for (ll u : i) s1.push_back(u);
    for (ll u : o) s2.push_back(u);
    for (ll j = 0; j < min(s1.size(), s2.size()); j++) a[v][k].m.push_back({s1[j], v, s2[j]});
    if (s1.size() > s2.size()) a[v][k].u = s1.back();
    if (s2.size() > s1.size()) a[v][k].u = s2.back();
    return 1;
}

R dfs(const vector<set<pair<ll, ll>>> &g, vector<ll> &w, ll v) {
    w[v] = 1;
    set<ll> i, o, x, y, z;
    R r;
    for (auto[u, t] : g[v]) {
        if (w[u]) continue;
        R d = dfs(g, w, u);
        if (t == 2 || t == 0) o.insert(u);
        if (t == 2 || t == 1) i.insert(u);
        if (t != 2 && t != 0) d.r[1] = 0;
        if (t != 2 && t != 1) d.r[2] = 0;
        if (!d.r[0] && !d.r[1] && !d.r[2]) return {0, 0, 0};
        else if (!d.r[0] && !d.r[1]) {
            for (ll j = 0; j < 3; j++) {
                a[v][j].m.push_back({a[u][2].u, u, v});
                a[v][j].s.push_back({u, 2});
            }
            o.erase(u);
        } else if (!d.r[0] && !d.r[2]) {
            for (ll j = 0; j < 3; j++) {
                a[v][j].m.push_back({v, u, a[u][1].u});
                a[v][j].s.push_back({u, 1});
            }
            o.erase(u);
        } else if (d.r[1] || d.r[2]) {
            if (!d.r[0]) z.insert(u);
            else {
                if (!d.r[1]) x.insert(u);
                if (!d.r[2]) y.insert(u);
            }
        }
    }
    if (!z.empty()) {
        cerr << "lol" << '\n';
        exit(1);
    }
    for (ll k = 0; k < 2; k++) r.r[k] = match(i, o, x, y, v, k);
    return r;
}

void collect(vector<T> &ans, ll v, ll k) {
    for (T p : a[v][k].m) ans.push_back(p);
    for (auto[u, l] : a[v][k].s) collect(ans, u, l);
}

int main() {
    ll n, m;
    cin >> n >> m;
    a.assign(n, vector<M>(3));
    vector<vector<ll >> h(n);
    for (ll i = 0; i < m; i++) {
        ll v, u;
        cin >> v >> u;
        v--, u--;
        h[v].push_back(u);
    }
    vector<set<pair<ll, ll>>> g(n);
    for (ll v = 0; v < n; v++) {
        for (ll u : h[v]) {
            if (g[v].find({u, 1}) != g[v].end()) g[v].erase({u, 1}), g[v].insert({u, 2});
            else g[v].insert({u, 0});
            if (g[u].find({v, 0}) != g[u].end()) g[u].erase({v, 0}), g[u].insert({v, 2});
            else g[u].insert({v, 1});
        }
    }
    vector<ll> w(n, 0);
    vector<T> ans;
    for (ll v = 0; v < n; v++) {
        if (!w[v]) {
            if (!dfs(g, w, v).r[0]) {
                cout << "No\n";
                return 0;
            } else collect(ans, v, 0);
        }
    }
    cout << "Yes\n";
    for (auto t : ans) {
        cout << t.a + 1 << ' ' << t.b + 1 << ' ' << t.b + 1 << ' ' << t.c + 1 << '\n';
    }
}