#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define em emplace
#define eb emplace_back
#define pb pop_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int inf = 1e9;
const int N = 3e5 + 5;

int n, m;
vector<pii> g[N];
int wei[N], ans[N];
bool used[N];

void rec(int v, int mn, int mx) {
    ans[v] = min(ans[v], mn + mx);
    for (auto &e : g[v]) {
        int u = e.fi, i = e.se, w = wei[i];
        if (!used[i]) {
            used[i] = 1;
            rec(u, min(mn, w), max(mx, w));
            used[i] = 0;
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        g[v].eb(u, i);
        g[u].eb(v, i);
        wei[i] = w;
    }
    fill(ans + 1, ans + n + 1, 2 * inf);
    rec(1, inf, -inf);
    for (int i = 2; i <= n; ++i) cout << ans[i] << "\n";
    return 0;
}
