#include <bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define all(x) x.begin(), x.end()
#define mp make_pair
//define int long long
#define time() clock() / (ld)CLOKS_PER_SEC

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

const int MAXN = 3e5, INF = 1e9;

int ans[MAXN];
int tin[MAXN], tout[MAXN], fup[MAXN], wup[MAXN];

vector<pii> g[MAXN];

int nowt = 1;

void dfs(int v) {
    tin[v] = nowt++;
    int to, w;
    for (auto e : g[v]) {
        to = e.f, w = e.s;
        if (!tin[to]) {
            dfs(to);
        } else {
            wup[to] = min(wup[to], w);
        }
    }
}

void calc_ans(int v, int mn) {
    mn = min(mn, wup[v]);
    ans[v] = mn + INF;
    tin[v] = nowt++;
    for (auto e : g[v]) {
        if (tin[e.f]) continue;
        calc_ans(e.f, mn);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    int v, to, w;
    for (int i = 0; i < m; i++) {
        cin >> v >> to >> w;
        g[--v].push_back({--to, w});
        g[to].push_back({v, w});
    }
    fill(wup, wup + MAXN, INF);
    dfs(0);
    fill(tin, tin + MAXN, 0);
    calc_ans(0, INF);
    for (int i = 1; i < n; i++) cout << ans[i] << ' ';
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}


