#ifdef LOCAL
#define GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define mp make_pair
#define all(x) x.begin(), x.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define pb push_back

const ll inf = 2e18;
const ll INF = 1e9;
const ll MAXN = 3e5 + 10;

using namespace std;

int ans[MAXN];
int bridge[MAXN];
int fup[MAXN];
int tin[MAXN];
int used[MAXN];
int timer = 0;

struct edge{
    int v, u, t, ind;
    edge(int v, int u, int t, int ind): v(v), u(u), t(t) {}
    edge() {}
};

vector<edge> edges;
vector<edge> graph[MAXN];

void dfs(int v, int p = -1, int mine = INF + 1) {
    fup[v] = tin[v] = timer++;
    used[v] = 1;
    ans[v] = mine;
    for (edge e : graph[v]) {
        if (e.ind == p) continue;
        if (used[e.u]) {
            mn(fup[v], tin[e.u]);
            continue;
        }
        dfs(e.u, e.ind, min(mine, e.t));
        if (fup[e.u] > tin[v]) bridge[e.ind] = 1;
    }
}

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int v, u, t; cin >> v >> u >> t;
        --v, --u;
        graph[v].pb(edge(v, u, t, edges.size()));
        graph[u].pb(edge(u, v, t, edges.size()));
        edges.push_back(edge(v, u, t, edges.size()));
    }
    dfs(0);
    int min_val = INF + 1;
    for (auto e : edges) {
        if (!bridge[e.ind]) mn(min_val, e.t);
    }
    for (int i = 1; i < n; ++i) {
        cout << min(ans[i], min_val) + INF << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    cout.precision(30);

//    int t; cin >> t;
//    while (t--)
    solve();

    return 0;
}
