#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
using namespace std;

vector<vector<int>> g, t;
vector<int> used, mn, mx;
void dfs(int x) {
    used[x] = 1;
    for (int i = 0; i < g[x].size(); ++i) {
        int to = g[x][i];
        if (used[to])
            continue;
        mn[to] = min(mn[x], t[x][i]);
        mx[to] = max(mx[x], t[x][i]);
        dfs(to);
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    int u, v, time;
    g.resize(n, vector<int>());
    t.resize(n, vector<int>());
    for (int i = 0; i < m; ++i) {
        cin >> u >> v >> time;
        --u;
        --v;
        g[u].push_back(v);
        g[v].push_back(u);
        t[u].push_back(time);
        t[v].push_back(time);
    }
    used.resize(n);
    mx.resize(n);
    mn.resize(n, 1000000000);
    dfs(0);
    for (int i = 1; i < n; ++i) {
        cout << mx[i] + mn[i] << '\n';
    }
}
