#include <bits/stdc++.h>
using namespace std;


#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()


struct edge {
    int u, w;
    int index;
};


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> g(n);
    vector<int> allW;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[v].pb({u, w, i});
        g[u].pb({v, w, i});
        allW.pb(w);
    }
    vector<int> answer(n, 2e9 + 1);

    function<void(int, int, int)> forward = [&](int v, int mn, int mx) {
        if (v == n) {
            return;
        }
        int best = 1e9 + 1;
        answer[v] = mn + mx;
        for (auto e : g[v]) {
            if (e.u < v) {
                continue;
            }
            best = min(best, e.w);
        }
        forward(v + 1, min(mn, best), max(mx, best));
    };

    forward(0, 1e9 + 1, 0);
    for (int i = 1; i < n; i++) {
        cout << answer[i] << "\n";
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
