#include<iostream>
#include<vector>
#include<cmath>
#include<string>
#include<algorithm>

using namespace std;

typedef long long int ll;

struct rebro {
	ll a, b, t;
};

struct nm {
	ll a, i;
};

struct resmin {
	ll sum, tmin, tmax;
};

ll min(ll a, ll b) {
	if (a > b) return b;
	return a;
}

void dfs(ll n, ll m, vector<rebro>& a, vector<vector<nm>>& b, vector<ll>& min_l, ll x, vector<bool>& usd) {
	usd[x] = true;
	for (auto i : b[x]) {
		if (!usd[i.a]) {
			min_l[i.a] = min(min_l[x], a[i.i].t);
			dfs(n, m, a, b, min_l, i.a, usd);
		}
	}
}

int main() {
	ll n, m;
	cin >> n >> m;
	vector<rebro> a(m);
	vector<vector<nm>> b(n);
	vector<resmin> res(n);
	vector<ll> min_l(n, 1e9+1);
	vector<bool> usd(n, false);
	for (ll i = 0; i < m; i++) {
		cin >> a[i].a >> a[i].b >> a[i].t;
		a[i].a--;
		a[i].b--;
		nm x;
		x.a = a[i].a;
		x.i = i;
		b[a[i].b].push_back(x);
		x.a = a[i].b;
		b[a[i].a].push_back(x);
	}
	dfs(n, m, a, b, min_l, 0, usd);
	for (ll i = 1; i < n; i++) cout << 1000000000 + min_l[i] << endl;
}