#include <bits/stdc++.h>
using namespace std;
const int maxn = 300001;
// vector <int> g[maxn];
vector <pair<int, pair<int, int> > > ed; 

vector <int> vals[maxn];

int pr[maxn];
int sz[maxn];

bool ifE[maxn];

int ans[maxn];

int getR(int x) {
	if (pr[x] == x) return x;
	return pr[x] = getR(pr[x]);
}

void unite(int a, int b, int e_sz) {
	int r1 = getR(a), r2 = getR(b);
	// cerr << "rootz : " << r1 << " " << r2 << "\n";
	if (r1 == r2) return;

	bool iff = 0;
	if (ifE[r1] || ifE[r2]) {
		iff = 1;
	}

	if (iff && !ifE[r1]) {
		// cerr << "UPD root=" << r1 << "\n";
		for (int t : vals[r1]) {
			ans[t] = e_sz;
		}
		// vals[r1].~vector();
	}
	if (iff && !ifE[r2]) {
		// cerr << "UPD root=" << r2 << "\n";
		for (int t : vals[r2]) {
			ans[t] = e_sz;
		}

		// vals[r2].~vector();
	}

	if (sz[r1] > sz[r2]) swap(r1, r2);
	// cout << r2 << " <- " << r1 << "\n";
	pr[r1] = r2;
	
	if (iff) ifE[r2] = 1;

	if (!iff)
	for (int t : vals[r1]) {
		vals[r2].push_back(t);
	}

	sz[r2] += sz[r1];
}

int main() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v, C;
		cin >> u >> v >> C;
		u--; v--;
		C = -C;
		// g[u].push_back({ v, C });
		// g[v].push_back({ u, C });
		ed.push_back({C, {u, v}});
	}

	for (int i = 0; i < n; i++) {
		pr[i] = i;
		sz[i] = 1;
		vals[i].push_back(i);
	}
	ifE[0] = 1;

	sort(ed.begin(), ed.end());
	for (int i = ed.size() - 1; i >= 0; i--) {
		auto x = ed[i];
		int f = x.second.first, s = x.second.second;
		// cerr << "AT " << f << ", " << s << " and weight = " << x.first << ":\n";
		unite(f, s, x.first);
	}

	for (int i = 1; i < n; i++) {
		cout << -ans[i] + 1e9  << "\n";
	}
	// cerr << "!!";
}