#include "bits/stdc++.h"

using namespace std;

typedef long long ll;

#define fi first
#define se second


int main() {
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> a(n);
    for(int i = 0; i < n; ++i) {
        int x, h;
        cin >> x >> h;
        a[i] = {x, h};
    }

    vector<int> left(n), right(n);
    vector<bool> used(n);
    for(int t = 0; t < q; ++t) {
        int l, r;
        cin >> l >> r;
        --l; --r;

        for(int i = l; i <= r; ++i) {
            used[i] = false;
            if(i == 0) left[i] = a[i].fi;
            else left[i] = a[i - 1].fi;

            if(i == n - 1) right[i] = a[i].fi;
            else right[i] = a[i + 1].fi;
        }
        int ans = 0;
        while(true) {
            int cnt = 0;
            for(int i = l; i <= r; ++i) {
                if(used[i]) continue;;
                if(a[i].fi - left[i] >= a[i].se || right[i] - a[i].fi >= a[i].se) {
                    cnt ++;
                    used[i] = true;
                    if(i > l) right[i - 1] = right[i];
                    if(i < r) left[i + 1] = left[i];
                }
            }
            ans += cnt;
            if(cnt == 0)
                break;
        }
        cout << ans << '\n';
    }
    return 0;
}
/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

 */
