#include <bits/stdc++.h>

using namespace std;

#define prev abcd

const int MAX_N = 21;
vector < pair < int, int > > in_gr[MAX_N];
vector < pair < int, int > > out_gr[MAX_N];
bool dp[(1 << MAX_N)];
pair < int, int > prev[(1 << MAX_N)];

int main() {
    //freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    vector < pair < int, int > > e;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        e.emplace_back(v, u);
        in_gr[u].emplace_back(v, i);
        out_gr[v].emplace_back(u, i);
    }
    vector < pair < int, int > > can;
    for (int i = 0; i < n; i++) {
        for (auto x : in_gr[i]) {
            for (auto y : out_gr[i]) {
                can.emplace_back(x.second, y.second);
            }
        }
    }
    dp[0] = 1;
    for (int mask = 0; mask < (1 << m); mask++) {
        if (!dp[mask]) {
            continue;
        }
        for (auto i : can) {
            int v = i.first;
            int u = i.second;
            if (((mask >> v) & 1) == 1 || (((mask >> u) & 1)) == 1) {
                continue;
            }
            dp[mask + (1 << v) + (1 << u)] = 1;
            prev[mask + (1 << v) + (1 << u)] = {v, u};
        }
    }
    if (!dp[(1 << m) - 1]) {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    int mask = (1 << m) - 1;
    while (mask > 1) {
        auto p = prev[mask];
        int  v = p.first;
        int u = p.second;
        cout << e[v].first + 1 << " " << e[v].second + 1 << " " << e[u].first + 1 << " " << e[u].second + 1 << "\n";
        mask -= (1 << v);
        mask -= (1 << u);
    }
    return 0;
}
