#include <bits/stdc++.h>

using namespace std;

#define prev abcd

const int MAX_N = 2e5 + 42;
vector < int > in_gr[MAX_N];
vector < int > out_gr[MAX_N];
vector < int > gr[MAX_N];
bool used[MAX_N];
bool dp[3][MAX_N];
map < pair < int, int >, pair < int, int > > res;
int prev[3][MAX_N];

void dfs(int v, int p) {
    dp[0][v] = 1;
    used[v] = 1;
    vector < int > in;
    vector < int > out;
    for (auto u : gr[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v);
        int x1 = lower_bound(in_gr[v].begin(), in_gr[v].end(), u) - in_gr[v].begin();
        int x2 = lower_bound(out_gr[v].begin(), out_gr[v].end(), u) - out_gr[v].begin();
        if (x1 >= in_gr[v].size() || in_gr[v][x1] != u) {
            x1 = -1;
        }
        if (x2 >= out_gr[v].size() || out_gr[v][x2] != u) {
            x2 = -1;
        }
        if (dp[0][u] == 0 && dp[1][u] == 0 && dp[2][u] == 0) {
            cout << "No";
            exit(0);
        }
        if (x2 == -1 && dp[2][u]) {
            cout << "No";
            exit(0);
        }
        if (x1 == -1 && dp[1][u]) {
            cout << "No";
            exit(0);
        }
        if (x2 == -1 && dp[1][u]) {
            res[{prev[1][u], u}] = {u, v};
            continue;
        }
        if (x1 == -1 && dp[2][u]) {
            res[{v, u}] = {u, prev[2][u]};
            continue;
        }
        if (x2 == -1 && dp[0][u]) {
            in.emplace_back(u);
            continue;
        }
        if (x1 == -1 && dp[0][u]) {
            out.emplace_back(u);
            continue;
        }
        if (dp[1][u]) {
            res[{prev[1][u], u}] = {u, v};
            out.emplace_back(u);
            continue;
        }
        if (dp[2][u]) {
            res[{v, u}] = {u, prev[2][u]};
            in.emplace_back(u);
            continue;
        }
        res[{v, u}] = {u, v};
        continue;
    }
    if (abs((int)in.size() - (int)out.size()) > 1) {
        cout << "No";
        exit(0);
    }
    while (in.size() > 0 && out.size() > 0) {
        int x = in.back();
        int y = out.back();
        res[{x, v}] = {v, y};
        in.pop_back();
        out.pop_back();
    }
    if (in.size() > 0) {
        dp[0][v] = 0;
        dp[1][v] = 1;
        prev[1][v] = in.back();
        dp[2][v] = 0;
        return;
    }
    if (out.size() > 0) {
        dp[0][v] = 0;
        dp[1][v] = 0;
        dp[2][v] = 1;
        prev[2][v] = out.back();
    }
}

int main() {
    //freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    set < pair < int, int > > s;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        if (s.find({min(v, u), max(v, u)}) == s.end()) {
            gr[v].emplace_back(u);
            gr[u].emplace_back(v);
            s.insert({min(v, u), max(v, u)});
        }
        out_gr[v].emplace_back(u);
        in_gr[u].emplace_back(v);
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, i);
            if (dp[0][i] == 0) {
                cout << "No";
                return 0;
            }
        }
    }
    cout << "Yes\n";
    for (auto i : res) {
        cout << i.first.first + 1 << " " << i.first.second + 1 << " ";
        cout << i.second.first + 1 << " "<< i.second.second + 1 << endl;
    }
    return 0;
}
