#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9;

int main() {
  int n, q;
  cin >> n >> q;
  vector <int> x(n), h(n);
  for (int i = 0; i < n; i++) {
    cin >> x[i] >> h[i];
  }
  while (q--) {
    int l, r;
    cin >> l >> r;
    l--, r--;
    int L = (l ? x[l - 1] : x[0]);
    int R = (r + 1 < n ? x[r + 1] : x[n - 1]);
    vector <int> trees;
    for (int i = l; i <= r; i++) {
      trees.push_back(i);
    }
    int ans = 0;
    while (!trees.empty()) {
      if (x[trees[0]] - h[trees[0]] >= L) {
        ans++;
        trees.erase(trees.begin());
        continue;
      }
      int k = trees.size();
      if (x[trees[k - 1]] + h[trees[k - 1]] <= R) {
        ans++;
        trees.erase(trees.begin() + k - 1);
        continue;
      }
      bool flag = false;
      for (int i = 0; i + 1 < k; i++) {
        if (flag) {
          break;
        }
        if (x[trees[i]] + h[trees[i]] <= x[trees[i + 1]]) {
          flag = true;
          ans++;
          trees.erase(trees.begin() + i);
        }
      }
      for (int i = 1; i < k; i++) {
        if (flag) {
          break;
        }
        if (x[trees[i]] - h[trees[i]] >= x[trees[i - 1]]) {
          flag = true;
          ans++;
          trees.erase(trees.begin() + i);
        }
      }
      if (!flag) {
        break;
      }
    }
    cout << ans << '\n';
  }
  return 0;
}

/*
3 3
 1 3
 3 1
 4 2
 1 1
 2 3
 1 3
 */


/*
 5 3
 1 5
 3 1
 4 2
 5 3
 6 1
 1 5
 5 5
 1 1
 */