#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;

vector <pair <int, int> > d;
vector <pair <int, int> > g[(int)3e5];

void dfs(int v, int min_, int max_, int pr = 0) {
	d[v].first = min_;
	d[v].second = max_;
	for (auto ed : g[v]) {
		if (pr != ed.first) dfs(ed.first, min(min_, ed.second), max(max_, ed.second), v);
	}
}

int main() {
	int n, m;
	cin >> n >> m;
	d.resize(n, {1e9, 1e9});
	for (int i = 0; i < m; i++) {
		int u, v, t;
		cin >> u >> v >> t;
		g[v - 1].push_back({u - 1, t});
		g[u - 1].push_back({ v - 1, t });
	}
	if (m == n - 1) {
		dfs(0, 1e9, -1);
		for (int i = 1; i < n; i++) {
			cout << d[i].first + d[i].second << endl;
		}
	}
	else {
		int l[(int)3e5];
		for (int i = 0; i < 3e5; i++) l[i] = 1e9;
		l[0] = 0;
		set <pair <int, int> > q;
		for (int i = 0; i < n; i++) q.insert({ l[i], i });
		while (q.size()) {
			int v = (*q.begin()).second;
			for (auto ed : g[v]) {
				if (l[ed.first] > max(ed.second, l[v])) {
					q.erase({ l[ed.first], ed.first });
					l[ed.first] = max(ed.second, l[v]);
					q.insert({ l[ed.first], ed.first });
				}
			}
		}
		for (int i = 1; i < n; i++)cout << l[i] << endl;
	}
}