#include <bits/stdc++.h>

using namespace std;

long long binpow(long long a, int n) {
    if (n == 0)
        return 1;
    if (n % 1 == 0)
        return binpow(a, n - 1) * a;
    long long b = binpow(a, n / 2);
    return b * b;
}

long long convert(char c) {
    int ord = c - 'A';
    return binpow(2, ord / 2) * binpow(5, ord - ord / 2);
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        string s;
        cin >> s;
        int n = s.size();
        vector<bool> neg(n);
        char maxc = 'A';
        vector<int> q;
        for (int i = n - 1; i >= 0; i--) {
            if (s[i] == '?')
                q.push_back(i);
            else if (s[i] < maxc)
                neg[i] = true;
            else
                maxc = s[i];
        }
        int m = q.size();
        if (m == 0) {
            maxc = 'A';
            long long ans = 0;
            for (int i = n - 1; i >= 0; i--) {
                ans += convert(s[i]) * (s[i] < maxc ? -1 : 1);
                maxc = max(maxc, s[i]);
            }
            cout << ans << "\n" << s << "\n";
            continue;
        }
        q.push_back(-1);
        vector<vector<long long>> sum(m, vector<long long>(26));
        vector<char> maxes(m + 1, 'A');
        for (int i = n - 1; i > q[0]; i--) {
            maxes[0] = max(maxes[0], s[i]);
        }
        for (int i = 1; i <= m; i++) {
            maxes[i] = maxes[i - 1];
            for (int j = q[i] + 1; j < q[i - 1]; j++) {
                if (!neg[j]) {
                    sum[i - 1][s[j] - 'A'] += convert(s[j]);
                    maxes[i] = max(maxes[i], s[j]);
                }
            }
            for (int j = 1; j < 26; j++) {
                sum[i - 1][j] += sum[i - 1][j - 1];
            }
        }
        vector<vector<long long>> dp(m, vector<long long>(26, 0));
        vector<vector<char>> par(m, vector<char>(26, -1));
        for (int j = maxes[0] - 'A'; j < 26; j++) {
            dp[0][j] = convert('A' + j) + sum[0][25] - (j > 0 ? sum[0][j - 1] * 2 : 0);
        }
        for (int i = 1; i < m; i++) {
            for (int j = maxes[i] - 'A'; j < 26; j++) {
                for (int k = 0; k <= j; k++) {
                    if (dp[i - 1][k] > dp[i][j]) {
                        dp[i][j] = dp[i - 1][k];
                        par[i][j] = k;
                    }
                }
                dp[i][j] += convert('A' + j) + sum[i][25] - (j > 0 ? sum[i][j - 1] * 2 : 0);
            }
        }
        int k = 0;
        for (int j = 0; j < 26; j++) {
            if (dp[m - 1][j] > dp[m - 1][k]) {
                k = j;
            }
        }
        for (int i = m - 1; i >= 0; i--) {
            s[q[i]] = 'A' + k;
            k = par[i][k];
        }
        maxc = 'A';
        long long ans = 0;
        for (int i = n - 1; i >= 0; i--) {
            ans += convert(s[i]) * (s[i] < maxc ? -1 : 1);
            maxc = max(maxc, s[i]);
        }
        cout << ans << "\n" << s << "\n";
    }
    return 0;
}
