#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define size(x) (int)(x).size()

const int con = 27;
ll inf = 3e18;

signed main() {

#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t;
    cin >> t;

    vector<ll> cost(con);
    cost[0] = 1, cost[1] = 5;
    for (int i = 2; i < size(cost); ++i) {
        cost[i] = cost[i - 2] * (ll) 10;
    }

    while (t--) {
        string s;
        cin >> s;
        int n = size(s);
        vector<vector<ll> > dp(n, vector<ll>(con, -inf));
        vector<vector<int> > pr(n, vector<int>(con, -1));
        vector<vector<int> > pred(n, vector<int>(con, -1));
        for (int i = 0; i < con; ++i) {
            if (s[0] == '?') {
                for (int j = 0; j < 26; ++j) {
                    if (j < i) {
                        if (dp[0][i] < -cost[j]) {
                            dp[0][i] = -cost[j];
                            pr[0][i] = j;
                        }
                    } else {
                        if (dp[0][i] < cost[j]) {
                            dp[0][i] = cost[j];
                            pr[0][i] = j;
                        }
                    }
                }
            } else {
                int j = s[0] - 'A';
                if (j < i) {
                    if (dp[0][i] < -cost[j]) {
                        dp[0][i] = -cost[j];
                        pr[0][i] = j;
                    }
                } else {
                    if (dp[0][i] < cost[j]) {
                        dp[0][i] = cost[j];
                        pr[0][i] = j;
                    }
                }
            }
        }

        for (int i = 1; i < n; ++i) {
            for (int j = 0; j < con; ++j) {
                if (s[i] == '?') {
                    dp[i][j] = dp[i - 1][j] - cost[0];
                    pr[i][j] = 0;
                    pred[i][j] = j;
                    for (int k = j; k < 26; ++k) {
                        if (dp[i][j] < dp[i - 1][k] + cost[k]) {
                            dp[i][j] = dp[i - 1][k] + cost[k];
                            pr[i][j] = k;
                            pred[i][j] = j;
                        }
                    }
                } else {
                    int k = s[i] - 'A';
                    if (k < j) {
                        if (dp[i][j] < dp[i - 1][j] - cost[k]) {
                            dp[i][j] = dp[i - 1][j] - cost[k];
                            pr[i][j] = k;
                            pred[i][j] = j;
                        }
                    } else {
                        if (dp[i][j] < dp[i - 1][k] + cost[k]) {
                            dp[i][j] = dp[i - 1][k] + cost[k];
                            pr[i][j] = k;
                            pred[i][j] = j;
                        }
                    }
                }
            }
        }
        cout << dp[n - 1][0] << "\n";
        int x = n - 1, y = 0;
        string p = "";
        p = (char) (pr[x][y] + 'A') + p;
        while (x != 0) {
            y = pred[x][y];
            x--;
            p = (char) (pr[x][y] + 'A') + p;
        }
        cout << p;
        cout << "\n";

        //cout << 26 * 26 * 3 * 100000 << "\n";
    }
}
