#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define size(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

int n, q;
vector<int> x, h;

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> n >> q;
    x.resize(n), h.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        l[i] = n + 1;
        r[i] = n + 1;
        if (x[i] + h[i] <= x[n - 1]) {
            r[i] = 0;
            for (int j = i + 1; j < n; ++j) {
                if (x[i] + h[i] <= x[j]) break;
                r[i]++;
            }
        }
        if (x[i] - h[i] >= x[0]) {
            l[i] = 0;
            for (int j = i - 1; j >= 0; --j) {
                if (x[j] + h[i] <= x[i]) break;
                l[i]++;
            }
        }
    }

    while (q--) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        stack<int> st;

        for (int i = a; i <= b; ++i) {
            while (!st.empty()) {
                int v = st.top();
                if (x[v] + h[v] <= x[i]) {
                    st.pop();
                } else break;
            }
            int le = x[0];
            if (a != 0) le = x[a - 1];
            if (!st.empty()) le = x[st.top()];
            if (le + h[i] > x[i]) st.push(i);
        }
        int ri = x[n - 1];
        if (b != n - 1) ri = x[b + 1];
        while (!st.empty()) {
            int v = st.top();
            if (x[v] + h[v] <= ri) {
                st.pop();
            } else break;
        }
        int ans = b - a + 1 - size(st);

        cout << ans << "\n";
    }

}