#include <bits/stdc++.h>

#define sz(s) (int)(s).size()
#define rep(i, n) for (int i = 0; i < n; i++)
#define rrep(i, n) for (int i = n - 1; i >= 0; i--)

#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define re return
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef vector <ll> vll;
typedef pair <int, int> ii;
typedef vector <ii> vii;

const int N = 5e5 + 5;
const ll INF = 3e18;
const int mod = 1e9 + 7;

mt19937 rnd(165166164);

vii v[N];
int was[N];

int tin[N], tout[N], up[N];
int timer = 1;

vii br[N];

unordered_set <ll> brs;

void dfs (int pos, int pr)
{
    was[pos] = 1;
    up[pos] = timer;
    tin[pos] = timer++;
    for (auto y : v[pos])
    {
        int x = y.fi, t = y.se;
        if(x == pr) continue;
        if(!was[x])
        {
            dfs(x, pos);
            up[pos] = min(up[pos], up[x]);
            if(up[x] > tin[pos]) {
                br[pos].pb(x, t);
                br[x].pb(pos, t);
                brs.insert(pos * mod + x);
                brs.insert(x * mod + pos);
            }
        }
        else
        {
            up[pos] = min(up[pos], tin[x]);
        }
    }
    tout[pos] = timer;
}

int an[N], mi[N], ans[N];

void dfs1 (int pos)
{
    was[pos] = 1;
    for (ii y : br[pos])
    {
        int x = y.fi, t = y.se;
        if(!was[x]) {
            an[x] = min(an[pos], t);
            dfs1(x);
        }
    }
    for (ii y : v[pos])
    {
        int x = y.fi, t = y.se;
        if(!was[x]) {
            an[x] = min(an[x], an[pos]);
            ans[x] = min(ans[pos], t);
            dfs1(x);
        }

    }
}

int pa[N], Mi[N];

void Makeset (int n)
{
    rep(i, n)
    {
        pa[i] = i;
        Mi[i] = ans[i];
    }
}

int Find (int i)
{
    if(pa[i] == i) re i;
    re pa[i] = Find(pa[i]);
}

void Union (int i, int j)
{
    i = Find(i), j = Find(j);
    if(rnd() % 2)
    {
        swap(i, j);
    }
    pa[j] = i;
    Mi[i] = min(Mi[i], Mi[j]);
}

vector <pair <ii, int> > e;


void solve()
{
    int n, m;
    cin >> n >> m;
    rep(i, m)
    {
        int l, r, t;
        cin >> l >> r >> t;
        l--; r--;
        v[l].pb(r, t);
        v[r].pb(l, t);
        e.pb(mp(mp(l, r), t));
    }
    dfs(0, -1);
//    for (auto x : br)
//        cout << x.fi + 1 << ' ' << x.se + 1 << '\n';
    rep(i ,n) {
        was[i] = 0;
        an[i] = mod;
        ans[i] = mod;
    }
    dfs1(0);

    Makeset(n);

    for (auto q : e)
    {
        int l = q.fi.fi, r = q.fi.se, t = q.se;
        if(brs.find(l * mod + r) == brs.end())
            Union(l, r);
    }

//    rep(i, n)
//    {
//        cout << an[i] << ' ' << Mi[Find(i + 1)] << '\n';
//    }

    rep(i, n - 1)
    {
        cout << 1000000000 + min(an[i + 1], Mi[Find(i + 1)]) << '\n';
    }

}

signed main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int qq = 1;
//    cin >> qq;
    while(qq--)
        solve();
}
//
//3 3
//1 2 2
//1 3 1
//2 3 1

//8 9
//1 2 1
//2 3 1
//1 3 1
//2 4 1
//4 5 1
//4 6 1
//6 7 1
//7 8 1
//6 8 1

//9 10
//1 2 1000000000
//1 3 1000000000
//1 4 1000000000
//3 4 5
//2 5 2
//5 6 3
//6 7 3
//5 7 3
//3 8 2
//3 9 1
