#include <iostream>
#include <vector>
#include <algorithm>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#pragma GCC optimization("unroll-loops")
#pragma GCC optimization("O3")

using namespace std;

#define v vector
#define int long long

int tp;

void part1() {
    string s; cin >> s;
    for (auto ch : s) {
        for (int j = 0; j < 3; j++) {
            cout << ch;
        }
    }
    cout << "\n";
}

void part2() {
    string s; cin >> s;
    int n = s.size() / 3;
    for (int i = 0; i < n; i++) {
        v<int> cnt(2);
        for (int j = 3 * i; j < 3 * (i + 1); j++) {
            cnt[s[j] - '0']++;
        }
        if (cnt[0] > cnt[1]) {
            cout << '0';
        } else {
            cout << '1';
        }
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> tp;
    if (tp == 1) {
        part1();
    } else {
        part2();
    }
    return 0;
}
