#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <complex>
#include <cassert>
#include <random>
#include <ctime>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

using namespace std;
using ll = long long;
using ld = long double;
using cmpl = complex<long double>;

int query(int x) {
	cout << x << endl;
	int reply;
	cin >> reply;
	return reply;
}

int main(int argc, char* argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	if (argc > 1)
		freopen(argv[1], "r", stdin);
	if (argc > 2)
		freopen(argv[2], "w", stdout);
	
	int run_type, n;
	cin >> run_type >> n;
	if (run_type == 1) {
		int l = 1, r = n;
		while (r - l > 0) {
			int m = (l + r) >> 1;
			int rep = query(m);
			if (rep == 0)
				return 0;
			if (rep < 0)
				r = m - 1;
			else
				l = m + 1;
		}
		query(l);
	} else {
		int q;
		cin >> q;
		vector<int> replies(q);
		for (int i = 0; i < q; ++i)
			cin >> replies[i];

		int l = 1, r = n;
		int ind = 0;
		while (r - l > 0) {
			int m = (l + r) >> 1;
			int rep = replies[ind++];
			if (rep == 0) {
				cout << m;
				return 0;
			}
			if (rep < 0)
				r = m - 1;
			else
				l = m + 1;
		}
		cout << l;
	}

	return 0;
}