#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#include <chrono>
using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define cap(x) (int)(x).size()
const int C = 17;
void solve1() {
	string s;
	cin >> s;
	vector<int> cnt(C);
	for (int i = 0; i < cap(s); i++)
		for (int j = 0; j < C; j++)
			if ((i & (1 << j)) > 0 && s[i] == '1')
				cnt[j] ^= 1;
	string q;
	for (int i = 0; i < C; i++) q.push_back('0' + cnt[i]);
	q += s;
	cout << q << endl;
}
void solve2() {
	string s;
	cin >> s;
	vector<int> cnt(C), c(C);
	for (int j = 0; j < C; j++)
		cnt[j] = s[j] - '0';
	for (int i = C; i < cap(s); i++) {
		int msk = i - C;
		if (s[i] == '1')
			for (int j = 0; j < C; j++)
				if (msk & (1 << j))
					c[j] ^= 1;
	}
	string ans = s.substr(C, cap(s) - C);
	for (int i = 0; i < C; i++) {
		cnt[i] ^= 1;
		if (cnt == c) {
			cout << ans << endl;
			return;
		}
		cnt[i] ^= 1;
	}
	for (int i = C; i < cap(s); i++) {
		int msk = i - C;
		for (int j = 0; j < C; j++)
			if (msk & (1 << j))
				c[j] ^= 1;
		if (c == cnt) {
			if (s[i] == '1') ans[i - C] = '0';
			else ans[i - C] = '1';
			break;
		}
		for (int j = 0; j < C; j++)
			if (msk & (1 << j))
				c[j] ^= 1;
	}
	cout << ans << endl;
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int t;
	cin >> t;
	if (t == 1) solve1();
	else solve2();
	return 0;
}
//1110001110
//010100000000000001110001110