#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
#if DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e6 + 100, INF = 1e18;

int secret;

int f(int x) {
    cout << x << endl;
    int res;
#ifdef INTERACTOR
    if (secret == x) res = 0;
    else if (secret < x) res = -1;
    else res = 1;
#else
    cin >> res;
#endif
    if (res == 0) {
        exit(0);
    }
    return res;
}



int n;

void solve() {
    cin >> n;
#ifdef INTERACTOR
    cin >> secret;
#endif
    int l = 1, r = n;
    while (l + 1 < r) {
        int m = (r + l) / 2;
        if (f(m) == 1) {
            l = m + 1;
        } else {
            r = m - 1;
        }
    }
    f(l);
    f(r);
}
