#include <bits/stdc++.h>

using namespace std;


#ifndef SEVA
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#endif
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,popcnt,abm,fma,mmx,tune=native")

#include <immintrin.h>

#define nl '\n'
#define all(a) (a).begin(), (a).end()

typedef long long ll;

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
}

void Solve() {
    int a, b;
    cin >> a >> b;
    __m256i _a = _mm256_set1_epi32(a);
    __m256i _b = _mm256_set1_epi32(b);
    __m256i _c = _mm256_add_epi32(_a, _b);
    auto f = (int*)&_c;
    cout << f[0] << nl;
}

int main() {
    IO();
    Solve();
    return 0;
}
