#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using vll = vector<ll>;

const int M = 320;

void optimize() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}

string s;
bool f[M][M];
const int N = 1e5;

void solve1() {
    if (s.size() == 10) {
        cout << s << s << s << '\n';
        return;
    }
    for (int i = 0; i < M; ++i) {
        for (int j = 0; j < M; ++j) {
            int num = i * M + j;
            if (num >= s.size()) break;
            f[i][j] = s[num] == '1';
        }
    }
    for (int i = 0; i < M; ++i) {
        int cnt = 0;
        for (int j = 0; j < M; ++j) cnt += f[i][j];
        cnt %= 2;
        s += char('0' + cnt);
    }
    for (int j = 0; j < M; ++j) {
        int cnt = 0;
        for (int i = 0; i < M; ++i) cnt += f[i][j];
        cnt %= 2;
        s += char('0' + cnt);
    }
    cout << s << '\n';
}

void solve2() {
    int n = s.size();
    if (n == 30) {
        string s1, s2, s3;
        for (int i = 0; i < 3 * n; ++i) {
            if (i < n) s1 += s[i];
            else if (i < 2 * n) s2 += s[i];
            else s3 += s[i];
        }
        if (s1 == s2) cout << s1 << '\n';
        else if (s2 == s3) cout << s2 << '\n';
        else cout << s1 << '\n';
        return;
    }
    for (int i = 0; i < N; ++i) {
        f[i / M][i % M] = s[i] == '1';
    }
    int badCol = -1, badRow = -1;
    for (int i = N; i < N + M; ++i) {
        int right = s[i] == '1', cnt = 0;
        for (int j = 0; j < M; ++j) cnt += f[i - N][j];
        cnt %= 2;
        if (cnt != right) badRow = i - N;
    }
    for (int i = N + M; i < N + 2 * M; ++i) {
        int right = s[i] == '1', cnt = 0;
        for (int j = 0; j < M; ++j) cnt += f[j][i - N - M];
        cnt %= 2;
        if (cnt != right) badCol = i - N - M;
    }

    if (badCol != -1 && badRow != -1) f[badRow][badCol] ^= 1;
    for (int i = 0; i < M; ++i) {
        for (int j = 0; j < M; ++j) {
            int num = i * M + j;
            if (num < N) cout << char('0' + f[i][j]);
        }
    }
    cout << '\n';
}


int main() {
    optimize();
    int p; cin >> p >> s;
    if (p == 1) solve1();
    else solve2();

    return 0;
}
