#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out()
{
    cerr << endl;
}
template<typename T1, typename... T2> void debug_out(T1 A, T2... B)
{
    cerr << ' ' << A;
    debug_out(B...);
}
template<typename T> void mdebug_out(T* a, int n)
{
    for (int i = 0; i < n; ++i)
        cerr << a[i] << ' ';
    cerr << endl;
}
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif

int queries;
int ask(ll x)
{
    assert(--queries >= 0);
    cout << x << endl;
    int res;
    cin >> res;
    if (!res) exit(0);
    return res;
}

const int N = 1100;
int A[N][N];

signed main()
{
    queries = 30;

    mt19937 rng(time(0));
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < N; ++j)
        {
            A[i][j] = (i == j ? 0 : rng() % 1000000000);
        }

    for (int k = 0; k < N; ++k)
        for (int i = 0; i < N; ++i)
            for (int j = 0; j < N; ++j)
                chkmin(A[i][j], A[i][k] + A[k][j]);

    int task;
    cin >> task;
    if (task == 1)
    {
        ll n;
        cin >> n;

        ll x = 0;
        for (int j = 29; j >= 0; --j)
        {
            if (x + (1ll << j) <= n && ask(x + (1ll << j)) == 1)
                x += (1ll << j);
        }
        exit(0);
    }
    else
    {
        ll n;
        cin >> n;
        int Q;
        cin >> Q;
        vector<int> a(Q);
        for (auto& x : a) cin >> x;
        for (int i = 0; i < 30; ++i) a.push_back(0);
        ll x = 0;
        int i = 0;
        for (int j = 29; j >= 0; --j)
        {
            if (x + (1ll << j) <= n)
            {
                if (a[i] != -1)
                {
                    x += 1ll << j;
                    if (a[i] == 0) break;

                }
                ++i;
            }
        }
        cout << x << endl;
        exit(0);
    }



    /*ll n;
    cin >> n;
    ll vl = 0;
    ll vr = n;
    while (vr - vl > 1)
    {
        ll vm = (vl + vr) >> 1;
        if (ask(vm) == -1)
            vr = vm - 1;
        else
            vl = vm;
    }
    ask(vr);*/

    return 0;
}