#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>

using namespace std;

#define endl '\n'

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

#define all(a) a.begin(), a.end()

typedef int64_t ll;
typedef uint64_t ull;
//typedef __int128_t lll;
//typedef __uint128_t ulll;

void setup() {
#ifdef LOCAL
//    freopen("../input.txt", "r", stdin);
//    freopen("../output.txt", "w", stdout);
#endif
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
}
void solve();
signed main() {
    setup();
    int t = 1;
//    cin >> t;
    range(i, t) {
        solve();
    }
}


void fSolve();
void sSolve();
void solve() {
    int t; cin >> t;
    if (t == 1) {
        fSolve();
    } else {
        sSolve();
    }
}

const int MOD = 103179;
const int T = 279;
const int R = 17;

int mod(int x) {
    while(x >= MOD) x-=MOD;
    while(x < 0) x+=MOD;
    return x;
}

int countH(const string &s) {
    int h = 0;
    for (auto c : s) {
        h = (h * T + (c - '0')) % MOD;
    }
    return h;
}

void fSolve() {
    string x; cin >> x;
    int h = countH(x);
    cout << x;
    rrange(j, R) {
        cout << ((h >> j) & 1);
    }
}


void sSolve() {
    string z; cin >> z;
    int n = z.size() - R;
    string x; x.resize(n);
    copy(z.begin(), z.begin() + n, x.begin());
    int h = 0;
    range(j, R) {
        h = h * 2 + (z[n + j] - '0');
    }
    int xh = countH(x);
    if (xh == h) {
        cout << x;
        return;
    }
    range(j, R) {
        int sh = h ^ (1 << j);
        if (sh == xh) {
            cout << x;
            return;
        }
    }
    int pp = 1;
    rrange(i, n) {
        int sh = xh;
        if (x[i] == '0') {
            sh += pp;
            sh = mod(sh);
            if (sh == h) {
                x[i] = '1';
                cout << x;
                return;
            }
        } else {
            sh -= pp; sh = mod(sh);
            if (sh == h) {
                x[i] = '0';
                cout << x;
                return;
            }
        }
        pp *= T;
        pp %= MOD;
    }
}

