import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.math.BigInteger;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Locale;
import java.util.StringTokenizer;

public class A {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter writer = new PrintWriter(System.out);
        int n = Integer.parseInt(reader.readLine());
        char[] s = reader.readLine().toCharArray();
        if(n == 1){
            int sz = Integer.toBinaryString(s.length).length();
            if(s.length + sz > (1 << sz)){
                ++sz;
            }
            int[] ans = new int[s.length + sz];
            int cnt = 0;
            for(int i = 1; i <= s.length + sz; ++i){
                if(i == (1 << cnt)){
                    ++cnt;
                    continue;
                }
                if(s[i - 1 - cnt] == '1'){
                    char[] b = Integer.toBinaryString(i).toCharArray();
                    for(int j = 0; j < b.length; ++j){
                        if(b[b.length - 1 - j] == '1'){
                            ++ans[(1 << j) - 1];
                            ans[(1 << j) - 1] %= 2;
                        }
                    }
                }
                ans[i - 1] = s[i - 1 - cnt] - '0';
            }
            StringBuilder ss = new StringBuilder();
            for(int c : ans){
                ss.append(c);
            }
            System.out.println(ss);
        }
        else{
            int sz = Integer.toBinaryString(s.length).length();
            if(s.length - 1 <= (1 << (sz - 1))){
                --sz;
            }
            int[] steps = new int[sz];
            int cnt = 0;
            for(int i = 0; i < s.length; ++i){
                if(i == (1 << cnt) - 1){
                    ++cnt;
                    continue;
                }
                if(s[i] == '1'){
                    char[] b = Integer.toBinaryString(i + 1).toCharArray();
                    for(int j = 0; j < b.length; ++j){
                        if(b[b.length - 1 - j] == '1'){
                            ++steps[j];
                            steps[j] %= 2;
                        }
                    }
                }
            }
            int pered = 0;
            for(int i = 0; i < steps.length; ++i){
                if(steps[i] != s[(1 << i) - 1] - '0'){
                    pered += (1 << i);
                }
            }
            cnt = 0;
            StringBuilder ss = new StringBuilder();
            for(int i = 0; i < s.length; ++i){
                if(i == (1 << cnt) - 1){
                    ++cnt;
                    continue;
                }
                if(pered == i + 1){
                    if(s[i] == '0'){
                        ss.append('1');
                    }
                    else{
                        ss.append('0');
                    }
                }
                else{
                    ss.append(s[i]);
                }
            }
            System.out.println(ss);
        }
    }
}