#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array


typedef long long ll;
using namespace std;

const int md = 1e9 + 123;

inline int mul(const int &a, const int &b) {
    return (1ll * a * b) % md;
}

inline int add(const int &a, const int &b) {
    return a + b >= md ? a + b - md : a + b;
}

inline int sub(const int &a, const int &b) {
    return a - b < 0 ? a - b + md : a - b;
}

const int K = 19;

mt19937 rng(998244353);

vector<int> gen(int sz) {
    vector<int> res(sz);
    range(i, sz) res[i] = rng() % md;
    return res;
}
vector<int> ord;
vector<int> pos;
vector<int> kek;

void gen_kek(int sz) {
    kek.resize(sz);
    range(i, sz) kek[i] = rng() % 2;
}

void gen_ord(int sz) {
    ord.resize(sz);
    iota(all(ord), 0);
    shuffle(all(ord), rng);
    pos.resize(sz);
    range(i, sz) pos[ord[i]] = i;
}

void solve1() {
    string s; cin >> s;
    gen_kek((int)s.size() + K);
    gen_ord(s.size() + K);
    int h = 0;
    auto g = gen(s.size());
    range(i, (int)s.size()) {
        if (s[i] == '1') h = add(h, g[i]);
    }
    range(j, K) {
        if (h & (1 << j)) {
            s += '1';
        } else {
            s += '0';
        }
    }
    string t;
    int j = 0;
    for(auto &i : ord) {
        t += s[i];
        if (kek[j]) {
            if (t.back() == '1') t.back() = '0';
            else t.back() = '1';
        }
        j++;
    }
    cout << t;
}

void solve2() {
    string y; cin >> y;
    gen_kek(y.size());
    range(i, (int)y.size()) {
        if (kek[i]) {
            if (y[i] == '1') y[i] = '0';
            else y[i] = '1';
        }
    }
    gen_ord(y.size());
    int d = 0;
    int sz = y.size();
    int st2 = 1;
    for(int i = sz - K; i < sz; ++i) {
        int j = pos[i];
        if (y[j] == '1') {
            d += st2;
        }
        st2 *= 2;
    }
    auto g = gen(sz - K);
    int h = 0;
    range(i, sz - K) {
        int j = pos[i];
        if (y[j] == '1') h = add(h, g[i]);
    }
    auto chk = [&] (int x) {
        return ((1 << K) - 1) & x;
    };

    auto print = [&] () {
        range(i, sz - K) cout << y[pos[i]];
    };
    if (__builtin_popcount(chk(h) ^ d) <= 1) {
        print();
        return;
    }
    range(i, sz - K) {
        int j = pos[i];
        int h2 = h;
        if (y[j] == '1') {
            h2 = sub(h2, g[i]);
        } else {
            h2 = add(h2, g[i]);
        }
        if (chk(h2) == d) {
            if (y[j] == '1') y[j] = '0';
            else y[j] = '1';
            print();
            return;
        }
    }
    assert(0);
}

void solve() {
    int x; cin >> x;
    if (x == 1) solve1();
    else solve2();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    range(_, tests) {
        solve();
    }
    return 0;
}