#include <iostream>
#include <vector>
#include <algorithm>
#include <sstream>
#include <random>

using namespace std;


//  0 - a; 1 - b
bool what_large(string& a, string& b) {
	if (a.size() != b.size()) {
		return b.size() > a.size();
	}
	int first_diff = 0;
	while (first_diff < a.size() && a[first_diff] == b[first_diff]) first_diff++;
	if (first_diff == a.size()) return 0;
	return b[first_diff] > a[first_diff];
}

void norm(string& a, string& b) {
	if (a.size() > b.size()) swap(a, b);
	while (a.size() < b.size()) a = '0' + a;
	if (what_large(a, b)) swap(a, b);
}


string sum(string& a, string& b) {
	norm(a, b);
	string answ = "";
	bool add_one = false;
	for (int i = a.size() - 1; i >= 0; i--) {
		int now = (a[i] - '0' + b[i] - '0' + add_one);
		if (now >= 10) add_one = true;
		else add_one = false;
		now = now % 10;
		answ = char(now + '0') + answ;
	}
	if (add_one) answ = '1' + answ;
	return answ;
}
string diff(string& a, string& b) {
	norm(a, b);
	string answ = "";
	bool take_one = false;
	for (int i = a.size() - 1; i >= 0; i--) {
		int now = (a[i] - b[i] - take_one);
		if (now < 0) {
			now += 10;
			take_one = true;
		}
		else take_one = false;
		answ = char(now + '0') + answ;
	}
	return answ;
}

string get_answ(string a, string b) {
	bool negative_1 = false, negative_2 = false;
	if (a[0] == '-') {
		a.erase(a.begin());
		negative_1 = true;
	}
	if (b[0] == '-') {
		b.erase(b.begin());
		negative_2 = true;
	}
	if (negative_1 == negative_2) {
		string answ = sum(a, b);
		if (negative_1) answ = '-' + answ;
		return answ;
	}
	else {
		if (a == b) {
			return "0";
		}

		bool larger = what_large(a, b);
		string answ = diff(a, b);
		bool is_negative = false;
		if (larger == 0 && negative_1) is_negative = true;
		if (larger == 1 && negative_2) is_negative = true;
		if (is_negative) answ = '-' + answ;
		return answ;
	}
}

string itos(int a) {
	stringstream help;
	help << a;
	string answ;
	help >> answ;
	return answ;
}
int stoi(string& a) {
	stringstream help;
	help << a;
	int answ;
	help >> answ;
	return answ;
}

int main() {
	string a, b;
	cin >> a >> b;
	cout << get_answ(a, b) << endl;
}