#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#define int long long
#define all(z) z.begin(), z.end()
#define pb push_back
#define eb emplace_back
using namespace std;
using vi = vector<int>;
using pii = pair<int, int>;


void guess(int lv, int rv)
{
    if (rv - lv == 1)
    {
        cout << lv << endl;
        return;
    }

    int mv = (lv + rv) / 2;
    cout << mv << endl;

    int res;
    cin >> res;

    if (res == 0)
        return;

    if (res == 1)
        guess(mv+1, rv);
    else
        guess(lv, mv);
}


template <typename IIt>
void guess2(int lv, int rv, IIt a)
{
    if (rv - lv == 1)
    {
        cout << lv << '\n';
        return;
    }

    int mv = (lv + rv) / 2;
    int res = *a++;

    if (res == 0)
        cout << mv << '\n';
    else if (res == -1)
        guess2(lv, mv, a);
    else
        guess2(mv+1, rv, a);
}


inline void solve1()
{
    int n;
    cin >> n;

    guess(1, n+1);
}


inline void solve2()
{
    int n, q;
    cin >> n >> q;

    vi a(q);
    for (int i = 0; i < q; i++)
        cin >> a[i];

    guess2(1, n+1, a.begin());
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int com;
    cin >> com;

    if (com == 1)
        solve1();
    else
        solve2();

    return 0;
}
