#include <bits/stdc++.h>

using namespace std;

template<typename T>
using vec = vector<T>;

#define ALL(a) a.begin(), a.end()


//int N = 200;
const int N = 200;

void diff(string &a, string &b) {
  vec<int> va(N);
  vec<int> vb(N);
  for (int i = 0; i < a.size(); i++) {
    va[i] = a[i] - '0';
  }
  for (int i = 0; i < (int)b.size(); i++) {
    vb[i] = b[i] - '0';
  }
  int i = N - 1;
  while (i >= 0 && va[i] == vb[i])
    i--;
  bool min = false;
  if (va[i] < vb[i]) {
    swap(va, vb);
    min = true;
  }
  vec<int> ans(N);
  int carry = 0;
  for (i = 0; i < N; i++) {
    ans[i] = va[i] - vb[i] - carry;
    if (ans[i] < 0) {
      carry = 1;
      ans[i] += 10;
    } else {
      carry = 0;
    }
  }
  string ansik;
  i = N - 1;
  while (i > 0 && ans[i] == 0) {
    i--;
  }
  while (i >= 0) {
    ansik.push_back(ans[i] + '0');
    i--;
  }
  if (min)
    cout << '-';
  cout << ansik << '\n';
}

void run() {
  string a, b;
  cin >> a >> b;
  reverse(ALL(a));
  reverse(ALL(b));
  bool min = false;
  if (a.back() == '-' && b.back() == '-') {
    a.pop_back();
    b.pop_back();
    min = true;
  } else if (a.back() == '-' || b.back() == '-') {
    if (a.back() == '-')
      swap(a, b);
    b.pop_back();
    diff(a, b);
    return;
  }
  vec<int> va(N), vb(N);
  for (int i = 0; i < (int)a.size(); i++) {
    va[i] = a[i] - '0';
  }
  for (int i = 0; i < (int)b.size(); i++) {
    vb[i] = b[i] - '0';
  }
  vec<int> ans(N);
  int carry = 0;
  for (int i = 0; i < N; i++) {
    ans[i] = (va[i] + vb[i] + carry) % 10;
    carry = (va[i] + vb[i] + carry) / 10;
  }
  string ansik;
  int i = N - 1;
  while (i > 0 && ans[i] == 0) {
    i--;
  }
  while (i >= 0) {
    ansik.push_back('0' + ans[i]);
    i--;
  }
//  reverse(ALL(ansik));
  if (min) {
    cout << '-';
  }
  cout << ansik << '\n';
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  run();
  return 0;
}