#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct num {
    vector<int> val;

    num() {}

    num(string s) {
        reverse(s.begin(), s.end());
        for (char x : s) {
            val.push_back(x - '0');
        }
    }

    num operator + (num p) {
        num c;
        c.val.assign(200, 0);
        val.resize(200);
        p.val.resize(200);
        for (int i = 0; i < 200; ++i) {
            c.val[i] += p.val[i] + val[i];
            if (i < 199) {
                c.val[i + 1] += c.val[i] / 10;
            }
            c.val[i] %= 10;
        }
        return c;
    }

    void print() {
        while (val.back() == 0 && val.size() > 1) {
            val.pop_back();
        }
        reverse(val.begin(), val.end());
        for (int i : val) {
            cout << i;
        }
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    num a, b;
    string s, t;
    cin >> s >> t;
    a = num(s);
    b = num(t);
    num c = a + b;
    c.print();
}