#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define int long long

int ask(int x) {
    cout << x << endl;
    int y;
    cin >> y;
    return y;
}

int ask2(int x) {
    int y;
    cin >> y;
    return y;
}

void player1() {
    int n;
    cin >> n;
    if (n == 1) {
        ask(1);
        return;
    }
    int l = 0, r = n;
    while (l < r) {
        int m = (l + r) / 2;
        int res = ask(m);
        if (res == 0) {
            return;
        }
        if (res == 1) {
            l = m + 1;
        } else {
            r = m;
        }
    }
    ask(r);
}

void player2() {
    int n;
    cin >> n;
    int q;
    cin >> q;
    if (n == 1) {
        cout << 1 << endl;
        ask2(1);
        return;
    }
    int l = 0, r = n;
    while (l < r) {
        int m = (l + r) / 2;
        int res = ask2(m);
        if (res == 0) {
            cout << m << endl;
            return;
        }
        if (res == 1) {
            l = m + 1;
        } else {
            r = m;
        }
    }
    cout << r << endl;
    ask2(r);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    if (t == 1) {
        player1();
    } else {
        player2();
    }
}