#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>



int64_t mod = 1e9 + 7;

int mul(int a, int b) {
	return (a * 1ll * b) % mod;
}

int sum(int a, int b) {
	return (a + b) % mod;
}

int sub(int a, int b) {
	return (a + mod - b) % mod;
}



int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int t;
	std::cin >> t;

	std::string s;
	std::cin >> s;
	int n = s.size();
	std::vector<bool> vec(n);
	for (int i = 0; i < n; i++) {
		vec[i] = s[i] == '1';
	}

	if (t == 1) {
		if (n == 10) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < 3; j++) {
					std::cout << vec[i];
				}
			}
			return 0;
		}


	} else {
		if (n == 30) {
			for (int i = 0; i < n / 3; i++) {
				int sum = std::accumulate(vec.begin() + i * 3, vec.begin() + i * 3 + 3, 0);
				std::cout << (sum >= 2);
			}
		}

	}

	return 0;
}
