#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
typedef long long LL;

using namespace std;

void solveFirst(string s) {
	string ans = s;

	LL zerosums = 0;
	for (int i = 0; i < s.length(); i++)
	{
		if (s[i] == '0') {
			zerosums += i;
		}
	}

	for (int i = 0; i < 17; i++)
	{
		int q = (zerosums >> i) % 2;
		ans += ('0' + q);
	}

	cout << ans << endl;
}

void solveSecond(string s) {
	LL zerosums = 0;
	LL rightsums = 0;

	for (int i = 0; i < s.length() - 17; i++)
	{
		if (s[i] == '0') {
			zerosums += i;
		}
	}

	for (int i = s.length() - 17; i < s.length(); i++)
	{
		rightsums += (1ll >> (i - s.length() + 17)) * (LL)(s[i] - '0');
	}

	string ans = "";

	for (int i = 0; i < s.length() - 17; i++)
	{
		ans += s[i];
		if (zerosums > rightsums) {
			if (s[i] == '0') {
				if (zerosums - i == rightsums) {
					ans[i] = '1';
					zerosums -= i;
				}
			}
		}
		if (zerosums < rightsums) {
			if (s[i] == '1') {
				if (zerosums + i == rightsums) {
					ans[i] = '0';
					zerosums += i;
				}
			}
		}
	}

	cout << ans << endl;
}

int D() {
	int type;
	cin >> type;
	string s;
	cin >> s;

	string ans = "";

	if (type == 1) {
		solveFirst(s);
	}
	else {
		solveSecond(s);
	}

	return 0;
}