#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 1040;
int d[maxn][maxn];

void solve() {
    for (int i = 0; i < maxn; i++) {
        for (int j = 0; j < maxn; j++) {
            if (i == j) {
                d[i][j] = 0;
            } else if (i < j) {
                d[i][j] = (i ^ j) % 20;
            } else {
                d[i][j] = d[j][i];
            }
        }
    }
    for (int k = 0; k < maxn; k++) {
        for (int i = 0; i < maxn; i++) {
            for (int j = 0; j < maxn; j++) {
                d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
            }
        }
    }
    if (d[0][1] != -42) {
        ll x, y; cin >> x >> y;
        cout << x + y << '\n';
    }
}

signed main() {
    //int START = clock();
    ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);

    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }

    //cout << double(int(clock()) - START) / CLOCKS_PER_SEC;
    return 0;
}