#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <iomanip>

using namespace std;
#define int long long
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	string s, t;
	cin >> s >> t;
	reverse(s.begin(), s.end());
	reverse(t.begin(), t.end());
	while (s.size() < t.size()) s += '0';
	while (t.size() < s.size()) t += '0';
	vector <int> a, b;
	for (auto& x : s)
		a.push_back(x - '0');
	for (auto& x : t)
		b.push_back(x - '0');
	vector <int> c(a.size());
	int cur = 0;
	for (int i = 0; i < a.size(); ++i) {
		c[i] = (a[i] + b[i] + cur) % 10;
		cur = (a[i] + b[i] + cur) / 10;
	}
	if (cur) c.push_back(cur);
	reverse(c.begin(), c.end());
	for (auto x : c) cout << x;
	cout << '\n';
}