#include <bits/stdc++.h>
#pragma GCC optimize("Ofast, unroll-loops")

#define ALL(x) (x).begin(), (x).end()

using namespace std;

int n;

mt19937_64 rnd(566);

const int MAX_SZ = 500;

int solve() {
    vector<long long> nums(1);
    while (cin >> nums[nums.size() - 1]) {nums.emplace_back(0);}
    nums.pop_back();
    reverse(ALL(nums));

    vector<vector<long long>> to_for(MAX_SZ, vector<long long>(MAX_SZ));
    for (int i = 0; i < MAX_SZ; ++i) {
        for (int j = 0; j < MAX_SZ; ++j) {
            to_for[i][j] = i * 239 + j * 566 + i * j + 1;
        }
    }

    for (int i = 0; i < MAX_SZ; ++i) {
        for (int j = 0; j < MAX_SZ; ++j) {
            for (int k = 0; k < MAX_SZ; ++k) {
                to_for[i][j] = to_for[i][k] % to_for[k][j] + i * k + 3;
            }
        }
    }
    if (to_for[MAX_SZ - 1][MAX_SZ - 1] == 1) return 1;
    for (long long e : nums) {
        cout << e << ' ';
    }
    cout << '\n';

    return 0;
}

int main() {
#ifdef LOCAL
    freopen("B.in", "r", stdin);
#endif
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(false);


    int tests = 1;
    // cin >> tests;
    for (int i = 1; i <= tests; ++i) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "---------------\n";
#endif
    }
    return 0;
}
