#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

string sum(string a, string b) {
	string res;
	ll psh = 0;
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	while (a.size() < b.size()) a.push_back('0');
	while (b.size() < a.size()) b.push_back('0');
	a.push_back('0');
	b.push_back('0');

	for (int i = 0; i < a.size(); i++) {
		res.push_back(a[i] - '0' + b[i] - '0' + psh);
		psh = res.back() / 10;
		res.back() %= 10;
		res.back() += '0';
	}

	while (res.size() > 1 && res.back() == '0') res.pop_back();

	reverse(res.begin(), res.end());
	return res;
}

int main() {
	fastInp;

	string a, b;
	cin >> a >> b;

	cout << sum(a, b);

	return 0;
}