#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

void sol1() {
	string s;
	cin >> s;

	string nw = s;
	
	ll c = 0;
	for (auto k : s) {
		if (k == '1') {
			c++;
		}
	}

	c %= 2;

	for (int i = 1; i < s.size(); i++) {
		if (s[i] == s[i - 1]) {
			nw.push_back('1');
		}
		else {
			nw.push_back('0');
		}
	}

	nw.push_back(c + '0');
	cout << nw;
	exit(0);
}

void sol2() {
	string st;
	cin >> st;
	string s, s2, ans, s3;
	for (int i = 0; i < st.size() / 2; i++) s.push_back(st[i]);

	s2.push_back('0');
	s3.push_back('1');

	for (int j = st.size() / 2; j < st.size() - 1; j++) {
		if (st[j] == '1') {
			s2.push_back(s2.back());
			s3.push_back(s3.back());
		}
		else {
			s2.push_back(((s2.back() - '0') ^ 1) + '0');
			s3.push_back(((s3.back() - '0') ^ 1) + '0');
		}
	}

	ll dif1 = 0, dif2 = 0;
	for (int i = 0; i < s2.size(); i++) {
		if (s2[i] != s[i]) dif1++;
		if (s3[i] != s[i]) dif2++;
	}

	if (dif1 > dif2) {
		swap(s2, s3);
	}

	if (s2 == s) {
		ans = s;
	}
	else {
		ll c = 0;
		for (auto cur : s) {
			if (cur == '1') c++;
		}

		c %= 2;

		if (c == st.back() - '0') {
			ans = s;
		}
		else {
			ans = s2;
		}
	}

	cout << ans;
	exit(0);
}

int main() {
	fastInp;

	ll t;
	cin >> t;

	if (t == 1) {
		sol1();
	}
	else {
		sol2();
	}

	return 0;
} 