#include <iostream>
#include <bitset>
#include <cassert>

using namespace std;

int x;
string s;

void read() {
    cin >> x >> s;
}

void solve() {
    if (x == 1) {
        int sum = 0;
        for (int i = 0; i < s.size(); ++i) {
            if (s[i] == '1') {
                sum ^= (i + 1);
            }
        }
        if (s.size() <= 10) {
            bitset<10> y(sum);
            cout << y << y;
        } else {
            bitset<20> y(sum);
            cout << y << y;
        }
        cout << s << "\n";
    } else {
        int k = 20;
        if (s.size() <= 28) {
            k = 10;
        }
        int y = 0;
        for (int i = 0; i < k; ++i) {
            y <<= 1;
            y += s[i] - '0';
            if (s[i] != s[i + k]) {
                cout << s.substr(2 * k);
                return;
            }
        }

        int sum = 0;
        string ans = s.substr(2 * k);
        for (int i = 0; i < ans.size(); ++i) {
            if (ans[i] == '1') {
                sum ^= (i + 1);
            }
        }

        if (sum != y) ans[(sum ^ y) - 1] = '0' + '1' - ans[(sum ^ y) - 1];

        cout << ans << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}
