#include <bits/stdc++.h>

using namespace std;
#define get(x) cout << #x << " : " << (x) << endl
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define fork(s, i, n) for (int i = (s); i < (n); ++i)
#define printl(x) cout << x << '\n'
#define printe(x) cout << x << ' '
#define null(x) memset(x, 0, sizeof(x))
#define sz(x) (int)x.size()
#define nLine() cout << '\n'
#define pii pair<int, int>
#define fi first
#define se second
#define vpii vector<pii>
#define vi vector<int>
#define dfor(i, n) for (int i = (n) - 1; i >= 0; --i)
#define point() cout << "Have reached" << endl

void MP() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
}

const int MAX = 105;

inline bool gt(int a, int i) {
    return (a >> i) & 1;
}

void solve1() {
    int k, n;
    cin >> k >> n;
    bool a[k][k];
    forn (i, k) {
        forn (j, k) {
            char c;
            cin >> c;
            a[i][j] = c == '1';
        }
    }
    string s;
    cin >> s;
    int d[n][n];
    forn (l, n) {
        fork (l, r, n) {
            bool change = true;
            string t = s.substr(l, r - l + 1);
            while (change && sz(t)) {
                change = false;
                dfor (i, sz(t)) {
                    if (i && a[t[i - 1] - 'a'][t[i] - 'a']) {
                        t.erase(t.begin() + i);
                        change = true;
                        break;
                    }
                    if (!i && l && a[s[l - 1] - 'a'][t[i] - 'a']) {
                        t.erase(t.begin());
                        change = true;
                        break;
                    }
                }
            }
            d[l][r] = t.empty();
        }
    }
    string ans;
    ans += (char)('z' + 1);
    forn (mask, (1 << n)) {
        int id = 0;
        bool ok = true;
        forn (i, n) {
            if (gt(mask, i)) {
                if (id <= i - 1 && !d[id][i - 1]) {
                    ok = false;
                    break;
                }
                id = i + 1;
            }
        }
        if (id <= n - 1) {
            if (!d[id][n - 1]) ok = false;
        }
        if (ok) {
            string t;
            forn (i, n) {
                if (gt(mask, i)) t += s[i];
            }
            ans = min(ans, t);
        }
    }
    printl(ans);
}

void solve() {
    int k, n;
    cin >> k >> n;
    bool a[k][k];
    forn (i, k) {
        forn (j, k) {
            char c;
            cin >> c;
            a[i][j] = c == '1';
        }
    }
    string s;
    cin >> s;
    int d[n][n];
    forn (l, n) {
        fork (l, r, n) {
            bool change = true;
            string t = s.substr(l, r - l + 1);
            while (change && sz(t)) {
                change = false;
                dfor (i, sz(t)) {
                    if (i && a[t[i - 1] - 'a'][t[i] - 'a']) {
                        t.erase(t.begin() + i);
                        change = true;
                        break;
                    }
                    if (!i && l && a[s[l - 1] - 'a'][t[i] - 'a']) {
                        t.erase(t.begin());
                        change = true;
                        break;
                    }
                }
            }
            d[l][r] = t.empty();
        }
    }
    string dp[n];
    dp[0] += s[0];
    fork (1, i, n) {
        dp[i] = dp[i - 1];
        dp[i] += s[i];
        forn (l, i) {
            if (d[l][i - 1]) {
                string val = dp[l - 1];
                val += s[i];
                dp[i] = min(dp[i], val);
            }
        }
    }
    bool change = true;
    if (sz(dp[n - 1]) >= 2 && change) {
        change = false;
        if (a[dp[n - 1][sz(dp[n - 1]) - 2] - 'a'][dp[n - 1].back() - 'a']) {
            dp[n - 1].pop_back();
            change = true;
        }
    }
    assert(!dp[n - 1].empty());
    printl(dp[n - 1]);
}

signed main() {
    MP();
    solve1();
}