#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define ld long double

vector<int> cl, to;
int k, n;
string s;

bool erase(int l, int r) {
    if (to[r - 1] > l)return false;
    for(int j = l + 1; j < r; ++j){
        if(cl[j] != j - 1 && cl[j] > cl[j - 1])return false;
    }
    for (int j = l ; j < r; ++j)if (cl[j] < l)return false;
    return true;
}

int solve(int last) {
    if (last == n - 1)return -1;
    if (erase(last, n))return -1;

    for (int c = 0; c < 26; ++c) {
        for (int i = last + 1; i < n; ++i) {
            if ((int) (s[i] - 'a') == c && erase(last, i))return i;
        }
    }
    return n - 1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> k >> n;
    vector<vector<int>> er(26);

    for (int i = 0; i < k; ++i) {
        string S;
        cin >> S;
        for (int j = 0; j < k; ++j) {
            if (S[j] == '1')er[j].push_back(i);
        }
    }

    cin >> s;
    cl.resize(n, -1);
    to.resize(n, -1);
    vector<int> last(26, -1);

    for (int i = 0; i < s.size(); ++i) {
        for (int j : er[s[i] - 'a']) {
            cl[i] = max(cl[i], last[j]);
        }
        last[s[i] - 'a'] = i;
    }


    int l = 0;
    string res;
    res.push_back(s[0]);
    while (true) {
        l = solve(l);
        if (l == -1)break;
        res.push_back(s[l]);
    }
    cout << res;
}
