#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_K = 30;
const int MAX_N = 500005;
int k, n;
bool A[MAX_K][MAX_K];
string s;
string dp[MAX_N];
int to[MAX_N];

int main()
{
	//freopen(".in", "r", stdin);
	//freopen(",out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> k >> n;
	char c;
	for (int i = 0; i < k; i++)
	{
		for (int j = 0; j < k; j++)
		{
			cin >> c;
			A[i][j] = c - '0';
		}
	}
	cin >> s;

	dp[n - 1] = s[n - 1];
	to[n - 1] = n;
	vector<int> v;
	for (int i = n - 2; i >= 0; i--)
	{
		v.clear();
		for (int j = n - 1; j > i; j--)
		{
			v.push_back(j);
			while (!v.empty() && A[s[j - 1] - 'a'][s[v.back()] - 'a'])
				v.pop_back();
		}

		if (v.empty())
		{
			dp[i] = s[i];
			to[i] = n;
		}
		else
		{
			c = 'z' + 1;
			for (int j = i + 1; j <= v.back(); j++)
			{
				c = min(c, s[j]);
			}
			dp[i] = 'z' + 1;
			to[i] = n;
			for (int j = i + 1; j <= v.back(); j++)
			{
				if (s[j] == c && dp[j] < dp[i])
				{
					dp[i] = dp[j];
					to[i] = j;
				}
			}
			dp[i] = s[i] + dp[i];
		}
	}

	cout << dp[0];

	/*int cur = 0;
	while (cur < n)
	{
		cout << s[cur];
		cur = to[cur];
	}*/

	return 0;
}