#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define f first
#define s second

const int maxk = 26, maxn = 2228;

int used[maxk][maxk];
bool del[maxn][maxn];

bool cmp(string a, string b) {
    for (int i = 0; i < min(a.size(), b.size()); ++i) {
        if (a[i] != b[i]) {
            return a[i] < b[i];
        }
    }
    return a.size() < b.size();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int k, n;
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            used[i][j] = (c - '0');
        }
    }
    string s;
    cin >> s;
    for (int i = 1; i < n; ++i) {
        if (used[s[i - 1] - 'a'][s[i] - 'a'] == 0) {
            continue;
        }
        del[i][i] = 1;
        vector<int> st;
        st.pb(i - 1);
        st.pb(i);
        for (int j = i + 1; j < n; ++j) {
            while (st.size() > 1) {
                if (!used[s[st.back()] - 'a'][s[j] - 'a']) {
                    st.pop_back();
                } else {
                    break;
                }
            }
            if (!used[s[st.back()] - 'a'][s[j] - 'a']) {
                break;
            }
            del[i][j] = 1;
            st.pb(j);
        }
    }
    vector<string> dp(n);
    for (int i = 0; i < n; ++i) {
        if (i == 0) {
            dp[i] = "";
            dp[i] += s[i];
        } else {
            dp[i] = dp[i - 1] + s[i];
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (j == i + 1) {
                if (cmp(dp[i] + s[j], dp[j])) {
                    dp[j] = dp[i] + s[j];
                }
            } else {
                if (del[i + 1][j - 1] && cmp(dp[i] + s[j], dp[j])) {
                    dp[j] = dp[i] + s[j];
                }
            }
        }
    }
    string ans = dp[n - 1];
    for (int i = 0; i < n; ++i) {
        if (del[i + 1][n - 1]) {
            if (cmp(dp[i], ans)) {
                ans = dp[i];
            }
        }
    }
    cout << ans;
    return 0;
}
