#include <bits/stdc++.h>

#define ld double
#define ft first
#define sd second
#define pb push_back

using namespace std;

int k, n;
bool a[26][26];
int dp[5000][5000];
string s;
bool get(int l, int r) {
    if (l > r) return 0;
    if (l == r) return 1;
    if (dp[l][r] != -1) return dp[l][r];
    dp[l][r] = 0;
    for (int i = l + 1; i <= r; ++i) {
        if (a[s[l] - 'a'][s[i] - 'a'] && get(l, i - 1) && get(i, r)) {
            dp[l][r] = 1;
            break;
        }
    }
    return dp[l][r];
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef FREOPEN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
        }
    }
    cin >> s;
    string cur[n][n + 1];
    for (int i = 0; i < n; ++i) {
        fill(dp[i], dp[i] + n, -1);
    }
    cur[0][1] += s[0];
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (!get(j, i - 1)) continue;
            for (int len = 2; len <= i + 1; ++len) {
                if (!cur[j][len - 1].empty() && (cur[i][len].empty() || cur[i][len] > cur[j][len - 1] + s[i])) {
                    cur[i][len] = cur[j][len - 1] + s[i];
                }
            }
        }
    }
    string ans;

    for (int i = 0; i < n; ++i) {
        for (int len = 0; len <= n; ++len) {
            if (!cur[i][len].empty() && get(i, n - 1) && (ans.empty() || ans > cur[i][len]))
                ans = cur[i][len];
        }
    }

    cout << ans;
    return 0;
}