#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void permutations(uint64_t n, vector <vector <char>> ar, vector <uint64_t> &ans, vector <uint64_t> iter, vector <bool> used, string s, bool trig)
{
	if (iter.size() == n)
	{
		
		vector <bool> pos(ar[0].size(), true); // size of m
		for (auto k : iter)
		{
			for (uint64_t l = 0; l < ar[k].size(); ++l)
			{
				if (!pos[l])
				{
					if (ar[k][l] == s[l])
					{
						pos[l] = false;
					}
					else if (ar[k][l] != '_')
					{
						trig = false;
						break;
					}
				}
			}
			if (!trig)
			{
				break;
			}
		}
		if (trig)
		{
			ans = iter;
			return;
		}
		trig = true;
	}
	for (uint64_t k = 0; k < n; ++k)
	{
		if (!used[k])
		{
			used[k] = true;
			iter.push_back(k);
			permutations(n, ar, ans, iter, used, s, trig);
			iter.pop_back();
			used[k] = false;
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	uint64_t n, m, indx, size;
	string s;
	char elem;
	vector <vector <char>> ar;
	vector <uint64_t> ans;

	cin >> n >> m;
	vector <bool> used(n, false);
	cin >> s;
	for (uint64_t k = 0; k < n; ++k)
	{
		cin >> size;
		ar.push_back({});
		for (uint64_t l = 0; l < size; ++l)
		{
			cin >> indx >> elem;
			for (uint64_t i = ar[k].size(); i < indx - 1; ++i)
			{
				ar[k].push_back('_');
			}
			ar[k].push_back(elem);
		}
		for (uint64_t i = ar[k].size(); i < m; ++i)
		{
			ar[k].push_back('_');
		}
	}
	/*
	for (auto k : ar)
	{
		cout << k.size() << " ";
		for (auto l : k)
		{
			cout << l;
		}
		cout << '\n';
	}
	*/
	permutations(n, ar, ans, {}, used, s, true);

	if (ans.empty())
	{
		cout << "-1";
	}
	else
	{
		for (auto k : ans)
		{
			cout << k + 1 << ' ';
		}
	}

	return 0;

}