#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>
#include <chrono>
#include <ctime>
#include <random>
#include <cstring>
using namespace std;
#define pb push_back
#define cap(x) (int)x.size()
const int N = 1010;
int A[100][100];
int f[N];
mt19937 rnd(time(0));
vector<int> g[N];
int k, n;
string s, ans;
int used[N];
void dfs(vector<int> v) {
	if (v.size() == 1 && v[0] == n) return;
	char mn = 'z';
	for (int x : v) {
		mn = min(mn, s[x]);
	}
	ans.pb(mn);
	vector<int> nxt;
	for (int x : v) {
		if (s[x] == mn) {
			for (int to : g[x])
				if (!used[to]) {
					used[to] = 1;
					nxt.pb(to);
				}
		}
	}
	if (cap(nxt))
		dfs(nxt);
}
void solve1() {
	used[0] = 1;
	dfs({ 0 });
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cin >> k >> n;
	for (int i = 0; i < k; i++)
		for (int j = 0; j < k; j++) {
			char c;
			cin >> c;
			A[i][j] = c - '0';
		}
	cin >> s;
	memset(f, -1, sizeof f);
	for (int i = 1; i < n; i++) {
		int j = i - 1;
		int y = s[i] - 'a';
		while (j != -1) {
			int x = s[j] - 'a';
			if (A[x][y]) {
				f[i] = j;	
				break;
			}
			j = f[j];
		}
	}
	for (int i = 0; i < n; i++) {
		g[i].pb(i + 1);
		int j = f[i];
		while (j != -1) {
			g[j].pb(i + 1);
			j = f[j];
		}
	}
	solve1();
	cout << ans;
	return 0;
}
/*
3 7
010
001
100
abacaba
*/