#include <iostream>
#include <string>
#include <queue>
#include <set>

using namespace std;

int main() {
    int k, n; cin >> k >> n;
    vector<int> len(n);
    vector t(k, vector<bool>(k));
    for (int i = 0; i < k; ++i) {
        string s; cin >> s;
        for (int j = 0; j < k; ++j) t[i][j] = s[j] == '1';
    }

    string s; cin >> s;
    string ans = s;

    set<string> r;
    queue<string> q({s});
    while (!q.empty()) {
        string s = q.front(); q.pop();
        ans = min(ans, s);
        for (int i = 1; i < s.size(); ++i) {
            if (t[s[i-1]-'a'][s[i]-'a']) {
                string t = string(s.begin(), s.begin()+i) + string(s.begin()+i+1, s.end());
                if (!r.count(t)) {
                    r.insert(t);
                    q.push(t);
                }
            }
        }
    }

    cout << ans << endl;
}