#include <bits/stdc++.h>
using namespace std;

int prv(int k) {
    return (k & (k + 1)) - 1;
}

int nxt(int k) {
    return k | (k + 1);
}

vector<vector<int>> ft;

int rmq(int x, int y) {
    int res = 0;
    for (int i = 0; i <= x; i = nxt(i)) {
        for (int j = 0; j <= y; j = nxt(j))
            res += ft[i][j];
    }
    return res;
}

void set1(int x, int y) {
    for (int i = x; i >= 0; i = prv(i)) {
        for (int j = y; j >= 0; j = prv(j))
            ++ft[i][j];
    }
}

int sum(int x1, int y1, int x2, int y2) {
    return rmq(x2, y2) - rmq(x2, y1) - rmq(x1, y2) + rmq(x1, y1);
}

int main() {
    int t, n, k, m;
    cin >> t >> n >> k >> m;
    ft.assign(n, vector<int>(n, 0));
    if (t == 1) {
        string s;
        cin >> s;
        int game = 0, i = 0;
        vector<vector<int>> ones(n, vector<int>(n, 0));
        while (i < m) {
            int x = -1, y = -1;
            if (game % 2 == 1) {
                cin >> x >> y;
                --x;
                --y;
                for (int _x = x; _x < n; ++_x) {
                    for (int _y = y; _y < n; ++_y) {
                        set1(_x, _y);
                        ones[_x][_y] = 1;
                    }
                }
            }
            while (x != 0 || y != 0) {
                int bx = -1, by = -1, emp = 0;
                for (int _x = 0; _x < n; ++_x) {
                    for (int _y = 0; _y < n; ++_y) {
                        int _emp = (n - _x) * (n - _y) - sum(_x, _y, n - 1, n - 1);
                        if ((_x + _y) % 2 == (s[i] - '0') && ones[_x][_y] == 0 && (bx == -1 || _emp < emp)) {
                            bx = _x;
                            by = _y;
                            emp = _emp;
                        }
                    }
                }
                if (bx == -1) {
                    bx = 0;
                    by = 0;
                }
                cout << bx + 1 << ' ' << by + 1 << endl;
                for (int _x = bx; _x < n; ++_x) {
                    for (int _y = by; _y < n; ++_y) {
                        if (ones[_x][_y] == 0) {
                            set1(_x, _y);
                            ones[_x][_y] = 1;
                        }
                    }
                }
                if (bx == 0 && by == 0)
                    break;
                cin >> x >> y;
                --x;
                --y;
                for (int _x = x; _x < n; ++_x) {
                    for (int _y = y; _y < n; ++_y) {
                        if (ones[_x][_y] == 0) {
                            set1(_x, _y);
                            ones[_x][_y] = 1;
                        }
                    }
                }
                ++i;
            }
            for (int _x = 0; _x < n; ++_x) {
                for (int _y = 0; _y < n; ++_y) {
                    ft[_x][_y] = 0;
                    ones[_x][_y] = 0;
                }
            }
            ++game;
        }
        cout << 0 << endl;
    }
    else {
        int num;
        cin >> num;
        string s;
        int game = 0, i = 0;
        vector<vector<int>> ones(n, vector<int>(n, 0));
        while (i < m) {
            int x = -1, y = -1;
            if (game % 2 == 1) {
                cin >> x >> y;
                --x;
                --y;
                for (int _x = x; _x < n; ++_x) {
                    for (int _y = y; _y < n; ++_y) {
                        set1(_x, _y);
                        ones[_x][_y] = 1;
                    }
                }
            }
            while (x != 0 || y != 0) {
                cin >> x >> y;
                --x;
                --y;
                if (x == 0 && y == 0)
                    break;
                s.push_back('0' + (x + y) % 2);
                for (int _x = x; _x < n; ++_x) {
                    for (int _y = y; _y < n; ++_y) {
                        if (ones[_x][_y] == 0) {
                            set1(_x, _y);
                            ones[_x][_y] = 1;
                        }
                    }
                }
                cin >> x >> y;
                --x;
                --y;
                for (int _x = x; _x < n; ++_x) {
                    for (int _y = y; _y < n; ++_y) {
                        if (ones[_x][_y] == 0) {
                            set1(_x, _y);
                            ones[_x][_y] = 1;
                        }
                    }
                }
                ++i;
            }
            for (int _x = 0; _x < n; ++_x) {
                for (int _y = 0; _y < n; ++_y) {
                    ft[_x][_y] = 0;
                    ones[_x][_y] = 0;
                }
            }
            ++game;
        }
        for (int j = 0; j < m; ++j)
            cout << s[j];
        cout << endl;
    }
}
