#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define all(a) (a).begin(), (a).end()
#define int long long
typedef long long ll;
using namespace std;

const int INF = 1e18;

signed main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif

    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<pair<int, char>>> a(n);
    vector<vector<int>> here_s(m);
    vector<int> cnt_a(n);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        a[i].resize(t);
        for (int j = 0; j < t; ++j) {
            cin >> a[i][j].first >> a[i][j].second;
            a[i][j].first--;
            if (a[i][j].second != s[a[i][j].first]) {
                here_s[a[i][j].first].emplace_back(i);
                cnt_a[i]++;
            }
        }
    }

    vector<int> ans, used_s(m);
    set<pair<int, int>> solver;

    for (int i = 0; i < n; ++i) {
        solver.emplace(cnt_a[i], i);
    }

    while (!solver.empty()) {
        auto cur = *solver.begin();
        solver.erase(solver.begin());
        if (cur.first > 0) {
            cout << -1;
            return 0;
        }
        ans.emplace_back(cur.second);
        for (auto i : a[cur.second]) {
            if (s[i.first] == i.second && !used_s[i.first]) {
                used_s[i.first] = 1;
                for (int j : here_s[i.first]) {
                    solver.erase(make_pair(cnt_a[j], j));
                    cnt_a[j]--;
                    solver.emplace(cnt_a[j], j);
                }
            }
        }
    }

    for (int i = 0; i < m; ++i) {
        if (used_s[i] == 0) {
            cout << -1;
            return 0;
        }
    }
    for (int i : ans) {
        cout << i + 1 << ' ';
    }
    return 0;
}
