#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define all(a) (a).begin(), (a).end()
#define int long long
typedef long long ll;
using namespace std;

const int INF = 1e18;

string int_to_byte(int x) {
    string res;
    for (int i = 0; i < 5; ++i) {
        res += (x % 2 + '0');
        x /= 2;
    }
    reverse(all(res));
    return res;
}

int calc(string s) {
    int res = 0;
    for (auto i : s) {
        res = res * 2 + (i == '1');
    }
    //cout << s << ' ' << res << endl;
    return res;
}

signed main() {
#ifdef LOCAL
    //freopen("input", "r", stdin);
    //freopen("output", "w", stdout);
#else
    //ios_base::sync_with_stdio(0);cin.tie(0);
#endif

    //freopen("/tmp/game.in", "r", stdin);
    //freopen("/tmp/game.out", "w", stdout);
    int run;
    cin >> run;
    int n, k, m;
    cin >> n >> k >> m;
    if (run == 1) {
        string s;
        cin >> s;
        while (m % 5 != 0) {
            m++;
            s += "0";
        }
        vector<int> bl;
        for (int i = 0; i < m; i += 5) {
            bl.emplace_back(calc(s.substr(i, 5)));
        }

        for (int game = 0; game < bl.size(); ++game) {
            if (game % 2 == 0) {
                //first turn
                cout << bl[game] + 1 << ' ' << n - bl[game] << endl;
                pair<int, int> turn;
                cin >> turn.first >> turn.second;
                cout << 1 << ' ' << 1 << endl;
            } else {
                //second turn
                pair<int, int> turn;
                cin >> turn.first >> turn.second;
                cout << bl[game] + 1 << ' ' << n - bl[game] << endl;
                cin >> turn.first >> turn.second;
                cout << 1 << ' ' << 1 << endl;
            }
        }
        cout << 0 << endl;
    } else {
        int games;
        cin >> games;
        string ans;
        vector<int> blocks;
        for (int game = 0; game < games; ++game) {
            vector<pair<int, int>> turns;
            pair<int, int> turn;
            while (1) {
                cin >> turn.first >> turn.second;
                turns.emplace_back(turn);
                if (turn == make_pair(1ll, 1ll)) {
                    break;
                }
            }
            if (game % 2 == 0) {
                //first turn
                blocks.emplace_back(turns[0].first - 1);
            } else {
                //second turn
                blocks.emplace_back(turns[1].first - 1);
            }
        }
        for (int i : blocks) {
            ans += int_to_byte(i);
        }
        cout << ans.substr(0, m) << endl;
    }
    return 0;
}
