#include <bits/stdc++.h>
using namespace std;

#define size(a) (int)(a.size())
#define chkmax(a, b) a = max(a, b)
#define chkmin(a, b) a = min(a, b)

const int max_n = 2e5 + 3;

int n;
int gr[26][26];
string s;
int f[max_n];
int dp[max_n];
set<int> b;

bool chk(int l, int r) {
	vector<int> a;
	for(int i = r;i >= l;i--) {
		while(size(a) && gr[s[i] - 'a'][a.back()]) a.pop_back();
		a.emplace_back(s[i] - 'a');
	}
	return size(a) == 1;
}

void build_f() {
	/*f[n] = n;
	for(int i = n - 1;i >= 0;i--) {
		int mx = i + 1;
		for(int j = i + 1;j < i + 2;j++) {
			if (!gr[s[i] - 'a'][s[j] - 'a']) break;
			chkmax(mx, f[j]);
		}
		for(;mx < n;mx++)
			if (!gr[s[i] - 'a'][s[mx] - 'a']) break;
		f[i] = mx;
	}*/
	for(int i = 0;i < n;i++) {
		for(int j = i;j < n;j++) {
			if (j + 1 < n && !chk(i, j) && chk(i, j + 1)) while(n > 0) n++;
			if (chk(i, j)) f[i] = j + 1;
		}
	}
}

void solve() {
	int k;
    cin >> k >> n;
    for(int i = 0;i < k;i++) {
        string s;
        cin >> s;
        for(int j = 0;j < k;j++)
            gr[i][j] = s[j] - '0';
    }
    cin >> s;
 
    build_f();
    /*for(int i = 0;i < n;i++)
        cout << f[i] << " ";
    cout << endl;*/
 
    b.emplace(n);
    for(int i = n - 1;i >= 0;i--) {
        int k = *(--b.upper_bound(f[i]));
        dp[i] = k;
        while(true) {
            int v = *b.begin();
            if (v == n || s[v] < s[i]) break;
            if (s[v] == s[i] && dp[v] > dp[i]) break;
            b.erase(b.begin());
        }
        b.emplace(i);
    }
 	
 	//cout << dp[0];
    string t;
    int id = 0;
    while(id < n)
        t += s[id], id = dp[id];
    cout << t << endl;
}


signed main() {
	cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
	#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif

	solve();
}