#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;
    vector <vector <bool> > g(n, vector <bool> (n));

    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
        {
            char ch; cin >> ch;
            g[i][j] = bool(ch - '0');
        }

    string s;
    cin >> s;


    vector <vector <string> > dp(q, vector <string> (q));
    for (int len = 1; len <= q; len++)
        for (int left = 0; left <= q - len; left++)
        {
            int right = left + len - 1;
            if (len == 1)
            {
                dp[left][right] = s[left];
            } else
            {
                dp[left][right] = s.substr(left, right - left + 1);
                for (int mid = left; mid < right; mid++)
                {
                    string lhs = dp[left][mid];
                    string rhs = dp[mid + 1][right];
                    dp[left][right] = min(lhs + rhs, dp[left][right]);
                    while (rhs.size() && g[lhs.back() - 'a'][rhs[0] - 'a'])
                    {
                        rhs = rhs.substr(1);
                        dp[left][right] = min(dp[left][right], lhs + rhs);
                    }
                }
            }

            //cout << left << " " << right << " " << dp[left][right] << "\n";
        }

    cout << dp[0].back();
}

