#include <bits/stdc++.h>

std::string s;

int main() {
    int n, m;
    std::cin >> n >> m;
    std::cin >> s;

    std::vector<int> order(n);
    std::iota(order.begin(), order.end(), 0);
    std::vector<std::vector<std::pair<int, char>>> cards(n);
    for (auto &i : cards) {
        int sz;
        std::cin >> sz;
        i.resize(sz);
        for (auto &j : i) std::cin >> j.first >> j.second, --j.first;
    }

    auto check = [&]() {
        char have[m];
        memset(have, 0, sizeof(have));
        for (auto &i : order) {
            for (auto &[p, e] : cards[i]) {
                if (have[p] == 0) have[p] = e;
            }
        }
        bool good = true;
        for(int i = 0; i < m; i++) good &= s[i] == have[i];

        return good;
    };

    order.clear();
    char have[m];
    bool used[n];
    memset(used, 0, sizeof used);
    memset(have, 0, sizeof have);

    std::set<std::pair<int, int>> ord;
    int cnt[n]; // bad poss for card i
    memset(cnt, 0, sizeof(cnt));

    std::set<int> badEls[m];
    for(int i = 0; i < n; i++) {
        for(auto &[p, e] : cards[i]) {
            cnt[i] += e != s[p];

            if(s[p] != e) badEls[p].insert(i);
        }

        ord.insert(std::make_pair(cnt[i], i));
    }

    while(!ord.empty()) {
        auto [cntUseless, ind] = *ord.begin();
        ord.erase(ord.begin());
        order.push_back(ind);

        for(auto &[p, e] : cards[ind]) {
            badEls[p].erase(ind);
            if(have[p]) continue;

            for(auto &bad : badEls[p]) {
                ord.erase(std::make_pair(cnt[bad], bad));
                cnt[bad]--;
                ord.insert(std::make_pair(cnt[bad], bad));
            }
        }
    }

    if(check()) {
        for(auto &I : order) std::cout << I + 1 << ' ';
        std::cout << '\n';
        return 0;
    }

    std::cout << -1 << '\n';
}
