#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

const int MAXN = 1e5 + 15;

vi adj[MAXN];
vi can[MAXN];
int what[MAXN];
int n;

void Answer() {
    cout << "Yes\n";
    for (int i = 1; i <= n; ++i) {
        if (can[i].empty()) {
            cout << adj[i] << '\n';
        } else {
            cout << what[i] << '\n';
        }
    }
    exit(0);
}

void Check(const vi& order, const vector<vpi>& all, vpi& ans, int i = 0, int mn = 1000000, int mx = -1) {
    if (i == sz(order)) {
        if (mn <= mx) {
            ans.eb(mn, mx);
        }
        return;
    }
    int me = order[i];
    for (auto now : all[me]) {
        if (now.first <= mx) {
            continue;
        }
        Check(order, all, ans, i + 1, min(mn, now.first), now.second);
    }
}

vpi DFS(int v) {
    vpi ans;
    if (can[v].empty()) {
       vector <vpi> all;
       for (auto u : adj[v]) {
           all.eb(DFS(u));
       }
       vi order(sz(adj[v]));
       iota(all(order), 0);
       do{
           Check(order, all, ans);
       }while(next_permutation(all(order)));
   } else {
       for (auto u : can[v]) {
           ans.eb(u, u);
       }
   }
    if (ans.empty()) {
        cout << "No";
        exit(0);
    }
   return ans;
}

void Solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        int who;
        cin >> who;
        int k;
        cin >> k;
        if (who == 1) {
            forn(j, k) {
                int x;
                cin >> x;
                adj[i].eb(x);
            }
        } else {
            forn(j, k) {
                int x;
                cin >> x;
                can[i].eb(x);
            }
        }
    }
    DFS(1);
    cout << "No";
}

signed main() {
//    freopen("/tmp/game.in", "r", stdin);
//    freopen("/tmp/game.out", "w", stdout);
    int start = clock();
    IO();
    Solve();
#ifdef DIVAN
    int Timeme = (clock() - start + 999) / 1000;
    cout << '\n' << "TIME: " << Timeme;
#endif
    return 0;
}
