#include<iostream>
#include<stdio.h>
#include<string>
#include<vector>
#include<deque>
#include<set>
#include<algorithm>
#define mp make_pair
using namespace std;
bool arr[26][26];

void deleteSimilarSymbols(char tgt, string& s)
{
	string sTmp;

	bool WasTgt = false;

	for (auto ch : s)
	{
		if (ch != tgt || !WasTgt)
			sTmp += ch;

		WasTgt = (ch == tgt);
	}

	s = sTmp;
}

vector<pair<char, int>> getSortedCharList(string s)
{
	vector<pair<char, int>> ans;

	for (int i = 0; i < s.size(); i++)
	{
		ans.push_back(mp(s[i], -i));
	}

	ans.push_back(mp('1', -(int)s.size()));
	sort(ans.begin(), ans.end());
	return ans;
}

bool isPossibleToBeFirst(string s, int pos, int leftBorder)
{
	deque<int> stack;
	stack.push_back(leftBorder);

	for (int i = 0; i < pos; i++)
	{
		int curChar = s[i] - 'a';

		while (true)
		{
			if (curChar < 0 || arr[stack.back()][curChar])
			{
				stack.push_back(curChar);
				break;
			}
			else
			{
				stack.pop_back();

				if (stack.empty())
					return false;
			}
		}
	}

	return true;
}

int main()
{
	int k, n;
	cin >> k >> n;

	for (int i = 0; i < k; i++)
		for (int j = 0; j < k; j++)
		{
			char a;
			cin >> a;
			arr[i][j] = a - '0';
		}

	string s;
	cin >> s;

	for (int ch = 0; ch < k; ch++)
	{
		if (arr[ch][ch])
			deleteSimilarSymbols(ch + 'a', s);
	}

	/*if (k <= 2)
	{
		if (k == 1)
		{
			cout << s;
			return 0;
		}

		if (arr[1].find(0) == arr[1].end())
		{
			cout << s;
			return 0;
		}



		if (s[0] == 'b')
			cout << 'b';

		int cnt = 0;

		for (auto ch : s)
			if (ch == 'a')
				cout << 'a';

		return 0;

	}*/
	
	string ans;

	ans += s[0];
	int leftBorder = 0;
	

	while (true)
	{
		string sTmp = s.substr(leftBorder + 1, s.size() - 1 - leftBorder);
		auto v = getSortedCharList(sTmp);

		for (auto p : v)
		{
			if (isPossibleToBeFirst(sTmp, -p.second, s[leftBorder] - 'a'))
			{
				if (p.first != '1')
					ans += p.first;
				leftBorder += (-p.second + 1);
				break;
			}
		}

		if (leftBorder >= s.size() - 1)
			break;
	}

	cout << ans;
}