#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <stack>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.end()

void solve1() {
	int n, k, m;
	cin >> n >> k >> m;
	string s;
	cin >> s;
	int st = 0;
	for (int i{}; i < m; ++i) {
		int t = st;
		bool step = false;
		while (1) {
			if (t & 1) {
				int x, y;
				cin >> x >> y;
			}
			else {
				if (s[i] == '0' || step) {
					cout << "1 1" << endl;
					break;
				}
				cout << "10 10" << endl;
				step = true;
			}
			t ^= 1;
		}
		st ^= 1;
	}
	cout << 0 << endl;
}

void solve2() {
	int n, k, m;
	cin >> n >> k >> m;
	int q;
	cin >> q;
	vector<int> game(m);
	int gm = 0;
	for (; gm < m;) {
		int x, y;
		cin >> x >> y;
		game[gm]++;
		if (x == 1 && y == 1) gm++;
	}
	string ans;
	for (int i{}; i < m; ++i) {
		if (game[i] <= 2) ans += "0";
		else ans += "1";
	}
	cout << ans << endl;

}

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int t;
	cin >> t;

	if (t == 1) solve1();
	else solve2();
	
	return 0;
}
