#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
using namespace std;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, n) for (int i = 0; (i) < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; (i) >= 0; i--)

const int N = 2010;
vector<int> g[N];
vector<int> u[N];
int dp[N][N];

int curdp[N];
int ndp[N];
int suf[N];

vector<int> p1[N][N];
int p2[N][8][N];

void f(int v, vector<int> order) {
	memcpy(curdp, dp[g[v][order[0]]], sizeof(curdp));
	for (int i = 1; i < order.size(); i++) {
		int k = g[v][order[i]];
		for (auto& i : ndp) i = N;
		rforn(j, N) {
			suf[j] = j;
			if (j < N - 1 && dp[k][suf[j + 1]] < dp[k][j]) suf[j] = suf[j + 1];
		}
		forn(j, N) {
			ndp[j] = N;
			if (curdp[j] < N - 1) {
				ndp[j] = dp[k][suf[curdp[j] + 1]];
				p2[v][i - 1][suf[curdp[j] + 1]] = j;
			}
		}
		memcpy(curdp, ndp, sizeof(ndp));
	}
	forn(i, N) {
		if (curdp[i] < dp[v][i]) {
			dp[v][i] = curdp[i];
			p1[v][i] = order;
		}
	}
}

int resp[N];
void countp(int v, int x) {
	resp[v] = x;
	if (u[v].size()) {
		return;
	}
	int old = x;
	auto order = p1[v][x];
	forn(z, order.size()) {
		int i = order[z];
		countp(g[v][i], x);
		if (z == (int)g[v].size() - 1) break;
		int mn = 1e9;
		int imn = -1;
		int y = dp[g[v][i]][x];
		for (int j = y + 1; j < N; j++) {
			int cur = dp[g[v][order[z + 1]]][j];
			if (cur < mn) {
				mn = cur;
				imn = j;
			}
		}
		if (imn == -1) throw(0);
		x = imn;
	}
}

void r(int v, vector<int> cur = vector<int>()) {
	if (cur.size() == g[v].size()) {
		f(v, cur);
		return;
	}
	vector<bool> used(g[v].size(), false);
	for (auto i : cur) used[i] = true;
	forn(i, g[v].size()) {
		if (!used[i]) {
			cur.push_back(i);
			r(v, cur);
			cur.pop_back();
		}
	}
}

void dfs(int v = 0) {
	if (!g[v].size()) {
		return;
	}
	for (auto u : g[v]) {
		dfs(u);
	}
	r(v);
}

int main() {
	fastio;
	int n;
	cin >> n;
	vector<int> z;
	forn(i, n) {
		int type;
		cin >> type;
		if (type == 1) {
			int k;
			cin >> k;
			g[i].resize(k);
			forn(j, k) {
				cin >> g[i][j];
				g[i][j]--;
			}
		}
		else {
			int m;
			cin >> m;
			u[i].resize(m);
			forn(j, m) {
				cin >> u[i][j];
				z.push_back(u[i][j]);
			}
		}
	}

	for (auto& i : dp) {
		for (auto& j : i) {
			j = N;
		}
	}
	sort(all(z));
	forn(i, n) {
		if (u[i].size()) {
			for (auto j : u[i]) {
				dp[i][lower_bound(all(z), j) - z.begin()] = lower_bound(all(z), j) - z.begin();
			}
		}
	}
	dfs();
	forn(i, N) {
		if (dp[0][i] != N) {
			cout << "Yes\n";
			countp(0, i);
			forn(j, n) {
				if (g[j].size()) {
					for (auto k : p1[j][resp[j]]) {
						cout << g[j][k] + 1 << ' ';
					}
				}
				else {
					cout << z[resp[j]];
				}
				cout << '\n';
			}
			return 0;
		}
	}
	cout << "No\n";
	return 0;
}