#include <bits/stdc++.h>

#define int long long
#define all(v) v.begin(), v.end()

using namespace std;

const int maxn = 1e5 + 10;


int errors[maxn];

map<int, char> perfs[maxn];

vector<int> ind[maxn];

bool used[maxn];


signed main() {
    cin.tie();
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int a;
            char c;
            cin >> a >> c;
            --a;
            perfs[i][a] = c;
            if (s[a] != c) {
                errors[i]++;
            }
            ind[a].push_back(i);
        }
    }
    auto comp = [&](int l, int r) -> bool {
        return tie(errors[l], l) < tie(errors[r], r);
    };
    set<int, decltype(comp)> x(comp);
    for (int i = 0; i < n; ++i) {
        x.insert(i);
    }
    vector<int> res;
    for (int i = 0; i < n; ++i) {
        int v = *x.begin();
        x.erase(x.begin());
        if (errors[v] != 0) {
            cout << -1;
            exit(0);
        }
        res.push_back(v);
        for (auto[j, c]: perfs[v]) {
            used[j] = true;
            for (auto k: ind[j]) {
                if (k != v) {
                    if (perfs[k][j] != s[j]) {
                        x.erase(k);
                        errors[k]--;
                        x.insert(k);
                    }
                    perfs[k].erase(j);
                }
            }
        }
        perfs[v].clear();
    }
    for (int i = 0; i < m; ++i) {
        if (!used[i]) {
            cout << -1;
            exit(0);
        }
    }
    for (auto p: res) {
        cout << p + 1 << " ";
    }
    return 0;
}
