#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y)
{
    return y < x ? (x = y, true) : false;
}
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y)
{
    return y > x ? (x = y, true) : false;
}
void debug_out()
{
    cerr << endl;
}
template<typename T1, typename... T2> void debug_out(T1 A, T2... B)
{
    cerr << ' ' << A;
    debug_out(B...);
}
template<typename T> void mdebug_out(T* a, int n)
{
    for (int i = 0; i < n; ++i)
        cerr << a[i] << ' ';
    cerr << endl;
}
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T> &a)
{
    for (auto& x : a)
        stream << x << ' ';
    return stream;
}
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2>& p)
{
    return stream << p.first << ' ' << p.second;
}

const int logN = 20;
const int maxN = 500005;
const int maxA = 26;
int A, n;
char s[maxN];
int R[maxA][maxN];
bool C[maxA][maxA];
int nxt[maxN];

const int MOD = 1000992299;
struct Hash
{
    int a;
    Hash(): a(0) {}
    Hash(ll _a)
    {
        a = _a % MOD;
        if (a < 0)
            a += MOD;
    }

    Hash& operator += (const Hash& oth)
    {
        if ((a += oth.a) >= MOD)
            a -= MOD;
        return *this;
    }
    Hash& operator -= (const Hash& oth)
    {
        if ((a -= oth.a) < 0)
            a += MOD;
        return *this;
    }

    bool operator == (const Hash& oth)
    {
        return a == oth.a;
    }
};
Hash operator + (const Hash& lhs, const Hash& rhs)
{
    return Hash(lhs) += Hash(rhs);
}
Hash operator - (const Hash& lhs, const Hash& rhs)
{
    return Hash(lhs) -= Hash(rhs);
}
Hash operator * (const Hash& lhs, const Hash& rhs)
{
    return Hash(lhs.a * (ll)rhs.a);
}

Hash base;
Hash pw[maxN];

int up_v[logN][maxN];
Hash up_h[logN][maxN];
Hash H[maxN];
int len[maxN];

struct fnw
{
    int mx[maxN * 2];

    fnw()
    {
        memset(mx, 0, sizeof mx);
    }

    void upd(int i, int val)
    {
        for (++i; i < maxN; i += i & -i)
            chkmax(mx[i], val);
    }

    int gt(int i)
    {
        int res = 0;
        for (++i; i > 0; i -= i & -i)
            chkmax(res, mx[i]);
        return res;
    }

} F[maxA];

bool Less(int i, int j)
{
    int u = i;
    int v = j;
    for (int l = logN - 1; l >= 0; --l)
    {
        if (up_v[l][u] != -1 && up_v[l][v] != -1 && up_h[l][u] == up_h[l][v])
        {
            u = up_v[l][u];
            v = up_v[l][v];
        }
    }
    int x = (u == n ? -1 : s[u]);
    int y = (v == n ? -1 : s[v]);
    return x < y;
}

namespace sgt
{
    const int N = 1 << logN;
    int t[2 * N];

    void init()
    {
        for (int i = 0; i < N; ++i)
            t[i + N] = i;
        for (int i = 2 * N - 1; i > 1; --i)
            t[i >> 1] = t[i];
    }

    void upd(int v)
    {
        if (v < N)
        {
            if (Less(t[v << 1], t[v << 1 | 1]))
                t[v] = t[v << 1];
            else
                t[v] = t[v << 1 | 1];
        }
    }

    void mdf(int i)
    {
        t[i + N] = i;
        i += N;
        for (i >>= 1; i >= 1; i >>= 1)
            upd(i);
    }

    int gt(int l, int r)
    {
        int ans = -1;
        for (l += N, r += N; l <= r; l >>= 1, r >>= 1)
        {
            if (l & 1)
            {
                if (ans == -1 || Less(t[l], ans))
                    ans = t[l];
                l++;
            }
            if (~r & 1)
            {
                if (ans == -1 || Less(t[r], ans))
                    ans = t[r];
                r--;
            }
        }
        return ans;
    }
}



signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    base = Hash(228);
    pw[0] = 1;
    for (int i = 1; i < maxN; ++i)
        pw[i] = pw[i - 1] * base;

    cin >> A >> n;
    for (int x = 0; x < A; ++x)
    {
        string t;
        cin >> t;
        for (int y = 0; y < A; ++y)
            C[x][y] = t[y] - '0';
    }
    cin >> s;
    for (int i = 0; i < n; ++i)
        s[i] -= 'a';
    for (int i = n; i <= n + 3; ++i)
        for (int c = 0; c < A; ++c)
        {
            F[c].upd(n, n);
            R[c][i] = n;
        }

    for (int l = n - 1; l >= 0; --l)
    {
        for (int c = 0; c < A; ++c)
        {
            if (!C[c][s[l]])
            {
                R[c][l] = l;
            }
            else
            {
                int r = R[s[l]][l + 1];
                R[c][l] = F[c].gt(r);
//                for (int i = l + 1; i <= r; ++i)
//                    chkmax(R[c][l], R[c][i]);
//                debug(c, l, R[c][l]);
            }
            F[c].upd(l, R[c][l]);
        }
    }
    
    memset(up_v, 255, sizeof up_v);
//    string w[n + 1];
//    w[n] = "";
    sgt::init();
    for (int i = n - 1; i >= 0; --i)
    {
        /*int min_j = i + 1;
        for (int j = i + 2; j <= R[s[i]][i + 1]; ++j)
        {
            if (Less(j, min_j))
            {
                min_j = j;
            }
        }*/
        int min_j = sgt::gt(i + 1, R[s[i]][i + 1]);
        int j = min_j;
        debug(i, j, i + 1, R[s[i]][i + 1]);
        nxt[i] = j;
        up_v[0][i] = j;
        up_h[0][i] = Hash(s[i] + 1);
        len[i] = len[j] + 1;
        H[i] = Hash(s[i] + 1) * pw[len[j]] + H[j];
//        w[i] = (char)(s[i] + 'a') + w[j];
        for (int l = 1; l < logN && up_v[l - 1][i] != -1; ++l)
        {
            int u = up_v[l - 1][i];
            up_v[l][i] = up_v[l - 1][u];
            up_h[l][i] = up_h[l - 1][i] * pw[1 << (l - 1)] + up_h[l - 1][u];
        }
        sgt::mdf(i);
    }
    for (int i = 0; i < n; i = nxt[i])
        cout << (char)(s[i] + 'a');
    cout << '\n';

    return 0;
}