#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline bool chkmin(T1& x, const T2& y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1& x, const T2& y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;


int n, k, m;



int getScore(int x, int y) {
	return (x - 1) * n + y - 1;
}

namespace encode {
	string s;	
	int uk = 0;
	bool f[33][33];
	int lyambda[33][33];


	void play(int start, bool win) {
		if (start) {
			int mi, mj;
			cin >> mi >> mj;
			for (int i = mi; i <= n; i++) {
				for (int j = mj; j <= n; j++) {
					f[i][j] = 1;
				}
			}
		}
		if (!win) {
			cout << 0 << endl;
			return;
		}
		int opt = 1e9;
		int pi = 1;
		int pj = 1;
		for (int i = n; i >= 1; i--) {
			for (int j = n; j >= 1; j--) {
				if (!f[i][j]) {
					if (opt > lyambda[i][j]) {
						opt =  lyambda[i][j];
						pi = i;
						pj = j;
					}
				}
			}
		}
		cout << pi << ' ' << pj << endl;
		if (pi == 1 && pj == 1) {
			return;
		}
		{
			for (int i = pi; i <= n; i++) {
				for (int j = pj; j <= n; j++) {
					f[i][j] = 1;
				}
			}
		}
		while (true) {
			{
				int mi, mj;
				cin >> mi >> mj;
				{
					for (int i = mi; i <= n; i++) {
						for (int j = mj; j <= n; j++) {
							f[i][j] = 1;
						}
					}
				}
				if (mi == 1 && mj == 1) {
					return;
				}
			}
			int val = (uk < m ? s[uk] - '0': 0) + 2 * (uk + 1 < m ? s[uk + 1] - '0': 0);
			int rem = (getScore(pi, pj) + val) % 4;
			opt = 1e9;
			pi = 1;
			pj = 1;
			for (int i = n; i >= 1; i--) {
				for (int j = n; j >= 1; j--) {
					if (!f[i][j] && getScore(i, j) % 4 == rem) {
						if (opt > lyambda[i][j]) {
							opt =  lyambda[i][j];
							pi = i;
							pj = j;
						}
					}
				}
			}
			cout << pi << ' ' << pj << endl;
			if (pi == 1 && pj == 1) {
				return;
			}
			uk += 2;
			{
				for (int i = pi; i <= n; i++) {
					for (int j = pj; j <= n; j++) {
						f[i][j] = 1;
					}
				}
			}
		}
	}

	void encoder() {
		cin >> n >> k >> m;
		cin >> s;
		int d = 0;
		uk = 0;
		for (int i =1; i <= n; i++) {
			for (int j = 1; j <= n; j++) {
				lyambda[i][j] = (n - i) * (n - j) * max(n - i, n - j);
			}
		}
		while (uk < m) {
			memset(f, 0, sizeof(f));
			play(d & 1, true);
			d++;
		}
		memset(f, 0, sizeof(f));
		play(d, false);
	}

};


namespace decode {

void decoder() {
	cin >> n >> k >> m;
	int cnt;
	cin >> cnt;
	vector<vector<pair<int, int> > > moves;
	for (int it = 0; it < cnt; it++) {
		vector<pair<int, int> > cur;
		int a, b;
		int id = it & 1;
		while (cin >> a >> b) {
			if (a == 1 && b == 1) {
				break;
			}
			if (id == 0) {
				cur.pb(mp(a, b));
			}
			id ^= 1;
			
		}
		moves.pb(cur);
	}
	string ans;
	for (auto x: moves) {
		for (int f = 1; f < sz(x); f++) {
			int k = getScore(x[f - 1].first, x[f - 1].second);
			int k1 = getScore(x[f].first, x[f].second);
			int t =	((k1 - k) % 4 + 4) % 4;
			ans += char('0' + (t & 1));
			ans += char('0' + (t / 2));
		}
	}
	ans.resize(m);
	cout << ans << endl;
}

};

int main() {
	ios_base::sync_with_stdio(false);
	//freopen("/tmp/game.in", "r", stdin); 
	//freopen("/tmp/game.out", "w", stdout);
	//freopen("input.in", "r", stdin);
	int t;
	cin >> t;
	if (t == 1) {
		encode::encoder();
	} else {
		decode::decoder();
	}
	return 0;
}
