#include <bits/stdc++.h>

using namespace std;


bool cmp(vector<char> &a, vector<char> &b)
{
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());

    int j = 0;
    while (j < (int)a.size() && j < (int)b.size())
    {
        if (a[j] < b[j])
        {
            reverse(a.begin(), a.end());
            reverse(b.begin(), b.end());
            return true;
        }
        else if (b[j] < a[j])
        {
            reverse(a.begin(), a.end());
            reverse(b.begin(), b.end());
            return false;
        }
        j++;
    }
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    return (int)a.size() < (int)b.size();
}


vector<char> find_best(vector<char> &a, vector<vector<int>> &tb)
{
    vector<char> nw = a;
    reverse(nw.begin(), nw.end());
    vector<char> res = a;
    for (int j = 2; j <= (int)nw.size() && tb[nw[0] - 'a'][nw[j - 1] - 'a'] == 1; j++)
    {
        vector<char> loc = {nw[0]};
        for (int k = j; k < (int)nw.size(); k++)
            loc.push_back(nw[k]);
        reverse(loc.begin(), loc.end());
        if (cmp(loc, res))
            res = loc;
    }
    return res;
}


int main()
{
    int k, n; cin >> k >> n;
    vector<vector<int>> t(k, vector<int> (k));
    for (int i = 0; i < k; i++)
        for (int j = 0; j < k; j++)
        {
            char c; cin >> c;
            t[i][j] = c - '0';
        }
    vector<char> res(n);

    for (int i = 0; i < n; i++)
        cin >> res[i];

    vector<vector<char>> dp(n + 1);
    dp.back() = {};
    for (int i = n - 1; i > -1; i--)
    {
        vector<char> stp;
        for (int j = n - 1; j >= i; j--)
            stp.push_back(res[j]);
        stp = find_best(stp, t);

        vector<char> lc = dp[i + 1];
        lc.push_back(res[i]);
        char c = res[i];
        int j = i + 1;
        lc = find_best(lc, t);
        while (j < n && t[c - 'a'][res[j] - 'a'] == 1)
        {
            j++;
            vector<char> nw = dp[j];
            nw.push_back(res[i]);
            auto best = find_best(nw, t);
            if (cmp(best, lc))
                lc = best;
        }
        if (cmp(stp, lc))
            lc = stp;
        dp[i] = lc;
    }
    reverse(dp[0].begin(), dp[0].end());
    for (int i = 0; i < (int)dp[0].size(); i++)
        cout << dp[0][i];
    cout << endl;
    return 0;
}

/*
3 7
010
001
100
abacaba
 */