#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e5;
int cnt[maxn];
vector<int> miss[maxn];
vector<int> have[maxn];
bool covered[maxn];

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    deque<int> ok;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int p;
            char c;
            cin >> p >> c;
            --p;
            have[i].push_back(p);
            covered[p] = true;
            if (s[p] != c) {
                miss[p].push_back(i);
                ++cnt[i];
            }
        }
        if (cnt[i] == 0) ok.push_back(i);
    }
    for (int i = 0; i < m; ++i) {
        if (!covered[i]) {
            cout << -1 << "\n";
            return 0;
        }
        covered[i] = false;
    }
    vector<int> ans;
    while (!ok.empty()) {
        int curr;
        curr = ok.front();
        ok.pop_front();
        ans.push_back(curr);
        for (auto elem : have[curr]) {
            if (!covered[elem]) {
                covered[elem] = true;
                for (auto u : miss[elem]) {
                    --cnt[u];
                    if (cnt[u] == 0) {
                        ok.push_back(u);
                    }
                }
            }
        }
    }
    if (ans.size() == n) {
        for (auto elem : ans) cout << elem + 1 << " ";
        return 0;
    }
    cout << -1;
    return 0;
}

/*
1 1
a
1 1 a

3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f
 */