#include <bits/stdc++.h>
using namespace std;
//#define int long long
typedef vector<int> vi;
typedef vector<vi> v2i;

void dfs(int v, v2i& g, vi& used, vi& order) {
    used[v] = 1;
    for (int to : g[v])
        if (used[to] == 0)
            dfs(to, g, used, order);
        else if (used[to] == 1) {
            cout << "-1\n";
            exit(0);
        }
    used[v] = 2;
    order.push_back(v);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    for (auto& e : s)
        e -= 'a';
    v2i data(m, vi(n, -1));
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int p;
            char c;
            cin >> p >> c;
            data[p - 1][i] = c - 'a';
        }
    }
    for (int c = 0; c < m; ++c) {
        bool bad = true;
        for (int i = 0; i < n; ++i)
            if (data[c][i] == s[c])
                bad = false;
        if (bad) {
            cout << "-1\n";
            return 0;
        }
    }
    v2i g(n);
    for (int c = 0; c < m; ++c) {
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < n; ++j)
                if (data[c][i] == s[c] && data[c][j] != s[c] && data[c][j] != -1)
                    g[i].push_back(j);
    }
    vi used(n), order;
    for (int v = 0; v < n; ++v)
        if (!used[v])
            dfs(v, g, used, order);
    reverse(order.begin(), order.end());
    for (auto e : order)
        cout << e + 1 << ' ';
    cout << '\n';
}
