#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)5e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

int dfs(int v, vvi& a, vvi& s, vi& c, int l) {
	if (a[v].empty()) {
		if (s[v].back() < l)
			return -1;
		else
			return c[v] = *lower_bound(s[v].begin(), s[v].end(), l);
	}
	sort(a[v].begin(), a[v].end());
	do {
		int l1 = l;
		bool flag = 1;
		for (int u : a[v]) {
			int r = dfs(u, a, s, c, l1);
			if (r == -1) {
				flag = 0;
				break;
			}
			l1 = r;
		}
		if (flag)
			return l1;
	} while (next_permutation(a[v].begin(), a[v].end()));
	return -1;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n;
	cin >> n;
	vvi a(n);
	vvi s(n);
	vi c(n);
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int x;
				cin >> x;
				--x;
				a[i].pb(x);
			}
		}
		else {
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int x;
				cin >> x;
				s[i].pb(x);
			}
			sort(s[i].begin(), s[i].end());
		}
	}
	if (dfs(0, a, s, c, 1) == -1) {
		cout << "No";
		return 0;
	}
	cout << "Yes\n";
	for (int i = 0; i < n; ++i) {
		if (!a[i].empty()) {
			for (int x : a[i])
				cout << x + 1 << ' ';
			cout << endl;
		}
		else {
			cout << c[i] << endl;
		}
	}

	return 0;
}