﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

string INF = "";

int main() {
	int k, n, x;
	cin >> k >> n;
	vector<vector<char>> g(k, vector<char>(k));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> g[i][j];
			g[i][j] -= '0';
		}
	}
	string s;
	cin >> s;
	for (char& i : s) {
		i -= 'a';
	}

	vector<int> dp(n, n);
	dp[0] = -1;
	for (int i = 1; i < n; ++i) {
		x = n;
		for (int j = i - 1; j >= 0 && x > -1; --j) {
			if (g[s[j]][s[i]] && x >= j) {
				dp[i] = j;
				break;
			}
			x = min(x, dp[j]);
		}
		if (dp[i] == n) {
			dp[i] = -1;
		}
	}

	for (int i = 0; i <= n; ++i) {
		INF += 'z';
	}

	vector<vector<string>> ans(n, vector<string>(n + 1));
	ans[0][1] = s[0] + 'a';
	string y = INF; //
	for (int i = 1; i < n; ++i) {
		for (int j = 1; j <= i + 1; ++j) {
			y = INF;
			if (ans[i - 1][j - 1] != "") {
				y = ans[i - 1][j - 1] + char(s[i] + 'a');
			}
			if (dp[i] != -1 && ans[dp[i]][j] != "") {
				y = min(y, ans[dp[i]][j]);
			}
			if (y.size() != n + 1) {
				ans[i][j] = y;
			}
		}
	}

	y = INF;
	for (int i = 1; i <= n; ++i) {
		if (ans[n - 1][i] != "") {
			y = min(y, ans[n - 1][i]);
		}
	}
	cout << y;

	return 0;
}

string f(int i, const string& cur, int n, string& s, vector<int>& dp) {
	if (i == -1) {
		return cur;
	}

	if (dp[i] == -1) {
		return f(i - 1, char(s[i] + 'a') + cur, n, s, dp);
	}
	return min(f(i - 1, char(s[i] + 'a') + cur, n, s, dp), f(dp[i], cur, n, s, dp));
}
