#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#define int long long

using namespace std;

signed main() {
	int n, m; cin >> n >> m;
	vector <vector <int>> a(m);
	vector <vector <int>> b(n);
	vector <int> cnt(n);

	string s; cin >> s;

	for (int i = 0; i < n; i++) {
		int k; cin >> k;
		for (int j = 0; j < k; j++) {
			int pos; char c; cin >> pos >> c; pos--;
			if (c != s[pos]) {
				a[pos].push_back(i);
				cnt[i]++;
			}
			b[i].push_back(pos);
		}
	}

	vector <int> p(n, -1);
	vector <char> used(n, false);
	vector <char> fill(m, false);
	set <pair <int, int>> q;

	for (int i = 0; i < n; i++) {
		q.insert({ cnt[i], i });
	}

	for (int i = 0; i < n; i++) {
		auto pr = *q.begin(); q.erase(q.begin());
		int val = pr.first, ind = pr.second;
		if (val > 0) {
			cout << -1;
			return 0;
		}

		p[i] = ind;
		used[ind] = true;
		for (auto pos : b[ind]) {
			if (fill[pos])
				continue;
			fill[pos] = true;
			for (auto ind2 : a[pos]) {
				if (used[ind2])
					continue;
				q.erase({ cnt[ind2], ind2 });
				cnt[ind2]--;
				q.insert({ cnt[ind2], ind2 });
			}
		}
	}

	for (int i = 0; i < m; i++) {
		if (!fill[i]) {
			cout << -1;
			return 0;
		}
	}

	for (auto x : p) {
		cout << x + 1 << ' ';
	}

	return 0;
}

/*
1 1
a
1 1 a

3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f
*/