#include <bits/stdc++.h>
#define ll long long
#define pb push_back
#define f first
#define s second
#define ld long double

using namespace std;

vector<vector<int>> good;
vector<vector<int>> bad;
vector<int> ptr;
vector<vector<int>> problem;
vector<bool> used;
vector<int> ans;

bool dfs(int i) {
    if (good[i].size() < 1) {
        cout << "-1";
        exit(0);
    }
    int j = good[i][0];
    if (used[j]) {
        return 1;
    }
    used[j] = 1;
    ans.pb(j);
    for ( ; ptr[j] < problem[j].size(); ptr[j]++) {
        if (!dfs(problem[j][ptr[i]])) {
            cout << "-1";
            exit(0);
        }
    }
    return 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n ,m;
    cin >> n >> m;
    string s;
    cin >> s;
    good.resize(m);
    bad.resize(m);
    ptr.resize(n);
    problem.resize(n);
    used.resize(n);
   // vector<map<int, char>> a(n);
    for (int i = 0; i<n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j<k; j++) {
            int pos;
            char c;
            cin >> pos >> c;
            pos--;
            //a[i][pos] = c;
            if (s[pos] == c) {
                good[pos].pb(i);
            } else {
                bad[pos].pb(i);
                problem[i].pb(pos);
            }
        }
    }
    for (int i = 0; i<m; i++) {
        dfs(i);
    }
    for (int i = 0; i<n; i++) {
        if (!used[i]) {
            ans.pb(i);
        }
    }
    for (int i : ans) {
        cout << i+1 << " ";
    }



    return 0;
}
/*
1 1
a
1 1 a

3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f

2 2
aa
2 1 a 2 b
2 1 b 4 a

*/
