#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#define _CRT_SECURE_NO_WARNINGS
#define endl '\n'
using namespace std;
using ll = long long;


bool operator <(set<int> a, set<int> b)
{
	return a.size() < b.size();
}

const int N = 2e5;
vector<pair<int, char>> v[N];
bool used[N];
vector<int> ans;

vector<int> posbad[N];

set<int> bad[N];
vector<int> good[N];

set<pair<int, int>> ss;


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif

	int n, m;
	string s;
	cin >> n >> m;
	cin >> s;
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		v[i].resize(k);
		for (int j = 0; j < k; j++)
		{
			int p;
			char c;
			cin >> p >> c;
			p--;
			v[i][j] = { p, c };

			if (p >= s.size() || s[p] != c)
			{
				posbad[v[i][j].first].push_back(i);
				bad[i].insert(p);
			}
			else
				good[i].push_back(p);
		}
		ss.insert({ bad[i].size(), i });
	}
	while (!ss.empty())
	{
		auto b = ss.begin();
		if ((*b).first != 0)
		{
			cout << -1;
			return 0;
		}
		int i = (*b).second;
		ss.erase(b);
		ans.push_back(i);
		for (auto p : good[i])
		{
			used[p] = true;
			for (auto j : posbad[p])
			{
				ss.erase({ bad[j].size(), j });
				bad[j].erase(p);
				ss.insert({ bad[j].size(), j });
			}
			posbad[p].resize(0);
		}
	}
	for (int i = 0; i < s.size(); i++)
	{
		if (!used[i])
		{
			cout << -1;
			return 0;
		}
	}
	for (auto x : ans)cout << x + 1 << " ";
}