#include <iostream>
#include <vector>
#include <set>

std::vector<char> candidates;
bool extend(char ch, bool** allow) {
    bool ok = false;
    for(int32_t j = candidates.size() - 1; j >= 0; j--)
        if( allow[candidates[j] - 'a'][ch - 'a']) {
            ok = true;
            for(int32_t p = candidates.size() - 1; p > j; p--)
                candidates.pop_back();
            break;
        }
    if(!ok)
        return false;
    candidates.push_back(ch);
    return true;
}

int main() {
    int32_t k, n;
    std::cin >> k >> n;

    bool** allow = new bool*[k];
    for(int32_t i = 0; i < k; i++) {
        allow[i] = new bool[k];
        std::string str;
        std::cin >> str;

        for(int32_t j = 0; j < k; j++) {
            allow[i][j] = str[j] == '1';
        }
    }

    std::string str;
    std::cin >> str;

    std::string* dp = new std::string[n + 1];
    for (int32_t i = 1; i <= n; i++) {
        dp[i] = str.substr(n - i);
        candidates = {str[n - i]};
        for (int32_t j = i - 1; j >= 0; j--) {
            if(j != i - 1) {
                if(!extend(str[n - j - 1], allow))
                    break;
            }
            dp[i] = std::min(dp[i], str[n - i] + dp[j]);
        }
    }

    std::string answer = dp[n];

    std::cout << answer;
    return 0;
}