#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

vector<vector<int>> d, a, s;
int n, m = 0;

void DFS(int vertex){
    for (int q: d[vertex]){
        DFS(q);
    }
    if (d[vertex].empty()){
        for (int q = 0; q < m; q++){
            auto w = lower_bound(a[vertex].begin(), a[vertex].end(), q);
            if (w == a[vertex].end()){
                s[vertex][q] = INF;
            }else{
                s[vertex][q] = *w;
            }
        }
        return;
    }
    vector<int> perm(d[vertex].size());
    iota(perm.begin(), perm.end(), 0);
    while (true){
        for (int q = 0; q < m; q++){
            int q1 = q;
            for (int q2: perm){
                if (q1 >= m){
                    q1 = INF;
                    break;
                }
                q1 = s[d[vertex][q2]][q1]+1;
            }
            s[vertex][q] = min(s[vertex][q], q1-1);
        }
        if (!next_permutation(perm.begin(), perm.end())){
            break;
        }
    }
}

vector<vector<int>> ans;

void DFS_ans(int vertex, int num){
    if (d[vertex].empty()){
        ans[vertex] = {*lower_bound(a[vertex].begin(), a[vertex].end(), num)};
        return;
    }
    vector<int> perm(d[vertex].size());
    iota(perm.begin(), perm.end(), 0);
    while (true){
        int q1 = num;
        for (int q2: perm){
            if (q1 >= m){
                q1 = INF;
                break;
            }
            q1 = s[d[vertex][q2]][q1]+1;
        }
        if (s[vertex][num] == q1-1){
            break;
        }
        next_permutation(perm.begin(), perm.end());
    }
    int q1 = num;
    for (int q2: perm){
        DFS_ans(d[vertex][q2], q1);
        q1 = s[d[vertex][q2]][q1]+1;
    }
    for (int q: perm){
        ans[vertex].push_back(d[vertex][q]);
    }
}

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    d.assign(n, {}), a.assign(n, {});
    for (int q = 0; q < n; q++){
        int type, m1;
        cin >> type >> m1;
        if (type == 1){
            d[q].assign(m1, {});
            for (int q1 = 0; q1 < m1; q1++){
                cin >> d[q][q1];
                d[q][q1]--;
            }
        }else{
            a[q].assign(m1, {});
            for (int q1 = 0; q1 < m1; q1++){
                cin >> a[q][q1];
            }
            m += m1;
        }
    }
    s.assign(n, vector<int>(m, INF)), ans.assign(n, {});
    set<int> all;
    for (auto &q: a){
        for (int q1: q){
            all.insert(q1);
        }
    }
    vector<int> for_ans;
    for (int q: all){
        for_ans.push_back(q);
    }
    map<int, int> renum;
    for (int q: all){
        renum[q] = renum.size();
    }
    for (auto &q: a){
        for (int &q1: q){
            q1 = renum[q1];
        }
        sort(q.begin(), q.end());
    }
    DFS(0);
    if (s[0][0] >= m){
        cout << "No" << endl;
    }else{
        cout << "Yes" << endl;
        DFS_ans(0, 0);
        for (int q = 0; q < n; q++){
            if (d[q].empty()){
                cout << for_ans[ans[q][0]] << endl;
            }else{
                for (int q1: ans[q]){
                    cout << q1+1 << ' ';
                }
                cout << endl;
            }
        }
    }
    return 0;
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92

3
1 2 2 3
2 1 1
2 1 2

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3

*/
