#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array


typedef long long ll;
using namespace std;

const int maxN = 1e5 + 5;
const int INFi = 2e9;
vector<int> g[maxN];
bool emp[maxN];
vector<int> here[maxN];
vector<int> dp[maxN];
vector<vector<int>> orddp[maxN];
int sp[maxN];
int m;

void dfs(int v) {
    dp[v].resize(m + 1, INFi);
    orddp[v].resize(m + 1);
    if (emp[v]) {
        if (here[v].empty()) {
            range(i, m + 1) dp[v][i] = i;
        }
        for (auto &i : here[v]) {
            dp[v][i] = i + 1;
        }
        for (int i = m - 1; i >= 0; --i) dp[v][i] = min(dp[v][i], dp[v][i + 1]);
        return;
    }
    for(auto &u : g[v]) {
        dfs(u);
    }
    vector<int> ord = g[v];
    int al = ord.size();
    al = 1 << al;
    al--;
    vector<vector<int>> mem(m + 1, vector<int>(al + 1, -1));
    vector<vector<int>> nxt(m + 1, vector<int>(al + 1, -1));
    function<int(int, int)> rec = [&] (int cur, int mask) {
        if (cur == INFi) return INFi;
        if (mask == al) return cur;
        if (mem[cur][mask] != -1) return mem[cur][mask];
        mem[cur][mask] = INFi;
        range(j, (int)ord.size()) {
            if (mask & (1 << j)) continue;
            int nx = dp[ord[j]][cur];
            int t = rec(nx, mask | (1 << j));
            if (t < mem[cur][mask]) {
                mem[cur][mask] = t;
                nxt[cur][mask] = j;
            }
        }
        return mem[cur][mask];
    };
    for(int s = 0; s <= m; ++s) {
        dp[v][s] = rec(s, 0);
        if (dp[v][s] == INFi) break;
        int cur = s;
        int mask = 0;
        range(_, (int)ord.size()) {
            orddp[v][s].push_back(ord[nxt[cur][mask]]);
            int mask2 = mask | (1 << nxt[cur][mask]);
            cur = dp[ord[nxt[cur][mask]]][cur];
            mask = mask2;
        }
    }
}

void dfs2(int v) {
    int cur = sp[v];
    for(auto &u : orddp[v][sp[v]]) {
        sp[u] = cur;
        dfs2(u);
        cur = dp[u][cur];
    }
}

void solve() {
    int n; cin >> n;
    vector<int> xx;
    for(int i = 1; i <= n; ++i) {
        int t; cin >> t;
        if (t == 1) {
            int k; cin >> k;
            g[i].resize(k);
            range(j, k) cin >> g[i][j];
        } else {
            int mm; cin >> mm;
            emp[i] = true;
            here[i].resize(mm);
            range(j, mm) cin >> here[i][j];
            for(auto &x : here[i]) xx.push_back(x);
        }
    }
    sort(all(xx));
    xx.resize(unique(all(xx)) - xx.begin());
    for(int i = 1; i <= n; ++i) {
        for(auto &x : here[i]) {
            x = lower_bound(all(xx), x) - xx.begin();
        }
    }
    m = xx.size() + 2;
    dfs(1);
    if (dp[1][0] == INFi) {
        cout << "No\n";
        return;
    }
    dfs2(1);
    cout << "Yes\n";
    for(int i = 1; i <= n; ++i) {
        if (emp[i]) {
            if (!here[i].empty()) {
                cout << xx[dp[i][sp[i]] - 1];
            }
        } else {
            for(auto &u : orddp[i][sp[i]]) {
                cout << u << ' ';
            }
        }
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    range(_, tests) {
        solve();
    }
    return 0;
}