#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

ll k, n;
vector<string> a;
string s;

void solve2() {
    if(a[1][1] == '1') {
        string nw = "";
        ll i = 0;
        while(i < s.size()) {
            if(s[i] == 'a') {
                i++;
                continue;
            }

            ll j = i + 1;
            while(j < s.size() && s[j] == 'b') {
                j++;
            }

            nw += "b";
            i = j;
        }

        s = nw;
    }

    if(a[0][1] == '1') {
        string nw = "";
        ll i = 0;
        if(s[0] == 'b') {
            while(i < s.size() && s[i] == 'b') {
                nw += s[i];
            }
        }

        for(; i < s.size(); i++) {
            if(s[i] == 'a') nw += 'a';
        }

        s = nw;
    }

    if(a[1][0] == '1' && s[s.size() - 1] == 'a') {
        bool has_1 = false;
        for(auto el : s) {
            if(el == 'b') {
                has_1 = true;
            }
        }

        if(has_1) {
            string nw = "";
            ll i = ll(s.size()) - 1;
            while(i >= 0 && s[i] == 'a') {
                i--;
            }

            for(ll j = 0; j <= i; j++) {
                nw += s[j];
            }

            s = nw;
        }
    }

    if(a[0][0] == '1' && s[s.size() - 1] == 'a') {
        string nw = "";
        ll i = ll(s.size()) - 1;
        while(i >= 0 && s[i] == 'a') {
            i--;
        }

        for(ll j = 0; j <= i + 1; j++) {
            nw += s[j];
        }

        s = nw;
    }

    cout << s << "\n";
    return;
}

void solve() {
    cin >> k >> n;
    a.resize(k);
    for(ll i = 0; i < k; i++) {
        cin >> a[i];
    }
    cin >> s;

    if(k == 2) {
        solve2();
        return;
    }

    vector<ll> free[k]; /// free positions
    ll lst_obs = 0; /// last obstacle
    vector<ll> nearest(n, -1);

    string ans = "";
    ans += s[0];
    free[s[0] - 'a'].pb(0);

    for(ll i = 1; i < n; i++) {
        ll prev = -1;
        for(ll j = 0; j < k; j++) {
            if(free[j].size() == 0) continue;
            if(a[j][s[i] - 'a'] == '0') continue; /// watch out

            prev = max(prev, free[j].back());
        }

        if(prev >= lst_obs) {
            nearest[i] = prev;
            for(ll j = 0; j < k; j++) {
                while(free[j].size() > 0 && free[j].back() > prev) {
                    free[j].pop_back();
                }
            }
        } else {
            lst_obs = i;
        }

        free[s[i] - 'a'].pb(i);
    }

    /*for(ll i = 0; i < n; i++) {
        cout << nearest[i] << " ";
    }
    cout << endl;*/

    ll old[n], cur[n]; /// last pos of taken
    for(ll i = 0; i < n; i++) {
        cur[i] = 0;
    }
    cur[0] = 1;
    for(ll i = 1; i < n; i++) {
        for(ll j = 0; j < n; j++) {
            old[j] = cur[j];
            cur[j] = 0;
        }

        ll cur_let = 27;

        for(ll j = 0; j < n; j++) {
            if(old[j] == 0) continue;

            ll obs_pos = -1;
            for(ll c = j + 1; c < n; c++) {
                if(nearest[c] == -1 || nearest[c] < j) {
                    obs_pos = c;
                    break;
                }
            }
            if(obs_pos == -1) {
                cout << ans << "\n";
                return;
            }

            for(ll c = obs_pos - 1; c > j; c--) {
                if(cur_let > s[c] - 'a') {
                    cur_let = s[c] - 'a';
                }
            }
            if(cur_let > s[obs_pos] - 'a') {
                cur_let = s[obs_pos] - 'a';
            }
        }

        ans += char('a' + cur_let);
        for(ll j = 0; j < n; j++) {
            if(old[j] == 0) continue;

            ll obs_pos = -1;
            for(ll c = j + 1; c < n; c++) {
                if(nearest[c] == -1 || nearest[c] < j) {
                    obs_pos = c;
                    break;
                }
            }
            if(obs_pos == -1) {
                cout << ans << "\n";
                return;
            }

            for(ll c = obs_pos - 1; c > j; c--) {
                if(cur_let == s[c] - 'a') {
                    cur[c] = 1;
                }
            }
            if(s[obs_pos] - 'a' == cur_let) {
                cur[obs_pos] = 1;
            }
        }

        /*cout << i << " " << ans << ": ";
        for(ll i = 0; i < n; i++) {
            cout << cur[i] << " ";
        }
        cout << endl;*/
    }

    cout << ans << "\n";
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
