#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int MAXN = 25;

vector<int> g[MAXN];

bool comp(const pair<int, vector<int>> &a, const pair<int, vector<int>> &b) {
    return a.second[0] < b.second[0];
}

vector<int> dfs(int v, vector<int> &rofl, vector<vector<int>> &res) {
    if (g[v].empty()) {
        return {rofl[v]};
    }
    vector<pair<int, vector<int>>> lol;
    for (int u : g[v]) {
        lol.emplace_back(u, dfs(u, rofl, res));
    }
    sort(all(lol), comp);
    vector<int> now;
    for (auto &el : lol) {
        res[v].push_back(el.first);
        for (int heh : el.second) {
            now.push_back(heh);
        }
    }
    return now;
}

bool check(vector<int> &a) {
    for (int i = 1; i < (int) a.size(); i++) {
        if (a[i] < a[i - 1]) {
            return false;
        }
    }
    return true;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<int, int>> dd;
    int sm_d = 0;
    for (int i = 1; i <= n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; j++) {
                int el;
                cin >> el;
                g[i].push_back(el);
            }
        } else {
            sm_d++;
            int k;
            cin >> k;
            for (int j = 0; j < k; j++) {
                int el;
                cin >> el;
                dd.emplace_back(el, i);
            }
        }
    }
    int m = dd.size();
    for (int mask = 0; mask < (1 << m); mask++) {
        vector<int> rofl(n + 1);
        int cnt = 0;
        bool flag = true;
        for (int b = 0; b < m; b++) {
            if (mask & (1 << b)) {
                cnt++;
                if (rofl[dd[b].second] > 0) {
                    flag = false;
                }
                rofl[dd[b].second] = dd[b].first;
            }
        }
        if (flag && cnt == sm_d) {
            vector<vector<int>> res(n + 1);
            vector<int> fin = dfs(1, rofl, res);
            if (check(fin)) {
                cout << "Yes\n";
                for (int i = 1; i <= n; i++) {
                    if (rofl[i] > 0) {
                        cout << rofl[i] << '\n';
                    } else {
                        for (int el : res[i]) {
                            cout << el << ' ';
                        }
                        cout << '\n';
                    }
                }
                return 0;
            }
        }
    }
    cout << "No\n";
    return 0;
}
