#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()

void fill(int x, int y, vector<int> &edge){
    int n = edge.size();
    for (int i = n - 1; i >= x; i--)
        edge[i] = min(edge[i], y);
}

void step(int digit, vector<int> &edge, int &game, int &pos, int &in){
    int n = edge.size();
    bool END = true;
    for (int i = n - 1; i >= 0; i--){
        if (edge[i] == 0 || (edge[i] == 1 && digit == 1))
            continue;
        int j = edge[i] - 1;
        if (j % 2 != digit)
            j--;
        if (i == 0 && j == 0)
            continue;
        cout << i + 1 << " " << j + 1 << endl;
        END = false; pos++; in = 1;
        fill(i, j, edge);
        break;
    }

    if (END){
        cout << 1 << " " << 1 << endl;
        in = 0;
    }

    if (!END){
        int x, y;
        cin >> x >> y;
        x--; y--;
        fill(x, y, edge);
        if (x == 0 && y == 0){
            END = true;
            in = 0;
        }
    }

    if (END){
        edge.assign(n, n);
        game++;
        if (game % 2 != 0){
            int x, y;
            cin >> x >> y;
            x--; y--;
            fill(x, y, edge);
        }
    }
}

void MODE1(int n, int k, int m){
    string s;
    cin >> s;
    int pos = 0;
    vector<int> edge(n, n);
    int game = 0, in = 0;
    while (pos < m){
        //cout << "for pos " << pos << endl;
        step(s[pos] - '0', edge, game, pos, in);
    }
    if (in)
        cout << 1 << " " << 1 << endl;
    cout << 0 << endl;
}

void MODE2(int n, int k, int m){
    int all;
    cin >> all;
    int x, y;
    string s;
    for (int game = 0; game < all; game++){
        int cnt = 0;
        cin >> x >> y;
        while (x != 1 || y != 1){
            x--; y--;
            if ((cnt + game) % 2 == 0)
                s += (y % 2) + '0';
            cnt++;
            cin >> x >> y;
        }
    }
    cout << s << endl;
}

signed main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int mode, n, k, m;
    cin >> mode >> n >> k >> m;

    if (mode == 1)
        MODE1(n, k, m);
    else
        MODE2(n, k, m);
    return 0;
}