#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

const int M = 2001;
bool all[30][30];
vector<int>e[M];
vector<int>good[M];
bool used[M];
string ans[M];
string s;
bool kon[M];
//bool dp[M][M];
int t[4 * M];
void build(int v, int l, int r,vector<int>&mx) {
	if (l == r) {
		t[v] = mx[l];
		return;
	}
	int m = (l + r) / 2;
	build(2 * v, l, m, mx);
	build(2 * v + 1, m + 1, r, mx);
	t[v] = min(t[2 * v], t[2 * v + 1]);
}
int get(int v, int l, int r, int l1, int r1) {
	if (l >= l1 && r <= r1)
		return t[v];
	if (l > r1 || l1 > r)
		return 5 * M;
	int m = (l + r) / 2;
	return min(get(2 * v, l, m, l1, r1), get(2 * v + 1, m + 1, r, l1, r1));
}
void dfs(int v) {
	used[v] = 1;
	if (kon[v]) {
		string x;
		x += s[v];
		ans[v] = x;
		return;
	}
	string f="A";
	for (auto c : good[v]) {
		if (used[c] == 0)
			dfs(c);
		string x;
		x += s[v];
		x += ans[c];
		if (f == "A")
			f = x;
		else
		f = min(f, x);
	}
	ans[v] = f;
	return;
}
bool cnt(int l, int r,vector<int>& mx) {
	for (int i = r; i > l; i--) {
		int now = get(1, 0, mx.size() - 1, mx[i]+1, i);
		if (now < mx[i]||mx[i]<l)
			return false;
	}
	return true;
}

void solve() {
	int n, k;
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		for (int y = 0; y < k; y++) {
			char c;
			cin >> c;
			if (c == '1')
				all[i][y] = 1;
		}
	}
	
	cin >> s;
	string best = s;
	vector<int>last(26, -1);
	vector<int>mx(n,-1);
	for (int i = 0; i < n; i++) {
		int ans = -1;
		for (int j = 0; j < 26; j++) {
			if (last[j] == -1)
				continue;
			if (all[j][s[i] - 'a'] == 1)
				ans = max(ans, last[j]);
		}
		mx[i] = ans;
		last[s[i] - 'a'] = i;
	}
	build(1, 0, n - 1, mx);
	vector<int>cn;
	for (int i = 0; i < n; i++) {
		int mn = 100000;
		for (int y = i - 1; y >= 0; y--) {
			if (y == i - 1) {
				e[y].push_back(i);
			}
			else {
				if(cnt(y,i-1,mx))
					e[y].push_back(i);
			}
		}
	}
	kon[n - 1] = 1;
	int mn = 100000;
	for (int i = n - 2; i >= 0; i--) {
		if (cnt(i, n - 1, mx))
			kon[i] = 1;
	}
	for (int i = 0; i < n; i++) {
		char x = '#';
		for (auto c : e[i]) {
			if (x == '#' || s[c] < x)
				x = s[c];
		}
		for (auto c : e[i]) {
			if (x == s[c]) {
				good[i].push_back(c);
			}
		}
	}
	dfs(0);
	cout << ans[0];
}


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	int t;
	//cin >> t;
	t = 1;
	while (t) {
		t--;
		solve();
	}
}
//vector<pair<int, char>> all[100001];
//vector<int>bad[100001];
//
//int n, m;
//string s;
//cin >> n >> m >> s;
//for (int i = 0; i < n; i++) {
//	int k;
//	cin >> k;
//	int a;
//	char c;
//	cin >> a >> c;
//	a--;
//	all[i].push_back({ a,c });
//}
//for (int i = 0; i < n; i++) {
//	if (all[i].size() == 0 || all[i][0].first != 0)
//		continue;
//	if (all[i][0].second != s[0])
//		bad[i].push_back(i);
//}
//bool ok = 0;
//for (int i = 0; i < n; i++) {
//	if (bad[i].size())
//		continue;
//	ok = 1;
//}