#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>
#include <math.h>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>
#define pii pair<int, int>

const int N = 1e5 + 5;
const ll INF = 1e18 + 5;

vi mi(N, -INF), ma(N, INF);
vi a[N];
void dfs(int v) {
	if (!a[v].size()) return;
	if (a[v].size() == 1) {
		mi[v] = mi[a[v][0]];
		ma[v] = ma[a[v][0]];
	}
	else {
		auto i = a[v][0], j = a[v][1];
		dfs(i); dfs(j);
		bool ok = 0;
		if (ma[i] < mi[j]) {
			ok = 1;
			mi[v] = max(mi[v], mi[i]);
			ma[v] = min(ma[v], ma[j]);
		}
		if (ma[j] < mi[i]) {
			ok = 1;
			mi[v] = max(mi[v], mi[j]);
			ma[v] = min(ma[v], ma[i]);
		}
		if (!ok) {
			cout << "No\n";
			exit(0);
		}
	}
}
signed main() {
	int n; cin >> n;
	for (int i = 0; i < n; ++i) {
		int x; cin >> x;
		if (x == 2) {
			int k; cin >> k;
			vi res;
			for (int j = 0; j < k; ++j) {
				int v; cin >> v;
				res.push_back(v);
			}
			sort(res.begin(), res.end());
			mi[i] = res.back();
			ma[i] = res[0];
		}
		else {
			int k; cin >> k;
			for (int j = 0; j < k; ++j) {
				int f; cin >> f;
				--f;
				a[i].push_back(f);
			}
		}
	}

	dfs(0);
	cout << "Yes\n";

}

/*

3
1 2 2 3
2 1 1
2 1 2

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3

*/