#include <iostream>
#include <vector>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N = 1e5 + 228;

vector<int> G[N];

int main() {
	// ios_base::sync_with_stdio(0);
	// cin.tie(0);
	// cout.tie(0);

	int n, m;
	cin >> n >> m;
	vector<int> cnt(n), now, used(n);
	string ans(m, '!');
	string s;
	cin >> s;
	vector<vector<pair<int, char>>> a(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int pos;
			char c;
			cin >> pos >> c;
			a[i].emplace_back(pos - 1, c);
			if (s[pos - 1] != c) {
				// cout << i << ' ' << s << ' ' << pos << ' ' << c << '\n';
				++cnt[i];
				G[pos - 1].push_back(i);
			}
		}
	}
	// for (int i : cnt)
	// 	cout << i << ' ';
	// cout << '\n';
	for (int i = 0; i < n; ++i) {
		if (!cnt[i]) {
			used[i] = 1;
			now.push_back(i);
		}
	}
	vector<int> res;
	while (now.size()) {
		res.push_back(now.back() + 1);
		int v = now.back();
		// cout << v << '\n';
		now.pop_back();
		for (auto i : a[v]) {
			if (ans[i.first] == '!') {
				ans[i.first] = i.second;
				for (int j : G[i.first]) {
					// cout << i.first << ' ' << i.second << ' ' << j << '\n';
					if (!used[j]) {
						--cnt[j];
						if (!cnt[j]) {
							used[j] = 1;
							now.push_back(j);
						}
					}
				}
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i])
			res.push_back(i);
	}
	if (ans != s) {
		cout << -1 << '\n';
	} else {
		for (int j : res)
			cout << j << ' ';
		cout << '\n';
	}
}