#include <bits/stdc++.h>

using namespace std;

#define pii pair <int, int>
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()

typedef long long ll;
typedef long double ld;
#define int ll

const int inf = 1e9 + 100;
const ll inf64 = 1ll * inf * inf;

void run(){
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector <vector <pair <int, char>>> a(n);
    vector <vector <int>> same(m);
    vector <vector <int>> not_same(m);
    vector <int> sovp(n);
    vector <int> nesovp(n);
    vector <unordered_set <int>> sovp_poses(n);
    vector <unordered_set <int>> nesovp_poses(n);
    for(int i = 0; i < n; ++i){
        int k;
        cin >> k;
        a[i].resize(k);
        for(int j = 0; j < k; ++j){
            int id; char c;
            cin >> id >> c;
            --id;
            a[i][j] = (mp(id, c));
            if(s[id] == c){
                same[id].pb(i);
                sovp[i]++;
                sovp_poses[i].insert(id);
            }
            else{
                not_same[id].pb(i);
                nesovp[i]++;
                nesovp_poses[i].insert(id);
            }
        }
    }
    vector <int> ans;
    unordered_set <int> left_poses;
    for(int i = 0; i < m; ++i){
        left_poses.insert(i);
    }
    unordered_set <int> can_id;
    for(int i = 0; i < n; ++i){
        if(sz(nesovp_poses[i]) == 0 && sz(sovp_poses[i])){
            can_id.insert(i);
        }
    }
    while(!left_poses.empty()){
        bool found = 0;
        int id = -1;
        if(can_id.size()) {
            id = *can_id.begin();
            can_id.erase(can_id.begin());
        }
        if(id != -1)
            found = 1;
        if(!found){
            cout << -1;
            return;
        }
        ans.pb(id);
        unordered_set <int> todel = sovp_poses[id];
        id = -1;
        for(auto i : todel){
            for(auto j : same[i]){
                sovp_poses[j].erase(i);
            }
            for(auto j : not_same[i]){
                nesovp_poses[j].erase(i);
                if(nesovp_poses[j].size() == 0 && sovp_poses[j].size())
                    can_id.insert(j);
            }
            left_poses.erase(i);
        }
    }
    unordered_set <int> in_ans(all(ans));
    for(int i = 0; i < n; ++i){
        if(in_ans.find(i) == in_ans.end())
            ans.pb(i);
    }
    for(auto i : ans){
        cout << i + 1 << ' ';
    }
}

signed main(){
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(0);
    run();
}