#include <bits/stdc++.h>

using namespace std;
vector<vector<int>> graph;
vector<vector<int>> bet;
vector<int> chs;

vector<int> kon;
vector<vector<int>> por;

pair<int, int> dfs(int v) {
  if (!bet[v].empty()) {
    return {chs[v], chs[v]};
  }
  vector<pair<pair<int, int>, int>> kek;
  for (int u : graph[v]) {
    auto pp = dfs(u);
    kek.emplace_back(pp, u);
  }
  sort(kek.begin(), kek.end());
  if (kek[0].first.first == -1)
    return {-1, -1};
  for (int i = 1; i < kek.size(); ++i) {
    if (kek[i - 1].first.second >= kek[i].first.first)
      return {-1, -1};
  }
  por[v].clear();
  por[v].resize(kek.size());
  for (int i = 0; i < kek.size(); ++i)
    por[v][i] = kek[i].second;
  return {kek[0].first.first, kek.back().first.second};
}

void brut(int ind) {
  if (ind == kon.size()) {
    auto pp = dfs(0);
    if (pp.first == -1)
      return;
    cout << "Yes\n";
    exit(0);
  }
  int v = kon[ind];
  for (int i = 0; i < bet[v].size(); ++i) {
    chs[v] = bet[v][i];
    brut(ind + 1);
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n;
  cin >> n;
  graph.resize(n);
  bet.resize(n);
  chs.resize(n);
  for (int i = 0; i < n; ++i) {
    int t;
    cin >> t;
    if (t == 1) {
      int k;
      cin >> k;
      for (int j = 0; j < k; ++j) {
        int x;
        cin >> x;
        graph[i].push_back(x - 1);
      }
    } else {
      kon.push_back(i);
      int m;
      cin >> m;
      bet[i].resize(m);
      for (int &el : bet[i])
        cin >> el;
    }
  }
  cout << "No";
}