#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
using namespace std;

void send(int x) {
    int a = x / 2;
    int b = x % 2;
    cout << 7 - a << ' ' << 7 - b << endl;
}

void ban() {
    cout << 1 << ' ' << 1 << endl;
}

void player1() {
    int n, k, m;
    cin >> n >> k >> m;
    string s;
    cin >> s;
    for (int i = 0; i < s.size(); i += 2) {
        int c = 0;
        if (s[i] == '1') {
            c += 2;
        }
        if (s[i + 1] == '1') {
            c += 1;
        }
        send(c);
        int a, b;
        cin >> a >> b;
        ban();
        cin >> a >> b;
        ban();
    }
    cout << 0 << endl;
}

string decode(int x) {
    string res;
    if (x > 1) {
        res += '1';
    } else {
        res += '0';
    }
    if (x % 2) {
        res += '1';
    } else {
        res += '0';
    }
    return res;
}

void player2() {
    int n, k, m;
    cin >> n >> k >> m;

    int q;
    cin >> q;
    string s;
    vector<pair<int, int>> t;
    int a, b;
    int cntt = 0;
    while (cntt < q) {
        cin >> a >> b;
        if (a == 1 && b == 1) {
            ++cntt;
        }
        t.push_back({ a, b });
    }
    int cnt = 0;
    bool ok = true;
    for (pair<int, int> p : t) {
        if (p.first == 1 && p.second == 1) {
            ++cnt;
            ok = true;
        } else {
            if (cnt % 2 == 0 && ok) {
                int a = 7 - p.first;
                int b = 7 - p.second;
                int c = a * 2 + c;
                s += decode(c);
            }
            ok = false;
        }
    }
    cout << s << endl;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    if (t == 1) {
        player1();
    } else {
        player2();
    }
}
/*
3 7
010
001
100
abacaba

 3 5
010
001
100
bcacb

 6
 1 3 5 4 6
 2 3 10 61 60
 2 2 80 20
 2 2 40 70
 1 2 3 2
 2 4 30 90 91 92

 5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
 */