#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
using namespace std;

vector<vector<int>> g;
map<int, vector<int>> d;
vector<vector<pair<int, int>>> can;
vector<vector<vector<pair<int, pair<int, int>>>>> ord;

void dfs(int v, int p) {
    if (d.count(v)) {
        for (int x : d[v]) {
            can[v].push_back({ x, x });
        }
    }
    for(int u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    for (int u : g[v]) {
        for (int u1 : g[v]) {
            if (u != p && u1 != p && u != u1 && u < u1) {
                for (pair<int, int> p1 : can[u]) {
                    for (pair<int, int> p2 : can[u1]) {
                        if (p1.first > p2.second || p2.first > p1.second) {
                            can[v].push_back({ min(p1.first, p2.first), max(p1.second, p2.second) });
                            if (p1.first > p2.second) {
                                vector<pair<int, pair<int, int>>> x;
                                x.push_back({ u1, p2 });
                                x.push_back({ u, p1 });
                                ord[v].push_back(x);

                            } else {
                                vector<pair<int, pair<int, int>>> x;
                                x.push_back({ u, p1 });
                                x.push_back({ u1, p2 });
                                ord[v].push_back(x);
                            }
                        }
                    }
                }
            }
        }
    }
    if (g[v].size() == 1) {
        for (int u : g[v]) {
            if (u != p) {
                for (pair<int, int> p1 : can[u]) {
                    can[v].push_back(p1);
                    vector<pair<int, pair<int, int>>> x;
                    x.push_back({ u, p1 });
                    ord[v].push_back(x);
                }
            }
        }
    }
}

vector<vector<int>> ans;

void getAns(int v, pair<int, int> want) {
    if (g[v].size() == 0) {
        ans[v].push_back(want.first);
        return;
    }
    for (int i = 0; i < can[v].size(); ++i) {
        if (can[v][i] == want) {
            pair<int, pair<int, int>> t = ord[v][i][0];
            getAns(t.first, t.second);
            ans[v].push_back(t.first + 1);
            if (g[v].size() > 1) {
                pair<int, pair<int, int>> t = ord[v][i][1];
                ans[v].push_back(t.first + 1);
                getAns(t.first, t.second);
            }
            break;
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    g.resize(n);
    ord.resize(n);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 2) {
            int m;
            cin >> m;
            assert(m != 0);
            while (m--) {
                int x;
                cin >> x;
                d[i].push_back(x);
            }
        } else {
            int k;
            cin >> k;
            while (k--) {
                int u;
                cin >> u;
                --u;
                g[i].push_back(u);
            }
        }
    }
    can.resize(n);
    dfs(0, -1);
    if (can[0].size()) {
        cout << "Yes\n";
        if (n <= 10) {
            ans.resize(n);
            getAns(0, can[0][0]);
            for (int i = 0; i < n; ++i) {
                for (int j : ans[i]) {
                    cout << j << ' ';
                }
                cout << '\n';
            }
        }
    } else {
        cout << "No\n";
    }
}
/*
3 7
010
001
100
abacaba

 3 5
010
001
100
bcacb

 6
 1 3 5 4 6
 2 3 10 61 60
 2 2 80 20
 2 2 40 70
 1 2 3 2
 2 4 30 90 91 92

 5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
 */