#include <bits/stdc++.h>
using namespace std;

const int MAXN = 20;

vector<int> graph[MAXN];
vector<int> kek[MAXN];

int get_bit(int mask, int ind) {
  return (mask >> ind) & 1;
}

bool dfs(int v, int mask, vector<int> &a) {
  if (graph[v].empty()) { // leaf
    auto it = upper_bound(kek[v].begin(), kek[v].end(), a.back());
    if (it == kek[v].end())
      return false;
    a.emplace_back(*it);
    return true;
  }

  if (graph[v].size() == 2) {
    if (get_bit(mask, v) == 0) {
      swap(graph[v][0], graph[v][1]);
    }
  }

  for (auto u : graph[v]) {
    bool st = dfs(u, mask, a);
    if (!st)
      return false;
  }

  if (graph[v].size() == 2) {
    if (get_bit(mask, v) == 0) {
      swap(graph[v][0], graph[v][1]);
    }
  }

  return true;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n;
  cin >> n;
  for (int i = 0; i < n; i++) {
    int t;
    cin >> t;
    if (t == 1) {
      int k;
      cin >> k;
      for (int j = 0; j < k; j++) {
        int u;
        cin >> u;
        u--;
        graph[i].push_back(u);
      }
    } else {
      int m;
      cin >> m;
      for (int j = 0; j < m; j++) {
        int a;
        cin >> a;
        kek[i].push_back(a);
      }
      stable_sort(kek[i].begin(), kek[i].end());
    }
  }
  for (int mask = 0; mask < (1 << n); mask++) {
    vector<int> a = {0};
    if (dfs(0, mask, a)) {
      cout << "Yes\n";
      return 0;
    }
  }
  cout << "No\n";
  return 0;
}

/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92



3
1 2 2 3
2 1 1
2 1 2


5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
 */