#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second

const int MAXN = 131072 * 4;

void solve() {
    int k, n;
    cin >> k >> n;
    vector<vector<int>> may(k, vector<int> (k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char x;
            cin >> x;
            may[i][j] = x - '0';
        }
    }
    string s;
    cin >> s;
    vector<pair<int, char>> v;
    vector<int> jump(n);
    for (int i = n - 1; i >= 0; --i) {
        while (v.size() && may[s[i] - 'a'][v.back().y - 'a'])
            v.pop_back();
        if (v.size()) {
            jump[i] = v.back().x;
        } else {
            jump[i] = MAXN;
        }
        v.push_back({i, s[i]});
    }
    deque<int> now;
    now.push_back(MAXN);
    vector<int> my_next(n);
    for (int i = n - 1; i >= 0; --i) {
        int lb = 0, rb = now.size();
        while (rb - lb > 1) {
            int mid = (lb + rb) >> 1;
            if (jump[i] >= now[mid])
                lb = mid;
            else
                rb = mid;
        }
        my_next[i] = now[lb];
        while (true) {
            int P1 = i;
            int P2 = now.front();
            bool stop = false;
            while (true) {
                if (P2 == MAXN) {
                    stop = true;
                    break;
                } else if (P1 == MAXN) {
                    now.pop_front();
                    break;
                } else if (s[P1] < s[P2]) {
                    now.pop_front();
                    break;
                } else if (s[P1] > s[P2]) {
                    stop = true;
                    break;
                }
                P1 = my_next[P1];
                P2 = my_next[P2];
            }
            if (stop)
                break;
        }
        now.push_front(i);
    }
    int id = 0;
    while (id != MAXN) {
        cout << s[id];
        id = my_next[id];
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}
