#include <bits/stdc++.h>

using namespace std;

//#define int long long
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 _mt(seed);

int n; bool f = false;
vector <vector <int> > g, tasks, ans;
vector <int> used, cur;
vector <pair <int, int> > dp;

bool nxt() {
    int i = n - 1;
    while (i >= 0 && tasks[i].empty() || tasks[i].size() < cur[i] + 2)
        i--;
    if (i < 0) return false;
    cur[i++]++;
    while (i < n)
        cur[i++] = 0;
    return true;
}

void dfs(int v) {
    used[v] = 1;
    vector <pair <int, int> > us;
    for (auto &u : g[v]) {
        if (!used[u]) {
            dfs(u);
            us.push_back({dp[u].first, dp[u].second});
        }
    }
    if (us.empty()) {
        dp[v] = {tasks[v][cur[v]], tasks[v][cur[v]]};
    } else {
        sort(us.begin(), us.end());
        dp[v] = {us[0].first, us.back().second};
        for (int i = 1; i < us.size(); i++)
            if (us[i - 1].second > us[i].first)
                f = false;
    }
}

void ddfs(int v) {
    used[v] = 1;
    vector <vector <int> > us;
    for (auto &u : g[v]) {
        if (!used[u]) {
            ddfs(u);
            us.push_back({dp[u].first, dp[u].second, u});
        }
    }
    if (us.empty()) {
        dp[v] = {tasks[v][cur[v]], tasks[v][cur[v]]};
        ans[v] = {tasks[v][cur[v]]};
    } else {
        sort(us.begin(), us.end());
        dp[v] = {us[0][0], us.back()[1]};
        for (auto &el : us)
            ans[v].push_back(el[2] + 1);
    }
}


int32_t main()
{
    #ifdef LOCAL
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    #endif
    cin >> n;
    g.resize(n); used.resize(n);
    dp.resize(n); tasks.resize(n);
    for (int i = 0; i < n; i++) {
        int type; cin >> type;
        if (type == 1) {
            int x; cin >> x;
            for (int j = 0; j < x; j++) {
                int v; cin >> v;
                g[i].push_back(v - 1);
                g[v - 1].push_back(i);
            }
        } else {
            int x; cin >> x;
            tasks[i].resize(x);
            for (int j = 0; j < x; j++)
                cin >> tasks[i][j];
        }
    }
    cur.resize(n);
    while (1) {
        f = true; dfs(0);
        fill(used.begin(), used.end(), 0);
        if (f) break;
        if (!nxt()) {
            cout << "No";
            return 0;
        }
    }
    cout << "Yes\n";
    ans.resize(n); ddfs(0);
    for (auto &_el : ans) {
        for (auto &el : _el)
            cout << el << " ";
        cout << "\n";
    }
    return 0;
}
