#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>

#define IO
#define endl '\n'
#define int long long
#define float long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

int n, k;
string s;
vector<string> del;

string f(int i, string pref) {
	if (i == n - 1) {
		for (int j = 0; j < pref.size(); ++j) {
			if (del[pref[j]][s[i]]) {
				return "";
			}
		}
		return string(1, s[i]);
	}
	int k = -1;
	for (int j = 0; j < pref.size(); ++j) {
		if (del[pref[j]][s[i]]) {
			k = j;
			break;
		}
	}
	string t = f(i + 1, string(1, s[i]) + (k == -1 ? "" : pref.substr(k, (int)(pref.size()) - k)));
	string ans = string(1, s[i]) + t;
	while (!t.empty() && del[s[i]][t.front()]) {
		t.erase(t.begin());
		ans = min(ans, string(1, s[i]) + t);
	}
	return ans;

}

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
#ifdef IO
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	cin >> k >> n;
	del.assign(k, string(k, 0));
	for (int i = 0; i < k; ++i) {
		cin >> del[i];
	}
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			del[i][j] -= '0';
		}
	}
	cin >> s;
	for (int i = 0; i < n; ++i) {
		s[i] -= 'a';
	}
	string ans = f(0, "");
	for (int i = 0; i < ans.size(); ++i) {
		ans[i] += 'a';
	}
	cout << ans << endl;
	/*
	vector<vector<string>> dp(n, vector<string>(n));
	dp[n - 1][0] = string(1, s[n - 1]);
	int can = 0;
	for (int i = 1; i < n; ++i) {
		can = can || del[s[n - i - 1]][s[n - 1]];
		if (!can) {
			dp[n - 1][i] = string(1, s[n - 1]);
	 	}
	}
	for (int i = n - 2; i >= 0; --i) {
		int k = -1;
		for (int j = 1; j <= i; ++j) {
			if (del[s[i]][s[i - j]]) {
				k = j;
				break;
			}
		}
		for (int j = 0; j <= i; ++j) {
			if (k == -1 || j < k) {
				string t = dp[i + 1][1];
				dp[i][j] = string(1, s[i]) + t;
				while (!t.empty() && del[s[i]][t.front()]) {
					t.erase(t.begin());
					dp[i][j] = min(dp[i][j], string(1, s[i]) + t);
				}
			} else {
				string t = dp[i + 1][0];
				dp[i][j] = s.substr(i, n - i);
			}
		}
	}
	for (int i = 0; i < s.size(); ++i) {
		s[i] += 'a';
	}
	cout << s << endl;
	*/
	return 0;
}