#define ll long long

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

ll num(char c) {
	return (c - 'a');
}

signed main() {
	ll n, k;
	cin >> k >> n;
	vector<vector<ll>> del(k, vector<ll>(k));
	for (int i = 0; i < k; i++) {
		string hj;
		cin >> hj;
		for (int j = 0; j < k; j++) {
			del[i][j] = (hj[j] == '1');
		}
	}
	string s;
	cin >> s;
	if (k == 2) {
		vector<pair<ll, char>> ans;
		ans.push_back({ 1, s[0] });
		for (int i = 1; i < n; i++) {
			if (s[i] == s[i - 1]) {
				ans.back().first++;
			}
			else {
				ans.push_back({ 1, s[i] });
			}
		}
		for (int i = 0; i < ans.size();  i++) {
			if (ans[i].second == 'b' && del[1][1]) {
				ans[i].first = 1;
			}
		}
		if (!del[0][1] && !del[1][1]) {
			if (ans.back().second == 'a' && ans.size() != 1 && del[1][0]) {
				ans.pop_back();
			}
		}
		else {
			vector<ll >next(ans.size(), 1e9);
			for (int i = ans.size() - 2; i >= 0; i--) {
				next[i] = i + 1;
				if (ans[i + 1].first == 0) {
					next[i] = next[i + 1];
				}
				while (next[i] != 1e9 && del[num(ans[i].second)][num(ans[next[i]].second)]) {
					ans[next[i]].first = 0;
					next[i] = next[next[i]];
				}
			}
		}
		if (ans.back().second == 'a' && del[0][0]) {
			ans.back().first = 1;
		}
		for (int i = 0; i < ans.size(); i++) {
			for (int j = 0; j < ans[i].first; j++) {
				cout << ans[i].second;
			}
		}
		return 0;
	}
	if (k == 1) {
		if (del[0][0]) {
			cout << 'a';
		}
		else {
			cout << s;
		}
		return 0;
	}
	vector<vector<string>> dp(n, vector<string>(k, "}"));
	vector<vector<ll>> a(n, vector<ll>(k, 1e9));
	dp[0][num(s[0])] = s[0];
	a[0][num(s[0])] = 0;
	for (int i = 1; i < n; i++) {
		ll op = num(s[i]);

		for (int j = 0; j < k; j++) {
			ll px = 1e9;
			if (a[i - 1][j] != 1e9 && del[j][op]) {
				ll l_j = a[i - 1][j];
				for (int l = 0; l < k; l++) {
					a[i][l] = min(a[i][l], a[l_j][l]);
				}
			}
		}
		for (int j = 0; j < k; j++) {
			if (a[i][j] != 1e9) {
				dp[i][j] = dp[a[i][j]][j];
			}
		}

		for (int j = 0; j < k; j++) {
			if (dp[i][j] != "}" && dp[i][j] + s[i] < dp[i][op]) {
				dp[i][op] = dp[i][j] + s[i];
				a[i][op] = i;
			}
		}

		for (int j = 0; j < k; j++) {
			ll l_j = a[i - 1][j];
			if (l_j == 1e9) {
				continue;
			}
			if (dp[l_j][j] + s[i] < dp[i][op]) {
				dp[i][op] = dp[l_j][j] + s[i];
				a[i][op] = i;
			}
		}
	}
	string ans = "";
	ans += char('z' + 1);
	for (int i = 0; i < k; i++) {
		ans = min(dp.back()[i], ans);
	}
	cout << ans;
}


/*
3 7
010
001
100
abacaba

2 7
01
10
aabbaab
*/