#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (auto x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
	#define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
	#define dbg(...)
#endif



int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vec<vec<pair<int, char>>> a(n);
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		a[i].resize(k);
		for (auto &[pos, c] : a[i]) {
			cin >> pos >> c;
			pos--;
		}
	}
	vec<int> bad(n);
	vec<vec<int>> where_bad(m);
	for (int i = 0; i < n; i++) {
		for (auto [pos, c] : a[i]) {
			if (s[pos] != c) {
				bad[i]++;
				where_bad[pos].push_back(i);
			}
		}
	}
	vec<int> que;
	for (int i = 0; i < n; i++) {
		if (!bad[i]) {
			que.push_back(i);
		}
	}
	vec<char> used(m);
	for (int st = 0; st < len(que); st++) {
		int v = que[st];
		for (auto [pos, c] : a[v]) {
			if (used[pos]) {
				continue;
			}
			used[pos] = 1;
			for (auto j : where_bad[pos]) {
				bad[j]--;
				if (!bad[j]) {
					que.push_back(j);
				}
			}
		}
	}
	if (find(all(used), 0) != used.end()) {
		cout << "-1\n";
	} else {
		assert(len(que) == n);
		for (auto x : que) {
			cout << x + 1 << ' ';
		}
		cout << '\n';
	}
}
