#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define int long long
#define double long double

using namespace std;
using namespace __gnu_pbds;

typedef pair<int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

const int NMAX = 500010, MMAX = 200010, KMAX = 200010;

int a[30][30];

string s;

/*

3 3
111
000
000
abc

ans:
a

*/


string dp[NMAX];

bool can_erase(int l, int r) {
    if (l >= r) {
        return true;
    }

    deque<int> d = {r - 1};

    for (int i = r - 2; i >= l; i--) {
        while (!d.empty() && a[s[i] - 'a'][s[d.front()] - 'a']) {
            d.pof();
        }
        d.puf(i);
    }


    return sz(d) == 1;
}


void solve_solve_solve() {
    int k, n;
    cin >> k >> n;

    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char c;
            cin >> c;

            if (c == '0') {
                a[i][j] = 0;
            } else {
                a[i][j] = 1;
            }
        }
    }
    cin >> s;

    dp[n - 1] = (string)"" + s[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        //cout << "!!!!!!!!!!!!!!!!!!! " << i << " " << can_erase(i, n) << "\n";

        if (can_erase(i, n)) {
            dp[i] = "";
        } else {
            dp[i] = "{";
        }

        for (int j = i + 1; j < n; j++) {
            //cout << "OK " << i << " " << j << " "  << can_erase(i, j + 1) << "\n";
            if (can_erase(i, j)) {
                dp[i] = min(dp[i], dp[j]);
            } else {
                break;
            }
        }
        dp[i] = s[i] + dp[i];
    }

    /*
    cout << "dp = \n";
    for (int i = n - 1; i >= 0; i--) {
        cout << i << " " << dp[i] << "\n";
    }
    cout << "END\n\n";
    */


    cout << dp[0] << "\n";
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int Q = 1;
    //cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
