#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

const int INF = 1e9;
const int MOD = 228228227;

inline void solve() {
    int k, n;
    cin >> k >> n;

    map <int, map <int, bool>> deletions;

    char x;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            cin >> x;

            if (x == '1') {
                deletions[i][j] = true;
            }
        }
    }

    string str_s;
    cin >> str_s;

    vector <int> s(n);
    for (int i = 0; i < n; i++)
        s[i] = str_s[i] - 'a';

    vector <int> answer = s;
    vector <bool> blocked;

    for (int mask = 0; mask < (1 << n); mask++) {
        blocked.assign(n, false);

        bool shit_iteration = false;
        for (int i = 0; i < n; i++) {
            if ((1 << i) & mask) {
                bool found = false;
                for (int j = i - 1; j >= 0; j--) {
                    if (blocked[j]) continue;
                    if (deletions[s[j]][s[i]]) {
                        found = true;
                        break;
                    }

                    blocked[j] = true;
                    if (((1 << j) & mask) == 0) break;
                }

                if (!found) {
                    shit_iteration  = true;
                    break;
                }
            }
        }

        if (shit_iteration) continue;
        vector <int> new_answer;
        for (int i = 0; i < n; i++) {
            if ((1 << i) & mask) continue;
            new_answer.push_back(s[i]);
        }

        answer = min(answer, new_answer);
    }

    for (int x: answer)
        cout << (char)('a' + x);
    cout << '\n';
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
