#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;


void get_answer(map <int, map <int, bool>> &deletions, vector <int> &s, vector <bool> &deleted, vector <int> &answer, int n) {
    vector <int> new_s;
    for (int i = 0; i < n; i++) {
        if (deleted[i]) continue;
        new_s.push_back(s[i]);
    }

    if (new_s < answer) {
        answer = new_s;
    }

    int prev = -1;
    for (int i = 0; i < n; i++) {
        if (deleted[i]) continue;

        if (prev != -1 && deletions[s[prev]][s[i]]) {
            deleted[i] = true;
            get_answer(deletions, s, deleted, answer, n);
            deleted[i] = false;
        }

        prev = i;
    }
}

inline void solve() {
    int k, n;
    cin >> k >> n;

    map <int, map <int, bool>> deletions;

    char x;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            cin >> x;

            if (x == '1') {
                deletions[i][j] = true;
            }
        }
    }

    string str_s;
    cin >> str_s;

    vector <int> s(n);
    for (int i = 0; i < n; i++) {
        s[i] = str_s[i] - 'a';
    }

    vector <int> answer = s;
    vector <bool> deleted(n);

    get_answer(deletions, s, deleted, answer, n);

    for (int x: answer)
        cout << (char)('a' + x);
    cout << '\n';
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
