#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define print(x) {for (auto xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}

const int maxn = 1000 + 5;

bool dp[26][maxn][maxn];

void solve() {
    int k, n;
    cin >> k >> n;
    vector < vector <bool> > a(k, vector <bool> (k));
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char c; cin >> c;
            a[i][j] = (c == '1');
        }
    }
    vector <int> s(n);
    for (int i = 0; i < n; i++) {
        char c; cin >> c;
        s[i] = c - 'a';
    }
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                dp[i][j][k] = (j > k);
            }
        }
    }
    for (int len = 1; len <= n; len++) {
        for (int t = 0; t < k; t++) {
            for (int i = 0; i + len <= n; i++) {
                int j = i + len - 1;
                for (int k = i; k <= j; k++) {
                    if (a[t][s[k]] && (k - 1 < 0 || dp[t][i][k - 1]) && (k + 1 >= n || dp[s[k]][k + 1][j])) {
                        dp[t][i][j] = true;
                        break;
                    }
                }
            }
        }
    }
    vector <string> suff(n);
    for (int i = 0; i < n; i++) {
        suff[i] = "";
        for (int j = i; j < n; j++) {
            suff[i] += (s[j] + 'a');
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = i + 1; j < n; j++) {
            if (i + 1 > j - 1 || dp[s[i]][i + 1][j - 1]) {
                suff[i] = min(suff[i], char(s[i] + 'a') + suff[j]);
            }
        }
        if (dp[s[i]][i + 1][n - 1]) {
            suff[i] = "";
            suff[i] += s[i];
        }
    }
    cout << suff[0] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);

    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}