#include <bits/stdc++.h>

///#define int ll

using namespace std;

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << " " <<

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MXN = 32;
const int K = 10;

map<int, string> mp;

string mask_to_str(int len, int mask) {
    string ans = "";
    for (int i = 0; i < len; ++i) {
        if ((mask >> i) & 1) ans.push_back('1');
        else ans.push_back('0');
    }
    return ans;
}

int fst_stp = 1;

int n, m, k;


string s;
int pos = 0;

int cool_check(string e) {
    for (int i = 0; ((pos+i < s.size()) && (i < e.size())); ++i) {
        if (s[pos+i] != e[i]) return false;
    }
    return true;
}

int a[MXN][MXN];

void clear_all() {
    for (int i = 0; i < MXN; ++i) {
    for (int j = 0; j < MXN; ++j) {
        a[i][j] = 0;
    }}
}

void do_step(int x, int y) {
    for (int i = x; i < n; ++i) {
    for (int j = y; j < n; ++j) {
        a[i][j] = 1;
    }}
}

bool cmp(pii a, pii b) {
    if ((a.ff*a.ff + a.ss*a.ss) < (b.ff*b.ff + b.ss*b.ss)) return true;
    return (a < b);
}

vector<pii> all_mvs() {
    vector<pii> ans;
    for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
        if (a[i][j]) continue;
        ans.push_back({i, j});
    }}
    sort(all(ans), cmp);
    return ans;
}

void game1() {
    clear_all();
    int turn = 0;
    if (fst_stp) turn = 1;
    while (1) {
        if (turn) {
            vector<pii> mv = all_mvs();
            int i = 0;
            if (pos < s.size() && mv.size() >= 2) {
                for (int j = 0; j < min(K, (int)(mv.size())); ++j) {
                    if (cool_check(mp[j])) {
                        i = j;
                    }
                }
                pos += mp[i].size();
            }
            cout << mv[i].ff+1 _ mv[i].ss+1 << endl;
            do_step(mv[i].ff, mv[i].ss);
            if (mv[i].ff+1 == 1 && mv[i].ss+1 == 1) {
                return;
            }
            turn = 0;
        } else {
            int x, y;
            cin >> x >> y; --x; --y;
            do_step(x, y);
            if (x+1 == 1 && y+1 == 1) return;
            turn = 1;
        }
    }
}

void game2() {
    clear_all();
    int turn = 0;
    if (fst_stp) turn = 1;
    while (1) {
        if (turn) {
            vector<pii> mv = all_mvs();
            int x, y;
            cin >> x >> y; --x; --y;
            if (s.size() < m && mv.size() >= 2) {
                int i = -1;
                for (int j = 0; j < mv.size(); ++j) {
                    if (mv[j] == make_pair(x, y)) {
                        i = j;
                    }
                }
                s += mp[i];
            }
            //cout << mv[i].ff+1 _ mv[i].ss+1 << endl;
            do_step(x, y);
            if (x+1 == 1 && y+1 == 1) return;
            turn = 0;
        } else {
            int x, y;
            cin >> x >> y; --x; --y;
            do_step(x, y);
            if (x+1 == 1 && y+1 == 1) return;
            turn = 1;
        }
    }
}

void solve1() {
    cin >> s;
    fst_stp = 1;
    while (pos < s.size()) {
        game1();
        fst_stp ^= 1;
    }
    cout << 0 << endl;
}

void solve2() {
    fst_stp = 1;
    int cnt;
    cin >> cnt;
    while (s.size() < m) {
        game2();
        fst_stp ^= 1;
    }
    for (int i = 0; i < m; ++i) {
        cout << s[i];
    } cout << endl;
}

int32_t main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);
    ///
    int mp_pos = 0;
    for (int len = 1; len < 10; ++len) {
        for (int mask = 0; mask < (1 << len); ++mask) {
            mp[mp_pos] = mask_to_str(len, mask); ++mp_pos;
            //cout << len _ mask _ mask_to_str(len, mask) << endl;
        }
    }
    ///
    int tp;
    cin >> tp;
    cin >> n >> k >> m;
    if (tp == 1) {
        solve1();
    } else {
        solve2();
    }
}

