#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define ALL(x) (x).begin(), (x).end()

int n, m;
string s;

int solve() {
    if (!(cin >> n >> m))
        return 1;
    cin >> s;
    vector<set<int>> cards_bad(n);
    vector<vector<int>> blocking(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int p; char c;
            cin >> p >> c;
            p--;
            blocking[i].emplace_back(p);
            if (s[p] != c) {
                cards_bad[i].insert(p);
            }
        }
    }

    priority_queue<pair<int, int>> q;
    priority_queue<pair<int, int>> r_q;
    for (int i = 0; i < n; ++i) {
        q.emplace(make_pair(-((int)cards_bad[i].size()), i));
    }
    vector<bool> blocked(m, false);
    bool failure = false;
    vector<int> answer;
    int ops = 0;
    bool was_kek = false;
    while (!failure) {
        {
            if (q.empty()) {
                if (!was_kek) {
                    failure = true;
                    break;
                }
                was_kek = false;
                swap(q, r_q);
            }
            if (q.empty()) {
                break;
            }
        }
        pair<int, int> _c_i = q.top();
        q.pop();
        int cnt = -_c_i.first, ind = _c_i.second;
        if (cnt == 0) {
            answer.emplace_back(ind);
            for (int p : blocking[ind]) {
                blocked[p] = true;
                ops++;
            }
            was_kek = true;
            continue;
        } else {
            vector<int> to_delete;
            for (int e : cards_bad[ind]) {
                ops++;
                if (blocked[e]) to_delete.emplace_back(e);
            }
            for (int e : to_delete) {
                ops++;
                cards_bad[ind].erase(e);
            }
            int n_c = cards_bad[ind].size();
//            if (n_c == cnt) {
//                failure = true;
//                break;
//            } else {
                r_q.push(make_pair(-n_c, ind));
//            }
        }
    }
    if (failure) {
        cout << -1 << '\n';
    } else {
        for (bool e : blocked) {
            if (!e) {
                cout << -1 << '\n';
                return 0;
            }
        }
        for (int e : answer) {
            cout << e + 1 << ' ';
        }
        cout << '\n';
    }

    return 0;
}

int main() {
#ifdef LOCAL
    freopen("A.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    // cin >> tests;
    for (int i = 1; i <= tests; ++i) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "-------------------------\n";
#endif
    }
}
