#include<bits/stdc++.h>
using namespace std;

const int MAXN = 32;
bool mp[MAXN][MAXN];
int pref[MAXN][MAXN];
set<pair<int, int>> inter;
int tgame = 0;

void upd(int x, int y, int t) {
    for (; x < MAXN; x = (x | (x + 1))) {
        for (; y < MAXN; y = (y | (y + 1))) {
            pref[x][y] += t;
        }
    }
}

int get(int x, int y) {
    int res = 0;
    for (; x >= 0; x = (x & (x + 1)) - 1) {
        for (; y >= 0; y = (y & (y + 1)) - 1) {
            res += pref[x][y];
        }
    }
    return res;
}

int getnow(int x, int y) {
    return (x + 1) * (y + 1) - get(x, y);
}

void sett(int x, int y) {
    //cout << x << " " << y << ":" << endl;
    for (int i = 0; i <= x + 1; ++i) {
        //cout << i << " " << y + 1 << endl;
        for (int off = 1; off <= 2; ++off) {
            if (y + off < MAXN && i < MAXN) inter.insert({i, y + off});
        }
    }
    for (int i = 0; i <= y + 1; ++i) {
        //cout << x + 1 << " " << i << endl;
        for (int off = 1; off <= 2; ++off) {
            if (x + off < MAXN && i < MAXN) inter.insert({x + off, i});
        }
    }
    for (int i = x; i >= 0; --i) {
        if (mp[i][y]) break;
        for (int j = y; j >= 0; --j) {
            if (mp[i][j]) break;
            mp[i][j] = true;
            inter.erase({i, j});
            upd(i, j, 1);
        }
    }
    /*for (int i = 0; i < MAXN; ++i) {
        for (int j = 0; j < MAXN; ++j) {
            cout << mp[i][j];
        }
        cout << "\n";
    }
    cout << endl;*/
}

void show(int x, int y) {
    cout << MAXN - x << " " << MAXN - y << endl;
    if (x == MAXN - 1 && y == MAXN - 1) {
        tgame++;
        for (int t1 = 0; t1 < MAXN; ++t1) {
            for (int t2 = 0; t2 < MAXN; ++t2) {
                mp[t1][t2] = false;
                pref[t1][t2] = 0;
            }
        }
        inter.clear();
        inter.insert({0, 0});
        inter.insert({0, 1});
        inter.insert({1, 0});
        inter.insert({1, 1});
        if (tgame % 2 == 1) {
            int x, y;
            cin >> x >> y;
            sett(MAXN - x, MAXN - y);
        }
    }
}

bool visu(int bit) {
    set<pair<int, int>> toer;
    bool ok = false;
    for (auto it : inter) {
        //cout << it.first << " " << it.second << endl;
        if (mp[it.first][it.second]) {
            toer.insert(it);
            continue;
        }
        //cout << it.first << " " << it.second << " " << getnow(it.first, it.second) << " DEB" << endl;
        if (!ok && getnow(it.first, it.second) == bit + 1 && !(it.first == MAXN - 1 && it.second == MAXN - 1)) {
            sett(it.first, it.second);
            show(it.first, it.second);
            ok = true;
            break;
        }
    }
    //cout << ok << endl;
    for (auto it : toer) {
        inter.erase(it);
    }
    return ok;
}

void solv1() {
    int n, k, m;
    string s;
    cin >> n >> k >> m >> s;
    inter.insert({0, 0});
    inter.insert({0, 1});
    inter.insert({1, 0});
    inter.insert({1, 1});
    for (int i = 0; i < m; ++i) {
        bool ok = visu(s[i] - '0');
        if (!ok) {
            i--;
            show(MAXN - 1, MAXN - 1);
        }
        int x, y;
        cin >> x >> y;
        if (x == 1 && y == 1) {
            tgame++;
            for (int t1 = 0; t1 < MAXN; ++t1) {
                for (int t2 = 0; t2 < MAXN; ++t2) {
                    mp[t1][t2] = false;
                    pref[t1][t2] = 0;
                }
            }
            inter.clear();
            inter.insert({0, 0});
            inter.insert({0, 1});
            inter.insert({1, 0});
            inter.insert({1, 1});
            if (tgame % 2 == 1) {
                int x, y;
                cin >> x >> y;
                sett(MAXN - x, MAXN - y);
            }
        } else {
            sett(MAXN - x, MAXN - y);
        }
    }
    cout << "0" << endl;
}

void solv2() {
    int n, k, m, q;
    cin >> n >> k >> m >> q;
    int tgame = 0;
    int chet = 0;
    string ans;
    while (q != tgame) {
        int x, y;
        cin >> x >> y;
        if (x == 1 && y == 1) {
            for (int t1 = 0; t1 < MAXN; ++t1) {
                for (int t2 = 0; t2 < MAXN; ++t2) {
                    pref[t1][t2] = 0;
                }
            }
            if (tgame % 2 == 0) chet = 1;
            else chet = 0;
            tgame++;
        } else {
            x = MAXN - x;
            y = MAXN - y;
            if (chet == 0) {
                ans.push_back((char)(getnow(x, y) - 1 + '0'));
            }
            sett(x, y);
        }
    }
}

/*
1
32 8 10
1001101011
*/

int32_t main() {
    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    int type;
    cin >> type;
    if (type == 1) {
        solv1();
    } else {
        solv2();
    }
    return 0;
}


