#include <bits/stdc++.h>

using namespace std;

void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
}

string solve(int n, int k, vector<vector<bool>> a, string s) {
    vector<string> dp(n + 1);
    dp[n] = "";
    for (int i = n - 1; i >= 0; --i) {
        string next = dp[i + 1];
        string mn = next;
        int j = 0;
        while (j < next.size() && a[s[i] - 'a'][next[j] - 'a']) {
            mn = min(mn, next.substr(++j, next.size()));
        }
        dp[i] = s[i] + mn;
    }
    return dp[0];
}

string solve_slow(int n, int k, const vector<vector<bool>> &a, const string &s) {
    string ans = s;
    for (int mask = 0; mask < 1 << n; mask += 2) {
        vector<int> erase;
        for (int bit = 0; bit < n; ++bit) {
            if (mask & (1 << bit)) erase.push_back(bit);
        }
        do {
            string t = s;
            vector<int> ord = erase;
            for (int i = 0; i < ord.size(); ++i) {
                int idx = ord[i];
                if (!a[t[idx - 1] - 'a'][t[idx] -'a']) goto NO;
                t.erase(t.begin() + ord[i]);
                for (int j = i + 1; j < ord.size(); ++j) if (ord[j] > ord[i]) --ord[j];
            }
            ans = min(ans, t);
            NO:;
        } while (next_permutation(erase.begin(), erase.end()));
    }
    return ans;
}

void solve(){
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> a(k, vector<bool>(k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            a[i][j] = c == '1';
        }
    }
    string s;
    cin >> s;
    cout << solve_slow(n, k, a, s) << '\n';
}

//void solve() {
//    int n = rand() %
//}slow_