#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <queue>

using namespace std;

int main() {
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector<vector<int>> bad(m);
	vector<int> cnt(n);
	vector<vector<int>> good(n);
	//set<pair<int, int>> all;
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		for (int j = 0; j < x; j++) {
			int a;
			char b;
			cin >> a >> b;
			a--;
			if (s[a] != b) {
				bad[a].push_back(i);
				//all.insert({ a,  i });
				cnt[i]++;
			}
			if (s[a] == b) {
				good[i].push_back(a);
			}
		}
	}

	vector<int> ans;
	vector<bool> del(m, false);
	vector<bool> check(n, false);
	queue<int> order;
	for (int i = 0; i < n; i++) {
		if (cnt[i] == 0) {
			order.push(i);
			check[i] = true;
		}
	}

	while (!order.empty()) {
		int t = order.front();
		order.pop();
		ans.push_back(t);
		for (auto i : good[t]) {
			if (del[i]) {
				continue;
			}
			for (auto j : bad[i]) {
				if (check[j]) {
					continue;
				}
				cnt[j]--;
				if (cnt[j] == 0) {
					check[j] = true;
					order.push(j);
				}
			}
		}
	}
	if (ans.size() != n) {
		cout << -1 << endl;
		return 0;
	}
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] + 1 << " ";
	}
	/*if (cnt[i] == 0) {
		check[i] = true;
		order.push_back(i + 1);
		for (int j = 0; j < good[i].size(); j++) {
			int t = good[i][j];
			if (!del[t]) {
				del[t] = true;
				for (int k = 0; k < bad[t].size(); k++) {
					//if (all.find({ t, bad[k] }) != all.end()) {
						//cnt[bad[k]]--;
					//}
					cnt[bad[k]]--;
					if (cnt[bad[k]] == 0) {

					}
				}*
	}*/

	cin >> n;
	return 0;
}