#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<int> _min;
vector<int> _max;

vector<int> pr;
vector<vector<int>> edges;

//vector<vector<pair<int, int>>> level;

void dfs(int u, int d = 0) {
	for (auto v : edges[u]) {
		if (v != pr[u]) {
			dfs(v, d + 1);
			_min[u] = min(_min[u], _min[v]);
			_max[u] = max(_max[u], _max[v]);
		}
	}
	//level[d].push_back({ _min[u], _max[u] });
}

int main() {
	int n;
	cin >> n;
	edges.resize(n);
	pr.resize(n, -1);
	vector<pair<int, int>> all;
	_min.resize(n);
	_max.resize(n);
	//level.resize(n);
	int cnt = 0;
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			for (int j = 0; j < k; j++) {
				int x;
				cin >> x;
				x--;
				edges[i].push_back(x);
				edges[x].push_back(i);
				pr[x] = i;
			}
		}
		if (t == 2) {
			cnt++;
			int k;
			cin >> k;
			for (int j = 0; j < k; j++) {
				int x;
				cin >> x;
				all.push_back({ x, i });
			}
		}
	}
	sort(all.begin(), all.end());
	for (int i = 0; i < (1 << all.size()); i++) {
		set<int> people;
		vector<int> cur;
		int ind = 0;
		int t = i;
		while (t > 0) {
			if (t % 2 == 1) {
				cur.push_back(ind);
			}
			t /= 2;
			ind++;
		}
		if (cur.size() != cnt) {
			continue;
		}
		for (int i = 0; i < cur.size(); i++) {
			people.insert(all[cur[i]].second);
		}
		if (people.size() != cur.size()) {
			continue;
		}
		for (int i = 0; i < cur.size(); i++) {
			_min[all[cur[i]].second] = all[cur[i]].first;
			_max[all[cur[i]].second] = all[cur[i]].first;
		}
		dfs(0);
		bool ch = true;
		for (int i = 0; i < n; i++) {
			vector<pair<int, int>> _cur;
			for (auto v : edges[i]) {
				if (v == pr[i]) {
					continue;
				}
				_cur.push_back({ _min[v], _max[v] });
			}
			sort(_cur.begin(), _cur.end());
			for (int i = 1; i < _cur.size(); i++) {
				if (_cur[i - 1].second >= _cur[i].first) {
					ch = false;
				}
			}
		}
		if (ch) {
			cout << "Yes" << endl;
			cin >> n;
			return 0;
		}
	}
	cout << "No" << endl;
	cin >> n;
	return 0;
}