#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <deque>
#include <string>
#include <set>
#include <stack>

using namespace std;
using ll = long long;

#define ve vector
#define vll ve <ll>
#define look1(n) cerr << (#n) << ":" << n << "\n";
#define pb push_back
#define ft first
#define sd second



ve <ve < bool> > a;
string s;

ve <ll> tree;


void build(ll l, ll r, ll ind) {
	if (l == r) return;
	if (l == r - 1) {
		tree[ind] = l;
		return;
	}
	ll m = (l + r) / 2;
	build(l, m, ind * 2 + 1);
	build(m, r, ind * 2 + 2);
	if (s[tree[ind * 2 + 1]] <= s[tree[ind * 2 + 2]]) {
		tree[ind] = tree[ind * 2 + 1];
	}
	else {
		tree[ind] = tree[ind * 2 + 2];
	}
}

ll get_min(ll l, ll r, ll ind, ll ql, ll qr) {
	if (l >= qr || ql >= r) return 1e9;
	if (ql <= l && qr >= r) {
		return tree[ind];
	}
	ll m = (l + r) / 2;
	ll cnt1 = get_min(l, m, ind * 2 + 1, ql, qr), cnt2 = get_min(m, r, ind * 2 + 2, ql, qr);
	if (cnt1 == 1e9) {
		return cnt2;
	}
	if (cnt2 == 1e9) {
		return cnt1;
	}
	if (s[cnt1] <= s[cnt2]) return cnt1;
	return cnt2;
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll k, n;
	cin >> k >> n;
	a.resize(k, ve <bool>(k));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			char l;
			cin >> l;
			a[i][j] = (l == '1');
		}
	}
	string ans;
	cin >> s;
	stack <ll> inds;
	++n;
	tree.resize(n * 4, n - 1);
	build(0, n, 0);
	s += '$';
	vll last(n);
	vll pr(n, n - 1);
	for (int i = n - 1; i >= 0; --i) {
		if (inds.empty()) {
			inds.push(i);
			last[i] = n;
		}
		else {
			while (s[inds.top()] != '$' && a[s[i] - 'a'][s[inds.top()] - 'a']) {
				if (s[pr[i]] > s[pr[inds.top()]]) {
					pr[i] = pr[inds.top()];
				}
				inds.pop();
			}
			last[i] = inds.top();
			inds.push(i);
		}
	}
	/*for (int i = 0; i < 4 * n; ++i) {
		cout << tree[i] << " ";
	}*/
	ll ind = 0;
	while (s[ind] != '$') {
		ans += s[ind];
		//look1(t);
		/*for (int i = ind + 1; i <= last[ind]; ++i) {
			if (t > s[i]) {
				id = i;
				t = s[i];
			}
		}*/
		//look1(ind);
		//look1(id);

		//look1(ind);
		ind = get_min(0, n, 0, ind + 1, last[ind] + 1);
	}
	cout << ans;
	return 0;
}



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll k, n;
	cin >> k >> n;
	if (n <= 20) {
		a.resize(k, ve <bool>(k));
		for (int i = 0; i < k; ++i) {
			for (int j = 0; j < k; ++j) {
				char l;
				cin >> l;
				a[i][j] = (l == '1');
			}
		}
		cin >> s;
		string ans = "}";
		for (int mask = 0; mask < (1 << (n - 1)); ++mask) {
			vll h;
			h.pb(0);
			string t;
			t += s[0];
			for (int i = 0; i < n - 1; ++i) {
				if ((mask >> i) & 1) {
					h.pb(i + 1);
					t += s[i + 1];
				}
			}
			h.pb(n);
			bool f = true;
			for (int i = 1; i < h.size(); ++i) {
				stack <ll> w;
				for (int j = h[i] - 1; j >= h[i - 1]; --j) {
					if (w.empty()) {
						w.push(j);
					}
					else {
						while (!w.empty() && a[s[j] - 'a'][s[w.top()] - 'a']) {
							w.pop();
						}
						w.push(j);
					}
				}
				if (w.size() != 1) {
					f = false;
				}
			}
			if (f) {
				ans = min(ans, t);
			}
		}
		cout << ans;
	}
	else {
		a.resize(k, ve <bool>(k));
		for (int i = 0; i < k; ++i) {
			for (int j = 0; j < k; ++j) {
				char l;
				cin >> l;
				a[i][j] = (l == '1');
			}
		}
		string ans;
		cin >> s;
		stack <ll> inds;
		++n;
		tree.resize(n * 4, n - 1);
		build(0, n, 0);
		s += '$';
		vll last(n);
		vll pr(n, n - 1);
		for (int i = n - 1; i >= 0; --i) {
			if (inds.empty()) {
				inds.push(i);
				last[i] = n;
			}
			else {
				while (s[inds.top()] != '$' && a[s[i] - 'a'][s[inds.top()] - 'a']) {
					if (s[pr[i]] > s[pr[inds.top()]]) {
						pr[i] = pr[inds.top()];
					}
					inds.pop();
				}
				last[i] = inds.top();
				inds.push(i);
			}
		}
		/*for (int i = 0; i < 4 * n; ++i) {
			cout << tree[i] << " ";
		}*/
		ll ind = 0;
		while (s[ind] != '$') {
			ans += s[ind];
			//look1(t);
			/*for (int i = ind + 1; i <= last[ind]; ++i) {
				if (t > s[i]) {
					id = i;
					t = s[i];
				}
			}*/
			//look1(ind);
			//look1(id);

			//look1(ind);
			ind = get_min(0, n, 0, ind + 1, last[ind] + 1);
		}
		cout << ans;
	}
	return 0;
}
