#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

bool field[50][50];
int prefsum[50][50];

void recalc(int n) {
    for (int i = n; i >= 1; i--) {
        for (int j = n; j >= 1; j--) {
            prefsum[i][j] = (int)field[i][j] + prefsum[i + 1][j] + prefsum[i][j + 1] - prefsum[i + 1][j + 1];
        }
    }
}

inline int free(int n, int i, int j) {
    return (n - i + 1) * (n - j + 1) - prefsum[i][j];
}

void make(int i, int j, int n) {
    for (int x = n; x >= i; x--) {
        for (int y = n; y >= j; y--) field[x][y] = 1;
    }
}

void solve1() {
    int n, k, m;
    cin >> n >> k >> m;

    string s;
    cin >> s;

    int pref = 0;
    int curr = 0;
    while (true) {
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++) {
                field[i][j] = 0;
            }
        }

        recalc(n);
        if (curr == 0 && pref == m) {
            cout << 0 << endl;
            return;
        }

        if (curr == 1) {
            int x, y;
            cin >> x >> y;
            make(x, y, n);
            recalc(n);
        }

        while (true) {
            int whx = -1, why = -1, mn = 1000000;
            vector<pii> ao;
            for (int i = n; i >= 1; i--) {
                for (int j = n; j >= 1; j--) {
                    if (field[i][j] == 0 && (pref == m || i % 4 == ((s[pref] - '0') * 2 + (s[pref + 1] - '0')) && j % 8 == (s[pref + 2] - '0') * 4 + (s[pref + 3] - '0') * 2 + s[pref + 4] - '0')) {
                        if (mn > free(n, i, j)) {
                            mn = free(n, i, j);
                            ao = {};
                        }

                        if (mn == free(n, i, j)) {
                            ao.push_back({i, j});
                        }
                    }
                }
            }

            //of << "\t" << pref << ' '<< s[pref] << ' ' << whx << ' '<< why << endl;

            if (ao.size()) {
            int t = randlr(0, ao.size() - 1);
            whx = ao[t].x;
            why = ao[t].y;
            }

            if (whx == -1) {
                whx = 1;
                why = 1;
            }

            if (whx == 1 && why == 1) {
                cout << 1 << ' ' << 1 << endl;
                break;
            }

            cout << whx << ' ' << why << endl;
            pref+=4;
            pref = min(pref, m);
            int a, b;
            cin >> a >> b;

            if (a == 1 && b == 1) {
                break;
            }

            make(a, b, n);
            make(whx, why, n);
            recalc(n);
        }

        curr = 1 - curr;
    }
}

void solve2() {
    int n, k, m;
    cin >> n >> k >> m;

    string answ = "";

    int games;
    cin >> games;

    for (int xx = 0; xx < games; xx++) {
        int i = 0;
        while (true) {
            int x, y;
            cin >> x >> y;
            if (i % 2 == xx % 2) {
                if (x == 1 && y == 1) break;
                auto ret = x;
                if (answ.size() < m) {
                    answ += (x % 4) / 2 + '0';
                    answ += (x % 4) % 2 + '0';
                    answ += (y % 8) / 4 + '0';
                    answ += (y % 4) / 2 + '0';
                    answ += (y % 8) % 2 + '0';
                }
            }

            i++;
            if (x == 1 && y == 1) break;

            make(x, y, n);
            recalc(n);
        }

        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++) field[i][j] = 0;
        }

        recalc(n);
    }

    cout << answ << endl;
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile


   // freopen("\\\\.\\pipe\\game.in", "r", stdin);
//freopen("\\\\.\\pipe\\game.out", "w", stdout);
    #endif // localfile

    int ttt;
    cin >> ttt;

    if (ttt == 1) {
        solve1();
    }

    else {
        solve2();
    }

    return 0;
}
