#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using namespace  std;

//#define int long long
const int INF = 1e9;
string inf;

struct e{
    int l, r;
    string s;
};
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> mat(k, vector<bool>(k, false));
    for (int i =0 ; i < n ;i++){
        char xx = 'a' + 28;
        inf += xx;
    }
    for (int i =0; i < k; i++){
        for (int j =0 ; j < k; j++){
            char x;
            cin >> x;
            if (x == '1'){
                mat[i][j] = true;
            }
        }
    }
    string s;
    cin >> s;
    s += ' ';
    vector<int> pos(n, -1);
    vector<string>dp(n + 1, "");
    for (int i =0; i < n; i++){
        stack<int> cur;
        cur.push(s[i] - 'a');
        for (int j = i + 1; j < n; j++) {
            while (!cur.empty() && !mat[cur.top()][s[j] - 'a']) {
                cur.pop();
            }
            pos[i] = j;
            if (cur.empty()) {
                break;
            }
            cur.push(s[j] - 'a');
        }
        if (!cur.empty()){
            pos[i] = n;
        }
    }
    dp[n - 1] = "";
    dp[n - 1] += s[n - 1];
    //cout << pos[0] << " ";
    vector<e> cur;
    cur.push_back({n - 1, n - 1, dp[n - 1]});
    for (int i = n -2; i >= 0; i--){
        int l = i, r = i;
        string ss = dp[i + 1];
        while (!cur.empty() && mat[s[r] - 'a'][s[cur.back().l] - 'a']){
            r = cur.back().r;
            ss = min(ss, cur.back().s);
            cur.pop_back();
        }
        cur.push_back({l, r, ss});
        dp[i] += s[i];
        dp[i].append(ss);
        if (pos[i] == n){
            dp[i] = s[i];
        }
//        cerr << dp[i] << '\n';
    }
    cout << dp[0];
    return 0;
}
