#include <bits/stdc++.h>
#define int long long

using namespace std;

int n;
vector <vector <int> > g;
vector <bool> used;
vector <int> ans;

void topsort(int v)
{
    used[v] = true;
    for (auto u : g[v])
    {
        if (!used[u])
        {
            topsort(u);
        }
    }
    if (v < n)
    {
        ans.push_back(v + 1);
    }
}

ostream &operator<<(ostream& out, vector <int> a)
{
    for (auto x : a)
    {
        out << x << " ";
    }
    return out;
}

int32_t main()
{
    int m;
    string s;
    cin >> n >> m >> s;
    vector <vector <pair <int, char> > > cards;
    for (int i = 0; i < n; i++)
    {
        int k;
        cin >> k;
        vector <pair <int, char> > card;
        for (int j = 0; j < k; j++)
        {
            int a;
            char c;
            cin >> a >> c;
            card.push_back(make_pair(a - 1, c));
        }
        cards.push_back(card);
    }
    vector <int> temp;
    g.assign(n + m, temp);
    for (int i = 0; i < n; i++)
    {
        vector <pair <int, char> > card = cards[i];
        int k = card.size();
        for (int j = 0; j < k; j++)
        {
            int a = card[j].first;
            char c = card[j].second;
            if (s[a] == c)
            {
                g[i].push_back(a + n);
            }
            else
            {
                g[a + n].push_back(i);
            }
        }
    }
    used.assign(n + m, false);
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            topsort(i);
        }
    }
    reverse(ans.begin(), ans.end());
    vector <bool> closed(m, false);
    bool check = true;
    for (int i = 0; i < n; i++)
    {
        vector <pair <int, char> > card = cards[ans[i] - 1];
        int k = card.size();
        for (auto t : card)
        {
            int a = t.first;
            char c = t.second;
            if (!closed[a])
            {
                if (s[a] == c)
                {
                    closed[a] = true;
                }
                else
                {
                    check = false;
                    break;
                }
            }
        }
    }
    for (int i = 0; i < m; i++)
    {
        check = check && closed[i];
    }
    if (check)
    {
        cout << ans;
    }
    else
    {
        cout << -1;
    }

    return 0;
}
/*
1 1
a
1 1 a

3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f

2 2
aa
2 1 a 2 b
2 1 b 2 a

2 2
aa
2 1 a 2 b
1 1 b

2 2
aa
2 1 a 2 b
1 2 a

2 2
aa
0
0

2 2
aa
1 1 a
0

2 1
a
1 1 a
0

1 2
aa
2 1 a 2 b

4 2
aa
1 1 b
1 1 a
1 2 b
1 2 a
*/
