#include <bits/stdc++.h>
using namespace std;

//#define int long long
#define F first
#define S second
#define mp make_pair
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), x.end()
#ifdef MY
    #define endl '\n'
#endif // MY

typedef long long ll;
typedef pair <int, int> pii;
mt19937 rnd(2007);
const int N = 32;
int dp[N][N];
int n;
string s;

int sum(int x, int y, int x1, int y1) {
    int s = 0;
    for (int i = x; i < x1; i++) {
        for (int j = y; j < y1; j++) {
            if (dp[i][j] == 0) {
                s++;
            }
        }
    }
    return s;
}

int sum(int x, int y) {
    int x1 = x, y1 = y;
    while (x1 < n && dp[x1][y] == 0) {
        x1++;
    }
    while (y1 < n && dp[x][y1] == 0) {
        y1++;
    }
    return sum(x, y, x1, y1);
}

bool ok(int x, int y, int p) {
    return p == sum(x, y);
}

void upd(pii p) {
    for (int i = p.F; i < n; i++) {
        for (int j = p.S; j < n; j++) {
            if (dp[i][j]) {
                break;
            }
            dp[i][j] = 1;
        }
    }
}

pii ask() {
    pii p;
    cin >> p.F >> p.S;
    p.F--, p.S--;
    upd(p);
    return p;
}

pii print(pii p) {
    cout << p.F + 1 << ' ' << p.S + 1 << endl;
    upd(p);
    pii q = ask();
    return q;
}

void clrdp() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            dp[i][j] = 0;
        }
    }
}

void game(int& i, bool fl) {

    if (fl) {
        ask();
    }
    int ind;
    for (ind = i; ind < min(sz(s), i + 100); ind += 2) {
        int p = 0;
        for (int j = i; j < min(sz(s), i + 2); j++) {
            p <<= 1;
            p |= (s[j] == '1');
        }
        vector < pii > pos;
        for (int x = 0; x < n; x++) {
            for (int y = 0; y < n; y++) {
                if (ok(x, y, p) && x + y > 0) {
                    pos.pb({x, y});
                }
            }
        }
        if (sz(pos) == 0) {
            assert(0);
        }
        int t = rnd() % sz(pos);
        print(pos[p]);
    }
    i = ind;
    if (dp[0][0]) {
        return;
    }
    if (dp[0][1] == 0) {
        if (print({0, 1}) == mp(0, 0)) {
            return;
        }
        if (!dp[1][0]) {
            print({1, 0});
        } else {
            print({0, 0});
        }
    } else if (dp[1][0] == 0) {
        if (print({1, 0}) == mp(0, 0)) {
            return;
        }
        if (!dp[0][1]) {
            print({0, 1});
        } else {
            print({0, 0});
        }
    } else {
        print({0, 0});
    }
}

void first() {
    int k, m;
    cin >> n >> k >> m;
    cin >> s;
    int cnt = 0;
    bool fl = 0;
    for (int i = 0; i < sz(s);) {
        game(i, fl);
        fl = 1 - fl;
    }
    cout << 0 << endl;
}

string ans;

vector < string > f = {"00", "01", "10", "11"};

void cnt(vector < pii > cur, int t) {
    int ss = 200;
    for (int i = 0; i < sz(cur); i++) {
        pii q = cur[i];
        if (ss) {
            if (i % 2 == t) {
                ans += f[sum(q.F, q.S)];
                ss -= 2;
            }
        } else {
            break;
        }
        upd(q);
    }
}

void second() {
    int k, m;
    cin >> n >> k >> m;
    int q;
    cin >> q;
    vector < pii > cur;
    for (int i = 0; i < q; i++) {
        int t = 0;
        pii p;
        cin >> p.F >> p.S;
        p.F--, p.S--;
        cur.pb(p);
        if (p == mp(0, 0)) {
            cnt(cur, t);
            cur.clear();
            clrdp();
            t = 1 - t;
        }
    }
    cout << ans;
}

int main() {
#ifdef MY
//    freopen("f.in", "r", stdin);
//    freopen("f.out", "w", stdout);
#endif // MY
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
    int t;
    cin >> t;
    if (t == 1) {
        first();
    } else {
        second();
    }
    return 0;
}
