#include "bits/stdc++.h"

using namespace std;

#define fi first
#define se second

int n, m;
string s;

vector<set<int>> blocked, add;

bool cmp(int a, int b) {
    bool tr1 = false, tr2 = false;
    for(auto x: blocked[b]) {
        //cout << x << '\n';
        if(!blocked[a].count(x)) {
            tr1 = true;
            break;
        }
    }
    //cout << "\n\n";
    for(auto x: blocked[a]) {
        //cout << x << "\n";
        if(!blocked[b].count(x)) {
            tr2 = true;
            break;
        }
    }

    //cout << tr1 << ' ' << tr2 << '\n';
    if(tr1 && !tr2) return true;
    return false;
}

bool check(vector<int> &ans) {
    bool tr = false;
    for(int pos = 0; pos < m; ++pos) {
        tr = false;
        for(int i = 0; i < n; ++i) {
            if(!add[ans[i]].count(pos) && !blocked[ans[i]].count(pos)) continue;
            if(add[ans[i]].count(pos)) {
                tr = true;
            }
            break;
        }
        if(!tr) break;
    }
    return tr;
}

int main() {
    cin >> n >> m;
    cin >> s;


    blocked.resize(n);
    add.resize(n);

    for(int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for(int j = 0; j < k; ++j) {
            int pos;
            char x;
            cin >> pos >> x;
            --pos;
            if(s[pos] != x) {
                blocked[i].insert(pos);
            }else{
                add[i].insert(pos);
            }
        }
    }

    vector<int> ans(n);
    for(int i = 0; i < n; ++i) ans[i] = i;
    //cout << cmp(2, 0) << '\n';
    //return 0;
    sort(ans.begin(), ans.end(), cmp);

    if(check(ans))
        for(int i = 0; i < n; ++i) cout << ans[i] + 1 << ' ';
    else
        cout << -1;

    return 0;
}
/*
3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f

*/