#include "bits/stdc++.h"

using namespace std;

#define fi first
#define se second

int n, m;
string s;

vector<vector<pair<int, char>>> a;

vector<int> ans;

char find(int pos, int i) {
    if(a[i].size() == 0) return 0;
    int l = 0, r = a[i].size();
    while(r - l > 1) {
        int mid = (l + r) / 2;
        if(a[i][mid].fi > pos) {
            r = mid;
        }else{
            l = mid;
        }
    }
    if(a[i][l].fi == pos) {
        return a[i][l].se;
    }else{
        return 0;
    }
}

int curpos;

bool cmp(int x, int y) {
    char v1 = find(curpos, x), v2 = find(curpos, y);
    if(v1 == v2) return false;

    if(v1 == 0) return true;
    if(v2 == 0) return false;

    if(s[curpos] == v1) return true;
    if(s[curpos] == v2) return false;

    return x < y;
}

void solve(int pos, int l, int r) {
/*
    cout << pos << ' ' << l << ' ' << r << '\n';
    for(int i = 0; i < n; ++i) cout << ans[i] << ' ';
    cout << '\n';
    cout << '\n';
    */
    //cout << "nice";
    if(l >= r) return;
    curpos = pos;
    sort(ans.begin() + l, ans.begin() + r, cmp);

    int s_ = l, e = r;
    while(e - s_ > 1) {
        int mid = (e + s_) / 2;
        char x = find(pos, ans[mid]);
        if(x == 0 || x == s[pos]) {
            s_ = mid;
        }else{
            e = mid;
        }
    }
    //cout << "X: " << (int)x << ' ' << pos << ' ' << ans[s_] << '\n';
    if(pos == s.length() - 1) return;
    solve(pos + 1, l, s_ + 1);
    solve(pos + 1, s_ + 1, r);
}

bool check(vector<int> &ans) {
    bool tr = false;
    for(int pos = 0; pos < m; ++pos) {
        tr = false;
        for(int i = 0; i < n; ++i) {
            char x = find(pos, ans[i]);
            if(x == 0) continue;
            if(x == s[pos]) {
                tr = true;
            }
            break;
        }
        if(!tr) break;
    }
    return tr;
}

int main() {
    cin >> n >> m;
    cin >> s;

    a.resize(n);
    vector<bool> can(m, false);
    for(int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        for(int j = 0; j < k; ++j) {
            int pos;
            char x;
            cin >> pos >> x;
            a[i][j] = {pos - 1, x};
            if(s[pos - 1] == x) can[pos - 1] = true;
        }
    }

    for(int i = 0; i < m; ++i) {
        if(!can[i]) {
            cout << -1;
            return 0;
        }
    }

    ans.resize(n);
    for(int i = 0; i < n; ++i) ans[i] = i;
    solve(0, 0, n);
    if(check(ans)) {
        for(int i = 0; i < n; ++i) {
            cout << ans[i] + 1 << ' ';
        }
        return 0;
    }
    /*
    while(next_permutation(ans.begin(), ans.end())) {
        if(check(ans)) {
            for(int i = 0; i < n; ++i) {
                cout << ans[i] + 1 << ' ';
            }
            return 0;
        }
    }*/

    cout << -1;

    return 0;
}
/*
2 2
aa
2 1 a 2 b
2 1 b 2 a

*/