#include <bits/stdc++.h>

using namespace std;

bool check(string a, string b) {
    for (int i = 0; i < min(a.size(), b.size()); i++) {
        if (a[i] != b[i]) {
            return a[i] > b[i];
        }
    }
    return a.size() > b.size();
}

int main() {
    //freopen("input.txt", "r", stdin);
    int k, n;
    cin >> k >> n;
    vector < vector < bool > > can(k, vector < bool >(k, 0));
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char x;
            cin >> x;
            can[i][j] = x - '0';
        }
    }
    string s;
    cin >> s;
    vector < vector < bool > > del(n, vector < bool >(n, 0));
    for (int i = 0; i < n; i++) {
        del[i][i] = 1;
    }
    for (int len = 2; len <= n; len++) {
        for (int l = 0; l + len - 1 < n; l++) {
            int r = l + len - 1;
            for (int j = l + 1; j <= r; j++) {
                if (del[l][j - 1] == 1 && del[j][r] == 1 && can[s[l] - 'a'][s[j] - 'a'] == 1) {
                    del[l][r] = 1;
                }
            }
        }
    }
    vector < string > dp(n, "");
    dp[0].push_back(s[0]);
    for (int i = 1; i < n; i++) {
        dp[i] = dp[i - 1];
        for (int j = i - 2; j >= 0; j--) {
            if (del[j][i - 1] && check(dp[i], dp[j])) {
                dp[i] = dp[j];
            }
        }
        dp[i].push_back(s[i]);
    }
    string ans = s;
    for (int i = 0; i < n; i++) {
        if (del[i][n - 1] && check(ans, dp[i])) {
            ans = dp[i];
        }
    }
    if (ans.size() > n) {
        assert(0);
    }
    cout << ans;
    return 0;
}
