#define CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <numeric>
#include <map>
#include <cassert>
#include <unordered_set>
#include <queue>
#include <deque>
#include <unordered_map>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <chrono>
#include <random>
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;
#define sp system("pause")
#define fastio() ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define pbc push_back
#define pob pop_back()
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define vin(v) for(auto&i:v)cin>>i;
#define vout(v,c) for(auto&i:v)cout<<i<<c;
#define rev(x) reverse(all(x))
#define mp make_pair
vector<vector<int>> used;
int cnt[33][33];
bool ok(int x, int y)
{
	return x >= 0 && y >= 0 && x < 32 && y < 32;
}
set<pair<int, int>> two;
set<pair<int, int>> one;
set<pair<int, int>> unite;
void paint(int x, int y)
{
	two.erase({ x,y });
	one.erase({ x,y });
	unite.erase({ x,y });
	for (int i = x; i < used.size(); ++i)
	{
		if (used[i][y])break;
		for (int j = y; j < used[x].size(); ++j)
		{
			if (used[i][j])break;
			used[i][j] = 1;
			cnt[i][j] = 12312312;
			two.erase({ i,j });
			one.erase({ i,j });
			unite.erase({ i,j });
		//	cnt[i][j]++;
			for (int ti = i - 2; ti <= i; ++ti)
			{
				for (int tj = j - 2; tj <= j; ++tj)
				{
					if (ok(ti, tj))
					{
						++cnt[ti][tj];
						if (cnt[ti][tj] == 7) two.insert({ ti,tj }), unite.insert({ ti,tj });
						else if (cnt[ti][tj] == 8)
						{
							two.erase({ ti,tj });
							one.insert({ ti,tj });
						}
						else if (cnt[ti][tj] == 9)
						{
							one.erase({ ti,tj });
							unite.erase({ ti,tj });
						}
					}
				}
			}
		}
	}
}
const int gao = 200;
signed main()
{
	fastio();
	int x;
	cin >> x;
	int n, k, m;
	cin >> n >> k >> m;
	if (x == 2)
	{
		int x;
		cin >> x;
		string ans = "";
		for (int i = 0; i < x; ++i)
		{
			int f, s;
			two.clear();
			one.clear();
			unite.clear();
			used = vector<vector<int>>(n, vector<int>(n));
			for (int ti = 0; ti < n; ++ti) for (int tj = 0; tj < n; ++tj) cnt[ti][tj] = 0;
			for (int ti = 0; ti < n; ++ti)
			{
				for (int tj = 0; tj < n; ++tj)
				{
					for (int x = ti; x < ti + 3; ++x)
					{
						for (int y = tj; y < tj + 3; ++y)
						{
							if (!ok(x, y)) cnt[ti][tj]++;
							if (cnt[ti][tj] == 7) two.insert({ ti,tj }), unite.insert({ ti,tj });
							else if (cnt[ti][tj] == 8)
							{
								two.erase({ ti,tj });
								one.insert({ ti,tj });
							}
							else if (cnt[ti][tj] == 9)
							{
								one.erase({ ti,tj });
								unite.erase({ ti,tj });
							}

						}
					}
				}
			}
			vector<pair<int, int>> our;
			vector<pair<int, int>> his;
			int parity = i % 2;
			string add = "";
			while (cin >> f >> s)
			{
				f--; s--;
				if (parity)
				{
					his.pbc({ f,s });
					paint(f,s);
				}
				else
				{
					our.pbc({ f,s });

					if (unite.size() >= 8)
					{
						if (f == 0 && s == 0)
						{
							break;
						}
						pair<int, int> nww = { f,s };
						int id = 0;
						for (auto sx = unite.begin();; ++sx)
						{
							if (*sx == nww) break;
							id++;
						//	if (id > 3) assert(0);
						}
						for (int pw = 2; pw >= 0; --pw)
						{
							if (add.size() + ans.size() == m)break;
							if (id >= (1 << pw)) add += '1';
							else add += '0';
						}
						paint(f, s);
					}
					else
					{
						if (cnt[f][s] == 7)
						{
							add += "1";
						}
						else if (cnt[f][s] == 8)
						{
							if (mp(f, s) == *one.begin()) add += "0";
							else add += "1";
						}
						paint(f, s);
					}
				}
				parity ^= 1;
				if (f == 0 && s == 0) break;
			}
			ans += add;
		}
		cout << ans << endl;
	}
	else
	{
		string s;
		cin >> s;
		string say = "";
		int it = 0;
		int games = 0;
		for (int gmid = 0; gmid < s.size(); ++gmid)
		{
			++games;
			two.clear();
			unite.clear();
			one.clear();
			if (say.size() >= s.size()) break;
			used = vector<vector<int>>(n, vector<int>(n, 0));
			for (int ti = 0; ti < n; ++ti) for (int tj = 0; tj < n; ++tj) cnt[ti][tj] = 0;
			for (int ti = 0; ti < n; ++ti)
			{
				for (int tj = 0; tj < n; ++tj)
				{
					for (int x = ti; x < ti + 3; ++x)
					{
						for (int y = tj; y < tj + 3; ++y)
						{
							if (!ok(x, y)) cnt[ti][tj]++;
							

						}
					}
					if (cnt[ti][tj] == 7) two.insert({ ti,tj }), unite.insert({ ti,tj });
					else if (cnt[ti][tj] == 8)
					{
						two.erase({ ti,tj });
						one.insert({ ti,tj });
					}
					else if (cnt[ti][tj] == 9)
					{
						one.erase({ ti,tj });
						unite.erase({ ti,tj });
					}
				}
			}
			if (gmid % 2)
			{
				int x, y;
				cin >> x >> y;
				x--; y--;
				paint(x, y);

			}
			int rofl = 0;
			while (1)
			{
				bool ok = 1;
				pair<int, int> go;
				if (it >= s.size() || rofl>=gao)
				{
					cout << 1 << ' ' << 1 << endl;
					break;
				}
				if (unite.size() >= 8)
				{
					int ids = 0;
					int pw = 2;
					int td = 0;
					for (int i = it; i < s.size() && i < it + 3; ++i)
					{
						if (s[i] == '1') ids += (1 << pw);
						++rofl;
						pw--;
						td++;
					}
					it += td;
					pair<int, int> fs;
					auto sx = unite.begin();
					while (ids--)
					{
						sx++;
					}
					fs = *sx;
					cout << fs.first + 1 << ' ' << fs.second + 1 << endl;
					paint(fs.first, fs.second);
					/*if (it == s.size() - 1)
					{
						if (s[it] == '1')
						{
							pair<int, int> fs = *(++(++two.begin()));
							cout << fs.first + 1 << ' ' << fs.second + 1 << endl;
							paint(fs.first, fs.second);
							++it;
							++rofl;
						}
						else
						{
							pair<int, int> fs = *(two.begin());
							cout << fs.first + 1 << ' ' << fs.second + 1 << endl;
							paint(fs.first, fs.second);
							++it;
							++rofl;
						}
						say += "0";
					}
					else
					{
						int id = 2 * (int)(s[it] == '1') + (int)(s[it + 1] == '1');
						pair<int, int> fs;
						auto sx = two.begin();
						while (id--)
						{
							++sx;
						}
						fs = *sx;
						cout << fs.first + 1 << ' ' << fs.second + 1 << endl;
						paint(fs.first, fs.second);
						it+=2;
						say += "00";
						rofl += 2;
					}*/
					cin >> go.first >> go.second;
					if (go == mp(1, 1)) break;
					paint(go.first - 1, go.second - 1);
					continue;
				}
				if (s[it] == '1')
				{
					say += "1";
					pair<int, int> fs;
					if (one.size() >= 2)
					{
						fs = *(++one.begin());
					}
					else
						fs = *two.begin();
					cout << fs.first + 1 << ' ' << fs.second + 1 << endl;
					paint(fs.first, fs.second);
					++it;
				}
				else
				{
					say += "0";
					auto fs = *one.begin();
					cout << fs.first + 1 << ' ' << fs.second + 1 << endl;
					paint(fs.first, fs.second);
					++it;
				}
				++rofl;
				cin >> go.first >> go.second;
				if (go == mp(1, 1)) break;
				paint(go.first - 1, go.second - 1);
			}
		}
		if (games % 2 == 0)
		{
			int x, y;
			cin >> x >> y; 
		}
		cout << 0 << endl;//
		return 0;
	}
	//  sp;
}