/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm,avx,avx2,popcnt")
*/

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <utility>
#include <functional>
#include <numeric>
#include <chrono>
#include <random>


#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto &x : a)
#define siz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define pb push_back
#define ppb pop_back()
#define mp make_pair
#define left left1337
#define right right1337


#ifdef LOCAL 
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

using namespace std;

template<typename T1, typename T2> inline void mine(T1 & x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 & x, const T2 &y) {if (x < y) x = y;}


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef string str;
typedef vector<str> vs;
typedef vector<vch> vvch;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 300;
const int K = 26;
const str INF = string(1, char('z' + 1));

str dp[N][N][K][K];
bool g[K][K];

str lol(const str & s) {
	str ss = s;
	fx(x, ss) x += 'a';
	return ss;
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k, n;
	cin >> k >> n;
	fi(0, k) {
		fj(0, k) {
			char x;
			cin >> x;
			g[i][j] = x - '0';
		}
	}
	str s;
	cin >> s;
	fx(x, s) x -= 'a';
	fi(0, n) fj(i, n) for (int c1 = 0; c1 < k; ++c1) for (int c2 = 0; c2 < k; ++c2) dp[i][j][c1][c2] = INF;
	fi(0, n) {
		dp[i][i][s[i]][s[i]] = string(1, s[i]);
	}
	for (int r = 1; r < n; ++r) {
		for (int l = r - 1; l >= 0; --l) {
			for (int m = l; m < r; ++m) {
				for (int c1 = 0; c1 < k; ++c1) {
					for (int c2 = 0; c2 < k; ++c2) {
						for (int c3 = 0; c3 < k; ++c3) {
							for (int c4 = 0; c4 < k; ++c4) {
								if (dp[l][m][c1][c2] == INF || dp[m + 1][r][c3][c4] == INF) continue;
								mine(dp[l][r][c1][c4], dp[l][m][c1][c2] + dp[m + 1][r][c3][c4]);
								if (g[c2][c3]) {
									if (dp[m + 1][r][c3][c4].size() > 1) {
										if (dp[l][m][c1][c2] != INF && dp[m + 1][r][c3][c4].substr(1) != INF)
											mine(dp[l][r][c1][c4], dp[l][m][c1][c2] + dp[m + 1][r][c3][c4].substr(1));
									} else {
										if (dp[l][m][c1][c2] != INF)
											mine(dp[l][r][c1][c2], dp[l][m][c1][c2]);
									}
								}
							}
						}
					} 
				}
			}
			/*cout << l << ' ' << r << " : ";
			fi(0, k) fj(0, k) cout << lol(dp[l][r][i][j]) << ' ';
			cout << '\n';*/
		}
	}
	str ans = INF;
	fi(0, k) fj(0, k) mine(ans, dp[0][n - 1][i][j]);
	fx(x, ans) cout << char(x + 'a');
	cout << '\n';
}