#pragma GCC optimize("Ofast")

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <cstring>

using namespace std;

//const int MAX_MEM = 6e8;
//char mem[MAX_MEM];
//int m_pos = 0;
//
//void* operator new(size_t n) {
//    assert((m_pos += n) <= MAX_MEM);
//    return (void*) (mem + m_pos - n);
//}
//
//void operator delete(void*) noexcept {}

#define int long long
const int SZ = 1e5 + 4;

int x;
int n, m, k;
string s;

void read() {
    cin >> x >> n >> k >> m;
    if (x == 1) cin >> s;
}

int f[32][32];

void get() {
    int x, y;
    cin >> x >> y;
    --x, --y;

    for (int i = x; i < 32; ++i) {
        for (int j = y; j < 32; ++j) {
            f[i][j] = true;
        }
    }
}

int cnt = 0;

void move(int x, int y) {
    assert(!f[x][y]);
    cout << x + 1 << " " << y + 1 << endl;

    for (int i = x; i < 32; ++i) {
        for (int j = y; j < 32; ++j) {
            f[i][j] = true;
        }
    }
}

void play(bool z, bool w) {
    memset(f, 0, sizeof f);
    if (z) {
        get();
    }

    if (w) {
        move(0, 1);
        get();
        move(1, 0);
        get();
    } else {
        move(1, 0);
        get();
        move(0, 1);
        get();
    }
}

void solve() {
    if (x == 1) {
        bool z = false;
        for (int i = 0; i < m; ++i) {
            play(z, s[i] == '0');
            z ^= 1;
        }

        if (z) get();
        cout << 0 << endl;
    } else {
        int p;
        cin >> p;
        string ans;
        for (int i = 0; i < p; ++i) {
            while (true) {
                int x, y;
                cin >> x >> y;
                if (x == 1 && y == 1) {
                    break;
                }
                else if (x == 1 && y == 2) {
                    if (ans.size() == i) ans.push_back('0');
                } else if (x == 2 && y == 1) {
                    if (ans.size() == i) ans.push_back('1');
                }
            }
        }

        cout << ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}