#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>

#define int long long

using namespace std;

signed main(){
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<pair<int, char>>> v(n);
    vector<set<int>> banned(m);
    vector<int> banned_cnt(n);
    queue<int> q;
    for (int i = 0; i < n; ++i){
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j){
            int x;
            char a;
            cin >> x >> a;
            v[i].push_back({x - 1, a});
            if (s[x - 1] != a){
                banned[x - 1].insert(i);
                banned_cnt[i]++;
            }
        }
        if (banned_cnt[i] == 0){
            q.push(i);
        }
    }
    vector<int> used(m);
    vector<int> ans;
    for (int i = 0; i < n; ++i){
        if (q.size() == 0){
            cout << -1;
            return 0;
        }
        int j = q.front();
        //cout << j << endl;
        q.pop();
        for (auto c : v[j]){
            if (used[c.first] == 0){
                used[c.first] = 1;
                for (auto x : banned[c.first]){
                    banned_cnt[x]--;
                    if (banned_cnt[x] == 0){
                        q.push(x);
                    }
                }
            }
        }
        ans.push_back(j);

    }
    if (ans.size() != n){
        cout << -1;
        return 0;
    }
    for (int i = 0; i < m; ++i){
        if (used[i] == 0){
            cout << -1;
            return 0;
        }
    }
    for (int i = 0; i < ans.size(); ++i){
        cout << ans[i] + 1 << " ";
    }
    return 0;
}
/*
3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f



*/
