#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define out(x); { for (auto i : x) cout << i << ' '; cout << endl; }

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef vector <int> vi;

const int N = 6e5;

char a[26][26];
int tb[N][20];
int lg[N];

int get(int l, int r) {
    int lvl = lg[r - l];
    int ans = min(tb[l][lvl], tb[r - (1 << lvl)][lvl]);
    //cout << l << ' ' << r << ' ' << lvl << ' ' << ans << endl;
    return ans;
}

vi st[26];
int nxt[N];
string s;

bool _less(int i, int j) {
    if (i >= s.size())
        return true;
    if (j >= s.size())
        return false;
    if (s[i] < s[j])
        return true;
    if (s[j] < s[i])
        return false;
    return _less(nxt[i], nxt[j]);
}

void add(int i) {
    int c = s[i] - 'a';
    while (!st[c].empty()) {
        if (_less(i, st[c].back()))
            st[c].pop_back();
        else break;
    }
    st[c].pb(i);
}

void solve() {
    int n, k; cin >> k >> n;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            cin >> a[i][j];
            a[i][j] -= '0';
        }
    }

    cin >> s;
    vi l(n);
    vi r(n);
    vi q;
    for (int i = 1; i < n; i++) {
        if (a[s[i - 1] - 'a'][s[i] - 'a'])
            q.pb(i);
        l[i] = i - 1;
        r[i] = i + 1;
    }

    vi dt(n, -1), dl(n, -1);
    int t = 0;
    while (!q.empty()) {
        int i = q.back();
        q.pop_back();
        dt[i] = ++t;
        dl[i] = l[i];
        l[r[i]] = l[i];
        r[l[i]] = r[i];
        if (r[i] != n) {
            if (a[s[l[i]] - 'a'][s[r[i]] - 'a'])
                q.pb(r[i]);
        }
        /*for (int j = 0; j < n; j++) {
            if (dt[j] == -1)
                cout << s[j];
        }
        cout << endl;*/
    }

    //out(dt);
    //out(dl);

    for (int i = 2; i < N; i++)
        lg[i] = lg[i / 2] + 1;

    for (int i = 0; i < n; i++)
        tb[i][0] = dl[i];
    for (int d = 1; d < 20; d++) {
        for (int i = 0; i + (1 << d) <= n; i++)
            tb[i][d] = min(tb[i][d - 1], tb[i + (1 << (d - 1))][d - 1]);
    }

    for (int i = n - 1; i > -1; i--) {
        int l = i, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (/*get(i + 1, m + 1)*/0 < i)
                r = m;
            else
                l = m;
        }
        //cout << i << " " << l << endl;

        if (l == i) {
            nxt[i] = i + 1;
            //add(i);
            continue;
        }
        if (l == n - 1) {
            nxt[i] = n;
            //add(i);
            continue;
        }

        exit(0);

        for (int j = 0; j < k; j++) {
            if (!st[j].empty()) {
                if (st[j].back() > r) continue;
                int l2 = -1, r2 = st[j].size() - 1;
                while (r2 - l2 > 1) {
                    int m = (l2 + r2) / 2;
                    if (st[j][m] > r)
                        l2 = m;
                    else
                        r2 = m;
                }
                nxt[i] = st[j][r2];
                add(i);
                break;
            }
            if (j == k - 1) exit(0);
        }
    }

    for (int i = 0; i < n; i = nxt[i])
        cout << s[i];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    solve();
}
