#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <deque>
using namespace std;
#define int long long

void solve() {
	int k, n;
	cin >> k >> n;
	vector <vector <int>> able(k, vector <int>(k));
	for (int i = 0; i < k; ++i) {
		string tmp;
		cin >> tmp;
		for (int j = 0; j < k; ++j) {
			able[i][j] = (tmp[j] - '0');
		}
	}
	string s;
	cin >> s;
	vector <vector <int>> can(n, vector <int>(n));
	for (int len = 1; len <= n; ++len) {
		for (int l = 0; l + len <= n; ++l) {
			int r = l + len - 1;
			if (len == 1) {
				if (l != 0 && able[s[l - 1] - 'a'][s[l] - 'a']) {
					can[l][r] = 1;
				}
			}
			else {
				for (int k = max(0ll, l - 1); k < r; ++k) {
					bool ok = true;
					if (!able[s[k] - 'a'][s[r] - 'a']) ok = false;
					if (k < r - 1 && can[k + 1][r - 1] == 0) ok = false;
					if (k != l - 1 && can[l][k] == 0) ok = false;
					if (ok) can[l][r] = 1;
				}
			}
		}
	}
	vector <string> d(n);
	d[0] = s.substr(0, 1);
	for (int i = 1; i < n; ++i) {
		d[i] = s.substr(0, i + 1);
		for (int j = 0; j < i; ++j) {
			if (j != i - 1 && can[j + 1][i - 1] == 0) continue;
			string s2 = d[j] + s[i];
			if (s2 < d[i]) {
				d[i] = s2;
			}
		}
	}
	string ans = d.back();
	for (int i = 0; i + 1 < n; ++i) {
		if (can[i + 1][n - 1] && d[i] < ans) {
			ans = d[i];
		}
	}
	cout << ans;
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	while (test--) {
		solve();
	}
}