#pragma GCC optimze("Ofast")
#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << '\n';
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::

const int N = 1e5 + 3;

int n, mx[N], mn[N], dpmx[N], dpmn[N];
vector<int> leafs;
vector<int> ch[N], have[N];

bool dfs(int v) {
    bool ret = 1;
    vector<pair<int, int>> lines;
    for (int to : ch[v]) {
        ret &= dfs(to);
        relax(dpmn[v], dpmn[to]);
        strain(dpmx[v], dpmx[to]);
        lines.emplace_back(dpmn[to], dpmx[to]);
    }
    sort(lines.begin(), lines.end());
    for (int i = 0; i + 1 < lines.size(); ++i) {
        if (lines[i + 1].first <= lines[i].second)
            ret = 0;
    }
    return ret;
}

void rec(int i) {
    if (i == leafs.size()) {
        for (int i = 0; i < n; ++i) {
            dpmn[i] = 1e9;
            dpmx[i] = -1e9;
        }
        for (int x : leafs) {
            dpmn[x] = dpmx[x] = mn[x];
        }
        if (dfs(0)) {
            cout << "Yes\n";
//            errvn(dpmn, n);
//            errvn(dpmx, n);
            exit(0);
        }
    }
    else {
        for (int x : have[leafs[i]]) {
            mx[leafs[i]] = mn[leafs[i]] = x;
            rec(i + 1);
        }
    }
}

void solve() {
    cin >> n;

    for (int i = 0; i < n; ++i) {
        int type;
        cin >> type;

        if (type == 1) {
            int k;
            cin >> k;

            for (int j = 0; j < k; ++j) {
                int x;
                cin >> x;

                --x;
                ch[i].emplace_back(x);
            }
        }
        else {
            int k;
            cin >> k;

            leafs.emplace_back(i);
            for (int j = 0; j < k; ++j) {
                int x;
                cin >> x;

                have[i].emplace_back(x);
            }
        }
    }

    rec(0);
    cout << "No\n";
}

/*
3
1 2 2 3
2 1 1
2 1 2

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
*/

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();

    return 0;
}

