#pragma comment(linker, "/STACK:10000000000")
#pragma GCC oprimize("O3")
#pragma GCC oprimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

//const int MAX_MEM = 1e8;
//int mpos = 0;
//char mem[MAX_MEM];
//inline void * operator new (size_t n) {
//    assert((mpos += n) <= MAX_MEM);
//    return (void *) (mem + mpos - n);
//}
//inline void operator delete(void *) noexcept {}

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << '\n';
#define sqr(a) (a) * (a)

template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(6734043);

const int maxn = 20;

vi g[maxn];
vpi segm[maxn];

bool cmp(const pi &a, const pi &b) {
    if (a.y != b.y) return a.y < b.y;
    return a.x < b.x;
}

void dfs(int v) {
//    debug(v)
    for (auto u : g[v]) {
        dfs(u);
    }
    if (sz(g[v]) == 0) return;
    else if (sz(g[v]) == 1) {
        int u = g[v][0];
        swap(segm[v], segm[u]);
        return;
    }
    int u1 = g[v][0], u2 = g[v][1];
    for (int i = 0; i < sz(segm[u1]); i++) {
        for (int j = 0; j < sz(segm[u2]); j++) {
            if (segm[u2][j].x >= segm[u1][i].y) {
                segm[v].push_back({segm[u1][i].x, segm[u2][j].y});
//                break;
            }
        }
    }
    sort(all(segm[v]), cmp);
//    debug(v);
//    for (auto &el : segm[v]) {
//        debug(el.x << ' ' << el.y);
//    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

//    freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        int tp;
        cin >> tp;
        if (tp == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; j++) {
                int v;
                cin >> v;
                g[i].push_back(v);
            }
        } else {
            int k;
            cin >> k;
            for (int j = 0; j < k; j++) {
                int x;
                cin >> x;
                segm[i].push_back({x, x});
            }
            sort(all(segm[i]), cmp);
        }
    }
    dfs(1);
    if (sz(segm[1])) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }

    return 0;
}