#pragma comment(linker, "/STACK:10000000000")
#pragma GCC oprimize("O3")
#pragma GCC oprimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

//const int MAX_MEM = 1e8;
//int mpos = 0;
//char mem[MAX_MEM];
//inline void * operator new (size_t n) {
//    assert((mpos += n) <= MAX_MEM);
//    return (void *) (mem + mpos - n);
//}
//inline void operator delete(void *) noexcept {}

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << '\n';
#define sqr(a) (a) * (a)

template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(6734043);

const int maxn = 1e5 + 10;

vi g[maxn];
vc<pair<pi, pair<pi, pi>>> segm[maxn];
vi ans[maxn];

bool cmp(const pair<pi, pair<pi, pi>> &a, const pair<pi, pair<pi, pi>> &b) {
    if (a.x.y != b.x.y) return a.x.y < b.x.y;
    return a.x.x < b.x.x;
}

void dfs(int v) {
//    debug(v)
    for (auto u : g[v]) {
        dfs(u);
    }
    if (sz(g[v]) == 0) return;
    else if (sz(g[v]) == 1) {
        int u = g[v][0];
        swap(segm[v], segm[u]);
        return;
    }
    int u1 = g[v][0], u2 = g[v][1];
    for (int i = 0; i < sz(segm[u1]); i++) {
        for (int j = 0; j < sz(segm[u2]); j++) {
            if (segm[u2][j].x.x >= segm[u1][i].x.y) {
                segm[v].push_back({{segm[u1][i].x.x, segm[u2][j].x.y}, {{u1, i}, {u2, j}}});
                break;
            }
        }
    }
    swap(u1, u2);
    for (int i = 0; i < sz(segm[u1]); i++) {
        for (int j = 0; j < sz(segm[u2]); j++) {
            if (segm[u2][j].x.x >= segm[u1][i].x.y) {
                segm[v].push_back({{segm[u1][i].x.x, segm[u2][j].x.y}, {{u1, i}, {u2, j}}});
                break;
            }
        }
    }
    sort(all(segm[v]), cmp);
//    debug(v);
//    for (auto &el : segm[v]) {
//        debug(el.x << ' ' << el.y);
//    }
}

void get_ans(int v, int num) {
    if (sz(g[v]) == 0) {
        ans[v] = {segm[v][num].x.x};
    } else if (sz(g[v]) == 1) {
        int u = g[v][0];
        ans[v] = {u};
        swap(segm[u], segm[v]);
        get_ans(u, num);
    } else {
        int u1 = segm[v][num].y.x.x, u2 = segm[v][num].y.y.x;
        int num1 = segm[v][num].y.x.y, num2 = segm[v][num].y.y.y;
        ans[v] = {u1, u2};
        get_ans(u1, num1);
        get_ans(u2, num2);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        int tp;
        cin >> tp;
        if (tp == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; j++) {
                int v;
                cin >> v;
                g[i].push_back(v);
            }
        } else {
            int k;
            cin >> k;
            for (int j = 0; j < k; j++) {
                int x;
                cin >> x;
                segm[i].push_back({{x, x}, {{-1, -1}, {-1, -1}}});
            }
            sort(all(segm[i]), cmp);
        }
    }
    dfs(1);
    if (sz(segm[1])) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
        return 0;
    }
    int v = 1, best = 0;
    get_ans(v, best);
    for (int i = 1; i <= n; i++) {
//        debug(i);
        for (auto &el : ans[i]) cout << el << " ";
        cout << "\n";
    }


    return 0;
}