#include <bits/stdc++.h>

using namespace std;
#define endl "\n"

#define int long long
#define double long double

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif


vector<int> ob;
void pob(int v, const bool *is_m, vector<int> *ch, unsigned mask) {
    if (!is_m[v]) {
        ob.push_back(v);
        return;
    }
    if (ch[v].size() == 1) {
        pob(ch[v][0], is_m, ch, mask);
    }
    if (mask & (1 << v)) {
        pob(ch[v][1], is_m, ch, mask);
        pob(ch[v][0], is_m, ch, mask);
    } else {
        pob(ch[v][0], is_m, ch, mask);
        pob(ch[v][1], is_m, ch, mask);
    }
}

void solve() {
    int n;
    cin >> n;
    bool is_m[n];
    vector<int> ch[n];
    for (int i = 0; i < n; i++) {
        int type;
        cin >> type;
        is_m[i] = (type == 1);
        int k;
        cin >> k;
        ch[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> ch[i][j];
            ch[i][j]--;
        }

        if (!is_m[i]) {
            sort(ch[i].begin(), ch[i].end());
        }
    }

    for (unsigned mask = 0; mask < (1 << n); mask++) {
        ob.clear();
        pob(0, is_m, ch, mask);

        int curr = ch[ob[0]][0];
        bool ok = true;
        for (int i = 1; i < (int)ob.size(); i++) {
            auto lb = lower_bound(ch[ob[i]].begin(), ch[ob[i]].end(), curr);
            if (lb == ch[ob[i]].end()) {
                ok = false;
                break;
            }
            curr = *lb;
        }
        if (ok) {
            cout << "Yes\n";
            return;
        }
    }
    cout << "No\n";
}

int32_t main() {
#ifdef LOCAL
    fin.open("in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
