#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>
#include <random>

using namespace std;

const int N = 5001;

int used[N];
int x[N];
int h[N];

void solve(int l, int r) {
	for (int i = l; i <= r; i++) {
		used[i] = 0;
	}	
	int ans = 0;
	while (true) {
		int any = 0;
		{
			int mx = x[l - 1];
			for (int i = l; i <= r; i++) {
				if (!used[i] && mx <= x[i] - h[i]) {
					any = 1;
					ans++;
					used[i] = 1;
				}
				if (!used[i]) {
					mx = x[i];
				}
			}
		}
		{
			int mn = x[r + 1];
			for (int i = r; i >= l; i--) {
				if (!used[i] && x[i] + h[i] <= mn) {
					any = 1;
					ans++;
					used[i] = 1;
				}
				if (!used[i]) {
					mn = x[i];
				}
			}
		}
		if (!any) {
			break;
		}
	}
	cout << ans << '\n';
}

signed main() {

	int n, q;
	cin >> n >> q;
	for (int i = 1; i <= n; i++) {
		cin >> x[i] >> h[i];
	}
	x[0] = x[1];
	x[n + 1] = x[n];
	n += 2;
	while (q--) {
		int l, r;
		cin >> l >> r;
		solve(l, r);
	}
}