#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;


template <class T> bool ckmin(T &a,T b) { return b < a ? a=b, true : false;}
template <class T> bool ckmax(T &a,T b) { return a < b ? a=b, true : false;}

#define all(v) v.begin(),v.end()
#define sz(v) (int)v.size()
#define F first
#define S second
#define eb emplace_back
#define mt make_tuple


const int N = 25;
const int INF = INT_MAX >> 1;
const ll LINF = LLONG_MAX >> 1;

vector<tuple<int,int,int>> g[N];
ll ans[N];

int main(){
    ios::sync_with_stdio(0); cin.tie(0);
    int n,m; cin>>n>>m;
    for(int i=0;i<m;i++){
        int a,b,t; cin>>a>>b>>t;
        g[a].eb(b,t,i), g[b].eb(a,t,i);
    }
    for(int i=1;i<=n;i++) ans[i] = LINF;

    queue<tuple<int,int,int,int>> q;
    q.push({0,1,INF,0});

    while(!q.empty()){
        auto [mask,v,mn,mx] = q.front(); q.pop();
        // cout<<mask<<' '<<v<<' '<<mn<<' '<<mx<<endl;
        for(auto [b,t,id] : g[v]) if(!((mask>>id) & 1)){
            int cur = mask; cur |= 1<<id;
            int tmn = min(mn,t), tmx = max(mx,t);
            if(ckmin(ans[b],ll(tmn) + tmx)) q.push(mt(cur,b,tmn,tmx));

        }
    }
    for(int i=2;i<=n;i++) cout<<ans[i]<<'\n';
    return 0;
}


/*

3 3
1 2 100
1 3 100
2 3 1



7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9

*/
