#include <bits/stdc++.h>

using namespace std;
#define int long long
const int MX = 2e18;
vector<vector<pair<int, int> > > gr;
vector<int> used;
vector<int> ans;

void dfs(int v, int mn, int mx) {
    ans[v] = mn + mx;
    used[v] = 1;
    for (auto u: gr[v]) {
        if (!used[u.first]) {
            dfs(u.first, min(mn, u.second), max(mx, u.second));
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    used.resize(n);
    gr.resize(n);
    ans.resize(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        int t;
        cin >> t;
        gr[x].push_back({y, t});
        gr[y].push_back({x, t});
    }
    vector<int> dist(n, MX);
    dist[0] = 0;
    set<pair<int, int>> q;
    q.insert({0, 0});
    dist[0] = 0;
    while (!q.empty()) {
        pair<int, int> now = *q.begin();
        q.erase(now);
        ans[now.first] = now.second;
        for (auto u : gr[now.first]) {
            if (dist[u.first] > min(u.second, now.second)) {
                if (q.find({dist[u.first], u.first}) != q.end()) {
                    q.erase({dist[u.first], u.first});
                }
                dist[u.first] = min(u.second, now.second);
                q.insert({dist[u.first], u.first});
            }
        }
    }
    for (int i = 1; i < n; ++i)
        cout << ans[i] << "\n";
}
