#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define f first
#define s second
#define pb push_back

const int maxn = 300228, inf = 1e10;

int n, m;

vector<pair<int, int>> g[maxn], g2[maxn];

void solve1() {
    vector<int> mn(n, -1), mx(n, -1);
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto[u, t]: g[v]) {
            if (v == 0) {
                mn[u] = mx[u] = t;
                q.push(u);
            } else {
                if (mn[u] == -1) {
                    mn[u] = min(mn[v], t);
                    mx[u] = max(mx[v], t);
                    q.push(u);
                }
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << mn[i] + mx[i] << '\n';
    }
}

void solve2() {
    vector<int> mx(n, inf);
    set<pair<int, int>> s;
    mx[0] = 0;
    for (int i = 0; i < n; ++i) {
        s.insert({mx[i], i});
    }
    while (!s.empty()) {
        int v = s.begin()->s;
        s.erase(s.begin());
        for (auto[u, t]: g[v]) {
            if (mx[u] > max(mx[v], t)) {
                s.erase({mx[u], u});
                mx[u] = max(mx[v], t);
                s.insert({mx[u], u});
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << mx[i] << '\n';
    }
}

int t = 0;
int tin[maxn], up[maxn], c[maxn];
int mn[maxn], ans[maxn];
bool used[maxn];

void dfs(int v, int pr) {
    t++;
    tin[v] = t;
    for (auto[u, t1]: g[v]) {
        if (u != pr) {
            if (tin[u] == 0) {
                dfs(u, v);
            }
        }
    }
}

void dfs2(int v, int pr) {
    int cnt = 0;
    used[v] = 1;
    up[v] = tin[v];
    for (auto[u, t1]: g[v]) {
        if (used[u] == 0) {
            dfs(u, v);
        }
        if (u == pr) {
            cnt++;
        } else if (tin[u] > tin[v]) {
            up[v] = min(up[v], up[u]);
        } else {
            up[v] = min(up[v], tin[u]);
        }
    }
    if (cnt > 1) {
        up[v] = min(up[v], tin[pr]);
    }
}

void col(int v, int c1) {
    c[v] = c1;
    for (auto[u, t]: g[v]) {
        if (c[u] == 0 && up[u] <= tin[v]) {
            col(u, c1);
        }
    }
}

void get_ans(int v, int pr, int m1) {
    m1 = min(m1, mn[v]);
    ans[v] = m1;
    for (auto [u, t1]: g2[v]) {
        if (u != pr) {
            get_ans(u, v, min(m1, t1));
        }
    }
}

void solve3() {
    dfs(0, 0);
    dfs2(0, 0);
    int c1 = 0;
    for (int i = 0; i < n; ++i) {
        if (c[i] == 0) {
            c1++;
            col(i, c1);
        }
    }
    for (int i = 1; i <= c1; ++i) {
        mn[i] = inf;
    }
    for (int i = 0; i < n; ++i) {
        for (auto [j, t1]: g[i]) {
            if (c[i] == c[j]) {
                mn[c[i]] = min(mn[c[i]], t1);
            } else {
                g2[c[i]].pb({c[j], t1});
            }
        }
    }
    get_ans(1, 1, inf);
    for (int i = 1; i < n; ++i) {
        cout << ans[c[i]] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        u--, v--;
        g[u].pb({v, t});
        g[v].pb({u, t});
    }
    if (m == n - 1) {
        solve1();
        return 0;
    }
    bool f = 1;
    for (auto[u, t]: g[0]) {
        if (t != 0) {
            f = 0;
        }
    }
    if (f) {
        solve2();
        return 0;
    }
    solve3();
    return 0;
}