#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pii pair<int, int>
#define ff first
#define ss second

#define left left777
#define right right777
#define dist dist777
#define prev prev777
#define tm tm777

using namespace std;

mt19937 rnd(time(nullptr));

const ll INF = 1e18 + 10;
const int inf = 1e9 + 10, N = 3e5 + 10, P = 1e9 + 7, X = 2007;
vector<int> g[N];
int n, m, used[N];
map<pii, int> ed;
vector<vector<int> > ans;

pii dfs(int v, int pr) {
    used[v] = 1;
    int in = ed[{pr, v}], out = ed[{v, pr}];
    vector<int> sons_in, sons_out;
    for (int u : g[v]) {
        if (u != pr) {
            pii p = dfs(u, v);
            int f1 = p.ff, f2 = p.ss;
            if (f1) {
                sons_in.push_back(u);
            }
            if (f2) {
                sons_out.push_back(u);
            }
        }
    }
    /*cout << "! " << v << ' ' << pr << "\n";
    cout << "sons_in ";
    for (int elem : sons_in) {
        cout << elem << ' ';
    }
    cout << "\nsons_out ";
    for (int elem : sons_out) {
        cout << elem << ' ';
    }
    cout << "\n";*/
    int m1 = sons_in.size(), m2 = sons_out.size();
    for (int i = 0; i < min(m1, m2); i++) {
        int u1 = sons_in.back(), u2 = sons_out.back();
        ans.push_back({u2, v, v, u1});
        //cout << u2 << ' ' << v << ' ' << v << ' ' << u1 << "\n";
        sons_in.pop_back();
        sons_out.pop_back();
    }
    /*cout << "sons_in ";
    for (int elem : sons_in) {
        cout << elem << ' ';
    }*/
    /*cout << "\nsons_out ";
    for (int elem : sons_out) {
        cout << elem << ' ';
    }
    cout << "\n";*/
    if (m1 > m2) {
        for (int u : sons_in) {
            if (!in) {
                cout << "No\n";
                exit(0);
            }
            ans.push_back({pr, v, v, u});
            in = 0;
            //cout << pr << ' ' << v << ' ' << v << ' ' << u << "\n";
        }
    }
    if (m1 < m2) {
        for (int u : sons_out) {
            if (!out) {
                cout << "No\n";
                exit(0);
            }
            ans.push_back({u, v, v, pr});
            out = 0;
            //cout << u << ' ' << v << ' ' << v << ' ' << pr << "\n";
        }
    }
    //cout << "returned " << in << ' ' << out << ""
    return {in, out};
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        ed[{v, u}] = 1;
        if (!ed[{u, v}]) {
            g[v].push_back(u);
            g[u].push_back(v);
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, -1);
        }
    }
    cout << "Yes\n";
    for (vector<int> elem : ans) {
        for (int e : elem) {
            cout << e + 1 << ' ';
        }
        cout << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //freopen("input.txt", "r", stdin);

    //cout << setprecision(15) << fixed();
    solve();
    return 0;
}
