#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <random>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

using namespace std;
using ll = long long;
constexpr int MAXN = (int)3e5;
constexpr int INF = (int)2e9;
vector<pair<int, int>> g[MAXN];
int dist[MAXN];
bool used[MAXN];

void dfs(int v, int mint = INF, int maxt = -INF) {
	used[v] = true;
	dist[v] = maxt + mint;
	for (const auto &[to, t] : g[v]) {
		if (used[to])
			continue;
		dfs(to, min(mint, t), max(maxt, t));
	}
}

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;
	assert(m == n - 1);
	for (int i = 0; i < n; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		g[--u].emplace_back(--v, t);
		g[v].emplace_back(u, t);
	}

	dfs(0);

	for (int i = 1; i < n; ++i)
		cout << dist[i] << '\n';

	return 0;
}