#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;
#define cap(x) (x).size()
const int Al = 26, N = 3e5 + 10;
using ll = long long;
ll val[Al];
ll dp[Al][N];
int par[Al][N];
const ll inf = 3e18;
bool cmx(ll& x, ll y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
void solve() {
	string s;
	cin >> s;
	int n = cap(s);
	for (int i = 0; i <= n; i++)
		for (int j = 0; j < Al; j++)
			dp[j][i] = -inf;
	dp[0][n] = 0;
	for (int i = n - 1; i >= 0; i--) {
		if (s[i] != '?') {
			int y = s[i] - 'A';
			ll X = val[y];
			for (int mx = 0; mx < Al; mx++) {
				if (y < mx && cmx(dp[mx][i], dp[mx][i + 1] - X)) {
					par[mx][i] = mx;
				}
				else if (y >= mx && cmx(dp[y][i], dp[mx][i + 1] + X)) {
					par[y][i] = mx;
				}
			}
		}
		else {
			for (int y = 0; y < Al; y++) {
				ll X = val[y];
				for (int mx = 0; mx < Al; mx++) {
					if (y < mx && cmx(dp[mx][i], dp[mx][i + 1] - X)) {
						par[mx][i] = mx;
					}
					else if (y >= mx && cmx(dp[y][i], dp[mx][i + 1] + X)) {
						par[y][i] = mx;
					}
				}
			}
		}
	}
	ll ans = -inf;
	for (int i = 0; i < Al; i++) cmx(ans, dp[i][0]);
	cout << ans << '\n';
	cout << s << '\n';
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	val[0] = 1;
	for (int i = 1; i < Al; i++) {
		if (i & 1) val[i] = val[i - 1] * 5;
		else val[i] = val[i - 1] * 2;
	}
	int t;
	cin >> t;
	while (t--) solve();
	return 0;
}