#include <bits/stdc++.h>
typedef long long ll;
using namespace std;

const ll INF = 2e18 + 100;
vector<ll> deg{1, 10, 100, (ll)1e3, (ll)1e4, (ll)1e5, (ll)1e6, (ll)1e7, (ll)1e8, (ll)1e9, (ll)1e10, (ll)1e11, (ll)1e12};

ll get(int c) {
    if (c % 2 == 0)
        return deg[c / 2];
    else
        return deg[c / 2] * 5;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        string s;
        cin >> s;
        vector<int> pos;
        int last = -1;
        for (int j = 0; j < s.size(); ++j) {
            if (s[j] == '?') {
                pos.push_back(j);
                last = j;
            }
        }
        if (last != -1) {
            vector<int> mx(pos.size(), 0);
            for (int j = 0; j < pos.size(); ++j) {
                int end;
                if (j == pos.size() - 1)
                    end = s.size() - 1;
                else
                    end = pos[j + 1] - 1;
                for (int k = pos[j] + 1; k <= end; ++k) {
                    if (s[k] - 'A' > mx[k])
                        mx[k] = s[k] - 'A';
                }
            }
            vector<vector<ll>> dp(pos.size() + 1, vector<ll>(26, -INF));
            for (int j = 0; j < 26; ++j)
                dp[0][j] = 0;
            for (int j = 0; j < pos.size(); ++j) {
                int beg;
                if (j == 0)
                    beg = 0;
                else
                    beg = pos[j - 1] + 1;
                vector<int> cnt(26, 0);
                ll sum = 0;
                for (int k = beg; k < pos[j]; ++k) {
                    ++cnt[s[k] - 'A'];
                    sum += get(s[k] - 'A');
                }
                for (int k = 0; k < mx[j] - 1; ++k)
                    sum -= cnt[k] * get(k);
                for (int k = mx[j]; k < 26; ++k) {
                    if (k > 0)
                        sum -= cnt[k - 1] * get(k - 1);
                    for (int l = k; l < 26; ++l)
                        dp[j + 1][k] = max(dp[j + 1][k], dp[j][l] + get(k) + sum);
                }
            }
            int best = 0, j = pos.size() - 1;
            for (int k = 0; k < 26; ++k) {
                if (dp[j + 1][k] > dp[j + 1][best])
                    best = k;
            }
            s[pos[j]] = 'A' + best;
            --j;
            while (j >= 0) {
                for (int k = best; k < 26; ++k) {
                    if (dp[j + 1][k] > dp[j + 1][best])
                        best = k;
                }
                s[pos[j]] = 'A' + best;
                --j;
            }
        }
        ll ans = 0;
        vector<int> cnt(26, 0);
        for (int j = s.size() - 1; j >= 0; --j) {
            bool b = true;
            for (int k = (s[j] - 'A') + 1; k < 26; ++k) {
                if (cnt[k] > 0) {
                    b = false;
                    break;
                }
            }
            ++cnt[s[j] - 'A'];
            if (b)
                ans += get(s[j] - 'A');
            else
                ans -= get(s[j] - 'A');
        }
        cout << ans << '\n' << s << '\n';
    }
}
