#include <bits/stdc++.h> 

#define pb push_back

#define pii pair<int, int>

#define ff first 
#define ss second 

#define int long long

#define all(x) (x).begin(), (x).end()    

using namespace std; 

typedef long long ll; 

const int maxn = 3e5 + 7; 
const ll inf = 8e18; 
int n, m;  
vector<pii> gr[maxn]; 
int used[maxn]; 

void dfs(int u, int mn, int mx, int &res) {
    res += mn + mx; 
    for (auto v : gr[u]) {
        if (!used[v.ff]) {
            dfs(v.ff, min(mn, v.ss), max(mx, v.ss), res); 
        }
    }
}

void solve() {
    cin >> n >> m; 
    for (int i = 0; i < m; ++i) {
        int u, v, t; cin >> u >> v >> t, --u, --v; 
        gr[u].pb({v, t}); 
        gr[v].pb({u, t}); 
    }
    if (m == n - 1) {
        int res = 0; 
        dfs(0, inf, -inf, res); 
        cout << res; 
    }
}                                        

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin); 
  freopen("TASK.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false); 
    cin.tie(0);

    int t = 1; 
    for (int i = 0; i < t; ++i) {
        solve(); 
    }
    return 0; 
}