#include <bits/stdc++.h>

using namespace std;

struct tree {
    int x, h;

    tree(int x = 0, int h = 0) : x(x), h(h) {}
};

#define MAXN 5000
tree trees[MAXN];
vector<int> need_l[MAXN];
vector<int> need_r[MAXN];
int n;

int solve(int l, int r) {
    set<int> done;
    while (true) {
        int pos = -1;
        for (int i = l; i < r; ++i) {
            if(done.count(i)){
                continue;
            }
            bool canl = trees[i].x - trees[i].h >= trees[0].x;
            for (auto x:need_l[i]) {
                if (!canl) {
                    break;
                }
                canl &= done.count(x);
            }
            bool canr = trees[i].x + trees[i].h <= trees[n - 1].x;
            for (auto x:need_r[i]) {
                if (!canr) {
                    break;
                }
                canr &= done.count(x);
            }
            if (canl || canr) {
                pos = i;
                break;
            }
        }
        if (pos == -1) {
            break;
        }
        done.insert(pos);
    }
    return done.size();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        int x, h;
        cin >> x >> h;
        trees[i] = {x, h};
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i - 1; j >= 0; --j) {
            if (trees[i].x - trees[i].h < trees[j].x) {
                need_l[i].push_back(j);
            } else {
                break;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (trees[i].x + trees[i].h > trees[j].x) {
                need_r[i].push_back(j);
            } else {
                break;
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        cout << solve(l, r) << "\n";
    }
    return 0;

}