#include <bits/stdc++.h>

using namespace std;
#define MAXN 300000
#define MAX 1000000000

struct edge {
    int to, t;

    edge(int to, int t) : to(to), t(t) {}
};

vector<edge> g[MAXN];
int n;
int m;
int ans[MAXN];

void dfs(int v, int p, int mx, int mn) {
    ans[v] = mx + mn;
    for (auto u:g[v]) {
        if (u.to == p) {
            break;
        }
        dfs(u.to, v, max(mx, u.t), min(mn, u.t));
    }
}

void solve() {
    if (m != n - 1) {
        cout << 1 / 0;
    }
    dfs(0, 0, 0, MAX);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        u--;
        v--;
        g[u].push_back({v, t});
        g[v].push_back({u, t});
    }
    solve();
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }
}
