#include <bits/stdc++.h>

using namespace std;
#define int long long
#define MAXN 300000
#define MAX 1000000000000ll

struct edge {
    int to, t, ind;

    edge(int to, int t, int ind) : to(to), t(t), ind(ind) {}
};

vector<edge> g[MAXN];
int n;
int m;
int ans[MAXN];
bool used[MAXN];

void dfs(int v, int mx, int mn) {
    ans[v] = min(ans[v], mx + mn);
    for (auto u:g[v]) {
        if (used[u.ind]) {
            continue;
        }
        used[u.ind] = 1;
        dfs(u.to, max(mx, u.t), min(mn, u.t));
        used[u.ind] = 0;
    }
}
void solve() {
    for (int i = 0; i < n; ++i) {
        ans[i] = MAX;
    }
    dfs(0, 0, MAX);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        u--;
        v--;
        g[u].emplace_back(v, t, i);
        g[v].emplace_back(u, t, i);
    }
    solve();
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }
}