#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INFLL = 1e18;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<pair<ll, ll> > > g(n);
    for (int i = 0; i < m; i++)
    {
        ll ft, to, tm;
        cin >> ft >> to >> tm;
        ft--, to--;
        g[ft].push_back({to, tm});
        g[to].push_back({ft, tm});
    }

    vector<ll> dist(n, INFLL);
    dist[0] = 0;
    set<pair<ll, ll> > S;
    S.insert({0, 0});
    while (S.size())
    {
        auto it = *S.begin();
        S.erase(S.begin());
        for (auto e : g[it.second])
        {
            int to = e.first;
            int w = max(dist[it.second], e.second);
            if (dist[to] > w)
            {
                S.erase({dist[to], to});
                dist[to] = w;
                S.insert({dist[to], to});
            }
        }
    }
    for (int i = 1; i < n; i++) cout << dist[i] << "\n";
}
