#include <bits/stdc++.h>
#define ll long long
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int q;
    cin >> q;
    unordered_map <char, ll> cost;
    vector <ll> all = {1, 5, 10, 50, 100, 500, 1000, 5 * 1000, 10000, 5 * 10000,
                        100000, 5 * 100000, 1000000LL, 5 * 1000000LL, 10000000LL, 5 * 10000000LL,
                        100000000LL, 5 * 100000000LL, 1000000000LL, 5 * 1000000000LL, 10000000000LL, 5 * 10000000000LL,
                        100000000000LL, 5 * 100000000000LL, 1000000000000LL, 5 * 1000000000000LL};

    for (int i = 0; i < 26; i++)
        cost['A' + i] = all[i];
    while (q--)
    {
        string s; cin >> s;
        ll baseCost = 0LL;
        set <char> used;
        vector <bool> toInsert(s.size(), false);
        int n = s.size();
        for (int i = s.size() - 1; i >= 0; i--)
        {
            if (s[i] == '?') continue;
            if (used.upper_bound(s[i]) != used.end())
                baseCost -= cost[s[i]];
            else
            {
                baseCost += cost[s[i]];
                toInsert[i] = true;
            }
            used.insert(s[i]);
        }

        int countLower = 0, countY = 0;
        ll lowerCost = 0;
        ll yCost = 0;
        for (int i = 0; i < n; i++)
        {
            if (s[i] == '?')
            {
                if (countY <= 2)
                {
                    baseCost -= lowerCost * 2;
                    baseCost -= yCost * 2;
                    baseCost += cost['Z'];
                    s[i] = 'Z';
                    countLower = 0;
                    countY = 0;
                    yCost = 0;
                    lowerCost = 0;
                } else
                {
                    baseCost -= lowerCost * 2;
                    baseCost += cost['Y'];
                    lowerCost = 0;
                    countY++;
                    s[i] = 'Y';
                    yCost += cost['Y'];
                    countLower = 0;
                }
            } else
            {
                if (!toInsert[i]) continue;
                if (s[i] == 'Y')
                {
                    countY++;
                    yCost += cost['Y'];
                } else if (s[i] != 'Z')
                {
                    countLower++;
                    lowerCost += cost[s[i]];
                }
            }
        }
        cout << baseCost << "\n";
        cout << s << "\n";
    }
}
