#include <bits/stdc++.h>
#define ll long long
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int q;
    cin >> q;
    unordered_map <char, ll> cost;
    vector <ll> all = {1, 5, 10, 50, 100, 500, 1000, 5 * 1000, 10000, 5 * 10000,
                        100000, 5 * 100000, 1000000LL, 5 * 1000000LL, 10000000LL, 5 * 10000000LL,
                        100000000LL, 5 * 100000000LL, 1000000000LL, 5 * 1000000000LL, 10000000000LL, 5 * 10000000000LL,
                        100000000000LL, 5 * 100000000000LL, 1000000000000LL, 5 * 1000000000000LL};

    for (int i = 0; i < 26; i++)
        cost['A' + i] = all[i];
    while (q--)
    {
        string s; cin >> s;
        ll baseCost = 0LL;
        set <char> used;
        vector <bool> toInsert(s.size(), false);
        int n = s.size();
        for (int i = s.size() - 1; i >= 0; i--)
        {
            if (s[i] == '?') continue;
            if (used.upper_bound(s[i]) != used.end())
                baseCost -= cost[s[i]];
            else
            {
                baseCost += cost[s[i]];
                toInsert[i] = true;
            }
            used.insert(s[i]);
        }

        ll curCost = 0LL;
        vector <int> cnt(26);
        for (int i = 0; i < n; i++)
        {
            if (s[i] == '?')
            {
                ll lowerCost = 0;
                ll best = -1;
                ll lower;
                int pos = -1;
                for (int ch = 0; ch < 26; ch++)
                {
                    ll temp = lowerCost + curCost + cost[ch + 'A'];
                    if (best == -1 || best <= temp)
                    {
                        best = temp;
                        pos = ch;
                        lower = lowerCost;
                    }
                    lowerCost -= cost[ch + 'A'] * cnt[ch] * 2;
                }

                s[i] = pos + 'A';
                curCost += lower;
                baseCost += lower + cost[pos + 'A'];
                cnt[pos]++;
                for (int t = 0; t < pos; t++)
                    cnt[t] = 0;

            } else if (toInsert[i])
            {
                cnt[s[i] - 'A']++;
                curCost += cost[s[i]];
            }
        }

        cout << baseCost << "\n" << s << "\n";
    }
}
