#include <bits/stdc++.h>

const int inf = 0x3f3f3f3f;
using ll = long long;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
using pii = std::pair<int, int>;

const int MAXN = 20;
std::vector<pii> g[MAXN];

int ans[MAXN];

std::set<pii> used;
void dfs(int v, int mini, int maxi) {
    ans[v] = std::min(ans[v], mini + maxi);
    for(auto &[to, cost] : g[v]) {
        if(used.count(std::make_pair(v, to))) continue;
        used.insert(std::make_pair(v, to));
        used.insert(std::make_pair(to, v));
        dfs(to, std::min(mini, cost), std::max(maxi, cost));
        used.erase(std::make_pair(v, to));
        used.erase(std::make_pair(to, v));
    }
}

int main() {
    int n, m;
    std::cin >> n >> m;

    std::map<pii, int> cntEdges;

    std::pair<pii, int> order[m];
    for (int i = 0; i < m; i++) {
        int a, b, t;
        std::cin >> a >> b >> t;
        a--, b--;
        order[i] = std::make_pair(std::make_pair(a, b), t);
        cntEdges[std::make_pair(a, b)]++;
        cntEdges[std::make_pair(b, a)]++;
        g[a].emplace_back(b, t);
        g[b].emplace_back(a, t);
    }

    std::fill(ans, ans + MAXN, 2e9 + 3);
    dfs(0, inf, -inf);

    for(int i = 1; i < n; i++) std::cout << ans[i] << ' ';
}