#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 3e5 + 100, K = 26, INF = 2e18;

int t, st[13], dp[N][K], q, w;
pair<int, char> p[N][K];
string s;

int get(char c) {
    q = c - 'A';
    w = st[q / 2];
    if (q % 2 == 1) {
        w *= 5;
    }
    return w;
}

void solve() {
    st[0] = 1;
    for (int i = 1; i < 13; i++) {
        st[i] = st[i - 1] * 10;
    }
    cin >> t;
    while (t--) {
        cin >> s;
        int n = s.size();
        for (int i = 0; i <= n; i++) {
            for (int j = 0; j < K; j++) {
                dp[i][j] = -INF;
            }
        }
        dp[n][0] = 0;
        for (int i = n - 1; i >= 0; i--) {
            for (int j = 0; j < K; j++) {
                if (s[i] == '?') {
                    for (int h = 0; h < K; h++) {
                        if (h >= j) {
                            if (dp[i][h] < dp[i + 1][j] + get('A' + h)) {
                                dp[i][h] = dp[i + 1][j] + get('A' + h);
                                p[i][h] = {j, 'A' + h};
                            }
                        } else {
                            if (dp[i][j] < dp[i + 1][j] - get('A' + h)) {
                                dp[i][j] = dp[i + 1][j] - get('A' + h);
                                p[i][j] = {j, 'A' + h};
                            }
                        }
                    }
                } else {
                    if (s[i] - 'A' >= j) {
                        if (dp[i][s[i] - 'A'] < dp[i + 1][j] + get(s[i])) {
                            dp[i][s[i] - 'A'] = dp[i + 1][j] + get(s[i]);
                            p[i][s[i] - 'A'] = {j, s[i]};
                        }
                    } else {
                        if (dp[i][j] < dp[i + 1][j] - get(s[i])) {
                            dp[i][j] = dp[i + 1][j] - get(s[i]);
                            p[i][j] = {j, s[i]};
                        }
                    }
                }
            }
        }
        int ans = -INF;
        int pos = 0, k = 0;
        for (int i = 0; i < K; i++) {
            if (ans < dp[0][i]) {
                k = i;
                ans = dp[0][i];
            }
        }
        cout << ans << '\n';
        while (pos < n) {
            cout << p[pos][k].second;
            k = p[pos][k].first;
            pos++;
        }
        cout << '\n';
    }
}
