#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 2e3 + 100, K = 26, INF = 2e18;

int n, m, ans[N], cost[N][N];
pair<int, int> d[N];
vector<pair<int, int>> a[N];
bool used[N];
map<pair<int, int>, vector<int>> ma;
map<pair<int, int>, int> ma1, ma2;

void dfs(int v, int mn, int mx) {
    ans[v] = min(ans[v], mn + mx);
    used[v] = true;
    for (auto to : a[v]) {
        if (used[to.first]) continue;
        dfs(to.first, min(mn, to.second), max(mx, to.second));
    }
}

void solve() {
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int f, s, c;
        cin >> f >> s >> c;
        if (f > s) swap(f, s);
        f--, s--;
        ma[{f, s}].push_back(c);
    }
    for (auto it = ma.begin(); it != ma.end(); it++) {
        sort(it->second.begin(), it->second.end());
        ma1[it->first] = it->second[0];
        if (it->second.size() > 1) {
            ma2[it->first] = it->second[1];
        }
    }
    d[0] = {INF, -INF};
    for (int i = 1; i < n; i++) {
        d[i] = d[i - 1];
        d[i].first = min(d[i].first, ma1[{i - 1, i}]);
        d[i].second = max(d[i].second, ma1[{i - 1, i}]);
    }
    for (int i = 0; i < n; i++) {
        cost[i][i] = -INF;
        for (int j = i + 1; j < n; j++) {
            cost[i][j] = cost[i][j - 1];
            cost[i][j] = max(cost[i][j], ma2[{j - 1, j}]);
        }
    }
    fill(ans, ans + n, INF);
    for (int i = 1; i < n; i++) {
        for (int j = i; j < n; j++) {
            ans[i] = min(ans[i], d[j].first + max(d[j].second, cost[i][j]));
        }
    }
    for (int i = 1; i < n; i++) {
        cout << ans[i] << " ";
    }
}
