#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

typedef long long ll;


const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;

//#define int ll

const int MAXN = 3e5 + 15;

vi adj[MAXN];
vpi g[MAXN];
int deepth[MAXN];
bool used[MAXN];
bool dp[MAXN][3];
pi p[MAXN];
vector <vi> ans;
vpi edges;

void DFS(int v) {
    for (auto u : adj[v]) {
        if (deepth[u] == -1) {
            deepth[u] = deepth[v] + 1;
            DFS(u);
        }
    }
}

void No() {
    cout << "No";
    exit(0);
}

void DFS2(int v) {
    used[v] = 1;
    if (g[v].empty()) {
        dp[v][0] = 1;
        return;
    }
    int cnt1 = 0, cnt2 = 0, canDel1 = 0, canDel2 = 0;
    for (auto [u, type] : g[v]) {
        if (!used[u]) {
            DFS2(u);
        }
        if (!dp[u][0]) {
            assert(!dp[u][1] || !dp[u][2]);
            if (dp[u][1]) {
                if (type == 2) {
                    No();
                } else if (type == 3) {
                    cnt2++;
                }
            } else if (dp[u][2]) {
                if (type == 1) {
                    No();
                } else if (type == 3) {
                    ++cnt1;
                }
            } else {
                assert(false);
            }
            continue;
        }
        if (type == 1 || type == 3) {
            ++cnt1;
            if (dp[u][1]) {
                ++canDel1;
            }
        }
        if (type == 2 || type == 3) {
            ++cnt2;
            if (dp[u][2]) {
                ++canDel2;
            }
        }
    }
    int l1 = cnt1 - canDel1, r1 = cnt1, l2 = cnt2 - canDel2, r2 = cnt2;
    if (max(l1, l2) <= min(r1, r2)) {
        dp[v][0] = 1;
    }
    if (max(l1, l2 + 1) <= min(r1, r2 + 1)) {
        dp[v][1] = 1;
    }
    if (max(l1 + 1, l2) <= min(r1 + 1, r2)) {
        dp[v][2] = 1;
    }
}

void GetAns(int v, int i) {
    if (used[v]) {return;}
    used[v] = 1;
    if (g[v].empty()) {
        return;
    }
    vi need1, need2, can1, can2;
    int cnt1 = 0, cnt2 = 0, canDel1 = 0, canDel2 = 0;
    for (auto [u, type] : g[v]) {
        if (!dp[u][0]) {
            assert(!dp[u][1] || !dp[u][2]);
            if (dp[u][1]) {
                GetAns(u, 1);
                if (type == 2) {
                    No();
                } else if(type == 1 || type == 3) {
                    ans.eb(vi{u, v, p[u].first, p[u].second});
                    if (type == 3) {
                        need2.eb(u);
                        ++cnt2;
                    }
                }
            } else if (dp[u][2]) {
                GetAns(u, 2);
                if (type == 1) {
                    No();
                } else if (type == 3 || type == 2) {
                    ans.eb(vi{v, u, p[u].first, p[u].second});
                    if (type == 3) {
                        need1.eb(u);
                        ++cnt1;
                    }
                }
            } else {
                assert(false);
            }
            continue;
        }
        if (type == 1 || type == 3) {
            ++cnt1;
            if (dp[u][1]) {
                ++canDel1;
                can1.eb(u);
            } else {
                need1.eb(u);
            }
        }
        if (type == 2 || type == 3) {
            ++cnt2;
            if (dp[u][2]) {
                ++canDel2;
                can2.eb(u);
            } else {
                need2.eb(u);
            }
        }
    }
    int l1 = cnt1 - canDel1, r1 = cnt1, l2 = cnt2 - canDel2, r2 = cnt2;
    if (i == 0) {
        int want = max(l1, l2);
        int del1 = cnt1 - want, del2 = cnt2 - want;
        while(del1) {
            int u = can1.back();
            can1.pop_back();
            GetAns(u, 1);
            ans.eb(vi{u, v, p[u].first, p[u].second});
            --del1;
        }
        for (auto u : can1) {
            need1.eb(u);
        }
        while(del2) {
            int u = can2.back();
            can2.pop_back();
            GetAns(u, 2);
            ans.eb(vi{v, u, p[u].first, p[u].second});
            --del2;
        }
        for (auto u : can2) {
            need2.eb(u);
        }
        forn(i, sz(need1)) {
            GetAns(need1[i], 1);
            GetAns(need2[i], 2);
            ans.eb(vi{need1[i], v, v, need2[i]});
        }
    } else if (i == 1) {
        int want1 = max(l1, l2 + 1), want2 = max(l1, l2 + 1) - 1;
        int del1 = cnt1 - want1, del2 = cnt2 - want2;
        while(del1) {
            int u = can1.back();
            can1.pop_back();
            GetAns(u, 1);
            ans.eb(vi{u, v, p[u].first, p[u].second});
            --del1;
        }
        for (auto u : can1) {
            need1.eb(u);
        }
        while(del2) {
            int u = can2.back();
            can2.pop_back();
            GetAns(u, 2);
            ans.eb(vi{v, u, p[u].first, p[u].second});
            --del2;
        }
        for (auto u : can2) {
            need2.eb(u);
        }
        GetAns(need1.back(), 1);
        p[v] = {need1.back(), v};
        need1.pop_back();
        forn(i, sz(need1)) {
            GetAns(need1[i], 1);
            GetAns(need2[i], 2);
            ans.eb(vi{need1[i], v, v, need2[i]});
        }
    } else {
        int want1 = max(l1 + 1, l2) - 1, want2 = max(l1 + 1, l2);
        int del1 = cnt1 - want1, del2 = cnt2 - want2;
        while(del1) {
            int u = can1.back();
            can1.pop_back();
            GetAns(u, 1);
            ans.eb(vi{u, v, p[u].first, p[u].second});
            --del1;
        }
        for (auto u : can1) {
            need1.eb(u);
        }
        while(del2) {
            int u = can2.back();
            can2.pop_back();
            GetAns(u, 2);
            ans.eb(vi{v, u, p[u].first, p[u].second});
            --del2;
        }
        for (auto u : can2) {
            need2.eb(u);
        }
        GetAns(need2.back(), 2);
        p[v] = {v, need1.back()};
        need2.pop_back();
        forn(i, sz(need1)) {
            GetAns(need1[i], 1);
            GetAns(need2[i], 2);
            ans.eb(vi{need1[i], v, v, need2[i]});
        }
    }
}

void Solve() {
    memset(deepth, -1, sizeof(deepth));
    int n, m;
    cin >> n >> m;
    edges.resize(m);
    forn(i, m) {
        int a, b;
        cin >> a >> b;
        adj[a].eb(b);
        adj[b].eb(a);
        edges[i] = {a, b};
    }
    for (int i = 1; i <= n; ++i) {
        if (deepth[i] == -1) {
            deepth[i] = 0;
            DFS(i);
        }
    }
    for(auto [a, b] : edges) {
        if (deepth[a] < deepth[b]) {
            g[a].eb(b, 2);
        } else {
            g[b].eb(a, 1);
        }
    }
    for (int i = 1; i <= n; ++i) {
        vpi nxt;
        sort(all(g[i]));
        for (auto [u, type] : g[i]) {
            if (!nxt.empty() && nxt.back().first == u) {
                nxt.back().second += type;
            } else {
                nxt.eb(u, type);
            }
        }
        swap(g[i], nxt);
    }
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            DFS2(i);
            if (!dp[i][0]) {
                No();
            }
        }
    }
    memset(used, 0, sizeof(used));
    for (int i = 1; i <= n; ++i) {
        if (used[i]) {continue;}
        GetAns(i, 0);
    }
    cout << "Yes\n";
    for (auto &u : ans) {
        for (auto v : u) {
            cout << v << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}
