#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

typedef long long ll;


const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;

//#define int ll

int Func(vpi a) {
    int ans = 0;
    int n = sz(a);
    vector <bool> deleted(n, 0);
    vi cool;
    vi left(n), right(n);
    deleted[0] = deleted[n - 1] = 1;
    forn(i, n) {
        left[i] = i - 1;
        right[i] = i + 1;
        int l = a[i - 1].first, r = a[i + 1].first;
        if (!deleted[i] && (l <= a[i].first - a[i].second || r >= a[i].first + a[i].second)) {
            cool.eb(i);
        }
    }
    while(!cool.empty()) {
        int i = cool.back();
        cool.pop_back();
        if (deleted[i]) {continue;}
        deleted[i] = 1;
        ++ans;
        int l = left[i], r = right[i];
        right[l] = r;
        left[r] = l;
        if (!deleted[l] && (a[r].first >= a[l].first + a[l].second)) {
            cool.eb(l);
        }
        if (!deleted[r] && (a[l].first <= a[r].first - a[r].second)) {
            cool.eb(r);
        }
    }
    return ans;
}

void Solve() {
    int n, q;
    cin >> n >> q;
    vpi a(n + 2);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    a[0] = a[1];
    a[n + 1] = a[n];
    while(q--) {
        int l, r;
        cin >> l >> r;
        vpi now;
        for (int i = l - 1; i <= r + 1; ++i) {
            now.eb(a[i]);
        }
        cout << Func(now) << '\n';
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}

