#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

typedef long long ll;


const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;

const int MAXN = 25 + 15;
const int MAXE = (1 << 20);

int ans[MAXN];
int cost[MAXE];
bool dp[MAXN][MAXE];
vpi adj[MAXN];

bool Check(int mask, int i) {
    return ((mask >> i) & 1);
}

void Solve() {
    int n, m;
    cin >> n >> m;
    vector <tuple <int, int, int>> edges;
    int mx = (1 << m);
    forn(i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        adj[a].eb(b, i);
        adj[b].eb(a, i);
        edges.eb(a, b, c);
    }
    forn(mask, mx) {
        int mn = INF, mx = nINF;
        forn(i, m) {
            if (Check(mask, i)) {
                mn = min(mn, get<2>(edges[i]));
                mx = max(mx, get<2>(edges[i]));
            }
        }
        cost[mask] = mn + mx;
    }
    dp[1][0] = 1;
    queue <pi> q;
    q.push({1, 0});
    while(!q.empty()) {
        auto [v, mask] = q.front();
        q.pop();
        for (auto [to, num] : adj[v]) {
            if (Check(mask, num)) {continue;}
            int nxt = (mask | (1 << num));
            if (!dp[to][nxt]) {
                dp[to][nxt] = 1;
                q.push({to, nxt});
            }
        }
    }
    for (int i = 2; i <= n; ++i) {
        int now = INF;
        forn(j, MAXE) {
            if (dp[i][j]) {
                now = min(now, cost[j]);
            }
        }
        cout << now << '\n';
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}