#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <random>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

mt19937 rnd(1859);
const int inf = 1e9;

char dp[(1 << 20)][20];


int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	for (int i{}; i < (1 << 20); ++i) {
		for (int j{}; j < 20; ++j) dp[i][j] = false;
		dp[i][0] = true;
	}
	int n, m;
	cin >> n >> m;
	int x, y, w;
	vector < pair<int, pair<int, int>>> e;
	for (int i{}; i < m; ++i) {
		cin >> x >> y >> w;
		x--;
		y--;
		e.push_back({ w, {x, y} });
	}

	sort(all(e));
	vector<int> ans(n, inf + inf);

	for (int i{}; i < (1 << m); ++i) {
		int mn = inf, mx = -inf;
		for (int j{}; j < m; ++j) {
			if (!(i & (1 << j))) continue;
			mn = min(mn, e[j].x);
			mx = max(mx, e[j].x);
			if (dp[i ^ (1 << j)][e[j].y.x]) dp[i][e[j].y.y] = true;
			if (dp[i ^ (1 << j)][e[j].y.y]) dp[i][e[j].y.x] = true;
		}
		for (int j{}; j < n; ++j) {
			if (dp[i][j] && mn + mx < ans[j]) ans[j] = mn + mx;
		}
	}

	for (int i{ 1 }; i < n; ++i) {
		cout << ans[i] << '\n';
	}

	return 0;
}