#include <bits/stdc++.h>
using namespace std;

#define int long long
#define s second
#define f first

vector <int> parl;
int n;

int getl(int v)
{
    if (v==-1)return -1;
    if (v==n)return v;
    if (parl[v]==v)return v;
    parl[v]=getl(parl[v]);
    return parl[v];
}

void updatel(int v, int u)
{
    v=getl(v);
    u=getl(u);
    if (v==-1)return;
    if (v==n)return;
    if (v==u)return;
    parl[v]=u;
}

vector <int> parr;

int getr(int v)
{
    if (v==-1)return -1;
    if (v==n)return v;
    if (parr[v]==v)return v;
    parr[v]=getr(parr[v]);
    return parr[v];
}

void updater(int v, int u)
{
    v=getr(v);
    u=getr(u);
    if (v==-1)return;
    if (v==n)return;
    if (v==u)return;
    parr[v]=u;
}


signed main()
{
    int q;
    cin >> n >> q;
    vector <int> h(n);
    vector <int> x(n);
    for (int i=0; i<n; i++){
        cin >> x[i] >> h[i];
    }
    parr.resize(n);
    parl.resize(n);

    while (q--){
        int l,r;
        cin >> l >> r;
        l--;
        r--;
        for (int i=0; i<n; i++){
            parr[i]=i;
            parl[i]=i;
        }
        /**for (int i=0; i<l; i++){
            parr[i]=n;
            parl[i]=-1;
        }
        for (int i=r+1; i<n; i++){
            parr[i]=n;
            parl[i]=-1;
        }*/

        queue <int> p;
        vector <int> used(n,0);
        for (int i=l; i<=r; i++){
            int u=getl(i-1);
            if (u!=-1 && x[i]-x[u]>=h[i]){
                p.push(i);
                used[i]=1;
                continue;
            }
            u=getr(i+1);
            if (u!=-1 && x[u]-x[i]>=h[i]){
                p.push(i);
                used[i]=1;
            }
        }

        int cnt=0;
        while (!p.empty()){
            int v=p.front();
            p.pop();
            if (v<l || r<v)continue;
            //cout << "v: " << v+1 << endl;
            updatel(v,v-1);
            updater(v,v+1);
            cnt++;
            int i=v+1;
            if (i!=n && !used[i]){
                int u=getl(i-1);
                if (u!=-1 && x[i]-x[u]>=h[i]){
                    p.push(i);
                    used[i]=1;
                    continue;
                }
                u=getr(i+1);
                if (u!=-1 && x[u]-x[i]>=h[i]){
                    p.push(i);
                    used[i]=1;
                }
            }
            i=v-1;
            if (i!=-1 && !used[i]){
                int u=getl(i-1);
                if (u!=-1 && x[i]-x[u]>=h[i]){
                    p.push(i);
                    used[i]=1;
                    continue;
                }
                u=getr(i+1);
                if (u!=-1 && x[u]-x[i]>=h[i]){
                    p.push(i);
                    used[i]=1;
                }
            }

        }
        cout << cnt << endl;
    }
}
/**
3 3
1 3
3 1
4 2

1 1
2 3
1 3

*/
