#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vii = vector<int>;

void optimize() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}

int n, q;
const int N = 505;

pll a[N];
bitset<N> bad_left[N];
bitset<N> bad_right[N];

bool used[N];

int ask(int l, int r) {
    fill(used, used + n, 0);
    vector<int> can;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (j == i) continue;
            if (j < i) bad_left[i][j] = (a[i].first - a[i].second) < a[j].first;
            else bad_right[i][j] = (a[i].first + a[i].second) > a[j].first;
        }
    }
    for (int i = l; i <= r; ++i) if (!bad_right[i].any() || !bad_left[i].any()) can.push_back(i), used[i] = 1;
    int cnt = 0;
    while (!can.empty()) {
        int i = can.back(); can.pop_back(); ++cnt;
//        cout << i << endl;
        bitset<N> b; b = ~b;
        b[i] = 0;
        for (int j = l; j <= r; ++j) {
            if (used[j]) continue;
            bad_left[j] &= b; bad_right[j] &= b;
            if (!bad_left[j].any() || !bad_right[j].any()) {
                used[j] = 1;
                can.push_back(j);
            }
        }
    }
    return cnt;
}

int main() {
    optimize();
    cin >> n >> q;
    a[0].first = 1; a[0].second = 1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i + 1].first >> a[i + 1].second;
    }
    a[n + 1].first = a[n].first; a[n + 1].second = 1;
    n += 2;

    for (int i = 0; i < q; ++i) {
        int l, r; cin >> l >> r;
        cout << ask(l, r) << '\n';
    }

    return 0;
}
