#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(v) v.begin(),  v.end()


using namespace std;

const int maxn = 10000;


vector<pair<int, int>> edges;

vector<int> graph[maxn];
int mt[maxn];

queue<int> st;

void dfs(int v) {
    while (!graph[v].empty()) {
        int ind = graph[v].back();
        graph[v].pop_back();
        dfs(edges[ind].second);
        if (!st.empty() && edges[st.front()].first == edges[ind].second) {
            mt[ind] = st.front();
            mt[st.front()] = ind;
            st.pop();
        } else {
            st.push(ind);
        }
    }
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        edges.emplace_back(u, v);
        graph[u].push_back(i);
    }
    fill(mt, mt + m, -1);
    for (int i = 0; i < n; ++i) {
        dfs(i);
    }
    for (int i = 0; i < m; ++i) {
        if (mt[i] == -1) {
            cout << "No";
            exit(0);
        }
    }
    cout << "Yes\n";
    vector<bool> used(m, false);
    for (int i = 0; i < m; ++i) {
        if (mt[i] == -1) assert(false);
        if (!used[i]) {
            if (edges[i].second != edges[mt[i]].first)
                continue;
            cout << edges[i].first + 1 << " " << edges[i].second + 1 << " " << edges[mt[i]].first + 1 << " " << edges[mt[i]].second + 1
                 << "\n";
            used[i] = true;
            used[mt[i]] = true;
        }
    }

    return 0;
}
