#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const ll INF =2e18;
vector<set<int>> g;
vector<vector<int>> tree;
vector<int> bal;
vector<tuple<int,int,int,int>> ans;
void finish(){
    cout<<"No";
    exit(0);
}
bool checkE(int u,int v){
    /*if((*lower_bound(g[u].begin(),g[u].end(),v)) == v)
        return true;
    return false;*/
    return g[u].find(v)!=g[u].end();
}

vector<int> leftE;
vector<bool> used;
void dfs(int v,int par){
    int cnt=0;
    used[v]=true;
    vector<int> in,out;
    for(int u:tree[v]){
        if(u!=par){
            dfs(u,v);
            cnt++;
            if(abs(bal[u])>1){
                finish();
            }
            bool uv,vu;
            uv=checkE(u,v);
            vu=checkE(v,u);
            if(bal[u]==0){

                if(uv&&vu){
                    ans.push_back({u,v,v,u});
                    g[u].erase(v);
                    g[v].erase(u);
                }
                else{
                    if(vu){
                        ans.push_back({v,u,u,leftE[u]});
                        bal[v]--;
                    }
                    else{
                        ans.push_back({leftE[u],u,u,v});
                        bal[v]++;
                    }
                }
            }
            if(bal[u]==1){
                in.push_back(u);
                if(vu&&uv){
                    ans.push_back({v,u,u,leftE[u]});
                    bal[v]--;
                }
            }
            if(bal[u]==-1){
                out.push_back(u);
                if(vu&&uv){
                    ans.push_back({leftE[u],u,u,v});
                    bal[v]++;

                }
            }
        }
    }
    while(!in.empty()&&!out.empty()){
        ans.push_back({in.back(),v,v,out.back()});
        in.pop_back();
        out.pop_back();
    }
    if(in.size()>1||out.size()>1)
        finish();
    if(!out.empty())
        leftE[v]=out[0];
    if(!in.empty())
        leftE[v]=in[0];
    if(par==-1&&(!out.empty()||!in.empty()))
        finish();

}

int main() {
    int n,m;
    cin>>n>>m;
    g.resize(n);
    tree.resize(n);
    leftE.resize(n);
    bal.assign(n,0);
    used.assign(n,false);
    for(int i=0;i<m;++i){
        int u,v;
        cin>>u>>v;
        u--,v--;
        bal[u]++;
        bal[v]--;
        g[u].insert(v);
        tree[u].push_back(v);
        tree[v].push_back(u);
    }
    for(int i=0;i<n;++i){
        sort(tree[i].begin(),tree[i].end());
//        sort(g[i].begin(),g[i].end());
        tree[i].resize(unique(tree[i].begin(),tree[i].end())-tree[i].begin());
    }
    for(int i=0;i<n;++i){
        if(!used[i])
            dfs(i,-1);
    }
    cout<<"Yes"<<'\n';
    for(auto[a,b,c,d]:ans){
        assert(b==c);
        cout<<a+1<<' '<<b+1<<' '<<c+1<<' '<<d+1<<'\n';
    }
}
