#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cstring>
#define int long long
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
using namespace std;

const int N = 3e5;

vector<pii> g[N];
int n, m, mx[N], mn[N];


void dfs(int v, int p, int mmx, int mmn) {
	mx[v] = mmx;
	mn[v] = mmn;
	for (auto to : g[v]) {
		if (to.X != p)
		dfs(to.X, v, max(mmx, to.Y), min(mmn, to.Y));
	}
}

void solve1() {
	dfs(0, 0, 0, 1e9);
	for (int i = 0; i < n; ++i)
		cout << mn[i] + mx[i] << "\n";

}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		--u; --v;
		g[u].push_back({ v, t });
		g[v].push_back({ u, t });
	}
	if (m + 1 == n) {
		solve1();
		return 0;
	}
}