#include <bits/stdc++.h>
using namespace std;

const int INF = 1e9;

int n, m;
vector<vector<int>> g;
vector<vector<int>> t;

vector<int> ans;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;
	
	g = vector<vector<int>>(n, vector<int>(0));
	t = vector<vector<int>>(n, vector<int>(0));
	ans = vector<int>(n, 0);

	int _u, _v, _t;
	for ( int i = 0; i < m; ++i ) {
		cin >> _u >> _v >> _t;
		_u--; _v--;

		g[_u].push_back(_v);
		g[_v].push_back(_u);

		t[_u].push_back(_t);
		t[_v].push_back(_t);
	}

	vector<vector<int>> ts(n - 1, vector<int>(0));
	for ( int v = 0; v < n - 1; ++v ) {
		for ( int i = 0; i < g[v].size(); ++i ) {
			if ( g[v][i] <= v ) continue;

			ts[v].push_back(t[v][i]);
		}
	}

	vector<pair<int, int>> poses = {{0, INF}};
	vector<pair<int, int>> new_pos = {};

	for ( int i = 0; i < n - 1; ++i ) {
		new_pos = {};

		for ( int x : ts[i] ) {
			for ( pair<int, int> pose : poses ) {
				new_pos.push_back({max(pose.first, x), min(pose.second, x)});
			}
		}

		sort(new_pos.begin(), new_pos.end());
		new_pos.erase(unique(new_pos.begin(), new_pos.end()), new_pos.end());

		poses.swap(new_pos);

		ans[i + 1] = poses[0].first + poses[0].second;
		for ( int j = 0; j < poses.size(); ++j )
			ans[i + 1] = min(ans[i + 1], poses[j].first + poses[j].second);
	}

	for ( int i = 1; i < n; ++i )
		cout << ans[i] << "\n";

	return 0;
}