#include <iostream>
#include <vector>
#pragma GCC Optimize("Ofast")

using namespace std;

const int N = 3e5;

struct edge {
    int u, t, i;
};

vector < vector <edge> > g(N, vector <edge> ());

/*int an; vector <bool> used;
void dfs(int v, int tn, int tx) {
    if (v == 0) {
        an = min(an, tn + tx);
    }
    for (auto u : g[v]) {
        if (!used[u.i]) {
            used[u.i] = 1;
            dfs(u.u, min(tn, u.t), max(tx, u.t));
            used[u.i] = 0;
        }
    }
}*/

vector <int> d, up, b;
vector <bool> used;

void dfs(int v, int p, int l) {
    d[v] = l;
    up[v] = l;
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u.u]) {
            dfs(u.u, u.i, l + 1);
            if (up[u.u] <= d[v]) {
                up[v] = min(up[v], up[u.u]);
            } else {
                b[u.i] = 1;
            }
        } else {
            if (u.i != p) {
                up[v] = min(up[v], d[u.u]);
            }
        }
    }
}

vector <int> t;
int c = 0;

void comp(int v) {
    t[v] = c;
    for (auto u : g[v]) {
        if (t[u.u] == -1 && b[u.i] == 0) {
            comp(u.u);
        }
    }
}

vector < vector <edge> > new_g(N, vector <edge> ());
vector <int> tn, me;
void calc(int v, int p) {
    tn[v] = min(tn[v], me[v]);
    for (auto u : new_g[v]) {
        if (u.u != p) {
            tn[u.u] = min(tn[v], u.t);
            calc(u.u, v);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    int n, m; cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t; cin >> u >> v >> t;
        u--; v--;
        g[u].push_back({v, t, i});
        g[v].push_back({u, t, i});
    }
    d.resize(n); up.resize(n);
    used.assign(n, 0);
    b.assign(m, 0);
    t.assign(n, -1);
    dfs(0, -1, 0);
    for (int i = 0; i < n; ++i) {
        if (t[i] == -1) {
            comp(i);
            c++;
        }
    }
    me.assign(c, 3e9);
    for (int i = 0; i < n; ++i) {
        for (auto u : g[i]) {
            if (t[u.u] == t[i]) {
                me[t[i]] = min(me[t[i]], u.t);
            } else {
                new_g[t[u.u]].push_back({t[i], u.t, u.i});
                new_g[t[i]].push_back({t[u.u], u.t, u.i});
            }
        }
    }
    tn.assign(c, 3e9);
    calc(0, -1);
    for (int i = 1; i < n; ++i) {
        cout << tn[t[i]] + 1000000000 << "\n";
    }
    /*used.assign(m, 0);
    for (int i = 1; i < n; ++i) {
        an = 3e9;
        dfs(i, 3e9, 0);
        cout << an << "\n";
    }*/
    /*vector <int> a(n, 3e9), b(n, 3e9), s(n, 0);
    for (int i = 1; i < n; ++i) {
        for (auto u : g[i]) {
            if (u.u == i - 1) {
                if (u.t <= a[i]) {
                    b[i] = a[i];
                    a[i] = u.t;
                } else {
                    b[i] = min(b[i], u.t);
                }
                s[i]++;
            }
        }
    }
    int tx = 0, tn = 3e9;
    for (int i = 1; i < n; ++i) {
        tx = max(tx, a[i]);
        tn = min(tn, a[i]);
        int an = tx + tn;
        int ctx = tx, ctn = tn;
        for (int j = i + 1; j < n; ++j) {
            if (s[j] == 1) {
                break;
            }
            ctx = max(ctx, b[j]);
            ctn = min(ctn, a[j]);
            an = min(an, ctx + ctn);
        }
        cout << an << "\n";
    }*/
    /*vector <int> tn(n, 3e9), tx(n, 0);
    vector <bool> used(n, 0), in(n, 0);
    queue <int> q;
    q.push(0); in[0] = 1;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        used[v] = 1;
        for (auto u : g[v]) {
            if (!used[u.u]) {
                tn[u.u] = min({tn[u.u], u.t, tn[v]});
                tx[u.u] = max({tx[u.u], u.t, tx[v]});
            }
            if (in[u.u] == 0) {
                q.push(u.u);
                in[u.u] = 1;
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << tx[i] + tn[i] << "\n";
    }
    vector <int> d(n, 3e9);
    d[0] = 0;
    set < pair <int, int> > q;
    q.insert({0, 0});
    while (!q.empty()) {
        auto v = (*q.begin()).second;
        q.erase(q.begin());
        for (auto u : g[v]) {
            if (max(d[v], u.t) < d[u.u]) {
                q.erase({d[u.u], u.u});
                d[u.u] = max(d[v], u.t);
                q.insert({d[u.u], u.u});
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << d[i] + 1000000000 << "\n";
    }*/
}
