#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int MAXN = 200;

int n, m;
vector<int> g[MAXN];
int used[MAXN][MAXN];

struct Three {
    int a, b, c;

    Three(int a, int b, int c) : a(a), b(b), c(c) {}
};

vector<Three> ans;

bool rec(int ind) {
    if (ind == m / 2) {
        return true;
    }

    for (int v = 0; v < n; v++) {
        for (int u : g[v]) {
            if (used[v][u]) {
                continue;
            }

            used[v][u] = true;
            for (int t : g[u]) {
                if (used[u][t]) {
                    continue;
                }

                used[u][t] = true;

                //cerr << v << " " << u << " " << t << " " << ind << "\n";
                if (rec(ind + 1)) {
                    ans.emplace_back(v, u, t);
                    return true;
                }

                used[u][t] = false;
            }

            used[v][u] = false;
        }
    }

    return false;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    cin >> n >> m;
    vector<ll> dist(n, LLONG_MAX);
    for (int i = 0; i < m; i++) {
        int u, v; ll w;
        cin >> u >> v >> w;

        u--;
        v--;

        dist[max(u, v)] = min(dist[max(u, v)], w);
    }


    ll mn = dist[1], mx = dist[1];
    for (int i = 1; i < n; i++) {
        mn = min(mn, dist[i]);
        mx = max(mx, dist[i]);
        cout << (mn + mx) << "\n";
    }

    return 0;
}
