#include <bits/stdc++.h>
using namespace std;

#define fi first
#define se second
#define int long long
#define all(x) x.begin(), x.end()

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    unordered_map<char, int> mp;
    for (char c = 'A'; c <= 'Z'; c++) {
        if (c == 'A') {
            mp[c] = 1;
        } else if (c == 'B') {
            mp[c] = 5;
        } else {
            mp[c] = mp[c - 2] * 10;
        }
    }

    int T;
    cin >> T;
    while (T --> 0) {
        string s;
        cin >> s;
        int n = s.size();
        vector<char> mx(n);
        mx[n - 1] = s[n - 1];
        for (int i = n - 2; i >= 0; i--) {
            if (s[i] == '?')
                mx[i] = max(mx[i + 1], 'A');
            else
                mx[i] = max(mx[i + 1], s[i]);
        }
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if (s[i] == '?')
                cnt++;
        }
        char cur = 'Z';
        int ans = 0;
        vector<pair<char, int> > st;
        for (int i = 0; i < n; i++) {
            if (s[i] != '?') {
                if (st.empty()) {
                    ans += mp[s[i]];
                    st.push_back({s[i], 1});
                } else {
                    while (!st.empty() && st.back().fi < s[i]) {
                        ans -= mp[st.back().fi] * st.back().se * 2;
                        st.pop_back();
                    }
                    if (st.empty()) {
                        st.push_back({s[i], 1});
                    } else if (st.back().fi == s[i]) {
                        st.back().se++;
                    } else {
                        st.push_back({s[i], 1});
                    }
                    ans += mp[s[i]];
                }
            } else {
                int del = 0, t = (int)st.size() - 1;
                int mx_add = -LLONG_MAX;
                char e = 'A';
                for (char j = mx[i]; j <= 'Z'; j++) {
                    while (t >= 0 && j > st[t].fi) {
                        del += mp[st[t].fi] * st[t].se;
                        t--;
                    }
                    if (cnt * mp[j] - 2 * del >= mx_add) {
                        mx_add = cnt * mp[j] - 2 * del;
                        e = j;
                    }
                }
                s[i] = e;
                if (st.empty()) {
                    ans += mp[s[i]];
                    st.push_back({s[i], 1});
                } else {
                    while (!st.empty() && st.back().fi < s[i]) {
                        ans -= mp[st.back().fi] * st.back().se * 2;
                        st.pop_back();
                    }
                    if (st.empty()) {
                        st.push_back({s[i], 1});
                    } else if (st.back().fi == s[i]) {
                        st.back().se++;
                    } else {
                        st.push_back({s[i], 1});
                    }
                    ans += mp[s[i]];
                }
                cnt--;
            }
        }
        cout << ans << '\n';
        cout << s << '\n';
    }

    return 0;
}
/*
1
BBBC

4
BBBC
????
A?B?C?D
YYYYY?
 */