#include <iostream>
#include <vector>
#include <set>
#include <random>
#include <algorithm>
#define int long long

using namespace std;
vector <int> ans;
vector <vector<pair<int, int>>> gr;
void dfs(int now, int minn, int maxx, int pr = -1) {
    cout<< now << endl;
    ans[now] = minn + maxx;
    for (auto c : gr[now]) {
        if (c.first == pr) continue;
        dfs(c.first, min(minn, c.second), max(maxx, c.second), now);
    }
}

signed main() {
    int n, m;
    cin >> n >> m;
    ans.resize(n + 1);
    gr.resize(n + 1);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        gr[a].push_back({b, c});
        gr[b].push_back({a, c});
    }
    dfs(1, 1e9 + 7, -1e9 - 7);
    for (int i = 2; i <= n; ++i) cout << ans[i] << "\n";
    return 0;
}
