#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)2e18 + 10;
const int MOD = (int)1e9 + 7;

vi dig(26);

void solve() {
	string s;
	cin >> s;
	int n = s.length();
	vvi dp(n + 1, vi(26, -INF));
	vvi p(n + 1, vi(26, -1));
	for (int i = 0; i < 26; ++i)
		dp[n][i] = 0;
	for (int i = n - 1; i >= 0; --i) {
		if (s[i] == '?') {
			for (int j = 0; j < 26; ++j) {
				dp[i][j] = max(dp[i + 1][25] - dig[j], dp[i + 1][j] + dig[j]);
				if (dp[i + 1][25] - dig[j] > dp[i + 1][j] + dig[j])
					p[i][j] = 25;
				else
					p[i][j] = j;
			}
			continue;
		}
		for (int j = s[i] - 'A'; j < 26; ++j) {
			dp[i][j] = max(dp[i + 1][j] - dig[s[i] - 'A'], dp[i + 1][s[i] - 'A'] + dig[s[i] - 'A']);
			if (dp[i + 1][j] - dig[s[i] - 'A'] > dp[i + 1][s[i] - 'A'] + dig[s[i] - 'A'])
				p[i][j] = j;
			else
				p[i][j] = s[i] - 'A';
		}
	}
	cout << dp[0][25] << endl;
	int cur = 25;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '?')
			s[i] = ('A' + cur);
		cur = p[i][cur];
	}
	cout << s << endl;

	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	dig[0] = 1;
	for (int i = 1; i < 26; ++i) {
		if (i % 2)
			dig[i] = dig[i - 1] * 5;
		else
			dig[i] = dig[i - 1] * 2;
	}

	int t;
	cin >> t;
	for (int i = 0; i < t; ++i)
		solve();

	return 0;
}