#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()


int n, q;

const int N = 5e5 + 1;
int x[N], h[N];

inline bool canL(int pos, int part) {
    if (pos == 0) return 0;
    part = max(part, 0);
    return x[pos] - x[part] >= h[pos];
}

inline bool canR(int pos, int part) {
    if (pos == n - 1) return 0;
    part = min(part, n - 1);
    return x[part] - x[pos] >= h[pos];
}

bool dead[N];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> q;
    for(int i = 0; i < n; i++) {
        cin >> x[i] >> h[i];
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        --l; --r;
        int ans = 0;
        vector<int> d(r - l + 1);
        iota(all(d), l);
        int dr = 1;
        int di = 0;
        for(int run = 1; run;) {
            di ^= 1;
            run = 0;
            vector<int> nxt;
            int la;
            if (di) la = l - 1;
            else la = r + 1;
            if (di) {
                for (int i = 0; i < size(d); i++) {
                    int ne;
                    if (i + 1 == size(d)) ne = r + 1;
                    else ne = d[i + 1];
                    if (!canL(d[i], la) && !canR(d[i], ne)) {
                        nxt.push_back(d[i]);
                    } else ans++, run = 1;
                }
            } else {
                for(int i = 0; i < size(d); i++) {
                    int ne;
                    if (i + 1 == size(d)) ne = l - 1;
                    else ne = d[i + 1];
                    if (!canL(d[i], ne) && !canR(d[i], la)) {
                        nxt.push_back(d[i]);
                    } else ans++, run = 1;
                }
            }
            reverse(all(nxt));
            d = nxt;
        }
        cout << ans << '\n';
    }
}