#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("tune=native")

#define ios ios_base::sync_with_stdio(true);cin.tie(0);cout.tie(0);
#define ll long long
#define len(x) (int)(x.size())

const ll INF = 2e18;

ll c[] = {1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, 500000, 1000000, 5000000, 10000000, 50000000, 100000000, 500000000, 1000000000, 5000000000, 10000000000, 50000000000, 100000000000, 500000000000, 1000000000000, 5000000000000};
ll count(const string& s){
    ll ans = 0;
    int maxL = 0;
    for (int i = len(s)-1; i >= 0; --i) {
        ans += (s[i]-'A' < maxL ? -c[s[i]-'A'] : c[s[i]-'A']);
        maxL = max(s[i]-'A', maxL);
    }
    return ans;
}

void solve() {
    string s; cin >> s;
    string run2 = s;
    int n = len(s), cntQ = 0;
    vector<int> cntL(26);
    int maxL = 0;
    for (int i = n-1; i >= 0; --i) {
        if(s[i] == '?')
            ++cntQ;
        else if(s[i]-'A' >= maxL) {
            ++cntL[s[i] - 'A'];
            maxL = max(s[i]-'A', maxL);
        }else{
            run2[i] = '0';
        }
    }
    int curLt = 0;
    for (int i = n-1; i >= 0; --i) {
        if(s[i] != '?'){
            cntL[s[i]-'A'] = max(cntL[s[i]-'A']-1, 0);
            continue;
        }
        ll cumsum  = 2 * cntL[curLt] * c[curLt], bestDiff = 0;
        int best = curLt;
        for (int j = curLt+1; j < 26; ++j) {
            if((c[j] - c[curLt]) * cntQ - cumsum > bestDiff){
                best = j;
                bestDiff = (c[j] - c[curLt]) * cntQ - cumsum;
            }
            cumsum += 2 * cntL[j] * c[j];
        }
        curLt = best;
        s[i] = 'A' + curLt;
        --cntQ;
    }
    cntL.clear();
    cntL.resize(26);
    for (int i = 0; i < n; ++i) {
        if(run2[i] == '0') continue;
        if(run2[i] != '?'){
            ++cntL[run2[i] - 'A'];
            continue;
        }
        curLt = s[i] - 'A';
        ll cumsum  = 2 * cntL[curLt] * c[curLt], bestDiff = 0;
        int best = curLt;
        for (int j = curLt+1; j < 26; ++j) {
            if((c[j] - c[curLt]) - cumsum > bestDiff){
                best = j;
                bestDiff = (c[j] - c[curLt]) * cntQ - cumsum;
            }
            cumsum += 2 * cntL[j] * c[j];
        }
        curLt = best;
        s[i] = 'A' + curLt;
        cntL.clear();
        cntL.resize(26);
    }
    cout << count(s) << "\n";
    cout << s << "\n";
}

int main() {
    //freopen("input.txt", stdin, "r")
    //freopen("output.txt", stdout, "w")
    ios;
    int t;
    cin >> t;
    while(t--)
        solve();
    return 0;
}