#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <stdio.h>
#include <algorithm>
#include <math.h>

#include <cassert>

using namespace std;

#define ll long long 
#define FOR(i, Left, Right) for(ll  i = (Left); i <= (Right); ++i)
#define FOR_DOWN(i, Right, Left) for(ll  i = (Right); i >= (Left); --i)
#define pii pair <ll  , ll > 




const ll  cnt = 612345;

ll  n, m;
vector <pii> g[cnt];

ll  min_ans[cnt], max_ans[cnt];


bool used[cnt];

void dfs(int v)
{
	used[v] = 1;
	for (auto u : g[v])
	{
		if (!used[u.first])
		{
			min_ans[u.first] = min(min_ans[v], u.second);
			max_ans[u.first] = max(max_ans[v], u.second);
			dfs(u.first);
		}
	}
}

int main()
{

#ifdef _DEBUG
	freopen("Text.txt", "r", stdin);
#endif // _DEBUG
	cin >> n >> m;
	if (m != n - 1)
	{
		return 0;
	}
	FOR(i, 1, m)
	{
		ll  u1, v, tt;
		cin >> u1 >> v >> tt;
		g[u1].push_back({ v, tt });
		g[v].push_back({ u1, tt });
	}

	FOR(i, 1, n)
	{
		min_ans[i] = 11234567890;
		max_ans[i] = -2;
	}
	
	dfs(1);

	FOR(i, 2, n)
	{
		cout << min_ans[i] + max_ans[i] << '\n';
	}
}
