import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class C {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter writer = new PrintWriter(System.out);
        StringTokenizer st = new StringTokenizer(reader.readLine());
        int n = Integer.parseInt(st.nextToken());
        int q = Integer.parseInt(st.nextToken());
        int[] x = new int[n];
        int[] h = new int[n];
        for (int i = 0; i < n; ++i) {
            st = new StringTokenizer(reader.readLine());
            x[i] = Integer.parseInt(st.nextToken());
            h[i] = Integer.parseInt(st.nextToken());
        }
        int[] l = new int[n];
        int[] r = new int[n];
        boolean[] used = new boolean[n];
        for (int t = 0; t < q; ++t) {
            st = new StringTokenizer(reader.readLine());
            int left = Integer.parseInt(st.nextToken()) - 1;
            int right = Integer.parseInt(st.nextToken()) - 1;
            for (int i = 0; i < n; ++i) {
                l[i] = i - 1;
                r[i] = i + 1;
                used[i] = false;
            }
            LinkedList<Integer> rem = new LinkedList<>();
            for (int i = left; i <= right; ++i) {
                if (i != 0 && x[i] - x[i - 1] >= h[i]) {
                    if (!used[i]) {
                        rem.add(i);
                        used[i] = true;
                    }
                }
                if (i != n - 1 && x[i + 1] - x[i] >= h[i]) {
                    if (!used[i]) {
                        rem.add(i);
                        used[i] = true;
                    }
                }
            }
            int cnt = 0;
            for (int j = 0; j < n; ++j) {
                if (rem.size() == 0) {
                    break;
                }
                ++cnt;
                int ind = rem.pollLast();
                int le = l[ind];
                int re = r[ind];
                if (le != -1) {
                    r[le] = re;
                    if (re == n) {
                        if (x[n - 1] - x[le] >= h[le]) {
                            if (!used[le]) {
                                rem.add(le);
                                used[le] = true;
                            }
                        }
                    } else {
                        if (x[re] - x[le] >= h[le]) {
                            if (!used[le]) {
                                rem.add(le);
                                used[le] = true;
                            }
                        }
                    }
                }
                if (re != n) {
                    l[re] = le;
                    if (le == -1) {
                        if (-x[0] + x[re] >= h[re]) {
                            if (!used[re]) {
                                rem.add(re);
                                used[re] = true;
                            }
                        }
                    } else {
                        if (-x[le] + x[re] >= h[re]) {
                            if (!used[re]) {
                                rem.add(re);
                                used[re] = true;
                            }
                        }
                    }
                }
            }
            writer.println(cnt);
        }
        writer.close();
    }
}
