#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <map>
#include <vector>

using namespace std;

#define endl '\n'

const int Base = 3e5 + 10;
const long long inf = 1e18;

struct Gadged
{
	int x1, y1;
	int x2, y2;
};

map<pair<int, int>, int> wasE;
int n, m;
vector<pair<int, int>> e[Base];
bool dp[Base][5];
int rec[Base][5];
bool used[Base];
vector<Gadged> ans;
int cl = 0;
pair<int, int> del[2];

void upd(int id, int x, int y)
{
	int d = 0;
	if (x == y)
	{
		d = 0;
	}
	else if (x + 1 == y)
	{
		d = 2;
	}
	else if (x == y + 1)
	{
		d = 1;
	}
	else
	{
		return;
	}
	dp[id][d] = true;
	if (x == y && x > 0)
	{
		d = 3;
	}
	dp[id][d] = true;
}

void cntDp(int x, int p)
{
	used[x] = true;

	if (e[x].size() == 1 && p != 0)
	{
		dp[x][0] = true;
		return;
	}

	for (auto v : e[x])
	{
		if (v.first != p)
		{
			cntDp(v.first, x);
		}
	}

	int cnt1 = 0, cnt2 = 0;
	int float10 = 0;
	int float01 = 0;
	bool float11 = false;
	for (auto v : e[x])
	{
		if (v.first != p)
		{
			bool can11 = false;
			bool can01 = false;
			bool can10 = false;
			bool can00 = false;
			if (v.second == 3 && dp[v.first][0])
			{
				can11 = true;
			}
			if (dp[v.first][v.second])
			{
				can00 = true;
			}
			if ((v.second == 1 && dp[v.first][0]) || (v.second == 3 && dp[v.first][2]))
			{
				can10 = true;
			}
			if ((v.second == 2 && dp[v.first][0]) || (v.second == 3 && dp[v.first][1]))
			{
				can01 = true;
			}

			if (!can11 && !can01 && !can10 && !can00)
			{
				return;
			}
			else if (can11 && !can01 && !can10 && !can00)
			{
				cnt1++;
				cnt2++;
			}
			else if (!can11 && can01 && !can10 && !can00)
			{
				cnt2++;
			}
			else if (!can11 && !can01 && can10 && !can00)
			{
				cnt1++;
			}
			else if (!can11 && !can01 && !can10 && can00)
			{
				//
			}
			else if (can11 && can01 && !can10 && !can00)
			{
				cnt2++;
				float10++;
			}
			else if (can11 && !can01 && can10 && !can00)
			{
				cnt1++;
				float01++;
			}
			else if (can11 && !can01 && !can10 && can00)
			{
				float11 = true;
			}
			else if (!can11 && can01 && can10 && !can00)
			{
				float11 = true;
			}
			else if (!can11 && can01 && !can10 && can00)
			{
				float01++;
			}
			else if (!can11 && !can01 && can10 && can00)
			{
				float10++;
			}
		}
	}

	if (float01 && float10)
	{
		float11 = true;
	}

	if (float11)
	{
		cnt1++;
		cnt2++;
	}

	if (cnt1 < cnt2)
	{
		if (float10 >= cnt2 - 1 - cnt1)
		{
			float10 -= cnt2 - 1 - cnt1;
			cnt1 = cnt2 - 1;
		}
		else
		{
			return;
		}
		upd(x, cnt1, cnt2);
		if (float10 >= 1)
		{
			float10 -= 1;
			cnt1 = cnt2;
		}
		else
		{
			return;
		}
		upd(x, cnt1, cnt2);
		if (float10 >= 1)
		{
			float10 -= 1;
			cnt1 = cnt2 + 1;
		}
		else
		{
			return;
		}
		upd(x, cnt1, cnt2);
	}
	else if (cnt2 < cnt1)
	{
		if (float01 >= cnt1 - 1 - cnt2)
		{
			float01 -= (cnt1 - 1 - cnt2);
			cnt2 = cnt1 - 1;
		}
		else
		{
			return;
		}
		upd(x, cnt1, cnt2);
		if (float01 >= 1)
		{
			float01 -= 1;
			cnt2 = cnt1;
		}
		else
		{
			return;
		}
		upd(x, cnt1, cnt2);
		if (float01 >= 1)
		{
			float01 -= 1;
			cnt2 = cnt1 + 1;
		}
		else
		{
			return;
		}
		upd(x, cnt1, cnt2);
	}
	else
	{
		if (float01 > 0)
		{
			cnt2++;
			upd(x, cnt1, cnt2);
			cnt2--;
		}
		if (float10 > 0)
		{
			cnt1++;
			upd(x, cnt1, cnt2);
			cnt1--;
		}
		upd(x, cnt1, cnt2);
	}
}

int col[Base];

void paint(int x, int p, bool c)
{
	if (c)
	{
		col[x] = 1;
	}
	else
	{
		col[x] = 2;
	}

	for (auto v : e[x])
	{
		if (v.first != p)
		{
			paint(v.first, x, !c);
		}
	}
}

vector<int> path;
bool dfs(int x, int p)
{
	path.push_back(x);
	if (x == del[1].first || x == del[1].second)
	{
		return true;
	}

	for (auto v : e[x])
	{
		if (v.first != p)
		{
			if (dfs(v.first, x))
			{
				return true;
			}
		}
	}

	path.pop_back();
	return false;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		int d = 1;
		if (a > b)
		{
			d = 10;
			swap(a, b);
		}
		wasE[make_pair(a, b)] += d;
	}

	for (auto k : wasE)
	{
		if (k.second == 1)
		{
			e[k.first.first].push_back(make_pair(k.first.second, 1));
			e[k.first.second].push_back(make_pair(k.first.first, 2));
		}
		if (k.second == 10)
		{
			e[k.first.first].push_back(make_pair(k.first.second, 2));
			e[k.first.second].push_back(make_pair(k.first.first, 1));
		}
		if (k.second == 11)
		{
			e[k.first.first].push_back(make_pair(k.first.second, 3));
			e[k.first.second].push_back(make_pair(k.first.first, 3));
		}
		if (k.second == 1)
		{
			del[cl++] = (make_pair(k.first.second, k.first.first));
		}
		if (k.second == 10)
		{
			del[cl++] = (k.first);
		}
	}

	if (cl == 0)
	{
		cout << "Yes" << endl;
		for (auto k : wasE)
		{
			cout << k.first.first << ' ' << k.first.second << ' ' << k.first.second << ' ' << k.first.first << endl;
		}
		return 0;
	}

	paint(1, 0, true);

	/*if (col[del[0].first] == col[del[1].first])
	{
		cout << "No" << endl;
		return 0;
	}*/

	dfs(del[0].second, -1);
	if (path.empty())
	{
		swap(del[0], del[1]);
		dfs(del[0].second, -1);
	}

	if (path.back() == del[1].second)
	{
		path.push_back(del[1].first);
		if (path.size() <= 1 || path[1] != del[0].first)
		{
			if (path.size() % 2 == 0)
			{
				cout << "No" << endl;
				return 0;
			}
			cout << "Yes" << endl;
			int last = del[0].first;
			for (int i = 0; i < path.size() - 1; i++)
			{
				cout << path[i] << ' ' << last;
				last = path[i];
				if (i % 2)
				{
					cout << endl;
				}
				else
				{
					cout << ' ';
				}
			}

			for (int i = 1; i < path.size(); i++)
			{
				cout << path[i - 1] << ' ' << path[i];
				if (i % 2 == 0)
				{
					cout << endl;
				}
				else
				{
					cout << ' ';
				}
			}

			for (int i = 1; i < path.size(); i++)
			{
				int a = path[i];
				int b = path[i - 1];
				if (a > b)
				{
					swap(a, b);
				}
				wasE[make_pair(a, b)] = 0;
			}

			for (auto k : wasE)
			{
				if (k.second == 11)
				{
					cout << k.first.first << ' ' << k.first.second << ' ' << k.first.second << ' ' << k.first.first << endl;
				}
			}
		}
		else
		{
			if (path.size() % 2 == 1)
			{
				cout << "No" << endl;
				return 0;
			}
			cout << "Yes" << endl;
			for (int i = 1; i < path.size(); i++)
			{
				cout << path[i - 1] << ' ' << path[i];
				if (i % 2 == 0)
				{
					cout << endl;
				}
				else
				{
					cout << ' ';
				}
			}
			for (int i = 2; i < path.size() - 1; i++)
			{
				cout << path[i - 1] << ' ' << path[i];
				if (i % 2)
				{
					cout << endl;
				}
				else
				{
					cout << ' ';
				}
			}
			for (int i = 1; i < path.size() - 1; i++)
			{
				int a = path[i];
				int b = path[i - 1];
				if (a > b)
				{
					swap(a, b);
				}
				wasE[make_pair(a, b)] = 0;
			}

			for (auto k : wasE)
			{
				if (k.second == 11)
				{
					cout << k.first.first << ' ' << k.first.second << ' ' << k.first.second << ' ' << k.first.first << endl;
				}
			}
		}

	}
	else
	{
		path.push_back(del[1].second);
		if (path.size() <= 1 || path[1] != del[0].first)
		{
			if (path.size() % 2 == 1)
			{
				cout << "No" << endl;
				return 0;
			}
			cout << "Yes" << endl;
			int last = del[0].first;
			for (int i = 0; i < path.size(); i++)
			{
				cout << path[i] << ' ' << last;
				last = path[i];
				if (i % 2)
				{
					cout << endl;
				}
				else
				{
					cout << ' ';
				}
			}

			for (int i = 1; i < path.size() - 1; i++)
			{
				cout << path[i - 1] << ' ' << path[i];
				if (i % 2 == 0)
				{
					cout << endl;
				}
				else
				{
					cout << ' ';
				}
			}

			for (int i = 1; i < path.size() - 1; i++)
			{
				int a = path[i];
				int b = path[i - 1];
				if (a > b)
				{
					swap(a, b);
				}
				wasE[make_pair(a, b)] = 0;
			}

			for (auto k : wasE)
			{
				if (k.second == 11)
				{
					cout << k.first.first << ' ' << k.first.second << ' ' << k.first.second << ' ' << k.first.first << endl;
				}
			}
		}
		else
		{
			if (path.size() % 2 == 0)
			{
				cout << "No" << endl;
				return 0;
			}
			cout << "Yes" << endl;
			for (int i = 1; i < path.size() - 1; i++)
			{
				cout << path[i - 1] << ' ' << path[i];
				if (i % 2 == 0)
				{
					cout << endl;
				}
				else
				{
					cout << ' ';
				}
			}
			for (int i = 2; i < path.size(); i++)
			{
				cout << path[i] << ' ' << path[i - 1];
				if (i % 2)
				{
					cout << endl;
				}
				else
				{
					cout << ' ';
				}
			}
			for (int i = 1; i < path.size() - 1; i++)
			{
				int a = path[i];
				int b = path[i - 1];
				if (a > b)
				{
					swap(a, b);
				}
				wasE[make_pair(a, b)] = 0;
			}

			for (auto k : wasE)
			{
				if (k.second == 11)
				{
					cout << k.first.first << ' ' << k.first.second << ' ' << k.first.second << ' ' << k.first.first << endl;
				}
			}
		}
	}

	return 0;
}