#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
using namespace std;

const int maxN = 3e5 + 100;
const int INFi = 2e9;


void solve() {
    int n, q; cin >> n >> q;
    vector<int> x(n), h(n);
    range(i, n) cin >> x[i] >> h[i];
    vector<int> dpl(n, -INFi), dpr(n, INFi);
    for(int i = 0; i < n; ++i) {
        vector<int> stk = {i};
        int res = x[i] - h[i];
        for(int j = i - 1; j >= 0; --j) {
            while(!stk.empty()) {
                int e = stk.back();
                if (x[e] - h[e] >= x[j]) stk.pop_back();
            }
            if (stk.empty()) break;
            if (x[j] + h[j] <= x[stk.back()]) {
                continue;
            } else {
                res = min(res, x[j] - h[j]);
                stk.push_back(j);
            }
        }
        if (stk.empty()) dpl[i] = res;
    }
    for(int i = n - 1; i >= 0; --i) {
        vector<int> stk = {i};
        int res = x[i] + h[i];
        for(int j = i + 1; j < n; ++j) {
            while(!stk.empty()) {
                int e = stk.back();
                if (x[e] + h[e] <= x[j]) stk.pop_back();
            }
            if (stk.empty()) break;
            if (x[j] - h[j] >= x[stk.back()]) {
                continue;
            } else {
                res = max(res, x[j] + h[j]);
                stk.push_back(j);
            }
        }
        if (stk.empty()) dpr[i] = res;
    }

    /*
    bool good = true;
    while(good) {
        good = false;
        range(i, n) {
            if (x[i] - h[i] < x[0]) continue;
            if (dpl[i] != -INFi) continue;
            int cur = x[i] - h[i];
            for(int j = i - 1; j >= 0; --j) {
                if (x[j] <= x[i] - h[i]) break;
                if (dpr[j] <= x[i]) continue;
                cur = min(cur, dpl[j]);
            }
            dpl[i] = max(dpl[i], cur);
            if (dpl[i] != -INFi) good = true;
        }
        for(int i = n - 1; i >= 0; --i) {
            if (x[i] + h[i] > x[n - 1]) continue;
            if (dpr[i] != INFi) continue;
            int cur = x[i] + h[i];
            for(int j = i + 1; j < n; ++j) {
                if (x[j] >= x[i] + h[i]) break;
                if (dpl[j] >= x[i]) continue;
                cur = max(cur, dpr[j]);
            }
            dpr[i] = min(dpr[i], cur);
            if (dpr[i] != INFi) good = true;
        }
    }*/
    range(_, q) {
        int l, r; cin >> l >> r;
        int x1;
        if (l == 1) {
            x1 = x[0];
        } else {
            x1 = x[l-2];
        }
        int x2;
        if (r == n) {
            x2 = x[n - 1];
        } else {
            x2 = x[r];
        }
        int ans = 0;
        for(int i = l - 1; i < r; ++i) {
            if (dpl[i] >= x1 || dpr[i] <= x2) ans++;
        }
        cout << ans << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}