#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
using namespace std;

const int maxN = 3e5 + 5;
const int INFi = 2e9;

vector<pair<int, int>> g[maxN];
bool can[21][1<<20];
int w[maxN];
int cost[1<<20];

void dfs(int v, int mask) {
    if (can[v][mask]) return;
    can[v][mask] = true;
    for(auto &[u, i] : g[v]) {
        if (mask & (1 << i)) continue;
        dfs(u, mask | (1 << i));
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    range(i, m) {
        int u, v;
        cin >> u >> v >> w[i];
        g[u].emplace_back(v, i);
        g[v].emplace_back(u, i);
    }
    range(mask, 1 << m) {
        int mn = INFi;
        int mx = -INFi;
        if (mask == 0) continue;
        range(i, m) {
            if ((1 << i )& mask) {
                mn = min(mn, w[i]);
                mx = max(mx, w[i]);
            }
        }
        cost[mask] = mn + mx;
    }
    dfs(1, 0);
    for(int i = 2; i <= n; ++i) {
        int result = INFi;
        for(int mask = 0; mask < (1 << m); ++mask) {
            if (!can[i][mask]) continue;
            result = min(result, cost[mask]);
        }
        cout << result << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}