#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
using namespace std;

const int maxN = 3e5 + 100;
const int INFi = 2e9;
vector<pair<int, int>> g[maxN];
int dist[maxN];

void dfs(int v, int p, int mx, int mn) {
    dist[v] = mx + mn;
    for(auto &[u, w] : g[v]) {
        if (u == p) continue;
        dfs(u, v, max(mx, w), min(mn, w));
    }
}

void solve() {
    int n, m; cin >> n >> m;
    range(_, m) {
        int u, v, w; cin >> u >> v >> w;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    dfs(1, -1, 0, 1e9);
    for(int k = 2; k <= n; ++k) cout << dist[k] << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}