#include <iostream>
#include <vector>
using namespace std;

long long was[26];
long long will[26];
pair<long long, int> pref[26];

long long cost[26];

pair<int, int> answer[300002][26];

const long long inf = 1e18;

void move(int val, int ind) {
    if (pref[val].first != inf && pref[val].first + cost[val] > will[val])
        will[val] = pref[val].first + cost[val], answer[ind][val] = {val, pref[val].second};
    for (int j = val + 1; j < 26; ++j)
        if (was[j] != inf && will[j] < was[j] - cost[val])
            will[j] = was[j] - cost[val], answer[ind][j] = {val, j};
}

int main() {
    cost[0] = 1;
    for (int i = 1; i < 26; ++i) {
        if (i % 2 == 1)
            cost[i] = cost[i - 1] * 5;
        else
            cost[i] = cost[i - 1] * 2;
    }

    int t;
    cin >> t;
    while (t--) {
        string s;
        cin >> s;
        int n = s.size();
        for (int i = 0; i < 26; ++i)
            was[i] = -inf;
        if (s[n - 1] == '?') {
            for (int val = 0; val < 26; ++val) {
                was[val] = cost[val];
                answer[n - 1][val] = {val, -1};
            }
        } else {
            int val = s[n - 1] - 'A';
            was[val] = cost[val];
            answer[n - 1][val] = {val, -1};
        }
        pref[0] = {was[0], 0};
        for (int i = 1; i < 26; ++i) pref[i] = max(pref[i - 1], {was[i], i});
        for (int i = n - 2; i >= 0; --i) {
            for (int j = 0; j < 26; ++j)
                will[j] = -inf;
            if (s[i] == '?') {
                for (int val = 0; val < 26; ++val)
                    move(val, i);
            } else {
                int val = s[i] - 'A';
                move(val, i);
            }
            for (int j = 0; j < 26; ++j)
                was[j] = will[j];
            pref[0] = {was[0], 0};
            for (int j = 1; j < 26; ++j)
                pref[j] = max(pref[j - 1], {was[j], j});
        }
        long long ans = -inf;
        int stind;
        for (int i = 0; i < 26; ++i) {
            if (was[i] > ans) {
                ans = was[i];
                stind = i;
            }
        }
        cout << ans << '\n';
        for (int i = 0; i < n; ++i) {
            cout << (char)('A' + answer[i][stind].first);
            stind = answer[i][stind].second;
        }
        cout << '\n';
    }
    return 0;
}
