#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> edges(m);
    for (auto &el : edges) {
        cin >> get<0>(el) >> get<1>(el) >> get<2>(el);
    }
    sort(all(edges));
    const int INF = (int) 1e15;
    vector<int> res(n + 1, INF);
    for (auto el : edges) {
        if (get<0>(el) == 1) {
            res[get<1>(el)] = 2 * get<2>(el);
        }
        if (get<1>(el) == 1) {
            res[get<0>(el)] = 2 * get<2>(el);
        }
    }
    if (m > 1) {
        do {
            bool f1 = true;
            for (int i = 0; i < m - 1; i++) {
                int u1 = get<0>(edges[i]), v1 = get<1>(edges[i]);
                int u2 = get<0>(edges[i + 1]), v2 = get<1>(edges[i + 1]);
                if (u1 != u2 && u1 != v2 && v1 != u2 && v1 != v2) {
                    f1 = false;
                    break;
                }
            }
            if (!f1) {
                continue;
            }
            vector<int> verts;
            int uu1 = get<0>(edges[0]), vv1 = get<1>(edges[0]);
            int uu2 = get<0>(edges[1]), vv2 = get<1>(edges[1]);
            if (uu1 != uu2 && uu1 != vv2) {
                verts.push_back(uu1);
                verts.push_back(vv1);
            } else {
                verts.push_back(vv1);
                verts.push_back(uu1);
            }
            if (verts[0] != 1) {
                continue;
            }
            int mn = get<2>(edges[0]), mx = get<2>(edges[1]);
            for (int i = 1; i < m; i++) {
                int u1 = get<0>(edges[i]), v1 = get<1>(edges[i]);
                if (u1 != verts.back()) {
                    verts.push_back(u1);
                } else if (v1 != verts.back()) {
                    verts.push_back(v1);
                } else {
                    break;
                }
                mn = min(mn, get<2>(edges[i])), mx = max(mx, get<2>(edges[i]));
                res[verts.back()] = min(res[verts.back()], mn + mx);
            }
        } while (next_permutation(all(edges)));
    }
    for (int i = 2; i <= n; i++) {
        cout << res[i] << '\n';
    }
}