#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast")

#include <iostream>
#include <algorithm>
#include <fstream>
#include <cmath>
#include <math.h>
#include <fstream>
#include <set>
#include <vector>
#include <queue>
#include <iomanip>
#include <string>

using namespace std;

#define ll long long
#define BE(x) x.begin(), x.end()
#define endl '\n'

const int N = 4e5;

struct E
{
	int from, to, t;
};

vector<E> e[N];
int t[N];
int ans[N];

void dfs(int i = 0, int p = -1, int min1 = 1e9, int max1 = 0)
{
	ans[i] = min1 + max1;
	for (E j : e[i])
	{
		if (j.to != p)
		{
			dfs(j.to, j.from, min(min1, j.t), max(max1, j.t));
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++)
	{
		int a, b, t;
		cin >> a >> b >> t;
		a--;
		b--;
		e[a].push_back({ a,b,t });
		e[b].push_back({ b,a,t });
	}
	dfs();
	for (int i = 1; i < n; i++)
	{
		cout << ans[i] << endl;
	}
}