#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::pair;
using std::string;

using ll = long long;
using ld = long double;

vector<std::set<int>> go;
vector<std::set<int>> gi;
vector<std::set<int>> g;
vector<pair<pair<int, int>, pair<int, int>>> ans;
vector<bool> used;


pair<int, int> dfs (int u, int pt = -1) {
	used[u] = true;
	for (int v : g[u]) {
		if (v == pt)
			continue;
		auto p = dfs(v, u);
		if (p.first == -2)
			return {-2, -2};
		if (p.first == v) {
			auto it = go[u].find(v);
			if (it == go[u].end())
				return {-2, -2};
			ans.emplace_back((pair<int, int>){u, v}, p);
			go[u].erase(it);
		}
		if (p.second == v) {
			auto it = gi[u].find(v);
			if (it == gi[u].end())
				return {-2, -2};
			ans.emplace_back(p, (pair<int, int>){v, u});
			gi[u].erase(it);
		}
	}
	go[u].erase(pt);
	gi[u].erase(pt);
	while (!go[u].empty() && !gi[u].empty()) {
		ans.push_back(std::make_pair(std::make_pair(*gi[u].begin(), u), std::make_pair(u, *go[u].begin())));
		go[u].erase(go[u].begin());
		gi[u].erase(gi[u].begin());
	}
	if (go[u].size() + gi[u].size() > 1)
		return {-2, -2};
	if (go[u].size() + gi[u].size() == 0)
		return {-1, -1};
	if (go[u].size() > 0)
		return {u, *go[u].begin()};
	assert(gi[u].size() == 1);
	return {*gi[u].begin(), u};
}


int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;

	used.resize(n);

	g.resize(n);
	gi.resize(n);
	go.resize(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		go[u].insert(v);
		gi[v].insert(u);
		g[u].insert(v);
		g[v].insert(u);
	}


	for (int i = 0; i < n; ++i) {
		if (!used[i] && dfs(i).first != -1) {
			cout << "NO\n";
			return 0;
		}
	}
	cout << "YES\n";
	assert(ans.size() == m / 2);
	for (auto p : ans) {
		cout << p.first.first + 1 << ' ' << p.first.second + 1 <<
			' ' << p.second.first + 1 << ' ' << p.second.second + 1 << '\n';
	}

	return 0;
}