#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::pair;
using std::string;

using ll = long long;
using ld = long double;

const int INF = 1e9;

vector<std::set<pair<int, int>>> g;
vector<vector<pair<int, int>>> g1;
vector<int> ans, tin, up;

void dfs (int u, int p = -1) {
	static int t = 0;
	tin[u] = ++t;
	for (auto pr : g[u]) {
		int t = pr.second;
		int v = pr.first;
		if (v == p)
			continue;
		if (!tin[v]) {
			dfs(v, u);
			up[u] = std::max(up[u], up[v]);
			if (up[v] > tin[u]) {
				g1[u].push_back({v, t});
				g1[v].push_back({u, t});
				g[u].erase({v, t});
				g[v].erase({u, t});
			}
		}
		up[u] = std::max(up[u], tin[v]);
	}
}

vector<int> used;
vector<int> comp;

int dfs1 (int u) {
	used[u] = true;
	int res = INF;
	comp.push_back(u);
	for (auto p : g[u]) {
		int v = p.first;
		res = std::min(res, p.second);
		if (!used[v])
			res = std::max(res, dfs1(v));
	}
	return res;
}


void get (int u, int p = -1, int cur = INF) {
	ans[u] = cur;
	for (auto pr : g[u]) {
		int v = pr.first, t = pr.second;
		if (v != p)
			get(v, u, std::min(cur, t));
	}
}


int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;
	g.resize(n), ans.resize(n), g1.resize(n), tin.resize(n), up.resize(n), used.resize(n);

	vector<pair<int, pair<int, int>>> edges(m);
	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		--u, --v;
		g[u].insert({v, t});
		g[v].insert({u, t});
	}


	dfs(0);

	for (int u = 0; u < n; ++u) {
		if (!used[u]) {
			comp.clear();
			int t = dfs1(u);
			for (int i = 0; i < comp.size() - 1; ++i) {
				int u = comp[i], v = comp[i + 1];
				g1[u].push_back({v, t});
				g1[v].push_back({u, t});
			}
		}
	}


	get(0);

	for (int i = 1; i < n; ++i)
		cout << ans[i] + INF << ' ';



	return 0;
}