#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::pair;
using std::string;

using ll = long long;
using ld = long double;

const int INF = 1e9;

vector<std::set<int>> g;
vector<int> to, tt;
vector<int> ans;

vector<int> usede;

void dfs (int u, int end, pair<int, int> cur = {-INF, INF}) {
	ans[u] = std::min(ans[u], cur.first + cur.second);
	if (u == end)
		return;
	for (auto pr = g[u].begin(); pr != g[u].end(); ++pr) {
		int t = tt[*pr];
		int v = to[*pr];
		if (usede[(*pr) / 2])
			continue;
		usede[(*pr) / 2] = true;
		dfs(v, end, (pair<int, int>){std::max(cur.first, t), std::min(cur.second, t)});
		usede[(*pr) / 2] = false;
	}
}



int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;
	g.resize(n), ans.resize(n, 2 * INF), to.resize(2 * m), tt.resize(2 * m);
	usede.resize(m);

	vector<pair<int, pair<int, int>>> edges(m);
	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		--u, --v;
		g[u].insert(i * 2);
		g[v].insert(i * 2 + 1);
		to[i * 2] = v;
		to[i * 2 + 1] = u;
		tt[i * 2] = t;
		tt[i * 2 + 1] = t;
	}

	dfs(0, i);

	for (int i = 1; i < n; ++i)
		cout << ans[i] << '\n';



	return 0;
}