#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <fstream>

using namespace std;

typedef long long ll;

const int N = 500010;
const ll INFLL = 300010ll * 5000000000010ll;

ll zn[1000];

ll dp[N][28];
int pr[N][28];
char symb[N][28];

string s;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif
	zn['A'] = 1;
	for (char c = 'B'; c <= 'Z'; ++c) {
		if ((c - 'B') % 2 == 0)
			zn[c] = zn[c - 1] * 5ll;
		else
			zn[c] = zn[c - 1] * 2ll;
	}

	int t;
	cin >> t;

	while (t--) {
		cin >> s;
		for (int c = 0; c <= ('Z' - 'A'); ++c) {
			dp[s.size()][c] = 0;
		}
		for (int i = (int)s.size() - 1; i >= 0; --i) {
			fill(dp[i], dp[i] + 28, -INFLL);
			if (s[i] == '?') {
				for (int pc = 0; pc <= ('Z' - 'A'); ++pc) {
					for (int c = 0; c <= ('Z' - 'A'); ++c) {
						if (c >= pc) {
							if (dp[i][c] < dp[i + 1][pc] + zn[c + 'A']) {
								dp[i][c] = dp[i + 1][pc] + zn[c + 'A'];
								pr[i][c] = pc;
								symb[i][c] = c + 'A';
							}
							//dp[i][c] = max(dp[i][c], dp[i + 1][pc] + zn[c + 'A']);
						}
						else {
							if (dp[i][pc] < dp[i + 1][pc] - zn[c + 'A']) {
								dp[i][pc] = dp[i + 1][pc] - zn[c + 'A'];
								pr[i][pc] = pc;
								symb[i][pc] = c + 'A';
							}
							//dp[i][pc] = max(dp[i][pc], dp[i + 1][pc] - zn[c + 'A']);
						}
					}
				}
			}
			else {
				for (int pc = 0; pc <= ('Z' - 'A'); ++pc) {
					char c = s[i] - 'A';
					if (c >= pc) {
						if (dp[i][c] < dp[i + 1][pc] + zn[c + 'A']) {
							dp[i][c] = dp[i + 1][pc] + zn[c + 'A'];
							pr[i][c] = pc;
							symb[i][c] = c + 'A';
						}
						//dp[i][c] = max(dp[i][c], dp[i + 1][pc] + zn[c + 'A']);
					}
					else {
						if (dp[i][pc] < dp[i + 1][pc] - zn[c + 'A']) {
							dp[i][pc] = dp[i + 1][pc] - zn[c + 'A'];
							pr[i][pc] = pc;
							symb[i][pc] = c + 'A';
						}
						//dp[i][pc] = max(dp[i][pc], dp[i + 1][pc] - zn[c + 'A']);
					}
				}
			}
		}
		ll ans = -INFLL;
		char vc = -1;
		for (int pc = 0; pc <= ('Z' - 'A'); ++pc) {
			if (ans < dp[0][pc]) {
				ans = dp[0][pc];
				vc = pc;
			}
		}
		cout << ans << '\n';
		int i = 0;
		while (i < s.size()) {
			cout << symb[i][vc];
			vc = pr[i][vc];
			++i;
		}
		cout << '\n';
	}
}
