#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <stack>

using namespace std;

#define endl '\n'
#define int long long

void task()
{
	int n, q;
	cin >> n >> q;

	vector<pair<int, int>> v(n);

	for (int i = 0; i < n; i++)
	{
		cin >> v[i].first >> v[i].second;
	}

	for (int t = 0; t < q; t++)
	{
		if (n == 1)
		{
			cout << 0 << endl;
			continue;
		}

		set<int> coor;
		int l, r;
		cin >> l >> r;

		l--;
		r--;

		coor.insert(v[0].first);
		coor.insert(v.back().first);

		for (int i = 0; i <= n-1; i++)
		{
			coor.insert(v[i].first);
		}

		bool can = true;
		int count = 0;

		vector<bool> used(n, false);

		while (can)
		{
			can = false;

			for (int i = l; i <= r; i++)
			{
				if (!used[i])
				{
					auto it = coor.find(v[i].first);
					int h = v[i].second;
					bool flag = false;

					if (it == coor.begin())
					{
						auto prev = it;
						prev--;
						auto next = it;
						next++;

						if (abs(*it - *next) >= h)
						{
							flag = true;
						}
					}
					else if (it == --coor.end())
					{
						auto prev = it;
						prev--;
						auto next = it;
						next++;

						if (abs(*it - *prev) >= h)
						{
							flag = true;
						}
					}
					else
					{
						auto prev = it;
						prev--;
						auto next = it;
						next++;

						if (abs(*it - *next) >= h || abs(*it - *prev) >= h)
						{
							flag = true;
						}
					}

					if (flag)
					{
						can = true;
						used[i] = true;
						coor.erase(it);
						coor.insert(v[0].first);
						coor.insert(v.back().first);
						count++;
						break;
					}
				}
			}
		}

		cout << count << endl;
	}
}

long main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	task();

	return 0;
}