#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()

const int A = 26;
const ll INF = 2 * 1e18;
vector<ll> values;

void build_mn(vector<int> &mn, vector<int> &gaps, string &s){
    if (gaps.empty())
        return;
    int n = s.size(), m = gaps.size();
    mn.resize(m);
    int pos = m - 1;
    char mx = 'A';
    for (int i = n - 1; i >= 0; i--){
        if (s[i] == '?'){
            mn[pos] = mx - 'A';
            pos--;
        }
        else
            mx = max(mx, s[i]);
        //cout << "i: " << i << " mx: " << mx << endl;
    }
}

ll sum(vector<ll> &lst, int a, int b){
    ll ans = 0;
    for (int i = a; i < b; i++)
        ans += lst[i];
    return ans;
}

ll count(string &s){
    int n = s.size();
    ll ans = 0; char mx = 'A';
    for (int i = n - 1; i >= 0; i--){
        if (s[i] < mx)
            ans -= values[s[i] - 'A'];
        else
            ans += values[s[i] - 'A'];
        mx = max(mx, s[i]);
    }
    return ans;
}

void out(vector<vector<ll>> &dp, vector<vector<int>> &prev, string &s){
    int mx = max_element(dp.back().begin(), dp.back().end()) - dp.back().begin();
    //cout << "mx: " << (char)(mx + 'A');
    int n = s.size(), m = dp.size();

    int last = -1;
    for (int i = n - 1; i >= 0; i--)
        if (s[i] == '?'){
            last = i;
            break;
        }
    string tail = s.substr(last + 1, n - last - 1);
    cout << dp[m - 1][mx] + count(tail) << "\n";

    string missing;
    ll curr = mx; int pos = (int)dp.size() - 1;
    while (curr != -1){
        missing += (char)('A' + curr);
        curr = prev[pos--][curr];
    }
    reverse(missing.begin(), missing.end());

    pos = 0;

    for (int i = 0; i < n; i++)
        if (s[i] == '?')
            cout << missing[pos++];
        else
            cout << s[i];
    cout << endl;
}

void solution(){
    string s;
    cin >> s;
    int n = s.size();
    vector<int> gaps;
    for (int i = 0; i < n; i++)
        if (s[i] == '?')
            gaps.pb(i);
    int m = gaps.size();

    values.resize(A);
    values[0] = 1;
    for (int i = 1; i < A; i++){
        if (i % 2 == 0)
            values[i] = values[i - 1] * 2;
        else
            values[i] = values[i - 1] * 5;
    }

    if (m == 0){
        cout << count(s) << "\n" << s << endl;
        return;
    }

    vector<int> mn;
    build_mn(mn, gaps, s);
//    cout << "mn:\n";
//    for (int el : mn)
//        cout << (char)(el + 'A') << " ";
//    cout << endl;

    vector<vector<ll>> dp(m, vector<ll> (A, -INF));
    vector<vector<int>> prev(m, vector<int> (A, -1));

    vector<ll> lst(A);
    int pos = 0;
    for (int i = 0; i < n; i++){
        if (s[i] != '?')
            lst[s[i] - 'A'] += values[s[i] - 'A']; // Change element
        else{
            //cout << "pos: " << pos << endl;
            for (int letter = mn[pos]; letter < A; letter++){
                dp[pos][letter] = 0;
                if (pos > 0){
                    ll mx = max_element(dp[pos - 1].begin() + letter, dp[pos - 1].end()) - dp[pos - 1].begin();
                    prev[pos][letter] = mx;
                    dp[pos][letter] += dp[pos - 1][mx];
                }
                ll sm = -sum(lst, 0, letter) + sum(lst, letter, A);
                dp[pos][letter] += sm;

                dp[pos][letter] += values[letter];
                //cout << (char)(letter + 'A') << ": " << dp[pos][letter] << endl;
            }
            lst.assign(A, 0);
            pos++;
        }
    }

    out(dp, prev, s);
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int tests;
    cin >> tests;
    for (int test = 0; test < tests; test++){
        solution();
        //cout << "test " << test << " completed" << endl;
    }
    return 0;
}