#include <iostream>
#include <vector>

using namespace std;

struct Tree {
    int lef;
    int rig;
    int coord;
    int high;
    Tree(int _lef=0, int _rig=0, int x=0, int h=0) {
        lef = _lef;
        rig = _rig;
        coord = x;
        high = h;
    }
};

Tree ddata[505];
bool del[505];
int n;

int get_max_del(int l, int r) {
    if (l == r) {
        if (del[l]) {
            //cout << l << ' ' << r << " 1\n";
            return 1;
        }
        int rig = ddata[l].rig;
        int lef = ddata[l].lef;
        /*if (l == 0 && r == 0) {
            cout << rig << ' ' << lef << '\n';
        }*/
        if (ddata[rig].coord - ddata[l].coord >= ddata[l].high) {
            del[l] = true;
            ddata[lef].rig = rig;
            ddata[rig].lef = lef;
            //cout << l << ' ' << r << " 1\n";
            return 1;
        }
        else if (ddata[l].coord - ddata[lef].coord >= ddata[l].high) {
            del[l] = true;
            ddata[lef].rig = rig;
            ddata[rig].lef = lef;
            //cout << l << ' ' << r << " 1\n";
            return 1;
        }
        //cout << l << ' ' << r << " 0\n";
        return 0;
    }
    if (del[l]) {
        /*    int ans = 1 + get_max_del(l + 1, r);
        cout << l << ' ' << r << ' ' << ans << '\n';*/
        return 1 + get_max_del(l + 1, r);
    }
    int lef = ddata[l].lef;
    if (ddata[l].coord - ddata[lef].coord >= ddata[l].high) {
        del[l] = true;
        int rig = ddata[l].rig;
        ddata[lef].rig = rig;
        ddata[rig].lef = lef;
        /*int ans = 1 + get_max_del(l + 1, r);
        cout << l << ' ' << r << ' ' << ans << '\n';*/
        return 1 + get_max_del(l + 1, r);
    }
    int max_del = get_max_del(l + 1, r);
    int rig = ddata[l].rig;
    if (ddata[rig].coord - ddata[l].coord >= ddata[l].high) {
        del[l] = true;
        ddata[lef].rig = rig;
        ddata[rig].lef = lef;
        /*int ans = 1 + get_max_del(l + 1, r);
        cout << l << ' ' << r << ' ' << ans << '\n';*/
        return 1 + get_max_del(l + 1, r);
    }
    //cout << l << ' ' << r << ' ' << max_del << '\n';
    return max_del;
}

int main()
{
    int q;
    cin >> n;
    cin >> q;
    for (int i = 0; i < n; ++i) {
        int x, h;
        cin >> x;
        cin >> h;
        if (i == 0) {
            ddata[i] = Tree(0, 1, x, h);
        }
        else if (i == n - 1) {
            ddata[i] = Tree(i - 1, i, x, h);
        }
        else {
            ddata[i] = Tree(i - 1, i + 1, x, h);
        }
    }
    for (int t = 0; t < q; ++t) {
        int l, r;
        cin >> l;
        cin >> r;
        l--;
        r--;
        for (int i = 0; i < n; ++i) {
            del[i] = false;
            int x = ddata[i].coord;
            int h = ddata[i].high;
            if (i == 0) {
                ddata[i] = Tree(0, 1, x, h);
            }
            else if (i == n - 1) {
                ddata[i] = Tree(i - 1, i, x, h);
            }
            else {
                ddata[i] = Tree(i - 1, i + 1, x, h);
            }
        }
        cout << get_max_del(l, r) << '\n';
    }
    return 0;
}
