#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>;
using namespace std;

const int M=405;

vector<int>kon[M];
vector<int>nac[M];
int ord[M][M];
vector<pair<int, int>>e;
vector<int>all[405];
int mt[2*M];
int used[2*M];
int step = 1;
bool kun(int v) {
	if (used[v] == step)
		return false;
	used[v] = step;
	for (auto to : all[v]) {
		if (mt[to] == -1) {
			mt[to] = v;
			return true;
		}
	}
	for (auto to : all[v]) {
		if (kun(mt[to])) {
			mt[to] = v;
			return true;
		}
	}
	return false;
}

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		kon[b].push_back(a);
		nac[a].push_back(b);
		ord[a][b] = i+1;
		e.push_back({ a,b });
	}
	for (int i = 0; i < n; i++) {
		for (auto c : kon[i]) {
			int x = c;
			for (auto g : nac[i]) {
				if (g == x && g > i)
					continue;
				all[ord[x][i]].push_back(M+ord[i][g]);
			}
		}
	}
	int M1 = 0;
	for (int i = 0; i < 2 * M; i++)
		mt[i] = -1;
	for (int i = 0; i < m; i++) {
		if (kun(i)) {
			step++;
			M1++;
		}
	}
	if (M1 < m / 2) {
		cout << "No";
		return;
	}
	cout << "Yes" << '\n';
	for (int i = 0; i < 2 * M; i++) {
		if (mt[i] == -1)
			continue;
		int pos = i - M-1;
		int x = e[pos].first;
		int y = e[pos].second;
		cout << x + 1 << ' ' << y + 1 << ' ';
		pos = mt[i]-1;
		x = e[pos].first;
		y = e[pos].second;
		cout << x + 1 << ' ' << y + 1 << '\n';
	}
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	
	int t;
	//cin >> t;
	t = 1;
	while (t) {

		t--;
		solve();
	}
}
