#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e18;

int n, m;
vector <vector <pair <int, int> > > gr;
multiset <int> all;
vector <int> ans;

void dfs(int v, int p) {
    if (v) {
        int min_el = *all.begin();
        int max_el = *all.rbegin();
        ans[v] = min_el + max_el;
    }
    for (auto el : gr[v]) {
        int to = el.first, w = el.second;
        if (to == p)
            continue;
        all.insert(w);
        dfs(to, v);
        all.erase(all.find(w));
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    gr.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        gr[a].push_back({b, w});
        gr[b].push_back({a, w});
    }
    ans.resize(n);
    dfs(0, -1);
    for (int i = 1; i < n; i++)
        cout << ans[i] << "\n";
    return 0;
}
