#include <bits/stdc++.h>
#pragma optimaze("Ofast")
using namespace std;

typedef long long ll;


#define mmp make_pair





const int maxn = 150000;
char dp[maxn][3];
vector<vector<pair<int, int>>> g(maxn);
vector<char> used(maxn), usd(maxn);


pair<int, int> walk(int v, vector<pair<pair<int, int>, pair<int, int>>> & ans) {
    vector<int> cntup, cntdwn;
    usd[v] = true;
    dp[v][0] = false;
    dp[v][1] = false;
    dp[v][2] = false;
    bool dead = false;
    for (auto eg : g[v]) {
        int to = eg.first;
        int t = eg.second;
        if (usd[to]) continue;
        pair<int, int> tt = walk(to, ans);
        if (t == 1) {
            if (dp[to][0]) {
                ans.emplace_back(mmp(to, v), mmp(v, to));
                continue;
            }
            if (dp[to][1]) {
                ans.emplace_back(mmp(v, to), tt);
                cntup.push_back(to);
                continue;
            }
            if (dp[to][2]) {
                ans.emplace_back(tt, mmp(to, v));
                cntdwn.push_back(to);
                continue;
            }
            dead = true;
            continue;
        }
        if (t == 2) {
            if (dp[to][0]) {
                cntdwn.push_back(to);
                continue;
            }
            if (dp[to][1]) {
                ans.emplace_back(mmp(v, to), tt);
                continue;
            }
            dead = true;
            continue;
        }
        if (t == 3) {
            if (dp[to][0]) {
                cntup.push_back(to);
                continue;
            }
            if (dp[to][2]) {
                ans.emplace_back(tt, mmp(to, v));
                continue;
            }
            dead = true;
            continue;
        }
    }
    if (dead) return {-1, -1};
    if (cntup.size() == cntdwn.size()) {
        int nn = cntup.size();
        for (int i = 0; i < nn; i++) {
            ans.emplace_back(mmp(cntup[i], v), mmp(v, cntdwn[i]));
        }
        dp[v][0] = true;
        return {-1, -1};
    }
    if (cntup.size() + 1 == cntdwn.size()) {
        int nn = cntup.size();
        for (int i = 0; i < nn; i++) {
            ans.emplace_back(mmp(cntup[i], v), mmp(v, cntdwn[i]));
        }
        dp[v][1] = true;
        return {v, cntdwn.back()};
    }

    if (cntup.size() == cntdwn.size() + 1) {
        int nn = cntdwn.size();
        assert(cntup.size() == nn + 1);
        for (int i = 0; i < nn; i++) {
            ans.emplace_back(mmp(cntup[i], v), mmp(v, cntdwn[i]));
        }
        dp[v][2] = true;
        return {cntup.back(), v};
    }
    return {-1, -1};
}






int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m; cin >> n >> m;
    vector<pair<pair<int, int>, int>> eg;

    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b;
        a--; b--;
        if (a < b) {
            eg.push_back(mmp(mmp(a, b), 1));
        } else {
            eg.push_back(mmp(mmp(b, a), -1));
        }
    }
    sort(eg.begin(), eg.end());
    for (int i = 0; i < m; i++) {
        if (i != m - 1 && eg[i].first == eg[i + 1].first) {
            int a = eg[i].first.first, b = eg[i].first.second;
            g[a].push_back(mmp(b, 1));
            g[b].push_back(mmp(a, 1));
            i++;
        } else {
            int a = eg[i].first.first, b = eg[i].first.second;
            int c = eg[i].second;
            if (c == 1) {
                g[a].push_back(mmp(b, 2));
                g[b].push_back(mmp(a, 3));
            } else {
                g[a].push_back(mmp(b, 3));
                g[b].push_back(mmp(a, 2));
            }
        }
    }
    vector<pair<pair<int, int>, pair<int, int>>> ans;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            walk(i, ans);
            if (!dp[i][0]) {
                cout << "No" << endl;
                return 0;
            }
        }
    }
    cout << "Yes" << endl;

    for (auto el : ans) {
        pair<int, int> i1 = el.first, i2 = el.second;
        cout << i1.first + 1 << " " << i1.second + 1 << " ";
        cout << i2.first + 1 << " " << i2.second + 1 << endl;
    }




    return 0;
}
