#include <bits/stdc++.h>

#define int long long

#define all(x) (x).begin(), (x).end()

using namespace std;


void solve() {
    vector<int> price = {1};
    for (int i = 1; i < 26; i++) {
        if (i % 2 == 1) {
            price.push_back(price.back() * 5);
        } else {
            price.push_back(price.back() * 2);
        }
    }

    string ss;
    cin >> ss;
    int n = ss.size();

    vector <int> q(n);
    for (int i = 0; i < n; i++) {
        if (ss[i] == '?') {
            q[i]++;
        }
    }

    vector <int> s(n), suf_max(n + 1);
    suf_max.back() = 0;

    for (int i = n - 1; i > -1; i--) {
        if (ss[i] != '?') {
            s[i] = ss[i] - 'A';
        } else {
            s[i] = suf_max[i + 1];
        }
        suf_max[i] = max(suf_max[i + 1], s[i]);
    }

    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == suf_max[i]) {
            ans += price[s[i]];
        } else {
            ans -= price[s[i]];
        }
    }

    vector <int> cnt(26);

    for (int i = 0; i < n; i++) {
        if (!q[i]) {
            cnt[s[i]]++;
            continue;
        }

        while (s[i] < 25) {
            int add = price[s[i] + 1] - price[s[i]];
            int del = (suf_max[i] != s[i] ? 0 : cnt[s[i]] * price[s[i]] * 2);
            if (add >= del) {
                s[i]++;
                ans += add - del;
                suf_max[i] = max(suf_max[i], s[i]);
            } else {
                break;
            }
        }
        cnt[s[i]]++;
    }

    cout << ans << "\n";
    for (int i : s)
        cout << (char) (i + 'A');
    cout << "\n";
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;
    while (q--)
        solve();
    return 0;
}
