#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

vector<pair<int, int>> a;

bool can_erase(int i, vector<pair<int, int>> &next, vector<int> &now) {
	int p = now[next[i].first];
	int nxt = now[next[i].second];
	int v = now[i];
	if (a[p].first + a[v].second <= a[v].first && 
		a[p].first + a[v].second <= a[now.back()].first)
		return true;
	if (a[nxt].first- a[v].second >= a[v].first &&
		a[nxt].first - a[v].second >= a[now[0]].first)
		return true;
	return false;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, q;
	cin >> n >> q;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	while (q--) {
		int l, r;
		cin >> l >> r;
		vector<int> now;
		now.push_back(max(0, l - 2));
		for (int i = l - 1; i < r; ++i)
			now.push_back(i);
		now.push_back(min(n - 1, r));
		int c = now.size();
		vector<pair<int, int>> next(c);
		vector<int> st;
		vector<int> used(c);
		for (int i = 1; i < c - 1; ++i) {
			next[i] = {i - 1, i + 1};
			if (can_erase(i, next, now)) {
				st.push_back(i);
				used[i] = 1;
			}
		}
		int ans = 0;
		while (st.size()) {
			int v = st.back();
			st.pop_back();
			++ans;
			next[next[v].first].second = next[v].second;
			next[next[v].second].first = next[v].first;
			if (next[v].second != c - 1 && !used[next[v].second]) {
				if (can_erase(next[v].second, next, now)) {
					st.push_back(next[v].second);
					used[next[v].second] = 1;
				}
			}
			if (next[v].first != 0 && !used[next[v].first]) {
				if (can_erase(next[v].first, next, now)) {
					st.push_back(next[v].first);
					used[next[v].first] = 1;
				}
			}
		}
		cout << ans << '\n';
	}
}