#include <iostream>
#include "vector"
#include "map"
#include "string"

using namespace std;

map<char, long long> mp = {{'A', 1}, {'B', 5}, {'C', 10}, {'D', 50}, {'E', 100}, {'F', 500}, {'G', 1000}, {'H', 5000}, {'I', 10000}, {'J', 50000}, {'K', 1e5}, {'L', 5 * 1e5}, {'M', 1e6}, {'N', 5 * 1e6}, {'O', 1e7}, {'P', 5 * 1e7}, {'Q', 1e8}, {'R', 5 * 1e8}, {'S', 1e9}, {'T', 5 * 1e9}, {'U', 1e10}, {'V', 5 * 1e10}, {'W', 1e11}, {'X', 5 * 1e11}, {'Y', 1e12}, {'Z', 5 * 1e12}};

long long calc(string s) {
    long long ans = 0;
    char mx = 'A';
    for (long long i = s.size() - 1; i >= 0; --i) {
        if (s[i] >= mx) {
            ans += mp[s[i]];
        } else {
            ans -= mp[s[i]];
        }
        mx = max(mx, s[i]);
    }
    return ans;
}

signed main() {
    long long t; cin >> t;
    for (long long i = 0; i < t; ++i) {
        string s; cin >> s;
        long long numv = 0;
        for (auto el : s) {
            if (el == '?') {
                numv++;
            }
        }
        if (numv == 0) {
            cout << calc(s) << endl;
            cout << s << endl;
        } else if (numv == 1) {
            long long ind;
            for (long long j = 0; j < s.size(); ++j) {
                if (s[j] == '?') {
                    ind = j;
                    break;
                }
            }
            long long ans = -1e18;
            string as;
            for (char j = 'A'; j <= 'Z'; ++j) {
                string s1 = s.substr(0, ind) + j;
                if (ind + 2 < s.size()) {
                    s1 += s.substr(ind + 2, s.size() - ind - 2);
                }
                long long tr = calc(s1);
                if (tr > ans) {
                    ans = tr;
                    as = s1;
                }
            }
            cout << ans << endl;
            cout << as << endl;
        } else if (numv == 2) {
            long long ind1 = -1, ind2 = -1;
            for (long long j = 0; j < s.size(); ++j) {
                if (s[j] == '?') {
                    if (ind1 == -1) {
                        ind1 = j;
                    } else {
                        ind2 = j;
                        break;
                    }
                }
            }
            long long ans = -1e18;
            string as;
            for (char j = 'A'; j <= 'Z'; ++j) {
                for (char k = 'A'; k <= 'Z'; ++k) {
                    string s1;
                    for (long long l = 0; l < s.size(); ++l) {
                        if (l == ind1) {
                            s1 += j;
                        } else if (l == ind2) {
                            s1 += k;
                        } else {
                            s1 += s[l];
                        }
                    }
                    long long tr = calc(s1);
                    if (tr > ans) {
                        ans = tr;
                        as = s1;
                    }
                }
            }
            cout << ans << endl;
            cout << as << endl;
        } else {
            long long ind1 = -1, ind2 = -1, ind3 = -1;
            for (long long j = 0; j < s.size(); ++j) {
                if (s[j] == '?') {
                    if (ind1 == -1) {
                        ind1 = j;
                    } else if (ind2 == -1) {
                        ind2 = j;
                    } else {
                        ind3 = j;
                        break;
                    }
                }
            }
            long long ans = -1e18;
            string as;
            for (char j = 'A'; j <= 'Z'; ++j) {
                for (char k = 'A'; k <= 'Z'; ++k) {
                    for (char g = 'A'; g <= 'Z'; ++g) {
                        string s1;
                        for (long long l = 0; l < s.size(); ++l) {
                            if (l == ind1) {
                                s1 += j;
                            } else if (l == ind2) {
                                s1 += k;
                            } else if (l == ind3) {
                                s1 += g;
                            } else {
                                s1 += s[l];
                            }
                        }
                        long long tr = calc(s1);
                        if (tr > ans) {
                            ans = tr;
                            as = s1;
                        }
                    }
                }
            }
            cout << ans << endl;
            cout << as << endl;
        }
    }
}