#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(),x.end()


int32_t main() {
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> E(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        if (u > v) swap(u, v);
        assert(u == v-1);
        E[u].push_back(c);
    }

    int mn = 1e15, mx = -1e15;
    for (int i = 0; i < n-1; ++i) {
        mn = min(mn, *min_element(all(E[i])));
        mx = max(mx, *min_element(all(E[i])));
        cout << mn + mx << ' ';
    }
}