#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(),x.end()


int32_t main() {
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> E(n);
    vector<int> sz(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        if (u > v) swap(u, v);
        assert(u == v-1);
        E[u].push_back(c);
    }

    for (int i = 0; i < n-1; ++i) {
        sort(all(E[i]));
    }

    for (int i = 0; i < n-1; ++i) {
        int mn = 1e15, mx = -1e15;

        for (int j = 0; j <= i; ++j) {
            mn = min(mn, E[j][0]);
            mx = max(mx, E[j][0]);
        }
        int res = mn + mx;
        for (int j = i+1; j < n-1; ++j) {
            if (E[j].size() >= 2) {
                mn = min(mn, E[j][0]);
                mx = max(mx, E[j][1]);
                res = min(res, mn + mx);
            } else {
                break;
            }
        }
        cout << res << '\n';
    }
}