#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define pii pair <int, int>
#define sz(a) (int)(a).size()

typedef long long ll;
#define int ll

const int inf = 1e9 + 100;
const int inf64 = 1ll * inf * inf;

vector <int> precalc(26);

void build_precalc(){
    if(precalc[0] != 0)
        return;
    precalc[0] = 1;
    for(int i = 1; i < 26; ++i){
        if(i % 2){
            precalc[i] = precalc[i - 1] * 5;
        }
        else{
            precalc[i] = precalc[i - 1] * 2;
        }
    }
}

void run(){
    build_precalc();
    string s;
    cin >> s;
    int n = sz(s);
    vector <vector <int>> dp(n, vector <int>(26, -inf64));
    vector <vector <int>> now(n, vector <int>(26, -1));
    if(s[n - 1] == '?'){
        for(int l = 0; l < 26; ++l){
            dp[n - 1][l] = precalc[l];
            now[n - 1][l] = l;
        }
    }
    else{
        dp[n - 1][s[n - 1] - 'A'] = precalc[s[n - 1] - 'A'];
        now[n - 1][s[n - 1] - 'A'] = s[n - 1] - 'A';
    }
    vector <vector <int>> prev(n, vector <int>(26, -1));
    for(int i = n - 2; i >= 0; --i){
        for(int p = 0; p < 26; ++p){
            if(s[i] == '?'){
                for(int l = 0; l < 26; ++l){
                    if(l >= p){
                        if(dp[i + 1][p] + precalc[l] > dp[i][l]){
                            prev[i][l] = p;
                            dp[i][l] = dp[i + 1][p] + precalc[l];
                            now[i][l] = l;
                        }
                    }
                    else{
                        if(dp[i + 1][p] - precalc[l] > dp[i][l]){
                            prev[i][p] = p;
                            dp[i][p] = dp[i + 1][p] - precalc[l];
                            now[i][p] = l;
                        }
                    }
                }
            }
            else{
                int l = s[i] - 'A';
                if(l >= p){
                    if(dp[i + 1][p] + precalc[l] > dp[i][l]){
                        prev[i][l] = p;
                        dp[i][l] = dp[i + 1][p] + precalc[l];
                        now[i][l] = l;
                    }
                }
                else{
                    if(dp[i + 1][p] - precalc[l] > dp[i][l]){
                        prev[i][p] = p;
                        dp[i][p] = dp[i + 1][p] - precalc[l];
                        now[i][p] = l;
                    }
                }
            }
        }
    }
    string sans;
    sans.resize(n);
    int ans_id = -1;
    int ans = -inf64;
    for(int i = 0; i < 26; ++i){
        if(dp[0][i] > ans){
            ans = dp[0][i];
            ans_id = i;
        }
    }
    int ti = 0;
    int tv = ans_id;
    while(ti != n){
        sans[ti] = now[ti][tv] + 'A';
        tv = prev[ti][tv];
        ti++;
    }
    cout << ans << '\n' << sans << '\n';
}

signed main(){
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(0);
    int t = 1;
    cin >> t;
    while(t--){
        run();
    }
}