#include <bits/stdc++.h>

template<class T>
std::istream& operator>>(std::istream &in, std::vector<T> &a) {
    for (auto &x : a)
        in >> x;
    return in;
}
template<class T>
std::ostream& operator<<(std::ostream &out, const std::vector<T> &a) {
    for (auto &x : a)
        out << x << " ";
    return out;
}

template<class T, class U>
std::istream& operator>>(std::istream &in, std::pair<T, U> &a) {
    in >> a.first >> a.second;
    return in;
}
template<class T, class U>
std::ostream& operator<<(std::ostream &out, const std::pair<T, U> &a) {
    out << a.first << " " << a.second;
    return out;
}

bool is_sym(char c) {
    return 'A' <= c && c <= 'Z';
}
std::vector<int64_t> cost = {};
void init() {
    cost.emplace_back(1);
    for (int i = 1; i <= 'Z' - 'A'; ++i)
        cost.emplace_back(cost.back() * (i & 1 ? 5ll : 2ll));
}
int64_t foo(char c) {
    return cost[c - 'A'];
}
const int64_t K = 'Z' - 'A' + 1, INF = 2e18;

void solve() {
    std::string s;
    std::cin >> s;
    int n = static_cast<int>(s.size());
    std::vector<std::vector<int64_t>> dp(n, std::vector<int64_t>(K, -INF));
    if (is_sym(s[n - 1])) {
        dp[n - 1][s[n - 1] - 'A'] = foo(s[n - 1]);
    } else {
        for (char c = 'A'; c <= 'Z'; ++c) {
            dp[n - 1][c - 'A'] = foo(c);
        }
    }
    for (int i = n - 2; i >= 0; --i) {
        if (is_sym(s[i])) {
            for (char c = 'A'; c <= 'Z'; ++c) {
                if (s[i] >= c) {
                    dp[i][s[i] - 'A'] = std::max(dp[i][s[i] - 'A'], dp[i + 1][c - 'A'] + foo(s[i]));
                } else {
                    dp[i][c - 'A'] = std::max(dp[i][c - 'A'], dp[i + 1][c - 'A'] - foo(s[i]));
                }
            }
        } else {
            for (char si = 'A'; si <= 'Z'; ++si) {
                for (char c = 'A'; c <= 'Z'; ++c) {
                    if (si >= c) {
                        dp[i][si - 'A'] = std::max(dp[i][si - 'A'], dp[i + 1][c - 'A'] + foo(si));
                    } else {
                        dp[i][c - 'A'] = std::max(dp[i][c - 'A'], dp[i + 1][c - 'A'] - foo(si));
                    }
                }
            }
        }
    }
//    for (auto lol : dp)
//        std::cerr << lol << std::endl;
    std::cout << *std::max_element(dp[0].begin(), dp[0].end()) << "\n";
    std::string ans = "";
    int curc = std::max_element(dp[0].begin(), dp[0].end()) - dp[0].begin();
    for (int i = 0; i + 1 < n; ++i) {
        if (is_sym(s[i])) {
            ans.push_back(s[i]);
            for (char c = 'A'; c <= 'A' + curc; ++c) {
                if (s[i] >= c) {
                     if (dp[i][curc] == dp[i + 1][c - 'A'] + foo(s[i])) {
                         curc = c - 'A';
                         break;
                     }
                } else {
                    if (dp[i][curc] == dp[i + 1][c - 'A'] - foo(s[i])) {
                        curc = c - 'A';
                        break;
                    }
                }
            }
        } else {
            for (char si = 'A'; si <= 'A' + curc; ++si) {
                for (char c = 'A'; c <= 'A' + curc; ++c) {
                    if (si >= c) {
                        if (dp[i][curc] == dp[i + 1][c - 'A'] + foo(si)) {
                            curc = c - 'A';
                            ans.push_back(si);
                            goto brek;
                        }
                    } else {
                        if (dp[i][curc] == dp[i + 1][c - 'A'] - foo(si)) {
                            curc = c - 'A';
                            ans.push_back(si);
                            goto brek;
                        }
                    }
                }
            }
            brek:;
        }
    }
    ans.push_back('A' + curc);
    std::cout << ans << "\n";
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0), std::cout.tie(0);
    init();
    //std::cerr << cost << std::endl;
    int t;
    std::cin >> t;
    while (t--)
        solve();
    return 0;
}
