#include<bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define fast cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
//typedef long long ll;
typedef long double ld;

const int N = 1e5;
const int MOD = 1e9 + 7;
const int INF = 1.7e18;

vector<vector<pair<int, int> > > gr;
vector<int> minn, maxx;

void dfs(int v, int p, int cmin, int cmax) {
    minn[v] = cmin;
    maxx[v] = cmax;
    for (auto [u, t] : gr[v]) {
        if (u == p) continue;
        dfs(u, v, min(cmin, t), max(cmax, t));
    }
}

signed main() {
#ifdef parasha
    freopen("Untitled2.cpp", "r", stdin);
#endif // parasha
    fast;
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    minn.resize(n);
    maxx.resize(n);
    vector<int> a(n, INF);
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        v--; u--;
        if (u < v) swap(v, u);
        assert(v == u - 1);
        a[v] = min(a[v], t);
    }
    minn[0] = a[0];
    maxx[0] = a[0];
    for (int i = 1; i < n - 1; i++) {
        minn[i] = min(minn[i - 1], a[i]);
        maxx[i] = max(maxx[i - 1], a[i]);
    }
    for (int i = 0; i < n - 1; i++) {
        cout << minn[i] + maxx[i] << ' ';
    }
    cout << '\n';
}
