#include <iostream>
#include <string>
#include <map>
using namespace std;

map <char, long long> d;
string al = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

pair<bool, long long> summ(string s)
{
	long long ans = 0;
	char maxi = '.';
	for (int i = s.size() - 1; i >= 0; i--)
	{
		if (s[i] == '?')
			return make_pair(false, 0);
		if (s[i] >= maxi)
		{
			ans += d[s[i]];
			maxi = s[i];
		}
		else
			ans -= d[s[i]];
	}
	return make_pair(true, ans);
}

pair <pair<bool, long long>, string> gen(string s, int ind, pair <pair<bool, long long>, string> ans)
{
	if (ind == -1)
	{
		pair<bool, long long> elem = summ(s);
		if (elem.first && (!((ans.first).first) || elem.second > (ans.first).second))
			ans = make_pair(elem, s);
	}
	else
	{
		if (s[ind] != '?')
			ans = gen(s, ind - 1, ans);
		else
		{
			for (int i = 0; i < al.size(); i++)
			{
				string neww = "";
				for (int j = 0; j < s.size(); j++)
				{
					if (j == ind)
						neww += al[i];
					else
						neww += s[j];
				}
				ans = gen(neww, ind - 1, ans);
			}
		}
	}
	return ans;
}

int main()
{
	long long t; cin >> t;
	d[al[0]] = 1;
	long long x = 5;
	for (int i = 1; i < 27; i += 2)
	{
		d[al[i]] = x; x *= 10;
	}
	x = 10;
	for (int i = 2; i < 27; i += 2)
	{
		d[al[i]] = x; x *= 10;
	}

	for (int i = 0; i < t; i++)
	{
		string s; cin >> s;
		pair <pair<bool, long long>, string> ans;
		ans = gen(s, s.size() - 1, make_pair(summ(s), s));
		cout << (ans.first).second << endl << ans.second << endl;
	}
	return 0;
}