#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
int n, m;
vector<set<int> > from, to;
vector<vector<int> > res;
vector<set<int> > all1;
set<int> good;
vector<int> amleafs;
vector<int> give;
vector<bool> is_leaf;
vector<bool> killed;

void for_adding(int v)
{
	if(all1[v].size() != 0 && amleafs[v] + 1 >= all1[v].size())
	{
		good.insert(v);
	}
}

void check(int v1, int v2)
{
	//cout << "info " << v2 << ' ' << from[v2].size() << ' ' << to[v2].size() << endl;
	if(from[v2].find(v1) == from[v2].end() && to[v2].find(v1) == to[v2].end())
	{
		//cout << "start1" << endl;
		all1[v1].erase(all1[v1].find(v2));
		all1[v2].erase(all1[v2].find(v1));
		if(is_leaf[v1] && give[v1] == v2)
		{
			--amleafs[v2];
		}
		if(is_leaf[v2] && give[v2] == v1)
		{
			--amleafs[v1];
		}
		for_adding(v1);
		for_adding(v2);
		int i = v1;
		if(!is_leaf[i] && (to[i].size() + from[i].size() == 1 ||
			(to[i].size() == 1 && from[i].size() == 1 &&
				*(from[i].begin()) == *(to[i].begin()))))
		{
			is_leaf[i] = true;
			int od;
			if(from[i].size() != 0)
			{
				od = *(from[i].begin());
			}
			else
			{
				od = *(to[i].begin());
			}
			give[i] = od;
			amleafs[od]++;
			for_adding(od);
		}
		i = v2;
		if(!is_leaf[i] && (to[i].size() + from[i].size() == 1 ||
			(to[i].size() == 1 && from[i].size() == 1 &&
				*(from[i].begin()) == *(to[i].begin()))))
		{
			is_leaf[i] = true;
			int od;
			if(from[i].size() != 0)
			{
				od = *(from[i].begin());
			}
			else
			{
				od = *(to[i].begin());
			}
			give[i] = od;
			amleafs[od]++;
			for_adding(od);
		}
	}
}

void connect(int v1, int v2, int v3)
{
	//cout << v1 << ' ' << v2 << ' ' << v3 << endl;
	res.push_back({v1, v2, v2, v3});
	to[v2].erase(to[v2].find(v1));
	from[v1].erase(from[v1].find(v2));
	to[v3].erase(to[v3].find(v2));
	from[v2].erase(from[v2].find(v3));
	//cout << "end1" << endl;
	check(v1, v2);
	//cout << "end2" << endl;
	if(v1 != v3)
	{
		check(v2, v3);
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	cin >> n >> m;
	from.resize(n);
	to.resize(n);
	all1.resize(n);
	killed.assign(n, false);
	for(int i = 0; i < m; i++)
	{
		int v, u;
		cin >> v >> u;
		--v;
		--u;
		from[v].insert(u);
		to[u].insert(v);
		all1[u].insert(v);
		all1[v].insert(u);
	}
	amleafs.assign(n, 0);
	give.assign(n, -1);
	is_leaf.assign(n, false);
	for(int i = 0; i < n; i++)
	{
		if(to[i].size() + from[i].size() == 1 ||
			(to[i].size() == 1 && from[i].size() == 1 &&
				*(from[i].begin()) == *(to[i].begin())))
		{
			is_leaf[i] = true;
		}
	}
	for(int i = 0; i < n; i++)
	{
		for(auto it = all1[i].begin(); it != all1[i].end(); ++it)
		{
			if(is_leaf[*it])
			{
				give[*it] = i;
				++amleafs[i];
			}
		}
		if(amleafs[i] + 1 >= all1[i].size() && !all1[i].empty())
		{
			good.insert(i);
		}
	}
	while(!good.empty())
	{
		int v = *(good.begin());
		good.erase(good.begin());
		//cout << 1 << ' ' << v << endl;
		if(killed[v])
		{
			continue;
		}
		killed[v] = true;
		if(abs((int)to[v].size() - (int)from[v].size()) > 1)
		{
			cout << "No";
			return 0;
		}
		set<pair<int, int> > to1;
		set<pair<int, int> > from1;
		for(auto it = to[v].begin(); it != to[v].end(); ++it)
		{
			if(is_leaf[*it])
			{
				to1.insert({0, *it});
				killed[*it] = true;
			}
			else
			{
				to1.insert({1, *it});
			}
		}
		for(auto it = from[v].begin(); it != from[v].end(); ++it)
		{
			if(is_leaf[*it])
			{
				from1.insert({0, *it});
				killed[*it] = true;
			}
			else
			{
				from1.insert({1, *it});
			}
		}
		//cout << 12 << endl;
		while(from1.size() != 0 && to1.size() != 0)
		{
			//cout << (*(to1.begin())).second << ' ' <<
			//(*(from1.begin())).second << endl;
			connect((*(to1.begin())).second, v, (*(from1.begin())).second);
			//cout << 32 << endl;
			from1.erase(from1.begin());
			to1.erase(to1.begin());
		}
		//cout << 2 << endl;
	}
	if(res.size() != m / 2)
	{
		cout << "No";
		return 0;
	}
	cout << "Yes\n";
	for(int i = 0; i < m / 2; i++)
	{
		for(int j = 0; j < 4; j++)
		{
			cout << res[i][j] + 1 << ' ';
		}
		cout << '\n';
	}
}