#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define INF 1000000000000000000ll
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
int n, m;
vector<vector<pair<int, int> > > g;
vector<vector<pair<pair<int, int>, int> > > g1;
vector<bool> used;
vector<ll> res;
void dfs(int v, int p, ll max1, ll min1)
{
	if(v != 0)
	{
		res[v] = max1 + min1;
	}
	for(int i = 0; i < g[v].size(); i++)
	{
		int u = g[v][i].first;
		int w = g[v][i].second;
		if(u == p)
		{
			continue;
		}
		dfs(u, v, max(max1, (ll)w), min(min1, (ll)w));
	}
}

void dfs1(int v, ll max1, ll min1)
{
	if(v != 0)
	{
		res[v] = min(res[v], max1 + min1);
	}
	for(int i = 0; i < g1[v].size(); i++)
	{
		int u = g1[v][i].first.first;
		int w = g1[v][i].first.second;
		int id1 = g1[v][i].second;
		if(used[id1])
		{
			continue;
		}
		used[id1] = true;
		dfs1(u, max(max1, (ll)w), min(min1, (ll)w));
		used[id1] = false;
	}
}


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	cin >> n >> m;
	res.assign(n, INF);
	if(m == n - 1)
	{
		g.resize(n);
		for(int i = 0; i < m; i++)
		{
			int v, u, w;
			cin >> v >> u >> w;
			--v;
			--u;
			g[v].push_back({u, w});
			g[u].push_back({v, w});
		}
		dfs(0, -1, -INF, INF);
	}
	else if(m <= 20 && n <= 20)
	{
		g1.resize(n);
		for(int i = 0; i < m; i++)
		{
			int v, u, w;
			cin >> v >> u >> w;
			--v;
			--u;
			g1[v].push_back({{u, w}, i});
			g1[u].push_back({{v, w}, i});
		}
		used.assign(m, false);
		dfs1(0, -INF, INF);
	}
	else
	{
		g.resize(n);
		bool all0 = true;
		for(int i = 0; i < m; i++)
		{
			int v, u, w;
			cin >> v >> u >> w;
			--v;
			--u;
			if((v == 0 || u == 0) && w != 0)
			{
				all0 = false;
			}
			g[v].push_back({u, w});
			g[u].push_back({v, w});
		}
		if(all0)
		{
			set<pair<ll, int> > s;
			used.assign(n, false);
			s.insert({0, 0});
			used[0] = true;
			res[0] = 0;
			while(!s.empty())
			{
				auto p = *(s.begin());
				s.erase(s.begin());
				int v = p.second;
				used[v] = true;
				int dist1 = p.first;
				for(int i = 0; i < g[v].size(); i++)
				{
					int u = g[v][i].first;
					int w = g[v][i].second;
					if(used[u])
					{
						continue;
					}
					if(res[u] > max(w, dist1))
					{
						if(res[u] != INF)
						{
							s.erase(s.find({res[u], u}));
						}
						res[u] = max(w, dist1);
						s.insert({res[u], u});
					}
				}
			}
		}
	}
	for(int i = 1; i < n; i++)
	{
		cout << res[i] << '\n';
	}
}