#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <stack>
#include <queue>

using namespace std;

#define ll long long
#define S second
#define F first
#define all(x) x.begin(), x.end()

ll a, b, c, d, e;
vector <ll> ar;
vector <vector <pair <ll, ll> > > arr;
vector <ll> vis;
vector <ll> ans, cnm;

void dfs(ll v, ll mn, ll mx)
{
    ans[v] = min(mn + mx, ans[v]);
    vis[v] = 1;
    for (auto v1 : arr[v])
        if (!vis[v1.F])
            dfs(v1.F, min(mn, v1.S), max(mx, v1.S));
    return;
}

bool comp(pair <pair <ll, ll>, ll> p, pair <pair <ll, ll>, ll> p1)
{
    return p.S > p1.S;
}

ll get_root(ll v)
{
    if (cnm[v] == v)
        return v;
    ll v1 = get_root(cnm[v]);
    cnm[v] = v1;
    return v1;
}

void un(ll v, ll v1)
{
    ll rt = get_root(v);
    ll rt1 = get_root(v1);
    cnm[rt] = rt1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> a >> b;
    vis.resize(a);
    cnm.resize(a);
    for (ll i = 0; i < a; ++i)
        cnm[i] = i;
    ans.resize(a, 1e18);
    arr.resize(a);
    vector <pair <pair <ll, ll>, ll > > edges;
    for (ll i = 0; i < b; ++i)
    {
         ll p, p1, w;
         cin >> p >> p1 >> w;
         --p, --p1;
         edges.push_back({{p, p1}, w});
         edges.push_back({{p1, p}, w});
    }
    //for (auto v : edges)
     //   cout << v.F.F << " " << v.F.S << " " << v.S << endl;
    arr.resize(a);
    for (ll i = 1; i < (1 << (ll)edges.size()); ++i)
    {
        arr.resize(0);
        arr.resize(a);
        for (ll j = 0; j < edges.size(); ++j)
        {
            if ((i & (1 << j)) == 0)
                continue;
            arr[edges[j].F.F].push_back({edges[j].F.S, edges[j].S});
            //arr[edges[j].F.S].push_back({edges[j].F.F, edges[j].S});
        }
        dfs(0, 1e9, 0);
        vis.assign(a, 0);
    }
    for (ll i = 1; i < a; ++i)
        cout << ans[i] << '\n';
}
