#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>


constexpr int MAXN = 3e5 + 5;
constexpr int INF = 1.1e9;

struct Edge {
	int t, w;
	int id;
};
int n, m;
std::vector<Edge> gr[MAXN];
int ans[MAXN];


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v, t;
		std::cin >> u >> v >> t;
		u--; v--;
		gr[u].push_back({ v, t, i });
		gr[v].push_back({ u, t, i });
	}
	if (n == m + 1) {
		std::function<void(int, int, int, int)> dfs = [&](int v, int f, int min, int max) {
			ans[v] = min + max;
			for (auto [t, w, id] : gr[v]) {
				if (id != f) {
					dfs(t, id, std::min(min, w), std::max(max, w));
				}
			}
		};
		dfs(0, -1, INF, 0);
		for (int i = 1; i < n; i++) {
			std::cout << ans[i] << " \n"[i == n - 1];
		}
	} else {

	}


	return 0;
}