#include <bits/stdc++.h>

using namespace std;

map<char, long long> kys_jury = {
    {'A', 1},
    {'B', 5},
    {'C', 10},
    {'D', 50},
    {'E', 100},
    {'F', 500},
    {'G', 1e3},
    {'H', 5e3},
    {'I', 1e4},
    {'J', 5e4},
    {'K', 1e5},
    {'L', 5e5},
    {'M', 1e6},
    {'N', 5e6},
    {'O', 1e7},
    {'P', 5e7},
    {'Q', 1e8},
    {'R', 5e8},
    {'S', 1e9},
    {'T', 5e9},
    {'U', 1e10},
    {'V', 5e10},
    {'W', 1e11},
    {'X', 5e11},
    {'Y', 1e12},
    {'Z', 5e12},
};

long long count(string &s) {
  int n = s.size();
  char mx = 0;
  long long ans = 0;
  for (int i = n - 1; i >= 0; i--) {
    if (s[i] >= mx) {
      ans += kys_jury[s[i]];
    } else {
      ans -= kys_jury[s[i]];
    }
    mx = max(mx, s[i]);
  }
  return ans;
}

string mx;
long long mx_ans = -INT_MAX;
vector<int> questions;

void bruteforce(int depth, string &s) {
  if (depth == questions.size()) {
    long long cur = count(s);
    if (cur > mx_ans) {
      mx_ans = cur;
      mx = s;
    }
    return;
  }
  for (int i = 0; i < 26; i++) {
    s[questions[depth]] = 'A' + i;
    bruteforce(depth + 1, s);
  }
}

void solve() {
  string s;
  cin >> s;
  int n = s.size();
  questions.clear();
  mx_ans = -INT_MAX;
  for (int i = 0; i < n; i++) {
    if (s[i] == '?') {
      questions.push_back(i);
    }
  }
  bruteforce(0, s);
  cout << mx_ans << '\n';
  cout << mx << '\n';
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t;
  cin >> t;
  while (t--)
    solve();
  return 0;
}