#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;

ll INF = 1e18;

vector<vector<lpair> > g;
lvec ans;

void dfs(ll v, ll mn, ll mx) {
    ans[v] = mn + mx;
    for (auto &e : g[v]) {
        auto[u, t] = e;
        if (ans[u] == -1) dfs(u, min(mn, t), max(mx, t));
    }
}

int main() {
    freopen("D.in", "r", stdin);
    ll n, m;
    cin >> n >> m;
    g.resize(n);
    ans.resize(n, -1);
    for (ll i = 0; i < m; i++) {
        ll u, v, t;
        cin >> u >> v >> t;
        g[--u].emplace_back(--v, t);
        g[v].emplace_back(u, t);
    }
    if (n == m + 1) {
        dfs(0, INF, -INF);
        for (ll i = 1; i < n; i++) cout << ans[i] << "\n";

    } else exit(-1);
    return 0;
}
