#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 3e3 + 10, INF = 1e9+10;
const ll LINF = 1e18 + 10;

int in[N], out[N];

int g[N][N];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a][b] = 1;
        out[a]++;
        in[b]++;
    }

    vector<pair<int,pair<int,int>>> ans;

    while (true) {
        bool f = true;
        for (int a = 1; a <= n; a++) {
            for (int b = 1; b < a; b++) {
                if (g[a][b] && g[b][a] && (in[a] == 1 && out[a] == 1 || in[b] == 1 && out[b] == 1)) {
                    ans.push_back({a, {b, a}});
                    f = false;
                    in[a]--;
                    out[a]--;
                    in[b]--;
                    out[b]--;
                    g[a][b] = g[b][a] = 0;
                }
            }
        }

        for (int a = 1; a <= n; a++) {
            if (in[a] == 0 && out[a] != 0) {
                bool del = false;
                for (int b = 1; b <= n; b++) {

                    if (g[a][b] && out[b] == 1) {
                        for(int c = 1; c <= n; c++) {
                            if (g[b][c]) {
                                f = false;
                                out[a]--;
                                in[b]--;
                                out[b]--;
                                in[c]--;
                                g[b][c] = g[a][b] = 0;
                                ans.push_back({a, {b, c}});
                                del = true;
                                break;
                            }
                        }
                    }
                    if (del) break;
                }
            }
        }

        for (int c = 1; c <= n; c++) {
            if (in[c] != 0 && out[c] == 0) {
                bool del = false;
                for (int b = 1; b <= n; b++) {

                    if (g[b][c] && in[b] == 1) {
                        for(int a = 1; a <= n; a++) {
                            if (g[a][b]) {
                                f = false;
                                out[a]--;
                                in[b]--;
                                out[b]--;
                                in[c]--;
                                g[b][c] = g[a][b] = 0;
                                ans.push_back({a, {b, c}});
                                del = true;
                                break;
                            }
                        }
                    }
                    if (del) break;
                }
            }
        }

        if (f) break;
    }

    if (ans.size() == m/2) {
        cout << "Yes\n";
        for (auto i : ans) {
            cout << i.first << " " << i.second.first << " " << i.second.first << " " << i.second.second << "\n";
        }
    } else {
        cout << "No\n";
    }

    return 0;
}