#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vtm")
#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 _mt(seed);

int n, m;
vector <vector <pair <int, int> > > g;
vector <int> used;
vector <vector <int> > dp;
vector <vector <vector <int> > > p;
bool f = true;

void dfs(int v) {
    if (!f) return;
    used[v] = 1;
    int cnt = 0;
    vector <vector <int> > us;
    for (auto &e : g[v]) {
        if (!f) return;
        int u = e.first;
        if (!used[u]) {
            dfs(u);
            us.push_back(vector <int>());
            if (dp[u][0] && e.second >= 0)
                us.back().push_back(0);
            if (dp[u][1])
                us.back().push_back(1);
            if (dp[u][2] && e.second <= 0)
                us.back().push_back(2);
            if (us.back().empty())
                f = false;
            cnt += e.second;
        }
    }
    if (!f) return;
    int sz = us.size();
    int mx = 0, mn = 0;
    for (int i = 0; i < sz; i++) {
        mx -= us[i][0] - 1;
        mn -= us[i].back() - 1;
    }
    cnt--;
    for (int i = 0; i < 3; i++) {
        if (cnt + i < mn || cnt + i > mx) {
            dp[v][i] = 0;
            continue;
        }
        dp[v][i] = 1;
        int cur = 0; cnt++;
        for (int j = 0; j < sz; j++) {
            mn += us[j].back() - 1;
            int k = 0;
            while (k + 1 < us[j].size() && cur - us[j][k + 1] + 1 + mn >= cnt)
                k++;
            p[v][i].push_back(us[j][k]);
        }
    }
}

void print(int v, int pp, int type) {
    used[v] = 1;
    vector <pair <int, int> > inv, outv;
    if (type == 0)
        inv.push_back({pp, v});
    if (type == 2)
        outv.push_back({v, pp});
    int cnt = 0;
    for (auto &e : g[v]) {
        int u = e.first;
        if (!used[u]) {
            if (e.second >= 0 && p[v][type][cnt] != 0)
                outv.push_back({v, u});
            if (e.second <= 0 && p[v][type][cnt] != 2)
                inv.push_back({u, v});
            print(u, v, p[v][type][cnt]);
            cnt++;
        }
    }
    for (int i = 0; i < inv.size(); i++) {
        cout << inv[i].first + 1 << " " << inv[i].second + 1 << " ";
        cout << outv[i].first + 1 << " " << outv[i].second + 1 << "\n";
    }
}


int32_t main()
{
    #ifdef LOCAL
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    #endif
    cin >> n >> m;
    g.resize(n); used.resize(n);
    dp.resize(n, vector <int>(3));
    p.resize(n, vector <vector <int> >(3));
    set <pair <int, int> > was;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        was.insert({v, u});
    }
    for (auto &e : was) {
        int v = e.first, u = e.second;
        if (was.count({u, v})) {
            if (v < u) {
                g[v - 1].push_back({u - 1, 0});
                g[u - 1].push_back({v - 1, 0});
            }
        } else {
            g[v - 1].push_back({u - 1, 1});
            g[u - 1].push_back({v - 1, -1});
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i])
            dfs(i);
        if (!f) {
            cout << "No";
            return 0;
        }
    }
    fill(used.begin(), used.end(), 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            print(i, -1, 1);
        }
    }
    return 0;
}
