#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;
using li = long long;
using pii = pair<int, int>;

const li INF = 3e18 + 13;
const int N = 3e5 + 13;
const int A = 26;



/*

*/

int query(int x1, int xn, vector<int> a, vector<int> b) {
    int n = a.size();
//    cout << "query" << endl;
    vector<int> lf(n), rg(n);
    for(int i = 0; i < n; i++) {
        rg[i] = i + 1;
        lf[i] = i - 1;
    }
//cout << "query" << endl;
    vector<int> del(n, 0);
    queue<int> q;
    for(int i = 0; i < n; i++) {
        if(a[i] - b[i] >= max(x1, i > 0 ? a[i - 1] : x1) ||
            a[i] + b[i] <= min(xn, i < n - 1 ? a[i + 1] : xn)) {
                del[i] = 1;
                q.push(i);
            }
    }
//cout << "query" << endl;
    int res = 0;

    while(!q.empty()) {
        int i = q.front();
        q.pop();
//cout << "query " << i << ' '<< lf[i] << ' '<< rg[i] << endl;
        res++;
        del[i] = 2;
//        cout << "esghbhn" << endl;
//        cout << (lf[i] > -1 && del[lf[i]] == 0) << endl;
//        cout << (rg[i] < n && del[rg[i]] == 0) << endl;

        if(lf[i] > -1 && del[lf[i]] == 0) {
//                cout << "lf" << endl;
            if(a[lf[i]] + b[lf[i]] <= min(xn, rg[i] < n ? a[rg[i]] : xn)) {
                del[lf[i]] = 1;
                q.push(lf[i]);
            }
        }

        if(rg[i] < n && del[rg[i]] == 0) {
//            cout << "rg" << endl;
            if(a[rg[i]] - b[rg[i]] >= max(x1, lf[i] > -1 ? a[lf[i]] : x1)) {
                del[rg[i]] = 1;
                q.push(rg[i]);
            }
        }

        if(rg[i] < n)
            lf[rg[i]] = lf[i];
        if(lf[i] > -1)
            rg[lf[i]] = rg[i];
    }

    return res;
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

5 3
1 5
3 1
4 2
5 3
6 1
1 5
5 5
1 1

1 1
100 100
1 1
*/

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;

    vector<int> a(n), b(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
    }

    for(int ind = 0; ind < q; ind++) {
        int l, r;
        cin >> l >> r;

        l--;

        vector<int> a1(r - l), b1(r - l);
        for(int i = l; i < r; i++) {
            a1[i - l] = a[i];
            b1[i - l] = b[i];
        }

        cout << query((l == 0 ? a[0] : a[l - 1]), (r == n ? a[n - 1] : a[r]), a1, b1) << endl;
    }
}
