#include <iostream>
#include <string>
#include <vector>


using namespace std;

vector<long long> p(26);

long long get(string s) {
    long long cur = 0;
    int max3 = 0;
    for (int j2 = s.length() - 1; j2 >= 0; --j2) {
        if (s[j2] == '?')
            continue;
        int k2 = int(s[j2]) - 65;
        max3 = max(max3, k2);
        if (k2 < max3)
            cur -= p[k2];
        else
            cur += p[k2];
    }
    return cur;
}



int main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);


    int t;
    cin >> t;
    vector<string> s(t);
    for (int i = 0; i < t; ++i) {
        cin >> s[i];
    }

    p[0] = 1; p[1] = 5;
    long long tn = 1;
    for (int i = 2; i < 26; ++i) {
        p[i] = p[i - 2] * 10;
    }

    for (int i = 0; i < t; ++i) {
        vector<int> q;
        for (int j = 0; j < s[i].length(); ++j) {
            if (s[i][j] == '?')
            q.push_back(j);
        }
        if (q.size() == 0)
            continue;
        else if (q.size() == 1) {
            long long best = 0;
            int best1 = 0;
            for (int j = 0; j < 26; ++j) {
                s[i][q[0]] = char(j + 65);
                long long cur = get(s[i]);
                if (cur > best) {
                    best = cur;
                    best1 = j + 65;
                }
            }
            s[i][q[0]] = char(best1);
        }
        else if (q.size() == 2) {
            long long best = 0;
            int best1 = 0, best2 = 0;
            for (int j = 0; j < 26; ++j) {
                s[i][q[0]] = char(j + 65);
                for (int l = 0; l < 26; ++l) {
                    s[i][q[1]] = char(l + 65);
                    long long cur = get(s[i]);
                    if (cur > best) {
                        best = cur;
                        best1 = j + 65;
                        best2 = l + 65;
                    }
                }
            }
            s[i][q[0]] = char(best1);
            s[i][q[1]] = char(best2);
        }
        else {
            long long best = 0;
            int best1 = 0, best2 = 0, best3 = 0;
            for (int j = 0; j < 26; ++j) {
                s[i][q[0]] = char(j + 65);
                for (int l = 0; l < 26; ++l) {
                    s[i][q[1]] = char(l + 65);
                    for (int f = 0; f < 26; ++f) {
                        s[i][q[2]] = char(f + 65);
                        long long cur = get(s[i]);
                        if (cur > best) {
                            best = cur;
                            best1 = j + 65;
                            best2 = l + 65;
                            best3 = f + 65;
                        }
                    }
                }
            }
            s[i][q[0]] = char(best1);
            s[i][q[1]] = char(best2);
            s[i][q[2]] = char(best3);
        }

        long long ans = 0;
        int max2 = 0;
        for (int j = s[i].length() - 1; j >= 0; --j) {
            int k = int(s[i][j]) - 65;
            max2 = max(max2, k);
            if (k < max2)
                ans -= p[k];
            else
                ans += p[k];
        }
        cout << ans << "\n" << s[i] << "\n";
    }

}
