#include <bits/stdc++.h>

using namespace std;

#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())


typedef long long ll;
typedef long double ld;

const ll inf = 1e9;
const ll inf2 = 1e18;
const ll mod = 1e9 + 7;
const ld eps = 1e-9;
const char nl = '\n';

const int maxn = 1e4 + 5, maxm = 1e6;

int ans[maxn][maxn];

int main() {
	FAST;
	
	int n, q;
	cin >> n >> q;
	
	vector<int> h(n + 2, inf), x(n + 2);
	for (int i = 0; i < n; i++) cin >> x[i + 1] >> h[i + 1];
	x[0] = x[1];
	x[n + 1] = x[n];
	
	vector<pair<int, int>> a(n + 2);
	for (int i = 1; i <= n; i++) {
		{
			int lb = 0, ub = i, tans = 0;
			while (lb <= ub) {
				int tm = (lb + ub) / 2;
				if (x[tm] > x[i] - h[i]) {
					ub = tm - 1;
					tans = tm;
				} else {
					lb = tm + 1;
				}
			}
			a[i].first = tans;
		}
		{
			int lb = i, ub = n + 1, tans = n + 1;
			while (lb <= ub) {
				int tm = (lb + ub) / 2;
				if (x[tm] < x[i] + h[i]) {
					lb = tm + 1;
					tans = tm;
				} else {
					ub = tm - 1;
				}
			}
			a[i].second = tans;
		}
	}
	
	for (int l = 1; l <= n; l++) {
		stack<int> s;
		int tans = 0;
		for (int r = l; r <= n; r++) {
			bool good = false;
			
			int tl = l - 1;
			if (!s.empty()) {
				tl = s.top();
			}
			if (a[r].first > tl) good = true;
			if (a[r].second < r + 1) good = true;
			
			if (good) {
				tans++;
				while (!s.empty() && a[s.top()].second <= r) {
					s.pop();
					tans++;
				}
			} else {
				s.push(r);
			}
			ans[l][r] = tans;
		}
	}
	
	while (q--) {
		int l, r;
		cin >> l >> r;
		cout << ans[l][r] << nl;
	}
}
