#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define pb push_back
ll inf = 1e18;
void solve () {
    ll n, q;
    cin >> n >> q;
    vector<ll> s(n + 2, -inf), h(n + 2, -inf);
    for (int i = 1; i <= n; i++) {
        cin >> s[i] >> h[i];
    }
    s[0] = s[1];
    s[n + 1] = s[n];
    while (q > 0) {
        ll l, r;
        cin >> l >> r;
        vector<ll> left(n + 2, inf), right(n + 2, inf), next(n + 2), prev(n + 2), used(n + 2, 1);
        deque<ll> pos;
        for (int i = l; i <= r; i++) {
            left[i] = s[i] - s[i - 1];
            right[i] = s[i + 1] - s[i];
            used[i] = 0;
        }
        for (int i = 1; i <= n; i++) {
            next[i] = i + 1;
            prev[i] = i - 1;
        }
        for (int i = l; i <= r; i++) {
            if (left[i] >= h[i] || right[i] >= h[i]) {
                pos.pb(i);
            }
        }
        ll kol = 0;
        while (pos.size() > 0) {
                //cout << pos.size() << endl;
            ll u = pos.front();
            pos.pop_front();
            used[u] = 1;
            kol++;
            next[prev[u]] = next[u];
            prev[next[u]] = prev[u];
            if (next[u] >= l && next[u] <= r && used[next[u]] == 0 && s[next[u]] - s[prev[u]] >= h[next[u]]) {
                pos.pb(next[u]);
            }
            if (prev[u] >= l && prev[u] <= r && used[prev[u]] == 0 && abs(s[next[u]] - s[prev[u]]) >= h[prev[u]]) {
                pos.pb(prev[u]);
            }
        }
        cout << kol << '\n';
        q--;
    }
}
int main() {
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
