#include <bits/stdc++.h>


using namespace std;
vector<int> used;


void dfs(int v, vector<vector<int>> &g){
    used[v] = 1;
    for (int u:g[v]){
        if (!used[u]) dfs(u, g);
    }
}


struct ed{
    int v, u, w;
};


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<ed> edges(m);
    for (int i = 0; i < m; ++i) {
        cin >> edges[i].v >> edges[i].u >> edges[i].w;
        edges[i].v--, edges[i].u--;
    }
    for (int i = 1; i < n; ++i) {
        long long ans = 2e9;
        for (int mask = 0; mask < (1 << m); ++mask) {
            vector<vector<int>> g(n);
            int minn = 1e9, maxx = 0;
            for (int j = 0; j < m; ++j) {
                if ((mask >> j) % 2){
                    g[edges[j].v].push_back(edges[j].u);
                    g[edges[j].u].push_back(edges[j].v);
                    minn = min(minn, edges[j].w);
                    maxx = max(maxx, edges[j].w);
                }
            }
            used.assign(n, 0);
            dfs(0, g);
            if (used[i]) ans = min(ans, (long long) minn + maxx);
        }
        cout << ans << '\n';
    }
}
