#include <bits/stdc++.h>
#define vec vector
#define ll long long
#define all(x) x.begin(), x.end()
#define fi first
#define se second
//#define int long long
//#define endl "\n"

using namespace std;

struct SNM{
    vec<int> lead, sz;
    SNM(){};
    SNM(int n) {
        lead.resize(n);
        sz.resize(n, 1);
        for (int i = 0; i < n; ++i) {
            lead[i] = i;
        }
    }

    int get(int x) {
        if (lead[x] != x) {
            lead[x] = get(lead[x]);
        }
        return lead[x];
    }

    bool pro(int x, int y) {
        return get(x) == get(y);
    }

    void merg(int x, int y) {
        x = get(x);
        y = get(y);
        if (x == y) return;
        if (sz[x] < sz[y]) {
            swap(x, y);
        }
        sz[y] += sz[x];
        lead[y] = x;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m; cin >> n >> m;
    vec<int> ans(n);
    vec<vec<int>> al;
    for (int i = 0; i < m; ++i) {
        int a, b, c; cin >> a >> b >> c;
        a--; b--;
        al.push_back({c, a, b});
    }
    sort(all(al));
    SNM snm(n);
    for (int i = 0; i < m; ++i) {
        int a = al[i][1], b = al[i][2], c = al[i][0];
        if (a == 0 || b == 0 && c != 0) return -1;
        bool x1 = snm.pro(0, a);
        bool y1 = snm.pro(0, b);
        snm.merg(a, b);
        bool x2 = snm.pro(0, a);
        bool y2 = snm.pro(0, b);
        if (x2 > x1) ans[a] = c;
        if (y2 > y1) ans[b] = c;
        //cout << a + 1 << ' ' << b + 1 << ' ' << c << endl;
        //cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
    }
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << ' ';
    }
}
/*
4 3
1 2 2
2 3 3
2 4 1
*/
/*
5 6
1 2 0
1 3 0
2 3 2
2 4 5
3 5 3
4 5 6
*/



