#include <iostream>
#include <iostream>
#include <iostream>
#include <map>
#include <algorithm>
#include <string>
#include <vector>


const int MAXN = 3e5+10;
using ll = long long;
using namespace std;

ll getnum[1000];

ll dp[26][MAXN];
int ans[26][MAXN];

ll go(string &s, int i, int maxc){
    if(i == -1){
        return 0;
    }
    if(dp[maxc][i] != INT64_MIN){
        return dp[maxc][i];
    }
    if(s[i] == '?') {
        ll bestr = INT64_MIN;
        int bestj = 0;
        ll sign = -1;
        for (int j = 0; j < 26; ++j) {
            if (j == maxc) {
                sign = 1;
            }
            ll rj = go(s, i - 1, max(maxc, j)) + getnum[j] * sign;
            if (rj > bestr) {
                bestr = rj, bestj = j;
            }
        }
        ans[maxc][i] = bestj;

        return dp[maxc][i] = bestr;
    }else{
        int curi = s[i] - 'A';
        ans[maxc][i] = curi;
        return dp[maxc][i] = go(s, i - 1, max(maxc, curi)) + getnum[curi] * (curi < maxc ? -1 : 1);
    }
}


int main() {

    vector<ll> tenpows = {1};
    for (int i = 0; i < 13; ++i) {
        tenpows.push_back(tenpows.back() * 10LL);
    }
    for (int i = 0; i < 26; ++i) {
        ll base = i%2 ? 5 : 1;
        getnum['A' + i] = getnum[i] = base * tenpows[i/2];
    }

    int t;
    cin >> t;
    while(t--){

        string s;
        cin >> s;

        for (int i = 0; i < 26; ++i) {
            fill(dp[i], dp[i] + s.length() + 10, INT64_MIN * 1LL);
        }

        cout << go(s, s.length() - 1, 0) << endl;

        string r;
        int cur = 0;
        int maxc = 0;
        for (int i = s.length() - 1; i >= 0; --i) {
            r.push_back(ans[maxc][i] + 'A');
            maxc = max(maxc, ans[maxc][i]);
        }
        reverse(r.begin(), r.end());


        cout << r << endl;

    }
    return 0;
}
