//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("avx,avx2")

#include <bits/extc++.h>

using namespace std;

#define vc vector
typedef long long ll;
typedef vc<ll> vll;

vc<pair<ll, pair<ll, ll>>> g[300005];

ll d[300005];

bool used[300005];

void dfs(ll v, ll mn, ll mx) {
    d[v] = min(d[v], mx + mn);
    for (auto &to1 : g[v]) {
        pair<ll, ll> to = to1.second;
        if (!used[to1.first]) {
            used[to1.first] = true;
            dfs(to.first, min(mn, to.second), max(mx, to.second));
            used[to1.first] = false;
        }
    }
}

int main() {
    ll n, m;
    cin >> n >> m;
    for (ll v = 1; v <= n; ++v) {
        d[v] = INT_MAX;
    }
    while (m--) {
        ll v, to, w;
        cin >> v >> to >> w;
        g[v].push_back({m + 1, {to, w}});
        g[to].push_back({m + 1, {v, w}});
    }
    dfs(1, LLONG_MAX, -LLONG_MAX);
    for (ll to = 2; to <= n; ++to) {
        cout << d[to] << '\n';
    }
}