#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
using namespace std;
#define int long long
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double
map <char, int> mp;
vector <int> ids;
string s, ans1 = "";
int res;
void gen(int sz) {
	if (sz == ids.size()) {
		int n = s.size(), get = mp[s.back()];
		char mx = s.back();
		for (int i = n - 2; i >= 0; --i) {
			if (mx > s[i]) get -= mp[s[i]];
			else get += mp[s[i]];
			mx = max(mx, s[i]);
		}
		if (get > res) {
			ans1 = s, res = get;
		}
		return;
	}
	for (auto x = 'A'; x <= 'Z'; ++x) {
		s[ids[sz]] = x;
		gen(sz + 1);
	}
}
/*
4
BBBC
????
A?B?C?D
YYYYY?
*/
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	mp['A'] = 1;
	int cur = 5;
	for (auto x = 'B'; x <= 'Z'; x++) {
		mp[x] = mp[x - 1] * cur;
		cur = 7 - cur;
	}
	int testcases;
	cin >> testcases;
	while (testcases-- > 0) {
		cin >> s;
		res = -1e18;
		ids = {};
		vector <vector <int>> ok = { {} };
		int n = s.size(), last = -1, cnt = 0, ans = 0;
		for (int i = 0; i < n; ++i) {
			if (s[i] == '?') {
				ids.push_back(i);
				last = i, cnt++;
				if (i != n - 1)
					ok.push_back({});
			}
			else {
				ok.back().push_back(s[i] - 'A');
			}
		}
		char mx = 'A';
		for (int i = n - 1; i > last; --i) {
			if (mx > s[i]) ans -= mp[s[i]];
			else ans += mp[s[i]];
			mx = max(mx, s[i]);
		}
		vector <char> suf(n + 1);
		suf.back() = 'A';
		for (int i = n - 1; i >= 0; --i) {
			suf[i] = suf[i + 1];
			if (s[i] != '?' and s[i] > suf[i])
				suf[i] = s[i];
		}
		while (ok.size() != cnt)
			ok.pop_back();
		vector <vector <int>> dp(cnt + 1, vector <int>(26, 0));
		vector <vector <int>> pr(cnt + 1, vector <int>(26, -1));
		for (int i = 1; i < dp.size(); ++i) {
			for (int j = 0; j < 26; ++j) {
				dp[i][j] = -1e18;
				int add = 0, mmx = max((int)suf[ids[i - 1]] - 'A', j);
				for (auto x : ok[i - 1]) {
					if (x < mmx) add -= mp['A' + x];
					else add += mp['A' + x];
					mmx = max(x, mmx);
				}
				for (int k = j; k < 26; ++k) {
					if (dp[i - 1][k] >= dp[i][j])
						pr[i][j] = k;
					dp[i][j] = max(dp[i][j], dp[i - 1][k]);
				}
				dp[i][j] += add;
				if (j < (int)(suf[ids[i - 1]] - 'A')) dp[i][j] -= mp[j + 'A'];
				else dp[i][j] += mp[j + 'A'];
			}
		}
		int add = -1e18, ind = 0;
		for (int i = (int)(mx - 'A'); i < 26; ++i) {
			if (dp.back()[i] >= add)
				ind = i, add = dp.back()[i];
		}
		string plus = "";
		int end = dp.size() - 1;
		while (end) {
			plus += (char)('A' + ind);
			ind = pr[end][ind];
			end--;
		}
		reverse(plus.begin(), plus.end());
		end = 0;
		cout << ans + add << '\n';
		for (int i = 0; i < n; ++i) {
			if (s[i] == '?') cout << plus[end++];
			else cout << s[i];
		}
		cout << '\n';
		gen(0);
		assert(res >= ans + add);
	}
}