#include <bits/stdc++.h>

#define ALL(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;

map<char, ll> to_values;

int n;

ll count_value(string &ss) {
    vector<char> suf_max;
    int l = ss.length();
    suf_max.resize(l + 1);
    suf_max[l] = 'A';
    for (int i = l - 1; i >= 0; --i) {
        suf_max[i] = max(suf_max[i + 1], ss[i]);
    }

    ll value = 0;
    for (int i = 0; i < l; ++i) {
        if (suf_max[i] > ss[i]) {
            value -= to_values[ss[i]];
        } else {
            value += to_values[ss[i]];
        }
    }
    return value;
}

string best_string;
ll max_value = LLONG_MIN;

void find_best(string &s, int pos, string generated) {
    if (pos == s.length()) {
        ll pos_val = count_value(generated);
        if (pos_val > max_value) {
            max_value = pos_val;
            best_string = generated;
        }
        return;
    }
    bool was_gen = false;
    for (int i = pos; i < s.length(); ++i) {
        if (s[i] != '?') {
            generated += s[i];
            continue;
        }
        was_gen = true;
        for (char c = 'A'; c <= 'Z'; ++c) {
            generated += c;
            find_best(s, i + 1, generated);
            generated.pop_back();

        }
    }
    if (!was_gen) {
        find_best(s, s.length(), generated);
    }
}

int solve() {
    if (!(cin >> n))
        return 1;
    ll val = 1;
    for (char c = 'A'; c <= 'Z'; ++c) {
        to_values[c] = val;
        if ((c - 'A') % 2 == 0) {
            val *= 5LL;
        } else {
            val *= 2LL;
        }
    }

    for (int _ = 0; _ < n; ++_) {
        max_value = LONG_LONG_MIN;
        best_string = "";
        string s;
        cin >> s;
        int l = s.length();
        vector<int> positions;
        vector<char> replacements;

        find_best(s, 0, "");
        cout << max_value << '\n';
        cout << best_string << '\n';
    }
    return 0;
}


int main() {
#ifdef LOCAL
    freopen("A.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    for (int i = 0; i < tests; ++i) {
        if (solve())
            break;

#ifdef LOCAL
        cout << "------------------------\n";
#endif
    }
}