#include <bits/stdc++.h>
using ll = long long;
using namespace std;
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()

const int MAXN = 15;
int cost[MAXN];
int matrix[MAXN][MAXN];
pair<pair<int, int>, int> edges[MAXN];
int n, m;


void solve(){
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            matrix[i][j] = -1;
    for (int i = 0; i < m; i++){
        int v, u, t;
        cin >> v >> u >> t;
        --v, --u;
        edges[i] = {{v, u}, t};
    }
    vector<int> perm(m);
    iota(ALL(perm), 0);
    fill(cost, cost + n, 2 * 1'000'000'000);
    do{
        int mn = 1e9;
        int mx = 0;
        int now = 0;
        for (int i = 0; i < m; i++){
            auto [vu, w] = edges[perm[i]];
            auto [v, u] = vu;
            if (v != now && u != now)
                break;
            mx = max(mx, w);
            mn = min(mn, w);
            cost[v ^ u ^ now] = min(cost[v ^ u ^ now], mx + mn);
            now ^= (v ^ u);
        }
    } while (next_permutation(perm.begin(), perm.end()));
    for (int i = 1; i < n; i++)
        cout << cost[i] << '\n';
    return 0;
}
