#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 1e18;

vector<int> pr;

void precalc() {
    pr.resize(26);
    pr[0] = 1;
    for (int i = 1; i < 26; ++i) {
        if (i % 2 == 1)
            pr[i] = pr[i - 1] * 5;
        else
            pr[i] = pr[i - 1] * 2;
    }
}

void solve() {
    string s;
    cin >> s;
    int n = s.size();
    vector<vector<int>> dp(n + 1, vector<int>(26, -INF));

    for (int i = 0; i < 26; ++i)
        dp[n][i] = 0;

    for (int i = n - 1; i >= 0; --i) {
        if (s[i] == '?') {
            for (int a = 0; a < 26; ++a) {
                for (int b = 0; b < 26; ++b) {
                    if (b > a) {
                        if (dp[i + 1][b] > -INF)
                            dp[i][b] =
                                    max(dp[i][b], dp[i + 1][b] - pr[a]);
                    } else {
                        if (dp[i + 1][b] > -INF)
                            dp[i][a] =
                                    max(dp[i][a], dp[i + 1][b] + pr[a]);
                    }
                }
            }
        } else {
            for (int b = 0; b < 26; ++b) {
                if (b > s[i] - 'A') {
                    if (dp[i + 1][b] > -INF)
                        dp[i][b] =
                                max(dp[i][b], dp[i + 1][b] - pr[s[i] - 'A']);
                } else {
                    if (dp[i + 1][b] > -INF)
                        dp[i][s[i] - 'A'] =
                                max(dp[i][s[i] - 'A'], dp[i + 1][b] + pr[s[i] - 'A']);
                }
            }
        }
    }

    int m = 0;
    for (int i = 0; i < 26; ++i)
        if (dp[0][i] > dp[0][m])
            m = i;
    //cout << dp[0]['Y' - 'A'] << endl;
    cout << dp[0][m] << endl;

    for (int i = 0; i < n; ++i) {
        if (s[i] == '?') {
            int d = -1, tm = m;
            for (int a = 0; a < 26; ++a) {
                for (int b = 0; b < 26; ++b) {
                    if (b > a && b == m) {
                        if (dp[i + 1][b] > -INF &&
                            dp[i][m] == dp[i + 1][b] - pr[a]) {
                            tm = b;
                            d = a;
                        }
                    } else if (a >= b && a == m) {
                        if (dp[i][m] == dp[i + 1][b] + pr[a]) {
                            tm = b;
                            d = a;
                        }
                    }
                }
            }

            m = tm;
            assert(d != -1);
            cout << ((char) (d + 'A'));
        } else {
            cout << s[i];

            if (s[i] == m) {
                int tm = m;
                int a = s[i] - 'A';
                for (int prev = 0; prev < 26; ++prev) {
                    if (prev > a && prev == m) {
                        if (dp[i + 1][prev] > -INF &&
                            dp[i][m] == dp[i + 1][prev] - pr[a]) {
                            tm = prev;
                        }
                    } else if (a >= prev && a == m) {
                        if (dp[i][m] == dp[i + 1][prev] + pr[a]) {
                            tm = prev;
                        }
                    }
                }
                m = tm;
            }

        }
    }
    cout << endl;
}

signed main() {
    precalc();

    int t;

    cin >> t;
    while (t--)
        solve();
    return 0;
}
