#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
#define x first
#define y second

void debug_out() {
    cerr << endl;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
const int N = 3e5 + 5;
const int INF = 1e18;

#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)

int sootv[26];
pair<int, int> dp[N][26];
int p[N][26];

void solve() {
    string s;
    cin >> s;
    int n = sz(s);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 26; j++) {
            dp[i][j] = {-INF, -INF};
        }
    }
    if (s[n - 1] == '?') {
        for (int i = 0; i < 26; i++) {
            dp[n - 1][i] = {sootv[i], i};
        }
    } else {
        int c = s[n - 1] - 'A';
        dp[n - 1][c] = {sootv[c], c};
    }
    for (int i = n - 2; i >= 0; i--) {
        if (s[i] != '?') {
            int c = s[i] - 'A';
            for (int prev = 0; prev < 26; prev++) {
                int aga = dp[i + 1][prev].x;
                if (prev > c) {
                    aga -= sootv[c];
                } else {
                    aga += sootv[c];
                }
                if (aga > dp[i][max(c, prev)].x) {
                    dp[i][max(c, prev)] = {aga, c};
                    p[i][max(c, prev)] = prev;
                }
            }
        } else {
            for (int here = 0; here < 26; here++) {
                for (int prev = 0; prev < 26; prev++) {
                    int aga = dp[i + 1][prev].x;
                    if (prev > here) {
                        aga -= sootv[here];
                    } else {
                        aga += sootv[here];
                    }
                    if (aga > dp[i][max(here, prev)].x) {
                        dp[i][max(here, prev)] = {aga, here};
                        p[i][max(here, prev)] = prev;
                    }
                }
            }
        }
    }
    int res = -INF;
    for (int i = 0; i < 26; i++) {
        res = max(res, dp[0][i].x);
    }
    int x;
    for (int i = 0; i < 26; i++) {
        if (dp[0][i].x == res) {
            x = i;
        }
    }
    string ss;
    for (int i = 0; i < n; i++) {
        ss += 'A' + dp[i][x].y;
        x = p[i][x];
    }
    cout << res << '\n';
    cout << ss << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    sootv[0] = 1;
    for (int i = 1; i < 26; i++) {
        if (i % 2) {
            sootv[i] = sootv[i - 1] * 5;
        } else {
            sootv[i] = sootv[i - 1] * 2;
        }
    }

    int T = 1;
    cin >> T;

    while (T-- > 0) {
        solve();
    }

    return 0;
}
