#include "bits/stdc++.h"

using namespace std;
typedef long long ll;
//#define int ll
const int MAXN = 1e5;
vector<int> affectl[MAXN];
vector<int> affectr[MAXN];
int cl[MAXN];
int cr[MAXN];
int tmpl[MAXN];
int tmpr[MAXN];
int usd[MAXN];

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> x(n);
    vector<int> h(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
    for (int i = 0; i < n; ++i) {
        cl[i] = -1;
        cr[i] = -1;
        if (x[i] - h[i] >= x[0]) {
            cl[i] = 0;
            for (int j = i - 1; j >= 0; --j) {
                if (x[j] > x[i] - h[i]) {
                    affectl[j].push_back(i);
                    cl[i]++;
                } else {
                    break;
                }

            }
        }
        if (x[i] + h[i] <= x.back()) {
            cr[i] = 0;
            for (int j = i + 1; j <n; ++j) {
                if (x[j] < x[i] + h[i]) {
                    affectr[j].push_back(i);
                    cr[i]++;
                } else {
                    break;
                }

            }
        }
    }
    for (int req = 0; req < q; ++req) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        queue<int> q;
        for (int i = l; i <= r; ++i) {
            tmpl[i] = cl[i];
            tmpr[i] = cr[i];
            usd[i] = 0;
            if (cl[i] == 0 || cr[i] == 0) {
                q.push(i);
                usd[i] =1 ;
            }
        }
        int ans = 0;
        while (!q.empty()) {
            ans++;
            int v = q.front();
            q.pop();
            for (auto to: affectl[v]) {
                if (to< l || to > r) continue;
                if (usd[to]) continue;
                tmpl[to]--;
                if (tmpl[to] == 0) {
                    q.push(to);
                    usd[to] = 1;
                }
            }
            for (auto to: affectr[v]) {
                if (to< l || to > r) continue;
                if (usd[to]) continue;
                tmpr[to]--;
                if (tmpr[to] == 0) {
                    q.push(to);
                    usd[to] = 1;
                }
            }
        }
        cout << ans <<'\n';

    }


}

signed main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();

}