#include<bits/stdc++.h>

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

typedef long long ll;
int const maxn = 3e5 + 5;
ll dp[maxn][26];
pair < int, int > lst[maxn][26];
ll inf = 1e18;
ll cost[26];

main() {
#ifdef karpovich
    freopen("input.txt", "r", stdin);
#endif // karpovich
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    cost[0] = 1;
    for (int i = 1; i < 26; ++i) {
        cost[i] = cost[i - 1];
        if (i % 2 == 1) cost[i] *= 5;
        else cost[i] *= 2;
    }
    while (t--) {
        string s;
        cin >> s;
        s = "#" + s;
        for (int i = 0; i <= (int)s.size(); ++i) {
            for (int j = 0; j < 26; ++j) dp[i][j] = -inf;
        }
        dp[(int)s.size()][0] = 0;
        for (int i = (int)s.size() - 1; i >= 1; --i) {
            for (int j = 0; j < 26; ++j) {
                if (s[i] != '?' && s[i] != char('A' + j)) continue;
                for (int was = 0; was < 26; ++was) {
                    if (was > j) {
                        if (dp[i + 1][was] - cost[j] > dp[i][was]) {
                            dp[i][was] = dp[i + 1][was] - cost[j];
                            lst[i][was] = {j, was};
                        }
                    }
                    else {
                        if (dp[i + 1][was] + cost[j] > dp[i][j]) {
                            dp[i][j] = dp[i + 1][was] + cost[j];
                            lst[i][j] = {j, was};
                        }
                    }
                }
            }
        }
        int i = 1, j = 0;
        for (int pos = 0; pos < 26; ++pos) {
            if (dp[1][pos] > dp[1][j]) j = pos;
        }
        cout << dp[i][j] << '\n';
        while (i < (int)s.size()) {
            cout << char('A' + lst[i][j].first);
            j = lst[i][j].second;
            i++;
        }
        cout << '\n';
    }
    return 0;
}
