#include<bits/stdc++.h>

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int const maxn = 5005, maxN = 3e5 + 5;
multiset < pair < int, int > > g[maxN];
int inf = 1e9 + 7;
int ans[maxN], best[maxN], cur, timer;
int used[maxN], tin[maxN], up[maxN];
int cnt[maxn][maxn];
int f[maxn][maxn];
int cmp[maxN], imin[maxN], numb, goal[maxN];
vector < pair < int, int > > go[maxN];
int check[maxN], w;
int tape[maxN], sz[maxN];
int win[maxN], childs[maxN];

int get(int i) {
    if (i == tape[i]) return i;
    return get(tape[i]);
}

inline void unions(int x, int y) {
    x = get(x), y = get(y);
    if (x == y) return;
    if (sz[x] < sz[y]) {
        tape[x] = y;
        win[y] += win[x];
    }
    else if (sz[x] > sz[y]) {
        tape[y] = x;
        win[x] += win[y];
    }
    else {
        tape[x] = y;
        sz[y]++;
        win[y] += win[x];
    }
}

void dfss(int v, int p, int val1, int val2) {
    ans[v] = val1 + val2;
    for (auto u : g[v]) {
        if (u.first != p) {
            dfss(u.first, v, min(val1, u.second), max(val2, u.second));
        }
    }
}

void dfs2(int v, int p, int d) {
    d = min(d, imin[v]);
    goal[v] = d;
    check[v] = w;
    for (auto u : go[v]) {
        if (u.first == p || check[u.first] == w) continue;
        dfs2(u.first, v, min(d, u.second));
    }
}

void dfs(int v, int p) {
    used[v] = cur;
    tin[v] = timer++, up[v] = tin[v];
    for (auto u : g[v]) {
        if (u.first == p) continue;
        if (used[u.first] == cur) {
            up[v] = min(up[v], tin[u.first]);
        }
        else {
            dfs(u.first, v);
            up[v] = min(up[v], up[u.first]);
            if (up[u.first] > tin[v] && cnt[min(u.first, v)][max(u.first, v)] == 1) {
                f[min(u.first, v)][max(u.first, v)] = cur;
            }
        }
    }
}

void dfs1(int v, int p) {
    cmp[v] = numb;
    for (auto u : g[v]) {
        if (cmp[u.first] == 0 && f[min(u.first, v)][max(u.first, v)] != cur) dfs1(u.first, v);
    }
}

void build(int n) {
    cur++;
    for (int i = 1; i <= n; ++i) {
        go[i] = {};
        if (used[i] != cur) dfs(i, 0);
    }
    numb = 0;
    for (int i = 1; i <= n; ++i) cmp[i] = 0;
    for (int i = 1; i <= n; ++i) {
        if (cmp[i] == 0) {
            numb++;
            imin[numb] = inf;
            dfs1(i, 0);
        }
    }
    for (int i = 1; i <= n; ++i) {
        best[i] = inf;
        goal[i] = inf;
        for (auto key : g[i]) {
            if (cmp[i] == cmp[key.first]) imin[cmp[i]] = min(imin[cmp[i]], key.second);
            else {
                go[cmp[i]].push_back({cmp[key.first], key.second});
                go[cmp[key.first]].push_back({cmp[i], key.second});
            }
        }
    }
    w++;
    dfs2(cmp[1], 0, imin[1]);
    for (int i = 1; i <= n; ++i) {
        best[i] = goal[cmp[i]];
    }
}

main() {
#ifdef karpovich
    freopen("input.txt", "r", stdin);
#endif // karpovich
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, u, v, l, r, t;
    cin >> n >> m;
    vector < vector < int > > Q;
    for (int i = 1; i <= n; ++i) ans[i] = 2 * inf;
    for (int i = 1; i <= m; ++i) {
        cin >> u >> v >> t;
        if (u > v) swap(u, v);
        if (n <= 5000) cnt[u][v]++;

        g[u].insert({v, t});
        g[v].insert({u, t});

    }

    for (int i = 1; i <= n; ++i) {
        int lst = -1, cnt = 0;
        multiset < pair < int, int > > neww;
        for (auto key : g[i]) {
            if (key.first == lst) cnt++;
            else lst = key.first, cnt = 1;
            if (cnt <= 2) {
                neww.insert(key);
                if (i < key.first) Q.push_back({key.second, i, key.first});
            }
        }
        g[i] = neww;
    }

    if (m == n - 1) {
        dfss(1, 0, inf, -inf);
        for (int i = 2; i <= n; ++i) cout << ans[i] << '\n';
        exit(0);
    }
    vector < int > tops;
    sort(Q.begin(), Q.end());
    int K;
    if (m <= 2000) K = 64;
    else K = 8;
    for (int i = 1; i <= n; ++i) {
        int it = 0;
        for (auto key : g[i]) {
            it++;
            if (it <= K) tops.push_back(key.second);
        }
        auto gt = g[i].end();
        while (gt != g[i].begin() && it <= K * 2) {
            it++;
            gt--;
            tops.push_back((*gt).second);
        }
    }
    reverse(Q.begin(), Q.end());
    int i = 0;
    sort(tops.rbegin(), tops.rend());
    int lst = -1;
    for (auto key : tops) {
        if (lst == key) continue;
        lst = key;
        if (1.0 * clock() / CLOCKS_PER_SEC > 2.8) break;
        while (i < (int)Q.size() && Q[i][0] > key) {
            u = Q[i][1], v = Q[i][2], t = Q[i][0];
            g[u].erase(g[u].find({v, t}));
            g[v].erase(g[v].find({u, t}));
            cnt[u][v]--;
            i++;
        }
        build(n);
        for (int j = 2; j <= n; ++j) if (best[j] != inf) ans[j] = min(ans[j], key + best[j]);
    }
    for (int i = 2; i <= n; ++i) {
        cout << ans[i] << '\n';
    }
    return 0;
}

