#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

int x[500009];
int h[500009];

const int inf = 1e9 + 7;
bool dp[10009][10009];

pii lefseg[500009];
pii rigseg[500009];

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        freopen("input.txt", "r", stdin);
    #endif // localfile

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; i++) {
        cin >> x[i] >> h[i];
    }

    x[0] = x[1];
    x[n + 1] = x[n];

    for (int i = 1; i <= n; i++) {
        int l = 0, r = i + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (x[m] <= x[i] - h[i] + 1) {
                l = m;
            }

            else {
                r = m;
            }
        }

        lefseg[i] = {l, i - 1};
        l = i, r = n + 2;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (x[m] > x[i] + h[i] - 1) {
                r = m;
            }

            else {
                l = m;
            }
        }

        rigseg[i] = {i + 1, l};

        //cout << i << ' ' << lefseg[i].x << ' ' << lefseg[i].y << endl;
        //cout << i << ' ' << rigseg[i].x << ' ' << rigseg[i].y << endl;
    }

    for (int i = 1; i <= n + 1; i++) {
        for (int j = 0; j < i; j++) dp[i][j] = 1;
    }

    for (int len = 1; len <= n; len++) {
        for (int i = 1; i + len - 1 <= n; i++) {
            int j = i + len - 1;
            if (i == j && (lefseg[i].x > lefseg[i].y || rigseg[i].x > rigseg[i].y)) {
                dp[i][j] = 1;
            }

            else if (i != j) {
                dp[i][j] = 1;
                for (int m = i; m <= j; m++) {
                    if (lefseg[m].x >= i && dp[lefseg[m].x][m - 1] || rigseg[m].y <= j && dp[m + 1][rigseg[m].y]) ;
                    else dp[i][j] = 0;
                }
            }
        }
    }

    for (int qqq = 0; qqq < q; qqq++) {
        int l, r;
        cin >> l >> r;

        int answ = 0;
        for (int i = l; i <= r; i++) {
            if (lefseg[i].x >= l && dp[lefseg[i].x][i - 1] || rigseg[i].y <= r && dp[i + 1][rigseg[i].y]) {
                answ++;
            }
        }

        cout << answ << "\n";
    }

    return 0;
}


