#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

vector<pii> g[300009];
int dist[300009];
int answ[300009];

bool used[300009];

const int inf = 1e9 + 7;

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        freopen("input.txt", "r", stdin);
    #endif // localfile

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;

        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }

    for (int i = 1; i <= n; i++) {
        dist[i] = inf;
    }

    dist[1] = 1e9;
    priority_queue<pii> q;
    q.push({-1e9, 1});

    while (q.size()) {
        auto vp = q.top();
        q.pop();

        int v = vp.y;
        if (dist[v] != -vp.x) {
            continue;
        }

        used[v] = 1;

        for (auto e : g[v]) {
            int u = e.x;
            if (used[u] == 0 && dist[u] > min(dist[v], e.y)) {
                dist[u] = min(dist[v], e.y);
                q.push({-dist[u], u});
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        answ[i] = dist[i] + 1000000000;
    }

    for (int i = 2; i <= n; i++) {
        cout << answ[i] << "\n";
    }

    return 0;
}
