#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

vector<pii> g[300009];
int dist[300009];
int answ[300009];

const int inf = 1e9 + 7;

int tin[300009];
int fup[300009];

bool brid[300009];
int cost[300009];
bool used[300009];

int timer = 0;

bool cmp(pii a, pii b) {
    return cost[a.y] < cost[b.y];
}

void dfs(int v, int p, int currmn) {
    dist[v] = currmn;
    used[v] = 1;
    tin[v] = timer++;
    fup[v] = tin[v];

    sort(g[v].begin(), g[v].end(), cmp);

    for (auto e : g[v]) {
        if (e.y == p) continue;
        int u = e.x;
        if (used[u]) {
            //cout << v << ' ' << u << endl;
            fup[v] = min(fup[v], tin[u]);
        }

        else {
            dfs(u, e.y, min(currmn, cost[e.y]));
            fup[v] = min(fup[v], fup[u]);
            //cout << v << ' ' << u << ' ' << e.y << ' '<<tin[v] << ' ' << fup[u] <<' ' << fup[v]<< endl;
            if (fup[u] > tin[v]) {
                   // cout << e.y << endl;
                brid[e.y] = 1;
            }
        }
    }
}

int comp[300009];
int mncomp[300009];
int color = 1;
void dfs_comp(int v) {
    comp[v] = color;
    for (auto u : g[v]) {
        if (comp[u.x] == 0 && brid[u.y] == 0) {
            mncomp[color] = min(mncomp[color], cost[u.y]);
            dfs_comp(u.x);
        }
    }
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        freopen("input.txt", "r", stdin);
        freopen("wa.txt", "w", stdout);
    #endif // localfile

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;

        g[a].push_back({b, i});
        g[b].push_back({a, i});
        cost[i] = c;
    }

    for (int i = 1; i <= n; i++) {
        dist[i] = inf;
    }

    dfs(1, -1, 1000000000);

    for (int i = 1; i <= n; i++) {
        if (comp[i] == 0) {
            mncomp[color] = inf;
            dfs_comp(i);
            color++;
        }
    }

    for (int i = 1; i <= n; i++) {
        dist[i] = min(dist[i], mncomp[comp[i]]);
    }

    for (int i = 1; i <= n; i++) {
        answ[i] = dist[i] + 1000000000;
    }

    for (int i = 2; i <= n; i++) {
        cout << answ[i] << "\n";
    }

    return 0;
}
