#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

ll K = 26;

vector<ll> P(13, 1);

inline ll val(char c) {
    if (c == '?') return 0;
    else return (((c - 'A') % 2) ? 5 : 1) * P[(c - 'A') / 2];
}

inline ll val(ll c) {
    return val(char('A' + c));
}

const ll INF = 3e18;

int main() {
    for (ll i = 0; i < P.size() - 1; i++) P[i + 1] = P[i] * 10ll;
    ll t;
    cin >> t;
    while (t--) {
        string s;
        cin >> s;
        ll n = s.length();
        reverse(s.begin(), s.end());
        vector<vector<ll>> d(n + 1, vector<ll>(K, -INF));
        vector<vector<pair<ll, char>>> a(n + 1, vector<pair<ll, char>>(K));
        for (ll k = 0; k < K; k++) d[0][k] = 0;
        for (ll i = 0; i < n; i++) {
            if (ll v = val(s[i])) {
                for (ll j = s[i] - 'A'; j < K; j++) {
                    for (ll k = 0; k <= j; k++) {
                        ll c = d[i][k] + v * (k > (s[i] - 'A') ? -1 : 1);
                        if (c > d[i + 1][j]) d[i + 1][j] = c, a[i + 1][j] = {k, s[i]};
                    }
                }
            } else {
                for (ll k = 0; k < K; k++) {
                    ll r = -INF;
                    pair<ll, ll> p;
                    for (ll j = 0; j < K; j++) {
                        ll c = d[i][j] + val(k) * (j > k ? -1 : 1);
                        if (c > r) r = c, p = {j, 'A' + k};
                    }
                    for (ll j = k; j < K; j++) if (d[i + 1][j] < r) d[i + 1][j] = r, a[i + 1][j] = p;
                }
            }
        }
        cout << d[n][K - 1] << '\n';
        string r;
        r.reserve(s.size());
        {
            ll i = n, k = K - 1;
            while (i != 0) {
                r.push_back(a[i][k].second);
                k = a[i--][k].first;
            }
        }
        cout << r << '\n';
    }
}
