#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define em emplace
#define eb emplace_back
#define pb pop_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 1.5e5 + 5;

int n, m;
bool used[N];
vector<int> g[N];
bool dp[N][3];
set<pii> edges;

void dfs(int v, int p = 0) {
    used[v] = true;
    int cnt1 = 0, cnt2 = 0, cnt12 = 0, cnt01 = 0, cnt02 = 0, cnt012 = 0;
    for (int u : g[v]) if (!used[u]) {
        dfs(u, v);
        cnt1 += (dp[u][1] && !dp[u][0] && !dp[u][2]);
        cnt2 += (dp[u][2] && !dp[u][0] && !dp[u][1]);
        cnt12 += (dp[u][1] && dp[u][2] && !dp[u][0]);
        cnt01 += (dp[u][0] && dp[u][1] && !dp[u][2]);
        cnt02 += (dp[u][0] && dp[u][2] && !dp[u][1]);
        cnt012 += (dp[u][0] && dp[u][1] && dp[u][2]);
    }
    cnt12 %= 2;
    if (edges.count(mp(v, p)) && edges.count(mp(p, v))) {
        //     - dp[v][0]
        if (cnt1 > cnt2) {
            dp[v][0] = (cnt1 - cnt2 - cnt12 - cnt02 - cnt012 <= 0);
        } else {
            dp[v][0] = (cnt2 - cnt1 - cnt12 - cnt01 - cnt012 <= 0);
        }
        //   (p->v) - dp[v][1]
        cnt1++;
        if (cnt1 > cnt2) {
            dp[v][1] = (cnt1 - cnt2 - cnt12 - cnt02 - cnt012 <= 0);
        } else {
            dp[v][1] = (cnt2 - cnt1 - cnt12 - cnt01 - cnt012 <= 0);
        }
        cnt1--;
        //   (v->p) - dp[v][2]
        cnt2++;
        if (cnt1 > cnt2) {
            dp[v][2] = (cnt1 - cnt2 - cnt12 - cnt02 - cnt012 <= 0);
        } else {
            dp[v][2] = (cnt2 - cnt1 - cnt12 - cnt01 - cnt012 <= 0);
        }
        cnt2--;
    } else if (edges.count(mp(v, p))) {
        //     - dp[v][1]
        if (cnt1 > cnt2) {
            dp[v][1] = (cnt1 - cnt2 - cnt12 - cnt02 - cnt012 <= 0);
        } else {
            dp[v][1] = (cnt2 - cnt1 - cnt12 - cnt01 - cnt012 <= 0);
        }
        //   (v->p) - dp[v][0]
        cnt2++;
        if (cnt1 > cnt2) {
            dp[v][0] = (cnt1 - cnt2 - cnt12 - cnt02 - cnt012 <= 0);
        } else {
            dp[v][0] = (cnt2 - cnt1 - cnt12 - cnt01 - cnt012 <= 0);
        }
        cnt2--;
    } else if (edges.count(mp(p, v))) {
        //     - dp[v][2]
        if (cnt1 > cnt2) {
            dp[v][2] = (cnt1 - cnt2 - cnt12 - cnt02 - cnt012 <= 0);
        } else {
            dp[v][2] = (cnt2 - cnt1 - cnt12 - cnt01 - cnt012 <= 0);
        }
        //   (p->v) - dp[v][0]
        cnt1++;
        if (cnt1 > cnt2) {
            dp[v][0] = (cnt1 - cnt2 - cnt12 - cnt02 - cnt012 <= 0);
        } else {
            dp[v][0] = (cnt2 - cnt1 - cnt12 - cnt01 - cnt012 <= 0);
        }
        cnt1--;
    } else {
        if (cnt1 > cnt2) {
            dp[v][0] = (cnt1 - cnt2 - cnt12 - cnt02 - cnt012 <= 0);
        } else {
            dp[v][0] = (cnt2 - cnt1 - cnt12 - cnt01 - cnt012 <= 0);
        }
    }
}

vector<pair<pii, pii>> ans;

void calc_ans(int v, int t, int p);

void parse(int v, int t, int p, vector<int> &type1, vector<int> &type2, vector<int> &type12, vector<int> &type01, vector<int> &type02, vector<int> &type012) {
    while (!type1.empty() && !type2.empty()) {
        int x = type1.back();
        type1.pb();
        int y = type2.back();
        type2.pb();
        ans.eb(mp(x, v), mp(v, y));
        if (x != p) calc_ans(x, 1, v);
        if (y != p) calc_ans(y, 2, v);
    }
    if (!type1.empty()) {
        if (!type12.empty()) {
            int x = type1.back();
            type1.pb();
            int y = type12.back();
            type12.pb();
            ans.eb(mp(x, v), mp(v, y));
            if (x != p) calc_ans(x, 1, v);
            if (y != p) calc_ans(y, 2, v);
        }
        while (!type1.empty() && !type02.empty()) {
            int x = type1.back();
            type1.pb();
            int y = type02.back();
            type02.pb();
            ans.eb(mp(x, v), mp(v, y));
            if (x != p) calc_ans(x, 1, v);
            if (y != p) calc_ans(y, 2, v);
        }
        while (!type1.empty() && !type012.empty()) {
            int x = type1.back();
            type1.pb();
            int y = type012.back();
            type012.pb();
            ans.eb(mp(x, v), mp(v, y));
            if (x != p) calc_ans(x, 1, v);
            if (y != p) calc_ans(y, 2, v);
        }
    } else if (!type2.empty()) {
        if (!type12.empty()) {
            int x = type2.back();
            type2.pb();
            int y = type12.back();
            type12.pb();
            ans.eb(mp(y, v), mp(v, x));
            if (x != p) calc_ans(x, 2, v);
            if (y != p) calc_ans(y, 1, v);
        }
        while (!type2.empty() && !type01.empty()) {
            int x = type2.back();
            type2.pb();
            int y = type01.back();
            type01.pb();
            ans.eb(mp(y, v), mp(v, x));
            if (x != p) calc_ans(x, 2, v);
            if (y != p) calc_ans(y, 1, v);
        }
        while (!type2.empty() && !type012.empty()) {
            int x = type2.back();
            type2.pb();
            int y = type012.back();
            type012.pb();
            ans.eb(mp(y, v), mp(v, x));
            if (x != p) calc_ans(x, 2, v);
            if (y != p) calc_ans(y, 1, v);
        }
    }
    while (!type01.empty()) {
        int x = type01.back();
        type01.pb();
        if (x != p) calc_ans(x, 0, v);
    }
    while (!type02.empty()) {
        int x = type02.back();
        type02.pb();
        if (x != p) calc_ans(x, 0, v);
    }
    while (!type012.empty()) {
        int x = type012.back();
        type012.pb();
        if (x != p) calc_ans(x, 0, v);
    }
}

void calc_ans(int v, int t, int p) {
    if (used[v]) return;
    used[v] = 1;
    vector<int> type1, type2, type12, type01, type02, type012;
    for (int u : g[v]) if (!used[u]) {
        if (dp[u][1] && !dp[u][0] && !dp[u][2]) {
            type1.eb(u);
        }
        if (dp[u][2] && !dp[u][0] && !dp[u][1]) {
            type2.eb(u);
        }
        if (dp[u][1] && dp[u][2] && !dp[u][0]) {
            type12.eb(u);
        }
        if (dp[u][0] && dp[u][1] && !dp[u][2]) {
            type01.eb(u);
        }
        if (dp[u][0] && dp[u][2] && !dp[u][1]) {
            type02.eb(u);
        }
        if (dp[u][0] && dp[u][1] && dp[u][2]) {
            type012.eb(u);
        }
    }
    while (sz(type12) > 1) {
        int x = type12.back();
        type12.pb();
        int y = type12.back();
        type12.pb();
        ans.eb(mp(x, v), mp(v, y));
        if (x != p) calc_ans(x, 1, v);
        if (y != p) calc_ans(y, 2, v);
    }
    if (edges.count(mp(v, p)) && edges.count(mp(p, v))) {
        if (t == 0) {
            //     - dp[v][0]
            assert(dp[v][0]);
            parse(v, t, p, type1, type2, type12, type01, type02, type012);
        }
        if (t == 1) {
            //   (p->v) - dp[v][1]
            assert(dp[v][1]);
            type1.eb(p);
            parse(v, t, p, type1, type2, type12, type01, type02, type012);
        }
        if (t == 2) {
            //   (v->p) - dp[v][2]
            assert(dp[v][2]);
            type2.eb(p);
            parse(v, t, p, type1, type2, type12, type01, type02, type012);
        }
    } else if (edges.count(mp(v, p))) {
        if (t == 1) {
            //     - dp[v][1]
            assert(dp[v][1]);
            parse(v, t, p, type1, type2, type12, type01, type02, type012);
        }
        if (t == 0) {
            //   (v->p) - dp[v][0]
            assert(dp[v][0]);
            type2.eb(p);
            parse(v, t, p, type1, type2, type12, type01, type02, type012);
        }
    } else if (edges.count(mp(p, v))) {
        if (t == 2) {
            //     - dp[v][2]
            assert(dp[v][2]);
            parse(v, t, p, type1, type2, type12, type01, type02, type012);
        }
        if (t == 0) {
            //   (p->v) - dp[v][0]
            assert(dp[v][0]);
            type1.eb(p);
            parse(v, t, p, type1, type2, type12, type01, type02, type012);
        }
    } else {
        assert(t == 0 && dp[v][0]);
        parse(v, t, p, type1, type2, type12, type01, type02, type012);
    }
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        int v, u;
        cin >> v >> u;
        g[v].eb(u);
        g[u].eb(v);
        edges.em(mp(v, u));
    }
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            dfs(i);
            if (!dp[i][0]) {
                cout << "No\n";
                return 0;
            }
        }
    }
    for (int v = 1; v <= n; ++v) {
        if (!dp[v][0] && !dp[v][1] && !dp[v][2]) {
            cout << "No\n";
            return 0;
        }
    }
    cout << "Yes\n";
    fill(used + 1, used + n + 1, false);
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            calc_ans(i, 0, 0);
        }
    }
    for (auto &pp : ans) {
        edges.erase(pp.fi);
        edges.erase(pp.se);
    }
    for (int i = 1; i <= n; ++i) {
        for (int j : g[i]) {
            if (edges.count(mp(i, j))) {
                assert(edges.count(mp(j, i)));
                ans.eb(mp(i, j), mp(j, i));
                edges.erase(mp(i, j));
                edges.erase(mp(j, i));
            }
        }
    }
    for (auto &pp : ans) {
        cout << pp.fi.fi << " " << pp.fi.se << " " << pp.se.fi << " " << pp.se.se << "\n";
    }
    return 0;
}
