#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define em emplace
#define eb emplace_back
#define pb pop_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 3e5 + 5;

int n, q;
int x[N], h[N];
int lef[N], rig[N];

bool check(int i, int L, int R) {
    if (x[i] - h[i] >= L) {
        if (lef[i] == -1 || x[i] - h[i] >= x[lef[i]]) {
            return true;
        }
    }
    if (x[i] + h[i] <= R) {
        if (rig[i] == n +1 || x[i] + h[i] <= x[rig[i]]) {
            return true;
        }
    }
    return false;
}

int Q[N];
bool used[N];

int32_t main() {
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);

    cin.tie(0);
    cin >> n >> q;
    for (int i = 1; i <= n; ++i) cin >> x[i] >> h[i];
    while (q--) {
        int l, r;
        cin >> l >> r;
        int L = x[1], R = x[n];
        if (l != 1) L = x[l - 1];
        if (r != n) R = x[r + 1];
        int tail = 0;
        fill(used + l, used + r + 1, false);
        for (int i = l; i <= r; ++i) {
            lef[i] = i - 1;
            rig[i] = i + 1;
            if (i == l) lef[i] = -1;
            if (i == r) rig[i] = n + 1;
            if (check(i, L, R)) Q[tail++] = i, used[i] = 1;
        }
        int ans = 0;
        for (int head = 0; head < tail; ++head) {
            int i = Q[head];
            ans++;
            int plef = lef[i], prig = rig[i];
            if (plef != -1) rig[plef] = prig;
            if (prig != n + 1) lef[prig] = plef;
            if (plef != -1 && check(plef, L, R) && !used[plef]) Q[tail++] = plef;
            if (prig != n + 1 && check(prig, L, R) && !used[prig]) Q[tail++] = prig;
        }
        cout << ans << "\n";
    }
    return 0;
}
