#include <bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define all(x) x.begin(), x.end()
#define mp make_pair
//define int long long
#define time() clock() / (ld)CLOKS_PER_SEC

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

const int MAXN = 1e4 + 10;

int lefx, rigx, l, r;

pii a[MAXN];
int used[MAXN];
int lef[MAXN], rig[MAXN];

int n;

bool check(int i) {
    if (!(i >= l && i <= r) || used[i]) return 0;
    if (a[i].f - a[i].s >= lefx && (lef[i] == -1 || a[i].f - a[i].s >= a[lef[i]].f)) return 1;
    if (a[i].f + a[i].s <= rigx && (rig[i] == n + 1 || a[i].f + a[i].s <= a[rig[i]].f)) return 1;
    return 0;
}

void del(int i) {
    if (lef[i] != -1) rig[lef[i]] = rig[i];
    if (rig[i] != n + 1) lef[rig[i]] = lef[i];
}

int get_ans() {
    fill(used, used + MAXN, 0);
    for (int i = l; i <= r; i++) {
        if (i - 1 >= 0) lef[i] = i - 1;
        else lef[i] = -1;
        if (i + 1 <= n - 1) rig[i] = i + 1;
        else rig[i] = n + 1;
    }
    vector<int> q;
    for (int i = l; i <= r; i++) {
        if (check(i)) {
            q.push_back(i);
            used[i] = 1;
        }
    }
    int ans = 0;
    while (q.size() > 0) {
        auto i = q.back();
        q.pop_back();
        del(i);
        ans++;
        if (check(lef[i])) {
            q.push_back(lef[i]);
            used[lef[i]] = 1;
        }
        if (check(rig[i])) {
            q.push_back(rig[i]);
            used[rig[i]] = 1;
        }
    }
    return ans;
}

void solve() {
    int q;
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        cin >> a[i].f >> a[i].s;
    }
    lefx = a[0].f, rigx = a[n - 1].f;
    while (q--) {
        cin >> l >> r;
        l--;
        r--;
        cout << get_ans() << '\n';
    }
}

signed main() {
    #ifdef LOCAL
        //freopen("input.txt", "r", stdin);
    #endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}

