#include <bits/stdc++.h>
using namespace std;
#define int long long

const int INF = 1e20;

int get_val(int a)
{
    int ans = 1;
    for (int i = 1; i <= a; i += 2)
        ans *= 5;
    for (int i = 2; i <= a; i += 2)
        ans *= 2;
    return ans;
}

pair<int, string> solve(string st)
{
    int n = st.size();
    vector<vector<int>> dp(26, vector<int>(n + 1));
    vector<vector<char>> way(26, vector<char>(n + 1));
    for (int i = 0; i < 26; i++)
        dp[i][0] = 0;
    for (int i = 0; i < 26; i++)
        way[i][0] = '&';

    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < 26; j++) {
            if (st[i - 1] == '?') {
                dp[j][i] = -INF;
                for (int k = 0; k < 26; k++) {
                    if (k < j) {
                        if (dp[j][i] < dp[j][i - 1] - get_val(k)) {
                            dp[j][i] = dp[j][i - 1] - get_val(k);
                            way[j][i] = 'A' + k;
                        }
                    }
                    else{
                        if (dp[j][i] < dp[k][i - 1] + get_val(k)) {
                            dp[j][i] = dp[k][i - 1] + get_val(k);
                            way[j][i] = 'A' + k;
                        }
                    }
                }
            }
            else {
                int now = st[i - 1] - 'A';
                if (now < j) {
                    dp[j][i] = dp[j][i - 1] - get_val(now);
                    way[j][i] = 'A' + now;
                }
                else {
                    dp[j][i] = dp[now][i - 1] + get_val(now);
                    way[j][i] = 'A' + now;
                }
            }
        }
    }

    vector<char> ans;
    int x = 0, y = n;
    while (y > 0) {
        ans.push_back(way[x][y]);
        if (way[x][y] == '&')
            exit(1);
        y--;
        x = max(x, (int)(way[x][y] - 'A'));

    }

    reverse(ans.begin(), ans.end());
    string an = "";
    for (char c : ans) an += c;

    return { dp[0][n], an };
}

pair<int, string> glob_ans;
string st;

int get_value(string sss)
{
    int value = 0;
    int max_now = 0;
    for (int i = sss.size() - 1; i >= 0; i--) {
        int now = sss[i] - 'A';
        if (now < max_now)
            value -= get_val(now);
        else
            value += get_val(now);
        max_now = max(max_now, now);
    }
    return value;
}

void pereb(int v)
{
    if (v == st.size()) {
        int max_now = -1;
        int value = get_value(st);
        if (value > glob_ans.first) {
            string copy_str = "";
            for (char c : st) copy_str += c;
            glob_ans = {value, copy_str};
        }
    }
    else {
        if (st[v] == '?') {
            for (int i = 0; i < 26; i++) {
                st[v] = 'A' + i;
                pereb(v + 1);
            }
            st[v] = '?';
        }
        else
            pereb(v + 1);
    }
}

pair<int, string> solve2()
{
    glob_ans = {-INF, ""};
    pereb(0);
    return glob_ans;
}

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    srand(123);
    int t;
    cin >> t;
    while (t-- > 0) {
        cin >> st;
        auto ans = solve2();
        cout << ans.first << '\n' << ans.second << '\n';
    }
    /*int i = 0;
    while (true) {
        if (++i % 100 == 0)
            cout << i << endl;
        st = "";
        int sz = rand() % 10 + 10;
        for (int it = 0; it < sz; it++) {
            if (rand() % 10 == 0)
                st += '?';
            else
                st += ('A' + (rand() % 26));
        }
        st = "H??YMOGYXI?";
        string last_st = st;
        auto ans1 = solve(st);
        auto ans2 = solve2();
        if (ans1.first != ans2.first) {
            cout << last_st << '\n';
            cout << ans1.first << ' ' << ans1.second << '\n';
            cout << ans2.first << ' ' << ans2.second << '\n';
            cout << get_value(ans1.second) << ' ' << get_value(ans2.second) << '\n';
            exit(0);
        }
        exit(0);
    }*/
    return 0;
}
