#include <bits/stdc++.h>
using namespace std;

#define int long long
#define F first
#define S second
#define mp make_pair
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#ifdef MY
    #define endl '\n'
#endif // MY

typedef long long ll;
typedef double db;
typedef pair < int, int > pii;

const int A = 26;
const int inf = 2e18;
const int N = 3e5 + 5;
int num[A];
int lst[N][A];
pii par[N][A];
int dp[N][A];

void build() {
    num[0] = 1;
    num[1] = 5;
    for (int i = 2; i < A; i++) {
        num[i] = num[i - 2] * 10;
    }
}

int used[A];
int C = 0;

int cnt(string s) {
    C++;
    int n = sz(s);
    int ans = 0;
    for (int i = n - 1; i >= 0; i--) {
        int x = s[i] - 'A';
        used[x] = C;
        int fl = 1;
        for (int j = x + 1; j < A; j++) {
            if (used[j] == C) {
                fl = -1;
                break;
            }
        }
        ans += num[x] * fl;
    }
    return ans;
}

int sum(int p, int l, int r) {
    if (p < 0 || l > r) {
        return 0;
    }
    return lst[r][p] - lst[l - 1][p];
}

void rebuild(int i, int x, string& t) {
    if (i == 0) {
        return;
    }
    t[i] = 'A' + x;
    rebuild(par[i][x].F, par[i][x].S, t);
}

void solve() {
    C++;
    string s;
    cin >> s;
    s = "?" + s;
    string t = s;
    int n = sz(s);
    for (int i = n - 1; i >= 0; i--) {
        if (s[i] == '?') {
            continue;
        }
        int x = s[i] - 'A';
        used[x] = C;
        for (int j = x + 1; j < A; j++) {
            if (used[j] == C) {
                s[i] = '.';
                break;
            }
        }
    }
//    cout << s<< ' ' << t << endl;
    int prv = 0;
    for (int i = 0; i < A; i++) {
        dp[0][i] = num[i];
    }
    for (int i = 1; i < n; i++) {
        if (s[i] == '?') {
            fill(dp[i], dp[i] + A, -inf);
            for (int j = 0; j < A; j++) {
                for (int t = 0; t <= j; t++) {
                    int res = dp[prv][j] + num[t];
                    res += sum(A - 1, prv + 1, i - 1);
                    res -= sum(t - 1, prv + 1, i - 1);
                    if (dp[i][t] < res) {
                        dp[i][t] = res;
                        par[i][t] = {prv, j};
                    }
                }
            }
            prv = i;
        } else if (s[i] != '.') {
            int a = s[i] - 'A';
            for (int j = a; j < A; j++) {
                lst[i][j] += num[a];
            }
        }
        for (int j = 0; j < A; j++) {
            lst[i][j] += lst[i - 1][j];
        }
    }
    pii kek = {-inf, -inf};
    for (int i = 0; i < A; i++) {
        kek = max(kek, {dp[prv][i], i});
    }
    rebuild(prv, kek.S, t);
//    cout << t << endl;
    t.erase(t.begin());

    cout << cnt(t) << endl << t << endl;
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    build();
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}
