#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct Tree {
    int x, h;
};

ll makepair(int x, int y) {
    return (long long)x << 32 | y;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    Tree trees[n];
    unordered_map<int, int> x_to_h;
    for (int i = 0; i < n; ++i) {
        cin >> trees[i].x >> trees[i].h;
        x_to_h[trees[i].x] = trees[i].h;
    }
    unordered_map<ll, int> cache;
    while (q --> 0) {
        int l, r;
        cin >> l >> r;

        --l;
        --r;

        if (cache.find(makepair(l, r)) != cache.end()) {
            cout << cache[makepair(l, r)] << '\n';
            continue;
        }
        multiset<int> xs;
        for (int i = l; i <= r; ++i) {
            xs.insert(trees[i].x);
        }
        if (l == 0) {
            xs.insert(trees[0].x);
        }
        else {
            xs.insert(trees[l - 1].x);
        }
        if (r == n - 1) {
            xs.insert(trees[r].x);
        }
        else {
            xs.insert(trees[r + 1].x);
        }
        while (xs.size() > 2) {
            bool fl = false;
            auto cur = xs.begin();
            for (++cur; cur != xs.end(); ++cur) {
                if (++cur == xs.end()) {
                    break;
                }
                else {
                    --cur;
                }
                auto now = *cur;
                auto it2 = xs.upper_bound(now);
                auto it = xs.lower_bound(now);
                --it;
                int h = x_to_h[now];
                if (*it + h <= now || *it2 - h >= now) {
                    xs.erase(cur);
                    fl = true;
                    break;
                }
            }
            if (!fl) break;
        }
        cout << r - l + 3 - xs.size() << '\n';
        cache[makepair(l, r)] = r + l + 3 - xs.size();
    }
    return 0;
}