#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(o) o.begin(), o.end()


vector<ll> values;

const int ALPHA = 26;


ll eval_for_string(const string &s) {
    char max_char = 0;
    ll total = 0;
    for (char q : s) {
        if (q < max_char) {
            total -= values[q - 'A'];
        } else {
            total += values[q - 'A'];
            max_char = q;
        }
    }
    return total;
}


ll best_total = INT64_MIN;
string best_str;


ll rec(string &s, int index = 0) {
    if (index >= s.size()) {
        reverse(all(s));
        ll res = eval_for_string(s);
        reverse(all(s));
        if (best_total < res) {
            best_total = res;
            best_str = s;
        }
        return res;
    }
    if (s[index] == '?') {
        ll res = INT64_MIN;
        char c = 'A';
        for (char i = 'A'; i <= 'Z'; ++i) {
            s[index] = i;
            ll r = rec(s, index + 1);
            if (res < r) {
                res = r;
                c = i;
            }
        }
        s[index] = '?';
        return res;
    } else {
        return rec(s, index + 1);
    }
}


void solve() {
    values.resize(ALPHA);
    for (int i = 0; i < ALPHA; i++) {
        values[i] = (i % 2 == 0 ? 1 : 5) * pow(10, i / 2);
    }

    string s; cin >> s;

    rec(s);
    cout << best_total << '\n';
    cout << best_str << "\n";
}


int main() {
#if ELT
    freopen("../A.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        cout << " -- TEST --\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int q; cin >> q;
    while(q--) {
        solve();
    }
#endif
    return 0;
}
