#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(o) o.begin(), o.end()


struct Tree {
    int x, h;
};



void solve() {
    int n, q; cin >> n >> q;
    vector<Tree> trees(n + 2);
    for (int i = 0; i < n; ++i) {
        int x, h; cin >> x >> h;
        trees[i + 1] = {x, h};
        if (i == 0) {
            trees[0] = {x, h};
        } else if (i == n - 1) {
            trees[n + 1] = {x, h};
        }
    }

    for (int i = 0; i < q; ++i) {
        vector<bool> cut(n + 2, false);
        int l, r; cin >> l >> r;
        for (int j = 0; j <= r - l; ++j) {
            for (int k = l; k <= r; ++k) {
                if (cut[k]) continue;
                bool can_be_cut = true;
                for (int m = 0; m < k; ++m) {
                    if (!cut[m] && trees[m].x > trees[k].x - trees[k].h) {
                        can_be_cut = false;
                    }
                }
                if (can_be_cut) {
                    cut[k] = true;
                    continue;
                }
                can_be_cut = true;
                for (int m = k + 1; m < n + 2; ++m) {
                    if (!cut[m] && trees[m].x < trees[k].x + trees[k].h) {
                        can_be_cut = false;
                    }
                }
                if (can_be_cut) {
                    cut[k] = true;
                    continue;
                }
            }
        }
        cout << count(all(cut), true) << "\n";
    }
}


int main() {
#if ELT
    freopen("../C.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        cout << " -- TEST --\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int q; cin >> q;
    while(q--) {
        solve();
    }
#endif
    return 0;
}
