#include <iostream>
#include <queue>

using namespace std;



int main()
{
	int n, q;
	cin >> n >> q;
	int* x = new int[n], * h = new int[n];
	for (int i = 0; i < n; i++)
		cin >> x[i] >> h[i];
	int l, r, * nearest_left = new int[n], * nearest_right = new int[n];
	bool* used = new bool[n];
	for (int q1 = 0; q1 < q; q1++)
	{
		memset(used, 0, n * sizeof(bool));
		cin >> l >> r;
		l--, r--;
		for (int i = l; i <= r; i++)
		{
			nearest_left[i] = max(i - 1, 0);
			nearest_right[i] = min(i + 1, n - 1);
		}
		queue<int> q;
		for (int i = l; i <= r; i++)
		{
			if (i > 0 && x[i] - x[i - 1] >= h[i])
				q.push(i);
			else if (i + 1 < n && x[i + 1] - x[i] >= h[i])
				q.push(i);
			else
				continue;
			used[i] = 1;
		}
		int cnt = 0;
		while (!q.empty())
		{
			cnt++;
			int i = q.front();
			q.pop();
			int ri = nearest_right[i], li = nearest_left[i];
			if (ri <= r)
			{
				nearest_left[ri] = li;
				if (!used[ri] && x[ri] - x[li] >= h[ri])
				{
					q.push(ri);
					used[ri] = 1;
				}
			}
			if (li >= l)
			{
				nearest_right[li] = ri;
				if (!used[li] && x[ri] - x[li] >= h[li])
				{
					q.push(li);
					used[li] = 1;
				}
			}
		}
		cout << cnt << "\n";
	}
}
