#include <bits/stdc++.h>

using namespace std;

#define prev abcd

const int MAX_N = 2e5 + 42;
vector < int > in_gr[MAX_N];
vector < int > out_gr[MAX_N];
vector < int > gr[MAX_N];
bool used[MAX_N];
bool dp[3][MAX_N];
map < pair < int, int >, pair < int, int > > res;
int prev[3][MAX_N];

void dfs(int v, int p) {
    dp[0][v] = 1;
    used[v] = 1;
    for (auto u : gr[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v);
        int x1 = lower_bound(in_gr[v].begin(), in_gr[v].end(), u) - in_gr[v].begin();
        int x2 = lower_bound(out_gr[v].begin(), out_gr[v].end(), u) - out_gr[v].begin();
        if (x1 >= in_gr[v].size() || in_gr[v][x1] != u) {
            x1 = -1;
        }
        if (x2 >= out_gr[v].size() || out_gr[v][x2] != u) {
            x2 = -1;
        }
//        if (v == 0) {
//            cout << "!!! " << dp[0][v] << " " << dp[1][v] << " " << dp[2][v] << endl;
//        }
        if (x1 != -1 && x2 != -1) {
            bool c0 = 0;
            bool c1 = 0;
            bool c2 = 0;
            if (dp[0][v] && dp[0][u]) {
                dp[0][v] = 1;
                dp[1][v] = 0;
                dp[2][v] = 0;
                //cout << "!! " << v + 1 << " " << u + 1 << endl;
                res[{v, u}] = {u, v};
                //c0 = 1;
                continue;
            }
            if (dp[0][v] && dp[1][u]) {
                dp[0][v] = 0;
                dp[1][v] = 0;
                dp[2][v] = 1;
                res[{prev[1][u], u}] = {u, v};
                prev[2][v] = u;
                continue;
                //c2 = 1;
            }
            if (dp[0][v] && dp[2][u]) {
                //c1 = 1;
                dp[0][v] = 0;
                dp[1][v] = 1;
                dp[2][v] = 0;
                prev[1][v] = u;
                res[{v, u}] = {u, prev[2][u]};
                continue;
            }
            if (dp[1][v] && dp[0][u]) {
                //c1 = 1;
                dp[0][v] = 0;
                dp[1][v] = 1;
                dp[2][v] = 0;
                res[{v, u}] = {u, v};
                continue;
            }
            if (dp[2][v] && dp[0][u]) {
                //c2 = 1;
                dp[0][v] = 0;
                dp[1][v] = 0;
                dp[2][v] = 1;
                res[{v, u}] = {u, v};;
                continue;
            }
            dp[0][v] = 0;
            dp[1][v] = 0;
            dp[2][v] = 0;
            continue;
        }
        if (x2 == -1) {
            bool c0 = 0;
            bool c1 = 0;
            bool c2 = 0;
            if (dp[0][v] && dp[1][u]) {
                //c0 = 1;
                dp[0][v] = 1;
                dp[1][v] = 0;
                dp[2][v] = 0;
                res[{prev[1][u], u}] = {u, v};
                continue;
            }
            if (dp[0][u] && dp[2][v]) {
                //c0 = 1;
                dp[0][v] = 1;
                dp[1][v] = 0;
                dp[2][v] = 0;
                res[{u, v}] = {v, prev[2][v]};
                continue;
            }
            if (dp[0][v] && dp[0][u]) {
                //c1 = 1;
                dp[0][v] = 0;
                dp[1][v] = 1;
                dp[2][v] = 0;
                prev[1][v] = u;
                continue;
            }
            dp[0][v] = 0;
            dp[1][v] = 0;
            dp[2][v] = 0;
            continue;
        }
        bool c0 = 0;
        bool c1 = 0;
        bool c2 = 0;
        //cout << v << " " << u << endl;
        //cout << dp[0][v] << " " << dp[2][u] << endl;
        if (dp[0][v] && dp[2][u]) {
            //c0 = 1;
            dp[0][v] = 1;
            dp[1][v] = 0;
            dp[2][v] = 0;
            res[{v, u}] = {u, prev[2][u]};
            continue;
        }
        if (dp[0][u] && dp[1][v]) {
            dp[0][v] = 1;
            dp[1][v] = 0;
            dp[2][v] = 0;
            res[{prev[1][v], v}] = {v, u};
            continue;
        }
        if (dp[0][v] && dp[0][u]) {
            //c2 = 1
            dp[0][v] = 0;
            dp[1][v] = 0;
            dp[2][v] = 1;
            prev[2][v] = u;
            continue;
        }
        dp[0][v] = 0;
        dp[1][v] = 0;
        dp[2][v] = 0;
        continue;
    }
    //cout << v << " " << dp[0][v] << " " << dp[1][v] << " " << dp[2][v] << endl;
}

int main() {
    //freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    set < pair < int, int > > s;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        if (s.find({min(v, u), max(v, u)}) == s.end()) {
            gr[v].emplace_back(u);
            gr[u].emplace_back(v);
            s.insert({min(v, u), max(v, u)});
        }
        out_gr[v].emplace_back(u);
        in_gr[u].emplace_back(v);
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, i);
            if (dp[0][i] == 0) {
                cout << "No";
                return 0;
            }
        }
    }
    cout << "Yes\n";
    for (auto i : res) {
        cout << i.first.first + 1 << " " << i.first.second + 1 << " ";
        cout << i.second.first + 1 << " "<< i.second.second + 1 << endl;
    }
    return 0;
}
