#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>

#define all(a) a.begin(), a.end()

using namespace std;

#define pii pair<int, int>
#define mp make_pair
#define ft first
#define sd second

const int MAX_N = 500000;

vector<int> L(MAX_N, -1), R(MAX_N, MAX_N);


void solve() {
	int n, q;
	cin >> n >> q;
	vector<int> x(n), h(n);
	for (int i = 0; i < n; i++)
		cin >> x[i] >> h[i];

	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		vector<vector<int>> messing_falling_to_right(r - l), messing_falling_to_left(r - l);
		vector<int> cnt_right(r - l), cnt_left(r - l);
		vector<bool> used(r - l);
		vector<int> stack;
		for (int i = l; i < r; i++) {
			cnt_left[i - l] = n + 1;
			cnt_right[i - l] = n + 1;
			if (x[i] - h[i] >= x[max(0, l - 1)]) {
				cnt_left[i - l] = 0;
				for (int j = i - 1; j >= l && x[j] > x[i] - h[i]; j--) {
					cnt_left[i - l]++;
					messing_falling_to_left[j - l].push_back(i);
				}
				if (cnt_left[i - l] == 0) {
					stack.push_back(i);
					used[i - l] = true;
				}
			}
			if (x[i] + h[i] <= x[min(n - 1, r)]) {
				cnt_right[i - l] = 0;
				for (int j = i + 1; j < l && x[j] < x[i] - h[i]; j++) {
					cnt_right[i - l]++;
					messing_falling_to_right[j - l] .push_back(i);
				}
				if (!used[i - l] && cnt_right[i - l] == 0) {
					stack.push_back(i);
					used[i - l] = true;
				}
			}
		}
		int ans = 0;
		while (stack.size()) {
			int cur = stack.back();
			stack.pop_back();
			ans++;
			for (int u : messing_falling_to_left[cur - l]) {
				cnt_left[u - l]--;
				if (cnt_left[u - l] == 0 && !used[u - l]) {
					stack.push_back(u);
					used[u - l] = true;
				}
			}
			for (int u : messing_falling_to_right[cur - l]) {
				cnt_right[u - l]--;
				if (cnt_right[u - l] == 0 && !used[u - l]) {
					stack.push_back(u);
					used[u - l] = true;
				}
			}
		}
		cout << ans << '\n';
	}
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
    // cin >> t;
	while (t--)
		solve();
}