#include <bits/stdc++.h>

using namespace std;

bool can = true;

int sg(int x) {
    if (x > 0)
        return 1;
    if (x < 0)
        return -1;
    return 0;
}

void dfs(int v, int in, int par, vector<map<int, int>>& graph, vector<int>& bal, vector<pair<pair<int, int>, pair<int, int>>>& ans, vector<bool>& was) {
    was[v] = true;
    vector<pair<int, int>> st;
    for (auto[u, t] : graph[v]) {
        if (!can)
            return;
        if (u != par) {
            dfs(u, t, v, graph, bal, ans, was);
            int add = -bal[u] + t;
            if (add > 1 || add < -1) {
                can = false;
                return;
            }
            if (add == 0) {
                continue;
            }
            if (bal[v] < 0 && add > 0) {
                ans.push_back({*st.rbegin(), {v, u}});
                st.pop_back();
                bal[v] += add;
                continue;
            }
            if (bal[v] > 0 && add < 0) {
                ans.push_back({{u, v}, *st.rbegin()});
                st.pop_back();
                bal[v] += add;
                continue;
            }
            if (add < 0) {
                st.push_back({u, v});
                bal[v] += add;
                continue;
            }
            if (add > 0) {
                st.push_back({v, u});
                bal[v] += add;
                continue;
            }
        }
    }
    if (abs(bal[v]) > 1 || (par == -1 && bal[v] > 0)) {
        can = false;
        return;
    }
    if (par == -1) {
        return;
    }
    if (bal[v] > 0 && in >= 0) {
        ans.push_back({{par, v}, *st.rbegin()});
    }
    if (bal[v] < 0 && in <= 0) {
        ans.push_back({*st.rbegin(), {v, par}});
    }
    if (bal[v] == 0 && in == 0) {
        ans.push_back({{v, par}, {par, v}});
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<map<int, int>> graph(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        if (graph[v].find(u) != graph[v].end()) {
            graph[u][v] = 0;
            graph[v][u] = 0;
        } else {
            graph[u][v] = 1;
            graph[v][u] = -1;
        }
    }
    vector<bool> was(n, false);
    vector<int> bal(n, 0);
    vector<pair<pair<int, int>, pair<int, int>>> ans;
    for (int i = 0; i < n; i++) {
        if (!was[i]) {
            dfs(i, 0, -1, graph, bal, ans, was);
        }
    }
    if (can) {
        cout << "Yes\n";
        for (pair<pair<int, int>, pair<int, int>> p : ans) {
            cout << p.first.first + 1 << " " << p.first.second + 1 << " " << p.second.first + 1 << " " << p.second.second + 1 << "\n";
        }
    } else {
        cout << "No\n";
    }
    return 0;
}
