#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

vector<ll> mit, mat;

void dfs(ll v, ll p, vector<vector<pair<ll, ll>>>& g)
{
	for (auto u : g[v])
	{
		if (u.first != p)
		{
			mit[u.first] = min(mit[v], u.second);
			mat[u.first] = max(mat[v], u.second);
			dfs(u.first, v, g);
		}
	}
}

signed main()
{
	ll n, m; cin >> n >> m;
	vector<vector<pair<ll, ll>>> g(n);
	mit.assign(n, 1e18);
	mat.assign(n, 0);

	for (int i = 0; i < m; ++i)
	{
		ll u, v, t; cin >> u >> v >> t;
		--u; --v;

		g[u].push_back({ v, t });
		g[v].push_back({ u, t });
	}
	dfs(0, -1, g);
	for (int i = 1; i < n; ++i)
		cout << mit[i] + mat[i] << '\n';


	return 0;
}