#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define rrep(i, n) for (int i = n - 1; i >= 0; i--)
#define rep(i, n) for (int i = 0; i < n; i++)
#define re return
#define pb emplace_back

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;

bool del(vvi &gr, int u, int v)
{
    if (sz(gr[u]) > 0 && gr[u][0] == v) {
        gr[u].erase(gr[u].begin());
        re 1;
    }
    if (sz(gr[u]) > 1 && gr[u][1] == v) {
        gr[u].erase(++gr[u].begin());
        re 1;
    }
    re 0;
}

void solve()
{
    int n, m;
    cin >> n >> m;
    vvi gr(n);
    vvi inv_gr(n);
    rep(i, m)
    {
        int u, v;
        cin >> u >> v;
        u--; v--;
        gr[u].pb(v);
        inv_gr[v].pb(u);
    }
    vi ans;
    while (1)
    {
        int ok = 0;
        rep(i, n)
        {
            for (int j : gr[i])
            {
                for (int k : gr[j])
                {
                    if (sz(gr[k]) == 0) {
                        del(gr, i, j);
                        del(inv_gr, j, i);
                        del(gr, j, k);
                        del(inv_gr, k, j);
                        ans.pb(i); ans.pb(j); ans.pb(j); ans.pb(k);
                        ok = 1;
                        break;
                    }
                }
            }
        }
        if (ok == 1) continue;
        rep(i, n)
        {
            for (int j : gr[i])
            {
                for (int k : gr[j])
                {
                    if (k == i) {
                        if (!del(gr, i, j)) assert(false);
                        if (!del(gr, j, i)) assert(false);
                        if (!del(inv_gr, i, j)) assert(false);
                        if (!del(inv_gr, j, i)) assert(false);
                        ok = 1;
                        ans.pb(i); ans.pb(j); ans.pb(j); ans.pb(i);
                        break;
                    }
                }
                if (ok == 1) break;
            }
            if (ok == 1) break;
        }
        if (ok == 0) break;
    }
    if (sz(ans) < 2 * m) {
        cout << "No";
    }
     else {
        cout << "Yes\n";
        rep(i, sz(ans) / 4)
        {
            cout << ans[i * 4] + 1 << ' ' << ans[i * 4 + 1] + 1 << ' ' << ans[i * 4 + 2] + 1 << ' ' << ans[i * 4 + 3] + 1 << endl;
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
