#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define rrep(i, n) for (int i = n - 1; i >= 0; i--)
#define rep(i, n) for (int i = 0; i < n; i++)
#define re return
#define pb emplace_back

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;

int get(vi &x, vi &h)
{
    queue<int> can;
    vi nx(sz(x)), pr(sz(x));
    nx[0] = 1;
    pr[sz(x) - 1] = sz(x) - 2;
    for (int i = 1; i < sz(x) - 1; i++)
    {
        nx[i] = i + 1;
        pr[i] = i - 1;
        if (x[i] + h[i] <= x[i + 1] || x[i] - h[i] >= x[i - 1]) {
            can.push(i);
        }
    }
    int ret = 0;
    while (sz(can) > 0)
    {
        ret++;
        int i = can.front();
        can.pop();
        int next = nx[i], prev = pr[i];
        nx[prev] = next;
        pr[next] = prev;
        if (prev != 0) {
            if (x[prev] + h[prev] <= x[next]) {
                can.push(prev);
            }
        }
        if (next != sz(x) - 1) {
            if (x[next] - h[next] >= x[prev]) {
                can.push(next);
            }
        }
    }
    re ret;
}

void solve()
{
    int n, q;
    cin >> n >> q;
    vi x(n), h(n);
    rep(i, n)
    {
        cin >> x[i] >> h[i];
    }
    rep(i, q)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;
        vi nx, nh;
        nh.pb(-1);
        if (l == 0) nx.pb(x[0]);
        else nx.pb(x[l - 1]);
        for (int j = l; j <= r; j++)
        {
            nx.pb(x[j]);
            nh.pb(h[j]);
        }
        nh.pb(-1);
        if (r == n - 1) nx.pb(x[n - 1]);
        else nx.pb(x[r + 1]);
        cout << get(nx, nh) << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
