#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define size(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

int n, q;
vector<int> x, h;

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> n >> q;
    x.resize(n), h.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        l[i] = n + 1;
        r[i] = n + 1;
        if (x[i] + h[i] <= x[n - 1]) {
            r[i] = 0;
            for (int j = i + 1; j < n; ++j) {
                if (x[i] + h[i] <= x[j]) break;
                r[i]++;
            }
        }
        if (x[i] - h[i] >= x[0]) {
            l[i] = 0;
            for (int j = i - 1; j >= 0; --j) {
                if (x[j] + h[i] <= x[i]) break;
                l[i]++;
            }
        }
    }

    vector<int> us(n, 0);
    vector<int> le(n), ri(n);
    while (q--) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        int ans = 0;
        queue<int> qu;
        for (int i = 0; i < n; ++i) {
            le[i] = l[i];
            ri[i] = r[i];
            us[i] = 0;
        }
        for (int i = a; i <= b; ++i) {
            if (l[i] == 0 || r[i] == 0) qu.push(i);
        }

        while (!qu.empty()) {
            int v = qu.front();
            qu.pop();
            if (us[v] == 1) continue;
            us[v] = 1;
            ans++;

            for (int i = a; i <= b; ++i) {
                if (us[i] != 0) continue;
                if (x[i] < x[v] && x[i] + h[i] > x[v]) {
                    ri[i]--;
                    if (ri[i] == 0) qu.push(i);
                }
                if (x[v] < x[i] && x[v] + h[i] > x[i]) {
                    le[i]--;
                    if (le[i] == 0) qu.push(i);
                }
            }
        }
        cout << ans << "\n";
    }

}