#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

map < char, long long > kek;

const long long inf = 1e18;

long long calc(string& s) {
	int n = s.size();
	char c = 'A';
	long long res = 0;
	for (int i = n - 1; i >= 0; i--) {
		if (s[i] >= c) res += kek[s[i]];
		else res -= kek[s[i]];
		c = max(c, s[i]);
	}
	return res;
}

pair < string, long long > uwu(string &s) {
	int n = s.size();
	long long ans = -inf;
	string res;
	for (char t1 = 'A'; t1 <= 'Z'; t1++) {
		for (char t2 = 'A'; t2 <= 'Z'; t2++) {
//			for (char t3 = 'A'; t3 <= 'Z'; t3++) {
				string news = s;
				int cnt = 0;
				for (int i = 0; i < n; i++) {
					if (s[i] != '?') continue;
					if (cnt == 0) news[i] = t1;
					else if (cnt == 1) news[i] = t2;
//					else news[i] = t3;
					cnt++;
				}

				long long t = calc(news);
				if (t >= ans) {
					ans = t;
					res = news;
				}
			}
//		}
	}
	cout << ans << "\n" << res << "\n";
	return { res, ans };
}

pair < string, long long > solve(string &s) {
	int n = s.size();
	string res;
	long long ans = 0;

	for (int i = 0; i < n; i++) {
		if (s[i] == '?') {
			long long nans = -inf;
			int id = 0;
			for (int j = 0; j < 26; j++) {
				long long t = kek['A' + j];
				for (int k = 0; k < i; k++) {
					if (res[k] < 'A' + j) t -= kek[res[k]];
					else t += kek[res[k]];
				}
				if (t >= nans) {
					nans = t;
					id = j;
				}
			}
			res.push_back('A' + id);
			ans = nans;
		}
		else {
			ans = kek[s[i]];
			res.push_back(s[i]);
			for (int j = 0; j < i; j++) {
				if (res[j] < res[i]) ans -= kek[res[j]];
				else ans += kek[res[j]];
			}
		}
	}

	cout << ans << "\n" << res << "\n";
	return { res, ans };
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	kek['A'] = 1;
	for (int i = 1; i < 26; i++) {
		kek['A' + i] = kek['A' + i - 1];
		if (i % 2 == 1) kek['A' + i] *= 5;
		else kek['A' + i] *= 2;
	}

	int q;
	cin >> q;
//	q = 1e6;

	string h;
	for (int i = 0; i < q; i++) {
		cin >> h;
/*		int len = rand() % 10 + 1;
		int qcnt = 0;
		h = "";
		for (int j = 0; j < len; j++) {
			if (rand() % 3 == 0 && qcnt < 2) {
				h += '?';
				qcnt++;
			}
			else
				h += ('A' + rand() % 26);
		}
		cout << h << "\nANS:\n";
		auto t1 = uwu(h);
		auto t2 = solve(h); 
		cout << "\n";
		if (t1 != t2)
			return 0; */
		auto t1 = solve(h);
	}
}