#include <iostream>
#include <vector>
#include <climits>
//#include <algorithm>

using namespace std;

#define FOR(i, a, b) for(__typeof(b) i = (a); i < (b); ++i)
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

#define int long long

typedef long long ll;
typedef long double ld;
typedef int32_t i32;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int p[] = {
        1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000,
        500000, 1000000, 5000000, 10000000, 50000000, 100000000, 500000000, 1000000000,
        5000000000ll, 10000000000ll, 50000000000ll, 100000000000ll, 500000000000ll,
        1000000000000ll, 5000000000000ll};

void solve(){
    string s; cin >> s;
    int n = sz(s);
    vector<int> a(n);
    FOR(i, 0, n){
        if(s[i] == '?'){
            a[i] = -1;
        }else{
            a[i] = s[i] - 'A';
        }
    }
    vector<vi> ans(n+1, vi(26, 0)), par(n+1, vi(26));
    for(int i = n-1; i >= 0; --i){
        if(a[i] != -1){
            int x = -2e18, val = -1;
            FOR(j, 0, a[i]+1){
                if(ans[i+1][j] > x){
                    x = ans[i+1][j];
                    val = j;
                }
                ans[i][j] = -2e18;
            }
            ans[i][a[i]] = x + p[a[i]];
            par[i][a[i]] = val;
            FOR(j, a[i]+1, 26){
                ans[i][j] = ans[i+1][j] - p[a[i]];
                par[i][j] = j;
            }
        }else{
            int x = -2e18, val = -1;
            FOR(j, 0, 26){
                if(ans[i+1][j] > x){
                    x = ans[i+1][j];
                    val = j;
                }
                ans[i][j] = x + p[j];
                par[i][j] = j;
            }
        }
    }
    int x = -2e18, val = -1;
    FOR(i, 0, 26){
        if(ans[0][i] > x){
            x = ans[0][i];
            val = i;
        }
    }
    cout << x << '\n';
    if(a[0] == -1){
        cout << 'Z';
    }else{
        cout << s[0];
    }
    FOR(i, 1, n){
        if(a[i] == -1){
            cout << char(val + 'A');
        }else{
            cout << s[i];
        }
        val = par[i-1][val];
    }
    cout << '\n';
}

i32 main(){
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    solve();
    int t; cin >> t; while(t--) solve();
}