#include <iostream>
#include <vector>
//#include <algorithm>

using namespace std;

#define FOR(i, a, b) for(__typeof(b) i = (a); i < (b); ++i)
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

//#define int long long

typedef long long ll;
typedef long double ld;
typedef int32_t i32;
typedef pair<int, int> pii;
typedef vector<int> vi;

int l, r, n;
vector<vi> g_l, g_r;
vi vis;

bool dfs(int i){
    int res_l = sz(g_l[i]), res_r = sz(g_r[i]);
    vis[i] = 1;
    if(i == 0){
        res_l = INT32_MAX;
    }
    if(i == n-1){
        res_r = INT32_MAX;
    }
    for(int j : g_l[i]){
        if(j < l || j >= r){
            break;
        }
        if(vis[j] == 0){
            bool res = dfs(j);
            if(!res){
                break;
            }
            res_l -= 1;
        }else if(vis[j] == 2){
            res_l -= 1;
        }else{
            break;
        }
    }
    for(int j : g_r[i]){
        if(j < l || j >= r){
            break;
        }
        if(vis[j] == 0){
            bool res = dfs(j);
            if(!res){
                break;
            }
            res_r -= 1;
        }else if(vis[j] == 2){
            res_r -= 1;
        }else{
            break;
        }
    }
    if(res_l == 0 || res_r == 0){
        vis[i] = 2;
        return true;
    }
    return false;
}

void solve(){
    int q; cin >> n >> q;
    g_l.resize(n);
    g_r.resize(n);
    vector<pii> a(n);
    for(auto &[x, h] : a){
        cin >> x >> h;
    }
    FOR(i, 0, n){
        auto [xi, hi] = a[i];
        FOR(j, 0, i){
            auto [xj, hj] = a[j];
            if(xi < xj + hj){
                g_r[j].push_back(i);
            }
            if(xi - hi < xj){
                g_l[i].push_back(j);
            }
        }
    }
    FOR(qq, 0, q){
        cin >> l >> r;
        l--;
        vis.assign(n, 0);
        FOR(i, l, r){
            if(vis[i]) continue;
            dfs(i);
        }
        int res = 0;
        FOR(i, l, r){
            if(vis[i] == 2){
                res++;
            }
        }
        cout << res << '\n';
    }
}

i32 main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
//    int t; cin >> t; while(t--) solve();
}