#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pii pair <int, int>
#define vi vector <int>
#define pb push_back
#define all(c) (c).begin(), (c).end()
#define x first
#define y second
#define vpi vector <pii>

using namespace std;

const int N = 3e5 + 7, inf = 2e9 + 7, K = 26;

struct edge{
    int to, w, id;
};

vector <edge> v[N];
int d[N];

int used[N];
int n, m;

vector <array<int, 3> > e;

clock_t START;

void dfs(int x, int mn, int mx) {
    if((ld) (clock() - START) / CLOCKS_PER_SEC > 2.9) {
        for (int i = 1; i < n; i++)
            cout << d[i] << ' ';
        exit(0);
    }
    d[x] = min(d[x], mn + mx);
    for (auto u : v[x]) {
        if(!used[u.id]) {
            used[u.id] = 1;
            dfs(u.to, min(mn, u.w), max(mx, u.w));
            used[u.id] = 0;
        }
    }
}

void solve() {
    cin >> n >> m;
    fill(d, d + n, inf);
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--, b--;
        e.pb({w, a, b});
    }

    for (int mask = 0; mask < (1 << m); mask++) {
        for (int i = 0; i < n; i++)
            v[i].clear();
        for (int i = 0; i < m; i++) {
            used[i] = 0;
            if(mask & (1 << i)) {
                v[e[i][1]].pb({e[i][2], e[i][0], i});
                v[e[i][2]].pb({e[i][1], e[i][0], i});
            }
        }
        dfs(0, inf, -inf);
    }

    for (int i = 1; i < n; i++)
        cout << d[i] << ' ';

}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
