#include <iostream>

using namespace std;

long long n, q, trees[500100][2], can_be_choped[500100], left_border, right_border, l, r, count;

long long can_chop(long long tree, long long l, long long r, long long prev)
{
    long long can_chop_right = 0, can_chop_left = 0, pointer;

    //cout << tree << ' ' << l << ' ' << ' ' << r << can_be_choped[tree] << endl;

    if (can_be_choped[tree] == 0)
        return 0;
    else if (can_be_choped[tree] == 1)
        return 1;
    else if (tree < l or tree > r)
        return 0;
    else
    {
        if (trees[tree][0] - trees[tree][1] >= left_border)
        {
            can_chop_left = 1;
            pointer = tree-1;
            while (true)
            {
                if (pointer < 0)
                    break;
                if (trees[pointer][0] <= trees[tree][0] - trees[tree][1])
                    break;
                if (pointer == prev and can_be_choped[prev] == -1)
                {
                    return 0;
                    break;
                }
                if (!can_chop(pointer, l, r, tree))
                {
                    can_chop_left = 0;
                    break;
                }

                pointer --;
            }
        }

        if (trees[tree][0] + trees[tree][1] <= right_border)
        {
            can_chop_right = 1;
            pointer = tree+1;
            while (true)
            {
                if (pointer >= n)
                    break;
                if (trees[pointer][0] >= trees[tree][0] + trees[tree][1])
                    break;
                if (pointer == prev and can_be_choped[prev] == -1)
                {
                    return 0;
                    break;
                }
                if (can_chop(pointer, l, r, tree) == 0) {
                    can_chop_right = 0;
                    break;
                }

                pointer ++;
            }
        }


        //cout << tree << ' ' << can_chop_left << ' ' << can_chop_right<< endl;

        if (can_chop_right or can_chop_left)
            can_be_choped[tree] = 1;
        else
            can_be_choped[tree] = 0;

        return can_be_choped[tree];

    }

}

int main() {
    cin >> n >> q;

    for (int i = 0; i < n; i ++)
    {
        cin >> trees[i][0] >> trees[i][1];
    }

    left_border = trees[0][0];
    right_border = trees[n-1][0];

    for (int task = 0; task < q; task ++)
    {
        cin >> l >> r;

        l --;
        r --;

        for (int i = 0; i < n; i ++)
            can_be_choped[i] = -1;
        count = 0;

        for (int i = l; i <= r; i ++)
            count += can_chop(i, l, r, -100);

        cout << count << endl;

        //for (int i = 0; i < n; i ++)
        //    cout << can_be_choped[i] << ' ';
        //cout << can_chop(3, l, r, -100) << endl;
    }

    return 0;
}
