#pragma comment(linker, "/STACK:10000000000")
#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

//const int MAX_MEM = 1e8;
//int mpos = 0;
//char mem[MAX_MEM];
//inline void * operator new (size_t n) {
//    assert((mpos += n) <= MAX_MEM);
//    return (void *) (mem + mpos - n);
//}
//inline void operator delete (void *) noexcept {}

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << "\n";
#define sqr(x) (x) * (x)

template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(386493230);

const int maxn = 5e5 + 10;
const int inf = 2e9;
int n, m;
vpi g[maxn];
int ans[maxn];
int p[maxn];

int get_boss(int v) {
    if (p[v] == v) return v;
    return p[v] = get_boss(p[v]);
}

void merge(int u, int v) {
    u = get_boss(u), v = get_boss(v);
    if (u == v) return;
    p[v] = u;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
//    freopen("input.txt", "r", stdin);
    cin >> n >> m;
    vc<pair<int, pi>> e;
    for (int i = 0; i < m; i++) {
        int u, v, t;
        cin >> u >> v >> t;
        e.push_back({t, {u, v}});
    }
    for (int i = 1; i <= n; i++) {
        p[i] = i;
        ans[i] = inf;
    }
    sort(all(e));
    for (auto [cost, tmp] : e) {
        auto [u, v] = tmp;
        merge(u, v);
        if (get_boss(1) == get_boss(u)) {
            amin(ans[u], cost);
        }
        if (get_boss(1) == get_boss(v)) {
            amin(ans[v], cost);
        }
    }
//    for (int i = 1; i <= n; i++) {
//        debug(i << ' ' << get_boss(i));
//    }
    for (int i = 2; i <= n; i++) {
        assert(ans[i] != inf);
        cout << ans[i] << '\n';
    }

    return 0;
}