#pragma comment(linker, "/STACK:10000000000")
#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

const int MAX_MEM = 1e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new (size_t n) {
    assert((mpos += n) <= MAX_MEM);
    return (void *) (mem + mpos - n);
}
inline void operator delete (void *) noexcept {}

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << "\n";
#define sqr(x) (x) * (x)

template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(386493230);

const int maxn = 30;
const int inf = 2e9;
int n, m;
int ans[maxn];
int used[maxn];
vc<pair<pi, int>> g[maxn];

vc<pair<int, pi>> e;

void dfs(int v, int mn = inf, int mx = -inf) {
    amin(ans[v], mn + mx);
    for (auto &[tmp, cost] : g[v]) {
        auto [u, id] = tmp;
        if (used[id]) continue;
        used[id] = 1;
        dfs(u, min(mn, cost), max(mx, cost));
        used[id] = 0;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
//    freopen("input.txt", "r", stdin);
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v, t;
        cin >> u >> v >> t;
        g[u].push_back({{v, i}, t});
        g[v].push_back({{u, i}, t});
        e.push_back({t, {u, v}});
    }
    for (int i = 1; i <= n; i++) {
        ans[i] = inf;
    }
    dfs(1);
    for (int i = 2; i <= n; i++) {
        cout << ans[i] << "\n";
    }

    return 0;
}