#include <bits/stdc++.h>

#define endl "\n"
using namespace std;

#define double long double
#define int long long

#ifdef int
#define IMIN INT64_MIN
#define IMAX INT64_MAX
#endif

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

struct dp_t {
    int sum;
    char ch;
    int prv;
};

void solve() {
    int pr[26];
    {
        int v = 1;
        for (int i = 0; i < 26; i++) {
            pr[i] = v;
            if (i & 1) {
                v *= 2;
            } else {
                v *= 5;
            }
        }
    }

    string s;
    cin >> s;
    int n = s.length();
    dp_t dp[n][26];
    if (s[n - 1] != '?') {
        for (int i = 0; i < 26; i++) {
            dp[n - 1][i].sum = IMIN;
        }
        dp[n - 1][s[n - 1] - 'A'].sum = pr[s[n - 1] - 'A'];
        dp[n - 1][s[n - 1] - 'A'].prv = -1;
        dp[n - 1][s[n - 1] - 'A'].ch = s[n - 1];
    } else {
        for (int i = 0; i < 26; i++) {
            dp[n - 1][i].sum = pr[i];
            dp[n - 1][i].prv = -1;
            dp[n - 1][i].ch = 'A' + i;
        }
    }

    for (int i = n - 2; i >= 0; i--) {
        for (int j = 0; j < 26; j++) {
            dp[i][j].sum = IMIN;
        }
        if (s[i] == '?') {
            for (int c = 0; c < 26; c++) {
                for (int j = 0; j < 26; j++) {
                    if (dp[i + 1][j].sum == IMIN) {
                        continue;
                    }
                    int nsum = dp[i + 1][j].sum + (j > c ? -pr[c] : pr[c]);
                    int cj = max(c, j);
                    if (dp[i][cj].sum < nsum) {
                        dp[i][cj].sum = nsum;
                        dp[i][cj].ch = c + 'A';
                        dp[i][cj].prv = j;
                    }
                }
            }
        } else {
            int c = s[i] - 'A';
            for (int j = 0; j < 26; j++) {
                if (dp[i + 1][j].sum == IMIN) {
                    continue;
                }
                int nsum = dp[i + 1][j].sum + (j > c ? -pr[c] : pr[c]);
                int cj = max(c, j);
                if (dp[i][cj].sum < nsum) {
                    dp[i][cj].sum = nsum;
                    dp[i][cj].ch = c + 'A';
                    dp[i][cj].prv = j;
                }
            }
        }
    }
    int resj = 0;
    for (int i = 1; i < 26; i++) {
        if (dp[0][i].sum > dp[0][resj].sum) {
            resj = i;
        }
    }

    int j = resj;
    for (int i = 0; i < n; i++) {
        s[i] = dp[i][j].ch;
        j = dp[i][j].prv;
    }

    cout << dp[0][resj].sum << endl << s << endl;
}

#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin.open("in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef MULTITEST
    int32_t _t;
    cin >> _t;
    while (_t--)
#endif
        solve();
    return 0;
}
