#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <cmath>
#include <string>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define per(i, n) for (int i = n - 1; i >= 0; i--)
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
ll conv[300];

ll convert(char c) {
	return conv[c];
}
const ll infll = 1e18;

ll dp[300300][26];
int pr[300300][26];
int chose[300300][26];

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	conv['A'] = 1;
	rep(i, 25) {
		if (i % 2 == 0) {
			conv[i + 'A' + 1] = 5 * conv[i + 'A'];
		}
		else {
			conv[i + 'A' + 1] = 2 * conv[i + 'A'];
		}
	}
	int q;
	cin >> q;
	for (; q; q--) {
		string s;
		cin >> s;
		int n = sz(s);
		rep(i, n + 1) {
			rep(c, 26) {
				dp[i][c] = -infll;
			}
		}
		dp[n][0] = 0;
		per(i, n) {
			if (s[i] == '?') {
				rep(c1, 26) {
					rep(c2, 26) {
						ll add;
						if (c2 > c1) {
							add = -convert(c1 + 'A');
						}
						else {
							add = convert(c1 + 'A');
						}
						if (dp[i + 1][c2] + add > dp[i][max(c1, c2)]) {
							dp[i][max(c1, c2)] = dp[i + 1][c2] + add;
							pr[i][max(c1, c2)] = c2;
							chose[i][max(c1, c2)] = c1;
						}
					}
				}
			}
			else {
				rep(c, 26) {
					ll add;
					if (c > s[i] - 'A') {
						add = -convert(s[i]);
					}
					else {
						add = convert(s[i]);
					}
					if (dp[i][max(s[i] - 'A', c)] < dp[i + 1][c] + add) {
						dp[i][max(s[i] - 'A', c)] = max(
							dp[i][max(s[i] - 'A', c)], dp[i + 1][c] + add);
						pr[i][max(s[i] - 'A', c)] = c;
						chose[i][max(s[i] - 'A', c)] = s[i] -'A';
					}
				}
			}
		}
		ll best = -infll;
		int fn_c = -1;
		rep(c, 26) {
			if (dp[0][c] > best) {
				best = dp[0][c];
				fn_c = c;
			}
		}
		int i = 0;
		cout << best << "\n";
		while (i < n) {
			cout << (char)('A' + chose[i][fn_c]);
			fn_c = pr[i][fn_c];
			i++;
		}
		cout << "\n";
	}

	return 0;
}