#include <bits/stdc++.h>
using namespace std;

int const BLOCK = 400;

void encode() {
    string s;
    cin >> s;
    vector<int> colsum(BLOCK), rowsum(BLOCK);
    for (int i = 0; i < s.size(); i++) {
        rowsum[i / BLOCK] ^= s[i] - '0'; 
        colsum[i % BLOCK] ^= s[i] - '0';
    }
    for (int i = 0; i < BLOCK; i++) {
        s += (char) ('0' + rowsum[i]);
        s += (char) ('0' + colsum[i]);
    }
    cout << s;
    return;
}

void decode() {
    string s;
    cin >> s;
    int real_len = s.size() - 2 * BLOCK;
    int parity = 0;
    for (int i = 0; i < s.size(); i++) {
        parity ^= s[i] - '0';
    }
    if (parity == 0) {
        cout << s.substr(0, real_len) << endl;
        return;
    }
    vector<int> colsum(BLOCK), rowsum(BLOCK);
    for (int i = 0; i < real_len; i++) {
        rowsum[i / BLOCK] ^= s[i] - '0'; 
        colsum[i % BLOCK] ^= s[i] - '0';
    }
    int row_id = -1, col_id = -1;
    for (int i = 0; i < BLOCK; i++) {
        if (rowsum[i] != s[real_len + 2 * i] - '0') {
            row_id = i;
        }
        if (colsum[i] != s[real_len + 2 * i + 1] - '0') {
            col_id = i;
        }   
    }
    if (row_id != -1 && col_id != -1) {
        s[row_id * BLOCK + col_id] ^= 1;
    }
    cout << s.substr(0, real_len) << endl;
}

int main() {
    int type = 0;
    cin >> type;

    if (type == 1) {
        encode();
    } else {    
        decode();
    }
}
