#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
using namespace std;
using ll = long long;

int ask(int x) {
	cout << x << endl;
	int ans;
	cin >> ans;
	return ans;
}

void solve1() {
	int n;
	cin >> n;
	int left = 1, right = n + 1;
	while (left + 1 < right) {
		int x = (left + right) / 2;
		int ans = ask(x);
		if (ans == 1) left = x + 1;
		else if (ans == -1) right = x;
		else return;
	}
	ask(left);
}

void solve2() {
	int n, q;
	cin >> n >> q;
	int left = 1, right = n + 1;
	while (q--) {
		int x = (left + right) / 2;
		int ans;
		cin >> ans;
		if (ans == 1) left = x + 1;
		else if (ans == -1) right = x;
		else {
			cout << x << endl;
			return;
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int t;
	cin >> t;
	if (t == 1) solve1();
	else solve2();
	return 0;
}