#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <fstream>

using namespace std;

#define x first
#define y second
#define int long long
#define ll long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
//#define endl '\n'

string build(string s) {
	string t = s;
	int tmp = 0;
	for (int i{ 0 }; i <= 16; ++i) {
		tmp = 0;
		for (int j{}; j < s.length(); ++j) {
			if (s[j] == '0') continue;
			if ((j + 1) & (1ll << i)) tmp ^= 1;
		}
		if (tmp) t += "1";
		else t += "0";
	}
	tmp = 0;
	for (int i{}; i < s.length(); ++i) {
		if (s[i] == '0') continue;
		tmp ^= 1;
	}
	if (tmp) t += "1";
	else t += "0";
	return t;
}

void solve() {
	string s;
	cin >> s;
	cout << build(s) << endl;
}

void solve2() {
	string t{};
	cin >> t;
	string s{};
	for (int i{}; i < t.length() - 18; ++i) {
		s += t[i];
	}
	string ss = build(s);
	if (ss[ss.length() - 1] == t[t.length() - 1]) {
		cout << s << endl;
		return;
	}
	int n = s.length();
	int ind = 0;
	int temp;
	for (int i{ 0 }; i <= 16; ++i) {
		if (t[n + i - 1] != ss[n + i - 1]) ind ^= (1ll << i);
	}
	if (ind == 0) cout << s << endl;
	else {
		ind--;
		if (s[ind] == '0') s[ind] = '1';
		else s[ind] = '0';
		cout << s << endl;
	}

}


int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	
	int t{};
	cin >> t;
	//t = 1;
	if (t == 1) {
		solve();
	}
	else {
		solve2();
	}
	//for (int i{}; i < t; ++i) solve();
	return 0;
}