#include <bits/stdc++.h>

#pragma GCC optimize("O2")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;

template<typename T> void uin(T &a, T b) { if (b < a) { a = b; } }
const int inf = 1000'000'000;
#define forn(i, n) for (int i = 0; i < (n); i++)
#define all(v) v.begin(), v.end()
mt19937 rnd(time(nullptr));

vector<int> operator +(const vector<int> &a, const vector<int> &b) {
    vector<int> c(max(a.size(), b.size()) + 1);
    for (int i = 0, carry = 0; i < (int)c.size() || carry; i++) {
        c[i] = carry + (i < a.size() ? a[i] : 0) + (i < b.size() ? b[i] : 0);
        carry = 0;
        if (c[i] > 9) {
            carry = 1;
            c[i] -= 10;
        }
    }
    while(c.size() > 1 && c.back() == 0)
        c.pop_back();
    return c;
}
vector<int> operator -(const vector<int> &a, const vector<int> &b) {
    vector<int> c(a.size());
    for (int i = 0, carry = 0; i < c.size(); i++) {
        c[i] = a[i] - (i < b.size() ? b[i] : 0) - carry;
        carry = 0;
        if (c[i] < 0) {
            c[i] += 10;
            carry = 1;
        }
    }
    while(c.size() > 1 && c.back() == 0)
        c.pop_back();
    return c;
}
bool scan(vector<int> &a) {
    string s;
    cin >> s;
    reverse(all(s));
    bool ok = true;
    if (s.back() == '-') {
        ok = false;
        s.pop_back();
    }
    forn(i, s.size())
        a.push_back(s[i] - '0');
    return ok;
}
bool operator <(const vector<int> &a, const vector<int> &b) {
    if (a.size() != b.size())
        return a.size() < b.size();
    for (int i = (int)a.size() - 1; i >= 0; i--)
        if (a[i] != b[i])
            return a[i] < b[i];
    return false;
}
void print(vector<int> &a) {
    for (auto c = a.rbegin(); c != a.rend(); c++)
        cout << *c;
    cout << endl;
}
signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    vector<int> a, b;
    bool A = scan(a);
    bool B = scan(b);
    if (!(A ^ B)) {
        auto c = a + b;
        if (!A)
            cout << '-';
        print(c);
    } else {
        bool ok = A;
        if (a < b) {
            swap(a, b);
            ok = !ok;
        }
        auto c = a - b;
        if (!ok)
            cout << '-';
        print(c);
    }
    return 0;
}
