#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#pragma GCC target('sse,sse2,sse3,ssse3,sse4,avx,avx2,popcnt,tune="native"')
// #define int long long


int mod = 1e5 + 19;

ll mul(ll a, ll b) {
    return (a * b) % mod;
}

int sm(int a, int b) {
    if (a + b < mod) return a + b;
    return a + b - mod;
}

int dif(int a, int b) {
    if (a >= b) return a - b;
    return a + mod - b;
}

int pw(int a, int k) {
    if (k == 0) return 1;
    if (k % 2) return mul(pw(a, k - 1), a);
    return pw(mul(a, a), k / 2);
}

int hsh(string & s) {
    int key = 0;
    for (int i = 0; i < (int)s.size(); i++) {
        if (s[i] == '1') {
            key = sm(key, pw(2, i));
        }
    }
    return key;
}

int hsh(vector<char> & s) {
    int key = 0;
    for (int i = 0; i < (int)s.size(); i++) {
        if (s[i] == '1') {
            key = sm(key, pw(2, i));
        }
    }
    return key;
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int x; string s; cin >> x >> s;
    int endd = 7;
    if (x == 1) {
        int n = s.size();
        if (n == endd) {
            int tt = hsh(s);
            cout << s;
            for (int i = 0; i < 17; i++) {
                if (tt & (1 << i)) cout << 1;
                else cout << 0;
            }
            cout << endl;
        }
    } else {
        string t, key;
        for (int i = 0; i < endd; i++) {
            t += s[i];
        }
        int val = 0;
        for (int i = endd; i < (int)s.size(); i++) {
            key += s[i];
            if (s[i] == '1')
                val ^= (1 << (i - endd));
        }
        vector<char> tt(endd);
        for (int i = 0; i < endd; i++) {
            tt[i] = t[i];
        }
        int nval = hsh(tt);
        /*if (nval == val) {
            for (auto el : tt) cout << el;
            cout << endl;
            return 0;
        }*/
        for (int i = 0; i < endd; i++) {
            if (tt[i] == '0') {
                nval = sm(nval, pw(2, i));
                if (nval == val) {
                    tt[i] == '1';
                    for (auto el : tt) cout << el;
                    cout << endl;
                    return 0;
                }
                nval = dif(nval, pw(2, i));
            } else {
                nval = dif(nval, pw(2, i));
                if (nval == val) {
                    tt[i] = '0';
                    for (auto el : tt) cout << el;
                    cout << endl;
                    return 0;
                }
                nval = sm(nval, pw(2, i));
            }
        }
        for (auto el : tt) cout << el;
        cout << endl;

    }
    return 0;
}
