#include <iostream>
#include <vector>
#include <random>

using namespace std;

mt19937 rnd(777);

int main() {
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);

	int n = 1030;
	vector<vector<int>> d(n, vector<int> (n));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j)
			d[i][j] = rnd() % 7893489;
	}
	for (int t = 0; t < n; ++t) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j)
				d[i][j] = min(d[i][j], d[i][t] + d[t][j]);
		}
	}
	cout << "Meow\n";
}