#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <string>
#include <queue>
#include <deque>
#include <random>
#include <cassert>
#include <bitset>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

vector<int> v;

bool ask(int x) {
    if (v.size() > 0) {
        auto y = v.back();
        v.pop_back();
        if (y == 0) {
            cout << x << '\n';
            cout.flush();
            exit(0);
        }
        if (y == -1) return true;
        return false;
    }
    cout << x << '\n';
    cout.flush();
    int res;
    cin >> res;
    if (res == -1) return true;
    if (res == 0) {
        exit(0);
    }
    return false;
}

void solve() {
    int t;
    cin >> t;
    if (t == 1) {
        int n;
        cin >> n;
        int L = 1, R = n + 1;
        while (L + 1 < R) {
            int M = (L + R) / 2;
            if (ask(M)) {
                R = M;
            } else {
                L = M;
            }
        }
        ask(L);
    } else {
        int n;
        cin >> n;
        int cnt;
        cin >> cnt;
        v.resize(cnt);
        for (auto &i : v) {
            cin >> i;
        }
        reverse(all(v));
        int L = 1, R = n + 1;
        while (L + 1 < R) {
            int M = (L + R) / 2;
            if (ask(M)) {
                R = M;
            } else {
                L = M;
            }
        }
        ask(L);
    }
}

signed main() {
#ifdef lolipop
//    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}