#include <bits/stdc++.h>

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &i : v) {
        is >> i;
    }
    return is;
}

template<typename T>
istream &operator>>(istream &is, pair<T, T> &p) {
    is >> p.first >> p.second;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &i : v) {
        os << i << ' ';
    }
    return os;
}

template<typename T>
ostream &operator<<(ostream &os, pair<T, T> &p) {
    os << p.first << ' ' << p.second;
    return os;
}

#define all(a) a.begin(), a.end()
#define nl '\n'
#define elif else if
#define forn(i, n) for (int i = 0; i < n; i++)
#define pb push_back
#define vi vector<int>
#define pi pair<int, int>
#define vpi vector<pair<int, int>>
#define maxq(ma, a) ma = max(ma, a)
#define minq(mi, a) mi = min(mi, a)
#define sz(a) ((int)a.size())

typedef long long ll;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

inline void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

// #define int ll

const int MAXN = 1e3 + 10;

void Solve() {
    int type;
    cin >> type;
    string s;
    cin >> s;
    if (type == 1) {
        cout << s << s << s << nl;
    } else {
        int n = sz(s);
        map<string, int> m;
        m[s.substr(0, n / 3)]++;
        m[s.substr(n / 3, n / 3)]++;
        m[s.substr(2 * (n / 3), n / 3)]++;
        if (sz(m) == 1) {
            cout << m.begin()->first;
            exit(0);
        }
        vector<pair<int, string>> v;
        v.pb({m.begin()->second, m.begin()->first});
        v.pb({m.rbegin()->second, m.rbegin()->first});
        sort(all(v));
        reverse(all(v));
        cout << v[0].second << nl;
    }
}

signed main() {
//    IO();
    int t = 1;
//    cin >> t;
    for (int ii = 0; ii < t; ii++) {
        Solve();
    }
    return 0;
}