#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update> ordered_set;

void solve1(), solve2();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int type;
    cin >> type;
    if (type == 1)
        solve1();
    else
        solve2();
    return 0;
}

bool get(int x) {
    cout << x << endl;
    cin >> x;
    if (x == 0)
        exit(0);
    if (x == 1)
        return false;
    return true;
}

void solve1() {
    int n;
    cin >> n;
    int l = 1, r = n + 1;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        bool f = get(mid);
        if (f) {
            r = mid;
        } else
            l = mid;
    }
}

int ind = 0;

int a[100];

bool get2(int x) {
    int y = a[ind];
    ind++;
    if (y == 0) {
        cout << x << endl;
        exit(0);
    }
    if (y == 1)
        return false;
    return true;
}

void solve2() {
    int n;
    cin >> n;
    int k;
    cin >> k;
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    int l = 1, r = n + 1;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        bool f = get2(mid);
        if (f) {
            r = mid;
        } else
            l = mid;
    }
}

