#include <algorithm>
#include <ctime>
#include <iostream>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

const int N = 1000;

int g[N][N];

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  int start = clock();
  for (int i = 0; i < N; ++i) {
    for (int j = 0; j < N; ++j) {
      g[i][j] = rand() & 1023;
    }
  }
  for (int k = 0; k < N; ++k) {
    for (int i = 0; i < N; ++i) {
      for (int j = 0; j < N; ++j) {
        g[i][j] = min(g[i][j], g[i][k] + g[k][j]);
      }
    }
  }
  cout << (double)(clock() - start) / CLOCKS_PER_SEC << '\n';
  if (g[14][55] != 20) {
    int a, b;
    cin >> a >> b;
    cout << a + b << '\n';
  }
}
