#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define IO ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define pb push_back
#define mp make_pair
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define print(a) for(auto iiiii: a) cout << iiiii << ' '; cout << '\n';

mt19937_64 rng(time(0));
int random(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }

class SegmentTree{
public:
    int n;
    vector<int> t, add;
    SegmentTree(int _n){
        n = _n;
        t.resize(4*n);
        add.resize(4*n);
    }
    void push(int v){
        if(add[v] == 0) return;
        t[v] += add[v];
        if(v < 2*n) add[v*2] += add[v], add[v*2+1] += add[v];
        add[v] = 0;
    }
    int query(int v, int tl, int tr, int l, int r){
        push(v);
        if(r < tl || tr < l) return 0;
        if(l <= tl && tr <= r) return t[v];
        int tm = (tl+tr)/2;
        return query(v*2, tl, tm, l, r) + query(v*2+1, tm+1, tr, l, r);
    }
    void upd(int v, int tl, int tr, int l, int r, int x){
        push(v);
        if(r < tl || tr < l) return;
        if(l <= tl && tr <= r){
            add[v] += x;
            push(v);
            return;
        }
        int tm = (tl+tr)/2;
        upd(v*2, tl, tm, l, r, x);
        upd(v*2+1, tm+1, tr, l, r, x);
        t[v] = t[v*2] + t[v*2+1];
    }
};

void solve(){
    int a, b;
    cin >> a >> b;
    SegmentTree tree(1000);
    int l = random(0, 998), r = random(0, 998);
    if(l == r) r++;
    if(r < l) swap(l, r);
    //cout << l << ' ' << r << '\n';
    tree.upd(1, 0, 999, l, l, a);
    tree.upd(1, 0, 999, r, r, b);
    cout << tree.query(1, 0, 999, l, r);
}
/*

*/
signed main(){
    IO
    int test = 1;
    //cin >> test;
    while(test--){
        solve();
    }
}