#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("unswitch-loops,rename-registers,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,abm,popcnt")

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <chrono>
#include <ctime>
#include <random>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;
using ld = long double;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll n, m, k, q;

ll rndouble() {
	return rnd() * 1.0l / (1ll << 32 - 1);
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

int main() {
	ll beg = clock();

	vector <vector <ld>> a(1000, vector <ld>(1000));
	for (auto &x : a) {
		for (auto &y : x) {
			y = rndouble();
		}
	}

	for (int k = 0; k < 1000; ++k) {
		for (int i = 0; i < 1000; ++i) {
			for (int j = 0; j < 1000; ++j) {
				mini(a[i][j], a[i][k] + a[k][j]);
			}
		}
	}

	cerr << "Termminated in " << (clock() - beg) * 1.0l / CLOCKS_PER_SEC << "s\n";

	return 0;
}